package com.hand.hls.web.svc.tag;

import com.hand.hap.core.web.view.XMap;
import com.hand.hap.core.web.view.XMapHandler;
import com.hand.hap.core.web.view.XMapParser;
import com.hand.hls.web.svc.ServiceBuilder;
import com.hand.hls.web.svc.ServiceComponent;
import com.hand.hls.web.svc.ServiceContext;
import com.hand.hls.web.svc.SvcTag;
import freemarker.template.Template;

import java.io.StringReader;
import java.io.StringWriter;
import java.util.HashMap;
import java.util.List;

@SvcTag
public class Model extends ServiceComponent {
    public static final String PROPERTY_REF_NAME = "refName";
    public static final String PROPERTY_REF_CONTENT = "refContent";
    private static String PROPERTY_LOCATION = "location";
    private static String PROPERTY_NAME = "name";

    @Override
    public String execute(XMap view, ServiceContext context) throws Exception {
        List<XMap> children = view.getChildren();
        if(view.containsKey(PROPERTY_LOCATION)){
            //TODO 引用另一个bm，当前bm不进行渲染
            String bmName = view.getString(PROPERTY_NAME);
            String bmLocation = view.getString(PROPERTY_LOCATION);
            Template template = context.getConfiguration().getTemplate(bmLocation);
            String content;
            try(StringWriter writer = new StringWriter()){
               template.process(new HashMap(0),writer);
               writer.flush();
               content = writer.toString();
            }
            ServiceContext newInstance = context.createCloneInstance();
            newInstance.put(PROPERTY_REF_NAME,bmName);
            XMap xMap = XMapParser.parseReader(new StringReader(content), new XMapHandler());
            String refContent = ServiceBuilder.build(xMap, context);
            context.put(PROPERTY_REF_CONTENT,refContent);
        }else {
            if (children != null) {
                for (XMap child : children) {
                    String name = child.getName();
                    context.put(name, ServiceBuilder.build(child, context));
                }
            }
        }
        return super.build(context, getTemplate(view));
    }
}
