package com.hand.hls.web.svc.utils;

import com.hand.hls.web.svc.domain.KeyField;
import com.hand.hls.web.svc.domain.Model;
import org.springframework.util.Assert;

import java.util.List;
import java.util.Map;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-12-07
 * Time: 15:19
 */
public class ModelDeleteParser {
    public static String parseDelete(Model model, Map<String, Object> param) {
        //todo parse delete statement
        Assert.notNull(model, "invalid parameter");
        Assert.notNull(param, "invalid parameter");
        String tableName = model.getTableName();
        Assert.notNull(tableName, "tableName must not be null");
        List<KeyField> primaryKey = model.getPrimaryKey();
        Assert.notEmpty(primaryKey, "pk must be nonNull");

        StringBuilder whereBuilder = new StringBuilder(" where ");
        for (int i = 0; i < primaryKey.size(); i++) {
            if (i > 0) {
                whereBuilder.append(" and ");
            }
            KeyField key = primaryKey.get(i);
            String name = key.getName();
            String paramPath = key.getParamPath();
            if (!param.containsKey(paramPath)) {
                throw new IllegalArgumentException("each pk must be in params");
            }
            whereBuilder.append(name).append("=:").append(paramPath);
        }

        return "delete from " + tableName + whereBuilder.toString();
    }
}
