package com.hand.hls.web.svc.utils;

import com.hand.hls.web.svc.domain.Field;
import com.hand.hls.web.svc.domain.Model;
import org.apache.commons.lang.StringUtils;
import org.springframework.util.Assert;

import java.util.*;
import java.util.stream.Collectors;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-12-07
 * Time: 15:17
 */
public class ModelSaveParser {
    public static String parseSave(Model model) {
        return parseSaveWithParam(model, new HashMap<>(0));
    }

    public static String parseSaveWithParam(Model model, Map<String, Object> param) {
        Assert.notNull(model, "invalid parameter");
        String tableName = model.getTableName();
        Assert.notNull(tableName, "invalid tableName");
        List<Field> fields = model.getFields();
        StringBuilder sb = new StringBuilder(" insert into ");
        sb.append(tableName);

        Assert.notEmpty(fields, "fields must not be empty");
        String fieldPart = StringUtils.join(fields.stream().map(Field::getName).collect(Collectors.toList()), ",");
        String paramterPart = StringUtils.join(fields.stream().map(field -> {
            String name = field.getName();
            String paramPath = field.getParamPath();
            String defaultValue = field.getDefaultValue();
            if (param != null && !param.containsKey(paramPath) && Objects.nonNull(defaultValue)) {
                //put default value instead
                String dataType = field.getDataType();
                if (StringUtils.isEmpty(dataType) || "String".equals(dataType)) {
                    // add '' to string
                    name = "'" + defaultValue + "'";
                } else {
                    name = defaultValue;
                }
            } else {
                // put param holder
                name = ":" + field.getParamPath();
            }
            return name;
        }).collect(Collectors.toList()), ",");
        sb.append(" (").append(fieldPart)
                .append(") values(").append(paramterPart)
                .append(")");
        return sb.toString();
    }

    public static String parseSaveWithParamOnly(Model model, Map param) {
        // only parse fields passed by param
        // validate
        Assert.notNull(model, "invalid parameter");
        String tableName = model.getTableName();
        Assert.notNull(tableName, "invalid tableName");
        Assert.notNull(param, "invalid params");

        // parse params
        List<String> fields = new ArrayList<>(param.size());
        List<String> placeHolders = new ArrayList<>(param.size());


        return null;
    }
}
