package com.hls.core.sys.service.impl;

import com.hand.hap.cache.Cache;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import net.logstash.logback.encoder.org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import com.hls.core.sys.dto.Layout;
import com.hls.core.sys.service.ILayoutService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class LayoutServiceImpl extends BaseServiceImpl<Layout> implements ILayoutService{
    @Autowired
    @Qualifier("formCache")
    private Cache formCache;

    @Override
    public List<Layout> batchUpdate(IRequest request, List<Layout> forms) {
        for (Layout form : forms) {
            form.setLayoutCode(StringUtils.upperCase(form.getLayoutCode()));
            if (form.getLayoutId() == null) {
                self().insertSelective(request,form);
            } else if (form.getLayoutId() != null) {
                self().updateByPrimaryKey(request,form);

            }
            formCache.setValue(form.getLayoutCode(), form);
        }
        return forms;
    }

    public int batchDelete(List<Layout> forms){
        int c = 0;
        for(Layout form: forms){
            c += self().deleteByPrimaryKey(form);
            formCache.remove(form.getLayoutCode());
        }
        return c;
    }
}