package hls.core.activity.controllers;

import hls.core.csh.dto.HlsCusCshBankAccount;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.activity.dto.ProcessCondExpression;
import hls.core.activity.service.IProcessCondExpressionService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.springframework.validation.BindingResult;
import java.util.List;

    @Controller
    public class ProcessCondExpressionController extends BaseController{

    @Autowired
    private IProcessCondExpressionService service;


    @RequestMapping(value = "/act/process/cond/expression/query")
    @ResponseBody
    public ResponseData query(ProcessCondExpression dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/act/process/cond/expression/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<ProcessCondExpression> dto, BindingResult result, HttpServletRequest request){
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }

        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/act/process/cond/expression/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<ProcessCondExpression> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

    }