package hls.core.calc.controllers;

import hls.core.calc.dto.HlsPriceListConfigLn;
import hls.core.calc.service.HlsCalcSaveService;
import hls.core.calc.service.HlsPriceListConfigLnService;
import hls.core.calc.service.HlsPriceListService;
import hls.core.prj.dto.HlsCusPrjQuotation;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.calc.dto.HlsPriceList;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

@Controller
public class HlsPriceListController extends BaseController {

    @Autowired
    private HlsPriceListService service;
    @Autowired
    private HlsCalcSaveService hlsCalcSaveService;
    @Autowired
    private HlsPriceListConfigLnService hlsPriceListConfigLnService;


    @RequestMapping(value = "/hls/price/list/query")
    @ResponseBody
    public ResponseData query(HlsPriceList dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/hls/price/list/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request, @RequestBody List<HlsPriceList> dto) {
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/hls/price/list/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsPriceList> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }
    @RequestMapping(value = "/hls/price/detail/query")
    @ResponseBody
    public ResponseData hlsPriceListDetailQuery(HlsPriceList dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.hlsPriceListDetailQuery(dto));
    }

    @RequestMapping(value = "/hls/price/combobox/query")
    @ResponseBody
    public ResponseData hlsPriceListComboboxQuery(HlsPriceList dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                                @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.hlsPriceListComboBoxQuery(dto));
    }

    @RequestMapping(value = "/prj/quotation/quotationSumbit", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData quotationSumbit(HttpServletRequest request,Long sourceDocumentId,String priceList,String sourceDocumentCategory,@RequestBody String sheets)
            throws Exception {
        ResponseData rd = null;
        IRequest requestCtx = createRequestContext(request);
//        try {
        List<HlsCusPrjQuotation> prjQuotationList=new ArrayList<HlsCusPrjQuotation>();
        HlsCusPrjQuotation prjQuotation=new HlsCusPrjQuotation();
        prjQuotation.setSourceDocumentId(sourceDocumentId);
        prjQuotation.setPriceList(priceList);
        prjQuotation.setSourceDocumentCategory(sourceDocumentCategory);
        prjQuotation.setSheets(sheets);
        HlsCusPrjQuotation prjQuotationR =hlsCalcSaveService.savePrjQuotation(requestCtx,prjQuotation);
        prjQuotationList.add(prjQuotationR);
        return   new ResponseData(prjQuotationList);
//        } catch (Exception e) {
//            // TODO: handle exception
//            rd = new ResponseData(false);
//            rd.setMessage(e.getMessage());
//            return rd;
//        }



    }

    @RequestMapping(value = "/hls/price/detail/getHideInfo")
    @ResponseBody
    public ResponseData hlsPriceListDetailQuery(HttpServletRequest request,@RequestBody HlsPriceListConfigLn dto) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(hlsPriceListConfigLnService.selectHlsPriceListConfiglineHide(dto));
    }

}

