package hls.core.calc.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.calc.dto.HlsCalcConfig;
import hls.core.calc.dto.HlsPriceListConfigBT;
import hls.core.calc.mapper.HlsCalcConfigMapper;
import hls.core.calc.mapper.HlsPriceListConfigBTMapper;
import hls.core.calc.service.HlsCalcConfigService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 *  *author:yang.gao01@hand-china.com on 2016/11/3.
 */
@Service
@Transactional
public class HlsCalcConfigServiceImpl extends BaseServiceImpl<HlsCalcConfig> implements HlsCalcConfigService {

    @Autowired
    HlsCalcConfigMapper mapper;
    @Autowired
    HlsPriceListConfigBTMapper hlsPriceListConfigBTMapper;

    @Override
    public List<HlsCalcConfig> queryAll(IRequest requestContext, HlsCalcConfig hcc, int page, int pagesize) {
        PageHelper.startPage(page, pagesize);
        return mapper.queryAll(hcc);
    }

    @Override
    public List<HlsCalcConfig> queryUnSheets(IRequest requestContext, HlsCalcConfig hcc, int page, int pagesize) {
        PageHelper.startPage(page, pagesize);
        return mapper.queryUnSheets(hcc);
    }

	@Override
	public void updateSheets(String priceList,String sheets) {
		mapper.updateSheets(priceList, sheets);
		
	}

	@Override
	public List<HlsPriceListConfigBT> btConfigQuery(String priceList){
        HlsPriceListConfigBT hlsPriceListConfigBT = new HlsPriceListConfigBT();
        hlsPriceListConfigBT.setPriceList(priceList);
        List<HlsPriceListConfigBT> btList =  hlsPriceListConfigBTMapper.select(hlsPriceListConfigBT);
        return btList;
    }

}
