package hls.core.calc.service.impl;

import com.hand.hap.core.AppContextInitListener;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.calc.service.HlsCalcSaveService;
import hls.core.calc.service.QuotationCommon;
import hls.core.prj.dto.HlsCusPrjQuotation;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.Map;

@Service
@Transactional(rollbackFor = { Exception.class, RuntimeException.class })
public class HlsCalcSaveServiceImpl extends BaseServiceImpl<HlsCusPrjQuotation>
		implements AppContextInitListener, HlsCalcSaveService {


    private Map<String, QuotationCommon> QuotationCommonRegistion = new HashMap<>();

    @Override
    public void contextInitialized(ApplicationContext appCtx) {
        Map<String, QuotationCommon> map = appCtx.getBeansOfType(QuotationCommon.class);

        map.forEach((k, v) -> {
            QuotationCommonRegistion.put(v.getSourceDocumentCategory(), v);
        });

    }

    @Override
    public HlsCusPrjQuotation savePrjQuotation(IRequest iRequest, HlsCusPrjQuotation prjQuotation)throws Exception{

        if(prjQuotation!=null){
            String sourceDocumentCategory=prjQuotation.getSourceDocumentCategory();
            QuotationCommon quotation = QuotationCommonRegistion.get(sourceDocumentCategory);
            if (quotation == null) {
                throw new IllegalArgumentException("单据类别未找到！");
            } else {
                return   quotation.PrjQuotationSubmit(iRequest,prjQuotation);
            }
        }else{
            throw new IllegalArgumentException("报价信息未找到！");
        }
    }

}
