package hls.core.calc.service.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import hls.core.calc.dto.HlsPriceListConfigLn;
import hls.core.calc.service.HlsCalcExcelImportUtilService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.calc.dto.HlsPriceListConfigHd;
import hls.core.calc.mapper.HlsPriceListConfigHdMapper;
import hls.core.calc.service.HlsPriceListConfigHdService;
import hls.core.calc.service.HlsPriceListConfigLnService;

 
@Service
@Transactional
public class HlsPriceListConfigHdServiceImpl extends BaseServiceImpl<HlsPriceListConfigHd> implements HlsPriceListConfigHdService{

	@Autowired
	private HlsPriceListConfigHdMapper hlsPriceListConfigHdMapper;
	@Autowired
	private HlsPriceListConfigLnService hlsPriceListConfigLnService;
	@Autowired
	private HlsCalcExcelImportUtilService hlsCalcExcelImportUtilService;
	
	/* (non-Javadoc)
	 * @see hls.core.calc.service.HlsPriceListConfigHdService#updateHlsPriceListConfigHd(hls.core.calc.dto.HlsPriceListConfigHd)
	 */
	@Override
	public void updateHlsPriceListConfigHd(HlsPriceListConfigHd configHd) {
		// TODO Auto-generated method stub
		hlsPriceListConfigHdMapper.updateHlsPriceListConfigHd(configHd);
	}

	/* (non-Javadoc)
	 * @see hls.core.calc.service.HlsPriceListConfigHdService#insertHlsPriceListConfigHd(hls.core.calc.dto.HlsPriceListConfigHd)
	 */
	@Override
	public void insertHlsPriceListConfigHd(HlsPriceListConfigHd configHd) {
		hlsPriceListConfigHdMapper.insertHlsPriceListConfigHd(configHd);
	}
	@Override
	public List<HlsPriceListConfigHd> submit(IRequest iRequest, HlsPriceListConfigHd calcConfigs) {
		List<HlsPriceListConfigHd> lists = new ArrayList<>();
		List<HlsPriceListConfigLn> HlsPriceListConfigLnList=new ArrayList<HlsPriceListConfigLn>();
		//HD表头行两条记录用一条记录传入,HD的字段名后加H
        //插入MULTI_LINE类型的数据
		if(calcConfigs.getTableName().equals(calcConfigs.getTableNameH())){
			throw new IllegalArgumentException("头行表不能相同！");
		}
		if(calcConfigs.getConfigHdId()==null){
			self().insert(iRequest,calcConfigs);
		}else{
			hlsPriceListConfigHdMapper.updateHlsPriceListConfigHd(calcConfigs);
		}

		//插入或更新数据类型为SINGE
		HlsPriceListConfigHd  hlsPriceListConfigHdH=new HlsPriceListConfigHd();
		hlsPriceListConfigHdH.setTableName(calcConfigs.getTableNameH());
		hlsPriceListConfigHdH.setTableType(calcConfigs.getTableTypeH());
		hlsPriceListConfigHdH.setPriceList(calcConfigs.getPriceList());
		if(calcConfigs.getConfigHdIdH()==null){
			hlsPriceListConfigHdH.setConfigHdId(null);
			self().insert(iRequest,hlsPriceListConfigHdH);
			//把singe类型的id返回给头上
			calcConfigs.setConfigHdIdH(hlsPriceListConfigHdH.getConfigHdId());
		}else{
			hlsPriceListConfigHdH.setConfigHdId(calcConfigs.getConfigHdIdH());
			hlsPriceListConfigHdMapper.updateHlsPriceListConfigHd(hlsPriceListConfigHdH);
		}
		if(calcConfigs.getHlsPriceListConfigLns()!=null) {
			for (int i = 0; i < calcConfigs.getHlsPriceListConfigLns().size(); i++) {
				if (calcConfigs.getConfigHdId() != null && calcConfigs.getHlsPriceListConfigLns().get(i).getConfigHdId() == null) {
					calcConfigs.getHlsPriceListConfigLns().get(i).setConfigHdId(calcConfigs.getConfigHdId());
				}

				//行表上的code必须是类似aaa这种
				checkLineCodeFormat(calcConfigs.getHlsPriceListConfigLns().get(i).getColumnCode());
				if("update".equals(calcConfigs.getHlsPriceListConfigLns().get(i).get__status())){
					hlsPriceListConfigLnService.self().updateByPrimaryKey(iRequest,calcConfigs.getHlsPriceListConfigLns().get(i));
				}else if("add".equals(calcConfigs.getHlsPriceListConfigLns().get(i).get__status())){
					hlsPriceListConfigLnService.self().insertSelective(iRequest,calcConfigs.getHlsPriceListConfigLns().get(i));
				}

			}
			//hlsPriceListConfigLnService.batchUpdate(iRequest, calcConfigs.getHlsPriceListConfigLns());
		}
		if(calcConfigs.getHlsPriceListConfigLnsH()!=null) {
			for (int i = 0; i < calcConfigs.getHlsPriceListConfigLnsH().size(); i++) {
				if (calcConfigs.getConfigHdIdH() != null && calcConfigs.getHlsPriceListConfigLnsH().get(i).getConfigHdId() == null) {
					calcConfigs.getHlsPriceListConfigLnsH().get(i).setConfigHdId(calcConfigs.getConfigHdIdH());
				}
				//头表上的code必须是类似aaa1这种
				hlsCalcExcelImportUtilService.getNumberFromExcelStr(calcConfigs.getHlsPriceListConfigLnsH().get(i).getColumnCode(), "C");
				if("update".equals(calcConfigs.getHlsPriceListConfigLnsH().get(i).get__status())){
					hlsPriceListConfigLnService.self().updateByPrimaryKey(iRequest,calcConfigs.getHlsPriceListConfigLnsH().get(i));

				}else if("add".equals(calcConfigs.getHlsPriceListConfigLnsH().get(i).get__status())){
					hlsPriceListConfigLnService.self().insertSelective(iRequest,calcConfigs.getHlsPriceListConfigLnsH().get(i));

				}
			}
			//hlsPriceListConfigLnService.batchUpdate(iRequest, calcConfigs.getHlsPriceListConfigLnsH());
		}
		lists.add(calcConfigs);
		return lists;
	}

	 void checkLineCodeFormat(String str){
		str = str.trim();
		String strNumber = "";
		String StrD = "";
		if (str != null && !"".equals(str)) {
			for (int i = 0; i < str.length(); i++) {
				if (!((str.charAt(i) >= 97 && str.charAt(i) <= 122) || (str.charAt(i) >= 65 && str.charAt(i) <= 90))) {
					throw new IllegalArgumentException("行表表达式"+str+"必须为字母！");
				}

			}
		}

	}
}
