package hls.core.calc.service.impl;

import java.util.List;

import com.github.pagehelper.PageHelper;
import hls.core.calc.service.HlsCalcExcelImportUtilService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.calc.dto.HlsPriceListConfigLn;
import hls.core.calc.mapper.HlsPriceListConfigLnMapper;
import hls.core.calc.service.HlsPriceListConfigLnService;

@Service
@Transactional
public class HlsPriceListConfigLnServiceImpl extends BaseServiceImpl<HlsPriceListConfigLn> implements HlsPriceListConfigLnService{

	@Autowired
	private HlsPriceListConfigLnMapper mapper;
	@Autowired
	private HlsCalcExcelImportUtilService hlsCalcExcelImportUtilService;
	
	/* (non-Javadoc)
	 * @see hls.core.calc.service.HlsPriceListConfigLnService#selectAllHlsPriceListConfigLn()
	 */
	@Override
	public List<HlsPriceListConfigLn> selectAllHlsPriceListConfigLn(HlsPriceListConfigLn configLn){
		// TODO Auto-generated method stub
		return mapper.selectAllHlsPriceListConfigLn(configLn);
	}
	@Override
	public List<HlsPriceListConfigLn> selectHlsPriceListConfiglineByPriceList(HlsPriceListConfigLn configLn,int page,int pagesize){
		// TODO Auto-generated method stub
		PageHelper.startPage(page, pagesize);
		return mapper.selectHlsPriceListConfiglineByPriceList(configLn);
	}

	@Override
	public List<HlsPriceListConfigLn> selectHlsPriceListConfiglineHide(HlsPriceListConfigLn configLn){
		List<HlsPriceListConfigLn> hlsPriceListConfigLnList=mapper.selectHlsPriceListConfiglineByPriceList(configLn);
		for(int i=0;i<hlsPriceListConfigLnList.size();i++){
		String	columnCode=	hlsPriceListConfigLnList.get(i).getColumnCode()==null?"":hlsPriceListConfigLnList.get(i).getColumnCode().toUpperCase();
			String  hideColumnFlag=hlsPriceListConfigLnList.get(i).getHideColumnFlag()==null?"":hlsPriceListConfigLnList.get(i).getHideColumnFlag().toUpperCase();
			if("Y".equals(hideColumnFlag)&&"Y".equals(configLn.getHideColumnFlag())){
				int CellsIndex = hlsCalcExcelImportUtilService.excelColStrToNum(columnCode);
				hlsPriceListConfigLnList.get(i).setHideColumnIndex(CellsIndex-1);
			}
			String  hideRowFlag=hlsPriceListConfigLnList.get(i).getHideRowFlag()==null?"":hlsPriceListConfigLnList.get(i).getHideRowFlag().toUpperCase();
			if("Y".equals(hideRowFlag)&&"Y".equals(configLn.getHideRowFlag())){
				int rowIndex = Integer.parseInt(hlsCalcExcelImportUtilService.getNumberFromExcelStr(columnCode, "N"));
				hlsPriceListConfigLnList.get(i).setHideRowIndex(rowIndex-1);
			}
		}
		return hlsPriceListConfigLnList;
	}
}
