package hls.core.calc.service.impl;

import com.alibaba.fastjson.JSON;
import com.hand.hap.core.IRequest;
import hls.core.calc.service.HlsCalcExcelImportUtilService;
import hls.core.calc.service.QuotationCommon;
import hls.core.csh.service.IConContractCashflowService;
import hls.core.prj.dto.HlsCusPrjProject;
import hls.core.prj.dto.HlsCusPrjQuotation;
import hls.core.prj.dto.HlsCusPrjQuotationDetails;
import hls.core.prj.mapper.HlsCusPrjQuotationMapper;
import hls.core.prj.service.PrjProjectService;
import hls.core.prj.service.PrjQuotationCashflowService;
import hls.core.prj.service.PrjQuotationDetailsService;
import hls.core.prj.service.PrjQuotationService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.*;

@Service
public class PrjProjectQuotationServiceImpl implements QuotationCommon {


    private Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private PrjProjectService prjProjectService;
    @Autowired
    private IConContractCashflowService conContractCashflowService;
    @Autowired
    private HlsCusPrjQuotationMapper prjQuotationMapper;
    @Autowired
    HlsCalcExcelImportUtilService hlsCalcExcelImportUtilService;
    @Autowired
    private PrjQuotationCashflowService prjQuotationCashflowService;
    @Autowired
    private PrjQuotationService  prjQuotationService;
    private static final String sourceDocumentCategory = "PRJ_PROJECT";
    @Autowired
    private PrjQuotationDetailsService prjQuotationDetailsService;
    @Override
   public  String getSourceDocumentCategory(){
        return sourceDocumentCategory;
    }
    @Override
    public HlsCusPrjQuotation PrjQuotationSubmit(IRequest iRequest, HlsCusPrjQuotation prjQuotation) throws Exception{
        //校验公式是否被修改
//        hlsCalcExcelImportUtilService.excelFormatHasChange(iRequest,prjQuotation.getPriceList(),prjQuotation.getSheets());
        String jsonStr = JSON.toJSONString(hlsCalcExcelImportUtilService.getExcelToCalcHdTable(iRequest,prjQuotation.getSheets(),prjQuotation.getPriceList(),"prj"));
        HlsCusPrjQuotation prjQuotationDto = JSON.parseObject(jsonStr, HlsCusPrjQuotation.class);
      //  HlsCusPrjQuotation prjQuotationDto=(HlsCusPrjQuotation)hlsCalcExcelImportUtilService.getExcelToCalcHdTable(iRequest,prjQuotation.getSheets(),prjQuotation.getPriceList(),"prj");
        if(prjQuotationDto.getLeaseTimes()==null){
            throw new IllegalArgumentException("期数未取到！");
        }
        prjQuotationDto.setPriceList(prjQuotation.getPriceList());
        prjQuotationDto.setSheets(prjQuotation.getSheets());
        prjQuotationDto.setProjectId(prjQuotation.getSourceDocumentId());
        prjQuotationDto.setSourceDocumentCategory(prjQuotation.getSourceDocumentCategory());
        prjQuotationDto.setSourceDocumentId(prjQuotation.getSourceDocumentId());
        //获取项目项下的报价
        //当前项目下的只有一个报价
        List<HlsCusPrjQuotation> prjQuotationList=prjQuotationMapper.prjQuotationDetailQuery(prjQuotationDto);
        HlsCusPrjQuotation savePrjQuotation = new HlsCusPrjQuotation();
        if(prjQuotationList.size()>0){
            prjQuotationDto.setQuotationId(prjQuotationList.get(0).getQuotationId());
        }
        if(prjQuotationDto.getQuotationId()==null){
            //新插入默认为新建
            prjQuotationDto.setStatus("NEW");
            prjQuotationDto = updatePrjQutationProfile(prjQuotationDto,iRequest);
            savePrjQuotation = prjQuotationService.insertSelective(iRequest,prjQuotationDto);
        }else{
            prjQuotationDto = updatePrjQutationProfile(prjQuotationDto,iRequest);
            prjQuotationService.updateByPrimaryKey(iRequest,prjQuotationDto);
            savePrjQuotation.setQuotationId(prjQuotationDto.getQuotationId());
        }
        HlsCusPrjQuotationDetails prjQuotationDetails = new HlsCusPrjQuotationDetails();
        prjQuotationDetails.setQuotation_id(savePrjQuotation.getQuotationId());
        List<HlsCusPrjQuotationDetails> detailsList = new ArrayList<>();
        detailsList = prjQuotationDetailsService.queryDetailsById(prjQuotationDetails);
        if(detailsList.size()>0){
            detailsList.get(0).setSheets(prjQuotationDto.getSheets());
            detailsList.get(0).set__status("update");
        }else {
            prjQuotationDetails.setSheets(prjQuotationDto.getSheets());
            detailsList.add(prjQuotationDetails);
            detailsList.get(0).set__status("add");
        }
        prjQuotationDetailsService.batchUpdate(iRequest,detailsList);

        //保存现金流表
        prjQuotationCashflowService.saveCalc2PrjQuotationCashflow(iRequest,prjQuotationDto);


        //修改项目表中的finace_amount字段为报价表上的finace_amount
        HlsCusPrjProject prjProject = new HlsCusPrjProject();
        prjProject.setProjectId(prjQuotation.getSourceDocumentId());
        prjProject = prjProjectService.selectByPrimaryKey(iRequest,prjProject);

        prjProject.setFinanceAmount(new Double(prjQuotationDto.getFinanceAmount()).longValue());
        prjProjectService.updateByPrimaryKey(iRequest,prjProject);


        return prjQuotationDto;
    }



    public HlsCusPrjQuotation updatePrjQutationProfile(HlsCusPrjQuotation prjQuotationDto, IRequest iRequest) throws  Exception{
        //给报价表上的penalty_profile字段、invoice_profile字段加上默认值 （值先固定）
        HlsCusPrjProject prjProject = new HlsCusPrjProject() ;
        prjProject.setProjectId(prjQuotationDto.getSourceDocumentId());
        prjProject = prjProjectService.selectByPrimaryKey(iRequest,prjProject);

        //
        if(!"".equals(prjProject.getDocumentType())  &&  !"".equals(prjProject.getLeaseItemType()) &&  prjQuotationDto.getLeaseStartDate() != null){
            if(prjProject.getDocumentType().equals("PRJL")){   //直租
                if(prjProject.getLeaseItemType().equals("MOVABLE")){ //直租-动产
                    prjQuotationDto.setBillingProfile("LEASE_MOVABLES");
                } else if (prjProject.getLeaseItemType().equals("IMMOVABLE")){//直租-不动产
                    prjQuotationDto.setBillingProfile("LEASE_IMMOVABLES");
                }
            }else if(prjProject.getDocumentType().equals("PRJLB")){//回租
                if(prjProject.getLeaseItemType().equals("MOVABLE")){ //回租-动产
                    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
                    Date standardDate = sdf.parse("2016-5-1");
                    if( prjQuotationDto.getLeaseStartDate().getTime() > standardDate.getTime()){ //在2016-5-1之后的
                        prjQuotationDto.setBillingProfile("LEASEBACK_MOVABLES");
                    }else{  //在2016-5-1之前的
                        prjQuotationDto.setBillingProfile("LEASEBACK_MOVABLES_BEFORE");
                    }
                } else if (prjProject.getLeaseItemType().equals("IMMOVABLE")){//回租-不动产
                    prjQuotationDto.setBillingProfile("LEASEBACK_IMMOVABLES");
                }
            }
        }
        //当prj_project上的 leaseItemType 是
        prjQuotationDto.setPenaltyProfile("STD");

        return prjQuotationDto;
    }
}
