package hls.core.cont.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.cont.dto.HlsCusConContractCancel;
import hls.core.cont.mapper.ConContractCancelMapper;
import hls.core.cont.service.ConContractCancelService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created by yang on 2017/1/9.
 */
@Controller
@RequestMapping("/con/contract")
public class ConContractCancelController extends BaseController{
    @Autowired
    private ConContractCancelService cancelService;
    @Autowired
    private ConContractCancelMapper conContractCancelMapper;

    @RequestMapping("/cancel")
    public ResponseData cancel(HttpServletRequest request, HlsCusConContractCancel cancelContract) throws Exception{
        IRequest iRequest = createRequestContext(request);
        ResponseData data = null ;

        HlsCusConContractCancel conContractCancel = new HlsCusConContractCancel();
        conContractCancel.setContractId(cancelContract.getContractId());
        List<HlsCusConContractCancel> dtoStatus = conContractCancelMapper.select(conContractCancel);

        boolean flag = false;

        for(HlsCusConContractCancel dto: dtoStatus){
            if("APPROVING".equals(dto.getStatus()) || "APPROVED".equals(dto.getStatus())){
                data = new ResponseData(false);
                data.setMessage("合同撤销已在流程中或已结束！");
                flag = true;
            }
        }


        try {
            if(!flag) {
                data = cancelService.cancel(iRequest, cancelContract);
            }
            //eventService.contractEvent(iRequest,"CON_CONTRACT.CANCEL",cancelContract.getContractId(),iRequest.getUserId());
        } catch (Exception e) {
            data = new ResponseData(false);
            data.setMessage("系统异常，合同撤销申请失败！");
        }
        return data;
    }

    @RequestMapping("/cancel/query")
    @ResponseBody
    public ResponseData query(final HlsCusConContractCancel cancelContract, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pageSize, final HttpServletRequest request){
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(cancelService.select(requestContext, cancelContract, page, pageSize));
    }
}
