package hls.core.cont.controllers;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.dto.HlsCusConContractChangeReq;
import hls.core.cont.service.ConContractService;
import hls.core.csh.service.IConContractCashflowService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.hand.hap.attachment.exception.StoragePathNotExsitException;
import com.hand.hap.attachment.exception.UniqueFileMutiException;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.cont.dto.ConContractChangeH;
import hls.core.cont.service.ConContractChangeService;

import java.util.List;
import java.util.Map;

@Controller
public class ConContractChangeController extends BaseController{
	
	@Autowired
	private ConContractChangeService changeService;
	@Autowired
	private IConContractCashflowService cashflowService;
	@Autowired
	private ConContractService contractService;
	@RequestMapping(value="/con/ConContractChangeH1/submit", method = RequestMethod.POST) 
	@ResponseBody
	public ResponseData submit(@RequestBody final ConContractChangeH changeH, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request,HttpSession session){
			ResponseData data = null;
			IRequest iRequest = createRequestContext(request);
			try {
				changeService.saveBackup(iRequest,changeH, session);
			} catch (Exception e) {
				data = new ResponseData(false);
				data.setMessage(e.getMessage());
				return data;
			}
		return new ResponseData(); 
	}
	@RequestMapping(value = "/con/contract/change/upload", method = RequestMethod.POST, produces = "text/plain;charset=UTF-8")
	public String upload(HttpServletRequest request)throws StoragePathNotExsitException, UniqueFileMutiException, JsonProcessingException {
		
		return "";
	}

	@RequestMapping(value = "/con/contract/changeReq/query")
	@ResponseBody
	public ResponseData query(HlsCusConContractChangeReq changeReq, HttpServletRequest request) {
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(changeService.select(requestContext,changeReq));
	}

	/*合同变更-提前结清-判断是否提交审批 决定是否更新现金流信息和合同信息*/
	@RequestMapping("/con/contract/changeReq/checkChangeStatus")
	@ResponseBody
	public ResponseData checkChangeStatus(HttpServletRequest httpRequest, @RequestBody Map map, HttpSession session) {
		IRequest requestContext = createRequestContext(httpRequest);
		ResponseData data = new ResponseData(true);
		try {
			String flag = changeService.checkChangeStatus(map);
			if("N".equals(flag)){
				HlsCusConContract contract = new HlsCusConContract();
				contract.setContractId(Long.parseLong(map.get("contractId").toString()));
				contract.setContractStatus("INCEPT");
				contractService.updateByPrimaryKeySelective(requestContext,contract);
			}
		} catch (Exception e) {
			data = new ResponseData(false);
			data.setMessage(e.getMessage());
		}
		return data;
	}
	/*合同变更抽屉-判断某一个合同是否做过变更*/
	@RequestMapping(value = "/con/contract/changeReq/checkHasChangeHistory")
	@ResponseBody
	public ResponseData checkHasChangeHistory(HlsCusConContractChangeReq changeReq, HttpServletRequest request) {
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(changeService.checkHasChangeHistory(requestContext,changeReq));
	}
}
