package hls.core.cont.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.cont.dto.HlsCusConContractTermination;
import hls.core.cont.mapper.ConContractTerminationMapper;
import hls.core.cont.service.ConContractTerminationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created by yang on 2017/1/6.
 */
@Controller
public class ConContractCompleteController extends BaseController {

    @Autowired
    private ConContractTerminationService terminationService;

    @Autowired
    private ConContractTerminationMapper conContractTerminationMapper;

    @RequestMapping("/con/contract/complete/apply")
    public ResponseData apply( HttpServletRequest request,HlsCusConContractTermination termination) throws Exception{
        IRequest iRequest = createRequestContext(request);
        ResponseData data = null ;
        List<HlsCusConContractTermination> list = conContractTerminationMapper.select(termination);
        boolean flag = true;
        for(HlsCusConContractTermination dto: list){
            if("APPROVING".equals(dto.getStatus()) || "APPROVED".equals(dto.getStatus())){
                data = new ResponseData(false);
                data.setMessage("合同已提交审批，无需再次提交！");
                flag = false;
                break;
            }
        }

        try {
            if(flag) {
                data = terminationService.apply(iRequest, termination);
            }
        } catch (Exception e) {
            data = new ResponseData(false);
            data.setMessage("系统异常，合同结束申请失败！");
        }
        return data;
    }
    @RequestMapping("/con/contract/complete/query")
    public ResponseData query(HttpServletRequest request, HlsCusConContractTermination termination , @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize) throws Exception{
        IRequest iRequest = createRequestContext(request);
        return new ResponseData(terminationService.select(iRequest,termination,page,pageSize));
    }




}
