package hls.core.cont.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.cont.dto.ConContract;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.service.ConContractService;
import hls.core.prj.dto.HlsCusPrjProject;
import hls.core.prj.service.PrjProjectService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

    @Controller
    public class ConContractController extends BaseController{

    @Autowired
    private ConContractService service;
    @Autowired
     private PrjProjectService prjProjectService;


    @RequestMapping(value = "/con/contract/query")
    @ResponseBody
    public ResponseData query(HlsCusConContract dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/con/contract/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<HlsCusConContract> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/con/contract/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusConContract> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

        @RequestMapping(value = "/con/contract/saveConContractFromPrjProject")
        @ResponseBody
        public ResponseData saveConContractFromPrjProject(HttpServletRequest request,@RequestBody HlsCusPrjProject prjProject){
            IRequest requestCtx = createRequestContext(request);
            //修改项目状态
            prjProjectService.updatePrjProjectApproved(requestCtx,prjProject, "APPROVED_RETURN");
            //项目创建合同
            ConContract conContract=service.saveConContractFromPrjProject(requestCtx,prjProject);

            List<ConContract> conContractList=new ArrayList<>();
            conContractList.add(conContract);
            return new ResponseData(conContractList);
        }

    }