package hls.core.cont.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.excel.service.IExportService;
import com.hand.hap.excel.service.IHapExcelImportService;
import com.hand.hap.system.controllers.BaseController;
import hls.core.cont.service.ConContractExcelService;
import hls.core.hls.service.HlsExcelService;
import org.apache.bcel.generic.IREM;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileItemFactory;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import com.fasterxml.jackson.databind.JavaType;
import com.fasterxml.jackson.databind.ObjectMapper;

import com.hand.hap.excel.dto.ColumnInfo;
import com.hand.hap.excel.dto.ExportConfig;
import com.hand.hap.function.dto.Function;
import org.springframework.web.multipart.MultipartRequest;


import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.*;

/**
 * Copyright (C) Hand Business Consulting Services
 * AllRights Reserved
 *
 * @DESCRIPTION:合同Excel导入和导出
 * @author: SYJ
 * @date: 2017年2月9日
 */
@Controller
public class ConContractExcelController extends BaseController {

    @Autowired
    IExportService excelService;
    @Autowired
    HlsExcelService hlsExcelService;
    @Autowired
    ConContractExcelService conContractExcelService;

    @Autowired
    ObjectMapper objectMapper;

    @RequestMapping(value = "/con/CON100/contractExcelExport", method = RequestMethod.POST)
    public void createXLS(HttpServletRequest request, @RequestParam String config,
                          HttpServletResponse httpServletResponse) {
        IRequest requestContext = createRequestContext(request);
        try {
            JavaType type = objectMapper.getTypeFactory().constructParametrizedType(ExportConfig.class,
                    ExportConfig.class, Function.class, ColumnInfo.class);
            ExportConfig<Function, ColumnInfo> exportConfig = objectMapper.readValue(config, type);
            excelService.exportAndDownloadExcel("com.hand.hap.function.mapper.HlsCusCshConContractMapper.selectAllConContract",
                    exportConfig, request, httpServletResponse, requestContext);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


   /* @RequestMapping(value = "/cont/CON100/contractExcelImport", method = RequestMethod.POST)
    public Map<String, Object> upload(HttpServletRequest request) throws IOException {
        IRequest iRequest = createRequestContext(request);
        Map<String, Object> response = new HashMap<String, Object>();
        response.put("success", false);
        // 在解析请求之前先判断请求类型是否为文件上传类型
        boolean isMultipart = ServletFileUpload.isMultipartContent(request);
        if (!isMultipart) {
            return null;
        }
        // 文件上传处理工厂
        FileItemFactory factory = new DiskFileItemFactory();

        // 创建文件上传处理器
        ServletFileUpload upload = new ServletFileUpload(factory);

        List items = null;
        try {
            items = upload.parseRequest(request);
        } catch (FileUploadException e) {
            response.put("success", false);
            response.put("message", "文件错误！");
            e.printStackTrace();
        }


        // 对所有请求信息进行判断
        Iterator iter = items.iterator();

        while (iter.hasNext()) {
            FileItem item = (FileItem) iter.next();
            // 信息为文件的格式
            if (!item.isFormField()) {
                try {
                    InputStream fs = item.getInputStream();
                    String filename = new String(item.getName());
                    //插入接口表 返回头表ID
                    Long headerId = hlsExcelService.loadExcel(iRequest, fs, "CONTRACT", filename);
                    //conContractExcelService.contractExcelImport(iRequest,headerId);
                    response.put("headerId", headerId);
                    response.put("message", "导入成功");
                    response.put("success", true);
                } catch (Exception e) {
                    response.put("success", false);
                    response.put("message", "导入失败！" + e.getMessage());
                    e.printStackTrace();
                }

            }
        }
        return response;
    }
*/
    @RequestMapping(value = "/cont/CON100/contractExcelImportConfirm", method = RequestMethod.POST)
    public Map<String, Object> importConfirm(HttpServletRequest request, Long headerId) throws IOException {
        IRequest iRequest = createRequestContext(request);
        Map<String, Object> response = new HashMap<String, Object>();
        response.put("success", false);
        try {
            conContractExcelService.contractExcelImport(iRequest, headerId);
            response.put("message", "导入成功");
            response.put("success", true);
        } catch (Exception e) {
            response.put("success", false);
            response.put("message", "导入失败！" + e.getMessage());
            e.printStackTrace();
        }

        return response;
    }
}