package hls.core.cont.controllers;

import java.util.List;
import javax.servlet.http.HttpServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.cont.dto.HlsCusConContractGuarantor;
import hls.core.cont.service.ConContractGuarantorService;

/**
 * 担保人
 * @author Administrator
 *
 */
@Controller
public class ConContractGuarantorController extends BaseController
{
	@Autowired
	private ConContractGuarantorService service;
	
	
	@RequestMapping(value = "/con/contract/guarantor/query")
	@ResponseBody
	public ResponseData query(final HlsCusConContractGuarantor contractGuarantor, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(service.selectGuarantorDetail(requestContext, contractGuarantor, page, pagesize));
	}
	
	@RequestMapping(value = "/con/contract/guarantor/detail/query")
	@ResponseBody
	public ResponseData queryDetail(final HlsCusConContractGuarantor contractGuarantor, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                    @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(service.queryDetail(requestContext, contractGuarantor, page, pagesize));
	}
	
	@RequestMapping(value = "/con/contract/guarantor/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody final List<HlsCusConContractGuarantor> contractGuarantors, final BindingResult result,
                               final HttpServletRequest request){
		 	getValidator().validate(contractGuarantors, result);
	        if (result.hasErrors()) {
	            ResponseData responseData = new ResponseData(false);
	            responseData.setMessage(getErrorMessage(result, request));
	            return responseData;
	        }
	        IRequest requestContext = createRequestContext(request);
	        return new ResponseData(service.batchUpdate(requestContext, contractGuarantors));
	}
}
