package hls.core.cont.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.cont.dto.*;
import hls.core.cont.service.ConContractCancelService;
import hls.core.cont.service.IConContractHistoryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * Created with IntelliJ IDEA.
 * User: Jeffery
 * Date: 2017/8/31
 * Time: 13:43
 * To change this template use File | Settings | File Templates.
 */
@Controller
public class ConContractHistoryController extends BaseController {

    @Autowired
    private IConContractHistoryService conContractHistoryService;
    @Autowired
    private ConContractCancelService conContractCancelService;

    /**
     * User: Jeffery
     * Date: 2017/8/31
     * Time: 13:43
     * 合同签约历史查询
    * */
    @RequestMapping(value="/con/contractSign/query/detail")
    @ResponseBody
    public ResponseData queryConSignDetail(final HlsCusConContractSign conContractSign, final HttpServletRequest request){
        IRequest iRequest = createRequestContext(request);
        List<Map> list = conContractHistoryService.querySignList(conContractSign.getContractId());
        return new ResponseData(list);
    }

    /**
     * User: Jeffery
     * Date: 2017/8/31
     * Time: 13:43
     * 合同起租历史查询
     * */
    @RequestMapping(value="/con/contractIncept/query/history")
    @ResponseBody
    public ResponseData queryConInceptDetail(final HlsCusConContractIncept conContractIncept, final HttpServletRequest request){
        IRequest iRequest = createRequestContext(request);
        List<Map> list = conContractHistoryService.queryInceptList(conContractIncept.getContractId());
        return new ResponseData(list);
    }

    /**
     * User: Jeffery
     * Date: 2017/8/31
     * Time: 13:43
     * 合同起租历史查询
     * */
    @RequestMapping(value="/con/contractChange/query/history")
    @ResponseBody
    public ResponseData queryConChangeDetail(final HlsCusConContractChangeReq conContractChangeReq, final HttpServletRequest request){
        IRequest iRequest = createRequestContext(request);
        List<Map> list = conContractHistoryService.queryChangeList(conContractChangeReq.getContractId());
        return new ResponseData(list);
    }

    /**
     * User: Jeffery
     * Date: 2017/8/31
     * Time: 13:43
     * 合同罚息减免历史查询
     * */
    @RequestMapping(value="/con/contractDebtExemption/query/history")
    @ResponseBody
    public ResponseData queryConDebtExemptionDetail(final HlsCusConContractChangeReq conContractChangeReq, final HttpServletRequest request){
        IRequest iRequest = createRequestContext(request);
        List<Map> list = conContractHistoryService.queryDebtExemption(conContractChangeReq.getContractId());
        return new ResponseData(list);
    }

    /**
     * User: Jeffery
     * Date: 2017/8/31
     * Time: 13:43
     * 合同c撤销历史查询
     * */
    @RequestMapping(value="/con/contractCancel/query/history")
    @ResponseBody
    public ResponseData queryConCancelDetail(final HlsCusConContractChangeReq conContractChangeReq, final HttpServletRequest request){
        IRequest iRequest = createRequestContext(request);
        List<Map> list = conContractHistoryService.queryConCancelList(conContractChangeReq.getContractId());
        return new ResponseData(list);
    }

    /**
     * User: Jeffery
     * Date: 2017/8/31
     * Time: 13:43
     * 合同结束历史查询
     * */
    @RequestMapping(value="/con/contractComplete/query/history")
    @ResponseBody
    public ResponseData queryConCompleteDetail(final HlsCusConContractChangeReq conContractChangeReq, final HttpServletRequest request){
        IRequest iRequest = createRequestContext(request);
        List<Map> list = conContractHistoryService.queryConCompleteList(conContractChangeReq.getContractId());
        return new ResponseData(list);
    }

    /**
     * User: Jeffery
     * Date: 2017/8/31
     * Time: 13:43
     * 合同取消附件查询
     * */
    @RequestMapping(value = "/con/contract/cancel/detail/query")
    @ResponseBody
    public ResponseData queryConCancelDoc(final HlsCusConContractAttachment contractAttachment, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                          @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        List<Map> list = conContractHistoryService.queryConCancelDoc(requestContext, contractAttachment, page, pagesize);
        return new ResponseData(list);
    }

    /**
     * User: Jeffery
     * Date: 2017/8/31
     * Time: 13:43
     * 合同变更查询
     * */
    @RequestMapping(value = "/query/contract/change/info")
    @ResponseBody
    public ResponseData queryChangeInfo(final HttpServletRequest request,HlsCusConContractChangeReq conContractChangeReq){
        return new ResponseData(conContractHistoryService.queryChangeInfo(conContractChangeReq.getContractId()));
    }

    /**
     * User: Jeffery
     * Date: 2017/8/31
     * Time: 13:43
     * 根据合同id查询合同相关的历史信息
     * */
    @RequestMapping(value = "/contract/con/query/byId")
    @ResponseBody
    public ResponseData queryDetailCon(final HlsCusConContractSign contractSign, final HttpServletRequest request){
        return new ResponseData(conContractHistoryService.queryConById(contractSign.getContractId()));
    }

    /**
     * User: Jeffery
     * Date: 2017/8/31
     * Time: 13:43
     * 合同取消查询
     * */
    @RequestMapping("/cancel/info/query")
    @ResponseBody
    public ResponseData queryConCancelInfo(final HlsCusConContractCancel cancelContract, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                           @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pageSize, final HttpServletRequest request){
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(conContractCancelService.queryConCancelInfo(cancelContract));
    }
}
