package hls.core.cont.controllers;

import javax.servlet.http.HttpServletRequest;

import hls.core.cont.dto.HlsCusConContractChangeReq;
import hls.core.csh.dto.HlsCusCshConContract;
import hls.core.csh.dto.HlsCusCshWriteOff;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.system.dto.ResponseData;

import hls.core.cont.service.ConContractIndexService;

@Controller
public class ConContractIndexController {

	@Autowired
	private ConContractIndexService conContractIndexService; 
	
	@RequestMapping(value = "/con/contract/index/getContractInfo")
	@ResponseBody
	public ResponseData  getContractInfo(final HlsCusCshConContract cshConContract, final HttpServletRequest request){
		return new ResponseData(conContractIndexService.getContractInfo(cshConContract));
	}
	
	@RequestMapping(value = "/con/contract/index/currentOutAmountInfo")
	@ResponseBody
	public ResponseData  currentOutAmountInfo(final HlsCusCshWriteOff cshWriteOff, final HttpServletRequest request){
		return new ResponseData(conContractIndexService.currentOutAmountInfo(cshWriteOff));
	}
	
	@RequestMapping(value = "/con/contract/index/getContractDetailByBpId")
	@ResponseBody
	public ResponseData  getContractDetailByBpId(final HlsCusCshConContract cshConContract, final HttpServletRequest request){
		return new ResponseData(conContractIndexService.getContractDetailByBpId(cshConContract));
	}
	@RequestMapping(value = "/con/contract/index/conContractChangeReqInfo")
	@ResponseBody
	public ResponseData conContractChangeReqInfo(final HttpServletRequest request){
		return new ResponseData(conContractIndexService.conContractChangeReqInfo());
	}
	 
	@RequestMapping(value = "/con/contract/index/contractCashFlowOverDateDetail")
	@ResponseBody
	public ResponseData contractCashFlowOverDateDetail(final HttpServletRequest request){
		return new ResponseData(conContractIndexService.contractCashFlowOverDateDetail());
	}
	
	@RequestMapping(value = "/con/contract/index/getConContractIndexNumInfo")
	@ResponseBody
	public ResponseData getConContractIndexNumInfo(HlsCusCshConContract cshConContract, final HttpServletRequest request){
		return new ResponseData(conContractIndexService.getConContractIndexNumInfo());
	}


	@RequestMapping(value = "/con/contract/index/conContractChangeReqDetail")
	@ResponseBody
	public ResponseData selectChangeInfoDetail(final HttpServletRequest request, HlsCusConContractChangeReq conContractChangeReq ){
		return new ResponseData(conContractIndexService.selectChangeInfoDetail(conContractChangeReq));
	}


	@RequestMapping(value = "/con/contract/index/getNewChangeId")
	@ResponseBody
	public ResponseData getNewChangeIdByChangeId(final HttpServletRequest request,HlsCusConContractChangeReq conContractChangeReq){
		return new ResponseData(conContractIndexService.getNewChangeIdByChangeId(conContractChangeReq));
	}

	@RequestMapping(value = "/con/contract/change/detail")
	@ResponseBody
	public ResponseData selectDetail(final HttpServletRequest request,HlsCusConContractChangeReq conContractChangeReq){
		return new ResponseData(conContractIndexService.selectDetail(conContractChangeReq));
	}
}
