package hls.core.cont.controllers;

import java.util.List;
import javax.servlet.http.HttpServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.cont.dto.HlsCusConContractLeaseItem;
import hls.core.cont.service.ConContractLeaseItemService;

@Controller
public class ConContractLeaseItemController extends BaseController
{
	@Autowired
	private ConContractLeaseItemService service;
	
	
	@RequestMapping(value = "/con/contract/Lease/item/query")
	@ResponseBody
	public ResponseData query(final HlsCusConContractLeaseItem contractLeaseItem, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(service.select(requestContext, contractLeaseItem, page, pagesize));
	}
	
	@RequestMapping(value = "/con/contract/LeaseItem/detail/query")
	@ResponseBody
	public ResponseData queryDetail(final HlsCusConContractLeaseItem contractLeaseItem, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                    @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(service.queryDetail(requestContext, contractLeaseItem, page, pagesize));
	}
	
	@RequestMapping(value = "/con/contract/Lease/item/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody final List<HlsCusConContractLeaseItem> contractLeaseItems, final BindingResult result,
                               final HttpServletRequest request){
		 	getValidator().validate(contractLeaseItems, result);
	        if (result.hasErrors()) {
	            ResponseData responseData = new ResponseData(false);
	            responseData.setMessage(getErrorMessage(result, request));
	            return responseData;
	        }
	        IRequest requestContext = createRequestContext(request);
	        return new ResponseData(service.batchUpdate(requestContext, contractLeaseItems));
	}
}
