package hls.core.cont.controllers;

import java.util.List;
import javax.servlet.http.HttpServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.cont.dto.HlsCusConContractMortgage;
import hls.core.cont.service.ConContractMortgageService;

@Controller
public class ConContractMortgageController extends BaseController
{
	@Autowired
	private ConContractMortgageService service;
	
	@RequestMapping(value = "/con/contract/mortgage/query")
	@ResponseBody
	public ResponseData query(final HlsCusConContractMortgage contractMortgage, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(service.select(requestContext, contractMortgage, page, pagesize));
	}
	
	@RequestMapping(value = "/con/contract/mortgage/detail/query")
	@ResponseBody
	public ResponseData queryDetail(final HlsCusConContractMortgage contractMortgage, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                    @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(service.queryDetail(requestContext, contractMortgage, page, pagesize));
	}
	
	@RequestMapping(value = "/con/contract/mortgage/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody final List<HlsCusConContractMortgage> contractMortgages, final BindingResult result,
                               final HttpServletRequest request){
		 	getValidator().validate(contractMortgages, result);
	        if (result.hasErrors()) {
	            ResponseData responseData = new ResponseData(false);
	            responseData.setMessage(getErrorMessage(result, request));
	            return responseData;
	        }
	        IRequest requestContext = createRequestContext(request);
	        return new ResponseData(service.batchUpdate(requestContext, contractMortgages));
	}
}
