package hls.core.cont.controllers;

import javax.servlet.http.HttpServletRequest;

import hls.core.cont.dto.HlsCusConContractSign;
import hls.core.cont.service.ConContractEventService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.cont.service.ConContractSignService;

import java.util.List;

@Controller
public class ConContractSignController extends BaseController
{
	@Autowired
	private ConContractSignService service;
	@Autowired
	private ConContractEventService eventService;

	@RequestMapping(value = "/con/contract/sign/detail/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody HlsCusConContractSign ConContractSign, final BindingResult result,
                               final HttpServletRequest request){
		 	getValidator().validate(ConContractSign, result);
	        if (result.hasErrors()) {
	            ResponseData responseData = new ResponseData(false);
	            responseData.setMessage(getErrorMessage(result, request));
	            return responseData;
	        }
	        IRequest requestContext = createRequestContext(request);
	        
	        service.save(requestContext, ConContractSign,requestContext.getUserId());
		//	eventService.contractEvent(requestContext,"CON_CONTRACT.SIGN",HlsCusConContractSign.getContractId(),requestContext.getUserId());
	        return new ResponseData();
	}
	
	@RequestMapping(value = "/csh/contract/sign/query")
	@ResponseBody
	public ResponseData queryDetail(final HlsCusConContractSign contractSign, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                    @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(service.queryDetail(requestContext, contractSign, page, pagesize));
	}

	@RequestMapping(value="/con/contractSign/query")
	@ResponseBody
	public ResponseData query(final HlsCusConContractSign conContractSign, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest iRequest = createRequestContext(request);
		List<HlsCusConContractSign> list = service.select(iRequest,conContractSign,page,pagesize);
		return new ResponseData(list);
	}
}
