package hls.core.cont.controllers;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.cont.dto.HlsCusConContractTenant;
import hls.core.cont.service.ConContractTenantService;

@Controller
public class ConContractTenantController extends BaseController
{
	@Autowired
	private ConContractTenantService service;
	
	@RequestMapping(value = "/con/contract/tenant/query")
	@ResponseBody
	public ResponseData query(final HlsCusConContractTenant contractTenant, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(service.select(requestContext, contractTenant, page, pagesize));
	}
	
	@RequestMapping(value = "/con/contract/tenant/detail/query")
	@ResponseBody
	public ResponseData queryDetail(final HlsCusConContractTenant contractTenant, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                    @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(service.queryDetail(requestContext, contractTenant, page, pagesize));
	}
	
	@RequestMapping(value = "/con/contract/tenant/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody final List<HlsCusConContractTenant> contractTenants, final BindingResult result,
                               final HttpServletRequest request){
		 	getValidator().validate(contractTenants, result);
	        if (result.hasErrors()) {
	            ResponseData responseData = new ResponseData(false);
	            responseData.setMessage(getErrorMessage(result, request));
	            return responseData;
	        }
	        IRequest requestContext = createRequestContext(request);
	        return new ResponseData(service.batchUpdate(requestContext, contractTenants));
	}
}
