package hls.core.cont.controllers;

import hls.core.cont.dto.HlsCusConFloatingRateReq;
import hls.core.cont.dto.HlsCusConFloatingRateReqLn;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.cont.dto.ConFloatingRateReqLn;
import hls.core.cont.service.IConFloatingRateReqLnService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.springframework.validation.BindingResult;

import java.util.ArrayList;
import java.util.List;

@Controller
public class ConFloatingRateReqLnController extends BaseController {

    @Autowired
    private IConFloatingRateReqLnService service;


    @RequestMapping(value = "/con/floating/rate/req/ln/query")
    @ResponseBody
    public ResponseData query(HlsCusConFloatingRateReqLn dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/con/floating/rate/req/ln/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusConFloatingRateReqLn> dto, HttpServletRequest request) {
        //  getValidator().validate(dto, result);
        //if (result.hasErrors()) {
        //ResponseData responseData = new ResponseData(false);
        //responseData.setMessage(getErrorMessage(result, request));
        //return responseData;
        //}
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/con/floating/rate/req/ln/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusConFloatingRateReqLn> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }

    /*调息明细-调息列表查询*/
    @RequestMapping(value = "/con/floating/rate/req/ln/rateChangeListQuery")
    @ResponseBody
    public ResponseData rateChangeListQuery(@RequestBody(required = false) HlsCusConFloatingRateReqLn dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.rateChangeListQuery(requestContext, dto, page, pageSize));
    }

    /*调息明细-调息整体信息查询*/
    @RequestMapping(value = "/con/floating/rate/req/ln/rateChangeTotalQuery")
    @ResponseBody
    public ResponseData rateChangeTotalQuery(@RequestBody(required = false) HlsCusConFloatingRateReqLn dto, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        List<HlsCusConFloatingRateReqLn> list = new ArrayList<>();
        list.add(service.rateChangeTotalQuery(requestContext, dto));
        return new ResponseData(list);
    }

    /**
     * 开始调息申请,但是不计算
     *
     * @param request
     * @param floatingRateReq
     * @return
     */
    @RequestMapping(value = "/con/floating/rate/req/create/rateChange")
    @ResponseBody
    public HlsCusConFloatingRateReq createRateChange(HttpServletRequest request, @RequestBody(required = false) HlsCusConFloatingRateReq floatingRateReq, HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        Long companyId = session.getAttribute("companyId") != null ? (Long) session.getAttribute("companyId") : 0L;
        floatingRateReq.setCompanyId(companyId);
        HlsCusConFloatingRateReq floatingRateChange = service.createFloatingRateChange(requestContext, floatingRateReq);
        return floatingRateChange;
    }

    /**
     * 开始调息计算
     *
     * @param request
     * @param floatingRateReq
     * @return
     */
    @RequestMapping(value = "/con/floating/rate/req/cal/rateChange")
    @ResponseBody
    public ResponseData calRateChange(HttpServletRequest request,@RequestBody(required = false) HlsCusConFloatingRateReq floatingRateReq) {
        IRequest requestContext = createRequestContext(request);
        service.floatingRate(requestContext, floatingRateReq);
        return new ResponseData();
    }

    /**
     * 取消调息计算
     *
     * @param request
     * @param floatingRateReq
     * @return
     */
    @RequestMapping(value = "/con/floating/rate/req/cancel/rateChange")
    @ResponseBody
    public ResponseData cancelRateChange(HttpServletRequest request,@RequestBody(required = false) HlsCusConFloatingRateReq floatingRateReq) {
        IRequest requestContext = createRequestContext(request);
        service.cancelFloatingRateReq(requestContext, floatingRateReq);
        return new ResponseData();
    }

    /**
     * 启动调息工作流
     *
     * @param request
     * @param floatingRateReq
     * @return
     */
    @RequestMapping(value = "/con/floating/rate/req/workflow/rateChange")
    @ResponseBody
    public ResponseData rateChangeWorkFlowStart(HttpServletRequest request,@RequestBody(required = false) HlsCusConFloatingRateReq floatingRateReq) {
        IRequest requestContext = createRequestContext(request);
        service.floatingRateWorkFlowStart(requestContext, floatingRateReq);
        return new ResponseData();
    }
}