package hls.core.cont.controllers;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hand.hap.attachment.exception.FileReadIOException;
import com.hand.hap.core.IRequest;
import com.hand.hap.core.exception.TokenException;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.cont.dto.*;
import hls.core.cont.mapper.HlsCusConContractGuarantorMapper;
import hls.core.cont.mapper.HlsCusConContractLeaseItemMapper;
import hls.core.cont.mapper.HlsCusConContractMortgageMapper;
import hls.core.cont.mapper.HlsCusConContractTenantMapper;
import hls.core.cont.service.ConContractAttachmentService;
import hls.core.cont.service.ConContractDocxService;
import hls.core.csh.dto.*;
import hls.core.csh.exception.ChangeLimitException;
import hls.core.csh.service.*;
import hls.core.fnd.dto.DocFileTempletRule;
import hls.core.fnd.dto.HlsDocFileTemplet;
import hls.core.fnd.mapper.DocFileTempletRuleMapper;
import hls.core.fnd.service.HlsDocFileTempletService;
import hls.core.hls.components.Datasource2Json;
import hls.core.hls.dto.HlsSystemNotice;
import hls.core.hls.dto.HlsUserRelationship;
import hls.core.hls.service.HlsSystemNoticeService;
import hls.core.hls.service.IHlsUserRelationshipService;
import hls.core.ruleengine.service.IHLSRuleEngineInitService;
import hls.core.ruleengine.service.IHlsRuleEngineService;
import hls.core.vat.dto.HlsCusAcrInvoiceLn;
import hls.core.vat.service.AcrInvoiceLnService;
import org.docx4j.openpackaging.exceptions.Docx4JException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.text.ParseException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Controller
public class ConHomepageController extends BaseController{

	@Autowired
	private CshWriteOffService cshWriteOffService;
	@Autowired
	private ICshConContractService conContractService;
	@Autowired
	private HlsSystemNoticeService hlsSystemNoticeService;
	@Autowired
	private IConContractCashflowService conContractCashflowService;
	@Autowired
	private ICshPaymentReqLnService cshPaymentReqLnService;
	@Autowired
	private CshTransactionService cshTransactionService;
	@Autowired
	private AcrInvoiceLnService acrInvoiceLnService;
	@Autowired
	private IHlsUserRelationshipService hlsUserRelationshipService;
	@Autowired
	private IHLSRuleEngineInitService hLSRuleEngineInitService;
	@Autowired
	private ConContractDocxService contractDocxService;
	@Autowired
	private IHlsRuleEngineService hlsRuleEngineService;
	@Autowired
	private HlsDocFileTempletService hlsDocFileTempletService;
	@Autowired
	private ConContractAttachmentService contractAttachmentService;
	@Autowired
	private HlsCusConContractTenantMapper contractTenantMapper;
	@Autowired
	private HlsCusConContractGuarantorMapper contractGuarantorMapper;
	@Autowired
	private HlsCusConContractLeaseItemMapper contractLeaseItemMapper;
	@Autowired
	private Datasource2Json datasource2Json;
	@Autowired
	private DocFileTempletRuleMapper docFileTempletRuleMapper;
	@Autowired
	private HlsCusConContractMortgageMapper conContractMortgageMapper;






	/**
	 * 合同首页-基本信息-合同信息查询
	 * @param cshConContract
	 * @param request
	 * @return
	 */
	@RequestMapping(value = "/con/contract/Information/query")
	@ResponseBody
	public ResponseData  contractInformation (final HlsCusCshConContract cshConContract, final HttpServletRequest request, HttpSession session){
		cshConContract.setCompany_id((Long)session.getAttribute("companyId"));
		List<HlsCusCshConContract> list = conContractService.selectAllCshConContractInformation(cshConContract);
		return new ResponseData(list);
	}
	/**
	 * 合同首页    投放情况查询 -- 申请 -- 折线图
	 * @param request
	 * @param page
	 * @param pagesize
	 * @return
	 * @throws ParseException
	 */
	@RequestMapping(value = "/con/conHomepage/putIn/query")
	@ResponseBody
	public ResponseData putIn(final HlsCusCshWriteOff cshWriteOff, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
							  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request) throws ParseException{
		List<HlsCusCshWriteOff> list = cshWriteOffService.selectAllPutIn(createRequestContext(request), cshWriteOff, page, pagesize);
		return new ResponseData(list);
	}
	/**
	 * 合同首页    投放详情查询
	 * @param request
	 * @param page
	 * @param pagesize
	 * @return
	 * @throws ParseException
	 * @throws de.odysseus.el.tree.impl.Parser.ParseException
	 */
	@RequestMapping(value = "/con/conHomepage/details/query")
	@ResponseBody
	public ResponseData selectDetails(final HlsCusCshWriteOff cshWriteOff, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
									  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request) throws ParseException, de.odysseus.el.tree.impl.Parser.ParseException{
		List<HlsCusCshWriteOff> list = cshWriteOffService.selectAlldetails(createRequestContext(request), cshWriteOff, page, pagesize);
		return new ResponseData(list);
	}
	/**
	 * 投放信息grid查询信息 -- 右下角Grid
	 * @param request
	 * @param session
	 * @param cshPaymentReqLn
	 * @param page
	 * @param pagesize
	 * @return
	 */
	@RequestMapping(value = "/csh/CshPaymentReqLn/queryLaunchApp/query")
	@ResponseBody
	public ResponseData queryLaunchApp(HttpServletRequest request,HttpSession session, final HlsCusCshPaymentReqLn cshPaymentReqLn,
			@RequestParam(defaultValue = DEFAULT_PAGE) final int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
		List<HlsCusCshPaymentReqLn>  list = cshPaymentReqLnService.selectLaunchApplication(cshPaymentReqLn,session);
		return new ResponseData(list);
	}
	/**
	 * 合同各状态下数量
	 * @return
	 */
	@RequestMapping(value = "/csh/conHomepage/statistical/query")
	@ResponseBody
	public HlsCusCshConContract selectStatistical(final HlsCusCshConContract cshConContract , HttpSession session){
		HlsCusCshConContract conContract = conContractService.selectAllStatistical(session);
		return conContract;
	}
	/**
	 * 变更类型统计
	 * @return
	 * @throws ParseException
	 * @throws ChangeLimitException
	 */
	@RequestMapping(value = "/csh/conHomepage/alterStatistics/query")
	@ResponseBody
	public HlsCusConContractChangeReq alterStatistics(final HlsCusConContractChangeReq changeReq, HttpSession session) throws ParseException, ChangeLimitException{
		return conContractService.selectAlterStatistics(changeReq,session);
	}

	/**
	 * 合同变更信息
	 * @return
	 * @throws ChangeLimitException
	 */
	@RequestMapping(value = "/csh/conHomepage/conChangeInfo/query")
	@ResponseBody
	public ResponseData conChangeInfo(final HlsCusConContractChangeReq changeReq, HttpSession session) throws ChangeLimitException{

		return new ResponseData(conContractService.selectAllReqDetailedInformation(changeReq,session));
	}


	/**
	 * 合同动态信息
	 * @return
	 */
	@RequestMapping(value = "/con/conHomepage/dynamicInfo/query")
	@ResponseBody
	public List<HlsSystemNotice> dynamicInfo(final HlsSystemNotice hlsSystemNotice,final HttpServletRequest request,@RequestParam(defaultValue = DEFAULT_PAGE) int page, @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize){
		IRequest requestContext = createRequestContext(request);
		hlsSystemNotice.setCompanyId(requestContext.getCompanyId());
		List<HlsSystemNotice> hlist = hlsSystemNoticeService.selectConNotice(hlsSystemNotice,page,pageSize);
		return hlist;
	}

	/**
	 * 合同首页-基本信息-统计图
	 * @return
	 */
	@RequestMapping(value = "/con/conHomepage/statisticalChart/query")
	@ResponseBody
	public List<HlsCusConContractStatus> statisticalChart(final HlsCusConContractStatus conContractStatus, HttpSession session){
		List<HlsCusConContractStatus> clist = conContractService.selectContractStatusInfo(conContractStatus,session);
		return clist;
	}
	/**
	 * 首页-回笼信息-应收金额、应收本金查询
	 * @param cashflow
	 * @return
	 * @throws ParseException
	 * @throws ChangeLimitException
	 */
	@RequestMapping(value = "/con/conHomepage/principalInquiry/query")
	@ResponseBody
	public HlsCusConContractCashflow statistics(HlsCusConContractCashflow cashflow, HttpSession session) throws ParseException, ChangeLimitException{
		cashflow = conContractCashflowService.selectInformationStatistics(cashflow,session);
		return cashflow;
	}
	/**
	 * 首页-回笼信息-应收金额、应收本金,未收本金，未收金额查询
	 * @param cashflow
	 * @return
	 * @throws ParseException
	 * @throws ChangeLimitException
	 */
	@RequestMapping(value = "/con/conHomepage/principalAllInquiry/query")
	@ResponseBody
	public Map selectInformationAllStatistics(HlsCusConContractCashflow cashflow, HttpSession session) throws ParseException, ChangeLimitException{
		Map map = conContractCashflowService.selectInformationAllStatistics(cashflow,session);
		return map;
	}
	/**
	 * 首页-回笼信息-账龄
	 * @return
	 */
	@RequestMapping(value = "/con/conHomepage/aging/query")
	@ResponseBody
	public ConAging selectAgingCount(final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		ConAging conAging = cshWriteOffService.SelectAgingCount(requestContext);
		return conAging;
	}

	/**
	 * 首页-回笼信息-合同类型统计
	 * @param conContract
	 * @return
	 * @throws ParseException
	 * @throws ChangeLimitException
	 */
	@RequestMapping(value = "/con/conHomepage/typeStatistics/query")
	@ResponseBody
	public ResponseData typeStatistics(HlsCusCshConContract conContract, HttpSession session) throws ParseException, ChangeLimitException{
		List<HlsCusCshConContract> list  = conContractService.selectTypeStatistics(conContract,session);
		return new ResponseData(list);
	}

	@RequestMapping(value = "/con/conHomepage/twoTypeStatistics/query")
	@ResponseBody
	public Map selectTwoTypeStatistics(HlsCusCshConContract conContract, HttpSession session) throws ParseException, ChangeLimitException{
		Map map  = conContractService.selectTwoTypeStatistics(conContract,session);
		return map;
	}
	/**
	 * 合同首页   回笼    收款查询
	 * @param request
	 * @return
	 * @throws ParseException
	 */
	@RequestMapping(value = "/con/contract/index/currentGetAmountInfo")
	@ResponseBody
	public ResponseData currentGetAmountInfo(final HlsCusCshTransaction cshTransaction, final HttpServletRequest request) throws ParseException{
		//List<HlsCusCshWriteOff> list = conContractIndexService.currentGetAmountInfo(cshWriteOff);
		IRequest requestContext =  createRequestContext(request);
		List<HlsCusCshTransaction> list = cshTransactionService.selectAllCshTransaction(requestContext,cshTransaction);
		return new ResponseData(list);
	}

	/**
	 *合同首页，回笼，开票
	 */
	@RequestMapping(value = "/con/contract/index/acrInvoiceLn")
	@ResponseBody
	public ResponseData acrInvoiceLn(final HlsCusCshTransaction cshTransaction, HttpServletRequest request) throws ParseException {
		IRequest  requestContext = createRequestContext(request);
		List<HlsCusAcrInvoiceLn> list = acrInvoiceLnService.selectAllAcrInvoiceLn(requestContext,cshTransaction);
		return new ResponseData(list);
	}

	/**
	 * 合同首页-投放信息-投放金额信息百分比
	 * @return
	 */
	@RequestMapping(value = "/con/conHomepage/throwAmountPercent/query")
	@ResponseBody
	public HlsCusConContractStatus throwAmountPercent(final HttpServletRequest request, HlsCusConContractStatus pConContractStatus, HttpSession session){
		IRequest requestContext = createRequestContext(request);
		HlsCusConContractStatus conContractStatus = conContractService.selectTotalThrowInfo(requestContext,pConContractStatus);
		return conContractStatus;
	}
	/**
	 * 合同首页- 投放信息-审批状态查询
	 * @return
	 */
	@RequestMapping(value = "/con/conHomepage/ApprovalQuantity/query")
	@ResponseBody
	public HlsCusCshApprovalQuantity selectApprovalQuantity(HttpSession session){
		HlsCusCshApprovalQuantity approvalQuantity = cshPaymentReqLnService.selectApprovalQuantity(session);
		return approvalQuantity;
	}
	/**
	 * 合同首页-基本信息-合同信息
	 * @param conContract
	 * @return
	 * @throws ChangeLimitException
	 */
	@RequestMapping(value = "/con/conHomepage/ContractInFo/query")
	@ResponseBody
	public ResponseData selectContractInFo(HlsCusCshConContract conContract, HttpSession session) throws ChangeLimitException{
		List<HlsCusCshConContract> list =  conContractService.selectContractInFo(conContract,session);
		return new ResponseData(list);
	}
	/**
	 * 合同首页-基本信息-合同总数-   存量与新增合同树
	 * @param conContract
	 * @return
	 * @throws ParseException
	 * @throws ChangeLimitException
	 */
	@RequestMapping(value = "/con/conHomepage/StockCount/query")
	@ResponseBody
	public ResponseData selectStockCount(HlsCusCshConContract conContract, HttpSession session) throws ParseException, ChangeLimitException{
		List<HlsCusCshConContract> list = conContractService.selectStockCount(conContract,session);
		return new ResponseData(list);
	}

	/**
	 * 合同收藏
	 * @return
	 */
	@RequestMapping(value = "/hls/contract/collect/submit")
	@ResponseBody
	public ResponseData collect(String collecContractId, final HttpServletRequest request){

		IRequest requestContext = createRequestContext(request);

		Long userId = requestContext.getUserId();

		String[] arrs = collecContractId.split(",");

		HlsUserRelationship hlsUserRelationships = null;
		for(int i=0;i<arrs.length;i++) {
			hlsUserRelationships = new HlsUserRelationship();
			hlsUserRelationships.setRelationDocumentId(Long.parseLong(arrs[i]));
			hlsUserRelationships.setUserId(userId);
			hlsUserRelationships.setRelationDocumentCategory("CON_CONTRACT");
			hlsUserRelationships.setRelationType("P2D");

			hlsUserRelationshipService.insertSelective(requestContext, hlsUserRelationships);
		}

		return new ResponseData();
	}

	/**
	 * 合同取消收藏
	 * @return
	 */
	@RequestMapping(value = "/hls/contract/unCollect/submit")
	@ResponseBody
	public ResponseData collected(String unColleccontractId,final HttpServletRequest request){
		String[] arrs = unColleccontractId.split(",");

		for(int i=0;i<arrs.length;i++)
		{
			hlsUserRelationshipService.uncollect(Long.parseLong(arrs[i]));
		}

		return new ResponseData();
	}

	/**
	 * 合同文本生成
	 * @return
	 */
	@RequestMapping(value = "con/contract/content/create")
	@ResponseBody
	public ResponseData contentCreate(HlsCusCshConContract CshConContract , final HttpServletRequest request, HttpServletResponse response, HttpSession session) throws TokenException, FileReadIOException, Docx4JException{

		IRequest requestContext = createRequestContext(request);

		String templetType = "CONTRACT_SIGN";
		Long companyId = (Long) session.getAttribute("companyId");
		DocFileTempletRule docFileTempletRule = new DocFileTempletRule();
		docFileTempletRule.setCompanyId(companyId);
		docFileTempletRule.setTempletType(templetType);
		docFileTempletRule = docFileTempletRuleMapper.selectOne(docFileTempletRule);


//		String type = "CONTRACT_CONTENT";
//		HlsRuleEngine hlsRuleEngine = hlsRuleEngineService.queryByType(type);

		String json = null;
		try {

			Map<String, Object> pMap = new HashMap<String, Object>();
			pMap.put("contractId",CshConContract.getContract_id());
			json = datasource2Json.executeSQL4Json(docFileTempletRule.getDataSourceId(),pMap);
		} catch (IOException e) {
			e.printStackTrace();
		}
		JSONObject jsonObject0 = JSON.parseObject(json);
		JSONObject jsonObject1 = JSON.parseObject(JSON.toJSONString(jsonObject0.get(docFileTempletRule.getDataSourceId().toString())));
		JSONObject jsonObject =  JSON.parseObject(JSON.toJSONString(jsonObject1.get("default")));
		jsonObject.put("ruleEngineId",docFileTempletRule.getRuleEngineId());

		//保存合同附件表
		String[] arr = hLSRuleEngineInitService.ruleEngineInit(requestContext,jsonObject);
		HlsDocFileTemplet hlsDocFileTemplet = null;

		//每次生成合同文本区删除原来的合同文本记录
		contractAttachmentService.deleteContentById(CshConContract.getContract_id());
		//重新插入合同文本记录
		HlsCusConContractAttachment cca = null;
		Map<String,Object> params = null;
		for(int i=0 ;i<arr.length ;i++){
			hlsDocFileTemplet = new HlsDocFileTemplet();
			hlsDocFileTemplet.setTempletId(Long.parseLong(arr[i]));
			hlsDocFileTemplet = hlsDocFileTempletService.selectByPrimaryKey(requestContext,hlsDocFileTemplet);
			cca = new HlsCusConContractAttachment();
			params = new HashMap<String,Object>();
			params.put("contractId",CshConContract.getContract_id());
			params.put("templetId",hlsDocFileTemplet.getTempletId());

			if("TENANT".equalsIgnoreCase(hlsDocFileTemplet.getUsageCategory())){
				cca.setContractId(CshConContract.getContract_id());
				cca.setContractAttachmentCategory("CON_TRMPLATE");
				cca.setDescription("合同文本");
				cca.setSourceId(hlsDocFileTemplet.getTempletId());
				cca.setBpCategory("TENANT");
				cca.setSourceType("DOC_FILE");
				HlsCusConContractTenant contractTenant = new HlsCusConContractTenant();
				contractTenant.setContractId(CshConContract.getContract_id());
				List<HlsCusConContractTenant> lists = contractTenantMapper.select(contractTenant);
				for(int k=0 ;k<lists.size() ;k++){
					cca.setBpId(lists.get(k).getTenantBpId());
					cca = contractAttachmentService.insertSelective(requestContext,cca);
					params.put("bpId",cca.getBpId());
					params.put("contractAttachmentId",cca.getContractAttachmentId());
					contractDocxService.process(requestContext,params,jsonObject);
				}
			}else if("GUARANTOR".equalsIgnoreCase(hlsDocFileTemplet.getUsageCategory())){
				cca.setContractId(CshConContract.getContract_id());
				cca.setContractAttachmentCategory("CON_TRMPLATE");
				cca.setDescription("合同文本");
				cca.setSourceId(hlsDocFileTemplet.getTempletId());
				cca.setBpCategory("GUARANTOR");
				cca.setSourceType("DOC_FILE");
				HlsCusConContractGuarantor contractGuarantor = new HlsCusConContractGuarantor();
				contractGuarantor.setContractId(CshConContract.getContract_id());
				List<HlsCusConContractGuarantor> lists = contractGuarantorMapper.select(contractGuarantor);
				for(int k=0 ;k<lists.size() ;k++){
					cca.setBpId(lists.get(k).getGuarantorBpId());
					cca = contractAttachmentService.insertSelective(requestContext,cca);
					params.put("bpId",cca.getBpId());
					params.put("contractAttachmentId",cca.getContractAttachmentId());
					contractDocxService.process(requestContext,params,jsonObject);
				}

			}else if("VENDER".equalsIgnoreCase(hlsDocFileTemplet.getUsageCategory())){
				cca.setContractId(CshConContract.getContract_id());
				cca.setContractAttachmentCategory("CON_TRMPLATE");
				cca.setDescription("合同文本");
				cca.setSourceId(hlsDocFileTemplet.getTempletId());
				cca.setBpCategory("VENDER");
				cca.setSourceType("DOC_FILE");
				HlsCusConContractLeaseItem contractLeaseItem = new HlsCusConContractLeaseItem();
				contractLeaseItem.setContractId(CshConContract.getContract_id());
				List<HlsCusConContractLeaseItem> lists = contractLeaseItemMapper.select(contractLeaseItem);
				for(int k=0 ;k<lists.size() ;k++){
					cca.setBpId(lists.get(k).getVenderBpId());
					cca = contractAttachmentService.insertSelective(requestContext,cca);
					params.put("bpId",cca.getBpId());
					params.put("contractAttachmentId",cca.getContractAttachmentId());
					contractDocxService.process(requestContext,params,jsonObject);
				}
			}else if("PLEDGER".equalsIgnoreCase(hlsDocFileTemplet.getUsageCategory())){
				cca.setContractId(CshConContract.getContract_id());
				cca.setContractAttachmentCategory("CON_TRMPLATE");
				cca.setDescription("合同文本");
				cca.setSourceId(hlsDocFileTemplet.getTempletId());
				cca.setBpCategory("PLEDGER");
				cca.setSourceType("DOC_FILE");
				HlsCusConContractMortgage hlsCusConContractMortgage = new HlsCusConContractMortgage();
				hlsCusConContractMortgage.setContractId(CshConContract.getContract_id());

				List<HlsCusConContractMortgage> lists = conContractMortgageMapper.select(hlsCusConContractMortgage);
				for(int k=0 ;k<lists.size() ;k++){
					cca.setBpId(lists.get(k).getMortgagorBpId());
					cca = contractAttachmentService.insertSelective(requestContext,cca);
					params.put("bpId",cca.getBpId());
					params.put("contractAttachmentId",cca.getContractAttachmentId());
					contractDocxService.process(requestContext,params,jsonObject);
				}
			}
		}
		//contractDocxService.docxCreateMethod(requestContext,HlsCusCshConContract.getContract_id(),templetId);

		return new ResponseData();
	}
	/**
	 * 单条合同文本生成
	 * @return
	 */
	@RequestMapping(value = "con/contract/content/single/create")
	@ResponseBody
	public ResponseData contentCreate(HlsCusConContractAttachment contractAttachment , final HttpServletRequest request) throws TokenException, FileReadIOException, Docx4JException{
		IRequest requestContext = createRequestContext(request);
		JSONObject jsonObject = new JSONObject();
		contractAttachment = contractAttachmentService.selectByPrimaryKey(requestContext,contractAttachment);
		Map params = new HashMap<String,Object>();
		params.put("contractId",contractAttachment.getContractId());
		params.put("templetId",contractAttachment.getSourceId());
		params.put("bpId",contractAttachment.getBpId());
		params.put("contractAttachmentId",contractAttachment.getContractAttachmentId());

		contractDocxService.process(requestContext,params,jsonObject);
		return new ResponseData();
	}
}
