package hls.core.cont.dto;

import com.hand.hap.system.dto.BaseDTO;
import org.hibernate.validator.constraints.NotEmpty;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Transient;
import javax.validation.constraints.NotNull;
import java.util.Date;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-09-25
 * Time: 9:50
 */
public class ConContract extends BaseDTO{
    @Id
    @GeneratedValue
    private Long contractId;

    @NotNull
    private Long companyId;

    private Long projectId;

    private Long quotationId;

    @NotEmpty
    private String documentType;

    @NotEmpty
    private String documentCategory;

    @NotEmpty
    private String businessType;

    private String contractNumber;

    private String contractName;

    private String contractStatus;

    private String leaseChannel;

    private Long bpAccountId;

    private String division;

    private Date signDate;

    private Date inceptionOfLease;

    private Long employeeId;

    private Long unitId;

    private Date leaseStartDate;

    private Date firstPayDate;

    private Date lastPayDate;

    private Date leaseEndDate;

    private Date originalRecallDate;

    private Date leaseCardRecallDate;

    private Date earlyTerminationDate;

    private Date terminationDate;

    private Date assignmentDate;

    private Long leaseTimes;

    private Long annualPayTimes;

    private Double leaseTerm;

    private Long payType;

    private String currency;

    private Long taxTypeId;

    private String vatFlag;

    private Double vatRate;

    private Double leaseItemAmount;

    private Double vatInput;

    private Long vatInputTaxTypeId;

    private Double vatInputTaxTypeRate;

    private Double downPaymentRatio;

    private Double downPayment;

    private Double netDownPayment;

    private Double vatDownPayment;

    private Double financeAmount;

    private Double netFinanceAmount;

    private Double vatFinanceAmount;

    private Double totalRental;

    private Double netTotalRental;

    private Double vatTotalRental;

    private Double totalInterest;

    private Double netTotalInterest;

    private Double vatTotalInterest;

    private Double leaseChargeRatio;

    private Double leaseCharge;

    private Double netLeaseCharge;

    private Double vatLeaseCharge;

    private Double leaseMgtFeeRatio;

    private Double leaseMgtFee;

    private Double netLeaseMgtFee;

    private Double vatLeaseMgtFee;

    private String leaseMgtFeeRule;

    private Double depositRatio;

    private Double deposit;

    private String depositDeduction;

    private Double residualRatio;

    private Double residualValue;

    private Double netResidualValue;

    private Double vatResidualValue;

    private Double balloonRatio;

    private Double balloon;

    private Double netBalloon;

    private Double vatBalloon;

    private String baseRateType;

    private Double baseRate;

    private Double intRate;

    private Double intRateImplicit;

    private String intRateType;

    private Double irr;

    private Double irrAfterTax;

    private Double pmt;

    private Double pmtFirst;

    private Double annualMeanRate;

    private String receivedStatus;

    private String overdueStatus;

    private String billingMethod;

    private String billingStatus;

    private String bizDayConvention;

    private String penaltyProfile;

    private String authorityRuleString;

    private String billingProfile;

    private String floatingRangeMethod;

    @Transient
    private Date dayEndDate;

    @Transient
    private Double newBaseRate;

    public String getFloatingRangeMethod() {
        return floatingRangeMethod;
    }

    public void setFloatingRangeMethod(String floatingRangeMethod) {
        this.floatingRangeMethod = floatingRangeMethod;
    }

    public Double getNewBaseRate() {
        return newBaseRate;
    }

    public void setNewBaseRate(Double newBaseRate) {
        this.newBaseRate = newBaseRate;
    }

    public Date getDayEndDate() {
        return dayEndDate;
    }

    public void setDayEndDate(Date dayEndDate) {
        this.dayEndDate = dayEndDate;
    }

    public String getBillingProfile() {
        return billingProfile;
    }

    public void setBillingProfile(String billingProfile) {
        this.billingProfile = billingProfile;
    }

    public String getAuthorityRuleString() {
        return authorityRuleString;
    }

    public void setAuthorityRuleString(String authorityRuleString) {
        this.authorityRuleString = authorityRuleString;
    }

    public void setContractId(Long contractId){
        this.contractId = contractId;
    }

    public Long getContractId(){
        return contractId;
    }

    public void setCompanyId(Long companyId){
        this.companyId = companyId;
    }

    public Long getCompanyId(){
        return companyId;
    }

    public void setProjectId(Long projectId){
        this.projectId = projectId;
    }

    public Long getProjectId(){
        return projectId;
    }

    public void setQuotationId(Long quotationId){
        this.quotationId = quotationId;
    }

    public Long getQuotationId(){
        return quotationId;
    }

    public void setDocumentType(String documentType){
        this.documentType = documentType;
    }

    public String getDocumentType(){
        return documentType;
    }

    public void setDocumentCategory(String documentCategory){
        this.documentCategory = documentCategory;
    }

    public String getDocumentCategory(){
        return documentCategory;
    }

    public void setBusinessType(String businessType){
        this.businessType = businessType;
    }

    public String getBusinessType(){
        return businessType;
    }

    public void setContractNumber(String contractNumber){
        this.contractNumber = contractNumber;
    }

    public String getContractNumber(){
        return contractNumber;
    }

    public void setContractName(String contractName){
        this.contractName = contractName;
    }

    public String getContractName(){
        return contractName;
    }

    public void setContractStatus(String contractStatus){
        this.contractStatus = contractStatus;
    }

    public String getContractStatus(){
        return contractStatus;
    }

    public void setLeaseChannel(String leaseChannel){
        this.leaseChannel = leaseChannel;
    }

    public String getLeaseChannel(){
        return leaseChannel;
    }

    public void setBpAccountId(Long bpAccountId){
        this.bpAccountId = bpAccountId;
    }

    public Long getBpAccountId(){
        return bpAccountId;
    }

    public void setDivision(String division){
        this.division = division;
    }

    public String getDivision(){
        return division;
    }

    public void setSignDate(Date signDate){
        this.signDate = signDate;
    }

    public Date getSignDate(){
        return signDate;
    }

    public void setInceptionOfLease(Date inceptionOfLease){
        this.inceptionOfLease = inceptionOfLease;
    }

    public Date getInceptionOfLease(){
        return inceptionOfLease;
    }

    public void setEmployeeId(Long employeeId){
        this.employeeId = employeeId;
    }

    public Long getEmployeeId(){
        return employeeId;
    }

    public void setUnitId(Long unitId){
        this.unitId = unitId;
    }

    public Long getUnitId(){
        return unitId;
    }

    public void setLeaseStartDate(Date leaseStartDate){
        this.leaseStartDate = leaseStartDate;
    }

    public Date getLeaseStartDate(){
        return leaseStartDate;
    }

    public void setFirstPayDate(Date firstPayDate){
        this.firstPayDate = firstPayDate;
    }

    public Date getFirstPayDate(){
        return firstPayDate;
    }

    public void setLastPayDate(Date lastPayDate){
        this.lastPayDate = lastPayDate;
    }

    public Date getLastPayDate(){
        return lastPayDate;
    }

    public void setLeaseEndDate(Date leaseEndDate){
        this.leaseEndDate = leaseEndDate;
    }

    public Date getLeaseEndDate(){
        return leaseEndDate;
    }

    public void setOriginalRecallDate(Date originalRecallDate){
        this.originalRecallDate = originalRecallDate;
    }

    public Date getOriginalRecallDate(){
        return originalRecallDate;
    }

    public void setLeaseCardRecallDate(Date leaseCardRecallDate){
        this.leaseCardRecallDate = leaseCardRecallDate;
    }

    public Date getLeaseCardRecallDate(){
        return leaseCardRecallDate;
    }

    public void setEarlyTerminationDate(Date earlyTerminationDate){
        this.earlyTerminationDate = earlyTerminationDate;
    }

    public Date getEarlyTerminationDate(){
        return earlyTerminationDate;
    }

    public void setTerminationDate(Date terminationDate){
        this.terminationDate = terminationDate;
    }

    public Date getTerminationDate(){
        return terminationDate;
    }

    public void setAssignmentDate(Date assignmentDate){
        this.assignmentDate = assignmentDate;
    }

    public Date getAssignmentDate(){
        return assignmentDate;
    }

    public void setLeaseTimes(Long leaseTimes){
        this.leaseTimes = leaseTimes;
    }

    public Long getLeaseTimes(){
        return leaseTimes;
    }

    public void setAnnualPayTimes(Long annualPayTimes){
        this.annualPayTimes = annualPayTimes;
    }

    public Long getAnnualPayTimes(){
        return annualPayTimes;
    }

    public void setLeaseTerm(Double leaseTerm){
        this.leaseTerm = leaseTerm;
    }

    public Double getLeaseTerm(){
        return leaseTerm;
    }

    public void setPayType(Long payType){
        this.payType = payType;
    }

    public Long getPayType(){
        return payType;
    }

    public void setCurrency(String currency){
        this.currency = currency;
    }

    public String getCurrency(){
        return currency;
    }

    public void setTaxTypeId(Long taxTypeId){
        this.taxTypeId = taxTypeId;
    }

    public Long getTaxTypeId(){
        return taxTypeId;
    }

    public void setVatFlag(String vatFlag){
        this.vatFlag = vatFlag;
    }

    public String getVatFlag(){
        return vatFlag;
    }

    public void setVatRate(Double vatRate){
        this.vatRate = vatRate;
    }

    public Double getVatRate(){
        return vatRate;
    }

    public void setLeaseItemAmount(Double leaseItemAmount){
        this.leaseItemAmount = leaseItemAmount;
    }

    public Double getLeaseItemAmount(){
        return leaseItemAmount;
    }

    public void setVatInput(Double vatInput){
        this.vatInput = vatInput;
    }

    public Double getVatInput(){
        return vatInput;
    }

    public void setVatInputTaxTypeId(Long vatInputTaxTypeId){
        this.vatInputTaxTypeId = vatInputTaxTypeId;
    }

    public Long getVatInputTaxTypeId(){
        return vatInputTaxTypeId;
    }

    public void setVatInputTaxTypeRate(Double vatInputTaxTypeRate){
        this.vatInputTaxTypeRate = vatInputTaxTypeRate;
    }

    public Double getVatInputTaxTypeRate(){
        return vatInputTaxTypeRate;
    }

    public void setDownPaymentRatio(Double downPaymentRatio){
        this.downPaymentRatio = downPaymentRatio;
    }

    public Double getDownPaymentRatio(){
        return downPaymentRatio;
    }

    public void setDownPayment(Double downPayment){
        this.downPayment = downPayment;
    }

    public Double getDownPayment(){
        return downPayment;
    }

    public void setNetDownPayment(Double netDownPayment){
        this.netDownPayment = netDownPayment;
    }

    public Double getNetDownPayment(){
        return netDownPayment;
    }

    public void setVatDownPayment(Double vatDownPayment){
        this.vatDownPayment = vatDownPayment;
    }

    public Double getVatDownPayment(){
        return vatDownPayment;
    }

    public void setFinanceAmount(Double financeAmount){
        this.financeAmount = financeAmount;
    }

    public Double getFinanceAmount(){
        return financeAmount;
    }

    public void setNetFinanceAmount(Double netFinanceAmount){
        this.netFinanceAmount = netFinanceAmount;
    }

    public Double getNetFinanceAmount(){
        return netFinanceAmount;
    }

    public void setVatFinanceAmount(Double vatFinanceAmount){
        this.vatFinanceAmount = vatFinanceAmount;
    }

    public Double getVatFinanceAmount(){
        return vatFinanceAmount;
    }

    public void setTotalRental(Double totalRental){
        this.totalRental = totalRental;
    }

    public Double getTotalRental(){
        return totalRental;
    }

    public void setNetTotalRental(Double netTotalRental){
        this.netTotalRental = netTotalRental;
    }

    public Double getNetTotalRental(){
        return netTotalRental;
    }

    public void setVatTotalRental(Double vatTotalRental){
        this.vatTotalRental = vatTotalRental;
    }

    public Double getVatTotalRental(){
        return vatTotalRental;
    }

    public void setTotalInterest(Double totalInterest){
        this.totalInterest = totalInterest;
    }

    public Double getTotalInterest(){
        return totalInterest;
    }

    public void setNetTotalInterest(Double netTotalInterest){
        this.netTotalInterest = netTotalInterest;
    }

    public Double getNetTotalInterest(){
        return netTotalInterest;
    }

    public void setVatTotalInterest(Double vatTotalInterest){
        this.vatTotalInterest = vatTotalInterest;
    }

    public Double getVatTotalInterest(){
        return vatTotalInterest;
    }

    public void setLeaseChargeRatio(Double leaseChargeRatio){
        this.leaseChargeRatio = leaseChargeRatio;
    }

    public Double getLeaseChargeRatio(){
        return leaseChargeRatio;
    }

    public void setLeaseCharge(Double leaseCharge){
        this.leaseCharge = leaseCharge;
    }

    public Double getLeaseCharge(){
        return leaseCharge;
    }

    public void setNetLeaseCharge(Double netLeaseCharge){
        this.netLeaseCharge = netLeaseCharge;
    }

    public Double getNetLeaseCharge(){
        return netLeaseCharge;
    }

    public void setVatLeaseCharge(Double vatLeaseCharge){
        this.vatLeaseCharge = vatLeaseCharge;
    }

    public Double getVatLeaseCharge(){
        return vatLeaseCharge;
    }

    public void setLeaseMgtFeeRatio(Double leaseMgtFeeRatio){
        this.leaseMgtFeeRatio = leaseMgtFeeRatio;
    }

    public Double getLeaseMgtFeeRatio(){
        return leaseMgtFeeRatio;
    }

    public void setLeaseMgtFee(Double leaseMgtFee){
        this.leaseMgtFee = leaseMgtFee;
    }

    public Double getLeaseMgtFee(){
        return leaseMgtFee;
    }

    public void setNetLeaseMgtFee(Double netLeaseMgtFee){
        this.netLeaseMgtFee = netLeaseMgtFee;
    }

    public Double getNetLeaseMgtFee(){
        return netLeaseMgtFee;
    }

    public void setVatLeaseMgtFee(Double vatLeaseMgtFee){
        this.vatLeaseMgtFee = vatLeaseMgtFee;
    }

    public Double getVatLeaseMgtFee(){
        return vatLeaseMgtFee;
    }

    public void setLeaseMgtFeeRule(String leaseMgtFeeRule){
        this.leaseMgtFeeRule = leaseMgtFeeRule;
    }

    public String getLeaseMgtFeeRule(){
        return leaseMgtFeeRule;
    }

    public void setDepositRatio(Double depositRatio){
        this.depositRatio = depositRatio;
    }

    public Double getDepositRatio(){
        return depositRatio;
    }

    public void setDeposit(Double deposit){
        this.deposit = deposit;
    }

    public Double getDeposit(){
        return deposit;
    }

    public void setDepositDeduction(String depositDeduction){
        this.depositDeduction = depositDeduction;
    }

    public String getDepositDeduction(){
        return depositDeduction;
    }

    public void setResidualRatio(Double residualRatio){
        this.residualRatio = residualRatio;
    }

    public Double getResidualRatio(){
        return residualRatio;
    }

    public void setResidualValue(Double residualValue){
        this.residualValue = residualValue;
    }

    public Double getResidualValue(){
        return residualValue;
    }

    public void setNetResidualValue(Double netResidualValue){
        this.netResidualValue = netResidualValue;
    }

    public Double getNetResidualValue(){
        return netResidualValue;
    }

    public void setVatResidualValue(Double vatResidualValue){
        this.vatResidualValue = vatResidualValue;
    }

    public Double getVatResidualValue(){
        return vatResidualValue;
    }

    public void setBalloonRatio(Double balloonRatio){
        this.balloonRatio = balloonRatio;
    }

    public Double getBalloonRatio(){
        return balloonRatio;
    }

    public void setBalloon(Double balloon){
        this.balloon = balloon;
    }

    public Double getBalloon(){
        return balloon;
    }

    public void setNetBalloon(Double netBalloon){
        this.netBalloon = netBalloon;
    }

    public Double getNetBalloon(){
        return netBalloon;
    }

    public void setVatBalloon(Double vatBalloon){
        this.vatBalloon = vatBalloon;
    }

    public Double getVatBalloon(){
        return vatBalloon;
    }

    public void setBaseRateType(String baseRateType){
        this.baseRateType = baseRateType;
    }

    public String getBaseRateType(){
        return baseRateType;
    }

    public void setBaseRate(Double baseRate){
        this.baseRate = baseRate;
    }

    public Double getBaseRate(){
        return baseRate;
    }

    public void setIntRate(Double intRate){
        this.intRate = intRate;
    }

    public Double getIntRate(){
        return intRate;
    }

    public void setIntRateImplicit(Double intRateImplicit){
        this.intRateImplicit = intRateImplicit;
    }

    public Double getIntRateImplicit(){
        return intRateImplicit;
    }

    public void setIntRateType(String intRateType){
        this.intRateType = intRateType;
    }

    public String getIntRateType(){
        return intRateType;
    }

    public void setIrr(Double irr){
        this.irr = irr;
    }

    public Double getIrr(){
        return irr;
    }

    public void setIrrAfterTax(Double irrAfterTax){
        this.irrAfterTax = irrAfterTax;
    }

    public Double getIrrAfterTax(){
        return irrAfterTax;
    }

    public void setPmt(Double pmt){
        this.pmt = pmt;
    }

    public Double getPmt(){
        return pmt;
    }

    public void setPmtFirst(Double pmtFirst){
        this.pmtFirst = pmtFirst;
    }

    public Double getPmtFirst(){
        return pmtFirst;
    }

    public void setAnnualMeanRate(Double annualMeanRate){
        this.annualMeanRate = annualMeanRate;
    }

    public Double getAnnualMeanRate(){
        return annualMeanRate;
    }

    public void setReceivedStatus(String receivedStatus){
        this.receivedStatus = receivedStatus;
    }

    public String getReceivedStatus(){
        return receivedStatus;
    }

    public void setOverdueStatus(String overdueStatus){
        this.overdueStatus = overdueStatus;
    }

    public String getOverdueStatus(){
        return overdueStatus;
    }

    public void setBillingMethod(String billingMethod){
        this.billingMethod = billingMethod;
    }

    public String getBillingMethod(){
        return billingMethod;
    }

    public void setBillingStatus(String billingStatus){
        this.billingStatus = billingStatus;
    }

    public String getBillingStatus(){
        return billingStatus;
    }

    public void setBizDayConvention(String bizDayConvention){
        this.bizDayConvention = bizDayConvention;
    }

    public String getBizDayConvention(){
        return bizDayConvention;
    }

    public void setPenaltyProfile(String penaltyProfile){
        this.penaltyProfile = penaltyProfile;
    }

    public String getPenaltyProfile(){
        return penaltyProfile;
    }

}
