package hls.core.cont.dto;

import java.util.Date;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;

@SuppressWarnings("serial")
@Table(name = "con_contract_cashflow_h")
@ExtensionAttribute(disable = true)
public class ConContractCashflowH extends BaseDTO {

	@Id
	@GeneratedValue
	private Long cashflowId;
	private Long contractId;
	private Long cfItem;
	private Long cfType;
	private String cfDirection;
	private String cfStatus;
	private Long times;
	private Date dueDate;
	private Date finIncomeDate;
	private Double dueAmount;
	private Double netDueAmount;
	private Double vatDueAmount;
	private Double principal;
	private Double netPrincipal;
	private Double vatPrincipal;
	private Double interest;
	private Double netInterest;
	private Double vatInterest;
	private String writeOffFlag;
	private Double receivedAmount;
	private Double receivedPrincipal;
	private Double receivedInterest;
	private Date lastReceivedDate;
	private Date fullWriteOffDate;
	private String penaltyProcessStatus;
	private String billingStatus;
	private Double billingAmount;
	private Double billingPrincipal;
	private Double billingInterest;
	private Long paymentBpId;
	private String overdueStatus;

	@Transient
	private Long changeReqId;
	@Transient
	private String cfItemDesc;
	@Transient
	private Double surplusReceivedPrincipal;
    @Transient
	private Double newDueAmount;//调息-现金流对比 保存新现金流数据 应收租金
	@Transient
	private Double newInterest;//调息-现金流对比 保存新现金流数据  应收利息
	@Transient
	private Double interestAdj;//利息差额

	public String getOverdueStatus() {
		return overdueStatus;
	}

	public void setOverdueStatus(String overdueStatus) {
		this.overdueStatus = overdueStatus;
	}

	public Double getInterestAdj() {
		return interestAdj;
	}

	public void setInterestAdj(Double interestAdj) {
		this.interestAdj = interestAdj;
	}

	public Double getNewDueAmount() {
		return newDueAmount;
	}

	public void setNewDueAmount(Double newDueAmount) {
		this.newDueAmount = newDueAmount;
	}

	public Double getNewInterest() {
		return newInterest;
	}

	public void setNewInterest(Double newInterest) {
		this.newInterest = newInterest;
	}

	public String getCfItemDesc() {
		return cfItemDesc;
	}

	public void setCfItemDesc(String cfItemDesc) {
		this.cfItemDesc = cfItemDesc;
	}

	public Double getSurplusReceivedPrincipal() {
		return surplusReceivedPrincipal;
	}

	public void setSurplusReceivedPrincipal(Double surplusReceivedPrincipal) {
		this.surplusReceivedPrincipal = surplusReceivedPrincipal;
	}
	public Long getCashflowId() {
		return cashflowId;
	}
	public void setCashflowId(Long cashflowId) {
		this.cashflowId = cashflowId;
	}
	public Long getChangeReqId() {
		return changeReqId;
	}
	public void setChangeReqId(Long changeReqId) {
		this.changeReqId = changeReqId;
	}
	public Long getContractId() {
		return contractId;
	}
	public void setContractId(Long contractId) {
		this.contractId = contractId;
	}
	public Long getCfItem() {
		return cfItem;
	}
	public void setCfItem(Long cfItem) {
		this.cfItem = cfItem;
	}
	public Long getCfType() {
		return cfType;
	}
	public void setCfType(Long cfType) {
		this.cfType = cfType;
	}
	public String getCfDirection() {
		return cfDirection;
	}
	public void setCfDirection(String cfDirection) {
		this.cfDirection = cfDirection;
	}
	public String getCfStatus() {
		return cfStatus;
	}
	public void setCfStatus(String cfStatus) {
		this.cfStatus = cfStatus;
	}
	public Long getTimes() {
		return times;
	}
	public void setTimes(Long times) {
		this.times = times;
	}
	public Date getDueDate() {
		return dueDate;
	}
	public void setDueDate(Date dueDate) {
		this.dueDate = dueDate;
	}
	public Date getFinIncomeDate() {
		return finIncomeDate;
	}
	public void setFinIncomeDate(Date finIncomeDate) {
		this.finIncomeDate = finIncomeDate;
	}
	public Double getDueAmount() {
		return dueAmount;
	}
	public void setDueAmount(Double dueAmount) {
		this.dueAmount = dueAmount;
	}
	public Double getNetDueAmount() {
		return netDueAmount;
	}
	public void setNetDueAmount(Double netDueAmount) {
		this.netDueAmount = netDueAmount;
	}
	public Double getVatDueAmount() {
		return vatDueAmount;
	}
	public void setVatDueAmount(Double vatDueAmount) {
		this.vatDueAmount = vatDueAmount;
	}
	public Double getPrincipal() {
		return principal;
	}
	public void setPrincipal(Double principal) {
		this.principal = principal;
	}
	public Double getNetPrincipal() {
		return netPrincipal;
	}
	public void setNetPrincipal(Double netPrincipal) {
		this.netPrincipal = netPrincipal;
	}
	public Double getVatPrincipal() {
		return vatPrincipal;
	}
	public void setVatPrincipal(Double vatPrincipal) {
		this.vatPrincipal = vatPrincipal;
	}
	public Double getInterest() {
		return interest;
	}
	public void setInterest(Double interest) {
		this.interest = interest;
	}
	public Double getNetInterest() {
		return netInterest;
	}
	public void setNetInterest(Double netInterest) {
		this.netInterest = netInterest;
	}
	public Double getVatInterest() {
		return vatInterest;
	}
	public void setVatInterest(Double vatInterest) {
		this.vatInterest = vatInterest;
	}
	public String getWriteOffFlag() {
		return writeOffFlag;
	}
	public void setWriteOffFlag(String writeOffFlag) {
		this.writeOffFlag = writeOffFlag;
	}
	public Double getReceivedAmount() {
		return receivedAmount;
	}
	public void setReceivedAmount(Double receivedAmount) {
		this.receivedAmount = receivedAmount;
	}
	public Double getReceivedPrincipal() {
		return receivedPrincipal;
	}
	public void setReceivedPrincipal(Double receivedPrincipal) {
		this.receivedPrincipal = receivedPrincipal;
	}
	public Double getReceivedInterest() {
		return receivedInterest;
	}
	public void setReceivedInterest(Double receivedInterest) {
		this.receivedInterest = receivedInterest;
	}
	public Date getLastReceivedDate() {
		return lastReceivedDate;
	}
	public void setLastReceivedDate(Date lastReceivedDate) {
		this.lastReceivedDate = lastReceivedDate;
	}
	public Date getFullWriteOffDate() {
		return fullWriteOffDate;
	}
	public void setFullWriteOffDate(Date fullWriteOffDate) {
		this.fullWriteOffDate = fullWriteOffDate;
	}
	public String getPenaltyProcessStatus() {
		return penaltyProcessStatus;
	}
	public void setPenaltyProcessStatus(String penaltyProcessStatus) {
		this.penaltyProcessStatus = penaltyProcessStatus;
	}
	public String getBillingStatus() {
		return billingStatus;
	}
	public void setBillingStatus(String billingStatus) {
		this.billingStatus = billingStatus;
	}
	public Double getBillingAmount() {
		return billingAmount;
	}
	public void setBillingAmount(Double billingAmount) {
		this.billingAmount = billingAmount;
	}
	public Double getBillingPrincipal() {
		return billingPrincipal;
	}
	public void setBillingPrincipal(Double billingPrincipal) {
		this.billingPrincipal = billingPrincipal;
	}
	public Double getBillingInterest() {
		return billingInterest;
	}
	public void setBillingInterest(Double billingInterest) {
		this.billingInterest = billingInterest;
	}
	public Long getPaymentBpId() {
		return paymentBpId;
	}
	public void setPaymentBpId(Long paymentBpId) {
		this.paymentBpId = paymentBpId;
	}
	@Override
	public String toString() {
		return "ConContractCashflowH [cashflowId=" + cashflowId + ", changeReqId=" + changeReqId + ", contractId="
				+ contractId + ", cfItem=" + cfItem + ", cfType=" + cfType + ", cfDirection=" + cfDirection
				+ ", cfStatus=" + cfStatus + ", times=" + times + ", dueDate=" + dueDate + ", finIncomeDate="
				+ finIncomeDate + ", dueAmount=" + dueAmount + ", netDueAmount=" + netDueAmount + ", vatDueAmount="
				+ vatDueAmount + ", principal=" + principal + ", netPrincipal=" + netPrincipal + ", vatPrincipal="
				+ vatPrincipal + ", interest=" + interest + ", netInterest=" + netInterest + ", vatInterest="
				+ vatInterest + ", writeOffFlag=" + writeOffFlag + ", receivedAmount=" + receivedAmount
				+ ", receivedPrincipal=" + receivedPrincipal + ", receivedInterest=" + receivedInterest
				+ ", lastReceivedDate=" + lastReceivedDate + ", fullWriteOffDate=" + fullWriteOffDate
				+ ", penaltyProcessStatus=" + penaltyProcessStatus + ", billingStatus=" + billingStatus
				+ ", billingAmount=" + billingAmount + ", billingPrincipal=" + billingPrincipal + ", billingInterest="
				+ billingInterest + ", paymentBpId=" + paymentBpId + "]";
	}
}
