package hls.core.cont.dto;

import java.util.Date;
import java.util.List;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;

@ExtensionAttribute(disable = true)
@Table(name = "con_contract_change_req")
public class ConContractChangeReq extends BaseDTO{
    /**
     *
     */
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue
    private Long changeReqId;
    private Long contractId;
    private String status;
    private String description;
    private Date changeReqDate;
    private String documentType;
    private String documentCategory;
    private String businessType;
    private String changeReqNumber;
    private String earlyTerminationFlag; 	//变更-提前结清
    private String changeCashflowFlag;		//变更-还款计划
    private String changeTenantFlag;			//变更-承租人
    private String changeGuarantorFlag;		//变更-担保人
    private String changeLeaseItemFlag;		//变更-租赁物
    private String changeContractTextFlag;	//变更-合同文件
    private Long processInstanceId;
    private Long changeReqUserId;
    private Long documentVersionId;
    @Transient
    private String changeReqUserName;

    public Long getDocumentVersionId() {
        return documentVersionId;
    }

    public void setDocumentVersionId(Long documentVersionId) {
        this.documentVersionId = documentVersionId;
    }

    public String getChangeReqUserName() {
        return changeReqUserName;
    }

    public void setChangeReqUserName(String changeReqUserName) {
        this.changeReqUserName = changeReqUserName;
    }

    public Long getChangeReqUserId() {
        return changeReqUserId;
    }

    public void setChangeReqUserId(Long changeReqUserId) {
        this.changeReqUserId = changeReqUserId;
    }

    public Long getProcessInstanceId() {
        return processInstanceId;
    }

    public void setProcessInstanceId(Long processInstanceId) {
        this.processInstanceId = processInstanceId;
    }

    @Override
    public Date getCreationDate() {
        return creationDate;
    }

    @Override
    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    private Date creationDate;

    @Transient
    private String contractNumber;
    @Transient
    private String contractName;

    @Transient
    private String contractReqType;

    @Transient
    private String bpName;
    @Transient
    private Long bpId;

    @Transient
    private String cashflow;

    @Transient
    private String guarantor;

    @Transient
    private String item;

    @Transient
    private String mortgage;
    @Transient
    private String tenant;
    @Transient
    private Long companyId;

    @Transient
    private Long queryTimeSolt;
    @Transient
    private Date pastTime;
    @Transient
    private List<String> list;

    public Long getCompanyId() {
        return companyId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    @Transient
    private String userName;


    public Long getNewChangeReqId() {
        return newChangeReqId;
    }

    public void setNewChangeReqId(Long newChangeReqId) {
        this.newChangeReqId = newChangeReqId;
    }

    @Transient
    private Long newChangeReqId;

    @Transient
    private  Double financeAmount;
    @Transient
    private String businessTypeDesc;
    @Transient
    private String contractStatus;
    @Transient
    private  String contractStatusDesc;
    @Transient
    private  String changeType;
    @Transient
    private String statusDesc;
    @Transient
    private String bpCode;
    @Transient
    private String amount_1;
    @Transient
    private String amount_2;
    @Transient
    private String amount_3;
    @Transient
    private Double amount_from;
    @Transient
    private Double amount_to;


    public String getAmount_1() {
        return amount_1;
    }

    public void setAmount_1(String amount_1) {
        this.amount_1 = amount_1;
    }

    public String getAmount_2() {
        return amount_2;
    }

    public void setAmount_2(String amount_2) {
        this.amount_2 = amount_2;
    }

    public String getAmount_3() {
        return amount_3;
    }

    public void setAmount_3(String amount_3) {
        this.amount_3 = amount_3;
    }

    public Double getAmount_from() {
        return amount_from;
    }

    public void setAmount_from(Double amount_from) {
        this.amount_from = amount_from;
    }

    public Double getAmount_to() {
        return amount_to;
    }

    public void setAmount_to(Double amount_to) {
        this.amount_to = amount_to;
    }

    public String getBpCode() {
        return bpCode;
    }

    public void setBpCode(String bpCode) {
        this.bpCode = bpCode;
    }

    public String getStatusDesc() {
        return statusDesc;
    }

    public void setStatusDesc(String statusDesc) {
        this.statusDesc = statusDesc;
    }

    public String getChangeType() {
        return changeType;
    }

    public void setChangeType(String changeType) {
        this.changeType = changeType;
    }

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public Double getFinanceAmount() {
        return financeAmount;
    }

    public void setFinanceAmount(Double financeAmount) {
        this.financeAmount = financeAmount;
    }

    public String getBusinessTypeDesc() {
        return businessTypeDesc;
    }

    public void setBusinessTypeDesc(String businessTypeDesc) {
        this.businessTypeDesc = businessTypeDesc;
    }

    public String getContractStatus() {
        return contractStatus;
    }

    public void setContractStatus(String contractStatus) {
        this.contractStatus = contractStatus;
    }

    public String getContractStatusDesc() {
        return contractStatusDesc;
    }

    public void setContractStatusDesc(String contractStatusDesc) {
        this.contractStatusDesc = contractStatusDesc;
    }

    public List<String> getList() {
        return list;
    }

    public void setList(List<String> list) {
        this.list = list;
    }

    public Date getPastTime() {
        return pastTime;
    }

    public void setPastTime(Date pastTime) {
        this.pastTime = pastTime;
    }

    public static long getSerialversionuid() {
        return serialVersionUID;
    }

    public Long getChangeReqId() {
        return changeReqId;
    }

    public Long getContractId() {
        return contractId;
    }

    public String getStatus() {
        return status;
    }

    public String getDescription() {
        return description;
    }

    public Date getChangeReqDate() {
        return changeReqDate;
    }

    public String getDocumentType() {
        return documentType;
    }

    public String getDocumentCategory() {
        return documentCategory;
    }

    public String getBusinessType() {
        return businessType;
    }

    public String getChangeReqNumber() {
        return changeReqNumber;
    }

    public String getEarlyTerminationFlag() {
        return earlyTerminationFlag;
    }

    public String getChangeCashflowFlag() {
        return changeCashflowFlag;
    }

    public String getChangeTenantFlag() {
        return changeTenantFlag;
    }

    public String getChangeGuarantorFlag() {
        return changeGuarantorFlag;
    }

    public String getChangeLeaseItemFlag() {
        return changeLeaseItemFlag;
    }

    public String getChangeContractTextFlag() {
        return changeContractTextFlag;
    }

    public String getContractNumber() {
        return contractNumber;
    }

    public String getContractName() {
        return contractName;
    }

    public String getContractReqType() {
        return contractReqType;
    }

    public String getBpName() {
        return bpName;
    }

    public void setChangeReqId(Long changeReqId) {
        this.changeReqId = changeReqId;
    }

    public void setContractId(Long contractId) {
        this.contractId = contractId;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public void setChangeReqDate(Date changeReqDate) {
        this.changeReqDate = changeReqDate;
    }

    public void setDocumentType(String documentType) {
        this.documentType = documentType;
    }

    public void setDocumentCategory(String documentCategory) {
        this.documentCategory = documentCategory;
    }

    public void setBusinessType(String businessType) {
        this.businessType = businessType;
    }

    public void setChangeReqNumber(String changeReqNumber) {
        this.changeReqNumber = changeReqNumber;
    }

    public void setEarlyTerminationFlag(String earlyTerminationFlag) {
        this.earlyTerminationFlag = earlyTerminationFlag;
    }

    public void setChangeCashflowFlag(String changeCashflowFlag) {
        this.changeCashflowFlag = changeCashflowFlag;
    }

    public String getCashflow() {
        return cashflow;
    }

    public String getGuarantor() {
        return guarantor;
    }

    public String getItem() {
        return item;
    }

    public String getMortgage() {
        return mortgage;
    }

    public String getTenant() {
        return tenant;
    }

    public void setCashflow(String cashflow) {
        this.cashflow = cashflow;
    }

    public void setGuarantor(String guarantor) {
        this.guarantor = guarantor;
    }

    public void setItem(String item) {
        this.item = item;
    }

    public void setMortgage(String mortgage) {
        this.mortgage = mortgage;
    }

    public void setTenant(String tenant) {
        this.tenant = tenant;
    }

    public void setChangeTenantFlag(String changeTenantFlag) {
        this.changeTenantFlag = changeTenantFlag;
    }

    public void setChangeGuarantorFlag(String changeGuarantorFlag) {
        this.changeGuarantorFlag = changeGuarantorFlag;
    }

    public void setChangeLeaseItemFlag(String changeLeaseItemFlag) {
        this.changeLeaseItemFlag = changeLeaseItemFlag;
    }

    public void setChangeContractTextFlag(String changeContractTextFlag) {
        this.changeContractTextFlag = changeContractTextFlag;
    }

    public void setContractNumber(String contractNumber) {
        this.contractNumber = contractNumber;
    }

    public void setContractName(String contractName) {
        this.contractName = contractName;
    }

    public void setContractReqType(String contractReqType) {
        this.contractReqType = contractReqType;
    }

    public void setBpName(String bpName) {
        this.bpName = bpName;
    }

    public Long getQueryTimeSolt() {
        return queryTimeSolt;
    }

    public void setQueryTimeSolt(Long queryTimeSolt) {
        this.queryTimeSolt = queryTimeSolt;
    }


    public Long getBpId() {
        return bpId;
    }

    public void setBpId(Long bpId) {
        this.bpId = bpId;
    }
}
