package hls.core.cont.dto;

import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-09-25
 * Time: 10:23
 */
@ExtensionAttribute(disable = true)
@Table(name = "con_contract_h")
public class ConContractH extends BaseDTO {
    @Id
    @GeneratedValue
    private Long contractId;

    private Long companyId;

    private Long projectId;

    private Long quotationId;

    private String documentType;

    private String documentCategory;

    private String businessType;

    private String contractNumber;

    private String contractName;

    private String businessContractNumber;

    private String contractStatus;

    private String leaseChannel;

    private String division;

    private Date signDate;

    private Date inceptionOfLease;

    private Long employeeId;

    private Long unitId;

    private Date leaseStartDate;

    private Date firstPayDate;

    private Date lastPayDate;

    private Date leaseEndDate;

    private Date originalRecallDate;

    private Date leaseCardRecallDate;

    private Date earlyTerminationDate;

    private Date terminationDate;

    private Date assignmentDate;

    private Long leaseTimes;

    private Long annualPayTimes;

    private Double leaseTerm;

    private Long payType;

    private String currency;

    private Long taxTypeId;

    private String vatFlag;

    private Double vatRate;

    private Double leaseItemAmount;

    private Double vatInput;

    private Double vatInputTaxTypeId;

    private Double vatInputTaxTypeRate;

    private Double downPaymentRatio;

    private Double downPayment;

    private Double netDownPayment;

    private Double vatDownPayment;

    private Double financeAmount;

    private Double netFinanceAmount;

    private Double vatFinanceAmount;

    private Double totalRental;

    private Double netTotalRental;

    private Double vatTotalRental;

    private Double totalInterest;

    private Double netTotalInterest;

    private Double vatTotalInterest;

    private Double leaseChargeRatio;

    private Double leaseCharge;

    private Double netLeaseCharge;

    private Double vatLeaseCharge;

    private Double leaseMgtFeeRatio;

    private Double leaseMgtFee;

    private Double netLeaseMgtFee;

    private Double vatLeaseMgtFee;

    private String leaseMgtFeeRule;

    private Double depositRatio;

    private Double deposit;

    private String depositDeduction;

    private Double residualRatio;

    private Double residualValue;

    private Double netResidualValue;

    private Double vatResidualValue;

    private Double balloonRatio;

    private Double balloon;

    private Double netBalloon;

    private Double vatBalloon;

    private String baseRateType;

    private Double baseRate;

    private Double intRate;

    private Double intRateImplicit;

    private String intRateType;

    private Double irr;

    private Double irrAfterTax;

    private Double pmt;

    private Double pmtFirst;

    private Double annualMeanRate;

    private String receivedStatus;

    private String overdueStatus;

    private String billingMethod;

    private String billingStatus;

    private String bizDayConvention;

    private String penaltyProfile;

    private Long objectVersionNumber;

    private Long requestId;

    private Long programId;

    private Long createdBy;

    private Date creationDate;

    private Long lastUpdatedBy;

    private Date lastUpdateDate;

    private Long lastUpdateLogin;

    private Long bpAccountId;

    private String floatingRangeMethod;

    @Transient
    private Double newBaseRate;

    @Transient
    private Long changeReqId;

    @Transient
    private String versionType;

    @Transient
    private String priceList;
    @Transient
    private String intRateFixingWay;
    @Transient
    private Double intRateFixingRange;

    public String getVersionType() {
        return versionType;
    }

    public void setVersionType(String versionType) {
        this.versionType = versionType;
    }

    public Long getBpAccountId() {
        return bpAccountId;
    }

    public void setBpAccountId(Long bpAccountId) {
        this.bpAccountId = bpAccountId;
    }

    public Long getChangeReqId() {
        return changeReqId;
    }

    public void setChangeReqId(Long changeReqId) {
        this.changeReqId = changeReqId;
    }

    public String getFloatingRangeMethod() {
        return floatingRangeMethod;
    }

    public void setFloatingRangeMethod(String floatingRangeMethod) {
        this.floatingRangeMethod = floatingRangeMethod;
    }

    public Double getNewBaseRate() {
        return newBaseRate;
    }

    public void setNewBaseRate(Double newBaseRate) {
        this.newBaseRate = newBaseRate;
    }

    public String getPriceList() {
        return priceList;
    }

    public void setPriceList(String priceList) {
        this.priceList = priceList;
    }

    public String getIntRateFixingWay() {
        return intRateFixingWay;
    }

    public void setIntRateFixingWay(String intRateFixingWay) {
        this.intRateFixingWay = intRateFixingWay;
    }

    public Double getIntRateFixingRange() {
        return intRateFixingRange;
    }

    public void setIntRateFixingRange(Double intRateFixingRange) {
        this.intRateFixingRange = intRateFixingRange;
    }

    public Long getContractId() {
        return contractId;
    }

    public void setContractId(Long contractId) {
        this.contractId = contractId;
    }

    public Long getCompanyId() {
        return companyId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public Long getProjectId() {
        return projectId;
    }

    public void setProjectId(Long projectId) {
        this.projectId = projectId;
    }

    public Long getQuotationId() {
        return quotationId;
    }

    public void setQuotationId(Long quotationId) {
        this.quotationId = quotationId;
    }

    public String getDocumentType() {
        return documentType;
    }

    public void setDocumentType(String documentType) {
        this.documentType = documentType == null ? null : documentType.trim();
    }

    public String getDocumentCategory() {
        return documentCategory;
    }

    public void setDocumentCategory(String documentCategory) {
        this.documentCategory = documentCategory == null ? null : documentCategory.trim();
    }

    public String getBusinessType() {
        return businessType;
    }

    public void setBusinessType(String businessType) {
        this.businessType = businessType == null ? null : businessType.trim();
    }

    public String getContractNumber() {
        return contractNumber;
    }

    public void setContractNumber(String contractNumber) {
        this.contractNumber = contractNumber == null ? null : contractNumber.trim();
    }

    public String getContractName() {
        return contractName;
    }

    public void setContractName(String contractName) {
        this.contractName = contractName == null ? null : contractName.trim();
    }

    public String getBusinessContractNumber() {
        return businessContractNumber;
    }

    public void setBusinessContractNumber(String businessContractNumber) {
        this.businessContractNumber = businessContractNumber == null ? null : businessContractNumber.trim();
    }

    public String getContractStatus() {
        return contractStatus;
    }

    public void setContractStatus(String contractStatus) {
        this.contractStatus = contractStatus == null ? null : contractStatus.trim();
    }

    public String getLeaseChannel() {
        return leaseChannel;
    }

    public void setLeaseChannel(String leaseChannel) {
        this.leaseChannel = leaseChannel == null ? null : leaseChannel.trim();
    }

    public String getDivision() {
        return division;
    }

    public void setDivision(String division) {
        this.division = division == null ? null : division.trim();
    }

    public Date getSignDate() {
        return signDate;
    }

    public void setSignDate(Date signDate) {
        this.signDate = signDate;
    }

    public Date getInceptionOfLease() {
        return inceptionOfLease;
    }

    public void setInceptionOfLease(Date inceptionOfLease) {
        this.inceptionOfLease = inceptionOfLease;
    }

    public Long getEmployeeId() {
        return employeeId;
    }

    public void setEmployeeId(Long employeeId) {
        this.employeeId = employeeId;
    }

    public Long getUnitId() {
        return unitId;
    }

    public void setUnitId(Long unitId) {
        this.unitId = unitId;
    }

    public Date getLeaseStartDate() {
        return leaseStartDate;
    }

    public void setLeaseStartDate(Date leaseStartDate) {
        this.leaseStartDate = leaseStartDate;
    }

    public Date getFirstPayDate() {
        return firstPayDate;
    }

    public void setFirstPayDate(Date firstPayDate) {
        this.firstPayDate = firstPayDate;
    }

    public Date getLastPayDate() {
        return lastPayDate;
    }

    public void setLastPayDate(Date lastPayDate) {
        this.lastPayDate = lastPayDate;
    }

    public Date getLeaseEndDate() {
        return leaseEndDate;
    }

    public void setLeaseEndDate(Date leaseEndDate) {
        this.leaseEndDate = leaseEndDate;
    }

    public Date getOriginalRecallDate() {
        return originalRecallDate;
    }

    public void setOriginalRecallDate(Date originalRecallDate) {
        this.originalRecallDate = originalRecallDate;
    }

    public Date getLeaseCardRecallDate() {
        return leaseCardRecallDate;
    }

    public void setLeaseCardRecallDate(Date leaseCardRecallDate) {
        this.leaseCardRecallDate = leaseCardRecallDate;
    }

    public Date getEarlyTerminationDate() {
        return earlyTerminationDate;
    }

    public void setEarlyTerminationDate(Date earlyTerminationDate) {
        this.earlyTerminationDate = earlyTerminationDate;
    }

    public Date getTerminationDate() {
        return terminationDate;
    }

    public void setTerminationDate(Date terminationDate) {
        this.terminationDate = terminationDate;
    }

    public Date getAssignmentDate() {
        return assignmentDate;
    }

    public void setAssignmentDate(Date assignmentDate) {
        this.assignmentDate = assignmentDate;
    }

    public Long getLeaseTimes() {
        return leaseTimes;
    }

    public void setLeaseTimes(Long leaseTimes) {
        this.leaseTimes = leaseTimes;
    }

    public Long getAnnualPayTimes() {
        return annualPayTimes;
    }

    public void setAnnualPayTimes(Long annualPayTimes) {
        this.annualPayTimes = annualPayTimes;
    }

    public Double getLeaseTerm() {
        return leaseTerm;
    }

    public void setLeaseTerm(Double leaseTerm) {
        this.leaseTerm = leaseTerm;
    }

    public Long getPayType() {
        return payType;
    }

    public void setPayType(Long payType) {
        this.payType = payType;
    }

    public String getCurrency() {
        return currency;
    }

    public void setCurrency(String currency) {
        this.currency = currency == null ? null : currency.trim();
    }

    public Long getTaxTypeId() {
        return taxTypeId;
    }

    public void setTaxTypeId(Long taxTypeId) {
        this.taxTypeId = taxTypeId;
    }

    public String getVatFlag() {
        return vatFlag;
    }

    public void setVatFlag(String vatFlag) {
        this.vatFlag = vatFlag == null ? null : vatFlag.trim();
    }

    public Double getVatRate() {
        return vatRate;
    }

    public void setVatRate(Double vatRate) {
        this.vatRate = vatRate;
    }

    public Double getLeaseItemAmount() {
        return leaseItemAmount;
    }

    public void setLeaseItemAmount(Double leaseItemAmount) {
        this.leaseItemAmount = leaseItemAmount;
    }

    public Double getVatInput() {
        return vatInput;
    }

    public void setVatInput(Double vatInput) {
        this.vatInput = vatInput;
    }

    public Double getVatInputTaxTypeId() {
        return vatInputTaxTypeId;
    }

    public void setVatInputTaxTypeId(Double vatInputTaxTypeId) {
        this.vatInputTaxTypeId = vatInputTaxTypeId;
    }

    public Double getVatInputTaxTypeRate() {
        return vatInputTaxTypeRate;
    }

    public void setVatInputTaxTypeRate(Double vatInputTaxTypeRate) {
        this.vatInputTaxTypeRate = vatInputTaxTypeRate;
    }

    public Double getDownPaymentRatio() {
        return downPaymentRatio;
    }

    public void setDownPaymentRatio(Double downPaymentRatio) {
        this.downPaymentRatio = downPaymentRatio;
    }

    public Double getDownPayment() {
        return downPayment;
    }

    public void setDownPayment(Double downPayment) {
        this.downPayment = downPayment;
    }

    public Double getNetDownPayment() {
        return netDownPayment;
    }

    public void setNetDownPayment(Double netDownPayment) {
        this.netDownPayment = netDownPayment;
    }

    public Double getVatDownPayment() {
        return vatDownPayment;
    }

    public void setVatDownPayment(Double vatDownPayment) {
        this.vatDownPayment = vatDownPayment;
    }

    public Double getFinanceAmount() {
        return financeAmount;
    }

    public void setFinanceAmount(Double financeAmount) {
        this.financeAmount = financeAmount;
    }

    public Double getNetFinanceAmount() {
        return netFinanceAmount;
    }

    public void setNetFinanceAmount(Double netFinanceAmount) {
        this.netFinanceAmount = netFinanceAmount;
    }

    public Double getVatFinanceAmount() {
        return vatFinanceAmount;
    }

    public void setVatFinanceAmount(Double vatFinanceAmount) {
        this.vatFinanceAmount = vatFinanceAmount;
    }

    public Double getTotalRental() {
        return totalRental;
    }

    public void setTotalRental(Double totalRental) {
        this.totalRental = totalRental;
    }

    public Double getNetTotalRental() {
        return netTotalRental;
    }

    public void setNetTotalRental(Double netTotalRental) {
        this.netTotalRental = netTotalRental;
    }

    public Double getVatTotalRental() {
        return vatTotalRental;
    }

    public void setVatTotalRental(Double vatTotalRental) {
        this.vatTotalRental = vatTotalRental;
    }

    public Double getTotalInterest() {
        return totalInterest;
    }

    public void setTotalInterest(Double totalInterest) {
        this.totalInterest = totalInterest;
    }

    public Double getNetTotalInterest() {
        return netTotalInterest;
    }

    public void setNetTotalInterest(Double netTotalInterest) {
        this.netTotalInterest = netTotalInterest;
    }

    public Double getVatTotalInterest() {
        return vatTotalInterest;
    }

    public void setVatTotalInterest(Double vatTotalInterest) {
        this.vatTotalInterest = vatTotalInterest;
    }

    public Double getLeaseChargeRatio() {
        return leaseChargeRatio;
    }

    public void setLeaseChargeRatio(Double leaseChargeRatio) {
        this.leaseChargeRatio = leaseChargeRatio;
    }

    public Double getLeaseCharge() {
        return leaseCharge;
    }

    public void setLeaseCharge(Double leaseCharge) {
        this.leaseCharge = leaseCharge;
    }

    public Double getNetLeaseCharge() {
        return netLeaseCharge;
    }

    public void setNetLeaseCharge(Double netLeaseCharge) {
        this.netLeaseCharge = netLeaseCharge;
    }

    public Double getVatLeaseCharge() {
        return vatLeaseCharge;
    }

    public void setVatLeaseCharge(Double vatLeaseCharge) {
        this.vatLeaseCharge = vatLeaseCharge;
    }

    public Double getLeaseMgtFeeRatio() {
        return leaseMgtFeeRatio;
    }

    public void setLeaseMgtFeeRatio(Double leaseMgtFeeRatio) {
        this.leaseMgtFeeRatio = leaseMgtFeeRatio;
    }

    public Double getLeaseMgtFee() {
        return leaseMgtFee;
    }

    public void setLeaseMgtFee(Double leaseMgtFee) {
        this.leaseMgtFee = leaseMgtFee;
    }

    public Double getNetLeaseMgtFee() {
        return netLeaseMgtFee;
    }

    public void setNetLeaseMgtFee(Double netLeaseMgtFee) {
        this.netLeaseMgtFee = netLeaseMgtFee;
    }

    public Double getVatLeaseMgtFee() {
        return vatLeaseMgtFee;
    }

    public void setVatLeaseMgtFee(Double vatLeaseMgtFee) {
        this.vatLeaseMgtFee = vatLeaseMgtFee;
    }

    public String getLeaseMgtFeeRule() {
        return leaseMgtFeeRule;
    }

    public void setLeaseMgtFeeRule(String leaseMgtFeeRule) {
        this.leaseMgtFeeRule = leaseMgtFeeRule == null ? null : leaseMgtFeeRule.trim();
    }

    public Double getDepositRatio() {
        return depositRatio;
    }

    public void setDepositRatio(Double depositRatio) {
        this.depositRatio = depositRatio;
    }

    public Double getDeposit() {
        return deposit;
    }

    public void setDeposit(Double deposit) {
        this.deposit = deposit;
    }

    public String getDepositDeduction() {
        return depositDeduction;
    }

    public void setDepositDeduction(String depositDeduction) {
        this.depositDeduction = depositDeduction == null ? null : depositDeduction.trim();
    }

    public Double getResidualRatio() {
        return residualRatio;
    }

    public void setResidualRatio(Double residualRatio) {
        this.residualRatio = residualRatio;
    }

    public Double getResidualValue() {
        return residualValue;
    }

    public void setResidualValue(Double residualValue) {
        this.residualValue = residualValue;
    }

    public Double getNetResidualValue() {
        return netResidualValue;
    }

    public void setNetResidualValue(Double netResidualValue) {
        this.netResidualValue = netResidualValue;
    }

    public Double getVatResidualValue() {
        return vatResidualValue;
    }

    public void setVatResidualValue(Double vatResidualValue) {
        this.vatResidualValue = vatResidualValue;
    }

    public Double getBalloonRatio() {
        return balloonRatio;
    }

    public void setBalloonRatio(Double balloonRatio) {
        this.balloonRatio = balloonRatio;
    }

    public Double getBalloon() {
        return balloon;
    }

    public void setBalloon(Double balloon) {
        this.balloon = balloon;
    }

    public Double getNetBalloon() {
        return netBalloon;
    }

    public void setNetBalloon(Double netBalloon) {
        this.netBalloon = netBalloon;
    }

    public Double getVatBalloon() {
        return vatBalloon;
    }

    public void setVatBalloon(Double vatBalloon) {
        this.vatBalloon = vatBalloon;
    }

    public String getBaseRateType() {
        return baseRateType;
    }

    public void setBaseRateType(String baseRateType) {
        this.baseRateType = baseRateType == null ? null : baseRateType.trim();
    }

    public Double getBaseRate() {
        return baseRate;
    }

    public void setBaseRate(Double baseRate) {
        this.baseRate = baseRate;
    }

    public Double getIntRate() {
        return intRate;
    }

    public void setIntRate(Double intRate) {
        this.intRate = intRate;
    }

    public Double getIntRateImplicit() {
        return intRateImplicit;
    }

    public void setIntRateImplicit(Double intRateImplicit) {
        this.intRateImplicit = intRateImplicit;
    }

    public String getIntRateType() {
        return intRateType;
    }

    public void setIntRateType(String intRateType) {
        this.intRateType = intRateType == null ? null : intRateType.trim();
    }

    public Double getIrr() {
        return irr;
    }

    public void setIrr(Double irr) {
        this.irr = irr;
    }

    public Double getIrrAfterTax() {
        return irrAfterTax;
    }

    public void setIrrAfterTax(Double irrAfterTax) {
        this.irrAfterTax = irrAfterTax;
    }

    public Double getPmt() {
        return pmt;
    }

    public void setPmt(Double pmt) {
        this.pmt = pmt;
    }

    public Double getPmtFirst() {
        return pmtFirst;
    }

    public void setPmtFirst(Double pmtFirst) {
        this.pmtFirst = pmtFirst;
    }

    public Double getAnnualMeanRate() {
        return annualMeanRate;
    }

    public void setAnnualMeanRate(Double annualMeanRate) {
        this.annualMeanRate = annualMeanRate;
    }

    public String getReceivedStatus() {
        return receivedStatus;
    }

    public void setReceivedStatus(String receivedStatus) {
        this.receivedStatus = receivedStatus == null ? null : receivedStatus.trim();
    }

    public String getOverdueStatus() {
        return overdueStatus;
    }

    public void setOverdueStatus(String overdueStatus) {
        this.overdueStatus = overdueStatus == null ? null : overdueStatus.trim();
    }

    public String getBillingMethod() {
        return billingMethod;
    }

    public void setBillingMethod(String billingMethod) {
        this.billingMethod = billingMethod == null ? null : billingMethod.trim();
    }

    public String getBillingStatus() {
        return billingStatus;
    }

    public void setBillingStatus(String billingStatus) {
        this.billingStatus = billingStatus == null ? null : billingStatus.trim();
    }

    public String getBizDayConvention() {
        return bizDayConvention;
    }

    public void setBizDayConvention(String bizDayConvention) {
        this.bizDayConvention = bizDayConvention == null ? null : bizDayConvention.trim();
    }

    public String getPenaltyProfile() {
        return penaltyProfile;
    }

    public void setPenaltyProfile(String penaltyProfile) {
        this.penaltyProfile = penaltyProfile == null ? null : penaltyProfile.trim();
    }

    public Long getObjectVersionNumber() {
        return objectVersionNumber;
    }

    public void setObjectVersionNumber(Long objectVersionNumber) {
        this.objectVersionNumber = objectVersionNumber;
    }

    public Long getRequestId() {
        return requestId;
    }

    public void setRequestId(Long requestId) {
        this.requestId = requestId;
    }

    public Long getProgramId() {
        return programId;
    }

    public void setProgramId(Long programId) {
        this.programId = programId;
    }

    public Long getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(Long createdBy) {
        this.createdBy = createdBy;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    public Long getLastUpdatedBy() {
        return lastUpdatedBy;
    }

    public void setLastUpdatedBy(Long lastUpdatedBy) {
        this.lastUpdatedBy = lastUpdatedBy;
    }

    public Date getLastUpdateDate() {
        return lastUpdateDate;
    }

    public void setLastUpdateDate(Date lastUpdateDate) {
        this.lastUpdateDate = lastUpdateDate;
    }

    public Long getLastUpdateLogin() {
        return lastUpdateLogin;
    }

    public void setLastUpdateLogin(Long lastUpdateLogin) {
        this.lastUpdateLogin = lastUpdateLogin;
    }

}
