package hls.core.cont.service;

import javax.servlet.http.HttpSession;

import com.hand.hap.core.IRequest;
import com.hand.hap.core.ProxySelf;
import com.hand.hap.core.annotation.AuditEntry;

import com.hand.hap.system.service.IBaseService;
import hls.core.cont.dto.ConContractChangeH;
import hls.core.cont.dto.HlsCusConContractChangeReq;
import hls.core.csh.dto.HlsCusCshConContract;

import java.lang.reflect.InvocationTargetException;
import java.util.List;
import java.util.Map;

public interface ConContractChangeService  extends IBaseService<HlsCusConContractChangeReq>, ProxySelf<ConContractChangeService> {
	@AuditEntry
	public void saveBackup(IRequest iRequest, ConContractChangeH changeH,HttpSession session) throws Exception;

	public void modifyState(HlsCusCshConContract conContract, int characteristic);
	public void modifyStateReq(IRequest iRequest, HlsCusConContractChangeReq conContractChangeReq, String statusName);
	public void examineAndApprove(IRequest iRequest,Long changeReqId, Long contractId,String status)
			throws ClassNotFoundException, NoSuchMethodException, SecurityException, IllegalAccessException,
			IllegalArgumentException, InvocationTargetException;

	List<HlsCusConContractChangeReq> select(IRequest requestContext, HlsCusConContractChangeReq changeReq);
    /*合同变更-合同提前结清-判断是否有提前结清审批中*/
    String checkChangeStatus(Map map);
	/*合同变更抽屉-判断某一个合同是否做过变更*/
	List<HlsCusConContractChangeReq>  checkHasChangeHistory(IRequest requestContext, HlsCusConContractChangeReq changeReq);
}
