package hls.core.cont.service.impl;

import java.util.List;

import hls.core.cont.dto.HlsCusConContractAttachment;
import hls.core.cont.service.IConContractAttachmentCustomService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.cont.mapper.HlsCusConContractAttachmentMapper;
import hls.core.cont.service.ConContractAttachmentService;

@Service
@Transactional
public class ConContractAttachmentServiceImpl extends BaseServiceImpl<HlsCusConContractAttachment> implements ConContractAttachmentService {
    @Autowired(required = false)
    private IConContractAttachmentCustomService conContractAttachmentCustomService;

    @Autowired
    private HlsCusConContractAttachmentMapper mapper;

    @Override
    public List<HlsCusConContractAttachment> queryDetail(IRequest requestContext, HlsCusConContractAttachment contractAttachment,
                                                         int page, int pagesize) {
        PageHelper.startPage(page, pagesize);

        return mapper.queryDetail(contractAttachment);
    }

    @Override
    public HlsCusConContractAttachment signSubmit(IRequest requestContext, HlsCusConContractAttachment contractAttachment) {
        if (conContractAttachmentCustomService != null && !conContractAttachmentCustomService.beforeSignSubmit(requestContext, contractAttachment)) {
            return contractAttachment;
        }
        self().insertSelective(requestContext, contractAttachment);
        if (conContractAttachmentCustomService != null) {
            conContractAttachmentCustomService.afterSignSubmit(requestContext, contractAttachment);
        }
        return contractAttachment;
    }

    @Override
    public void deleteContentById(Long contractId) {
        mapper.deleteContentById(contractId);
    }

}
