package hls.core.cont.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import com.hand.hap.system.dto.ResponseData;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.dto.HlsCusConContractCancel;
import hls.core.cont.mapper.HlsCusConContractCancelMapper;
import hls.core.cont.mapper.HlsCusConContractMapper;
import hls.core.cont.service.ConContractCancelService;
import hls.core.cont.service.ConContractEventService;
import hls.core.cont.service.IConContractCancelCustomService;
import hls.core.fnd.dto.HlsEmployee;
import hls.core.fnd.mapper.HlsEmployeeMapper;
import hls.core.wfl.service.IActivitiStartService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

/**
 * Created by yang on 2017/1/6.
 */
@Service
@Transactional
public class ConContractCancelServiceImpl extends BaseServiceImpl<HlsCusConContractCancel> implements ConContractCancelService {
    @Autowired
    private IActivitiStartService activitiStartService;
    @Autowired
    private ConContractEventService eventService;
    @Autowired
    private HlsEmployeeMapper employeeMapper;
    @Autowired
    private HlsCusConContractMapper conContractMapper;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;
    @Autowired
    private HlsCusConContractCancelMapper conContractCancelMapper;
    @Autowired(required = false)
    private IConContractCancelCustomService iConContractCancelCustomService;

    @Override
    public ResponseData cancel(IRequest iRequest,HlsCusConContractCancel cancelContract) throws Exception {

        if(iConContractCancelCustomService != null && !iConContractCancelCustomService.beforeCancel(iRequest,cancelContract)){
            return new ResponseData(true);
        }
        HlsCusConContract conContract = new HlsCusConContract();
        conContract.setContractId(cancelContract.getContractId());
        conContract = conContractMapper.selectByPrimaryKey(conContract);
        //lock con_contract
        databaseLockProvider.lock(conContract);
        // 插入撤销表新数据
        cancelContract.setStatus("NEW");
        HlsCusConContractCancel cc = self().insertSelective(iRequest,cancelContract);

        //eventService.contractEvent(iRequest,"CON_CONTRACT.CANCEL",cancelContract.getContractId(),iRequest.getUserId());

/*        // 修改cashflow
        Example example = new Example(HlsCusConContractCashflow.class);
        Example.Criteria criteria = example.createCriteria();
        criteria.andEqualTo("contract_id",cancelContract.getContractId());
        criteria.andEqualTo("cf_status","RELEASE");

        HlsCusConContractCashflow conContractCashflow = new HlsCusConContractCashflow();
        conContractCashflow.setCf_status("CANCEL");
        cashflowMapper.updateByExampleSelective(conContractCashflow,example);*/
        HlsEmployee employee = employeeMapper.getEmployeeCode(iRequest.getUserId());
        String employeeCode = employee.getEmployeeCode();
        iRequest.setEmployeeCode(employeeCode);

        List<HlsCusConContractCancel> list = new ArrayList<HlsCusConContractCancel>();
        list.add(cc);
        Map<String,Object> params = new HashMap<String,Object>();
        params.put("workFlowType","CONTRACT_CANCEL");
        activitiStartService.start(iRequest,list,params);

        HlsCusConContractCancel cancel = new HlsCusConContractCancel();
        cancel.setContractCancelId(cc.getContractCancelId());
        cancel.setStatus("APPROVING");
        self().updateByPrimaryKeySelective(iRequest,cancel);
        //TODO 调用工作流
        if(iConContractCancelCustomService != null){
            iConContractCancelCustomService.afterCancel(iRequest,cancelContract);
        }
        return new ResponseData(true);
    }

    @Override
    public List<HlsCusConContractCancel> queryConCancelInfo(HlsCusConContractCancel conContractCancel) {
        return conContractCancelMapper.queryConCancelInfo(conContractCancel);
    }
}
