package hls.core.cont.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.hand.hap.attachment.dto.AttachCategory;
import com.hand.hap.attachment.dto.Attachment;
import com.hand.hap.attachment.exception.FileReadIOException;
import com.hand.hap.attachment.service.IAttachCategoryService;
import com.hand.hap.attachment.service.IAttachmentService;
import com.hand.hap.core.IRequest;
import com.hand.hap.core.exception.TokenException;
import hls.core.cont.dto.HlsCusConContractAttachment;
import hls.core.cont.service.ConContractAttachmentService;
import hls.core.cont.service.ConContractDocxService;
import hls.core.docx4J.component.BookMarkReplaceComponent;
import hls.core.fnd.service.HlsConFileTempletService;
import hls.core.hls.bp.dto.HlsCusSysAttachment;
import hls.core.hls.bp.dto.HlsCusSysFile;
import hls.core.hls.bp.service.HlsSysAttachmentService;
import hls.core.hls.bp.service.HlsSysFileService;
import org.apache.commons.lang.StringUtils;
import org.docx4j.openpackaging.exceptions.Docx4JException;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.io.*;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.UUID;

/**
 * Created by FJM on 2017/4/18.
 */
@Service
@Transactional
public class ConContractDocxServiceImpl implements ConContractDocxService {

    @Autowired
    private BookMarkReplaceComponent bookMarkReplaceComponent;
    @Autowired
    private HlsSysFileService fileService;
    @Autowired
    private ConContractAttachmentService contractAttachmentService;
    @Autowired
    private HlsSysAttachmentService hlsSysAttachmentService;
    @Autowired
    private IAttachCategoryService attachCategoryService;
    @Autowired
    private HlsConFileTempletService hlsConFileTempletService;

    /**
     * 文件不存在提示.
     */
    private static final String FILE_NOT_EXSIT = "未找到文件模板";
    /**
     * 文件下载默认编码.
     */
    private static final String ENC = "UTF-8";

    @Autowired
    private IAttachmentService attachmentService;

    public void createDocx(IRequest requestContext, InputStream is, File file,Map<String,Object> params) throws Exception {

        WordprocessingMLPackage wordMLPackage = WordprocessingMLPackage.load(is);//通过输入流构建WordprocessingMLPackage对象

        wordMLPackage = bookMarkReplaceComponent.docxCreateBookMarkReplaceWithText(wordMLPackage,requestContext,params);//将构建的wordMLPackage对象传入方法中

        wordMLPackage.save(file);//将替换后的合同文本保存到服务器上作为备份

        //wordMLPackage.save(os);//将替换后的合同文本写入到输出流中以用于下载

    }
    @Override
    public void process(IRequest requestContext,Map<String,Object> params,JSONObject jsonObject) {
        try {
            docxCreateMethod(requestContext,params);
        } catch (TokenException e) {
            e.printStackTrace();
        } catch (FileReadIOException e) {
            e.printStackTrace();
        } catch (Docx4JException e) {
            e.printStackTrace();
        }
    }


    public HlsCusSysFile docxCreateMethod(IRequest requestContext, Map<String,Object> params) throws TokenException, FileReadIOException, Docx4JException {
        //待合同文本表完成后，此处的contractId参数应该换位contentId,根据contentId获取书签对应的参数的key和value，然后传入到动态sql中执行

        Long templetId = Long.parseLong(params.get("templetId").toString());
        Long contractId = Long.parseLong(params.get("contractId").toString());
        Long contractAttachmentId = Long.parseLong(params.get("contractAttachmentId").toString());

        String SourceType = "HLS_DOC_FILE_TEMPLET";//合同文本的SourceType

        String backSourceType = "";//生成备份的合同文本对应的SourceType

        Long SourceKey = templetId;//模板的ID为对应的SourceKey

        Attachment attachment = new Attachment();
        HlsCusSysFile returnSysFile = null;

        try {

            attachment = attachmentService.selectAttachByCodeAndKey(requestContext,SourceType,SourceKey.toString());//根据sys_attachment表上的记录获取附件的信息

            HlsCusSysFile fileParam = new HlsCusSysFile();

            //fileParam.setAttachmentId(attachment.getAttachmentId());

           // List<HlsCusSysFile> sysFiles = fileService.queryByAttachmentId(requestContext,fileParam,0,10);//在sys_file上获取对应的文件的信息

            HlsCusSysFile sysFile = fileService.queryByAttachmentId(attachment.getAttachmentId());

            if (sysFile != null && StringUtils.isNotBlank(sysFile.getFilePath())) {
                File file = new File(sysFile.getFilePath());
                if (file.exists()) {
                 /*   response.addHeader("Content-Disposition",
                            "attachment;filename=\"" + URLEncoder.encode(sysFile.getFileName(), ENC) + "\"");
                    response.setContentType(sysFile.getFileType() + ";charset=" + ENC);
                    response.setHeader("Accept-Ranges", "bytes");*/

                    int fileLength = (int) file.length();//先获取模板文件的大小

                    int fileBackLength = 0;//定义备份文件的大小

                    if (fileLength > 0) {

                        InputStream inStream = new FileInputStream(file);//用inputStram输入流读取本地的docx文件

                        String copyPath = sysFile.getFilePath().concat("_back_").concat(UUID.randomUUID().toString());//定义复制模板的filepath,使用uuid拼接于文件末尾，避免备份文件重名覆盖

                        this.copyModel(copyPath,inStream);//复制模板

                        InputStream modelIs = new FileInputStream(copyPath);//用输入流读取复制后的模板

                        //ServletOutputStream outputStream = response.getOutputStream();//获取response对象中的outputStream输出流

                        createDocx(requestContext,modelIs,new File(copyPath),params);//生成合同文本

                        //attachmentService.insert(requestContext,attachment); 此处应该根据备份的SourceType获取到对应的CATEGORY_ID,然后先插入sys_attachment表，再根据插入之后的记录，获取attachment_id，再插入sys_file表

                        fileBackLength = (int)new File(copyPath).length();
                        //重新插入合同文本记录
                        HlsCusConContractAttachment cca = new HlsCusConContractAttachment();
                        cca.setContractAttachmentId(contractAttachmentId);
                        cca = contractAttachmentService.selectByPrimaryKey(requestContext,cca);
                        if(cca.getDocumentName() == null)
                        {
                            cca.setDocumentName(sysFile.getFileName());
                            contractAttachmentService.updateByPrimaryKeySelective(requestContext,cca);
                        }

                        HlsCusSysAttachment hsa = new HlsCusSysAttachment();
                        hsa.setSourceKey(contractAttachmentId.toString());

                        AttachCategory attachCategory = new AttachCategory();
                        attachCategory.setSourceType("CON_CONTRACT_ATTACHMENT_CREATE");
                        List<AttachCategory> lists = attachCategoryService.selectCategories(requestContext,attachCategory);
                        hsa.setCategoryId(lists.get(0).getCategoryId());
                        hsa.setSourceType("CON_CONTRACT_ATTACHMENT_CREATE");
                        hsa.setName("CON_CONTRACT_ATTACHMENT_CREATE");
                        hsa.setStatus("1");
                        hsa = hlsSysAttachmentService.insertSelective(requestContext,hsa);

                        HlsCusSysFile backSysFile = new HlsCusSysFile();
                        String fileBak = sysFile.getFileName().substring(0,sysFile.getFileName().length()-5);
                        backSysFile.setFileName(fileBak.concat("_模板.docx"));
                        backSysFile.setAttachmentId(hsa.getAttachmentId());
                        backSysFile.setFilePath(copyPath);
                        backSysFile.setFileSize(new BigDecimal(fileBackLength));
                        backSysFile.setFileType(sysFile.getFileType());
                        backSysFile.setUploadDate(new Date());
                        returnSysFile = fileService.insertSelective(requestContext,backSysFile);

                    }
                    //response.setContentLength(fileBackLength);//获取替换完成之后的文件大小

                } else {
                    //response.getWriter().write(FILE_NOT_EXSIT);
                }
            } else {
                //response.getWriter().write(FILE_NOT_EXSIT);
            }
        } catch (IOException e) {
            throw new FileReadIOException();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return returnSysFile;
    }

    /**
     *  复制文件模板,将读取源文件的输入流复制文件存入一个备用的模板文件
     * @param filePath
     * @param is
     * @throws IOException
     */
    private static synchronized void copyModel(String filePath,InputStream is) throws IOException {

        FileOutputStream fos = new FileOutputStream(filePath); //复制出一个模板
        int readData;
        byte[] b = new byte[1024];

        while((readData = is.read(b)) != -1){
            fos.write(b,0,readData);
        }

        fos.flush();
        is.close();
        fos.close();
    }


}
