package hls.core.cont.service.impl;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

import hls.core.cont.service.ConContractChangeService;
import hls.core.cont.service.ConContractGuarantorHService;
import hls.core.csh.service.ConContractChangeReqEventService;
import hls.core.hls.service.HlsBeanRefUtilService;
import hls.core.prj.dto.HlsCusPrjProjectGuarantor;
import hls.core.prj.mapper.HlsCusPrjProjectGuarantorMapper;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import org.apache.commons.beanutils.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.cont.dto.ConContractChangeH;
import hls.core.cont.dto.HlsCusConContractChangeReq;
import hls.core.cont.dto.HlsCusConContractGuarantor;
import hls.core.cont.dto.HlsCusConContractGuarantorH;
import hls.core.cont.mapper.HlsCusConContractGuarantorHMapper;
import hls.core.cont.mapper.HlsCusConContractGuarantorMapper;
import hls.core.cont.service.ConContractChangeCommon;
import hls.core.cont.service.ConContractGuarantorService;
@Service
@Transactional
public class ConContractGuarantorServiceImpl extends BaseServiceImpl<HlsCusConContractGuarantor> implements ConContractGuarantorService,ConContractChangeCommon{

	private static final String changeName="ConContractGuarantors";
	
	private static final String deleteName="guarantorsdel";
	
	private static final String ethodName="getChangeGuarantorFlag";
	
	@Autowired
	private HlsCusConContractGuarantorMapper guarantorMapper;
	@Autowired
	private ConContractGuarantorHService guarantorHService;
	@Autowired
	private HlsCusConContractGuarantorHMapper guarantorHMapper;
	@Autowired
	private ConContractChangeService changeReqService;
	@Autowired
	private ConContractChangeReqEventService conContractChangeReqEventService;
	@Autowired
	private HlsCusPrjProjectGuarantorMapper prjProjectGuarantorMapper;
	@Autowired
	private  HlsBeanRefUtilService  hlsBeanRefUtilService;
	@Autowired
	private SysEventService sysEventService;

	@Override
	public List<HlsCusConContractGuarantor> queryDetail(IRequest requestContext, HlsCusConContractGuarantor contractGuarantor, int page, int pagesize) {
		PageHelper.startPage(page, pagesize);
		
		return guarantorMapper.queryDetail(contractGuarantor);
	}

	@Override
	public String getChangeName() {
		return changeName;
	}

	@Override
	public Long dispose(IRequest iRequest,ConContractChangeH conContractChangeH, Long changeReqId) {
		List<HlsCusConContractGuarantor> lists = conContractChangeH.getConContractGuarantors();
		HlsCusConContractGuarantor contractGuarantor = new HlsCusConContractGuarantor();
		HlsCusConContractGuarantorH conContractGuarantorH=new HlsCusConContractGuarantorH();
		int count = 0;
		for (int i = 0; i < lists.size(); i++) {
//			contractGuarantor.setContractGuarantorId(lists.get(i).getContractGuarantorId());
//			conContractGuarantorHMapper.deleteConContractGuarantorH(contractGuarantor);
			contractGuarantor = lists.get(i);
			if(contractGuarantor.getContractGuarantorId() == null){
				continue;
			}
			count++;
			conContractGuarantorH = new HlsCusConContractGuarantorH();
			//conContractGuarantorH.setChangeReqId(changeReqId);
			conContractGuarantorH.setContractId(contractGuarantor.getContractId());
			conContractGuarantorH.setGuarantorBpId(contractGuarantor.getGuarantorBpId());
			conContractGuarantorH.setGuaranteeType(contractGuarantor.getGuaranteeType());
			conContractGuarantorH.setDescription(contractGuarantor.getDescription());

			conContractGuarantorH.setCreatedBy(iRequest.getUserId());
			conContractGuarantorH.setCreationDate(new Date());
			guarantorHService.insertSelective(iRequest,conContractGuarantorH);
			//conContractGuarantorHMapper.insertConContractGuarantorH(conContractGuarantorH);
		}
		if(count == 0){
			HlsCusConContractChangeReq req = new HlsCusConContractChangeReq();
			req.setChangeReqId(changeReqId);
			req = changeReqService.selectByPrimaryKey(iRequest,req);
			req.setChangeTenantFlag("N");
			changeReqService.updateByPrimaryKey(iRequest,req);
		}
		//合同变更-担保人变更-创建事件
		//FIXME 不确定的事件，因为下面的事件本身就被注释掉了
		sysEventService.createEvent(iRequest, conContractChangeH.getContractId(), "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_CHANGE_REQ_CHANGE_GUARANTOR_CREATE);

//	conContractChangeReqEventService.conContractChangeReqEvent(iRequest,"CON_CONTRACT_CHANGE_REQ.CHANGE_GUARANTOR.CREATE",changeReqId,conContractGuarantorH.getContractId());
		return conContractGuarantorH.getContractGuarantorId();
	}

	@Override
	public void delete(IRequest iRequest,ConContractChangeH conContractChangeH) {
		Long [] code = conContractChangeH.getConContractChangeDeleteArr().getGuarantorsDel();
		if(code!=null&&code.length!=0){
			HlsCusConContractGuarantor conContractGuarantorH = new HlsCusConContractGuarantor();
			for (int j = 0; j < code.length; j++) {
				conContractGuarantorH.setContractGuarantorId(code[j]);
				guarantorHService.deleteConContractGuarantorH(conContractGuarantorH);
			}
		}
	}

	@Override
	public String getDeleteName() {
		return deleteName;
	}

	/* (non-Javadoc)
	 * @see hls.core.cont.service.ConContractChangeCommon#getMethodName()
	 */
	@Override
	public String getMethodName() {
		return ethodName;
	}

	/* (non-Javadoc)
	 * @see hls.core.cont.service.ConContractChangeCommon#examineAndApprove()
	 */
	@Override
	public void examineAndApprove(IRequest iRequest,Long changeReqId,Long contractId,String status) throws IllegalAccessException, InvocationTargetException {
		if("APPROVED".equalsIgnoreCase(status)){
			HlsCusConContractGuarantorH guarantorH = new HlsCusConContractGuarantorH();
			//guarantorH.setChangeReqId(changeReqId);
	//		itemH.setContractId(contractId);
	//		itemH.setVenderBpId(bpId);
			HlsCusConContractGuarantor guarantor = new HlsCusConContractGuarantor();
			guarantor.setContractId(contractId);

			List<HlsCusConContractGuarantorH>  guarantorHs= guarantorHMapper.select(guarantorH);
			List<HlsCusConContractGuarantor>  guarantors = guarantorMapper.select(guarantor);

			//删除两表的数据：原表删除合同所对应的数据，_h表删除change_req_id对应的数据
			for (int i = 0; i < guarantors.size(); i++) {
				guarantorMapper.deleteByPrimaryKey(guarantors.get(i));
			}
			for (int i = 0; i < guarantorHs.size(); i++) {
				guarantorHMapper.deleteByPrimaryKey(guarantorHs.get(i));
			}
			// 将_h表的记录(conTenantList)插入到原表
			for (HlsCusConContractGuarantorH i : guarantorHs) {
				HlsCusConContractGuarantor cct = new HlsCusConContractGuarantor();
				BeanUtils.copyProperties(cct, i);
				cct.setContractId(contractId);
				//guarantorMapper.insertConContractGuarantor(cct);
	//			cct.setLastUpdatedBy((Long)session.getAttribute("userId"));
	//			cct.setLastUpdateDate(new Date());
				self().insertSelective(iRequest,cct);
			}
			// 将原表的记录(conTenantList)插入到_h表
			for (HlsCusConContractGuarantor i : guarantors) {
				HlsCusConContractGuarantorH ccth = new HlsCusConContractGuarantorH();
				BeanUtils.copyProperties(ccth, i);
				//ccth.setChangeReqId(changeReqId);
				//guarantorHMapper.insertConContractGuarantorH(ccth);
                guarantorHMapper.insertSelective(ccth);
			}
			//合同变更-担保人变更-确认事件
			sysEventService.createEvent(iRequest, contractId, "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_CHANGE_REQ_CHANGE_GUARANTOR_CONFRIM);

//			conContractChangeReqEventService.conContractChangeReqEvent(iRequest,"CON_CONTRACT_CHANGE_REQ.CHANGE_GUARANTOR.CONFRIM",changeReqId,contractId);
		}else if("CANCEL".equalsIgnoreCase(status)){
			sysEventService.createEvent(iRequest, contractId, "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_CHANGE_REQ_CHANGE_GUARANTOR_CANCEL);

//			conContractChangeReqEventService.conContractChangeReqEvent(iRequest,"CON_CONTRACT_CHANGE_REQ.CHANGE_GUARANTOR.CANCEL",changeReqId,contractId);
		}else
		{
			sysEventService.createEvent(iRequest, contractId, "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_CHANGE_REQ_CHANGE_GUARANTOR_REJECT);
//			conContractChangeReqEventService.conContractChangeReqEvent(iRequest,"CON_CONTRACT_CHANGE_REQ.CHANGE_GUARANTOR.REJECT",changeReqId,contractId);
		}
	}
	@Override
	public List<HlsCusConContractGuarantor> selectGuarantorDetail(IRequest requestContext, HlsCusConContractGuarantor contractGuarantor, int page, int pagesize){
		return guarantorMapper.selectGuarantorDetail(contractGuarantor);
	}

    @Override
	public List<HlsCusConContractGuarantor> saveGuarantorFromPrj(IRequest requestContex,Long contractId,Long projectId){
		List<HlsCusConContractGuarantor> conContractGuarantorList=new ArrayList<>();
        HlsCusPrjProjectGuarantor prjProjectGuarantorPara=new HlsCusPrjProjectGuarantor();
		prjProjectGuarantorPara.setProjectId(projectId);
		List<HlsCusPrjProjectGuarantor> prjProjectGuarantorList=prjProjectGuarantorMapper.prjProjectGuarantorDetailQuery(prjProjectGuarantorPara);
        for(int i=0;i<prjProjectGuarantorList.size();i++){
			HlsCusConContractGuarantor conContractGuarantor=new HlsCusConContractGuarantor();
			Map<String,String> map=	hlsBeanRefUtilService.getFieldValueMap(prjProjectGuarantorList.get(i));
			hlsBeanRefUtilService.setFieldValue(conContractGuarantor,map);
			conContractGuarantor.setContractId(contractId);
			self().insertSelective(requestContex,conContractGuarantor);
			conContractGuarantorList.add(conContractGuarantor);
		}
		return conContractGuarantorList;
	}

}
