package hls.core.cont.service.impl;

import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.cont.dto.HlsCusConContractH;
import hls.core.cont.mapper.HlsCusConContractHMapper;
import hls.core.cont.service.ConContractHService;
import hls.core.hls.dto.HlsCusHlsDocumentVersionRel;
import hls.core.hls.dto.HlsDocumentVersionRel;
import hls.core.hls.mapper.HlsCusHlsDocumentVersionRelMapper;
import hls.core.prj.dto.HlsCusHlsDocumentVersion;
import hls.core.prj.mapper.HlsCusHlsDocumentVersionMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

@Service
@Transactional
public class ConContractHServiceImpl extends BaseServiceImpl<HlsCusConContractH> implements ConContractHService {

	public static final String HISTORY = "HISTORY";
	public static final String CON_CONTRACT_CHANGE_REQ = "con_contract_change_req";
	@Autowired
	private HlsCusHlsDocumentVersionMapper documentVersionMapper;
	@Autowired
	private HlsCusHlsDocumentVersionRelMapper documentVersionRelMapper;
	@Autowired
    HlsCusConContractHMapper conContractHMapper;

	@Override
	public List<HlsCusConContractH> selectContractById(HlsCusConContractH conContractH) {
		return conContractHMapper.selectContractById(conContractH);
	}
	/*合同变更明细页面-查询变更前合同信息*/
	public HlsCusConContractH queryInfoBeforeChange(HlsCusConContractH dto){
		HlsCusHlsDocumentVersion documentVersion = new HlsCusHlsDocumentVersion();
		documentVersion.setVersionType(dto.getVersionType());
		documentVersion.setSourceDocumentId(dto.getChangeReqId());
		documentVersion.setSourceDocumentCategory(CON_CONTRACT_CHANGE_REQ);
		documentVersion = documentVersionMapper.selectOne(documentVersion);
		Long versionId = documentVersion.getVersionId();

		HlsCusHlsDocumentVersionRel documentVersionRel = new HlsCusHlsDocumentVersionRel();
		documentVersionRel.setVersionId(versionId);
		documentVersionRel.setFromTable("con_contract");
		documentVersionRel.setToTable("con_contract_h");
		HlsDocumentVersionRel hlsDocumentVersionRel = documentVersionRelMapper.selectOne(documentVersionRel);
		Long toPk = hlsDocumentVersionRel.getToPk();
		return conContractHMapper.selectByPrimaryKey(toPk);
	}
}
