package hls.core.cont.service.impl;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

import hls.core.csh.dto.HlsCusCshWriteOff;
import hls.core.csh.mapper.HlsCusCshConContractMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.cont.dto.HlsCusConContractChangeReq;
import hls.core.cont.mapper.HlsCusConContractChangeReqMapper;
import hls.core.cont.service.ConContractIndexService;
import hls.core.csh.dto.HlsCusConContractCashflow;
import hls.core.csh.dto.HlsCusCshConContract;
import hls.core.csh.mapper.HlsCusConContractCashflowMapper;
import hls.core.csh.mapper.HlsCusCshWriteOffMapper;

@Service
@Transactional
public class ConContractIndexServiceImpl extends BaseServiceImpl<HlsCusCshWriteOff> implements ConContractIndexService{

	@Autowired
	HlsCusCshWriteOffMapper cshWriteOffMapper;
	
	@Autowired
	HlsCusCshConContractMapper cshConContractMapper;
	
	@Autowired
    HlsCusConContractChangeReqMapper hlsCusConContractChangeReqMapper;
	
	@Autowired
	HlsCusConContractCashflowMapper conContractCashflowMapper;
	
	public List<HlsCusCshWriteOff> currentOutAmountInfo(HlsCusCshWriteOff cshWriteOff){
		return cshWriteOffMapper.currentOutAmountInfo(cshWriteOff);
	}
	
	public List<HlsCusCshConContract> getContractDetailByBpId(HlsCusCshConContract conContract){
		if(conContract.getCf_type().equals("tenantry")){
			return cshConContractMapper.getTenantryContractDetailByBpId(conContract);
		}
		else{
			return cshConContractMapper.getSecurityContractDetailByBpId(conContract);
		}
	}
	SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
	@Override
	public List<HlsCusCshWriteOff> currentGetAmountInfo(HlsCusCshWriteOff cshWriteOff) throws ParseException {
		// TODO Auto-generated method stub
		Long lafe = cshWriteOff.getQueryTimeSolt();
		if(lafe!=null){
			String dataStr = calculationDate(lafe);
			cshWriteOff.setWriteOffDate(sdf.parse(dataStr));
		}
		if(lafe== 0 ){
			cshWriteOff.setWriteOffDate(null);
		}
		return cshWriteOffMapper.currentGetAmountInfo(cshWriteOff);
	}
	private String calculationDate(Long fate) {
		//SimpleDateFormat dft = new SimpleDateFormat("yyyy-MM-dd");
		Date beginDate = new Date();
		Calendar date = Calendar.getInstance();
		date.setTime(beginDate);
		if (fate == 7) {
			date.set(Calendar.DATE, date.get(Calendar.DATE) - 7);
		}
		if (fate == 30) {
			date.add(Calendar.MONTH, -1);
		}
		if (fate == 90) {
			date.add(Calendar.MONTH, -3);
		}
		String endDate = sdf.format(date.getTime());
		return endDate;
	}

	@Override
	public List<HlsCusCshConContract> getContractInfo(HlsCusCshConContract conContract) {
		// TODO Auto-generated method stub
		Map<String, Object> params = new HashMap<String, Object>();
		final List<String> list = new ArrayList<String>();
		if(conContract.getContract_status().equals("N"))
		{
			params.put("flag", null);
			params.put("list", null);
			params.put("contract_id",conContract.getContract_id());
			params.put("contract_name",conContract.getContract_name());
			return cshConContractMapper.getContractInfo(params);
		}
		else
		{
			params.put("flag", true);
			String[] status = conContract.getContract_status().split(",");
			for(int i = 0; i < status.length; i++)
			{
				list.add(status[i]);
			}
			params.put("list", list);
			params.put("contract_name",conContract.getContract_name());
			return cshConContractMapper.getContractInfo(params);
		}
	}

	@Override
	public List<HlsCusConContractChangeReq> conContractChangeReqInfo() {
		// TODO Auto-generated method stub
		return hlsCusConContractChangeReqMapper.conContractChangeReqInfo();
	}

	@Override
	public List<HlsCusConContractCashflow> contractCashFlowOverDateDetail() {
		// TODO Auto-generated method stub
		return conContractCashflowMapper.contractCashFlowOverDateDetail();
	}

	@Override
	public List<HlsCusCshConContract> getConContractIndexNumInfo() {
		// TODO Auto-generated method stub
		return cshConContractMapper.getConContractIndexNumInfo();
	}

    @Override
    public List<HlsCusConContractChangeReq> selectChangeInfoDetail(HlsCusConContractChangeReq conContractChangeReq) {
        return  hlsCusConContractChangeReqMapper.selectChangeInfoDetail(conContractChangeReq);
    }

	@Override
	public List<HlsCusConContractChangeReq> getNewChangeIdByChangeId(HlsCusConContractChangeReq conContractChangeReq) {
		return  hlsCusConContractChangeReqMapper.getNewChangeIdByChangeId(conContractChangeReq);
	}

	@Override
	public List<HlsCusConContractChangeReq> selectDetail(HlsCusConContractChangeReq conContractChangeReq) {


		Map<String,Object> params = new HashMap<String, Object>();
		List<String> list_business_type = new ArrayList<String>();
		List<String> list_contract_status = new ArrayList<String>();
        List<String> list_status = new ArrayList<String>();
        String [] business_type = null;
        String [] contract_status = null;
        String [] status = null;
        if(conContractChangeReq.getBusinessType() != null){
            business_type = conContractChangeReq.getBusinessType().split(",");
            for (int i = 0; i < business_type.length; i++) {
                list_business_type.add(business_type[i]);
            }
            params.put("list_business_type", list_business_type);
        }

        if(conContractChangeReq.getContractStatus() != null){
            contract_status = conContractChangeReq.getContractStatus().split(",");
            for (int i = 0; i < contract_status.length; i++) {
                list_contract_status.add(contract_status[i]);
            }
            params.put("list_contract_status", list_contract_status);
        }

        if(conContractChangeReq.getStatus() != null){
            status = conContractChangeReq.getStatus().split(",");
            for (int i = 0; i < status.length; i++) {
                list_status.add(status[i]);
            }
            params.put("list_status", list_status);
        }

        params.put("changeReqId", conContractChangeReq.getChangeReqId());
        params.put("contractNumber", conContractChangeReq.getContractNumber());
        params.put("contractName", conContractChangeReq.getContractName());
        params.put("bpName", conContractChangeReq.getBpName());
        params.put("bpCode", conContractChangeReq.getBpCode());
        params.put("amount_1", conContractChangeReq.getAmount_1());
        params.put("amount_2",  conContractChangeReq.getAmount_2());
        params.put("amount_3",  conContractChangeReq.getAmount_3());
        params.put("amount_from", conContractChangeReq.getAmount_from());
        params.put("amount_to", conContractChangeReq.getAmount_to());

		return hlsCusConContractChangeReqMapper.selectDetail(params);
	}
}
