package hls.core.cont.service.impl;

import java.lang.reflect.InvocationTargetException;
import java.util.Date;
import java.util.List;

import com.hand.hap.core.IRequest;
import hls.core.cont.dto.HlsCusConContractLeaseItemH;
import hls.core.cont.service.ConContractChangeService;
import hls.core.cont.service.ConContractLeaseItemService;
import hls.core.csh.dto.HlsCusCshConContract;
import hls.core.csh.service.ConContractChangeReqEventService;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import org.apache.commons.beanutils.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.cont.dto.ConContractChangeH;
import hls.core.cont.dto.HlsCusConContractChangeReq;
import hls.core.cont.dto.HlsCusConContractLeaseItem;
import hls.core.cont.mapper.HlsCusConContractLeaseItemHMapper;
import hls.core.cont.mapper.HlsCusConContractLeaseItemMapper;
import hls.core.cont.service.ConContractChangeCommon;
import hls.core.cont.service.ConContractLeaseItemHService;

@Service
@Transactional
public class ConContractLeaseItemHServiceImpl extends BaseServiceImpl<HlsCusConContractLeaseItemH> implements ConContractLeaseItemHService,ConContractChangeCommon{

	private static final String changeName="ConContractLeaseItems";
	private static final String deleteName="leaseitemsdel";
	private static final String methodName = "getChangeLeaseItemFlag";
	
	@Autowired
	private HlsCusConContractLeaseItemHMapper itemHMapper;
	@Autowired
	private HlsCusConContractLeaseItemMapper itemMapper;
	@Autowired
	private ConContractLeaseItemService itemService;
	@Autowired
	private ConContractChangeService changeService;
	@Autowired
	private ConContractChangeReqEventService conContractChangeReqEventService;
	@Autowired
	private SysEventService sysEventService;

	@Override
	public List<HlsCusConContractLeaseItemH> selectConContractLeaseItemH(HlsCusCshConContract conContract) {
		return itemHMapper.selectConContractLeaseItemH(conContract);
	}

	@Override
	public List<HlsCusConContractLeaseItemH> selectDetail(HlsCusConContractLeaseItemH conContractLeaseItemH) {
		return itemHMapper.selectDetail(conContractLeaseItemH);
	}

	@Override
	public String getChangeName() {
		return changeName;
	}

	@Override
	public String getDeleteName() {
		return deleteName;
	}
	
	@Override
	public Long dispose(IRequest iRequest,ConContractChangeH conContractChangeH, Long changeReqId) {
		List<HlsCusConContractLeaseItem> lists = conContractChangeH.getConContractLeaseItems();
		if (lists.size()==0) {
			return null;
		}
		int count =0;
		HlsCusConContractLeaseItemH itemH=new HlsCusConContractLeaseItemH();
		for (int i = 0; i < lists.size(); i++) {
			HlsCusConContractLeaseItem item =  lists.get(i);
			if(item.getContractLeaseItemId()!=null){
				continue;
			}
			count++;
			itemH = new HlsCusConContractLeaseItemH();
			//itemH.setChangeReqId(changeReqId);
			itemH.setSeqNumber(Long.parseLong(((int)(Math.random()*10000))+""));		    
			itemH.setContractId(item.getContractId());		    
			itemH.setLeaseItemName(item.getLeaseItemName());
			itemH.setSerialNumber(item.getSerialNumber());
			itemH.setPattern(item.getPattern());
			itemH.setSpecification(item.getSpecification());
			itemH.setColour(item.getColour());
			itemH.setQuantity(item.getQuantity());
			itemH.setUom(item.getUom());
			itemH.setPrice(item.getPrice());
			itemH.setLeaseItemAmount(item.getLeaseItemAmount());
			itemH.setCurrency(item.getCurrency());
			itemH.setVenderBpId(item.getVenderBpId());
			itemH.setDescription(item.getDescription());

			itemH.setCreatedBy(iRequest.getUserId());
			itemH.setCreationDate(new Date());
			self().insertSelective(iRequest,itemH);
		}
		if(count == 0){
			HlsCusConContractChangeReq req = new HlsCusConContractChangeReq();
			req.setChangeReqId(changeReqId);
			req = changeService.selectByPrimaryKey(iRequest,req);
			req.setChangeTenantFlag("N");
			changeService.updateByPrimaryKey(iRequest,req);
		}
		sysEventService.createEvent(iRequest, itemH.getContractId(), "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_CHANGE_REQ_CHANGE_LEASE_ITEM_CREATE);

//		conContractChangeReqEventService.conContractChangeReqEvent(iRequest,"CON_CONTRACT_CHANGE_REQ.CHANGE_LEASE_ITEM.CREATE",changeReqId,itemH.getContractId());
		return itemH.getContractLeaseItemId();
	}

	@SuppressWarnings("null")
	@Override
	public void delete(IRequest iRequest,ConContractChangeH conContractChangeH) {
		Long code[] = conContractChangeH.getConContractChangeDeleteArr().getLeaseItemsDel();
		if(code==null&&code .length==0){
			return;
		}
		for (int i = 0; i < code.length; i++) {
			HlsCusConContractLeaseItem conContractLeaseItem = new HlsCusConContractLeaseItem();
			conContractLeaseItem.setContractLeaseItemId(code[i]);
			itemHMapper.deleteConContractLeaseItemH(conContractLeaseItem);
		}
	}

	/* (non-Javadoc)
	 * @see hls.core.cont.service.ConContractChangeCommon#getMethodName()
	 */
	@Override
	public String getMethodName() {
		return methodName;
	}

	/* (non-Javadoc)
	 * @see hls.core.cont.service.ConContractChangeCommon#examineAndApprove()
	 */
	@Override
	public void examineAndApprove(IRequest iRequest,Long changeReqId,Long contractId,String status) throws IllegalAccessException, InvocationTargetException {
		if("APPROVED".equalsIgnoreCase(status)){
			HlsCusConContractLeaseItemH itemH = new HlsCusConContractLeaseItemH();
			//itemH.setChangeReqId(changeReqId);
			//itemH.setContractId(contractId);
			//itemH.setVenderBpId(bpId);
			HlsCusConContractLeaseItem item = new HlsCusConContractLeaseItem();
			item.setContractId(contractId);

			List<HlsCusConContractLeaseItemH>  itemHs= itemHMapper.select(itemH);
			List<HlsCusConContractLeaseItem>  items = itemMapper.select(item);

			//删除两表的数据：原表删除合同所对应的数据，_h表删除change_req_id对应的数据
			for (int i = 0; i < items.size(); i++) {
				itemMapper.deleteByPrimaryKey(items.get(i));
			}
			for (int i = 0; i < itemHs.size(); i++) {
				itemHMapper.deleteByPrimaryKey(itemHs.get(i));
			}
			// 将_h表的记录(conTenantList)插入到原表
			for (HlsCusConContractLeaseItemH i : itemHs) {
				HlsCusConContractLeaseItem cct = new HlsCusConContractLeaseItem();
				BeanUtils.copyProperties(cct, i);
				cct.setContractId(contractId);
//			cct.setLastUpdatedBy((Long)session.getAttribute("userId"));
//			cct.setLastUpdateDate(new Date());
				itemService.insertSelective(iRequest,cct);
				//itemMapper.insertConContractLeaseItem(cct);
			}
			// 将原表的记录(conTenantList)插入到_h表
			for (HlsCusConContractLeaseItem i : items) {
				HlsCusConContractLeaseItemH ccth = new HlsCusConContractLeaseItemH();
				BeanUtils.copyProperties(ccth, i);
				//ccth.setChangeReqId(changeReqId);
				//itemHMapper.insertConContractLeaseItemH(ccth);
                itemHMapper.insertSelective(ccth);
			}
			//合同变更-租赁物变更-确认事件
			sysEventService.createEvent(iRequest, contractId, "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_CHANGE_REQ_CHANGE_LEASE_ITEM_CONFRIM);
//			conContractChangeReqEventService.conContractChangeReqEvent(iRequest,"CON_CONTRACT_CHANGE_REQ.CHANGE_LEASE_ITEM.CONFRIM",changeReqId,contractId);
		}else if("CANCEL".equalsIgnoreCase(status)){
			sysEventService.createEvent(iRequest, contractId, "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_CHANGE_REQ_CHANGE_LEASE_ITEM_CANCEL);
//			conContractChangeReqEventService.conContractChangeReqEvent(iRequest,"CON_CONTRACT_CHANGE_REQ.CHANGE_LEASE_ITEM.CANCEL",changeReqId,contractId);
		}else
		{
			sysEventService.createEvent(iRequest, contractId, "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_CHANGE_REQ_CHANGE_LEASE_ITEM_REJECT);
//			conContractChangeReqEventService.conContractChangeReqEvent(iRequest,"CON_CONTRACT_CHANGE_REQ.CHANGE_LEASE_ITEM.REJECT",changeReqId,contractId);
		}
	}
}
