package hls.core.cont.service.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import hls.core.hls.service.HlsBeanRefUtilService;
import hls.core.prj.dto.HlsCusPrjProjectLeaseItem;
import hls.core.prj.mapper.HlsCusPrjProjectLeaseItemMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.cont.dto.HlsCusConContractLeaseItem;
import hls.core.cont.mapper.HlsCusConContractLeaseItemMapper;
import hls.core.cont.service.ConContractLeaseItemService;

@Service
@Transactional
public class ConContractLeaseItemServiceImpl extends BaseServiceImpl<HlsCusConContractLeaseItem> implements ConContractLeaseItemService{

	@Autowired
	private HlsCusConContractLeaseItemMapper mapper;
	@Autowired
	private HlsCusPrjProjectLeaseItemMapper prjProjectLeaseItemMapper;
	@Autowired
	private HlsBeanRefUtilService hlsBeanRefUtilService;
	
	@Override
	public List<HlsCusConContractLeaseItem> queryDetail(IRequest requestContext, HlsCusConContractLeaseItem contractLeaseItem, int page, int pagesize) {
		PageHelper.startPage(page, pagesize);
		
		return mapper.queryDetail(contractLeaseItem);
	}

	@Override
    public	List<HlsCusConContractLeaseItem> saveLeaseItemFromPrj(IRequest requestContex,Long contractId,Long projectId){
		List<HlsCusConContractLeaseItem> conContractLeaseItemList= new ArrayList<>();
        HlsCusPrjProjectLeaseItem prjProjectLeaseItemPara=new HlsCusPrjProjectLeaseItem();
		prjProjectLeaseItemPara.setProjectId(projectId);
		List<HlsCusPrjProjectLeaseItem> prjProjectLeaseItemList=prjProjectLeaseItemMapper.prjProjectLeaseItemDetailQuery(prjProjectLeaseItemPara);
		for(int i=0;i<prjProjectLeaseItemList.size();i++){
			HlsCusConContractLeaseItem conContractLeaseItem= new HlsCusConContractLeaseItem();
		    Map<String,String> map= hlsBeanRefUtilService.getFieldValueMap(prjProjectLeaseItemList.get(i));
			hlsBeanRefUtilService.setFieldValue(conContractLeaseItem,map);
			conContractLeaseItem.setContractId(contractId);
			self().insertSelective(requestContex,conContractLeaseItem);
			conContractLeaseItemList.add(conContractLeaseItem);
		}
		return conContractLeaseItemList;
	}

}
