package hls.core.cont.service.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import hls.core.cont.dto.HlsCusConContractMortgage;
import hls.core.hls.service.HlsBeanRefUtilService;
import hls.core.prj.dto.HlsCusPrjProjectMortgage;
import hls.core.prj.mapper.HlsCusPrjProjectMortgageMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.cont.mapper.HlsCusConContractMortgageMapper;
import hls.core.cont.service.ConContractMortgageService;

@Service
@Transactional
public class ConContractMortgageServiceImpl extends BaseServiceImpl<HlsCusConContractMortgage> implements ConContractMortgageService{

	@Autowired
	private HlsCusConContractMortgageMapper mapper;
	@Autowired
	private HlsCusPrjProjectMortgageMapper prjProjectMortgageMapper;
	@Autowired
	private HlsBeanRefUtilService hlsBeanRefUtilService;
	
	@Override
	public List<HlsCusConContractMortgage> queryDetail(IRequest requestContext, HlsCusConContractMortgage contractMortgage, int page, int pagesize) {
		PageHelper.startPage(page, pagesize);
		
		return mapper.queryDetail(contractMortgage);
	}

	@Override
	public List<HlsCusConContractMortgage> saveMortgageFromPrj(IRequest requestContext, Long contractId, Long projectId){
		List<HlsCusConContractMortgage>  conContractMortgageList=new ArrayList<>();
        HlsCusPrjProjectMortgage prjProjectMortgagePara=new HlsCusPrjProjectMortgage();
		prjProjectMortgagePara.setProjectId(projectId);
		List<HlsCusPrjProjectMortgage> prjProjectMortgageList= prjProjectMortgageMapper.prjProjectMortgageMapperDetailQuery(prjProjectMortgagePara);
		for (int i=0;i<prjProjectMortgageList.size();i++){
			HlsCusConContractMortgage conContractMortgage=new HlsCusConContractMortgage();
			Map<String,String> map =hlsBeanRefUtilService.getFieldValueMap(prjProjectMortgageList.get(i));
			hlsBeanRefUtilService.setFieldValue(conContractMortgage,map);
			conContractMortgage.setContractId(contractId);
			self().insertSelective(requestContext,conContractMortgage);
			conContractMortgageList.add(conContractMortgage);
		}
		return conContractMortgageList;
	}

}
