package hls.core.cont.service.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.dto.HlsCusConContractSign;
import hls.core.cont.mapper.HlsCusConContractMapper;
import hls.core.cont.service.ConContractEventService;
import hls.core.fnd.dto.HlsEmployee;
import hls.core.fnd.mapper.HlsEmployeeMapper;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import hls.core.wfl.service.IActivitiStartService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.cont.mapper.HlsCusConContractSignMapper;
import hls.core.cont.service.ConContractSignService;

@Service
@Transactional
public class ConContractSignServiceImpl extends BaseServiceImpl<HlsCusConContractSign> implements ConContractSignService{

	@Autowired
	private HlsCusConContractSignMapper mapper;
	@Autowired
	private IActivitiStartService activitiStartService;
	@Autowired
	private ConContractEventService eventService;
	@Autowired
	private HlsEmployeeMapper employeeMapper;
	@Autowired
	private SysEventService sysEventService;
	@Autowired
	private DatabaseLockProvider databaseLockProvider;
	@Autowired
	private HlsCusConContractMapper conContractMapper;
	@Override
	public void save(IRequest requestContext, HlsCusConContractSign conContractSign, Long userId) {
		HlsCusConContract conContract = new HlsCusConContract();
		conContract.setContractId(conContractSign.getContractId());
		conContract = conContractMapper.selectByPrimaryKey(conContract);
		if(conContract == null){
			return;
		}
		// lock con_contract
		databaseLockProvider.lock(conContract);

		conContractSign.setStatus("NEW");
		HlsCusConContractSign ccs = self().insertSelective(requestContext,conContractSign);

		sysEventService.createEvent(requestContext, conContractSign.getContractId(), "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_SIGN);
		//eventService.contractEvent(requestContext,"CON_CONTRACT.SIGN",conContractSign.getContractId(),requestContext.getUserId());

		HlsEmployee employee = employeeMapper.getEmployeeCode(requestContext.getUserId());
			String employeeCode = employee.getEmployeeCode();
		requestContext.setEmployeeCode(employeeCode);

		List<HlsCusConContractSign> cs = new ArrayList<HlsCusConContractSign>();
		cs.add(ccs);
		Map<String,Object> params = new HashMap<String,Object>();
		params.put("workFlowType","CONTRACT_SIGN");
		//params.put("ContractSignId",ccs.getContractSignId());
		activitiStartService.start(requestContext,cs,params);

		HlsCusConContractSign contractSign = new HlsCusConContractSign();
		contractSign.setContractSignId(ccs.getContractSignId());
		contractSign.setStatus("APPROVING");
		self().updateByPrimaryKeySelective(requestContext,contractSign);

	}

	@Override
	public List<HlsCusConContractSign> queryDetail(IRequest requestContext, HlsCusConContractSign contractSign, int page,
                                                   int pagesize) {
		return mapper.queryDetail(contractSign);
	}

}
