package hls.core.cont.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.cont.dto.ConContractChangeH;
import hls.core.cont.dto.HlsCusConContractChangeReq;
import hls.core.cont.dto.HlsCusConContractTenant;
import hls.core.cont.dto.HlsCusConContractTenantH;
import hls.core.cont.mapper.HlsCusConContractTenantHMapper;
import hls.core.cont.mapper.HlsCusConContractTenantMapper;
import hls.core.cont.service.ConContractChangeCommon;
import hls.core.cont.service.ConContractChangeService;
import hls.core.cont.service.ConContractTenantService;
import hls.core.csh.service.ConContractChangeReqEventService;
import hls.core.hls.service.HlsBeanRefUtilService;
import hls.core.prj.dto.HlsCusPrjProjectTenant;
import hls.core.prj.mapper.HlsCusPrjProjectTenantMapper;
import hls.core.prj.mapper.PrjProjectTenantMapper;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import org.apache.commons.beanutils.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service
@Transactional
public class ConContractTenantServiceImpl extends BaseServiceImpl<HlsCusConContractTenant> implements ConContractTenantService,ConContractChangeCommon{

	private static final String changeName="ConContractTenants";
	private static final String deleteName="tenantsdel";
	private static final String methodName ="getChangeTenantFlag";
	@Autowired
	private HlsCusConContractTenantMapper tenantMapper;
	@Autowired
	private HlsCusConContractTenantHMapper conContractTenantHMapper;
	@Autowired
	private ConContractChangeService changeService;
	@Autowired
	private ConContractChangeReqEventService conContractChangeReqEventService;
	@Autowired
	private HlsCusPrjProjectTenantMapper prjProjectTenantMapper;
	@Autowired
	private HlsBeanRefUtilService hlsBeanRefUtilService;
	@Autowired
	private SysEventService sysEventService;
	
	@Override
	public List<HlsCusConContractTenant> queryDetail(IRequest requestContext, HlsCusConContractTenant contractTenant, int page,int pagesize) {
		PageHelper.startPage(page, pagesize);
		
		return tenantMapper.queryDetail(contractTenant);
	}

	@Override
	public String getChangeName() {
		return changeName;
	}

	@Override
	public Long dispose(IRequest iRequest,ConContractChangeH conContractChangeH, Long changeReqId) {
		List<HlsCusConContractTenant> lists = conContractChangeH.getConContractTenants();
		HlsCusConContractTenant tenant = new HlsCusConContractTenant();
		HlsCusConContractTenantH tenantH=new HlsCusConContractTenantH();
		int count =0;
		for (int i = 0; i < lists.size(); i++) {
			tenant=lists.get(i);
			if(tenant.getContractTenantId()!=null){
				continue;
			}
			count ++;
			
			tenantH = new HlsCusConContractTenantH();
			//tenantH.setChangeReqId(changeReqId);
			tenantH.setContractId(tenant.getContractId());
			tenantH.setTenantBpId(tenant.getTenantBpId());
			tenantH.setTenantBpType(tenant.getTenantBpType());
			tenantH.setDescription(tenant.getDescription());
     		conContractTenantHMapper.insertSelective(tenantH);
//			conContractTenantHMapper.insertConContractTenantH(tenantH);
		}
		if(count == 0){
			HlsCusConContractChangeReq req = new HlsCusConContractChangeReq();
			req.setChangeReqId(changeReqId);
			req = changeService.selectByPrimaryKey(iRequest,req);
			req.setChangeTenantFlag("N");
			changeService.updateByPrimaryKey(iRequest,req);
		}
		// 合同变更-承租人变更-创建 事件
		sysEventService.createEvent(iRequest, lists.get(0).getContractId(), "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_CHANGE_REQ_CHANGE_TENANT_CREATE);

//		conContractChangeReqEventService.conContractChangeReqEvent(iRequest,"CON_CONTRACT_CHANGE_REQ.CHANGE_TENANT.CREATE",changeReqId,lists.get(0).getContractId());
		return tenantH.getContractTenantId();
	}

	@Override
	public void delete(IRequest iRequest,ConContractChangeH conContractChangeH) {
		Long [] code = conContractChangeH.getConContractChangeDeleteArr().getTenantsDel();
		if(code!=null&&code.length!=0){
			for (int i = 0; i < code.length; i++) {
				HlsCusConContractTenant conContractTenant = new HlsCusConContractTenant();
				conContractTenant.setContractTenantId(code[i]);
				conContractTenantHMapper.deleteConContractTenant(conContractTenant);
			}
			return;
		}
	}

	@Override
	public String getDeleteName() {
		return deleteName;
	}

	/* (non-Javadoc)
	 * @see hls.core.cont.service.ConContractChangeCommon#getMethodName()
	 */
	@Override
	public String getMethodName() {
		return methodName;
	}

	/* (non-Javadoc)
	 * @see hls.core.cont.service.ConContractChangeCommon#examineAndApprove()
	 */
	@Override
	public void examineAndApprove(IRequest iRequest,Long changeReqId,Long contractId,String status) throws IllegalAccessException, InvocationTargetException {
		if("APPROVED".equalsIgnoreCase(status)){
			HlsCusConContractTenantH tenantH = new HlsCusConContractTenantH();
			//tenantH.setChangeReqId(changeReqId);
	//		itemH.setContractId(contractId);
	//		itemH.setVenderBpId(bpId);
			HlsCusConContractTenant tenant = new HlsCusConContractTenant();
			tenant.setContractId(contractId);
			List<HlsCusConContractTenantH>  tenantHs= conContractTenantHMapper.select(tenantH);
			List<HlsCusConContractTenant>  tenants = tenantMapper.select(tenant);

			//删除两表的数据：原表删除合同所对应的数据，_h表删除change_req_id对应的数据
			for (int i = 0; i < tenants.size(); i++) {
				tenantMapper.deleteByPrimaryKey(tenants.get(i));
			}
			for (int i = 0; i < tenantHs.size(); i++) {
				conContractTenantHMapper.deleteByPrimaryKey(tenantHs.get(i));
			}
			// 将_h表的记录(conTenantList)插入到原表
			for (HlsCusConContractTenantH i : tenantHs) {
				HlsCusConContractTenant cct = new HlsCusConContractTenant();
				BeanUtils.copyProperties(cct, i);
				cct.setContractId(contractId);
				self().insertSelective(iRequest,cct);
				cct.setLastUpdatedBy((Long)iRequest.getUserId());
				cct.setLastUpdateDate(new Date());
				//tenantMapper.insertConContractTenant(cct);
			}
			// 将原表的记录(conTenantList)插入到_h表
			for (HlsCusConContractTenant i : tenants) {
				HlsCusConContractTenantH ccth = new HlsCusConContractTenantH();
				BeanUtils.copyProperties(ccth, i);
				//ccth.setChangeReqId(changeReqId);
				conContractTenantHMapper.insertSelective(ccth);
				//conContractTenantHMapper.insertConContractTenantH(ccth);
			}
			// 合同变更-承租人变更-确认事件
			sysEventService.createEvent(iRequest, contractId, "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_CHANGE_REQ_CHANGE_TENANT_CONFRIM);

//			conContractChangeReqEventService.conContractChangeReqEvent(iRequest,"CON_CONTRACT_CHANGE_REQ.CHANGE_TENANT.CONFRIM",changeReqId,contractId);
		}else if("CANCEL".equalsIgnoreCase(status)){
			sysEventService.createEvent(iRequest, contractId, "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_CHANGE_REQ_CHANGE_TENANT_CANCEL);

//			conContractChangeReqEventService.conContractChangeReqEvent(iRequest,"CON_CONTRACT_CHANGE_REQ.CHANGE_TENANT.CANCEL",changeReqId,contractId);
		}else
		{
			sysEventService.createEvent(iRequest, contractId, "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_CHANGE_REQ_CHANGE_TENANT_REJECT);

//			conContractChangeReqEventService.conContractChangeReqEvent(iRequest,"CON_CONTRACT_CHANGE_REQ.CHANGE_TENANT.REJECT",changeReqId,contractId);
		}
	}
    public  List<HlsCusConContractTenant> saveTenantFromPrj(IRequest iRequest,Long contractId,Long ProjectId){
		List<HlsCusConContractTenant> conContractTenantList=new ArrayList<>();
        HlsCusPrjProjectTenant prjProjectTenantPara=new HlsCusPrjProjectTenant();
		prjProjectTenantPara.setProjectId(ProjectId);
		List<HlsCusPrjProjectTenant> prjProjectTenantList=prjProjectTenantMapper.prjProjectTenantDetailInfo(prjProjectTenantPara);
		for (int i=0;i<prjProjectTenantList.size();i++){
            HlsCusConContractTenant conContractTenant=new HlsCusConContractTenant();
		    Map<String,String> map=	hlsBeanRefUtilService.getFieldValueMap(prjProjectTenantList.get(i));
			hlsBeanRefUtilService.setFieldValue(conContractTenant,map);
			conContractTenant.setContractId(contractId);
			self().insertSelective(iRequest,conContractTenant);
			conContractTenantList.add(conContractTenant);
		}
		return conContractTenantList;
	}
}

