package hls.core.cont.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.cont.dto.HlsCusConFloatingRateReq;
import hls.core.cont.mapper.HlsCusConFloatingRateReqMapper;
import org.apache.commons.collections.map.HashedMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.cont.dto.ConFloatingRateReq;
import hls.core.cont.service.IConFloatingRateReqService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

@Service
@Transactional(rollbackFor = Exception.class)
public class ConFloatingRateReqServiceImpl extends BaseServiceImpl<HlsCusConFloatingRateReq> implements IConFloatingRateReqService{
    @Autowired
    private HlsCusConFloatingRateReqMapper mapper;
    /*调息头查询方法*/
    public List<HlsCusConFloatingRateReq> queryHeadList(IRequest iRequest, HlsCusConFloatingRateReq dto, int page, int pageSize){
        PageHelper.startPage(page, pageSize);
        Map<String,Object> map = new HashedMap();
        map.put("companyId",dto.getCompanyId());
        map.put("fltReqId",dto.getFltReqId());
        String[]  paramStatus = null;
        if(dto.getStatusList()!=null){
            paramStatus=dto.getStatusList().split("、");
        }
        map.put("statusList",paramStatus);
       return mapper.queryHeadList(map);
    }
}