package hls.core.cont.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.mybatis.util.SqlMapper;
import hls.core.cont.service.CustomSqlService;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;

/**
 * Created by FJM on 2017/4/18.
 */
@Service
public class CustomSqlServiceImpl implements CustomSqlService {
    @Autowired
    @Qualifier("sqlSessionFactory")
    private SqlSessionFactory sqlSessionFactory;

    private final Logger logger = LoggerFactory.getLogger(CustomSqlServiceImpl.class);

    /**
     *  该方法用于执行模板参数对应的sql
     * @param request
     * @param param 该参数
     * @return
     */
    @Transactional(propagation = Propagation.SUPPORTS)
    @Override
    public List<HashMap> excuteSql(IRequest request, HashMap param) {

        String sql;

        if (param.get("sql")!=null){
            sql = (String) param.get("sql");
        }else {
            return Collections.emptyList();
        }

        List<HashMap> preResults;


        StringBuilder str = new StringBuilder(sql);
        String paramName; //定义参数名
        String paramValue; //定义参数值
        while (str.lastIndexOf("{$")>0){    //循环遍历字符串中的${}标示

        paramName = str.subSequence(str.lastIndexOf("{$")+2, str.lastIndexOf("$}")).toString();//获取标示中的参数名

        if(param.get(paramName)!=null) {
            paramValue = param.get(paramName).toString();//从HashMap中将参数取出
        }else{
            paramValue = "null"; //若没有得到该参数的值，则在sql上替换为"null"这样使得sql执行结果为空避免报错
        }

        str.replace(str.lastIndexOf("{$"), str.lastIndexOf("$}")+2,paramValue);

        }
        sql = str.toString();//此处替换${}标签中的变量，生成我们需要的sql

        try (SqlSession sqlSession = sqlSessionFactory.openSession()){//SqlSession是非线程安全的，所以必须在方法中获取

         SqlMapper sqlMapper = new SqlMapper(sqlSession);//SqlMapper类为MyBatis执行sql工具

        preResults = sqlMapper.selectList("<script>\n\t" + sql + "</script>", null,
                    HashMap.class);//第二个参数是object类型可以为一个Map也可以为空，其中Map中的key如果和sql中的#{}标记中的字段一致，则会用map中key对应的value替换值

        return preResults;

        }catch (Throwable e) {
            if (logger.isErrorEnabled()) {
                logger.error(e.getMessage(), e);
            }
        }

        return Collections.emptyList();
    }
}
