package hls.core.csh.components;

import com.hand.hap.core.IRequest;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.service.ConContractService;
import hls.core.sys.event.service.SysEventCommonService;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import org.activiti.engine.delegate.DelegateExecution;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.HashMap;
import java.util.Map;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-08-18
 * Time: 10:41
 */
abstract class AbstractCshEventWithContractHandler implements SysEventCommonService {
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private ConContractService conContractService;

    abstract String getNoticeTitle();

    public String getCurrency(Map<String, Object> params){
        return params.get("currency").toString();
    }

    public String getAmount(Map<String, Object> params){
        return params.get("amount").toString();
    }

    public String getBpName(Map<String, Object> params){
        return params.get("bpName").toString();
    }

    public String getCfName(Map<String, Object> params){
        return params.get("cfName").toString();
    }

    abstract String getMessage(String contractName, String bpName, String cfName, String currency, String amount);

    public String getSourceModel() {
        return SysEventCodeUtil.PROPERTITY_SOURCEMODULE_CSH;
    }

    public String getRelation() {
        return SysEventCodeUtil.PROPERTITY_RELATIONTYPE_P2D;
    }

    public Long getLevel() {
        return 2L;
    }

    @Override
    public String getDocumentCategory() {
        return null;
    }

    @Override
    public void process(IRequest iRequest, Long documentId, String documentCategory, String documentType, Map<String, Object> params) {
        if (params == null) {
            params = new HashMap<>();
        }
        HlsCusConContract conContract = conContractService.squerConContractById(documentId);

        String contractName = conContract.getContractName();

        String message = getMessage(contractName, getBpName(params), getCfName(params), getCurrency(params), getAmount(params));
        params.put("message", message);
        params.put("noticeTitle", getNoticeTitle());
        params.put("level", getLevel());
        params.put("noticeType", "NOTICE");

        sysEventService.eventSave(iRequest, documentId, documentCategory, documentType, getSourceModel(), getEventCode(), getRelation(), params);
    }

    @Override
    public void notice(DelegateExecution delegateExecution, String status) {

    }

}
