package hls.core.csh.components;

import com.hand.hap.core.IRequest;
import hls.core.hls.bp.dto.HlsCusBpMaster;
import hls.core.hls.bp.mapper.HlsBpMasterMapper;
import hls.core.hls.bp.mapper.HlsCusBpMasterMapper;
import hls.core.sys.event.service.SysEventCommonService;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import org.activiti.engine.delegate.DelegateExecution;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.HashMap;
import java.util.Map;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-08-18
 * Time: 10:41
 */
abstract class AbstractCshEventWithTransactionHandler implements SysEventCommonService {
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private HlsCusBpMasterMapper bpCusMasterMapper;

    abstract String getNoticeTitle();

    String getCurrency(Map<String, Object> params) {
        return params.get("currency").toString();
    }

    String getAmount(Map<String, Object> params) {
        return params.get("amount").toString();
    }

    abstract String getMessage(String bpName, String currency, String amount);

    public String getSourceModel() {
        return SysEventCodeUtil.PROPERTITY_SOURCEMODULE_CSH;
    }

    public String getRelation() {
        return SysEventCodeUtil.PROPERTITY_RELATIONTYPE_P2D;
    }

    public Long getLevel() {
        return 2L;
    }

    @Override
    public String getDocumentCategory() {
        return null;
    }

    @Override
    public void process(IRequest iRequest, Long documentId, String documentCategory, String documentType, Map<String, Object> params) {
        if (params == null) {
            params = new HashMap<>();
        }

        HlsCusBpMaster hlsCusBpMaster = new HlsCusBpMaster();
        hlsCusBpMaster.setBpId(documentId);
        hlsCusBpMaster = bpCusMasterMapper.selectByPrimaryKey(hlsCusBpMaster);

        String bpName = hlsCusBpMaster.getBpName();

        String message = getMessage(bpName, getCurrency(params), getAmount(params));
        params.put("message", message);
        params.put("noticeTitle", getNoticeTitle());
        params.put("level", getLevel());
        params.put("noticeType", "NOTICE");

        sysEventService.eventSave(iRequest, documentId, documentCategory, documentType, getSourceModel(), getEventCode(), getRelation(), params);
    }

    @Override
    public void notice(DelegateExecution delegateExecution, String status) {

    }

}
