package hls.core.csh.components;

import hls.core.sys.event.utils.SysEventCodeUtil;
import org.springframework.stereotype.Component;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-08-18
 * Time: 13:51
 */
@Component
public class CshWriteoffPaymentDebtEventHandler extends AbstractCshEventWithContractHandler {
    @Override
    String getNoticeTitle() {
        return "付款核销";
    }

    @Override
    String getMessage(String contractName, String bpName, String cfName, String currency, String amount) {
        return "已支付 " + contractName + "(" + bpName + ")" + cfName + currency + " " + amount;
    }

    @Override
    public String getEventCode() {
        return SysEventCodeUtil.PROPERTY_CSH_WRITE_OFF_PAYMENT_DEBT;
    }
}
