package hls.core.csh.controllers;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.hand.hap.excel.dto.ColumnInfo;
import com.hand.hap.excel.dto.ExportConfig;
import com.hand.hap.excel.service.IExportService;
import hls.core.csh.dto.HlsCusAging;
import hls.core.rpt.service.IRptReportGetDataService;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.csh.service.IAgingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.util.List;

    @Controller
    public class AgingController extends BaseController{

        @Autowired
        private IAgingService service;
        @Qualifier("agingServiceImpl")
        @Autowired
        private IRptReportGetDataService service2;
        @Autowired
        ObjectMapper objectMapper;

        @Autowired
        IExportService excelService;

        /*查询报表数据*/
    @RequestMapping(value = "/rpt310/aging/query")
    @ResponseBody
    public ResponseData query(HlsCusAging dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long companyId = (Long) session.getAttribute("companyId");
        dto.setCompanyId(companyId);
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.queryResult(dto));
    }
//    /*测试job执行*/
//    @RequestMapping(value = "/rpt310/aging/test")
//    public void test(HlsCusAging dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
//                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request,HttpSession session) {
//        Long companyId = (Long) session.getAttribute("companyId");
//        dto.setCompanyId(companyId);
//        IRequest requestContext = createRequestContext(request);
//        RptReportHd dto2 = new RptReportHd();
//        dto2.setCompanyId(dto.getCompanyId());
//        dto2.setReportDtlId(dto.getReportDtlId());
//        service2.tempData(requestContext,dto2);
//    }

    @RequestMapping(value = "/rpt310/aging/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<HlsCusAging> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/rpt310/aging/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusAging> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    /*导出数据*/
    @RequestMapping(value="/rpt310/aging/exportInfo")
    public void  queryExportInfo(HlsCusAging dto, HttpServletRequest request, HttpServletResponse httpServletResponse, @RequestParam String config){
        IRequest requestContext = createRequestContext(request);
        try {
			com.fasterxml.jackson.databind.JavaType type = objectMapper.getTypeFactory().constructParametrizedType(ExportConfig.class,
					ExportConfig.class, HlsCusAging.class, ColumnInfo.class);
			ExportConfig<HlsCusAging, ColumnInfo> exportConfig = objectMapper.readValue(config, type);
			excelService.exportAndDownloadExcel("hls.core.csh.mapper.HlsCusAgingMapper.queryExportInfo",
					exportConfig, request, httpServletResponse, requestContext);
		} catch (IOException e) {
			e.printStackTrace();
		}
    }

    }