package hls.core.csh.controllers;

import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.dto.HlsCusConContractCashflowH;
import hls.core.cont.dto.HlsCusConContractH;
import hls.core.csh.service.ConContractCashflowHService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.*;

/**
 * @Title: ConContractCashflowHController
 * @Description:
 * @Company:
 * @author: syj
 * @date 2017年2月27日14:05:43
 *
 */
@Controller
public class ConContractCashflowHController extends BaseController {

	@Autowired
	private ConContractCashflowHService cashflowHService;



	@RequestMapping(value = "/csh/ConContractCashflowH/query", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData selectList(HttpServletRequest request, final HlsCusConContractCashflowH cashflow,
			@RequestParam(defaultValue = DEFAULT_PAGE) final int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
		List<HlsCusConContractCashflowH> list = cashflowHService.selectDetail(cashflow);
		return new ResponseData(list);
	}

	/*调息-查询现金流对比信息*/
	@RequestMapping(value = "/csh/ConContractCashflowH/queryCashflowCompare")
	@ResponseBody
	public ResponseData queryCashflowCompare(HttpServletRequest  request, @RequestBody(required = false)final HlsCusConContractCashflowH cashflow,
								   @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
								   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
		List<HlsCusConContractCashflowH> list = cashflowHService.queryCashflowCompare(cashflow,page,pagesize);
		return new ResponseData(list);
	}
    /*合同变更-租赁计划变更-查询历史表中的现金流信息 参数changeReqId versionType*/
	@RequestMapping(value = "/csh/ConContractCashflowH/historyCashflow", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData selectHistoryCashflowByContract(HttpServletRequest request, final HlsCusConContractH conContractH,
								   @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
								   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
		List<HlsCusConContractCashflowH> list = cashflowHService.selectHistoryCashflowByContract(conContractH,page,pagesize);
		return new ResponseData(list);
	}


}
