package hls.core.csh.controllers;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.csh.dto.HlsCusConContractCashflow;
import hls.core.csh.dto.HlsCusConDebtExemptionReq;
import hls.core.csh.dto.HlsCusConDebtExemptionReqCf;
import hls.core.csh.service.ConDebtExemptionReqCfService;
import hls.core.csh.service.ConDebtExemptionReqService;
import hls.core.csh.service.IConContractCashflowService;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by haibin on 2017/7/25.
 */
@Controller
public class ConDebtExemptionController extends BaseController{
    @Autowired
    private IConContractCashflowService conContractCashflowService;
    @Autowired
    private ConDebtExemptionReqService conDebtExemptionReqService;
    @Autowired
    private ConDebtExemptionReqCfService conDebtExemptionReqCfService;

    @RequestMapping(value = "/csh/selectCalculateCashflow/query", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData selectCalculateCashflow(HttpServletRequest request,@RequestBody HlsCusConDebtExemptionReq conDebtExemptionReq,
                                   @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
        List<HlsCusConContractCashflow> list = conContractCashflowService.selectCalculateCashflow(conDebtExemptionReq);
        return new ResponseData(list);
    }
    @RequestMapping(value = "/csh/addChangeReq/add", method = RequestMethod.POST)
    @ResponseBody
    public Map<String, Object> addChangeReq(HttpServletRequest request, @RequestBody HlsCusConDebtExemptionReq conDebtExemptionReq, HttpSession session) {
        IRequest iRequest=createRequestContext(request);
        Long companyId=(Long) session.getAttribute("companyId");
        conDebtExemptionReq.setCompanyId(companyId);
        HlsCusConDebtExemptionReq Req = conDebtExemptionReqService.addChangeReq(iRequest,conDebtExemptionReq);
        Map<String, Object> response = new HashMap<String, Object>();
        if (Req.getChangeReqId()!=null){
            response.put("changeReqId", Req.getChangeReqId());
            response.put("success", true);
        }else {
            response.put("success", false);
        }
        return response;
    }
    @RequestMapping(value = "/csh/addChangeReqCf/add", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData addChangeReqCf(HttpServletRequest request, @RequestBody List<HlsCusConContractCashflow> conContractCashflow) {
        IRequest iRequest=createRequestContext(request);
        List<HlsCusConDebtExemptionReqCf> list = conDebtExemptionReqCfService.addChangeReqCf(iRequest,conContractCashflow);
        return new ResponseData(list);
    }
    @RequestMapping(value = "/csh/selectConDebtExemptionReq/query", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData selectConDebtExemptionReq(HttpServletRequest request, @Param("contractId")Long contractId,
                                                  @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                                  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
        IRequest iRequest=createRequestContext(request);
        PageHelper.startPage(page,pagesize);
        List<HlsCusConDebtExemptionReq> list = conDebtExemptionReqService.selectConDebtExemptionReq(iRequest,contractId);
        return new ResponseData(list);
    }
    @RequestMapping(value = "/csh/selectConDebtExemptionReqCf/query", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData selectConDebtExemptionReqCf(HttpServletRequest request,@RequestBody HlsCusConDebtExemptionReqCf conDebtExemptionReqCf,
                                                  @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                                  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
        IRequest iRequest=createRequestContext(request);
        PageHelper.startPage(page,pagesize);
        List<HlsCusConDebtExemptionReqCf> list = conDebtExemptionReqCfService.selectExemptionReqCfById(conDebtExemptionReqCf);
        return new ResponseData(list);
    }
    @RequestMapping(value = "/csh/selectOverdueCashflow/query", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData selectOverdueCashflow(HttpServletRequest request,@RequestBody HlsCusConContractCashflow cashflow,
                                                    @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                                    @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
        IRequest iRequest=createRequestContext(request);
        PageHelper.startPage(page,pagesize);
        List<HlsCusConContractCashflow> list = conDebtExemptionReqCfService.selectOverdueCashflow(cashflow);
        return new ResponseData(list);
    }
}
