package hls.core.csh.controllers;

import hls.core.csh.components.ExcelUtil;
import hls.core.csh.mapper.HlsCusConExecuteMapper;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.csh.dto.HlsCusConExecute;
import hls.core.csh.service.IConExecuteService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.springframework.validation.BindingResult;

import java.io.OutputStream;
import java.text.SimpleDateFormat;
import java.util.List;

        @Controller
        public class ConExecuteController extends BaseController{

        @Autowired
        private IConExecuteService service;

        @Autowired
        private HlsCusConExecuteMapper conExecuteMapper;
        //日期跨度
        @RequestMapping(value = "/rpt/con/execute/dayPeriod")
        @ResponseBody
        public ResponseData dayPeriod(HlsCusConExecute conExecute, HttpSession session) {
            Long companyId = (Long) session.getAttribute("companyId");
            conExecute.setCompanyId(companyId);
            List<HlsCusConExecute> conExecutes = conExecuteMapper.dayPeriod(conExecute);
            return new ResponseData(conExecutes);
        }

        //查询网格数据
        @RequestMapping(value = "/rpt/con/execute/query")
        @ResponseBody
        public ResponseData query(HlsCusConExecute conExecute, HttpSession session) {
            //传入参数（前台的rptdtlid 以及 companyId以及日期）
            Long companyId = (Long) session.getAttribute("companyId");
            conExecute.setCompanyId(companyId);
            List<HlsCusConExecute> templist = conExecuteMapper.dayPeriod(conExecute);
            conExecute.setReleaseDate(templist.get(0).getReleaseDate());
            List<HlsCusConExecute> conExecutes = conExecuteMapper.queryGenerator(conExecute);
            return new ResponseData(conExecutes);
        }
        //投放及应收情况
        @RequestMapping(value = "/rpt/con/execute/payAndReceive")
        @ResponseBody
        public ResponseData payAndReceive(HlsCusConExecute conExecute, HttpSession session) {

            Long companyId = (Long) session.getAttribute("companyId");
            conExecute.setCompanyId(companyId);
            List<HlsCusConExecute> conExecutes = conExecuteMapper.payAndReceive(conExecute);
            return new ResponseData(conExecutes);
        }
        //统计信息，表格1
        @RequestMapping(value = "/rpt/con/execute/conAnalysisInfo")
        @ResponseBody
        public ResponseData conAnalysisInfo(HlsCusConExecute conExecute, HttpSession session) {
            Long companyId = (Long) session.getAttribute("companyId");
            conExecute.setCompanyId(companyId);
            List<HlsCusConExecute> templist = conExecuteMapper.dayPeriod(conExecute);
            conExecute.setReleaseDate(templist.get(0).getReleaseDate());
            List<HlsCusConExecute> conExecutes = conExecuteMapper.conAnalysisInfo(conExecute);
            return new ResponseData(conExecutes);
        }
        //合同信息，表格2
        @RequestMapping(value = "/rpt/con/execute/conInfo")
        @ResponseBody
        public ResponseData conInfo(HlsCusConExecute conExecute, HttpSession session) {
            Long companyId = (Long) session.getAttribute("companyId");
            conExecute.setCompanyId(companyId);
            List<HlsCusConExecute> conExecutes = conExecuteMapper.conInfo(conExecute);
            return new ResponseData(conExecutes);
        }
        //逾期信息，表格3
        @RequestMapping(value = "/rpt/con/execute/overdueInfo")
        @ResponseBody
        public ResponseData overdueInfo(HlsCusConExecute conExecute, HttpSession session) {
            Long companyId = (Long) session.getAttribute("companyId");
            conExecute.setCompanyId(companyId);
            List<HlsCusConExecute> conExecutes = conExecuteMapper.overdueInfo(conExecute);
            return new ResponseData(conExecutes);
        }
        //逾期信息细节，表格3
        @RequestMapping(value = "/rpt/con/execute/overdueDetail")
        @ResponseBody
        public ResponseData overdueDetail(HlsCusConExecute conExecute, HttpSession session) {
            Long companyId = (Long) session.getAttribute("companyId");
            conExecute.setCompanyId(companyId);
            List<HlsCusConExecute> conExecutes = conExecuteMapper.overdueDetail(conExecute);
            return new ResponseData(conExecutes);
        }

        //导出excel
        @RequestMapping(value = "/rpt/con/execute/doExcel")
        @ResponseBody
        public ResponseData doExcel(HlsCusConExecute conExecute, HttpSession session, HttpServletResponse response) {
            Long companyId = (Long) session.getAttribute("companyId");
            List<HlsCusConExecute> list = conExecuteMapper.conInfo(conExecute);

            String fileName =  "合同信息" +System.currentTimeMillis()+".xls"; //文件名
            String sheetName = "合同信息明细";//sheet名
            String []title = new String[]{"合同编号","合同名称","承租人","合同类型","合同状态","项目名称","项目经理","部门",
                    "合同金额","期数","租赁期限","租赁利率","IRR","签约日","起租日",
                    "应投放金额","已投放金额","未投放金额","应收金额","已收金额","未收金额","保证金","管理费","手续费"};//标题
            String [][]values = new String[list.size()][];
            for(int i=0;i<list.size();i++){
                values[i] = new String[title.length];//一维的长度
                HlsCusConExecute obj = list.get(i);
                values[i][0] = obj.getContractNumber();
                values[i][1] = obj.getContractName();
                values[i][2] = obj.getBpName();
                values[i][3] = obj.getDocumentType();
                values[i][4] = obj.getContractStatus();
                values[i][5] = obj.getProjectName();
                values[i][6] = obj.getUserName();
                values[i][7] = obj.getUnitName();
                //"合同金额","期数","租赁期限","租赁利率","IRR",
                values[i][8] = String.valueOf(obj.getFinanceAmount());
                values[i][9] = String.valueOf(obj.getLeaseTimes());
                values[i][10] = String.valueOf(obj.getLeaseTerm());
                values[i][11] = String.valueOf(obj.getIntRate());
                values[i][12] = String.valueOf(obj.getIrr());
                //日期转字符串   "签约日","起租日",
                SimpleDateFormat simpleDateFormat=new SimpleDateFormat("yyyy-MM-dd");
                if(obj.getSignDate()!=null){
                    values[i][13] = simpleDateFormat.format(obj.getSignDate());
                }
                if(obj.getInceptionOfLease()!=null){
                    values[i][14] = simpleDateFormat.format(obj.getInceptionOfLease());
                }
                //"应投放金额","已投放金额","未投放金额","应收金额","已收金额","未收金额","保证金","管理费","手续费"
                if(obj.getConThrow()!=null){
                    values[i][15] = String.valueOf(obj.getConThrow());
                }
                if(obj.getAlreadyThrow()!=null){
                    values[i][16] = String.valueOf(obj.getAlreadyThrow());
                }
                if(obj.getConThrow()!=null && obj.getAlreadyThrow()!=null){
                    values[i][17] = String.valueOf(obj.getConThrow()-obj.getAlreadyThrow());
                }
                if(obj.getConDueAmount()!=null){
                    values[i][18] = String.valueOf(obj.getConDueAmount());
                }
                if(obj.getConAlreadyReceivedAmount()!=null){
                    values[i][19] = String.valueOf(obj.getConAlreadyReceivedAmount());
                }
                if(obj.getConDueAmount()!=null && obj.getConAlreadyReceivedAmount()!=null){
                    values[i][20] = String.valueOf(obj.getConDueAmount()-obj.getConAlreadyReceivedAmount());
                }
                values[i][21] = String.valueOf(obj.getMargin());
                values[i][22] = String.valueOf(obj.getManageAccount());
                values[i][23] = String.valueOf(obj.getServiceCharge());

            }
            HSSFWorkbook wb = ExcelUtil.getHSSFWorkbook(sheetName, title, values, null);
            ExcelUtil excelUtil = new ExcelUtil();
            //将文件存到指定位置
            try {
                excelUtil.setResponseHeader(response, fileName);
                OutputStream os = response.getOutputStream();
                wb.write(os);
                os.flush();
                os.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
            return new ResponseData(list);
        }

        @RequestMapping(value = "/rpt/con/execute/submit")
        @ResponseBody
            public ResponseData update(@RequestBody List<HlsCusConExecute> dto, BindingResult result, HttpServletRequest request){
                getValidator().validate(dto, result);
                if (result.hasErrors()) {
                ResponseData responseData = new ResponseData(false);
                responseData.setMessage(getErrorMessage(result, request));
                return responseData;
            }
            IRequest requestCtx = createRequestContext(request);
            return new ResponseData(service.batchUpdate(requestCtx, dto));
        }

        @RequestMapping(value = "/rpt/con/execute/remove")
        @ResponseBody
        public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusConExecute> dto){
            service.batchDelete(dto);
            return new ResponseData();
        }
    }