package hls.core.csh.controllers;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.csh.dto.HlsCusCshBankAccountBalance;
import hls.core.csh.service.CshBankAccountBalanceService;

@Controller
public class CshBankAccountBalanceController extends BaseController{

	@Autowired
	CshBankAccountBalanceService cshBankAccountBalanceService;
	
	@RequestMapping(value = "/csh/cshBankAccountBalance/query")
	@ResponseBody
	public ResponseData query(HlsCusCshBankAccountBalance cshBankAccountBalance, final HttpServletRequest request, final HttpSession session){
		Long companyId = Long.valueOf(String.valueOf(session.getAttribute("companyId")));
		cshBankAccountBalance.setCompanyId(companyId);
		return new ResponseData(cshBankAccountBalanceService.getAllBankAccountBalance(cshBankAccountBalance));
	}
	
	@RequestMapping(value = "/csh/cshBankAccountBalanceInfo/query")
	@ResponseBody
	public ResponseData infoQuery(HlsCusCshBankAccountBalance cshBankAccountBalance, final HttpServletRequest request){
		return new ResponseData(cshBankAccountBalanceService.getAllBankAccountBalanceInfo(cshBankAccountBalance));
	}
	
	@RequestMapping(value = "/csh/getCurrentAccountInfo/query")
	@ResponseBody
	public ResponseData getCurrentAccountInfo(HlsCusCshBankAccountBalance cshBankAccountBalance, final HttpServletRequest request){
		return new ResponseData(cshBankAccountBalanceService.getCurrentMonthAccountInfo(cshBankAccountBalance));
	}
}
