package hls.core.csh.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.csh.dto.HlsCusCshBank;
import hls.core.csh.dto.HlsCusCshBankAccount;
import hls.core.csh.service.CshBankAccountService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;


@Controller
public class CshBankAccountController extends BaseController{
	
	@Autowired
	private CshBankAccountService cshBankAccountService;
	
	
	/*@RequestMapping(value = "/csh/account/query")
	@ResponseBody
	public ResponseData query(final HlsCusCshBankAccount cshBankAccount, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
							  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		List<HlsCusCshBankAccount> list = cshBankAccountService.select(requestContext, cshBankAccount, page, pagesize);
		return new ResponseData(list);
	}*/


	@RequestMapping(value = "/csh/account/query")
	@ResponseBody
	public ResponseData bankAccountQuery(final HlsCusCshBankAccount cshBankAccount, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
										 @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		List<HlsCusCshBankAccount> list = cshBankAccountService.bankAccountQuery(cshBankAccount);
		return new ResponseData(list);
	}
	
	@RequestMapping(value = "/csh/accountInfo/query")
	@ResponseBody
	public ResponseData selectCshBankAccount(@RequestBody List<Map<String, Object>> map,final HttpSession session){
		
		/*HlsCusCshBankAccount cshBankAccount = new HlsCusCshBankAccount();*/
		Long companyId = Long.valueOf(String.valueOf(session.getAttribute("companyId")));
		
		Map<String, Object> mapInfo = map.get(0) ;
		
		mapInfo.put("companyId", companyId);
		
		List<HlsCusCshBankAccount> list = cshBankAccountService.selectCshBankAccount(mapInfo);
		return new ResponseData(list);
	}

	@RequestMapping(value = "/csh/account/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody final List<HlsCusCshBankAccount> cshBankAccounts, final BindingResult result,
							   final HttpServletRequest request, final HttpSession session){
		IRequest requestContext = createRequestContext(request);
//		    request.getSession().getAttribute("company_id");
		Long companyId = Long.valueOf(String.valueOf(session.getAttribute("companyId")));
		for (HlsCusCshBankAccount cshBankAccount: cshBankAccounts ) {
			cshBankAccount.setCompanyId(companyId);
		}
		return new ResponseData(cshBankAccountService.batchUpdate(requestContext, cshBankAccounts));
	}
	
	@RequestMapping(value = "/csh/account/creditSubmit")
	@ResponseBody
	public ResponseData creditSubmit(@RequestBody(required = false)  List<HlsCusCshBankAccount> cshBankAccounts,
							   final HttpServletRequest request, final HttpSession session){
	        IRequest requestContext = createRequestContext(request);
//		    request.getSession().getAttribute("company_id");
		    Long companyId = Long.valueOf(String.valueOf(session.getAttribute("companyId")));
		for (HlsCusCshBankAccount cshBankAccount: cshBankAccounts ) {
			cshBankAccount.setCompanyId(companyId);
		}
		if(cshBankAccounts.get(0).getBankId()==null){
			for(int i=0; i<cshBankAccounts.size(); i++){
				cshBankAccounts.get(i).setBankId(Long.valueOf(-1));
			}
		}else{
			for(int i=0; i<cshBankAccounts.size(); i++){
				cshBankAccounts.get(i).setBankId(cshBankAccounts.get(0).getBankId());
			}
		}
		return new ResponseData(cshBankAccountService.batchUpdate(requestContext, cshBankAccounts));
	}
	
	@RequestMapping(value = "/csh/account/delete", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusCshBankAccount> cshBankAccounts) {
		cshBankAccountService.batchDelete(cshBankAccounts);
		
		return new ResponseData();
	}

	
	@RequestMapping(value = "/csh/bank/account/info/query")
	@ResponseBody
	public ResponseData bankAccountInfoQuery(final HlsCusCshBankAccount cshBankAccount, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
											 @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		List<HlsCusCshBankAccount> list = cshBankAccountService.bankAccountInfoQuery(cshBankAccount);
		return new ResponseData(list);
	}

	@RequestMapping(value = "/csh/bank/info/query")
	@ResponseBody
	public ResponseData bankInfoQuery(final HlsCusCshBank cshBank, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                      @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		List<HlsCusCshBank> list = cshBankAccountService.bankInfoQuery(cshBank);
		return new ResponseData(list);
	}

	@RequestMapping(value = "/csh/bank/info/queryByBpId")
	@ResponseBody
	public ResponseData bankInfoQuery2(final Long bpId, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
									  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		List<HlsCusCshBank> list = cshBankAccountService.bankInfoQuery2(bpId);
		return new ResponseData(list);
	}


	@RequestMapping(value = "/csh/bank/account/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody HlsCusCshBankAccount cshBankAccount, final BindingResult result,
							   final HttpServletRequest request, final HttpSession session){
		     ResponseData rd = null;
            try {
				IRequest requestContext = createRequestContext(request);
				Long companyId = Long.valueOf(String.valueOf(session.getAttribute("companyId")));
				cshBankAccount.setCompanyId(companyId);
				cshBankAccountService.save(requestContext, cshBankAccount);
				rd = new ResponseData();
			}catch (Exception e){
				// TODO: handle exception
				rd = new ResponseData(false);
				rd.setMessage("账户号不可重复，请重新入");
			}
		    return rd;
	}
	@RequestMapping(value = "/csh/account/queryFinanceBankAccount")
	@ResponseBody
	public ResponseData queryFinanceBankAccount(HlsCusCshBankAccount cshBankAccount, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
										 @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request,HttpSession session){
		Long companyId = Long.valueOf(String.valueOf(session.getAttribute("companyId")));
		cshBankAccount.setCompanyId(companyId);
		List<HlsCusCshBankAccount> list = cshBankAccountService.queryFinanceBankAccount(cshBankAccount,page,pagesize);
		return new ResponseData(list);
	}
	
}
