package hls.core.csh.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.csh.dto.HlsCusCshBank;
import hls.core.csh.service.CshBankService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;


@Controller
public class CshBankController extends BaseController{
	
	@Autowired
	private CshBankService cshBankService;
	
	
	@RequestMapping(value = "/csh/bank/query")
	@ResponseBody
	public ResponseData query(final HlsCusCshBank cshBank, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		List<HlsCusCshBank> list = cshBankService.select(requestContext, cshBank, page, pagesize);
		return new ResponseData(list);
	}
	
	@RequestMapping(value = "/csh/bank/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody final List<HlsCusCshBank> cshBanks, final BindingResult result,
                               final HttpServletRequest request){
	        IRequest requestContext = createRequestContext(request);
	        return new ResponseData(cshBankService.batchUpdate(requestContext, cshBanks));
	}
	
	@RequestMapping(value = "/csh/bank/delete", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusCshBank> cshBanks) {
		cshBankService.batchDelete(cshBanks);
		
		return new ResponseData();
	}

	@RequestMapping(value = "/csh/bank/bankCodeQuery")
	@ResponseBody
	public ResponseData bankCodeQuery(HttpServletRequest request, String bankCode) {
		List<HlsCusCshBank> list =  cshBankService.bankCodeQuery(bankCode);

		return new ResponseData(list);
	}
	
	
}
