package hls.core.csh.controllers;


import java.util.List;

import javax.servlet.http.HttpServletRequest;

import hls.core.csh.dto.HlsCusCshPaymentReqLn;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import com.github.pagehelper.PageHelper;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.csh.service.ICshPaymentReqLnService;

@Controller
public class CshPaymentReqLnControllers extends BaseController{

	@Autowired
	private ICshPaymentReqLnService cshPaymentReqLnService;
	
	@RequestMapping(value = "/csh/CshPaymentReqLn/query")
	@ResponseBody
	public ResponseData selectList(HttpServletRequest request, final HlsCusCshPaymentReqLn cshPaymentReqLn,
			@RequestParam(defaultValue = DEFAULT_PAGE) final int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
		List<HlsCusCshPaymentReqLn> list = cshPaymentReqLnService.selectCshPaymentReqLnByHd(cshPaymentReqLn);
		return new ResponseData(list);
	}
	/**
	 * 查询到付款对象Lov
	 * @param request
	 * @param cshPaymentReqLn
	 * @param page
	 * @param pagesize
	 * @return
	 */
	@RequestMapping(value = "/csh/CshPaymentReqLn/lov/query", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData selectLovList(HttpServletRequest request, final HlsCusCshPaymentReqLn cshPaymentReqLn,
			@RequestParam(defaultValue = DEFAULT_PAGE) final int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
		List<HlsCusCshPaymentReqLn> list = cshPaymentReqLnService.selectLov(cshPaymentReqLn);
		return new ResponseData(list);
	}
	/**
	 * 查询到合同编号Lov
	 * @param request
	 * @param cshPaymentReqLn
	 * @param page
	 * @param pagesize
	 * @return
	 */
	@RequestMapping(value = "/csh/CshPaymentReqLn/lov/Contract/query", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData selectLov(HttpServletRequest request, final HlsCusCshPaymentReqLn cshPaymentReqLn,
			@RequestParam(defaultValue = DEFAULT_PAGE) final int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
		List<HlsCusCshPaymentReqLn> list = cshPaymentReqLnService.selectLovContract(cshPaymentReqLn);
		return new ResponseData(list);
	}
	
	
	@RequestMapping(value = "/csh/CshPaymentReqLnDetail/query", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData select(HttpServletRequest request, final HlsCusCshPaymentReqLn cshPaymentReqLn,
			@RequestParam(defaultValue = DEFAULT_PAGE) final int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
		PageHelper.startPage(page, pagesize);
		return new ResponseData(cshPaymentReqLnService.selectCshPaymentReqLnDetailByLnID(cshPaymentReqLn));
	}
	
	@RequestMapping(value = "/csh/Payment/ln/apply/query", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData queryAll(HttpServletRequest request, final HlsCusCshPaymentReqLn cshPaymentReqLn,
			@RequestParam(defaultValue = DEFAULT_PAGE) final int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
		PageHelper.startPage(page, pagesize);
		return new ResponseData(cshPaymentReqLnService.queryAll(cshPaymentReqLn));
	}
	/**
	 * 付款申请 - 多行 - 明细
	 * @param request
	 * @param cshPaymentReqLn
	 * @param page
	 * @param pagesize
	 * @return
	 */
	@RequestMapping(value = "/csh/Payment/ln/apply/detail/query")
	@ResponseBody
	public ResponseData queryDetail(HttpServletRequest request, final HlsCusCshPaymentReqLn cshPaymentReqLn,
			@RequestParam(defaultValue = DEFAULT_PAGE) final int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
		//PageHelper.startPage(page, pagesize);
		return new ResponseData(cshPaymentReqLnService.queryDetail(cshPaymentReqLn));
	}
	/**
	 * 付款申请 - 单行明细
	 * @param request
	 * @param cshPaymentReqLn
	 * @param page
	 * @param pagesize
	 * @return
	 */
	@RequestMapping(value = "/csh/Payment/ln/one/detail/query", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData queryOneDetail(HttpServletRequest request, final HlsCusCshPaymentReqLn cshPaymentReqLn,
			@RequestParam(defaultValue = DEFAULT_PAGE) final int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
		PageHelper.startPage(page, pagesize);
		return new ResponseData(cshPaymentReqLnService.queryOneDetail(cshPaymentReqLn));
	}

	@RequestMapping(value = "/csh/Payment/ln/query", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData lnQuery(HttpServletRequest request, @RequestBody HlsCusCshPaymentReqLn cshPaymentReqLn,
									   @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
									   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
		PageHelper.startPage(page, pagesize);
		return new ResponseData(cshPaymentReqLnService.selectCshPaymentReqLn(cshPaymentReqLn));
	}
	/*融资模块-还款维护-根据申请头ID获取相关行信息*/
	@RequestMapping(value = "/csh/CshPaymentReqLn/queryByPaymentReqId")
	@ResponseBody
	public ResponseData queryByPaymentReqId(HttpServletRequest request, final HlsCusCshPaymentReqLn cshPaymentReqLn) {
		List<HlsCusCshPaymentReqLn> list = cshPaymentReqLnService.queryByPaymentReqId(cshPaymentReqLn);
		return new ResponseData(list);
	}



}
