package hls.core.csh.controllers;

import hls.core.csh.mapper.HlsCusGatheringMapper;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.csh.dto.HlsCusGathering;
import hls.core.csh.service.IGatheringService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

    @Controller
    public class GatheringController extends BaseController{

    @Autowired
    private IGatheringService service;

    @Autowired
    private HlsCusGatheringMapper gatheringMapper;

    @RequestMapping(value = "/rpt/gathering/query")
    @ResponseBody
    public ResponseData query(HlsCusGathering dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpSession session) {
        //Long companyId = Long.valueOf(String.valueOf(session.getAttribute("companyId")));
        Long companyId = (Long) session.getAttribute("companyId");
        dto.setCompanyId(companyId);
        return new ResponseData(service.queryResult(dto,page,pageSize));
    }

        //导出数据库数据到excel表格
        @RequestMapping(value = "/rpt/gathering/doExcel")
        @ResponseBody
        public ResponseData deExcel(HttpServletRequest request,HlsCusGathering dto){
            IRequest requestCtx = createRequestContext(request);
            //获得图标所示数据
            List<HlsCusGathering> gatherings = gatheringMapper.queryResult(dto);
            return new ResponseData(service.doExcel(gatherings));
        }

    @RequestMapping(value = "/rpt/gathering/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<HlsCusGathering> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/rpt/gathering/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusGathering> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

    }