package hls.core.csh.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.csh.dto.HlsCusTransactionRelation;
import hls.core.csh.service.ITransactionRelationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.springframework.validation.BindingResult;

import java.util.Date;
import java.util.List;

    @Controller
    public class TransactionRelationController extends BaseController{

    @Autowired
    private ITransactionRelationService service;


    @RequestMapping(value = "/csh/transaction/relation/query")
    @ResponseBody
    public ResponseData query(HlsCusTransactionRelation dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/csh/transaction/relation/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusTransactionRelation> dto, BindingResult result, HttpServletRequest request){
    getValidator().validate(dto, result);
    if (result.hasErrors()) {
    ResponseData responseData = new ResponseData(false);
    responseData.setMessage(getErrorMessage(result, request));
    return responseData;
    }
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/csh/transaction/relation/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusTransactionRelation> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
   /*合同提前结清-获取收款信息*/
    @RequestMapping(value = "/csh/transaction/relation/queryTerminationCollectionInfo")
    public ResponseData queryTerminationCollectionInfo(HlsCusTransactionRelation dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request,HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        Long companyId = (Long) session.getAttribute("companyId");
        dto.setCompanyId(companyId);
        return new ResponseData(service.queryTerminationCollectionInfo(dto,page,pageSize));
    }
    /*合同提前结清-修改收款信息*/
    @RequestMapping(value = "/csh/transaction/relation/editTerminationCollectionInfo")
    @ResponseBody
    public ResponseData editTerminationCollectionInfo(@RequestBody List<HlsCusTransactionRelation> list, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        for(HlsCusTransactionRelation item:list){
            item.setRelationDate(new Date());
        }
        return new ResponseData(service.batchUpdate(requestContext,list));
    }
    }