package hls.core.csh.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.hand.hap.core.BaseConstants;
import com.hand.hap.mybatis.annotation.Condition;
import com.hand.hap.system.dto.BaseDTO;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Transient;
import java.util.Date;
import java.util.List;

/**
 * Created by lpc on 2017/9/30.
 */
public class ConContractCashflow extends BaseDTO {
    @Id
    @GeneratedValue
    private Long cashflow_id;//	NUMBER	现金流ID
    private Long contract_id;//	NUMBER	合同ID
    private Long cf_item;//	NUMBER	现金流项目
    private Long cf_type;//	NUMBER	现金流类型
    private String cf_direction;//	VARCHAR2(100) 现金流方向（INFLOW/OUTFLOW）
    private String cf_status;//	VARCHAR2(100) 现金流状态（BLOCK/冻结 、RELEASE/下达、CANCEL/取消）
    private Long times;//	NUMBER 期数
    @JsonFormat(pattern = BaseConstants.DATE_FORMAT)
    private Date due_date;//	DATE 支付日/到期日
    private Date fin_income_date;//	DATE 收入确认日
    private Double due_amount;//	NUMBER 应收金额
    private Double net_due_amount;//	NUMBER 不含税应收金额
    private Double vat_due_amount;//	NUMBER 增值税额
    private Double principal;//	NUMBER 应收本金
    private Double net_principal;//	NUMBER 不含税应收本金
    private Double vat_principal;//	NUMBER 本金增值税额
    private Double interest;//	NUMBER 应收利息
    private Double net_interest;//	NUMBER 不含税应收利息
    private Double vat_interest;//	NUMBER 利息增值税额
    private String write_off_flag;//	VARCHAR2(100) 核销标志（NOT/PARTIAL/FULL）
    private Double received_amount;//	NUMBER 已收金额
    private Double received_principal;//	NUMBER	 已收本金
    private Double received_interest;//	NUMBER 已收利息
    private Date last_received_date;//	DATE 最后收款日
    private Date full_write_off_date;//	DATE 完全核销日
    private String penalty_process_status;// VARCHAR2(100) 罚金处理状态（NORMAL 正常/SUSPEND 暂停计算/EXEMPT 豁免）
    private String billing_status;//	VARCHAR2(100) 开票状态（NOT/PARTIAL/FULL）
    private Double billing_amount;//	NUMBER 开票金额
    private Double billing_principal;//	NUMBER 开票本金
    private Double billing_interest;//	NUMBER 开票利息
    private Long payment_bp_id;//	NUMBER 付款商业伙伴ID
    private String overdueStatus;

    private String generated_source;
    private Long generated_source_doc_id;

    //自定义payment_creates_query.view里面的传输的字段开始
    @Transient
    private String descriptionFlag1;
    @Transient
    private String descriptionFlag2;
    @Transient
    private String descriptionFlag3;
    @Transient
    private String taxAmountFlag1;
    @Transient
    private String taxAmountFlag2;
    @Transient
    private String taxAmountFlag4;
    @Transient
    private String taxAmountFlag3;
    @Transient
    private String accountFrom;
    @Transient
    private String taxAmountTo;
    @Transient
    private String transactionDateFromStr;
    @Transient
    private String transactionDateToStr;
    //自定义payment_creates_query.view里面的传输的字段结束

    @Transient
    private Double amount;//申请金额
    @Transient
    @Condition(operator = LIKE)
    private String contract_name;//合同名称
    @Transient
    private String bankBranchName;//对方账户名
    @Transient
    private String bankAccountNum;//对方账户号
    @Transient
    @Condition(operator = LIKE)
    private String bp_name;//承租人名称
    @Transient
    @Condition(operator = LIKE)
    private String description;//应付项目
    @Transient
    private Double unpaid_amount;//未支付金额
    @Transient
    private String contract_status;//合同状态
    @Transient
    private String due_date_out;//应付日期到
    @Transient
    private String due_date_statop;//应付日期从
    @Transient
    private String bpCode;//付款对象
    @Transient
    private Long company_id; //公司ID
    @Transient
    private Date create_date;


    @Transient
    private String document_type;//单据类型	VARCHAR2(100)
    @Transient
    private String document_category;//单据类别	VARCHAR2(100)
    @Transient
    private String project_id;
    @Transient
    private String quotation_id;
    @Transient
    private String business_type;
    @Transient
    @Condition(operator = LIKE)
    private String contract_number;
    @Transient
    private String lease_channel;
    @Transient
    private String division;
    @Transient
    private Long bank_accout_id;//对方银行卡ID
    @Transient
    private String bank_full_name;// , <!-- 对方银行 -->
    @Transient
    private String bank_branch_name;// ,  <!-- 对方银行支行 -->
    @Transient
    private String cf_item_desc;
    @Transient
    private String cf_item_flag;
    @Transient
    private Double surplus_amount;
    @Transient
    private Double applied_amount;//对于一个合同现金流 已经申请的总金额
    @Transient
    private Double surplus_received_principal;  //剩余本金
    @Transient
    private Double overAmount;
    @Transient
    private Long overDate;

    @Transient
    private Long queryTimeSolt;

    @Transient
    private Double overdueAmount;       // 逾期金额
    @Transient
    private Double ioverdueAmount;     // 未逾期金额
    @Transient
    private Date beginDueDate;     // 应收日期从
    @Transient
    private Date endDueDate;      // 应收日期到
    @Transient
    private int due_diffTime;     // 逾期额度
    @Transient
    private int counts;          // 一张合同下的现金流数

    @Transient
    private String contractInfo;
    @Transient
    private String principalFormat;
    @Transient
    private String interestFormat;

    @Transient
    private String billingAmountFormat;
    @Transient
    private String billingInterestFormat;
    @Transient
    private String billingPrincipalFormat;

    @Transient
    private Long bp_id;//商业伙伴ID
    @Transient
    private Long delayId;//迟延履行金id
    @Transient
    private Long days;
    @Transient
    private Double residueAmount;
    @Transient
    private Long number;
    @Transient
    private Long sumDays;
    @Transient
    private String delayAmountFormat;
    @Transient
    private Double delayReceivedAmount;
    @Transient
    private Double delayOutstandingRental;
    @Transient
    private Long changeReqId;
    @Transient
    private Double exemptionAmount;
    @Transient
    private Double delayDueAmount;
    @Transient
    private Date applyPayDate;
    @Transient
    private String applyAmountLn;
    @Transient
    private String paymentReqStatus;
    @Transient
    private String descriptionLn;
    @Transient
    private String currentStatus;
    @Transient
    private Date reqDate;
    @Transient
    private String reqDescription;
    /*合同变更-提前结清*/
    @Transient
    private Double dueReceiveAmount;//未收金额
    @Transient
    private Double dueReceivePrincipal;//未收本金
    @Transient
    private Double dueReceiveInterest;//未收利息
    @Transient
    private Date settlementDate;//提前结清日期
    @Transient
    private Double fee;//结清手续费
    @Transient
    private String writeOffFlagDesc;//核销标志中文描述
    @Transient
    private String checkStatus;//提前结清的流程状态
    @Transient
    private String documentCategoryDesc;
    //付款申请行抵扣记录
    @Transient
    private List<HlsCusCshPaymentReqDt> cshPaymentReqDts;
    @Transient
    private String cfTypeDesc;

    public String getCfTypeDesc() {
        return cfTypeDesc;
    }

    public void setCfTypeDesc(String cfTypeDesc) {
        this.cfTypeDesc = cfTypeDesc;
    }

    public List<HlsCusCshPaymentReqDt> getCshPaymentReqDts() {
        return cshPaymentReqDts;
    }

    public void setCshPaymentReqDts(List<HlsCusCshPaymentReqDt> cshPaymentReqDts) {
        this.cshPaymentReqDts = cshPaymentReqDts;
    }

    public String getDocumentCategoryDesc() {
        return documentCategoryDesc;
    }

    public void setDocumentCategoryDesc(String documentCategoryDesc) {
        this.documentCategoryDesc = documentCategoryDesc;
    }

    public String getCheckStatus() {
        return checkStatus;
    }

    public void setCheckStatus(String checkStatus) {
        this.checkStatus = checkStatus;
    }

    public String getWriteOffFlagDesc() {
        return writeOffFlagDesc;
    }

    public void setWriteOffFlagDesc(String writeOffFlagDesc) {
        this.writeOffFlagDesc = writeOffFlagDesc;
    }

    public Double getFee() {
        return fee;
    }

    public void setFee(Double fee) {
        this.fee = fee;
    }

    public Date getSettlementDate() {
        return settlementDate;
    }

    public void setSettlementDate(Date settlementDate) {
        this.settlementDate = settlementDate;
    }

    public Double getDueReceiveAmount() {
        return dueReceiveAmount;
    }

    public void setDueReceiveAmount(Double dueReceiveAmount) {
        this.dueReceiveAmount = dueReceiveAmount;
    }

    public Double getDueReceivePrincipal() {
        return dueReceivePrincipal;
    }

    public void setDueReceivePrincipal(Double dueReceivePrincipal) {
        this.dueReceivePrincipal = dueReceivePrincipal;
    }

    public Double getDueReceiveInterest() {
        return dueReceiveInterest;
    }

    public void setDueReceiveInterest(Double dueReceiveInterest) {
        this.dueReceiveInterest = dueReceiveInterest;
    }

    public Date getReqDate() {
        return reqDate;
    }

    public void setReqDate(Date reqDate) {
        this.reqDate = reqDate;
    }

    public String getReqDescription() {
        return reqDescription;
    }

    public void setReqDescription(String reqDescription) {
        this.reqDescription = reqDescription;
    }

    public String getCurrentStatus() {
        return currentStatus;
    }

    public void setCurrentStatus(String currentStatus) {
        this.currentStatus = currentStatus;
    }

    public Date getApplyPayDate() {
        return applyPayDate;
    }

    public void setApplyPayDate(Date applyPayDate) {
        this.applyPayDate = applyPayDate;
    }

    public String getApplyAmountLn() {
        return applyAmountLn;
    }

    public void setApplyAmountLn(String applyAmountLn) {
        this.applyAmountLn = applyAmountLn;
    }

    public String getPaymentReqStatus() {
        return paymentReqStatus;
    }

    public void setPaymentReqStatus(String paymentReqStatus) {
        this.paymentReqStatus = paymentReqStatus;
    }

    public String getDescriptionLn() {
        return descriptionLn;
    }

    public void setDescriptionLn(String descriptionLn) {
        this.descriptionLn = descriptionLn;
    }

    public Double getDelayDueAmount() {
        return delayDueAmount;
    }

    public void setDelayDueAmount(Double delayDueAmount) {
        this.delayDueAmount = delayDueAmount;
    }
    @Transient
    private String mergeRentalFlag;
    @Transient
    private Long bsCfItem;
    @Transient
    private int vatModifyFlag ;

    public int getVatModifyFlag() {
        return vatModifyFlag;
    }

    public void setVatModifyFlag(int vatModifyFlag) {
        this.vatModifyFlag = vatModifyFlag;
    }

    public String getMergeRentalFlag() {
        return mergeRentalFlag;
    }

    public void setMergeRentalFlag(String mergeRentalFlag) {
        this.mergeRentalFlag = mergeRentalFlag;
    }

    public Long getBsCfItem() {
        return bsCfItem;
    }

    public void setBsCfItem(Long bsCfItem) {
        this.bsCfItem = bsCfItem;
    }

    public Long getChangeReqId() {
        return changeReqId;
    }

    public void setChangeReqId(Long changeReqId) {
        this.changeReqId = changeReqId;
    }

    public Double getExemptionAmount() {
        return exemptionAmount;
    }

    public void setExemptionAmount(Double exemptionAmount) {
        this.exemptionAmount = exemptionAmount;
    }

    public Long getNumber() {
        return number;
    }

    public void setNumber(Long number) {
        this.number = number;
    }

    public Long getSumDays() {
        return sumDays;
    }

    public void setSumDays(Long sumDays) {
        this.sumDays = sumDays;
    }

    public String getDelayAmountFormat() {
        return delayAmountFormat;
    }

    public void setDelayAmountFormat(String delayAmountFormat) {
        this.delayAmountFormat = delayAmountFormat;
    }

    public Double getDelayReceivedAmount() {
        return delayReceivedAmount;
    }

    public void setDelayReceivedAmount(Double delayReceivedAmount) {
        this.delayReceivedAmount = delayReceivedAmount;
    }

    public Double getDelayOutstandingRental() {
        return delayOutstandingRental;
    }

    public void setDelayOutstandingRental(Double delayOutstandingRental) {
        this.delayOutstandingRental = delayOutstandingRental;
    }

    public Double getResidueAmount() {
        return residueAmount;
    }

    public void setResidueAmount(Double residueAmount) {
        this.residueAmount = residueAmount;
    }

    public Long getDays() {
        return days;
    }

    public void setDays(Long days) {
        this.days = days;
    }

    public Long getDelayId() {
        return delayId;
    }

    public void setDelayId(Long delayId) {
        this.delayId = delayId;
    }

    public String getGenerated_source() {
        return generated_source;
    }

    public void setGenerated_source(String generated_source) {
        this.generated_source = generated_source;
    }

    public Long getGenerated_source_doc_id() {
        return generated_source_doc_id;
    }

    public void setGenerated_source_doc_id(Long generated_source_doc_id) {
        this.generated_source_doc_id = generated_source_doc_id;
    }

    public Long getBp_id() {
        return bp_id;
    }

    public void setBp_id(Long bp_id) {
        this.bp_id = bp_id;
    }

    public String getPrincipalFormat() {
        return principalFormat;
    }

    public void setPrincipalFormat(String principalFormat) {
        this.principalFormat = principalFormat;
    }

    public String getInterestFormat() {
        return interestFormat;
    }

    public void setInterestFormat(String interestFormat) {
        this.interestFormat = interestFormat;
    }

    public String getBillingAmountFormat() {
        return billingAmountFormat;
    }

    public void setBillingAmountFormat(String billingAmountFormat) {
        this.billingAmountFormat = billingAmountFormat;
    }

    public String getBillingInterestFormat() {
        return billingInterestFormat;
    }

    public void setBillingInterestFormat(String billingInterestFormat) {
        this.billingInterestFormat = billingInterestFormat;
    }

    public String getBillingPrincipalFormat() {
        return billingPrincipalFormat;
    }

    public void setBillingPrincipalFormat(String billingPrincipalFormat) {
        this.billingPrincipalFormat = billingPrincipalFormat;
    }

    @Transient
    private String dueAmountFormat;
    @Transient
    private String surplusAmountFormat;


    public String getDueAmountFormat() {
        return dueAmountFormat;
    }

    public void setDueAmountFormat(String dueAmountFormat) {
        this.dueAmountFormat = dueAmountFormat;
    }

    public String getSurplusAmountFormat() {
        return surplusAmountFormat;
    }

    public void setSurplusAmountFormat(String surplusAmountFormat) {
        this.surplusAmountFormat = surplusAmountFormat;
    }

    @Transient
    private Double overdueAmount1;
    @Transient
    private Double overdueAmount2;
    @Transient
    private Double overdueAmount3;
    @Transient
    private Double overdueAmount4;
    @Transient
    private Double overdueAmount5;
    @Transient
    private Double overInterest;
    @Transient
    private Double overdueAmount6;
    @Transient
    private String documentType;

    @Transient
    private String cf_item_list;
    @Transient
    private Long last_updated_by;
    @Transient
    private Date last_update_date;
    @Transient
    private String operationPerson;//操作人

    @Transient
    private String bank_account_name;
    @Transient
    private String bank_account_num;
    @Transient
    private String bank_name;

    @Transient
    private Date dayEndDate;

    @Transient
    private String invoiceKindDesc;
    @Transient
    private String invoiceKind;

    @Transient
    private String dateFromStr;
    @Transient
    private String dateToStr;

    public String getInvoiceKindDesc() {
        return invoiceKindDesc;
    }

    public void setInvoiceKindDesc(String invoiceKindDesc) {
        this.invoiceKindDesc = invoiceKindDesc;
    }

    public String getInvoiceKind() {
        return invoiceKind;
    }

    public void setInvoiceKind(String invoiceKind) {
        this.invoiceKind = invoiceKind;
    }

    public Date getDayEndDate() {
        return dayEndDate;
    }

    public void setDayEndDate(Date dayEndDate) {
        this.dayEndDate = dayEndDate;
    }
    public String getBank_account_name() {
        return bank_account_name;
    }

    public void setBank_account_name(String bank_account_name) {
        this.bank_account_name = bank_account_name;
    }

    public String getBank_account_num() {
        return bank_account_num;
    }

    public void setBank_account_num(String bank_account_num) {
        this.bank_account_num = bank_account_num;
    }

    public String getBank_name() {
        return bank_name;
    }

    public void setBank_name(String bank_name) {
        this.bank_name = bank_name;
    }

    public String getOperationPerson() {
        return operationPerson;
    }

    public void setOperationPerson(String operationPerson) {
        this.operationPerson = operationPerson;
    }

    public Long getLast_updated_by() {
        return last_updated_by;
    }

    public void setLast_updated_by(Long last_updated_by) {
        this.last_updated_by = last_updated_by;
    }

    public Date getLast_update_date() {
        return last_update_date;
    }

    public void setLast_update_date(Date last_update_date) {
        this.last_update_date = last_update_date;
    }

    public String getCf_item_list() {
        return cf_item_list;
    }

    public void setCf_item_list(String cf_item_list) {
        this.cf_item_list = cf_item_list;
    }

    public String getNot_cf_item_list() {
        return not_cf_item_list;
    }

    public void setNot_cf_item_list(String not_cf_item_list) {
        this.not_cf_item_list = not_cf_item_list;
    }

    @Transient
    private String not_cf_item_list;
    @Transient
    private Long count;

    public Long getCount() {
        return count;
    }

    public void setCount(Long count) {
        this.count = count;
    }

    public String getOverdueStatus() {
        return overdueStatus;
    }

    public void setOverdueStatus(String overdueStatus) {
        this.overdueStatus = overdueStatus!=null?overdueStatus.toUpperCase():overdueStatus;
    }

    public Long getQueryTimeSolt() {
        return queryTimeSolt;
    }

    public void setQueryTimeSolt(Long queryTimeSolt) {
        this.queryTimeSolt = queryTimeSolt;
    }

    public Double getOverAmount() {
        return overAmount;
    }

    public void setOverAmount(Double overAmount) {
        this.overAmount = overAmount;
    }

    public Long getOverDate() {
        return overDate;
    }

    public void setOverDate(Long overDate) {
        this.overDate = overDate;
    }

    public Double getOverInterest() {
        return overInterest;
    }

    public void setOverInterest(Double overInterest) {
        this.overInterest = overInterest;
    }

    public int getCounts() {
        return counts;
    }

    public void setCounts(int counts) {
        this.counts = counts;
    }

    public Double getOverdueAmount() {
        return overdueAmount;
    }

    public void setOverdueAmount(Double overdueAmount) {
        this.overdueAmount = overdueAmount;
    }

    public Double getIoverdueAmount() {
        return ioverdueAmount;
    }

    public void setIoverdueAmount(Double ioverdueAmount) {
        this.ioverdueAmount = ioverdueAmount;
    }

    public Date getBeginDueDate() {
        return beginDueDate;
    }

    public void setBeginDueDate(Date beginDueDate) {
        this.beginDueDate = beginDueDate;
    }

    public Date getEndDueDate() {
        return endDueDate;
    }

    public void setEndDueDate(Date endDueDate) {
        this.endDueDate = endDueDate;
    }

    public int getDue_diffTime() {
        return due_diffTime;
    }

    public void setDue_diffTime(int due_diffTime) {
        this.due_diffTime = due_diffTime;
    }

    public String getContractInfo() {
        return contractInfo;
    }

    public void setContractInfo(String contractInfo) {
        this.contractInfo = contractInfo;
    }

    public String getDocumentType() {
        return documentType;
    }

    public void setDocumentType(String documentType) {
        this.documentType = documentType;
    }

    public Double getOverdueAmount1() {
        return overdueAmount1;
    }

    public void setOverdueAmount1(Double overdueAmount1) {
        this.overdueAmount1 = overdueAmount1;
    }

    public Double getOverdueAmount2() {
        return overdueAmount2;
    }

    public void setOverdueAmount2(Double overdueAmount2) {
        this.overdueAmount2 = overdueAmount2;
    }

    public Double getOverdueAmount3() {
        return overdueAmount3;
    }

    public void setOverdueAmount3(Double overdueAmount3) {
        this.overdueAmount3 = overdueAmount3;
    }

    public Double getOverdueAmount4() {
        return overdueAmount4;
    }

    public void setOverdueAmount4(Double overdueAmount4) {
        this.overdueAmount4 = overdueAmount4;
    }

    public Double getOverdueAmount5() {
        return overdueAmount5;
    }

    public void setOverdueAmount5(Double overdueAmount5) {
        this.overdueAmount5 = overdueAmount5;
    }

    public Double getOverdueAmount6() {
        return overdueAmount6;
    }

    public void setOverdueAmount6(Double overdueAmount6) {
        this.overdueAmount6 = overdueAmount6;
    }

    public Double getSurplus_received_principal() {
        return surplus_received_principal;
    }

    public void setSurplus_received_principal(Double surplus_received_principal) {
        this.surplus_received_principal = surplus_received_principal;
    }

    public Date getCreate_date() {
        return create_date;
    }

    public void setCreate_date(Date create_date) {
        this.create_date = create_date;
    }

    public String getCf_item_desc() {
        return cf_item_desc;
    }

    public void setCf_item_desc(String cf_item_desc) {
        this.cf_item_desc = cf_item_desc;
    }

    /**
     * @return the bank_full_name
     */
    public String getBank_full_name() {
        return bank_full_name;
    }

    /**
     * @param bank_full_name the bank_full_name to set
     */
    public void setBank_full_name(String bank_full_name) {
        this.bank_full_name = bank_full_name;
    }

    /**
     * @return the bank_branch_name
     */
    public String getBank_branch_name() {
        return bank_branch_name;
    }

    /**
     * @param bank_branch_name the bank_branch_name to set
     */
    public void setBank_branch_name(String bank_branch_name) {
        this.bank_branch_name = bank_branch_name;
    }

    /**
     * @return the bank_accout_id
     */
    public Long getBank_accout_id() {
        return bank_accout_id;
    }

    /**
     * @param bank_accout_id the bank_accout_id to set
     */
    public void setBank_accout_id(Long bank_accout_id) {
        this.bank_accout_id = bank_accout_id;
    }

    /**
     * @return the project_id
     */
    public String getProject_id() {
        return project_id;
    }

    /**
     * @param project_id the project_id to set
     */
    public void setProject_id(String project_id) {
        this.project_id = project_id;
    }

    /**
     * @return the quotation_id
     */
    public String getQuotation_id() {
        return quotation_id;
    }

    /**
     * @param quotation_id the quotation_id to set
     */
    public void setQuotation_id(String quotation_id) {
        this.quotation_id = quotation_id;
    }

    /**
     * @return the business_type
     */
    public String getBusiness_type() {
        return business_type;
    }

    /**
     * @param business_type the business_type to set
     */
    public void setBusiness_type(String business_type) {
        this.business_type = business_type;
    }

    /**
     * @return the contract_number
     */
    public String getContract_number() {
        return contract_number;
    }

    /**
     * @param contract_number the contract_number to set
     */
    public void setContract_number(String contract_number) {
        this.contract_number = contract_number;
    }

    /**
     * @return the lease_channel
     */
    public String getLease_channel() {
        return lease_channel;
    }

    /**
     * @param lease_channel the lease_channel to set
     */
    public void setLease_channel(String lease_channel) {
        this.lease_channel = lease_channel;
    }

    /**
     * @return the division
     */
    public String getDivision() {
        return division;
    }

    /**
     * @param division the division to set
     */
    public void setDivision(String division) {
        this.division = division;
    }

    /**
     * @return the document_type
     */
    public String getDocument_type() {
        return document_type;
    }

    /**
     * @param document_type the document_type to set
     */
    public void setDocument_type(String document_type) {
        this.document_type = document_type;
    }

    /**
     * @return the document_category
     */
    public String getDocument_category() {
        return document_category;
    }

    /**
     * @param document_category the document_category to set
     */
    public void setDocument_category(String document_category) {
        this.document_category = document_category;
    }

    /**
     * @return the company_id
     */
    public Long getCompany_id() {
        return company_id;
    }

    /**
     * @param company_id the company_id to set
     */
    public void setCompany_id(Long company_id) {
        this.company_id = company_id;
    }

    /**
     * @return the bpCode
     */
    public String getBpCode() {
        return bpCode;
    }

    /**
     * @param bpCode the bpCode to set
     */
    public void setBpCode(String bpCode) {
        this.bpCode = bpCode;
    }

    /**
     * @return the due_date_out
     */
    public String getDue_date_out() {
        return due_date_out;
    }

    /**
     * @param due_date_out the due_date_out to set
     */
    public void setDue_date_out(String due_date_out) {
        this.due_date_out = due_date_out;
    }

    /**
     * @return the due_date_statop
     */
    public String getDue_date_statop() {
        return due_date_statop;
    }

    /**
     * @param due_date_statop the due_date_statop to set
     */
    public void setDue_date_statop(String due_date_statop) {
        this.due_date_statop = due_date_statop;
    }

    /**
     * @return the contract_status
     */
    public String getContract_status() {
        return contract_status;
    }

    /**
     * @param contract_status the contract_status to set
     */
    public void setContract_status(String contract_status) {
        this.contract_status = contract_status;
    }

    /**
     * @return the contract_name
     */
    public String getContract_name() {
        return contract_name;
    }

    /**
     * @param contract_name the contract_name to set
     */
    public void setContract_name(String contract_name) {
        this.contract_name = contract_name;
    }

    /**
     * @return the bankBranchName
     */
    public String getBankBranchName() {
        return bankBranchName;
    }

    /**
     * @param bankBranchName the bankBranchName to set
     */
    public void setBankBranchName(String bankBranchName) {
        this.bankBranchName = bankBranchName;
    }

    /**
     * @return the bankAccountNum
     */
    public String getBankAccountNum() {
        return bankAccountNum;
    }

    /**
     * @param bankAccountNum the bankAccountNum to set
     */
    public void setBankAccountNum(String bankAccountNum) {
        this.bankAccountNum = bankAccountNum;
    }

    /**
     * @return the bp_name
     */
    public String getBp_name() {
        return bp_name;
    }

    /**
     * @param bp_name the bp_name to set
     */
    public void setBp_name(String bp_name) {
        this.bp_name = bp_name;
    }

    /**
     * @return the description
     */
    public String getDescription() {
        return description;
    }

    /**
     * @param description the description to set
     */
    public void setDescription(String description) {
        this.description = description;
    }

    /**
     * @return the cashflow_id
     */
    public Long getCashflow_id() {
        return cashflow_id;
    }

    /**
     * @param cashflow_id the cashflow_id to set
     */
    public void setCashflow_id(Long cashflow_id) {
        this.cashflow_id = cashflow_id;
    }

    /**
     * @return the contract_id
     */
    public Long getContract_id() {
        return contract_id;
    }

    /**
     * @param contract_id the contract_id to set
     */
    public void setContract_id(Long contract_id) {
        this.contract_id = contract_id;
    }

    /**
     * @return the cf_item
     */
    public Long getCf_item() {
        return cf_item;
    }

    /**
     * @param cf_item the cf_item to set
     */
    public void setCf_item(Long cf_item) {
        this.cf_item = cf_item;
    }

    /**
     * @return the cf_type
     */
    public Long getCf_type() {
        return cf_type;
    }

    /**
     * @param cf_type the cf_type to set
     */
    public void setCf_type(Long cf_type) {
        this.cf_type = cf_type;
    }

    /**
     * @return the cf_direction
     */
    public String getCf_direction() {
        return cf_direction;
    }

    /**
     * @param cf_direction the cf_direction to set
     */
    public void setCf_direction(String cf_direction) {
        this.cf_direction = cf_direction;
    }

    /**
     * @return the cf_status
     */
    public String getCf_status() {
        return cf_status;
    }

    /**
     * @param cf_status the cf_status to set
     */
    public void setCf_status(String cf_status) {
        this.cf_status = cf_status;
    }

    /**
     * @return the times
     */
    public Long getTimes() {
        return times;
    }

    /**
     * @param times the times to set
     */
    public void setTimes(Long times) {
        this.times = times;
    }

    /**
     * @return the due_date
     */
    public Date getDue_date() {
        return due_date;
    }

    /**
     * @param due_date the due_date to set
     */
    public void setDue_date(Date due_date) {
        this.due_date = due_date;
    }

    /**
     * @return the fin_income_date
     */
    public Date getFin_income_date() {
        return fin_income_date;
    }

    /**
     * @param fin_income_date the fin_income_date to set
     */
    public void setFin_income_date(Date fin_income_date) {
        this.fin_income_date = fin_income_date;
    }

    /**
     * @return the write_off_flag
     */
    public String getWrite_off_flag() {
        return write_off_flag;
    }

    /**
     * @param write_off_flag the write_off_flag to set
     */
    public void setWrite_off_flag(String write_off_flag) {
        this.write_off_flag = write_off_flag;
    }

    /**
     * @return the last_received_date
     */
    public Date getLast_received_date() {
        return last_received_date;
    }

    /**
     * @param last_received_date the last_received_date to set
     */
    public void setLast_received_date(Date last_received_date) {
        this.last_received_date = last_received_date;
    }

    /**
     * @return the full_write_off_date
     */
    public Date getFull_write_off_date() {
        return full_write_off_date;
    }

    /**
     * @param full_write_off_date the full_write_off_date to set
     */
    public void setFull_write_off_date(Date full_write_off_date) {
        this.full_write_off_date = full_write_off_date;
    }

    /**
     * @return the penalty_process_status
     */
    public String getPenalty_process_status() {
        return penalty_process_status;
    }

    /**
     * @param penalty_process_status the penalty_process_status to set
     */
    public void setPenalty_process_status(String penalty_process_status) {
        this.penalty_process_status = penalty_process_status;
    }

    /**
     * @return the billing_status
     */
    public String getBilling_status() {
        return billing_status;
    }

    /**
     * @param billing_status the billing_status to set
     */
    public void setBilling_status(String billing_status) {
        this.billing_status = billing_status;
    }

    /**
     * @return the payment_bp_id
     */
    public Long getPayment_bp_id() {
        return payment_bp_id;
    }

    /**
     * @param payment_bp_id the payment_bp_id to set
     */
    public void setPayment_bp_id(Long payment_bp_id) {
        this.payment_bp_id = payment_bp_id;
    }

    //自定义payment_creates_query.view页面字段get/set开始
    public String getDescriptionFlag1() {
        return descriptionFlag1;
    }

    public String getDescriptionFlag2() {
        return descriptionFlag2;
    }

    public String getDescriptionFlag3() {
        return descriptionFlag3;
    }

    public String getTaxAmountFlag1() {
        return taxAmountFlag1;
    }

    public String getTaxAmountFlag2() {
        return taxAmountFlag2;
    }

    public String getTaxAmountFlag3() {
        return taxAmountFlag3;
    }

    public String getAccountFrom() {
        return accountFrom;
    }

    public String getTaxAmountTo() {
        return taxAmountTo;
    }

    public String getTransactionDateFromStr() {
        return transactionDateFromStr;
    }

    public String getTransactionDateToStr() {
        return transactionDateToStr;
    }

    public String getTaxAmountFlag4() {
        return taxAmountFlag4;
    }

    public void setTaxAmountFlag4(String taxAmountFlag4) {
        this.taxAmountFlag4 = taxAmountFlag4;
    }

    public void setDescriptionFlag1(String descriptionFlag1) {
        this.descriptionFlag1 = descriptionFlag1;
    }

    public void setDescriptionFlag2(String descriptionFlag2) {
        this.descriptionFlag2 = descriptionFlag2;
    }

    public void setDescriptionFlag3(String descriptionFlag3) {
        this.descriptionFlag3 = descriptionFlag3;
    }

    public void setTaxAmountFlag1(String taxAmountFlag1) {
        this.taxAmountFlag1 = taxAmountFlag1;
    }

    public void setTaxAmountFlag2(String taxAmountFlag2) {
        this.taxAmountFlag2 = taxAmountFlag2;
    }

    public void setTaxAmountFlag3(String taxAmountFlag3) {
        this.taxAmountFlag3 = taxAmountFlag3;
    }

    public void setAccountFrom(String accountFrom) {
        this.accountFrom = accountFrom;
    }

    public void setTaxAmountTo(String taxAmountTo) {
        this.taxAmountTo = taxAmountTo;
    }

    public void setTransactionDateFromStr(String transactionDateFromStr) {
        this.transactionDateFromStr = transactionDateFromStr;
    }

    public void setTransactionDateToStr(String transactionDateToStr) {
        this.transactionDateToStr = transactionDateToStr;
    }
    //自定义payment_creates_query.view页面字段get/set结束


    public Double getDue_amount() {
        return due_amount;
    }

    public void setDue_amount(Double due_amount) {
        this.due_amount = due_amount;
    }

    public Double getNet_due_amount() {
        return net_due_amount;
    }

    public void setNet_due_amount(Double net_due_amount) {
        this.net_due_amount = net_due_amount;
    }

    public Double getVat_due_amount() {
        return vat_due_amount;
    }

    public void setVat_due_amount(Double vat_due_amount) {
        this.vat_due_amount = vat_due_amount;
    }

    public Double getPrincipal() {
        return principal;
    }

    public void setPrincipal(Double principal) {
        this.principal = principal;
    }

    public Double getNet_principal() {
        return net_principal;
    }

    public void setNet_principal(Double net_principal) {
        this.net_principal = net_principal;
    }

    public Double getVat_principal() {
        return vat_principal;
    }

    public void setVat_principal(Double vat_principal) {
        this.vat_principal = vat_principal;
    }

    public Double getInterest() {
        return interest;
    }

    public void setInterest(Double interest) {
        this.interest = interest;
    }

    public Double getNet_interest() {
        return net_interest;
    }

    public void setNet_interest(Double net_interest) {
        this.net_interest = net_interest;
    }

    public Double getVat_interest() {
        return vat_interest;
    }

    public void setVat_interest(Double vat_interest) {
        this.vat_interest = vat_interest;
    }

    public Double getReceived_amount() {
        return received_amount;
    }

    public void setReceived_amount(Double received_amount) {
        this.received_amount = received_amount;
    }

    public Double getReceived_principal() {
        return received_principal;
    }

    public void setReceived_principal(Double received_principal) {
        this.received_principal = received_principal;
    }

    public Double getReceived_interest() {
        return received_interest;
    }

    public void setReceived_interest(Double received_interest) {
        this.received_interest = received_interest;
    }

    public Double getBilling_amount() {
        return billing_amount;
    }

    public void setBilling_amount(Double billing_amount) {
        this.billing_amount = billing_amount;
    }

    public Double getBilling_principal() {
        return billing_principal;
    }

    public void setBilling_principal(Double billing_principal) {
        this.billing_principal = billing_principal;
    }

    public Double getBilling_interest() {
        return billing_interest;
    }

    public void setBilling_interest(Double billing_interest) {
        this.billing_interest = billing_interest;
    }

    public Double getAmount() {
        return amount;
    }

    public void setAmount(Double amount) {
        this.amount = amount;
    }

    public Double getUnpaid_amount() {
        return unpaid_amount;
    }

    public void setUnpaid_amount(Double unpaid_amount) {
        this.unpaid_amount = unpaid_amount;
    }

    public Double getSurplus_amount() {
        return surplus_amount;
    }

    public void setSurplus_amount(Double surplus_amount) {
        this.surplus_amount = surplus_amount;
    }

    public String getCf_item_flag() {
        return cf_item_flag;
    }

    public void setCf_item_flag(String cf_item_flag) {
        this.cf_item_flag = cf_item_flag;
    }

    public Double getApplied_amount() {
        return applied_amount;
    }

    public void setApplied_amount(Double applied_amount) {
        this.applied_amount = applied_amount;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        StringBuilder builder = new StringBuilder();
        builder.append("HlsCusConContractCashflow [cashflow_id=").append(cashflow_id).append(", contract_id=")
                .append(contract_id).append(", cf_item=").append(cf_item).append(", cf_type=").append(cf_type)
                .append(", cf_direction=").append(cf_direction).append(", cf_status=").append(cf_status)
                .append(", times=").append(times).append(", due_date=").append(due_date).append(", fin_income_date=")
                .append(fin_income_date).append(", due_amount=").append(due_amount).append(", net_due_amount=")
                .append(net_due_amount).append(", vat_due_amount=").append(vat_due_amount).append(", principal=")
                .append(principal).append(", net_principal=").append(net_principal).append(", vat_principal=")
                .append(vat_principal).append(", interest=").append(interest).append(", net_interest=")
                .append(net_interest).append(", vat_interest=").append(vat_interest).append(", write_off_flag=")
                .append(write_off_flag).append(", received_amount=").append(received_amount)
                .append(", received_principal=").append(received_principal).append(", received_interest=")
                .append(received_interest).append(", last_received_date=").append(last_received_date)
                .append(", full_write_off_date=").append(full_write_off_date).append(", penalty_process_status=")
                .append(penalty_process_status).append(", billing_status=").append(billing_status)
                .append(", billing_amount=").append(billing_amount).append(", billing_principal=")
                .append(billing_principal).append(", billing_interest=").append(billing_interest)
                .append(", payment_bp_id=").append(payment_bp_id).append(", amount=").append(amount)
                .append(", contract_name=").append(contract_name).append(", bankBranchName=").append(bankBranchName)
                .append(", bankAccountNum=").append(bankAccountNum).append(", bp_name=").append(bp_name)
                .append(", description=").append(description).append(", unpaid_amount=").append(unpaid_amount)
                .append(", contract_status=").append(contract_status).append(", due_date_out=").append(due_date_out)
                .append(", due_date_statop=").append(due_date_statop).append(", bpCode=").append(bpCode)
                .append(", company_id=").append(company_id).append(", document_type=").append(document_type)
                .append(", document_category=").append(document_category).append(", project_id=").append(project_id)
                .append(", quotation_id=").append(quotation_id).append(", business_type=").append(business_type)
                .append(", contract_number=").append(contract_number).append(", lease_channel=").append(lease_channel)
                .append(", division=").append(division).append(", bank_accout_id=").append(bank_accout_id)
                .append(", bank_full_name=").append(bank_full_name).append(", bank_branch_name=")
                .append(bank_branch_name).append(", applied_amount=").append(applied_amount).append("]");
        return builder.toString();
    }

    public String getDateFromStr() {
        return dateFromStr;
    }

    public void setDateFromStr(String dateFromStr) {
        this.dateFromStr = dateFromStr;
    }

    public String getDateToStr() {
        return dateToStr;
    }

    public void setDateToStr(String dateToStr) {
        this.dateToStr = dateToStr;
    }
}
