package hls.core.csh.dto;

import com.hand.hap.system.dto.BaseDTO;
import org.hibernate.validator.constraints.Length;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Transient;
import java.util.Date;

/**
 * Created by lpc on 2017/9/30.
 */
public class ConExecute extends BaseDTO {
    @Id
    @GeneratedValue
    private Long rptConExecuteId; //主键

    private Long writeOffId; //核销id
    @Length(max = 200)
    private String reversedFlag;//反冲标志

    private Long cashflowId; //核销id

    private Long reportDtlId; //报表

    private Long contractId; //合同id

    @Length(max = 200)
    private String contractNumber; //合同编号

    public String getReversedFlag() {
        return reversedFlag;
    }

    public void setReversedFlag(String reversedFlag) {
        this.reversedFlag = reversedFlag;
    }

    public String getContractNumber() {
        return contractNumber;
    }

    public void setContractNumber(String contractNumber) {
        this.contractNumber = contractNumber;
    }

    @Length(max = 200)
    private String contractName; //合同名称

    @Length(max = 100)
    private String contractStatus; //合同状态

    @Length(max = 100)
    private String documentType; //合同类型
    private Date signDate;//签约日
    private Date inceptionOfLease;//起租日
    private Double leaseTerm;//租赁期限
    private Double irr; //内部收益率
    private Double intRate; //租赁利率


    public Double getIrr() {
        return irr;
    }

    public void setIrr(Double irr) {
        this.irr = irr;
    }

    public Double getIntRate() {
        return intRate;
    }

    public void setIntRate(Double intRate) {
        this.intRate = intRate;
    }

    private Long cfItem; //现金流项目
    private Long cfType; //现金流项目

    public Long getCfType() {
        return cfType;
    }

    public void setCfType(Long cfType) {
        this.cfType = cfType;
    }

    private Double writeOffDueAmount; //核销金额

    @Length(max = 100)
    private String cfDirection; //现金流方向

    @Length(max = 100)
    private String cfStatus; //现金流状态

    @Length(max = 100)
    private String overdueStatus; //逾期状态

    private Date writeOffDate; //核销时间

    private Long times; //期数

    private Double dueAmount; //应收金额

    private Date dueDate; //应收日期

    private Date lastReceivedDate; //最后收款日

    public Long getPrjCount() {
        return prjCount;
    }

    public void setPrjCount(Long prjCount) {
        this.prjCount = prjCount;
    }

    private Date ccCreationDate; //合同创建日期

    private Long leaseTimes; //租赁期数

    private Long employeeId; //项目经理id

    private Long prjCount;//业务员某段时间项目数

    private Double receivedAmount;//已收金额

    public Double getReceivedAmount() {
        return receivedAmount;
    }

    public void setReceivedAmount(Double receivedAmount) {
        this.receivedAmount = receivedAmount;
    }

    @Length(max = 100)
    private String userName; //员工名

    @Length(max = 200)
    private String bpName; //承租人

    private Long tenantBpId; //承租人id

    private Long projectId; //项目id

    @Length(max = 100)
    private String projectName; //项目名

    private Long unitId; //项目部门id

    @Length(max = 100)
    private String unitName; //项目名

    private Double financeAmount; //合同融资额

    public Double getPrjFinanceAmount() {
        return prjFinanceAmount;
    }

    public void setPrjFinanceAmount(Double prjFinanceAmount) {
        this.prjFinanceAmount = prjFinanceAmount;
    }

    private Double prjFinanceAmount; //项目总融资额（跟项目数一样，带过来）

    private Date releaseDate; //报表发布时间

    private Long companyId; //公司id

    private Long changeCount; //合同变更数量



    //外来字段
    @Transient
    private  Long totalCount;
    @Transient
    private  Long newCount;
    @Transient
    private  Long signCount;
    @Transient
    private  Long cancelCount;
    @Transient
    private  Long inceptCount;
    @Transient
    private  Long terminateCount;
    @Transient
    private  Long changeTocalCount;


    @Transient
    private Double totalThrow;//投放总额
    @Transient
    private Double alreadyThrowCount;//已经投放数量
    @Transient
    private Double alreadyThrow;//已经投放
    @Transient
    private Double totalDueAmount;//应收金额
    @Transient
    private Double alreadyReceivedAmount;//已收金额

    @Transient
    private  Double totalFinanceAmount;//合同总融资额

    @Transient
    private Long conCount;//合同签约数
    //逾期信息
    @Transient
    private  Double totalOverdueAmount;//总逾期金额
    @Transient
    private  Double overdueTimes;//m
    @Transient
    private  Double avgOverdueDates;//m
    @Transient
    private  Double MaxOverdueDates;//a
    @Transient
    private  Double totalOverdueDates;//t

    //逾期天数
    @Transient
    private Long perOverdueDate;//每个合同逾期细节

    //合同已收，已投情况
    @Transient
    private Double conThrow;//合同投放总额
    @Transient
    private Double conAlreadyThrow;//合同已经投放
    @Transient
    private Double conDueAmount;//合同应收金额
    @Transient
    private Double conAlreadyReceivedAmount;//合同已收金额
    @Transient
    private Double margin;//保证金
    @Transient
    private Double serviceCharge;//手续费
    @Transient
    private Double manageAccount;//管理费

    public Double getConThrow() {
        return conThrow;
    }

    public void setConThrow(Double conThrow) {
        this.conThrow = conThrow;
    }

    public Double getConAlreadyThrow() {
        return conAlreadyThrow;
    }

    public void setConAlreadyThrow(Double conAlreadyThrow) {
        this.conAlreadyThrow = conAlreadyThrow;
    }

    public Double getConDueAmount() {
        return conDueAmount;
    }

    public void setConDueAmount(Double conDueAmount) {
        this.conDueAmount = conDueAmount;
    }

    public Double getConAlreadyReceivedAmount() {
        return conAlreadyReceivedAmount;
    }

    public void setConAlreadyReceivedAmount(Double conAlreadyReceivedAmount) {
        this.conAlreadyReceivedAmount = conAlreadyReceivedAmount;
    }

    public Date getSignDate() {
        return signDate;
    }

    public void setSignDate(Date signDate) {
        this.signDate = signDate;
    }

    public Date getInceptionOfLease() {
        return inceptionOfLease;
    }

    public void setInceptionOfLease(Date inceptionOfLease) {
        this.inceptionOfLease = inceptionOfLease;
    }

    public Double getLeaseTerm() {
        return leaseTerm;
    }

    public void setLeaseTerm(Double leaseTerm) {
        this.leaseTerm = leaseTerm;
    }

    public Double getMargin() {
        return margin;
    }

    public void setMargin(Double margin) {
        this.margin = margin;
    }

    public Double getServiceCharge() {
        return serviceCharge;
    }

    public void setServiceCharge(Double serviceCharge) {
        this.serviceCharge = serviceCharge;
    }

    public Double getManageAccount() {
        return manageAccount;
    }

    public void setManageAccount(Double manageAccount) {
        this.manageAccount = manageAccount;
    }

    public Long getPerOverdueDate() {
        return perOverdueDate;
    }

    public void setPerOverdueDate(Long perOverdueDate) {
        this.perOverdueDate = perOverdueDate;
    }


    public Double getTotalOverdueAmount() {
        return totalOverdueAmount;
    }

    public void setTotalOverdueAmount(Double totalOverdueAmount) {
        this.totalOverdueAmount = totalOverdueAmount;
    }

    public Double getOverdueTimes() {
        return overdueTimes;
    }

    public void setOverdueTimes(Double overdueTimes) {
        this.overdueTimes = overdueTimes;
    }

    public Double getAvgOverdueDates() {
        return avgOverdueDates;
    }

    public void setAvgOverdueDates(Double avgOverdueDates) {
        this.avgOverdueDates = avgOverdueDates;
    }

    public Double getMaxOverdueDates() {
        return MaxOverdueDates;
    }

    public void setMaxOverdueDates(Double maxOverdueDates) {
        MaxOverdueDates = maxOverdueDates;
    }

    public Double getTotalOverdueDates() {
        return totalOverdueDates;
    }

    public void setTotalOverdueDates(Double totalOverdueDates) {
        this.totalOverdueDates = totalOverdueDates;
    }

    public Long getConCount() {
        return conCount;
    }

    public void setConCount(Long conCount) {
        this.conCount = conCount;
    }

    public Double getTotalFinanceAmount() {
        return totalFinanceAmount;
    }

    public void setTotalFinanceAmount(Double totalFinanceAmount) {
        this.totalFinanceAmount = totalFinanceAmount;
    }

    public Double getTotalThrow() {
        return totalThrow;
    }

    public void setTotalThrow(Double totalThrow) {
        this.totalThrow = totalThrow;
    }

    public Double getAlreadyThrowCount() {
        return alreadyThrowCount;
    }

    public void setAlreadyThrowCount(Double alreadyThrowCount) {
        this.alreadyThrowCount = alreadyThrowCount;
    }

    public Double getAlreadyThrow() {
        return alreadyThrow;
    }

    public void setAlreadyThrow(Double alreadyThrow) {
        this.alreadyThrow = alreadyThrow;
    }

    public Double getTotalDueAmount() {
        return totalDueAmount;
    }

    public void setTotalDueAmount(Double totalDueAmount) {
        this.totalDueAmount = totalDueAmount;
    }

    public Double getAlreadyReceivedAmount() {
        return alreadyReceivedAmount;
    }

    public void setAlreadyReceivedAmount(Double alreadyReceivedAmount) {
        this.alreadyReceivedAmount = alreadyReceivedAmount;
    }

    public Long getTotalCount() {
        return totalCount;
    }

    public void setTotalCount(Long totalCount) {
        this.totalCount = totalCount;
    }

    public Long getNewCount() {
        return newCount;
    }

    public void setNewCount(Long newCount) {
        this.newCount = newCount;
    }

    public Long getSignCount() {
        return signCount;
    }

    public void setSignCount(Long signCount) {
        this.signCount = signCount;
    }

    public Long getCancelCount() {
        return cancelCount;
    }

    public void setCancelCount(Long cancelCount) {
        this.cancelCount = cancelCount;
    }

    public Long getInceptCount() {
        return inceptCount;
    }

    public void setInceptCount(Long inceptCount) {
        this.inceptCount = inceptCount;
    }

    public Long getTerminateCount() {
        return terminateCount;
    }

    public void setTerminateCount(Long terminateCount) {
        this.terminateCount = terminateCount;
    }

    public Long getChangeTocalCount() {
        return changeTocalCount;
    }

    public void setChangeTocalCount(Long changeTocalCount) {
        this.changeTocalCount = changeTocalCount;
    }


    public void setRptConExecuteId(Long rptConExecuteId){
        this.rptConExecuteId = rptConExecuteId;
    }

    public Long getRptConExecuteId(){
        return rptConExecuteId;
    }

    public void setWriteOffId(Long writeOffId){
        this.writeOffId = writeOffId;
    }

    public Long getWriteOffId(){
        return writeOffId;
    }

    public void setCashflowId(Long cashflowId){
        this.cashflowId = cashflowId;
    }

    public Long getCashflowId(){
        return cashflowId;
    }

    public void setReportDtlId(Long reportDtlId){
        this.reportDtlId = reportDtlId;
    }

    public Long getReportDtlId(){
        return reportDtlId;
    }

    public void setContractId(Long contractId){
        this.contractId = contractId;
    }

    public Long getContractId(){
        return contractId;
    }

    public void setContractName(String contractName){
        this.contractName = contractName;
    }

    public String getContractName(){
        return contractName;
    }

    public void setContractStatus(String contractStatus){
        this.contractStatus = contractStatus;
    }

    public String getContractStatus(){
        return contractStatus;
    }

    public void setDocumentType(String documentType){
        this.documentType = documentType;
    }

    public String getDocumentType(){
        return documentType;
    }

    public void setCfItem(Long cfItem){
        this.cfItem = cfItem;
    }

    public Long getCfItem(){
        return cfItem;
    }

    public void setWriteOffDueAmount(Double writeOffDueAmount){
        this.writeOffDueAmount = writeOffDueAmount;
    }

    public Double getWriteOffDueAmount(){
        return writeOffDueAmount;
    }

    public void setCfDirection(String cfDirection){
        this.cfDirection = cfDirection;
    }

    public String getCfDirection(){
        return cfDirection;
    }

    public void setCfStatus(String cfStatus){
        this.cfStatus = cfStatus;
    }

    public String getCfStatus(){
        return cfStatus;
    }

    public void setOverdueStatus(String overdueStatus){
        this.overdueStatus = overdueStatus;
    }

    public String getOverdueStatus(){
        return overdueStatus;
    }

    public void setWriteOffDate(Date writeOffDate){
        this.writeOffDate = writeOffDate;
    }

    public Date getWriteOffDate(){
        return writeOffDate;
    }

    public void setTimes(Long times){
        this.times = times;
    }

    public Long getTimes(){
        return times;
    }

    public void setDueAmount(Double dueAmount){
        this.dueAmount = dueAmount;
    }

    public Double getDueAmount(){
        return dueAmount;
    }

    public void setDueDate(Date dueDate){
        this.dueDate = dueDate;
    }

    public Date getDueDate(){
        return dueDate;
    }

    public void setLastReceivedDate(Date lastReceivedDate){
        this.lastReceivedDate = lastReceivedDate;
    }

    public Date getLastReceivedDate(){
        return lastReceivedDate;
    }

    public Date getCcCreationDate() {
        return ccCreationDate;
    }

    public void setCcCreationDate(Date ccCreationDate) {
        this.ccCreationDate = ccCreationDate;
    }

    public void setLeaseTimes(Long leaseTimes){
        this.leaseTimes = leaseTimes;
    }

    public Long getLeaseTimes(){
        return leaseTimes;
    }

    public void setEmployeeId(Long employeeId){
        this.employeeId = employeeId;
    }

    public Long getEmployeeId(){
        return employeeId;
    }

    public void setUserName(String userName){
        this.userName = userName;
    }

    public String getUserName(){
        return userName;
    }

    public void setBpName(String bpName){
        this.bpName = bpName;
    }

    public String getBpName(){
        return bpName;
    }

    public void setTenantBpId(Long tenantBpId){
        this.tenantBpId = tenantBpId;
    }

    public Long getTenantBpId(){
        return tenantBpId;
    }

    public void setProjectId(Long projectId){
        this.projectId = projectId;
    }

    public Long getProjectId(){
        return projectId;
    }

    public void setProjectName(String projectName){
        this.projectName = projectName;
    }

    public String getProjectName(){
        return projectName;
    }

    public void setUnitId(Long unitId){
        this.unitId = unitId;
    }

    public Long getUnitId(){
        return unitId;
    }

    public void setUnitName(String unitName){
        this.unitName = unitName;
    }

    public String getUnitName(){
        return unitName;
    }

    public void setFinanceAmount(Double financeAmount){
        this.financeAmount = financeAmount;
    }

    public Double getFinanceAmount(){
        return financeAmount;
    }

    public void setReleaseDate(Date releaseDate){
        this.releaseDate = releaseDate;
    }

    public Date getReleaseDate(){
        return releaseDate;
    }

    public void setCompanyId(Long companyId){
        this.companyId = companyId;
    }

    public Long getCompanyId(){
        return companyId;
    }

    public void setChangeCount(Long changeCount){
        this.changeCount = changeCount;
    }

    public Long getChangeCount(){
        return changeCount;
    }

}
