package hls.core.csh.dto;

import com.hand.hap.core.annotation.Children;
import com.hand.hap.system.dto.BaseDTO;
import hls.core.cont.dto.*;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Transient;
import java.math.BigInteger;
import java.util.Date;
import java.util.List;

/**
 * Created by lpc on 2017/9/30.
 */
public class CshConContract extends BaseDTO {
    @Id
    @GeneratedValue
    private Long contract_id;
    private Long company_id;
    private Long project_id;
    private Long quotation_id;
    private String document_type;
    private String document_category;
    private String business_type;
    private String contract_number;
    private String contract_name;
    private String contract_status;
    private String lease_channel;
    private String division;
    private Long leaseTimes;

    private Date signDate;
    private Date inceptionOfLease;
    private Long employeeId;
    private Long unitId;
    private Date leaseStartDate;
    private Date firstPayDate;
    private Date lastPayDate;
    private Date leaseEndDate;
    private Date originalRecallDate;
    private Date leaseCardRecallDate;
    private Date earlyTerminationDate;
    private Date terminationDate;
    private Date assignmentDate;
    private Long annualPayTimes;
    private Double leaseTerm;
    private Long payType;
    private String currency;
    private Long taxTypeId;
    private String vatFlag;
    private Double vatRate;
    private Double leaseItemAmount;
    private Double vatInput;
    private Long vatInputTaxTypeId;
    private Double vatInputTaxTypeRate;
    private Double downPaymentRatio;
    private Double downPayment;
    private Double netDownPayment;
    private Double vatDownPayment;
    private Double financeAmount;
    private Double netFinanceAmount;
    private Double vatFinanceAmount;
    private Double totalRental;
    private Double netTotalRental;
    private Double vatTotalRental;
    private Double totalInterest;
    private Double netTotalInterest;
    private Double vatTotalInterest;
    private Double leaseChargeRatio;
    private Double leaseCharge;
    private Double netLeaseCharge;
    private Double vatLeaseCharge;
    private Double leaseMgtFeeRatio;
    private Double leaseMgtFee;
    private Double netLeaseMgtFee;
    private Double vatLeaseMgtFee;
    private String leaseMgtFeeRule;
    private Double depositRatio;
    private Double deposit;
    private String depositDeduction;
    private Double residualRatio;
    private Double residualValue;
    private Double netResidualValue;
    private Double vatResidualValue;
    private Double balloonRatio;
    private Double balloon;
    private Double netBalloon;
    private Double vatBalloon;
    private String baseRateType;
    private Double baseRate;
    private Double intRate;
    private Double intRateImplicit;
    private String intRateType;
    private Double irr;
    private Double irrAfterTax;
    private Double pmt;
    private Double pmtFirst;
    private Double annualMeanRate;
    private String receivedStatus;
    private String overdueStatus;
    private String billingMethod;
    private String billingStatus;
    private String bizDayConvention;
    private String penaltyProfile;
    private Long bpAccountId;
    @Transient
    private String organization1;

    public String getOrganization1() {
        return organization1;
    }

    public void setOrganization1(String organization1) {
        this.organization1 = organization1;
    }

    public Long getBpAccountId() {
        return bpAccountId;
    }

    public void setBpAccountId(Long bpAccountId) {
        this.bpAccountId = bpAccountId;
    }

    @Children
    @Transient
    private List<HlsCusConContractLeaseItem> conContractLeaseItems;
    @Children
    @Transient
    private List<HlsCusConContractMortgage>  conContractMortgages;
    @Children
    @Transient
    private List<HlsCusConContractAttachment> contractAttachments;
    @Children
    @Transient
    private List<HlsCusConContractTenant> conContractTenants;

    @Children
    @Transient
    private List<HlsCusConContractGuarantor> contractGuarantors;

    @Transient
    private Double paymentAmount;//抵扣付款金额

    @Transient
    private Double deductAmount;//抵扣金额

    @Transient
    private String cf_item;
    @Transient
    private String cf_type;
    @Transient
    private String tenantBpType;
    @Transient
    private Long days;
    @Transient
    private Long bp_id;
    @Transient
    private Date transactionDate;
    @Transient
    private String bp_name;

    @Transient
    private Long times;
    @Transient
    private String description;
    @Transient
    private Date due_date;
    @Transient
    private Double due_amount;
    @Transient
    private Double received_amount;
    @Transient
    private Double unpaid_amount;
    @Transient
    private String bankAccountNum;
    @Transient
    private String bankAccountName;
    @Transient
    private String companyName;
    @Transient
    private Double sumDueAmount;
    @Transient
    private Double sumReceivedAmount;
    @Transient
    private Double sumUnpaidAmount;
    @Transient
    private BigInteger latestHours;

    @Transient
    private Double outSumAmount;
    @Transient
    private Double inSumAmount;
    @Transient
    private Double newNum;
    @Transient
    private Double signNum;
    @Transient
    private Double inceptNum;
    @Transient
    private Double pendingNum;
    @Transient
    private Double terminationNum;
    @Transient
    private String writeOffFlag;

    @Transient
    private String signStatus;
    @Transient
    private String inceptStatus;
    @Transient
    private String changeStatus;
    @Transient
    private String cancelStatus;
    @Transient
    private Double sumAmount;

    @Transient
    private Date day;
    @Transient
    private Double amount;
    @Transient
    private Long contractCount;

    @Transient
    private Long stockContractCount;
    @Transient
    private Long newContractCount;

    @Transient
    private Long cashflowHCount;
    @Transient
    private Long guarantorHCount;
    @Transient
    private Long itemHCount;
    @Transient
    private Long mortgageHCount;
    @Transient
    private Long tenantHCount;
    @Transient
    private String contractReqType;
    @Transient
    private String changeReqDate;
    @Transient
    private String status;
    @Transient
    private String bp_number;
    @Transient
    private Double dueAmount;
    @Transient
    private Double receivedAmount;
    @Transient
    private Double transactionAmount;
    @Transient
    private Long dueAmountCount;
    @Transient
    private Long receivedAmountCount;
    @Transient
    private Long transactionAmountCount;
    @Transient
    private Long paymentReqLnId;
    @Transient
    private String userName;
    @Transient
    private String amountPaid;
    @Transient
    private String bpBankAccountName;
    @Transient
    private String bpBankName;
    @Transient
    private String bpBankAccountNum;
    @Transient
    private Date paymentReqDate;
    @Transient
    private Date writeOffDate;
    @Transient
    private Double writeOffDueAmount;
    @Transient
    private String companyFullName;
    @Transient
    private Long typeCount;
    @Transient
    private Long queryTimeSolt;
    @Transient
    private Long stockCount; // 已存在合同数量
    @Transient
    private Long newCount;// 新增合同数量
    @Transient
    private Long paymentReqId;
    @Transient
    private Long cshTransactionId;
    @Transient
    private Long transactionId;
    @Transient
    private Double writeOffAmount;
    @Transient
    private Long changeReqId;
    @Transient
    private String bankName;
    @Transient
    private String queryCondition;
    @Transient
    private String contractStatusValue;
    @Transient
    private String divisionDes;
    @Transient
    private String paymentAppFlag;
    @Transient
    private String collectFlag;
    @Transient
    private String receiveDateFrom;
    @Transient
    private String receiveDateTo;
    @Transient
    private String overdueFrom;
    @Transient
    private String overdueTo;
    @Transient
    private String division_name;
    @Transient
    private String document_type_name;
    @Transient
    private String priceList;
    @Transient
    private Double principal;
    @Transient
    private Double interest;
    @Transient
    private Double outstanding_principal;
    @Transient
    private String bpName;
    @Transient
    private String bpTypeDesc;
    @Transient
    private String sourceDocCategory;
    @Transient
    private String writeOffType;//核销类型
    @Transient
    private String transactionType;//现金事物类型

    public String getTransactionType() {
        return transactionType;
    }

    public void setTransactionType(String transactionType) {
        this.transactionType = transactionType;
    }

    public Date getTransactionDate() {
        return transactionDate;
    }

    public void setTransactionDate(Date transactionDate) {
        this.transactionDate = transactionDate;
    }

    public List<HlsCusConContractGuarantor> getContractGuarantors() {
        return contractGuarantors;
    }

    public void setContractGuarantors(List<HlsCusConContractGuarantor> contractGuarantors) {
        this.contractGuarantors = contractGuarantors;
    }

    public List<HlsCusConContractTenant> getConContractTenants() {
        return conContractTenants;
    }

    public void setConContractTenants(List<HlsCusConContractTenant> conContractTenants) {
        this.conContractTenants = conContractTenants;
    }

    public String getBp_number() {
        return bp_number;
    }

    public void setBp_number(String bp_number) {
        this.bp_number = bp_number;
    }
    public Long getTransactionId() {
        return transactionId;
    }

    public void setTransactionId(Long transactionId) {
        this.transactionId = transactionId;
    }

    public Double getWriteOffAmount() {
        return writeOffAmount;
    }

    public void setWriteOffAmount(Double writeOffAmount) {
        this.writeOffAmount = writeOffAmount;
    }

    public String getDivisionDes() {
        return divisionDes;
    }

    public void setDivisionDes(String divisionDes) {
        this.divisionDes = divisionDes;
    }

    public Double getDeductAmount() {
        return deductAmount;
    }

    public void setDeductAmount(Double deductAmount) {
        this.deductAmount = deductAmount;
    }

    public Double getPaymentAmount() {
        return paymentAmount;
    }

    public void setPaymentAmount(Double paymentAmount) {
        this.paymentAmount = paymentAmount;
    }

    public String getWriteOffType() {
        return writeOffType;
    }

    public void setWriteOffType(String writeOffType) {
        this.writeOffType = writeOffType;
    }

    public String getSourceDocCategory() {
        return sourceDocCategory;
    }

    public void setSourceDocCategory(String sourceDocCategory) {
        this.sourceDocCategory = sourceDocCategory;
    }

    public String getBpName() {
        return bpName;
    }

    public void setBpName(String bpName) {
        this.bpName = bpName;
    }

    public String getBpTypeDesc() {
        return bpTypeDesc;
    }

    public void setBpTypeDesc(String bpTypeDesc) {
        this.bpTypeDesc = bpTypeDesc;
    }

    public Double getPrincipal() {
        return principal;
    }

    public void setPrincipal(Double principal) {
        this.principal = principal;
    }

    public Double getInterest() {
        return interest;
    }

    public void setInterest(Double interest) {
        this.interest = interest;
    }

    public Double getOutstanding_principal() {
        return outstanding_principal;
    }

    public void setOutstanding_principal(Double outstanding_principal) {
        this.outstanding_principal = outstanding_principal;
    }

    public String getPriceList() {
        return priceList;
    }

    public void setPriceList(String priceList) {
        this.priceList = priceList;
    }

    public String getReceiveDateFrom() {
        return receiveDateFrom;
    }

    public void setReceiveDateFrom(String receiveDateFrom) {
        this.receiveDateFrom = receiveDateFrom;
    }

    public String getReceiveDateTo() {
        return receiveDateTo;
    }

    public void setReceiveDateTo(String receiveDateTo) {
        this.receiveDateTo = receiveDateTo;
    }

    public String getOverdueFrom() {
        return overdueFrom;
    }

    public void setOverdueFrom(String overdueFrom) {
        this.overdueFrom = overdueFrom;
    }

    public String getOverdueTo() {
        return overdueTo;
    }

    public void setOverdueTo(String overdueTo) {
        this.overdueTo = overdueTo;
    }

    public String getDivision_name() {
        return division_name;
    }

    public void setDivision_name(String division_name) {
        this.division_name = division_name;
    }

    public String getDocument_type_name() {
        return document_type_name;
    }

    public void setDocument_type_name(String document_type_name) {
        this.document_type_name = document_type_name;
    }

    public String getCollectFlag() {
        return collectFlag;
    }

    public void setCollectFlag(String collectFlag) {
        this.collectFlag = collectFlag;
    }

    public String getPaymentAppFlag() {
        return paymentAppFlag;
    }

    public void setPaymentAppFlag(String paymentAppFlag) {
        this.paymentAppFlag = paymentAppFlag;
    }

    public String getContractStatusValue() {
        return contractStatusValue;
    }

    public void setContractStatusValue(String contractStatusValue) {
        this.contractStatusValue = contractStatusValue;
    }

    public String getBankName() {
        return bankName;
    }

    public void setBankName(String bankName) {
        this.bankName = bankName;
    }

    public Long getChangeReqId() {
        return changeReqId;
    }

    public void setChangeReqId(Long changeReqId) {
        this.changeReqId = changeReqId;
    }

    public Long getPaymentReqId() {
        return paymentReqId;
    }

    public void setPaymentReqId(Long paymentReqId) {
        this.paymentReqId = paymentReqId;
    }

    public Long getCshTransactionId() {
        return cshTransactionId;
    }

    public void setCshTransactionId(Long cshTransactionId) {
        this.cshTransactionId = cshTransactionId;
    }

    public Long getStockCount() {
        return stockCount;
    }

    public void setStockCount(Long stockCount) {
        this.stockCount = stockCount;
    }

    public Long getNewCount() {
        return newCount;
    }

    public void setNewCount(Long newCount) {
        this.newCount = newCount;
    }

    public Long getQueryTimeSolt() {
        return queryTimeSolt;
    }

    public void setQueryTimeSolt(Long queryTimeSolt) {
        this.queryTimeSolt = queryTimeSolt;
    }

    public Long getTypeCount() {
        return typeCount;
    }

    public void setTypeCount(Long typeCount) {
        this.typeCount = typeCount;
    }

    public Double getDueAmount() {
        return dueAmount;
    }

    public void setDueAmount(Double dueAmount) {
        this.dueAmount = dueAmount;
    }

    public Double getReceivedAmount() {
        return receivedAmount;
    }

    public void setReceivedAmount(Double receivedAmount) {
        this.receivedAmount = receivedAmount;
    }

    public Double getTransactionAmount() {
        return transactionAmount;
    }

    public void setTransactionAmount(Double transactionAmount) {
        this.transactionAmount = transactionAmount;
    }

    public Long getDueAmountCount() {
        return dueAmountCount;
    }

    public void setDueAmountCount(Long dueAmountCount) {
        this.dueAmountCount = dueAmountCount;
    }

    public Long getReceivedAmountCount() {
        return receivedAmountCount;
    }

    public void setReceivedAmountCount(Long receivedAmountCount) {
        this.receivedAmountCount = receivedAmountCount;
    }

    public Long getTransactionAmountCount() {
        return transactionAmountCount;
    }

    public void setTransactionAmountCount(Long transactionAmountCount) {
        this.transactionAmountCount = transactionAmountCount;
    }

    public Long getPaymentReqLnId() {
        return paymentReqLnId;
    }

    public void setPaymentReqLnId(Long paymentReqLnId) {
        this.paymentReqLnId = paymentReqLnId;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getAmountPaid() {
        return amountPaid;
    }

    public void setAmountPaid(String amountPaid) {
        this.amountPaid = amountPaid;
    }

    public String getBpBankAccountName() {
        return bpBankAccountName;
    }

    public void setBpBankAccountName(String bpBankAccountName) {
        this.bpBankAccountName = bpBankAccountName;
    }

    public String getBpBankName() {
        return bpBankName;
    }

    public void setBpBankName(String bpBankName) {
        this.bpBankName = bpBankName;
    }

    public String getBpBankAccountNum() {
        return bpBankAccountNum;
    }

    public void setBpBankAccountNum(String bpBankAccountNum) {
        this.bpBankAccountNum = bpBankAccountNum;
    }

    public Date getPaymentReqDate() {
        return paymentReqDate;
    }

    public void setPaymentReqDate(Date paymentReqDate) {
        this.paymentReqDate = paymentReqDate;
    }

    public Date getWriteOffDate() {
        return writeOffDate;
    }

    public void setWriteOffDate(Date writeOffDate) {
        this.writeOffDate = writeOffDate;
    }

    public Double getWriteOffDueAmount() {
        return writeOffDueAmount;
    }

    public void setWriteOffDueAmount(Double writeOffDueAmount) {
        this.writeOffDueAmount = writeOffDueAmount;
    }

    public String getCompanyFullName() {
        return companyFullName;
    }

    public void setCompanyFullName(String companyFullName) {
        this.companyFullName = companyFullName;
    }

    public String getContractReqType() {
        return contractReqType;
    }

    public void setContractReqType(String contractReqType) {
        this.contractReqType = contractReqType;
    }

    public String getChangeReqDate() {
        return changeReqDate;
    }

    public void setChangeReqDate(String changeReqDate) {
        this.changeReqDate = changeReqDate;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public Long getCashflowHCount() {
        return cashflowHCount;
    }

    public void setCashflowHCount(Long cashflowHCount) {
        this.cashflowHCount = cashflowHCount;
    }

    public Long getGuarantorHCount() {
        return guarantorHCount;
    }

    public void setGuarantorHCount(Long guarantorHCount) {
        this.guarantorHCount = guarantorHCount;
    }

    public Long getItemHCount() {
        return itemHCount;
    }

    public void setItemHCount(Long itemHCount) {
        this.itemHCount = itemHCount;
    }

    public Long getMortgageHCount() {
        return mortgageHCount;
    }

    public void setMortgageHCount(Long mortgageHCount) {
        this.mortgageHCount = mortgageHCount;
    }

    public Long getTenantHCount() {
        return tenantHCount;
    }

    public void setTenantHCount(Long tenantHCount) {
        this.tenantHCount = tenantHCount;
    }

    public Long getStockContractCount() {
        return stockContractCount;
    }

    public void setStockContractCount(Long stockContractCount) {
        this.stockContractCount = stockContractCount;
    }

    public Long getNewContractCount() {
        return newContractCount;
    }

    public void setNewContractCount(Long newContractCount) {
        this.newContractCount = newContractCount;
    }

    public Long getContractCount() {
        return contractCount;
    }

    public void setContractCount(Long contractCount) {
        this.contractCount = contractCount;
    }

    public Date getDay() {
        return day;
    }

    public void setDay(Date day) {
        this.day = day;
    }

    public Double getAmount() {
        return amount;
    }

    public void setAmount(Double amount) {
        this.amount = amount;
    }

    public Double getSumAmount() {
        return sumAmount;
    }

    public void setSumAmount(Double sumAmount) {
        this.sumAmount = sumAmount;
    }

    public String getSignStatus() {
        return signStatus;
    }

    public void setSignStatus(String signStatus) {
        this.signStatus = signStatus;
    }

    public String getInceptStatus() {
        return inceptStatus;
    }

    public void setInceptStatus(String inceptStatus) {
        this.inceptStatus = inceptStatus;
    }

    public String getChangeStatus() {
        return changeStatus;
    }

    public void setChangeStatus(String changeStatus) {
        this.changeStatus = changeStatus;
    }

    public String getCancelStatus() {
        return cancelStatus;
    }

    public void setCancelStatus(String cancelStatus) {
        this.cancelStatus = cancelStatus;
    }

    public String getTerminationStatus() {
        return terminationStatus;
    }

    public void setTerminationStatus(String terminationStatus) {
        this.terminationStatus = terminationStatus;
    }

    @Transient
    private Double sumPrincipal;
    @Transient
    private Double sumInterest;

    public Double getSumPrincipal() {
        return sumPrincipal;
    }

    public void setSumPrincipal(Double sumPrincipal) {
        this.sumPrincipal = sumPrincipal;
    }

    public Double getSumInterest() {
        return sumInterest;
    }

    public void setSumInterest(Double sumInterest) {
        this.sumInterest = sumInterest;
    }

    @Transient
    private String terminationStatus;




    @Transient
    private String created_by_desc;

    @Transient
    private String creation_date_desc;
    @Transient
    private String document_type_desc;
    @Transient
    private String business_type_desc;

    @Transient
    private String division_desc;

    @Transient
    private String lease_channel_desc;

    @Transient
    private Long expired_times;
    @Transient
    private Long payment_times;
    @Transient
    private Long unpayment_times;
    @Transient
    private Long overdue_times;
    @Transient
    private Double avg_overdue_dates;
    @Transient
    private Double max_overdue_dates;
    @Transient
    private Double total_payment_amount;
    @Transient
    private String price_list;
    @Transient
    private String price_list_desc;

    public String getPrice_list_desc() {
        return price_list_desc;
    }

    public void setPrice_list_desc(String price_list_desc) {
        this.price_list_desc = price_list_desc;
    }

    @Transient

    private Date create_date;
    @Transient
    private Long contract_incept_id;

    public Date getCreate_date() {
        return create_date;
    }

    public void setCreate_date(Date create_date) {
        this.create_date = create_date;
    }

    public Long getContract_incept_id() {
        return contract_incept_id;
    }

    public void setContract_incept_id(Long contract_incept_id) {
        this.contract_incept_id = contract_incept_id;
    }

    public String getPrice_list() {
        return price_list;
    }

    public void setPrice_list(String price_list) {
        this.price_list = price_list;
    }

    public String getAnnual_pay_times_desc() {
        return annual_pay_times_desc;
    }

    public void setAnnual_pay_times_desc(String annual_pay_times_desc) {
        this.annual_pay_times_desc = annual_pay_times_desc;
    }

    @Transient
    private String annual_pay_times_desc;
    @Transient
    private Date createDate;
    @Transient
    private String int_rate_fixing_way;

    public String getInt_rate_fixing_way() {
        return int_rate_fixing_way;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public void setInt_rate_fixing_way(String int_rate_fixing_way) {
        this.int_rate_fixing_way = int_rate_fixing_way;
    }

    public Double getInt_rate_fixing_range() {
        return int_rate_fixing_range;
    }

    public void setInt_rate_fixing_range(Double int_rate_fixing_range) {
        this.int_rate_fixing_range = int_rate_fixing_range;
    }

    @Transient
    private Double int_rate_fixing_range;

    public Double getTotal_payment_amount() {
        return total_payment_amount;
    }

    public void setTotal_payment_amount(Double total_payment_amount) {
        this.total_payment_amount = total_payment_amount;
    }

    public Double getTotal_received_amount() {
        return total_received_amount;
    }

    public void setTotal_received_amount(Double total_received_amount) {
        this.total_received_amount = total_received_amount;
    }

    @Transient
    private Double total_received_amount;
    @Transient
    private String down_payment_way;
    @Transient
    private Double down_payment_range;

    @Transient
    private String deposit_way;

    public Double getDown_payment_range() {
        return down_payment_range;
    }

    public void setDown_payment_range(Double down_payment_range) {
        this.down_payment_range = down_payment_range;
    }


    public String getDeposit_way() {
        return deposit_way;
    }

    public void setDeposit_way(String deposit_way) {
        this.deposit_way = deposit_way;
    }

    public Double getDeposit_range() {
        return deposit_range;
    }

    public void setDeposit_range(Double deposit_range) {
        this.deposit_range = deposit_range;
    }

    @Transient
    private Double deposit_range;


    public String getDown_payment_way() {
        return down_payment_way;
    }

    public void setDown_payment_way(String down_payment_way) {
        this.down_payment_way = down_payment_way;
    }

    public String getCreated_by_desc() {
        return created_by_desc;
    }

    public void setCreated_by_desc(String created_by_desc) {
        this.created_by_desc = created_by_desc;
    }

    public String getCreation_date_desc() {
        return creation_date_desc;
    }

    public void setCreation_date_desc(String creation_date_desc) {
        this.creation_date_desc = creation_date_desc;
    }

    public String getDocument_type_desc() {
        return document_type_desc;
    }

    public void setDocument_type_desc(String document_type_desc) {
        this.document_type_desc = document_type_desc;
    }

    public String getBusiness_type_desc() {
        return business_type_desc;
    }

    public void setBusiness_type_desc(String business_type_desc) {
        this.business_type_desc = business_type_desc;
    }

    public String getDivision_desc() {
        return division_desc;
    }

    public void setDivision_desc(String division_desc) {
        this.division_desc = division_desc;
    }

    public String getLease_channel_desc() {
        return lease_channel_desc;
    }

    public void setLease_channel_desc(String lease_channel_desc) {
        this.lease_channel_desc = lease_channel_desc;
    }

    public Long getExpired_times() {
        return expired_times;
    }

    public void setExpired_times(Long expired_times) {
        this.expired_times = expired_times;
    }

    public Long getPayment_times() {
        return payment_times;
    }

    public void setPayment_times(Long payment_times) {
        this.payment_times = payment_times;
    }

    public Long getUnpayment_times() {
        return unpayment_times;
    }

    public void setUnpayment_times(Long unpayment_times) {
        this.unpayment_times = unpayment_times;
    }

    public Long getOverdue_times() {
        return overdue_times;
    }

    public void setOverdue_times(Long overdue_times) {
        this.overdue_times = overdue_times;
    }

    public Double getAvg_overdue_dates() {
        return avg_overdue_dates;
    }

    public void setAvg_overdue_dates(Double avg_overdue_dates) {
        this.avg_overdue_dates = avg_overdue_dates;
    }

    public Double getMax_overdue_dates() {
        return max_overdue_dates;
    }

    public void setMax_overdue_dates(Double max_overdue_dates) {
        this.max_overdue_dates = max_overdue_dates;
    }

    public Double getTotal_overdue_dates() {
        return total_overdue_dates;
    }

    public void setTotal_overdue_dates(Double total_overdue_dates) {
        this.total_overdue_dates = total_overdue_dates;
    }

    @Transient
    private Double total_overdue_dates;


    @Transient
    private String terminationFLag;

    public String getTerminationFLag() {
        return terminationFLag;
    }

    @Transient
    private String paymentFlag;

    public String getPaymentFlag() {
        return paymentFlag;
    }

    public void setPaymentFlag(String paymentFlag) {
        this.paymentFlag = paymentFlag;
    }

    public void setTerminationFLag(String terminationFLag) {
        this.terminationFLag = terminationFLag;
    }

    public String getWriteOffFlag() {
        return writeOffFlag;
    }

    public void setWriteOffFlag(String writeOffFlag) {
        this.writeOffFlag = writeOffFlag;
    }

    public String getCompanyName() {
        return companyName;
    }

    public void setCompanyName(String companyName) {
        this.companyName = companyName;
    }
    public List<HlsCusConContractAttachment> getContractAttachments() {
        return contractAttachments;
    }

    public void setContractAttachments(List<HlsCusConContractAttachment> contractAttachments) {
        this.contractAttachments = contractAttachments;
    }

    public Double getOutSumAmount() {
        return outSumAmount;
    }

    public void setOutSumAmount(Double outSumAmount) {
        this.outSumAmount = outSumAmount;
    }

    public Double getInSumAmount() {
        return inSumAmount;
    }

    public void setInSumAmount(Double inSumAmount) {
        this.inSumAmount = inSumAmount;
    }

    public Double getNewNum() {
        return newNum;
    }

    public void setNewNum(Double newNum) {
        this.newNum = newNum;
    }

    public Double getSignNum() {
        return signNum;
    }

    public void setSignNum(Double signNum) {
        this.signNum = signNum;
    }

    public Double getInceptNum() {
        return inceptNum;
    }

    public void setInceptNum(Double inceptNum) {
        this.inceptNum = inceptNum;
    }

    public Double getPendingNum() {
        return pendingNum;
    }

    public void setPendingNum(Double pendingNum) {
        this.pendingNum = pendingNum;
    }

    public Double getTerminationNum() {
        return terminationNum;
    }

    public void setTerminationNum(Double terminationNum) {
        this.terminationNum = terminationNum;
    }

    public Date getSignDate() {
        return signDate;
    }

    public void setSignDate(Date signDate) {
        this.signDate = signDate;
    }

    public Date getInceptionOfLease() {
        return inceptionOfLease;
    }

    public void setInceptionOfLease(Date inceptionOfLease) {
        this.inceptionOfLease = inceptionOfLease;
    }

    public Long getEmployeeId() {
        return employeeId;
    }

    public void setEmployeeId(Long employeeId) {
        this.employeeId = employeeId;
    }

    public Long getUnitId() {
        return unitId;
    }

    public void setUnitId(Long unitId) {
        this.unitId = unitId;
    }

    public Date getLeaseStartDate() {
        return leaseStartDate;
    }

    public void setLeaseStartDate(Date leaseStartDate) {
        this.leaseStartDate = leaseStartDate;
    }

    public Date getFirstPayDate() {
        return firstPayDate;
    }

    public void setFirstPayDate(Date firstPayDate) {
        this.firstPayDate = firstPayDate;
    }

    public Date getLastPayDate() {
        return lastPayDate;
    }

    public void setLastPayDate(Date lastPayDate) {
        this.lastPayDate = lastPayDate;
    }

    public Date getLeaseEndDate() {
        return leaseEndDate;
    }

    public void setLeaseEndDate(Date leaseEndDate) {
        this.leaseEndDate = leaseEndDate;
    }

    public Date getOriginalRecallDate() {
        return originalRecallDate;
    }

    public void setOriginalRecallDate(Date originalRecallDate) {
        this.originalRecallDate = originalRecallDate;
    }

    public Date getLeaseCardRecallDate() {
        return leaseCardRecallDate;
    }

    public void setLeaseCardRecallDate(Date leaseCardRecallDate) {
        this.leaseCardRecallDate = leaseCardRecallDate;
    }

    public Date getEarlyTerminationDate() {
        return earlyTerminationDate;
    }

    public void setEarlyTerminationDate(Date earlyTerminationDate) {
        this.earlyTerminationDate = earlyTerminationDate;
    }

    public Date getTerminationDate() {
        return terminationDate;
    }

    public void setTerminationDate(Date terminationDate) {
        this.terminationDate = terminationDate;
    }

    public Date getAssignmentDate() {
        return assignmentDate;
    }

    public void setAssignmentDate(Date assignmentDate) {
        this.assignmentDate = assignmentDate;
    }

    public Long getAnnualPayTimes() {
        return annualPayTimes;
    }

    public void setAnnualPayTimes(Long annualPayTimes) {
        this.annualPayTimes = annualPayTimes;
    }

    public Double getLeaseTerm() {
        return leaseTerm;
    }

    public void setLeaseTerm(Double leaseTerm) {
        this.leaseTerm = leaseTerm;
    }

    public Long getPayType() {
        return payType;
    }

    public void setPayType(Long payType) {
        this.payType = payType;
    }

    public String getCurrency() {
        return currency;
    }

    public void setCurrency(String currency) {
        this.currency = currency;
    }

    public Long getTaxTypeId() {
        return taxTypeId;
    }

    public void setTaxTypeId(Long taxTypeId) {
        this.taxTypeId = taxTypeId;
    }

    public String getVatFlag() {
        return vatFlag;
    }

    public void setVatFlag(String vatFlag) {
        this.vatFlag = vatFlag;
    }

    public Double getVatRate() {
        return vatRate;
    }

    public void setVatRate(Double vatRate) {
        this.vatRate = vatRate;
    }

    public Double getLeaseItemAmount() {
        return leaseItemAmount;
    }

    public void setLeaseItemAmount(Double leaseItemAmount) {
        this.leaseItemAmount = leaseItemAmount;
    }

    public Double getVatInput() {
        return vatInput;
    }

    public void setVatInput(Double vatInput) {
        this.vatInput = vatInput;
    }

    public Long getVatInputTaxTypeId() {
        return vatInputTaxTypeId;
    }

    public void setVatInputTaxTypeId(Long vatInputTaxTypeId) {
        this.vatInputTaxTypeId = vatInputTaxTypeId;
    }

    public Double getVatInputTaxTypeRate() {
        return vatInputTaxTypeRate;
    }

    public void setVatInputTaxTypeRate(Double vatInputTaxTypeRate) {
        this.vatInputTaxTypeRate = vatInputTaxTypeRate;
    }

    public Double getDownPaymentRatio() {
        return downPaymentRatio;
    }

    public void setDownPaymentRatio(Double downPaymentRatio) {
        this.downPaymentRatio = downPaymentRatio;
    }

    public Double getDownPayment() {
        return downPayment;
    }

    public void setDownPayment(Double downPayment) {
        this.downPayment = downPayment;
    }

    public Double getNetDownPayment() {
        return netDownPayment;
    }

    public void setNetDownPayment(Double netDownPayment) {
        this.netDownPayment = netDownPayment;
    }

    public Double getVatDownPayment() {
        return vatDownPayment;
    }

    public void setVatDownPayment(Double vatDownPayment) {
        this.vatDownPayment = vatDownPayment;
    }

    public Double getFinanceAmount() {
        return financeAmount;
    }

    public void setFinanceAmount(Double financeAmount) {
        this.financeAmount = financeAmount;
    }

    public Double getNetFinanceAmount() {
        return netFinanceAmount;
    }

    public void setNetFinanceAmount(Double netFinanceAmount) {
        this.netFinanceAmount = netFinanceAmount;
    }

    public Double getVatFinanceAmount() {
        return vatFinanceAmount;
    }

    public void setVatFinanceAmount(Double vatFinanceAmount) {
        this.vatFinanceAmount = vatFinanceAmount;
    }

    public Double getTotalRental() {
        return totalRental;
    }

    public void setTotalRental(Double totalRental) {
        this.totalRental = totalRental;
    }

    public Double getNetTotalRental() {
        return netTotalRental;
    }

    public void setNetTotalRental(Double netTotalRental) {
        this.netTotalRental = netTotalRental;
    }

    public Double getVatTotalRental() {
        return vatTotalRental;
    }

    public void setVatTotalRental(Double vatTotalRental) {
        this.vatTotalRental = vatTotalRental;
    }

    public Double getTotalInterest() {
        return totalInterest;
    }

    public void setTotalInterest(Double totalInterest) {
        this.totalInterest = totalInterest;
    }

    public Double getNetTotalInterest() {
        return netTotalInterest;
    }

    public void setNetTotalInterest(Double netTotalInterest) {
        this.netTotalInterest = netTotalInterest;
    }

    public Double getVatTotalInterest() {
        return vatTotalInterest;
    }

    public void setVatTotalInterest(Double vatTotalInterest) {
        this.vatTotalInterest = vatTotalInterest;
    }

    public Double getLeaseChargeRatio() {
        return leaseChargeRatio;
    }

    public void setLeaseChargeRatio(Double leaseChargeRatio) {
        this.leaseChargeRatio = leaseChargeRatio;
    }

    public Double getLeaseCharge() {
        return leaseCharge;
    }

    public void setLeaseCharge(Double leaseCharge) {
        this.leaseCharge = leaseCharge;
    }

    public Double getNetLeaseCharge() {
        return netLeaseCharge;
    }

    public void setNetLeaseCharge(Double netLeaseCharge) {
        this.netLeaseCharge = netLeaseCharge;
    }

    public Double getVatLeaseCharge() {
        return vatLeaseCharge;
    }

    public void setVatLeaseCharge(Double vatLeaseCharge) {
        this.vatLeaseCharge = vatLeaseCharge;
    }

    public Double getLeaseMgtFeeRatio() {
        return leaseMgtFeeRatio;
    }

    public void setLeaseMgtFeeRatio(Double leaseMgtFeeRatio) {
        this.leaseMgtFeeRatio = leaseMgtFeeRatio;
    }

    public Double getLeaseMgtFee() {
        return leaseMgtFee;
    }

    public void setLeaseMgtFee(Double leaseMgtFee) {
        this.leaseMgtFee = leaseMgtFee;
    }

    public Double getNetLeaseMgtFee() {
        return netLeaseMgtFee;
    }

    public void setNetLeaseMgtFee(Double netLeaseMgtFee) {
        this.netLeaseMgtFee = netLeaseMgtFee;
    }

    public Double getVatLeaseMgtFee() {
        return vatLeaseMgtFee;
    }

    public void setVatLeaseMgtFee(Double vatLeaseMgtFee) {
        this.vatLeaseMgtFee = vatLeaseMgtFee;
    }

    public String getLeaseMgtFeeRule() {
        return leaseMgtFeeRule;
    }

    public void setLeaseMgtFeeRule(String leaseMgtFeeRule) {
        this.leaseMgtFeeRule = leaseMgtFeeRule;
    }

    public Double getDepositRatio() {
        return depositRatio;
    }

    public void setDepositRatio(Double depositRatio) {
        this.depositRatio = depositRatio;
    }

    public Double getDeposit() {
        return deposit;
    }

    public void setDeposit(Double deposit) {
        this.deposit = deposit;
    }

    public String getDepositDeduction() {
        return depositDeduction;
    }

    public void setDepositDeduction(String depositDeduction) {
        this.depositDeduction = depositDeduction;
    }

    public Double getResidualRatio() {
        return residualRatio;
    }

    public void setResidualRatio(Double residualRatio) {
        this.residualRatio = residualRatio;
    }

    public Double getResidualValue() {
        return residualValue;
    }

    public void setResidualValue(Double residualValue) {
        this.residualValue = residualValue;
    }

    public Double getNetResidualValue() {
        return netResidualValue;
    }

    public void setNetResidualValue(Double netResidualValue) {
        this.netResidualValue = netResidualValue;
    }

    public Double getVatResidualValue() {
        return vatResidualValue;
    }

    public void setVatResidualValue(Double vatResidualValue) {
        this.vatResidualValue = vatResidualValue;
    }

    public Double getBalloonRatio() {
        return balloonRatio;
    }

    public void setBalloonRatio(Double balloonRatio) {
        this.balloonRatio = balloonRatio;
    }

    public Double getBalloon() {
        return balloon;
    }

    public void setBalloon(Double balloon) {
        this.balloon = balloon;
    }

    public Double getNetBalloon() {
        return netBalloon;
    }

    public void setNetBalloon(Double netBalloon) {
        this.netBalloon = netBalloon;
    }

    public Double getVatBalloon() {
        return vatBalloon;
    }

    public void setVatBalloon(Double vatBalloon) {
        this.vatBalloon = vatBalloon;
    }

    public String getBaseRateType() {
        return baseRateType;
    }

    public void setBaseRateType(String baseRateType) {
        this.baseRateType = baseRateType;
    }

    public Double getBaseRate() {
        return baseRate;
    }

    public void setBaseRate(Double baseRate) {
        this.baseRate = baseRate;
    }

    public Double getIntRate() {
        return intRate;
    }

    public void setIntRate(Double intRate) {
        this.intRate = intRate;
    }

    public Double getIntRateImplicit() {
        return intRateImplicit;
    }

    public void setIntRateImplicit(Double intRateImplicit) {
        this.intRateImplicit = intRateImplicit;
    }

    public String getIntRateType() {
        return intRateType;
    }

    public void setIntRateType(String intRateType) {
        this.intRateType = intRateType;
    }

    public Double getIrr() {
        return irr;
    }

    public void setIrr(Double irr) {
        this.irr = irr;
    }

    public Double getIrrAfterTax() {
        return irrAfterTax;
    }

    public void setIrrAfterTax(Double irrAfterTax) {
        this.irrAfterTax = irrAfterTax;
    }

    public Double getPmt() {
        return pmt;
    }

    public void setPmt(Double pmt) {
        this.pmt = pmt;
    }

    public Double getPmtFirst() {
        return pmtFirst;
    }

    public void setPmtFirst(Double pmtFirst) {
        this.pmtFirst = pmtFirst;
    }

    public Double getAnnualMeanRate() {
        return annualMeanRate;
    }

    public void setAnnualMeanRate(Double annualMeanRate) {
        this.annualMeanRate = annualMeanRate;
    }

    public String getReceivedStatus() {
        return receivedStatus;
    }

    public void setReceivedStatus(String receivedStatus) {
        this.receivedStatus = receivedStatus;
    }

    public String getOverdueStatus() {
        return overdueStatus;
    }

    public void setOverdueStatus(String overdueStatus) {
        this.overdueStatus = overdueStatus;
    }

    public String getBillingMethod() {
        return billingMethod;
    }

    public void setBillingMethod(String billingMethod) {
        this.billingMethod = billingMethod;
    }

    public String getBillingStatus() {
        return billingStatus;
    }

    public void setBillingStatus(String billingStatus) {
        this.billingStatus = billingStatus;
    }

    public String getBizDayConvention() {
        return bizDayConvention;
    }

    public void setBizDayConvention(String bizDayConvention) {
        this.bizDayConvention = bizDayConvention;
    }

    public String getPenaltyProfile() {
        return penaltyProfile;
    }

    public void setPenaltyProfile(String penaltyProfile) {
        this.penaltyProfile = penaltyProfile;
    }

    public List<HlsCusConContractLeaseItem> getConContractLeaseItems() {
        return conContractLeaseItems;
    }

    public void setConContractLeaseItems(List<HlsCusConContractLeaseItem> conContractLeaseItems) {
        this.conContractLeaseItems = conContractLeaseItems;
    }

    public List<HlsCusConContractMortgage> getConContractMortgages() {
        return conContractMortgages;
    }

    public void setConContractMortgages(List<HlsCusConContractMortgage> conContractMortgages) {
        this.conContractMortgages = conContractMortgages;
    }

    public Long getDays() {
        return days;
    }

    public void setDays(Long days) {
        this.days = days;
    }

    public String getTenantBpType() {
        return tenantBpType;
    }

    public void setTenantBpType(String tenantBpType) {
        this.tenantBpType = tenantBpType;
    }

    public Long getLeaseTimes() {
        return leaseTimes;
    }

    public void setLeaseTimes(Long leaseTimes) {
        this.leaseTimes = leaseTimes;
    }

    public Double getSumDueAmount() {
        return sumDueAmount;
    }

    public void setSumDueAmount(Double sumDueAmount) {
        this.sumDueAmount = sumDueAmount;
    }

    public Double getSumReceivedAmount() {
        return sumReceivedAmount;
    }

    public void setSumReceivedAmount(Double sumReceivedAmount) {
        this.sumReceivedAmount = sumReceivedAmount;
    }

    public Double getSumUnpaidAmount() {
        return sumUnpaidAmount;
    }

    public void setSumUnpaidAmount(Double sumUnpaidAmount) {
        this.sumUnpaidAmount = sumUnpaidAmount;
    }

    public String getBankAccountNum() {
        return bankAccountNum;
    }

    public void setBankAccountNum(String bankAccountNum) {
        this.bankAccountNum = bankAccountNum;
    }

    public String getBankAccountName() {
        return bankAccountName;
    }

    public void setBankAccountName(String bankAccountName) {
        this.bankAccountName = bankAccountName;
    }

    /**
     * @return the times
     */
    public Long getTimes() {
        return times;
    }

    /**
     * @param times
     *            the times to set
     */
    public void setTimes(Long times) {
        this.times = times;
    }

    public Double getDue_amount() {
        return due_amount;
    }

    public void setDue_amount(Double due_amount) {
        this.due_amount = due_amount;
    }

    public Double getReceived_amount() {
        return received_amount;
    }

    public void setReceived_amount(Double received_amount) {
        this.received_amount = received_amount;
    }

    public Double getUnpaid_amount() {
        return unpaid_amount;
    }

    public void setUnpaid_amount(Double unpaid_amount) {
        this.unpaid_amount = unpaid_amount;
    }

    /**
     * @return the bp_id
     */
    public Long getBp_id() {
        return bp_id;
    }

    /**
     * @param bp_id
     *            the bp_id to set
     */
    public void setBp_id(Long bp_id) {
        this.bp_id = bp_id;
    }

    /**
     * @return the bp_name
     */
    public String getBp_name() {
        return bp_name;
    }

    /**
     * @param bp_name
     *            the bp_name to set
     */
    public void setBp_name(String bp_name) {
        this.bp_name = bp_name;
    }

    /**
     * @return the description
     */
    public String getDescription() {
        return description;
    }

    /**
     * @param description
     *            the description to set
     */
    public void setDescription(String description) {
        this.description = description;
    }

    /**
     * @return the due_date
     */
    public Date getDue_date() {
        return due_date;
    }

    /**
     * @param due_date
     *            the due_date to set
     */
    public void setDue_date(Date due_date) {
        this.due_date = due_date;
    }

    /**
     * @return the contract_id
     */
    public Long getContract_id() {
        return contract_id;
    }

    /**
     * @param contract_id
     *            the contract_id to set
     */
    public void setContract_id(Long contract_id) {
        this.contract_id = contract_id;
    }

    /**
     * @return the company_id
     */
    public Long getCompany_id() {
        return company_id;
    }

    /**
     * @param company_id
     *            the company_id to set
     */
    public void setCompany_id(Long company_id) {
        this.company_id = company_id;
    }

    /**
     * @return the project_id
     */
    public Long getProject_id() {
        return project_id;
    }

    /**
     * @param project_id
     *            the project_id to set
     */
    public void setProject_id(Long project_id) {
        this.project_id = project_id;
    }

    /**
     * @return the quotation_id
     */
    public Long getQuotation_id() {
        return quotation_id;
    }

    /**
     * @param quotation_id
     *            the quotation_id to set
     */
    public void setQuotation_id(Long quotation_id) {
        this.quotation_id = quotation_id;
    }

    /**
     * @return the document_type
     */
    public String getDocument_type() {
        return document_type;
    }

    /**
     * @param document_type
     *            the document_type to set
     */
    public void setDocument_type(String document_type) {
        this.document_type = document_type;
    }

    /**
     * @return the document_category
     */
    public String getDocument_category() {
        return document_category;
    }

    /**
     * @param document_category
     *            the document_category to set
     */
    public void setDocument_category(String document_category) {
        this.document_category = document_category;
    }

    /**
     * @return the business_type
     */
    public String getBusiness_type() {
        return business_type;
    }

    public String getCf_item() {
        return cf_item;
    }

    public void setCf_item(String cf_item) {
        this.cf_item = cf_item;
    }

    public String getCf_type() {
        return cf_type;
    }

    public void setCf_type(String cf_type) {
        this.cf_type = cf_type;
    }

    /**
     * @param business_type
     *            the business_type to set
     */
    public void setBusiness_type(String business_type) {
        this.business_type = business_type;
    }

    /**
     * @return the contract_number
     */
    public String getContract_number() {
        return contract_number;
    }

    /**
     * @param contract_number
     *            the contract_number to set
     */
    public void setContract_number(String contract_number) {
        this.contract_number = contract_number;
    }

    /**
     * @return the contract_name
     */
    public String getContract_name() {
        return contract_name;
    }

    /**
     * @param contract_name
     *            the contract_name to set
     */
    public void setContract_name(String contract_name) {
        this.contract_name = contract_name;
    }

    /**
     * @return the contract_status
     */
    public String getContract_status() {
        return contract_status;
    }

    /**
     * @param contract_status
     *            the contract_status to set
     */
    public void setContract_status(String contract_status) {
        this.contract_status = contract_status;
    }

    /**
     * @return the lease_channel
     */
    public String getLease_channel() {
        return lease_channel;
    }

    /**
     * @param lease_channel
     *            the lease_channel to set
     */
    public void setLease_channel(String lease_channel) {
        this.lease_channel = lease_channel;
    }

    /**
     * @return the division
     */
    public String getDivision() {
        return division;
    }

    /**
     * @param division
     *            the division to set
     */
    public void setDivision(String division) {
        this.division = division;
    }

    @Transient
    private String documentCategoryDesc;

    public String getDocumentCategoryDesc() {
        return documentCategoryDesc;
    }

    public void setDocumentCategoryDesc(String documentCategoryDesc) {
        this.documentCategoryDesc = documentCategoryDesc;
    }

    /*
         * (non-Javadoc)
         *
         * @see java.lang.Object#toString()
         */
    @Override
    public String toString() {
        return "HlsCusCshConContract [contract_id=" + contract_id + ", company_id=" + company_id + ", project_id="
                + project_id + ", quotation_id=" + quotation_id + ", document_type=" + document_type
                + ", document_category=" + document_category + ", business_type=" + business_type + ", contract_number="
                + contract_number + ", contract_name=" + contract_name + ", contract_status=" + contract_status
                + ", lease_channel=" + lease_channel + ", division=" + division + ", cf_item=" + cf_item + ", cf_type="
                + cf_type + ", bp_id=" + bp_id + ", bp_name=" + bp_name + ", times=" + times + ", description="
                + description + ", due_date=" + due_date + ", due_amount=" + due_amount + ", received_amount="
                + received_amount + ", unpaid_amount=" + unpaid_amount + "]";
    }

    public BigInteger getLatestHours() {
        return latestHours;
    }

    public void setLatestHours(BigInteger latestHours) {
        this.latestHours = latestHours;
    }

    public String getQueryCondition() {
        return queryCondition;
    }

    public void setQueryCondition(String queryCondition) {
        this.queryCondition = queryCondition;
    }


}
