package hls.core.csh.dto;

import com.hand.hap.core.annotation.Children;
import com.hand.hap.mybatis.annotation.Condition;
import com.hand.hap.system.dto.BaseDTO;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Transient;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * Created by lpc on 2017/9/30.
 */
public class CshTransaction extends BaseDTO implements Serializable {
    public String getGatheringMethod() {
        return gatheringMethod;
    }

    public void setGatheringMethod(String gatheringMethod) {
        this.gatheringMethod = gatheringMethod;
    }

    @Id
    @GeneratedValue
    private Long transactionId;

    private String transactionNum;

    private String transactionCategory;

    private String transactionType;

    private String businessType;

    private Date transactionDate;

    private Date penaltyCalcDate;

    private Long companyId;

    private Double transactionAmount;

    private String currencyCode;

    private String paymentMethod;

    private String bankSlipNum;

    private Long bankAccountId;

    private Long bpId;

    private Long bpBankAccountId;

    private String bpBankName;

    private String bpBankBranchName;

    private String bpBankAccountNum;

    private String bpBankAccountName;

    private String reversedFlag;

    private Long reversedTrxId;

    private Date reversedDate;

    private String postedFlag;

    private Long contractId;

    private String description;

    private String sourceDocCategory;

    private Long sourceDocId;

    private Long sourceDocLineId;

    private Double handlingCharge;

    private String writeOffFlag;
    @Transient
    private String writeOffFlagTemp;  //核销临时标志Y/N（已核销/未核销）

    private Double writeOffAmount;

    private Date fullWriteOffDate;

    @Transient
    private Date transactionDateFrom; //收款日期从
    @Transient
    private Date transactionDateTo; //收款日期到
    @Transient
    private Double transactionAmountFrom; //收款金额从
    @Transient
    private Double transactionAmountTo; //收款金额到
    @Transient
    private String bpName; //商业伙伴名
    @Transient
    private String bankAccountName; //公司收款账户
    @Transient
    private String bankAccountNum; //公司收款账号
    @Transient
    private Double returnWriteOffAmount;  //已退款金额
    @Transient
    private Double sumWriteOffAmount;  //已核销金额（不包括核核销表中退款金额）
    @Transient
    private Double canReturnAmount;  //可退款金额
    @Transient
    private Double returnDueAmount;  //退款金额
    @Transient
    private String bankBranchName;
    @Transient
    private String bankAccountType; //银行账户类型
    @Transient
    private String documentType;

    @Transient
    private String gatheringMethod; //收款方式
    @Transient
    private String bpCode;
    @Transient
    @Condition(operator = LIKE)
    private String paymentObj;  //付款对象
    @Transient
    private String contractName;  //合同名称
    @Transient
    private String paymentReqNumber;  //付款申请编号
    @Transient
    private Date writeOffDate;  //核销日期
    @Transient
    private Long year;  //收款管理首页查询使用的年份
    @Transient
    private Long month; //收款管理首页查询使用的月份

    @Transient
    private String newReceivables; //收款新增
    @Transient
    private Double newReceivablesSum; //收款新增总额
    @Transient
    private String collectionRecoil; //收款反冲
    @Transient
    private Double collectionRecoilSum;//收款反冲总额
    @Transient
    private String collectionVerification;//收款核销
    @Transient
    private Double collectionVerificationSum;//收款核销总额
    @Transient
    private String collectionRefund;//收款退款
    @Transient
    private Double collectionRefundSum;//收款退款总额
    @Transient
    private String writeBack;//核销反冲
    @Transient
    private Double writeBackSum;//核销反冲总额
    @Transient
    private String refundRecoil;//退款反冲
    @Transient
    private Double refundRecoilSum;//退款反冲总额

    @Transient
    private String companyName;//公司名称
    @Transient
    private String userName;
    @Transient
    private String cfDirection;
    @Transient
    private Date LAST_UPDATE_DATE;
    @Transient
    private Long queryTimeSolt;




    @Transient
    private String operationPerson;//操作人

    @Transient
    private String transactionAmount1;

    @Transient
    private String contractNumber;

    @Transient
    private String documentTypeDesc;

    @Transient
    private String 	contractStatusDesc;


    @Transient
    private String 	queryCondition;

    // 收款核销保证金
    @Transient
    private Long cashflowId;
    @Transient
    private  Long cfItem;
    @Transient
    private  Double dueAmount;
    @Transient
    private Date dueDate;
    @Transient
    private  Double surplusAmount;
    @Transient
    private  Long times;
    @Transient
    private  Double writeOffDueAmount;
    @Transient
    private Long writeOffId;


    @Transient
    private String cf_item;

    @Transient
    private Long lonContractId;

    @Transient
    private Long withdrawId;

    @Transient
    private Long fctContractId;

    public Long getWithdrawId() {
        return withdrawId;
    }

    public void setWithdrawId(Long withdrawId) {
        this.withdrawId = withdrawId;
    }

    public Long getFctContractId() {
        return fctContractId;
    }

    public void setFctContractId(Long fctContractId) {
        this.fctContractId = fctContractId;
    }

    public Long getLonContractId() {
        return lonContractId;
    }

    public void setLonContractId(Long lonContractId) {
        this.lonContractId = lonContractId;
    }

    public String getQueryCondition() {
        return queryCondition;
    }

    public void setQueryCondition(String queryCondition) {
        this.queryCondition = queryCondition;
    }

    public Long getWriteOffId() {return writeOffId;}

    public void setWriteOffId(Long writeOffId) {this.writeOffId = writeOffId;}

    public String getCf_item() {
        return cf_item;
    }

    public void setCf_item(String cf_item) {
        this.cf_item = cf_item;
    }

    public Long getCashflowId() {
        return cashflowId;
    }

    public void setCashflowId(Long cashflowId) {
        this.cashflowId = cashflowId;
    }

    public Long getCfItem() {
        return cfItem;
    }

    public void setCfItem(Long cfItem) {
        this.cfItem = cfItem;
    }

    public Double getDueAmount() {
        return dueAmount;
    }

    public void setDueAmount(Double dueAmount) {
        this.dueAmount = dueAmount;
    }

    public Date getDueDate() {
        return dueDate;
    }

    public void setDueDate(Date dueDate) {
        this.dueDate = dueDate;
    }

    public Double getSurplusAmount() {
        return surplusAmount;
    }

    public void setSurplusAmount(Double surplusAmount) {
        this.surplusAmount = surplusAmount;
    }

    public Long getTimes() {
        return times;
    }

    public void setTimes(Long times) {
        this.times = times;
    }

    public Double getWriteOffDueAmount() {
        return writeOffDueAmount;
    }

    public void setWriteOffDueAmount(Double writeOffDueAmount) {
        this.writeOffDueAmount = writeOffDueAmount;
    }

    public String getContractNumber() {
        return contractNumber;
    }

    public void setContractNumber(String contractNumber) {
        this.contractNumber = contractNumber;
    }

    public String getDocumentTypeDesc() {
        return documentTypeDesc;
    }

    public void setDocumentTypeDesc(String documentTypeDesc) {
        this.documentTypeDesc = documentTypeDesc;
    }

    public String getContractStatusDesc() {
        return contractStatusDesc;
    }

    public void setContractStatusDesc(String contractStatusDesc) {
        this.contractStatusDesc = contractStatusDesc;
    }

    public Double getNotWriteOffAmount() {
        return notWriteOffAmount;
    }

    public void setNotWriteOffAmount(Double notWriteOffAmount) {
        this.notWriteOffAmount = notWriteOffAmount;
    }

    @Transient
    private Double notWriteOffAmount;


    public List<String> getQueryList() {
        return queryList;
    }

    public void setQueryList(List<String> queryList) {
        this.queryList = queryList;
    }

    @Transient
    private List<String>  queryList;

    public List<String> getQueryList1() {
        return queryList1;
    }

    public void setQueryList1(List<String> queryList1) {
        this.queryList1 = queryList1;
    }

    @Transient
    private List<String>  queryList1;

    public String getBpType() {
        return bpType;
    }

    public void setBpType(String bpType) {
        this.bpType = bpType;
    }

    @Transient
    private String bpType;

    public String getTransactionAmount2() {
        return transactionAmount2;
    }

    public void setTransactionAmount2(String transactionAmount2) {
        this.transactionAmount2 = transactionAmount2;
    }

    @Transient
    private String  transactionAmount2;

    public String getTransactionAmount3() {
        return transactionAmount3;
    }

    public void setTransactionAmount3(String transactionAmount3) {
        this.transactionAmount3 = transactionAmount3;
    }

    @Transient
    private String transactionAmount3;

    public String getTransactionAmount1() {
        return transactionAmount1;
    }

    public void setTransactionAmount1(String transactionAmount1) {
        this.transactionAmount1 = transactionAmount1;
    }

    @Transient
    private String writeOffFlagDesc;//核销状态描述

    public String getWriteOffFlagDesc() {
        return writeOffFlagDesc;
    }

    public void setWriteOffFlagDesc(String writeOffFlagDesc) {
        this.writeOffFlagDesc = writeOffFlagDesc;
    }

    @Transient
    private String transactionDateFromStr;


    @Transient
    private Date invoiceDate;

    public Date getInvoiceDate() {
        return invoiceDate;
    }

    public void setInvoiceDate(Date invoiceDate) {
        this.invoiceDate = invoiceDate;
    }

    @Transient
    private String transactionDateToStr;

    public String getOperationPerson() {
        return operationPerson;
    }

    public void setOperationPerson(String operationPerson) {
        this.operationPerson = operationPerson;
    }

    public Long getQueryTimeSolt() {
        return queryTimeSolt;
    }

    public void setQueryTimeSolt(Long queryTimeSolt) {
        this.queryTimeSolt = queryTimeSolt;
    }

    public Date getLAST_UPDATE_DATE() {
        return LAST_UPDATE_DATE;
    }

    public void setLAST_UPDATE_DATE(Date lAST_UPDATE_DATE) {
        LAST_UPDATE_DATE = lAST_UPDATE_DATE;
    }

    public String getCfDirection() {
        return cfDirection;
    }

    public void setCfDirection(String cfDirection) {
        this.cfDirection = cfDirection;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getBankName() {
        return bankName;
    }

    public void setBankName(String bankName) {
        this.bankName = bankName;
    }

    @Transient
    private String cfDescription;//现金流类型描述
    @Transient
    private String bankName;//本方银行



    public String getBankAccountType() {
        return bankAccountType;
    }

    public void setBankAccountType(String bankAccountType) {
        this.bankAccountType = bankAccountType;
    }


    public String getDocumentType() {
        return documentType;
    }

    public void setDocumentType(String documentType) {
        this.documentType = documentType;
    }

    public String getNewReceivables() {
        return newReceivables;
    }

    public void setNewReceivables(String newReceivables) {
        this.newReceivables = newReceivables;
    }

    public Double getNewReceivablesSum() {
        return newReceivablesSum;
    }

    public void setNewReceivablesSum(Double newReceivablesSum) {
        this.newReceivablesSum = newReceivablesSum;
    }

    public String getCollectionRecoil() {
        return collectionRecoil;
    }

    public void setCollectionRecoil(String collectionRecoil) {
        this.collectionRecoil = collectionRecoil;
    }

    public Double getCollectionRecoilSum() {
        return collectionRecoilSum;
    }

    public void setCollectionRecoilSum(Double collectionRecoilSum) {
        this.collectionRecoilSum = collectionRecoilSum;
    }

    public String getCollectionVerification() {
        return collectionVerification;
    }

    public void setCollectionVerification(String collectionVerification) {
        this.collectionVerification = collectionVerification;
    }

    public Double getCollectionVerificationSum() {
        return collectionVerificationSum;
    }

    public void setCollectionVerificationSum(Double collectionVerificationSum) {
        this.collectionVerificationSum = collectionVerificationSum;
    }

    public String getCollectionRefund() {
        return collectionRefund;
    }

    public void setCollectionRefund(String collectionRefund) {
        this.collectionRefund = collectionRefund;
    }

    public Double getCollectionRefundSum() {
        return collectionRefundSum;
    }

    public void setCollectionRefundSum(Double collectionRefundSum) {
        this.collectionRefundSum = collectionRefundSum;
    }

    public String getWriteBack() {
        return writeBack;
    }

    public void setWriteBack(String writeBack) {
        this.writeBack = writeBack;
    }

    public Double getWriteBackSum() {
        return writeBackSum;
    }

    public void setWriteBackSum(Double writeBackSum) {
        this.writeBackSum = writeBackSum;
    }

    public String getRefundRecoil() {
        return refundRecoil;
    }

    public void setRefundRecoil(String refundRecoil) {
        this.refundRecoil = refundRecoil;
    }

    public Double getRefundRecoilSum() {
        return refundRecoilSum;
    }

    public void setRefundRecoilSum(Double refundRecoilSum) {
        this.refundRecoilSum = refundRecoilSum;
    }

    public Long getYear() {
        return year;
    }

    public void setYear(Long year) {
        this.year = year;
    }

    public Long getMonth() {
        return month;
    }

    public void setMonth(Long month) {
        this.month = month;
    }

    @Transient
    @Children

    List<HlsCusCshWriteOff> creditCshWriteOffs;
    @Transient
    @Children
    List<HlsCusCshWriteOff> advanceCshWriteOffs;
    @Transient
    @Children
    List<HlsCusCshWriteOff> depositCshWriteOffs;

    public Date getWriteOffDate() {
        return writeOffDate;
    }

    public Double getTransactionAmount() {
        return transactionAmount;
    }

    public void setTransactionAmount(Double transactionAmount) {
        this.transactionAmount = transactionAmount;
    }

    public Double getHandlingCharge() {
        return handlingCharge;
    }

    public void setHandlingCharge(Double handlingCharge) {
        this.handlingCharge = handlingCharge;
    }

    public Double getWriteOffAmount() {
        return writeOffAmount;
    }

    public void setWriteOffAmount(Double writeOffAmount) {
        this.writeOffAmount = writeOffAmount;
    }

    public Double getTransactionAmountFrom() {
        return transactionAmountFrom;
    }

    public void setTransactionAmountFrom(Double transactionAmountFrom) {
        this.transactionAmountFrom = transactionAmountFrom;
    }

    public Double getTransactionAmountTo() {
        return transactionAmountTo;
    }

    public void setTransactionAmountTo(Double transactionAmountTo) {
        this.transactionAmountTo = transactionAmountTo;
    }

    public Double getReturnWriteOffAmount() {
        return returnWriteOffAmount;
    }

    public void setReturnWriteOffAmount(Double returnWriteOffAmount) {
        this.returnWriteOffAmount = returnWriteOffAmount;
    }

    public Double getSumWriteOffAmount() {
        return sumWriteOffAmount;
    }

    public void setSumWriteOffAmount(Double sumWriteOffAmount) {
        this.sumWriteOffAmount = sumWriteOffAmount;
    }

    public Double getCanReturnAmount() {
        return canReturnAmount;
    }

    public void setCanReturnAmount(Double canReturnAmount) {
        this.canReturnAmount = canReturnAmount;
    }

    public Double getReturnDueAmount() {
        return returnDueAmount;
    }

    public void setReturnDueAmount(Double returnDueAmount) {
        this.returnDueAmount = returnDueAmount;
    }

    public void setWriteOffDate(Date writeOffDate) {
        this.writeOffDate = writeOffDate;
    }

    public List<HlsCusCshWriteOff> getCreditCshWriteOffs() {
        return creditCshWriteOffs;
    }

    public void setCreditCshWriteOffs(List<HlsCusCshWriteOff> creditCshWriteOffs) {
        this.creditCshWriteOffs = creditCshWriteOffs;
    }

    public List<HlsCusCshWriteOff> getAdvanceCshWriteOffs() {
        return advanceCshWriteOffs;
    }

    public void setAdvanceCshWriteOffs(List<HlsCusCshWriteOff> advanceCshWriteOffs) {
        this.advanceCshWriteOffs = advanceCshWriteOffs;
    }

    public List<HlsCusCshWriteOff> getDepositCshWriteOffs() {
        return depositCshWriteOffs;
    }

    public void setDepositCshWriteOffs(List<HlsCusCshWriteOff> depositCshWriteOffs) {
        this.depositCshWriteOffs = depositCshWriteOffs;
    }

    public String getBpCode() {
        return bpCode;
    }

    public void setBpCode(String bpCode) {
        this.bpCode = bpCode;
    }

    public CshTransaction() {
        super();
    }

    public String getWriteOffFlagTemp() {
        return writeOffFlagTemp;
    }

    public void setWriteOffFlagTemp(String writeOffFlagTemp) {
        this.writeOffFlagTemp = writeOffFlagTemp;
    }

    public String getPaymentObj() {
        return paymentObj;
    }

    public void setPaymentObj(String paymentObj) {
        this.paymentObj = paymentObj;
    }

    public String getContractName() {
        return contractName;
    }

    public void setContractName(String contractName) {
        this.contractName = contractName;
    }

    public String getPaymentReqNumber() {
        return paymentReqNumber;
    }

    public void setPaymentReqNumber(String paymentReqNumber) {
        this.paymentReqNumber = paymentReqNumber;
    }

    public String getBankBranchName() {
        return bankBranchName;
    }

    public void setBankBranchName(String bankBranchName) {
        this.bankBranchName = bankBranchName;
    }

    public String getBpName() {
        return bpName;
    }

    public void setBpName(String bpName) {
        this.bpName = bpName;
    }

    public String getBankAccountName() {
        return bankAccountName;
    }

    public void setBankAccountName(String bankAccountName) {
        this.bankAccountName = bankAccountName;
    }

    public String getBankAccountNum() {
        return bankAccountNum;
    }

    public void setBankAccountNum(String bankAccountNum) {
        this.bankAccountNum = bankAccountNum;
    }

    public Date getTransactionDateFrom() {
        return transactionDateFrom;
    }

    public void setTransactionDateFrom(Date transactionDateFrom) {
        this.transactionDateFrom = transactionDateFrom;
    }

    public Date getTransactionDateTo() {
        return transactionDateTo;
    }

    public void setTransactionDateTo(Date transactionDateTo) {
        this.transactionDateTo = transactionDateTo;
    }

    public String getWriteOffFlag() {
        return writeOffFlag;
    }

    public void setWriteOffFlag(String writeOffFlag) {
        this.writeOffFlag = writeOffFlag;
    }

    public Date getFullWriteOffDate() {
        return fullWriteOffDate;
    }

    public void setFullWriteOffDate(Date fullWriteOffDate) {
        this.fullWriteOffDate = fullWriteOffDate;
    }

    public String getBankSlipNum() {
        return bankSlipNum;
    }

    public void setBankSlipNum(String bankSlipNum) {
        this.bankSlipNum = bankSlipNum;
    }

    public Long getTransactionId() {
        return transactionId;
    }

    public void setTransactionId(Long transactionId) {
        this.transactionId = transactionId;
    }

    public String getTransactionNum() {
        return transactionNum;
    }

    public void setTransactionNum(String transactionNum) {
        this.transactionNum = transactionNum == null ? null : transactionNum.trim();
    }

    public String getTransactionCategory() {
        return transactionCategory;
    }

    public void setTransactionCategory(String transactionCategory) {
        this.transactionCategory = transactionCategory == null ? null : transactionCategory.trim();
    }

    public String getTransactionType() {
        return transactionType;
    }

    public void setTransactionType(String transactionType) {
        this.transactionType = transactionType == null ? null : transactionType.trim();
    }

    public String getBusinessType() {
        return businessType;
    }

    public void setBusinessType(String businessType) {
        this.businessType = businessType == null ? null : businessType.trim();
    }

    public Date getTransactionDate() {
        return transactionDate;
    }

    public void setTransactionDate(Date transactionDate) {
        this.transactionDate = transactionDate;
    }

    public Date getPenaltyCalcDate() {
        return penaltyCalcDate;
    }

    public void setPenaltyCalcDate(Date penaltyCalcDate) {
        this.penaltyCalcDate = penaltyCalcDate;
    }

    public Long getCompanyId() {
        return companyId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public String getCurrencyCode() {
        return currencyCode;
    }

    public void setCurrencyCode(String currencyCode) {
        this.currencyCode = currencyCode == null ? null : currencyCode.trim();
    }

    public String getPaymentMethod() {
        return paymentMethod;
    }

    public void setPaymentMethod(String paymentMethod) {
        this.paymentMethod = paymentMethod == null ? null : paymentMethod.trim();
    }

    public Long getBankAccountId() {
        return bankAccountId;
    }

    public void setBankAccountId(Long bankAccountId) {
        this.bankAccountId = bankAccountId;
    }

    public Long getBpId() {
        return bpId;
    }

    public void setBpId(Long bpId) {
        this.bpId = bpId;
    }

    public Long getBpBankAccountId() {
        return bpBankAccountId;
    }

    public void setBpBankAccountId(Long bpBankAccountId) {
        this.bpBankAccountId = bpBankAccountId;
    }

    public String getBpBankName() {
        return bpBankName;
    }

    public void setBpBankName(String bpBankName) {
        this.bpBankName = bpBankName == null ? null : bpBankName.trim();
    }

    public String getBpBankBranchName() {
        return bpBankBranchName;
    }

    public void setBpBankBranchName(String bpBankBranchName) {
        this.bpBankBranchName = bpBankBranchName == null ? null : bpBankBranchName.trim();
    }

    public String getBpBankAccountNum() {
        return bpBankAccountNum;
    }

    public void setBpBankAccountNum(String bpBankAccountNum) {
        this.bpBankAccountNum = bpBankAccountNum == null ? null : bpBankAccountNum.trim();
    }

    public String getBpBankAccountName() {
        return bpBankAccountName;
    }

    public void setBpBankAccountName(String bpBankAccountName) {
        this.bpBankAccountName = bpBankAccountName == null ? null : bpBankAccountName.trim();
    }

    public String getReversedFlag() {
        return reversedFlag;
    }

    public void setReversedFlag(String reversedFlag) {
        this.reversedFlag = reversedFlag == null ? null : reversedFlag.trim();
    }

    public Long getReversedTrxId() {
        return reversedTrxId;
    }

    public void setReversedTrxId(Long reversedTrxId) {
        this.reversedTrxId = reversedTrxId;
    }

    public Date getReversedDate() {
        return reversedDate;
    }

    public void setReversedDate(Date reversedDate) {
        this.reversedDate = reversedDate;
    }

    public String getPostedFlag() {
        return postedFlag;
    }

    public void setPostedFlag(String postedFlag) {
        this.postedFlag = postedFlag == null ? null : postedFlag.trim();
    }

    public Long getContractId() {
        return contractId;
    }

    public void setContractId(Long contractId) {
        this.contractId = contractId;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description == null ? null : description.trim();
    }

    public String getSourceDocCategory() {
        return sourceDocCategory;
    }

    public void setSourceDocCategory(String sourceDocCategory) {
        this.sourceDocCategory = sourceDocCategory == null ? null : sourceDocCategory.trim();
    }

    public Long getSourceDocId() {
        return sourceDocId;
    }

    public void setSourceDocId(Long sourceDocId) {
        this.sourceDocId = sourceDocId;
    }

    public Long getSourceDocLineId() {
        return sourceDocLineId;
    }

    public void setSourceDocLineId(Long sourceDocLineId) {
        this.sourceDocLineId = sourceDocLineId;
    }

    public String getCompanyName() {
        return companyName;
    }

    public void setCompanyName(String companyName) {
        this.companyName = companyName;
    }

    public String getCfDescription() {
        return cfDescription;
    }

    public void setCfDescription(String cfDescription) {
        this.cfDescription = cfDescription;
    }

    public String getTransactionDateFromStr() {
        return transactionDateFromStr;
    }

    public void setTransactionDateFromStr(String transactionDateFromStr) {
        this.transactionDateFromStr = transactionDateFromStr;
    }

    public String getTransactionDateToStr() {
        return transactionDateToStr;
    }

    public void setTransactionDateToStr(String transactionDateToStr) {
        this.transactionDateToStr = transactionDateToStr;
    }

    public CshTransaction(CshTransaction cshTransaction) {
        super();
        this.transactionId = cshTransaction.transactionId;
        this.transactionNum = cshTransaction.transactionNum;
        this.transactionCategory = cshTransaction.transactionCategory;
        this.transactionType = cshTransaction.transactionType;
        this.businessType = cshTransaction.businessType;
        this.transactionDate = cshTransaction.transactionDate;
        this.penaltyCalcDate = cshTransaction.penaltyCalcDate;
        this.companyId = cshTransaction.companyId;
        this.transactionAmount = cshTransaction.transactionAmount;
        this.currencyCode = cshTransaction.currencyCode;
        this.paymentMethod = cshTransaction.paymentMethod;
        this.bankSlipNum = cshTransaction.bankSlipNum;
        this.bankAccountId = cshTransaction.bankAccountId;
        this.bpId = cshTransaction.bpId;
        this.bpBankAccountId = cshTransaction.bpBankAccountId;
        this.bpBankName = cshTransaction.bpBankName;
        this.bpBankBranchName = cshTransaction.bpBankBranchName;
        this.bpBankAccountNum = cshTransaction.bpBankAccountNum;
        this.bpBankAccountName = cshTransaction.bpBankAccountName;
        this.reversedFlag = cshTransaction.reversedFlag;
        this.reversedTrxId = cshTransaction.reversedTrxId;
        this.reversedDate = cshTransaction.reversedDate;
        this.postedFlag = cshTransaction.postedFlag;
        this.contractId = cshTransaction.contractId;
        this.description = cshTransaction.description;
        this.sourceDocCategory = cshTransaction.sourceDocCategory;
        this.sourceDocId = cshTransaction.sourceDocId;
        this.sourceDocLineId = cshTransaction.sourceDocLineId;
        this.handlingCharge = cshTransaction.handlingCharge;
        this.writeOffFlag = cshTransaction.writeOffFlag;
        this.writeOffAmount = cshTransaction.writeOffAmount;
        this.fullWriteOffDate = cshTransaction.fullWriteOffDate;
    }

    @Override
    public String toString() {
        return "CshTransaction [transactionId=" + transactionId + ", transactionNum=" + transactionNum
                + ", transactionCategory=" + transactionCategory + ", transactionType=" + transactionType
                + ", businessType=" + businessType + ", transactionDate=" + transactionDate + ", penaltyCalcDate="
                + penaltyCalcDate + ", companyId=" + companyId + ", transactionAmount=" + transactionAmount
                + ", currencyCode=" + currencyCode + ", paymentMethod=" + paymentMethod + ", bankSlipNum=" + bankSlipNum
                + ", bankAccountId=" + bankAccountId + ", bpId=" + bpId + ", bpBankAccountId=" + bpBankAccountId
                + ", bpBankName=" + bpBankName + ", bpBankBranchName=" + bpBankBranchName + ", bpBankAccountNum="
                + bpBankAccountNum + ", bpBankAccountName=" + bpBankAccountName + ", reversedFlag=" + reversedFlag
                + ", reversedTrxId=" + reversedTrxId + ", reversedDate=" + reversedDate + ", postedFlag=" + postedFlag
                + ", contractId=" + contractId + ", description=" + description + ", sourceDocCategory="
                + sourceDocCategory + ", sourceDocId=" + sourceDocId + ", sourceDocLineId=" + sourceDocLineId
                + ", handlingCharge=" + handlingCharge + ", writeOffFlag=" + writeOffFlag + ", writeOffFlagTemp="
                + writeOffFlagTemp + ", writeOffAmount=" + writeOffAmount + ", fullWriteOffDate=" + fullWriteOffDate
                + ", transactionDateFrom=" + transactionDateFrom + ", transactionDateTo=" + transactionDateTo
                + ", transactionAmountFrom=" + transactionAmountFrom + ", transactionAmountTo=" + transactionAmountTo
                + ", bpName=" + bpName + ", bankAccountName=" + bankAccountName + ", bankAccountNum=" + bankAccountNum
                + ", returnWriteOffAmount=" + returnWriteOffAmount + ", sumWriteOffAmount=" + sumWriteOffAmount
                + ", canReturnAmount=" + canReturnAmount + ", returnDueAmount=" + returnDueAmount + ", bankAccountType="
                + bankAccountType + ", gatheringMethod=" + gatheringMethod + ", bpCode=" + bpCode + ", paymentObj="
                + paymentObj + ", contractName=" + contractName + ", paymentReqNumber=" + paymentReqNumber
                + ", writeOffDate=" + writeOffDate + ", Year=" + year + ", Month=" + month + ", newReceivables="
                + newReceivables + ", newReceivablesSum=" + newReceivablesSum + ", collectionRecoil=" + collectionRecoil
                + ", collectionRecoilSum=" + collectionRecoilSum + ", collectionVerification=" + collectionVerification
                + ", collectionVerificationSum=" + collectionVerificationSum + ", collectionRefund=" + collectionRefund
                + ", collectionRefundSum=" + collectionRefundSum + ", writeBack=" + writeBack + ", writeBackSum="
                + writeBackSum + ", refundRecoil=" + refundRecoil + ", refundRecoilSum=" + refundRecoilSum
                + ", companyName=" + companyName + ", userName=" + userName + ", cfDescription=" + cfDescription
                + ", bankName=" + bankName + ", creditCshWriteOffs=" + creditCshWriteOffs + ", advanceCshWriteOffs="
                + advanceCshWriteOffs + ", depositCshWriteOffs=" + depositCshWriteOffs + "]";
    }

}
