package hls.core.csh.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.hand.hap.core.BaseConstants;
import com.hand.hap.mybatis.annotation.Condition;
import com.hand.hap.system.dto.BaseDTO;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Transient;
import java.util.Date;

/**
 * Created by lpc on 2017/9/30.
 */
public class CshWriteOff extends BaseDTO {
    @Id
    @GeneratedValue
    private Long writeOffId;

    private String writeOffType;

    private Date writeOffDate;

    private Long cshTransactionId;

    private Double cshWriteOffAmount;

    private Long subsequentCshTrxId;

    private Double subseqCshWriteOffAmount;

    private String reversedFlag;

    private Long reversedWriteOffId;

    private Date reversedDate;

    private Long cashflowId;
    @Condition(operator = LIKE)
    private Long contractId;

    private Long times;

    private Long cfItem;

    private Long cfType;

    private String description;

    private String writeOffDocCategory;//核销单据类别

    private Long withdrawId;//融资合同提款现金流id

    private Long repaymentId;//融资合同还款现金流id

    private Long withdrawCfId;//保理合同提款单现金流id

    private Date lastUpdateDate;

    @Override
    public Date getLastUpdateDate() {
        return lastUpdateDate;
    }

    @Override
    public void setLastUpdateDate(Date lastUpdateDate) {
        this.lastUpdateDate = lastUpdateDate;
    }

    @Transient
    private String bankSlipNum;//融资还款-核销明细- 银行流水号
    @Transient
    private Double withdrawAmount;//融资还款-核销明细-提款金额
    @Transient
    private String withdrawNumber;//融资还款-核销明细-提款编号

    public String getBankSlipNum() {
        return bankSlipNum;
    }

    public void setBankSlipNum(String bankSlipNum) {
        this.bankSlipNum = bankSlipNum;
    }

    public Double getWithdrawAmount() {
        return withdrawAmount;
    }

    public void setWithdrawAmount(Double withdrawAmount) {
        this.withdrawAmount = withdrawAmount;
    }

    public String getWithdrawNumber() {
        return withdrawNumber;
    }

    public void setWithdrawNumber(String withdrawNumber) {
        this.withdrawNumber = withdrawNumber;
    }

    private Double writeOffDueAmount;

    @Transient
    private String writeOffPrincipalFormat;

    @Transient
    private String writeOffInterestFormat;

    @Transient
    private String writeOffDueAmountFormat;


    @Transient
    private Date dayEndDate;

    @Transient
    private Date penaltyCalcDate;


    @Transient
    private String currencyCode;

    public Long getRepaymentId() {
        return repaymentId;
    }

    public void setRepaymentId(Long repaymentId) {
        this.repaymentId = repaymentId;
    }

    public Long getWithdrawCfId() {
        return withdrawCfId;
    }

    public void setWithdrawCfId(Long withdrawCfId) {
        this.withdrawCfId = withdrawCfId;
    }

    public Long getWithdrawId() {
        return withdrawId;
    }

    public void setWithdrawId(Long withdrawId) {
        this.withdrawId = withdrawId;
    }

    public String getWriteOffDocCategory() {
        return writeOffDocCategory;
    }

    public void setWriteOffDocCategory(String writeOffDocCategory) {
        this.writeOffDocCategory = writeOffDocCategory;
    }

    public String getCurrencyCode() {
        return currencyCode;
    }

    public void setCurrencyCode(String currencyCode) {
        this.currencyCode = currencyCode;
    }

    public Date getPenaltyCalcDate() {
        return penaltyCalcDate;
    }

    public void setPenaltyCalcDate(Date penaltyCalcDate) {
        this.penaltyCalcDate = penaltyCalcDate;
    }

    public Date getDayEndDate() {
        return dayEndDate;
    }

    public void setDayEndDate(Date dayEndDate) {
        this.dayEndDate = dayEndDate;
    }

    public String getWriteOffPrincipalFormat() {
        return writeOffPrincipalFormat;
    }

    public void setWriteOffPrincipalFormat(String writeOffPrincipalFormat) {
        this.writeOffPrincipalFormat = writeOffPrincipalFormat;
    }

    public String getWriteOffInterestFormat() {
        return writeOffInterestFormat;
    }

    public void setWriteOffInterestFormat(String writeOffInterestFormat) {
        this.writeOffInterestFormat = writeOffInterestFormat;
    }

    public String getWriteOffDueAmountFormat() {
        return writeOffDueAmountFormat;
    }

    public void setWriteOffDueAmountFormat(String writeOffDueAmountFormat) {
        this.writeOffDueAmountFormat = writeOffDueAmountFormat;
    }

    private Double writeOffPrincipal;

    private Double writeOffInterest;

    private Long paymentReqLineId;

    private Long paymentReqId;

    @Transient
    private Date writeOffDateFrom; // 核销日期从
    @Transient
    private Date writeOffDateTo; // 核销日期到
    @Transient
    private Double cshWriteOffAmountFrom; // 核销金额从
    @Transient
    private Double cshWriteOffAmountTo; // 核销金额到
    @Transient
    private String bpName; // 承租人
    @Transient
    private String transactionNum; // 收款编号

    @Transient
    private Date transactionDate; // 事务日期

    @Transient
    @Condition(operator = LIKE)
    private String contractNumber; // 合同编号
    @Transient
    private Double transactionAmount; // 收款金额
    @Transient
    private String bankAccountName; // 公司收款账户
    @Transient
    private String bankAccountNum; // 公司收款账号
    @Transient
    private Long bankAccountId;

    @Transient
    @Condition(operator = LIKE)
    private String contractName; // 合同名称

    @Transient
    private String cfItemDesc;

    @Transient
    private Double surplusAmount;

    @Transient
    private String cfTypeDesc;

    @Transient
    private String bankBranchName;

    @Transient
    private String companyShortName;

    @Transient
    private String bpBankAccountName;

    @Transient
    private String accountNum;

    @Transient
    private Long companyId;

    @Transient
    private String writeOffFlag;
    @Transient
    private Date fullWriteOffDate;
    @Transient
    private Long transactionId;
    @Transient
    private Date lastReceiveDate;

    @Transient
    private Double dueAmount;
    @Transient
    private Long bpId;
    @Transient
    @JsonFormat(pattern = BaseConstants.DATE_FORMAT)
    private Date dueDate;
    @Transient
    private String depositFrom;
    @Transient
    private Date startWriteOffDate;
    @Transient
    private Date endWriteOffDate;
    @Transient
    private Double startWriteOffAmount;
    @Transient
    private Double endWriteOffAmount;
    @Transient
    private Long wId;
    @Transient
    private String rFlag;
    @Transient
    private String division;
    @Transient
    private String documentType;

    @Transient
    private Double conlNUM;
    @Transient
    private Double conlbNUM;

    @Transient
    private Long writeOffMonth; // 公司收款账号

    @Transient
    private String bpBankAccountNum;
    // 款项支付新增的属性
    @Transient
    private HlsCusCshTransaction cshTransaction;

    // 付款反冲界面传递的备注参数
    @Transient
    private String remarks;
    @Transient
    private String paymentMethod;
    @Transient
    private String strDate;
    @Transient
    public static final String RECEIPT_CREDIT = "RECEIPT_CREDIT";  //收款核销债权类型
    @Transient
    public static final String ADVANCE_RECEIPT_CREDIT = "ADVANCE_RECEIPT_CREDIT"; //预收款核销债权类型
    @Transient
    public static final String RECEIPT_ADVANCE_RECEIPT = "RECEIPT_ADVANCE_RECEIPT";  //收款核销为预收款类型
    @Transient
    public static final String RECEIPT_DEPOSIT = "RECEIPT_DEPOSIT";  //收款核销保证金
    @Transient
    public static final String RECEIPT_DEPOSIT_POOL = "RECEIPT_DEPOSIT_POOL"; //收款核销保证金池
    @Transient
    public static final String PAYMENT_DEBT = "PAYMENT_DEBT";  //付款核销债务
    @Transient
    public static final String REFUND = "REFUND";  //现金退款
    @Transient
    private String billing_status;
    @Transient
    private Long queryTimeSolt;
    @Transient
    private Long timeCount;
    @Transient
    private Date LAST_UPDATE_DATE;
    @Transient
    private String userName;
    @Transient
    private String billingStatus;

    @Transient
    private String cf_direction;


    public Long getCompanyId() {
        return companyId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public String getCf_direction() {
        return cf_direction;
    }

    public String getBillingStatus() {
        return billingStatus;
    }

    public Long getBankAccountId() {
        return bankAccountId;
    }

    public void setBankAccountId(Long bankAccountId) {
        this.bankAccountId = bankAccountId;
    }

    public void setBillingStatus(String billingStatus) {
        this.billingStatus = billingStatus;
    }

    public void setCf_direction(String cf_direction) {
        this.cf_direction = cf_direction;
    }

    public Date getLAST_UPDATE_DATE() {
        return LAST_UPDATE_DATE;
    }

    public void setLAST_UPDATE_DATE(Date LAST_UPDATE_DATE) {
        this.LAST_UPDATE_DATE = LAST_UPDATE_DATE;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getStrDate() {
        return strDate;
    }

    public void setStrDate(String strDate) {
        this.strDate = strDate;
    }

    public Long getTimeCount() {
        return timeCount;
    }

    public void setTimeCount(Long timeCount) {
        this.timeCount = timeCount;
    }

    public Long getQueryTimeSolt() {
        return queryTimeSolt;
    }

    public void setQueryTimeSolt(Long queryTimeSolt) {
        this.queryTimeSolt = queryTimeSolt;
    }

    public String getBilling_status() {
        return billing_status;
    }

    public void setBilling_status(String billing_status) {
        this.billing_status = billing_status;
    }

    public Date getLastReceiveDate() {
        return lastReceiveDate;
    }

    public void setLastReceiveDate(Date lastReceiveDate) {
        this.lastReceiveDate = lastReceiveDate;
    }

    public String getAccountNum() {
        return accountNum;
    }

    public void setAccountNum(String accountNum) {
        this.accountNum = accountNum;
    }

    public String getWriteOffFlag() {
        return writeOffFlag;
    }

    public void setWriteOffFlag(String writeOffFlag) {
        this.writeOffFlag = writeOffFlag;
    }

    public Date getFullWriteOffDate() {
        return fullWriteOffDate;
    }

    public void setFullWriteOffDate(Date fullWriteOffDate) {
        this.fullWriteOffDate = fullWriteOffDate;
    }

    public Long getTransactionId() {
        return transactionId;
    }

    public void setTransactionId(Long transactionId) {
        this.transactionId = transactionId;
    }

    public Double getDueAmount() {
        return dueAmount;
    }

    public void setDueAmount(Double dueAmount) {
        this.dueAmount = dueAmount;
    }

    public Long getBpId() {
        return bpId;
    }

    public void setBpId(Long bpId) {
        this.bpId = bpId;
    }

    public Date getDueDate() {
        return dueDate;
    }

    public void setDueDate(Date dueDate) {
        this.dueDate = dueDate;
    }

    public String getDepositFrom() {
        return depositFrom;
    }

    public void setDepositFrom(String depositFrom) {
        this.depositFrom = depositFrom;
    }

    public Date getStartWriteOffDate() {
        return startWriteOffDate;
    }

    public void setStartWriteOffDate(Date startWriteOffDate) {
        this.startWriteOffDate = startWriteOffDate;
    }

    public Date getEndWriteOffDate() {
        return endWriteOffDate;
    }

    public void setEndWriteOffDate(Date endWriteOffDate) {
        this.endWriteOffDate = endWriteOffDate;
    }

    public Double getStartWriteOffAmount() {
        return startWriteOffAmount;
    }

    public void setStartWriteOffAmount(Double startWriteOffAmount) {
        this.startWriteOffAmount = startWriteOffAmount;
    }

    public Double getEndWriteOffAmount() {
        return endWriteOffAmount;
    }

    public void setEndWriteOffAmount(Double endWriteOffAmount) {
        this.endWriteOffAmount = endWriteOffAmount;
    }

    public Long getwId() {
        return wId;
    }

    public void setwId(Long wId) {
        this.wId = wId;
    }

    public String getrFlag() {
        return rFlag;
    }

    public void setrFlag(String rFlag) {
        this.rFlag = rFlag;
    }


    public Double getConlNUM() {
        return conlNUM;
    }

    public void setConlNUM(Double conlNUM) {
        this.conlNUM = conlNUM;
    }

    public Double getConlbNUM() {
        return conlbNUM;
    }

    public void setConlbNUM(Double conlbNUM) {
        this.conlbNUM = conlbNUM;
    }

    @Transient
    private String queryCondition;


    public String getQueryCondition() {
        return queryCondition;
    }

    public void setQueryCondition(String queryCondition) {
        this.queryCondition = queryCondition;
    }

    public Long getWriteOffMonth() {
        return writeOffMonth;
    }

    public void setWriteOffMonth(Long writeOffMonth) {
        this.writeOffMonth = writeOffMonth;
    }


    public String getDocumentType() {
        return documentType;
    }

    public void setDocumentType(String documentType) {
        this.documentType = documentType;
    }

    public String getDivision() {
        return division;
    }

    public void setDivision(String division) {
        this.division = division;
    }

    public String getBankBranchName() {
        return bankBranchName;
    }

    public void setBankBranchName(String bankBranchName) {
        this.bankBranchName = bankBranchName;
    }

    public String getCompanyShortName() {
        return companyShortName;
    }

    public void setCompanyShortName(String companyShortName) {
        this.companyShortName = companyShortName;
    }

    public String getBpBankAccountName() {
        return bpBankAccountName;
    }

    public void setBpBankAccountName(String bpBankAccountName) {
        this.bpBankAccountName = bpBankAccountName;
    }

    public String getBpBankAccountNum() {
        return bpBankAccountNum;
    }

    public void setBpBankAccountNum(String bpBankAccountNum) {
        this.bpBankAccountNum = bpBankAccountNum;
    }

    public String getPaymentMethod() {
        return paymentMethod;
    }

    public void setPaymentMethod(String paymentMethod) {
        this.paymentMethod = paymentMethod;
    }

    public String getCfItemDesc() {
        return cfItemDesc;
    }

    public void setCfItemDesc(String cfItemDesc) {
        this.cfItemDesc = cfItemDesc;
    }

    public String getCfTypeDesc() {
        return cfTypeDesc;
    }

    public void setCfTypeDesc(String cfTypeDesc) {
        this.cfTypeDesc = cfTypeDesc;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getTransactionNum() {
        return transactionNum;
    }

    public void setTransactionNum(String transactionNum) {
        this.transactionNum = transactionNum;
    }

    public String getContractNumber() {
        return contractNumber;
    }

    public void setContractNumber(String contractNumber) {
        this.contractNumber = contractNumber;
    }


    public Date getWriteOffDateFrom() {
        return writeOffDateFrom;
    }

    public void setWriteOffDateFrom(Date writeOffDateFrom) {
        this.writeOffDateFrom = writeOffDateFrom;
    }

    public Date getWriteOffDateTo() {
        return writeOffDateTo;
    }

    public void setWriteOffDateTo(Date writeOffDateTo) {
        this.writeOffDateTo = writeOffDateTo;
    }


    public String getBpName() {
        return bpName;
    }

    public void setBpName(String bpName) {
        this.bpName = bpName;
    }

    public Long getWriteOffId() {
        return writeOffId;
    }

    public void setWriteOffId(Long writeOffId) {
        this.writeOffId = writeOffId;
    }

    public String getWriteOffType() {
        return writeOffType;
    }

    public void setWriteOffType(String writeOffType) {
        this.writeOffType = writeOffType == null ? null : writeOffType.trim();
    }

    public Date getWriteOffDate() {
        return writeOffDate;
    }

    public void setWriteOffDate(Date writeOffDate) {
        this.writeOffDate = writeOffDate;
    }

    public Long getCshTransactionId() {
        return cshTransactionId;
    }

    public void setCshTransactionId(Long cshTransactionId) {
        this.cshTransactionId = cshTransactionId;
    }


    public HlsCusCshTransaction getCshTransaction() {
        return cshTransaction;
    }

    public void setCshTransaction(HlsCusCshTransaction cshTransaction) {
        this.cshTransaction = cshTransaction;
    }


    public Long getSubsequentCshTrxId() {
        return subsequentCshTrxId;
    }

    public void setSubsequentCshTrxId(Long subsequentCshTrxId) {
        this.subsequentCshTrxId = subsequentCshTrxId;
    }


    public String getReversedFlag() {
        return reversedFlag;
    }

    public void setReversedFlag(String reversedFlag) {
        this.reversedFlag = reversedFlag == null ? null : reversedFlag.trim();
    }

    public Long getReversedWriteOffId() {
        return reversedWriteOffId;
    }

    public void setReversedWriteOffId(Long reversedWriteOffId) {
        this.reversedWriteOffId = reversedWriteOffId;
    }

    public Date getReversedDate() {
        return reversedDate;
    }

    public void setReversedDate(Date reversedDate) {
        this.reversedDate = reversedDate;
    }

    public Long getCashflowId() {
        return cashflowId;
    }

    public void setCashflowId(Long cashflowId) {
        this.cashflowId = cashflowId;
    }

    public Long getContractId() {
        return contractId;
    }

    public void setContractId(Long contractId) {
        this.contractId = contractId;
    }

    public Long getTimes() {
        return times;
    }

    public void setTimes(Long times) {
        this.times = times;
    }

    public Long getCfItem() {
        return cfItem;
    }

    public void setCfItem(Long cfItem) {
        this.cfItem = cfItem;
    }

    public Long getCfType() {
        return cfType;
    }

    public void setCfType(Long cfType) {
        this.cfType = cfType;
    }


    public String getContractName() {
        return contractName;
    }

    public void setContractName(String contractName) {
        this.contractName = contractName;
    }

    public String getRemarks() {
        return remarks;
    }

    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }

    public Double getCshWriteOffAmount() {
        return cshWriteOffAmount;
    }

    public void setCshWriteOffAmount(Double cshWriteOffAmount) {
        this.cshWriteOffAmount = cshWriteOffAmount;
    }

    public Double getSubseqCshWriteOffAmount() {
        return subseqCshWriteOffAmount;
    }

    public void setSubseqCshWriteOffAmount(Double subseqCshWriteOffAmount) {
        this.subseqCshWriteOffAmount = subseqCshWriteOffAmount;
    }

    public Double getWriteOffDueAmount() {
        return writeOffDueAmount;
    }

    public void setWriteOffDueAmount(Double writeOffDueAmount) {
        this.writeOffDueAmount = writeOffDueAmount;
    }

    public Double getWriteOffPrincipal() {
        return writeOffPrincipal;
    }

    public void setWriteOffPrincipal(Double writeOffPrincipal) {
        this.writeOffPrincipal = writeOffPrincipal;
    }

    public Double getWriteOffInterest() {
        return writeOffInterest;
    }

    public void setWriteOffInterest(Double writeOffInterest) {
        this.writeOffInterest = writeOffInterest;
    }

    public Double getCshWriteOffAmountFrom() {
        return cshWriteOffAmountFrom;
    }

    public void setCshWriteOffAmountFrom(Double cshWriteOffAmountFrom) {
        this.cshWriteOffAmountFrom = cshWriteOffAmountFrom;
    }

    public Double getCshWriteOffAmountTo() {
        return cshWriteOffAmountTo;
    }

    public void setCshWriteOffAmountTo(Double cshWriteOffAmountTo) {
        this.cshWriteOffAmountTo = cshWriteOffAmountTo;
    }

    public Double getTransactionAmount() {
        return transactionAmount;
    }

    public void setTransactionAmount(Double transactionAmount) {
        this.transactionAmount = transactionAmount;
    }

    public String getBankAccountName() {
        return bankAccountName;
    }

    public void setBankAccountName(String bankAccountName) {
        this.bankAccountName = bankAccountName;
    }

    public String getBankAccountNum() {
        return bankAccountNum;
    }

    public void setBankAccountNum(String bankAccountNum) {
        this.bankAccountNum = bankAccountNum;
    }

    public Double getSurplusAmount() {
        return surplusAmount;
    }

    public void setSurplusAmount(Double surplusAmount) {
        this.surplusAmount = surplusAmount;
    }

    public Long getPaymentReqLineId() {
        return paymentReqLineId;
    }

    public void setPaymentReqLineId(Long paymentReqLineId) {
        this.paymentReqLineId = paymentReqLineId;
    }

    public Long getPaymentReqId() {
        return paymentReqId;
    }

    public void setPaymentReqId(Long paymentReqId) {
        this.paymentReqId = paymentReqId;
    }

    public Date getTransactionDate() {
        return transactionDate;
    }

    public void setTransactionDate(Date transactionDate) {
        this.transactionDate = transactionDate;
    }

    public CshWriteOff() {
        super();
    }

    public CshWriteOff(CshWriteOff cshWriteOff) {
        super();
        this.writeOffId = cshWriteOff.writeOffId;
        this.writeOffType = cshWriteOff.writeOffType;
        this.writeOffDate = cshWriteOff.writeOffDate;
        this.cshTransactionId = cshWriteOff.cshTransactionId;
        this.cshWriteOffAmount = cshWriteOff.cshWriteOffAmount;
        this.subsequentCshTrxId = cshWriteOff.subsequentCshTrxId;
        this.subseqCshWriteOffAmount = cshWriteOff.subseqCshWriteOffAmount;
        this.reversedFlag = cshWriteOff.reversedFlag;
        this.reversedWriteOffId = cshWriteOff.reversedWriteOffId;
        this.reversedDate = cshWriteOff.reversedDate;
        this.cashflowId = cshWriteOff.cashflowId;
        this.contractId = cshWriteOff.contractId;
        this.times = cshWriteOff.times;
        this.cfItem = cshWriteOff.cfItem;
        this.cfType = cshWriteOff.cfType;
        this.description = cshWriteOff.description;
        this.writeOffDueAmount = cshWriteOff.writeOffDueAmount;
        this.writeOffPrincipal = cshWriteOff.writeOffPrincipal;
        this.writeOffInterest = cshWriteOff.writeOffInterest;
        this.paymentReqLineId = cshWriteOff.paymentReqLineId;
        this.paymentReqId = cshWriteOff.paymentReqId;
        this.writeOffDateFrom = cshWriteOff.writeOffDateFrom;
        this.writeOffDateTo = cshWriteOff.writeOffDateTo;
        this.cshWriteOffAmountFrom = cshWriteOff.cshWriteOffAmountFrom;
        this.cshWriteOffAmountTo = cshWriteOff.cshWriteOffAmountTo;
        this.bpName = cshWriteOff.bpName;
        this.transactionNum = cshWriteOff.transactionNum;
        this.contractNumber = cshWriteOff.contractNumber;
        this.transactionAmount = cshWriteOff.transactionAmount;
        this.bankAccountName = cshWriteOff.bankAccountName;
        this.bankAccountNum = cshWriteOff.bankAccountNum;
        this.contractName = cshWriteOff.contractName;
        this.cfItemDesc = cshWriteOff.cfItemDesc;
        this.cfTypeDesc = cshWriteOff.cfTypeDesc;
        this.cshTransaction = cshWriteOff.cshTransaction;
        this.remarks = cshWriteOff.remarks;
        this.surplusAmount = cshWriteOff.surplusAmount;
    }

    @Override
    public String toString() {
        return "CshWriteOff [writeOffId=" + writeOffId + ", writeOffType=" + writeOffType + ", writeOffDate="
                + writeOffDate + ", cshTransactionId=" + cshTransactionId + ", cshWriteOffAmount=" + cshWriteOffAmount
                + ", subsequentCshTrxId=" + subsequentCshTrxId + ", subseqCshWriteOffAmount=" + subseqCshWriteOffAmount
                + ", reversedFlag=" + reversedFlag + ", reversedWriteOffId=" + reversedWriteOffId + ", reversedDate="
                + reversedDate + ", cashflowId=" + cashflowId + ", contractId=" + contractId + ", times=" + times
                + ", cfItem=" + cfItem + ", cfType=" + cfType + ", description=" + description + ", writeOffDueAmount="
                + writeOffDueAmount + ", writeOffPrincipal=" + writeOffPrincipal + ", writeOffInterest="
                + writeOffInterest + ", paymentReqLineId=" + paymentReqLineId + ", paymentReqId=" + paymentReqId
                + ", writeOffDateFrom=" + writeOffDateFrom + ", writeOffDateTo=" + writeOffDateTo
                + ", cshWriteOffAmountFrom=" + cshWriteOffAmountFrom + ", cshWriteOffAmountTo=" + cshWriteOffAmountTo
                + ", bpName=" + bpName + ", transactionNum=" + transactionNum + ", contractNumber=" + contractNumber
                + ", transactionAmount=" + transactionAmount + ", bankAccountName=" + bankAccountName
                + ", bankAccountNum=" + bankAccountNum + ", contractName=" + contractName + ", cfItemDesc=" + cfItemDesc
                + ", surplusAmount=" + surplusAmount + ", cfTypeDesc=" + cfTypeDesc + ", bankBranchName="
                + bankBranchName + ", companyShortName=" + companyShortName + ", bpBankAccountName=" + bpBankAccountName
                + ", accountNum=" + accountNum + ", writeOffFlag=" + writeOffFlag + ", fullWriteOffDate="
                + fullWriteOffDate + ", transactionId=" + transactionId + ", lastReceiveDate=" + lastReceiveDate
                + ", dueAmount=" + dueAmount + ", bpId=" + bpId + ", dueDate=" + dueDate + ", depositFrom="
                + depositFrom + ", startWriteOffDate=" + startWriteOffDate + ", endWriteOffDate=" + endWriteOffDate
                + ", startWriteOffAmount=" + startWriteOffAmount + ", endWriteOffAmount=" + endWriteOffAmount + ", wId="
                + wId + ", rFlag=" + rFlag + ", division=" + division + ", documentType=" + documentType + ", conlNUM="
                + conlNUM + ", conlbNUM=" + conlbNUM + ", writeOffMonth=" + writeOffMonth + ", bpBankAccountNum="
                + bpBankAccountNum + ", cshTransaction=" + cshTransaction + ", remarks=" + remarks + ", paymentMethod="
                + paymentMethod + ", billing_status=" + billing_status + ", queryTimeSolt=" + queryTimeSolt
                + ", timeCount=" + timeCount + ", queryCondition=" + queryCondition + "]";
    }
}
