package hls.core.csh.dto;

import com.hand.hap.system.dto.BaseDTO;
import org.hibernate.validator.constraints.Length;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Transient;
import javax.validation.constraints.NotNull;
import java.util.Date;

/**
 * Created by wangyan on 2017/9/27.
 */
public class TransactionRelation extends BaseDTO {
    public static final String FIELD_TRX_RELATION_ID = "trxRelationId";
    public static final String FIELD_TRANSACTION_ID = "transactionId";
    public static final String FIELD_RELATION_DOC_CATEGORY = "relationDocCategory";
    public static final String FIELD_RELATION_DOC_ID = "relationDocId";
    public static final String FIELD_RELATION_DATE = "relationDate";
    public static final String FIELD_DESCRIPTION = "description";


    @Id
    @GeneratedValue
    private Long trxRelationId; //关联ID

    @NotNull
    private Long transactionId; //现金事务ID

    @Length(max = 100)
    private String relationDocCategory; //关联单据类别

    private Long relationDocId; //关联单据ID

    private Date relationDate; //关联日期

    @Length(max = 1000)
    private String description; //说明

    @Transient
    private Date transactionDate;//现金事务交易日期
    @Transient
    private String transactionNum;//交易编号
    @Transient
    private Long bpId;//承租人ID
    @Transient
    private String bpName;//承租人名称
    @Transient
    private String bankSlipNum;//交易号
    @Transient
    private Double transactionAmount;//交易金额
    @Transient
    private  String bankAccountName;//银行账户名
    @Transient
    private  String bankAccountNum;//银行账户
    @Transient
    private  String writeOffFlag;//核销状态
    @Transient
    private  String writeOffFlagDesc;//核销状态名称
    @Transient
    private  String businessType;//交易类型
    @Transient
    private  String bankName;//银行名称
    @Transient
    private Long companyId;//公司ID

    public Long getCompanyId() {
        return companyId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public Date getTransactionDate() {
        return transactionDate;
    }

    public void setTransactionDate(Date transactionDate) {
        this.transactionDate = transactionDate;
    }

    public String getTransactionNum() {
        return transactionNum;
    }

    public void setTransactionNum(String transactionNum) {
        this.transactionNum = transactionNum;
    }

    public Long getBpId() {
        return bpId;
    }

    public void setBpId(Long bpId) {
        this.bpId = bpId;
    }

    public String getBpName() {
        return bpName;
    }

    public void setBpName(String bpName) {
        this.bpName = bpName;
    }

    public String getBankSlipNum() {
        return bankSlipNum;
    }

    public void setBankSlipNum(String bankSlipNum) {
        this.bankSlipNum = bankSlipNum;
    }

    public Double getTransactionAmount() {
        return transactionAmount;
    }

    public void setTransactionAmount(Double transactionAmount) {
        this.transactionAmount = transactionAmount;
    }

    public String getBankAccountName() {
        return bankAccountName;
    }

    public void setBankAccountName(String bankAccountName) {
        this.bankAccountName = bankAccountName;
    }

    public String getBankAccountNum() {
        return bankAccountNum;
    }

    public void setBankAccountNum(String bankAccountNum) {
        this.bankAccountNum = bankAccountNum;
    }

    public String getWriteOffFlag() {
        return writeOffFlag;
    }

    public void setWriteOffFlag(String writeOffFlag) {
        this.writeOffFlag = writeOffFlag;
    }

    public String getWriteOffFlagDesc() {
        return writeOffFlagDesc;
    }

    public void setWriteOffFlagDesc(String writeOffFlagDesc) {
        this.writeOffFlagDesc = writeOffFlagDesc;
    }

    public String getBusinessType() {
        return businessType;
    }

    public void setBusinessType(String businessType) {
        this.businessType = businessType;
    }

    public String getBankName() {
        return bankName;
    }

    public void setBankName(String bankName) {
        this.bankName = bankName;
    }

    public void setTrxRelationId(Long trxRelationId){
        this.trxRelationId = trxRelationId;
    }

    public Long getTrxRelationId(){
        return trxRelationId;
    }

    public void setTransactionId(Long transactionId){
        this.transactionId = transactionId;
    }

    public Long getTransactionId(){
        return transactionId;
    }

    public void setRelationDocCategory(String relationDocCategory){
        this.relationDocCategory = relationDocCategory;
    }

    public String getRelationDocCategory(){
        return relationDocCategory;
    }

    public void setRelationDocId(Long relationDocId){
        this.relationDocId = relationDocId;
    }

    public Long getRelationDocId(){
        return relationDocId;
    }

    public void setRelationDate(Date relationDate){
        this.relationDate = relationDate;
    }

    public Date getRelationDate(){
        return relationDate;
    }

    public void setDescription(String description){
        this.description = description;
    }

    public String getDescription(){
        return description;
    }
}
