package hls.core.csh.mapper;

import com.hand.hap.mybatis.common.Mapper;
import hls.core.cont.dto.ConAging;
import hls.core.csh.dto.*;
import hls.core.hls.bp.dto.HlsCusBpMaster;
import hls.core.vat.dto.HlsCusAcrInvoiceHd;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;


public interface ConContractCashflowMapper<T extends HlsCusConContractCashflow> extends Mapper<HlsCusConContractCashflow>{

	public List<HlsCusConContractCashflow> selectAllConContractCashflow(HlsCusConContractCashflow cashflow);

	public List<Map> query4depositMgr() throws Exception;

	public HlsCusConContractCashflow selectConContractCashflow(Long cashflow_id);

	public List<HlsCusConContractCashflow> selectAllConContractCashflowID(HlsCusConContractCashflow cashflow);

	public List<Map> queryDepositDetail(@Param("contractId")Long contractId) throws Exception;

	public List<Map> queryPoolDetail(@Param("bpId")Long bpId) throws Exception;

	public List<Map> query4PoolDepositMgr() throws Exception;

	public List<HlsCusConContractCashflow> selectOneConContract(HlsCusConContractCashflow cashflow);

	public void updateOne(HlsCusConContractCashflow cashflow);

	List<Map> query4Recall(HlsCusCshDeduction deduction);

	public List<HlsCusConContractCashflow> selectLovItem();

	List<Map> query4Back(HlsCusCshDeduction deduction);

	public void updateConContractCashflow(HlsCusConContractCashflow cashflow);

	public List<HlsCusConContractCashflow> contractCashFlowDetail(Map<String, Object> params);

	public List<HlsCusConContractCashflow> contractCashFlowOverDateDetail();

	public void insertConContractCashflow(HlsCusConContractCashflow cashflow);

	public Double getCurrentWeekOverDueAmount();
	public Double getYesterdayOverDueAmount();
	public Double getTodayOverDueAmount();
	public Double getTotalOverDueAmount();

	public List<HlsCusConContractCashflow> getLastWeekOverDueAmount();

	public HlsCusConContractCashflow selectInformationStatistics(HlsCusConContractCashflow cashflow);

	public Map selectInformationAllStatistics(HlsCusConContractCashflow cashflow);

	public ConAging SelectDueAmount(HlsCusConContractCashflow cashflow);

	public HlsCusConContractCashflow selectDueAmountInDiff(HlsCusConContractCashflow cashflow);

	public List<HlsCusConContractCashflow> selectRentBackInfo(HlsCusConContractCashflow cashflow);

	List<HlsCusConContractCashflow> selectRentBackStatus(@Param("contract_id")Long contract_id);

	public  List<HlsCusConContractCollection>  selectHisOfRentBackIf();

	public void updateOneConContractCashflow(HlsCusConContractCashflow cashflow);

	public List<HlsCusConContractCashflow> selectHireConContractCashflow(HlsCusConContractCashflow conContractCashflow);

	public HlsCusConContractCashflow selectOverdueCount(HlsCusConContractCashflow conContractCashflow);

	public List<HlsCusConContractCashflow> vatQuery(Map<String, Object> params);

	public HlsCusCshFundStatistics selectRiskExposure(HlsCusBpMaster hlsCusBpMaster);

	public HlsCusCshFundStatistics selectRiskGuarantorExposure(HlsCusBpMaster hlsCusBpMaster);

	List<HlsCusConContractCashflow> debtQuery(Map<String, String> map);

	public List<HlsCusConContractCashflow> selectAllConContractCashflowLov(HlsCusConContractCashflow cashflow);
	public List<HlsCusConContractCashflow> queryConContratCashFlowById(Long cashflowId);

	public void deleteByContractId(Long contractId);

	List<HlsCusConContractCashflow> selectCalcPenaltyCashFlowByConId(HlsCusConContractCashflow cashflow);
	List<HlsCusConContractCashflow> selectCalcPenaltyCashFlowBySourceId(HlsCusConContractCashflow cashflow);
	List<HlsCusConContractCashflow> selectCashFlowByContractId(Long contractId);

	List<HlsCusConContractCashflow> selectOverdueCashflow(HlsCusConContractCashflow cashflow);
	List<HlsCusConContractCashflow> selectCalculateCashflow(HlsCusConDebtExemptionReq conDebtExemptionReq);

	List<HlsCusConContractCashflow> selectCanInvoiceCashFlow(HlsCusAcrInvoiceHd acrInvoiceHd);
	/*合同变更 - 查询未完全核销现金流信息 */
	List<HlsCusConContractCashflow> queryReceivedWriteOff(HlsCusConContractCashflow cashflow);

	/* for contract_cashflow lov*/
	List<HlsCusConContractCashflow> selectCashflow(HlsCusConContractCashflow cashflow);

}
