package hls.core.csh.mapper;

import com.hand.hap.mybatis.common.Mapper;
import hls.core.cont.dto.HlsCusConContractChangeReq;
import hls.core.cont.dto.HlsCusConContractStatus;
import hls.core.csh.dto.HlsCusConContractCollection;
import hls.core.csh.dto.HlsCusCshConContract;
import hls.core.hls.bp.dto.HlsCusBpMaster;
import hls.core.hls.bp.dto.HlsCusBpMasterBankAccount;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;


public interface CshConContractMapper<T extends HlsCusCshConContract>  extends Mapper<HlsCusCshConContract>{

	
	public List<HlsCusCshConContract> selectAllConContract(HlsCusCshConContract conContract);
	
	public List<HlsCusBpMasterBankAccount> selectBank(HlsCusCshConContract conContract);

	List<HlsCusCshConContract> getContractsByNumberOrName(HlsCusCshConContract conContract);

	public List<HlsCusCshConContract> getContractInfo(Map<String, Object> params);

	public List<HlsCusCshConContract> contractDetail(HlsCusCshConContract conContract);
	
	public List<HlsCusCshConContract> getTenantryContractDetailByBpId(HlsCusCshConContract conContract);
	
	public List<HlsCusCshConContract> getSecurityContractDetailByBpId(HlsCusCshConContract conContract);
	
	public List<HlsCusCshConContract> selectConContract(HlsCusCshConContract conContract);
	
	public void updateConContractStatus(HlsCusCshConContract conContract);
	
	public List<HlsCusCshConContract> getConContractIndexNumInfo();

	public List<HlsCusCshConContract> contractAmountQuery(@Param("index") int index);
	
	public HlsCusCshConContract selectAllStatistical(HlsCusCshConContract conContract);

	public List<HlsCusCshConContract> getTotalContractCount();
	public List<HlsCusCshConContract> getDiffContractStatusCount();
	public List<HlsCusCshConContract> getTerminateContractCount();
	public List<HlsCusCshConContract> getStockContractAndMonthNewContract();
	public List<HlsCusCshConContract> getIndexContractInceptInfo(HlsCusCshConContract conContract);
	public List<HlsCusCshConContract> contractDueAmountQuery();
	
	public HlsCusConContractChangeReq selectAlterStatistics(HlsCusConContractChangeReq changeReq);
	
	public List<HlsCusConContractChangeReq> selectAllReqDetailedInformation(HlsCusConContractChangeReq conContractChangeReq);
	public List<HlsCusConContractStatus> selectContractStatusInfo(HlsCusConContractStatus conContractStatus);
	public HlsCusConContractStatus selectTotalThrowInfo(HlsCusConContractStatus conContractStatus);
	public List<HlsCusCshConContract> contractHomeFirstQuery(Map<String, Object> map);

	public List<HlsCusCshConContract> contractHomeSecordQuery(Map<String, Object> map);

	public List<HlsCusCshConContract> contractHomeThirdQuery(Map<String, Object> map);
	/**
	 * 统计一定时间范围内直租、回租合同数量
	 * @return
	 */
	public List<HlsCusCshConContract> selectTypeStatistics(HlsCusCshConContract conContract);

	public Map selectTwoTypeStatistics(HlsCusCshConContract conContract);

	public List<HlsCusCshConContract> selectContractByID(HlsCusCshConContract conContract);
	
	public List<HlsCusCshConContract> selectContractInFo(HlsCusCshConContract conContract);
	
	public List<HlsCusCshConContract> selectStockCount(HlsCusCshConContract conContract);
	
	public List<HlsCusCshConContract> selectAllCshConContractInformation(HlsCusCshConContract conContract);

	public List<HlsCusCshConContract> comprehensiveQuery(Map<String, Object> map);

	public List<HlsCusCshConContract> selectUpToDateCshConConTract(HlsCusCshConContract cshConContract);

	public List<HlsCusCshConContract> selectOnHireCshconcontract(HlsCusCshConContract cshConContract);

	public List<HlsCusCshConContract> selectCshConContract(Long bpId);

	public List<HlsCusCshConContract> selectCshConContractGuarantor(Long bpId);

	public List<HlsCusCshConContract> selectCshconcontractLov();

	List<Map> selectContractId(HlsCusBpMaster hlsCusBpMaster);

	List<Map> receivableCollection(List<Map> list);

	public List<HlsCusCshConContract> rentQuery(Map<String, Object> map);

	public List<HlsCusConContractCollection> rentRecordQuery(Long contractId);
}
