package hls.core.csh.mapper;

import com.hand.hap.mybatis.common.Mapper;
import hls.core.cont.dto.ConAging;
import hls.core.csh.dto.HlsCusCshWriteOff;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;
import java.util.Map;

public interface CshWriteOffMapper<T extends HlsCusCshWriteOff> extends Mapper<HlsCusCshWriteOff>{

	void updateSubCshTrxId(@Param("writeOffId") Long writeOffId, @Param("transactionId") Long transactionId, @Param("transactionAmount") Double transactionAmount);

	List<HlsCusCshWriteOff> queryDetail(HlsCusCshWriteOff cshWriteOff);

	List<HlsCusCshWriteOff> queryReversed(HlsCusCshWriteOff cshWriteOff);

	void updateCshWriteOffbyId(@Param("writeOffId") Long writeOffId, @Param("reversedFlag") String reversedFlag, @Param("subWriteOffId") Long subWriteOffId, @Param("reversedDate") Date reversedDate, @Param("userId") Long userId, @Param("date") Date date);

	List<HlsCusCshWriteOff> cashflowDetail(HlsCusCshWriteOff cshWriteOff);

	List<HlsCusCshWriteOff> currentOutAmountInfo(HlsCusCshWriteOff cshWriteOff);

	List<HlsCusCshWriteOff> currentGetAmountInfo(HlsCusCshWriteOff cshWriteOff);
	
	public List<HlsCusCshWriteOff> selectAllPutIn(HlsCusCshWriteOff cshWriteOff);
	
	public List<HlsCusCshWriteOff> selectAlldetails(HlsCusCshWriteOff cshWriteOff);

    public List<HlsCusCshWriteOff> getEveryMonthPaymentAndReceiptAmount();
    
    public List<HlsCusCshWriteOff> fundPaymentLineInfo(Map map);
    
    public ConAging SelectAgingCount(Long companyId);

	List<Map> writeOffDetail(Map map);
	List<Map> writeOffDetailByCFL(Map map);
	/**
	 * 核销事物-单行-核销明细
	 * @param cshWriteOff
	 * @return
	 */
	public List<HlsCusCshWriteOff> selectAllCancelAfterVerificationDetail(HlsCusCshWriteOff cshWriteOff);

	public List<HlsCusCshWriteOff>selectDetail(HlsCusCshWriteOff cshWriteOff);

	public List<HlsCusCshWriteOff> selectAllCshWriteOff(HlsCusCshWriteOff cshWriteOff);
	
	public List<Map> selectAllWriteOff(Map map);

	List<HlsCusCshWriteOff> vatDetail(@Param("cashflowId") Long cashflowId);

	public List<HlsCusCshWriteOff> selectPenaltyWriteOff(HlsCusCshWriteOff cshWriteOff);

	public List<HlsCusCshWriteOff> selectPenaltyWriteOffFct(HlsCusCshWriteOff cshWriteOff);

	/*融资还款-核销明细*/
	List<HlsCusCshWriteOff> queryLonRepayWriteoffDetail(HlsCusCshWriteOff cshWriteOff);

}
