package hls.core.csh.service;

import java.text.ParseException;
import java.util.List;
import java.util.Map;

import com.hand.hap.core.IRequest;
import com.hand.hap.core.ProxySelf;
import com.hand.hap.system.service.IBaseService;

import hls.core.csh.dto.HlsCusCshTransaction;
import hls.core.csh.exception.BeyondAmountLimitException;
import hls.core.csh.exception.WriteOffTypeNullException;
import hls.core.csh.exception.ChangeLimitException;



import javax.servlet.http.HttpSession;

public interface CshTransactionService extends IBaseService<HlsCusCshTransaction>, ProxySelf<CshTransactionService>{

	HlsCusCshTransaction updateCshTransaction(Long companyId, HlsCusCshTransaction cshTransaction, IRequest requestContext);

	List<HlsCusCshTransaction> queryAll(IRequest requestContext, HlsCusCshTransaction cshTransaction, int page, int pagesize);

	List<HlsCusCshTransaction> queryDetailById(Long transactionId);

	void updateReversed(IRequest requestContext, Long companyId, HlsCusCshTransaction cshTransaction);

	List<HlsCusCshTransaction> cshReturnQuery(IRequest requestContext, HlsCusCshTransaction cshTransaction, int page, int pagesize);

	void updateReturn(IRequest requestContext, Long companyId, HlsCusCshTransaction cshTransaction) throws BeyondAmountLimitException;

	List<HlsCusCshTransaction> cshWriteOffQuery(IRequest requestContext, HlsCusCshTransaction cshTransaction, int page, int pagesize);

	List<HlsCusCshTransaction> cshReturnReversedQuery(IRequest requestContext, HlsCusCshTransaction cshTransaction, int page, int pagesize);
	
	List<HlsCusCshTransaction> paymentreversedRquery(IRequest requestContext, HlsCusCshTransaction cshTransaction, int page, int pagesize);
	
	public List<HlsCusCshTransaction> paymentreversedRqueryLov();

	HlsCusCshTransaction fundHomePage(IRequest iRequest, Map map, int page, int pagesize);

	List<Map> collectionDetails(IRequest iRequest, Map map,int page,int pagesize);

	List<Map> collectionDetailsView(IRequest iRequest, Map map,int page,int pagesize);

	/**
	 * 现金事物-单行-交易明细
	 * @param cshTransaction
	 * @return
	 */
	List<HlsCusCshTransaction> selectAllCashThingTransactionDetails(HlsCusCshTransaction cshTransaction);

	/**
	 * @param cshTransaction
	 * @return
	 * @throws ParseException
	 */
	List<HlsCusCshTransaction> selectAllCshTransaction(IRequest requestContext, HlsCusCshTransaction cshTransaction) throws ParseException;

	List<Map> CashThingTransactionQueryDetail(Map cshTransaction);

	List<Map> csh330aCshTransactionQuery(HlsCusCshTransaction cshTransaction, IRequest iRequest, int page, int pagesize);

	List<Map> csh420aCshDepositPoolQuery(HlsCusCshTransaction cshTransaction, IRequest iRequest);

	List<Map> csh410aConContractDepoistQuery(HlsCusCshTransaction cshTransaction, IRequest iRequest);

	HlsCusCshTransaction cshTransactionAddDpositPool(Long companyId, HlsCusCshTransaction cshTransaction, IRequest requestContext, HttpSession session) throws BeyondAmountLimitException,WriteOffTypeNullException,ChangeLimitException;
	void contactAddDeposit(Long companyId, HlsCusCshTransaction cshTransaction, IRequest requestContext, HttpSession session) throws BeyondAmountLimitException, WriteOffTypeNullException, ChangeLimitException;
	void updateCshTrByPrimaryKey(HlsCusCshTransaction cshTr);

    List<HlsCusCshTransaction> selectAllNotInvoiced(HlsCusCshTransaction cshTransaction, int page, int pageSize, IRequest iRequest);

	List<HlsCusCshTransaction> queryByCshWriteId(HlsCusCshTransaction cshTransaction);

	/*提前结清-审批页面-lov查询收款信息*/
	List<Map> queryCollectionInfo(IRequest iRequest, Map map);

}
