package hls.core.csh.service;

import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpSession;

import com.hand.hap.core.IRequest;
import com.hand.hap.core.ProxySelf;
import com.hand.hap.system.service.IBaseService;

import de.odysseus.el.tree.impl.Parser.ParseException;
import hls.core.cont.dto.ConAging;
import hls.core.csh.dto.HlsCusConContractCashflow;
import hls.core.csh.dto.HlsCusCshWriteOff;
import hls.core.csh.exception.BeyondAmountLimitException;
import hls.core.csh.exception.ChangeLimitException;
import hls.core.csh.exception.WriteOffTypeNullException;

public interface CshWriteOffService extends IBaseService<HlsCusCshWriteOff>, ProxySelf<CshWriteOffService>{

	//void updateSubCshTrxId(@Param("writeOffId")Long writeOffId,@Param("transactionId")Long transactionId, @Param("transactionAmount")Double transactionAmount);

	//void updateWriteOff(List<HlsCusCshWriteOff> cshWriteOffs,HttpSession session) throws BeyondAmountLimitException, IllegalArgumentException, WriteOffTypeNullException;
	//void updateCshWriteOffbyId(@Param("writeOffId")Long writeOffId, @Param("reversedFlag")String reversedFlag, @Param("subWriteOffId")Long subWriteOffId, @Param("reversedDate")Date reversedDate);

	List<HlsCusCshWriteOff> queryDetail(IRequest requestContext, HlsCusCshWriteOff cshWriteOff, int page, int pagesize);

	List<HlsCusCshWriteOff> queryReversed(IRequest requestContext, HlsCusCshWriteOff cshWriteOff, int page, int pagesize);

	void updateWriteOffReversed(IRequest requestContext, HlsCusCshWriteOff cshWriteOff) throws BeyondAmountLimitException,WriteOffTypeNullException;


	List<HlsCusCshWriteOff> cashflowDetail(IRequest requestContext, HlsCusCshWriteOff cshWriteOff, int page, int pagesize);

	public List<Map> selectAllWriteOff(Map map,HttpSession session,IRequest iRequest);
	/**
	 * @param cshWriteOff
	 * @return
	 * @throws java.text.ParseException 
	 */
	List<HlsCusCshWriteOff> selectAllPutIn(IRequest requestContext, HlsCusCshWriteOff cshWriteOff, int page, int pagesize) throws java.text.ParseException;

	 
	List<HlsCusCshWriteOff> getEveryMonthPaymentAndReceiptAmount();
	
	List<HlsCusCshWriteOff> fundPaymentLineInfo(Map map);

	/**
	 * @param requestContext
	 * @param cshWriteOff
	 * @param page
	 * @param pagesize
	 * @return
	 * @throws ParseException
	 * @throws java.text.ParseException 
	 */
	List<HlsCusCshWriteOff> selectAlldetails(IRequest requestContext, HlsCusCshWriteOff cshWriteOff, int page, int pagesize)
			throws ParseException, java.text.ParseException;

	/**
	 * @return
	 */
	ConAging SelectAgingCount(IRequest iRequest);

	/**
	 * 核销事务-多行-核销明细（收付款维度）
	 */
	List<Map> WriteOffDetail(Map map,IRequest iRequest);


	/**
	 * 核销事务-多行-核销明细（现金流维度）
	 * @param map
	 * @param iRequest
	 * @return
     */
	List<Map> writeOffDetailByCFL(Map map,IRequest iRequest);

	/**
	 * @param cshWriteOff
	 * @return
	 */
	List<HlsCusCshWriteOff> selectAllCancelAfterVerificationDetail(HlsCusCshWriteOff cshWriteOff);

	public List<HlsCusCshWriteOff>selectDetail(HlsCusCshWriteOff cshWriteOff);

	/**
	 * @param iRequest
	 * @param cshWriteOffs
	 * @param session
	 * @throws BeyondAmountLimitException
	 * @throws IllegalArgumentException
	 * @throws WriteOffTypeNullException
	 * @throws ChangeLimitException 
	 */
	void updateWriteOff(IRequest iRequest, List<HlsCusCshWriteOff> cshWriteOffs, HttpSession session)
			throws BeyondAmountLimitException, IllegalArgumentException, WriteOffTypeNullException, ChangeLimitException;

	void updateWriteOff(IRequest iRequest, List<HlsCusCshWriteOff> cshWriteOffs, Long companyId)
			throws BeyondAmountLimitException, IllegalArgumentException, WriteOffTypeNullException, ChangeLimitException;

	/**
	 * @param iRequest
	 * @param cshWriteOff 
	 * @param session
	 * @throws ChangeLimitException 
	 */
	void paymentWriteOffReversed(IRequest iRequest, HlsCusCshWriteOff cshWriteOff, HttpSession session) throws ChangeLimitException;
	
	public boolean querySize(HlsCusCshWriteOff cshWriteOff, HttpSession session);

	List<HlsCusCshWriteOff> vatDetail(Long cashflowId);

	public void updateContractReceivedStatus(HlsCusConContractCashflow conCashflow);

	/*融资还款- 核销明细*/
	List<HlsCusCshWriteOff> queryLonRepayWriteoffDetail(IRequest request, HlsCusCshWriteOff dto, int page, int pageSize);
}
