package hls.core.csh.service;

import java.text.ParseException;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpSession;

import com.hand.hap.core.IRequest;
import com.hand.hap.core.ProxySelf;
import com.hand.hap.system.service.IBaseService;

import hls.core.cont.dto.ConAging;
import hls.core.csh.dto.*;
import hls.core.csh.exception.BeyondAmountLimitException;
import hls.core.csh.exception.ChangeLimitException;
import hls.core.hls.bp.dto.HlsCusBpMaster;
import hls.core.prj.dto.HlsCusPrjQuotation;


public interface IConContractCashflowService extends IBaseService<HlsCusConContractCashflow>,ProxySelf<IConContractCashflowService>{
	/**
	 * 查询合同现金流
	 * @param cashflow
	 * @return
	 */
	public List<HlsCusConContractCashflow> selectAllConContractCashflow(HlsCusConContractCashflow cashflow);

	public List<Map> query4depositMgr(int pageSize, int page) throws Exception;

	public HlsCusConContractCashflow selectConContractCashflow(Long cashflow_id);

	public List<Map> queryDepositDetail(Long contractId, int pageSize, int page) throws Exception;

	public List<Map> queryPoolDetail(Long bpId, int pageSize, int page) throws Exception;

	public List<Map> query4PoolDepositMgr(int pageSize, int page) throws Exception;

	public List<HlsCusConContractCashflow> selectOneConContract(HlsCusConContractCashflow cashflow);

	public void updateOne(HlsCusConContractCashflow cashflow);

	List<Map> query4Recall(HlsCusCshDeduction deduction, int page, int pageSize);
	public List<HlsCusConContractCashflow> selectLovItem();

	List<Map> query4Back(HlsCusCshDeduction deduction, int page, int pageSize);

	public List<HlsCusConContractCashflow> contractCashFlowDetail(IRequest requestContext, HlsCusConContractCashflow cashflow,
                                                                  int page, int pagesize);

	/*
     *
     */
	public Double getCurrentWeekOverDueAmount();

	public Double getYesterdayOverDueAmount();

	public Double getTodayOverDueAmount();

	public Double getTotalOverDueAmount();

	public List<HlsCusConContractCashflow> getLastWeekOverDueAmount();

	/**
	 * @param cashflow
	 * @param session
	 * @return
	 * @throws ParseException
	 * @throws ChangeLimitException
	 */
	HlsCusConContractCashflow selectInformationStatistics(HlsCusConContractCashflow cashflow, HttpSession session) throws ParseException, ChangeLimitException;
	Map selectInformationAllStatistics (HlsCusConContractCashflow cashflow, HttpSession session) throws ParseException, ChangeLimitException;
	HlsCusConContractCashflow selectDueAmountInDiff(HlsCusConContractCashflow cashflow, HttpSession session) throws ParseException, ChangeLimitException;

	public ConAging SelectDueAmount(HlsCusConContractCashflow cashflow) throws ParseException;

	public List<HlsCusConContractCashflow> selectRentBackInfo(IRequest irRequest,HlsCusConContractCashflow cashflow,int page,int pageSize) throws ParseException;

	public List<HlsCusConContractCashflow> astDetail(Long contractID);

	public List<HlsCusConContractCollection> selectHisOfRentBackIf(IRequest iRequest, int page, int pagesize);

	public List<HlsCusCshPaymentReqLn> creatPayInfo(List<HlsCusConContractCashflow> list, Long companyId, String value, IRequest requestContext) throws BeyondAmountLimitException;

	public List<HlsCusConContractCashflow> selectHireConContractCashflow(HlsCusConContractCashflow conContractCashflow, HttpSession session);

	public HlsCusConContractCashflow selectOverdueCount(HlsCusConContractCashflow conContractCashflow, HttpSession session);

	public List<HlsCusConContractCashflow> vatQuery(IRequest iRequest, Map<String, Object> map, int page, int pagesize);

	public List<HlsCusConContractCashflow> vatQueryList(Map<String, String> map);

	public HlsCusCshFundStatistics selectRiskExposure(IRequest irRequest, HlsCusBpMaster hlsCusBpMaster);

	public HlsCusCshFundStatistics selectRiskGuarantorExposure(IRequest irRequest, HlsCusBpMaster hlsCusBpMaster);

	List<HlsCusConContractCashflow> debtQuery(IRequest iRequest, Map map, int page, int pagesize);

	void paymentApproval(IRequest iRequest,HttpSession session,List<HlsCusConContractCashflow> list) throws BeyondAmountLimitException;

	List<HlsCusConContractCashflow> saveCashflowFromPrjCashflow(IRequest iRequest, Long contractId, Long ProjectId);
	public List<HlsCusConContractCashflow> queryConContratCashFlowById(Long cashflow_id);

	public List<HlsCusConContractCashflow> saveCalc2ConContractCashflow(IRequest requestContext, HlsCusPrjQuotation prjQuotation)throws  Exception;;
	public List<HlsCusConContractCashflow> selectCalculateCashflow(HlsCusConDebtExemptionReq conDebtExemptionReq);
	/*合同变更-提前结清-查询现金流grid信息 */
	 Map queryCashFlowInfo(IRequest iRequest, HlsCusConContractCashflow conContractCashflow, int page, int pageSize);
	/*合同变更-提前结清-查询结清信息*/
	Map<String,Object> settleInformation(IRequest iRequest,HlsCusConContractCashflow conContractCashflow);
	/*合同变更-根据不同的审批状态去获取结清信息*/
    Map<String,Object> settleInformationByStatus(IRequest iRequest,HlsCusConContractCashflow conContractCashflow);
 }
