package hls.core.csh.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.csh.dto.HlsCusAging;
import hls.core.csh.mapper.HlsCusAgingMapper;
import hls.core.rpt.dto.RptReportHd;
import hls.core.rpt.service.IRptReportGetDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.csh.service.IAgingService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;


@Service
@Transactional
public class AgingServiceImpl extends BaseServiceImpl<HlsCusAging> implements IAgingService , IRptReportGetDataService {
    @Autowired
    private HlsCusAgingMapper mapper;

    @Override
    public String getCode() {
        return "hls.core.csh.service.impl.AgingServiceImpl";
    }

    public void tempData(IRequest iRequest, RptReportHd rptReportHd) {
        //查询明细数据
        HlsCusAging age = new HlsCusAging();
        age.setReportDtlId(rptReportHd.getReportDtlId());//获取rpt_dtl_id
        List<HlsCusAging> list = mapper.queryDetail(age);
        //删除当前rpt_dtl_id原有数据
        mapper.delete(age);
        // 插入数据
        for(int i=0;i<list.size();i++){
            //赋值
            HlsCusAging ageInsert = new HlsCusAging();
            ageInsert.setReportDtlId(rptReportHd.getReportDtlId());//明细编号
            ageInsert.setContractId(list.get(i).getContractId());//合同编号
            ageInsert.setCompanyId(rptReportHd.getCompanyId());//公司ID
            ageInsert.setHalfYearAmount(list.get(i).getHalfYearAmount());//逾期半年金额
            ageInsert.setHalfYearDueAmount(list.get(i).getHalfYearDueAmount());//应收半年金额
            ageInsert.setOneYearAmount(list.get(i).getOneYearAmount());//逾期一年金额
            ageInsert.setOverOneYearDueAmount(list.get(i).getOverOneYearDueAmount());//应收超过一年金额
            ageInsert.setOverOneYearAmount(list.get(i).getOverOneYearAmount());//逾期超过一年金额
            ageInsert.setOneYearDueAmount(list.get(i).getOneYearDueAmount());//应收一年金额
            ageInsert.setOneMonthAmount(list.get(i).getOneMonthAmount());//逾期一个月金额
            ageInsert.setOneMonthDueAmount(list.get(i).getOneMonthDueAmount());//应收一个月金额
            ageInsert.setTwoMonthAmount(list.get(i).getTwoMonthAmount());//逾期2个月金额
            ageInsert.setTwoMonthDueAmount(list.get(i).getTwoMonthDueAmount());//应收2个月金额
            ageInsert.setThreeMonthAmount(list.get(i).getThreeMonthAmount());//逾期3个月金额
            ageInsert.setThreeMonthDueAmount(list.get(i).getThreeMonthDueAmount());//应收3个月金额
            //插入
            self().insertSelective(iRequest,ageInsert);
        }
    }
    /*查询报表数据*/
    public List<HlsCusAging> queryResult(HlsCusAging age){
            return mapper.queryResult(age);
    }
    /*查询导出数据*/
    public List<HlsCusAging> queryExportInfo(HlsCusAging age){
           return mapper.queryExportInfo(age);
    }
}