package hls.core.csh.service.impl;


import com.github.pagehelper.PageHelper;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.cont.dto.*;
import hls.core.cont.mapper.HlsCusConContractCashflowHMapper;
import hls.core.cont.mapper.HlsCusConFloatingRateReqLnMapper;
import hls.core.cont.mapper.HlsCusConFloatingRateReqMapper;
import hls.core.csh.service.ConContractCashflowHService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

/**
 * @Title: ConContractCashflowHServiceImpl
 * @Description:
 * @Company:
 * @author: syj
 * @date 2017年2月27日14:01:07
 */

@Service
@Transactional
public class ConContractCashflowHServiceImpl extends BaseServiceImpl<HlsCusConContractCashflowH> implements ConContractCashflowHService {


    public static final String APPROVED = "APPROVED";
    @Autowired
    private HlsCusConContractCashflowHMapper cashflowHMapper;
    @Autowired
    private HlsCusConFloatingRateReqLnMapper conFloatingRateReqLnMapper;
    @Autowired
    private HlsCusConFloatingRateReqMapper conFloatingRateReqMapper;


    @Override
    public List<HlsCusConContractCashflowH> selectDetail(HlsCusConContractCashflowH conContractCashflowH) {
        return cashflowHMapper.selectDetail(conContractCashflowH);
    }

    /*调息-查询现金流对比信息*/
    public List<HlsCusConContractCashflowH> queryCashflowCompare(HlsCusConContractCashflowH dto, int page, int pagesize) {

        Long changeReqId = dto.getChangeReqId();
        HlsCusConFloatingRateReqLn floatingRateReqLn = conFloatingRateReqLnMapper.selectByPrimaryKey(changeReqId);
        Long fltReqId = floatingRateReqLn.getFltReqId();
        HlsCusConFloatingRateReq conFloatingRateReq = conFloatingRateReqMapper.selectByPrimaryKey(fltReqId);
        List<HlsCusConContractCashflowH> contractCashflowHs;
        PageHelper.startPage(page, pagesize);
        if (APPROVED.equalsIgnoreCase(conFloatingRateReq.getStatus())){
            contractCashflowHs = cashflowHMapper.queryCashflowCompareAfterApprove(dto);
        }else {
            contractCashflowHs = cashflowHMapper.queryCashflowCompareBeforeApprove(dto);
        }
        return contractCashflowHs;
    }

    @Override
    public List<HlsCusConContractCashflowH> selectHistoryCashflowByContract(HlsCusConContractH dto, int page, int pagesize) {
        PageHelper.startPage(page,pagesize);
        return cashflowHMapper.selectHistoryCashflowByContract(dto);
    }

}
