package hls.core.csh.service.impl;

import com.hand.hap.activiti.dto.ReProcdef;
import com.hand.hap.activiti.service.IReProcdefService;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.csh.dto.HlsCusConDebtExemptionReq;
import hls.core.csh.dto.HlsCusCshConContract;
import hls.core.csh.mapper.HlsCusConDebtExemptionReqMapper;
import hls.core.csh.service.ConDebtExemptionReqService;
import hls.core.csh.service.IConDebtChangeReqCustomService;
import hls.core.csh.service.ICshConContractService;
import hls.core.fnd.service.FndCodingRuleValuesService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by haibin on 2017/7/25.
 */
@Service
@Transactional
public class ConDebtExemptionReqServiceImpl extends BaseServiceImpl<HlsCusConDebtExemptionReq> implements ConDebtExemptionReqService {
    @Autowired
    private HlsCusConDebtExemptionReqMapper conDebtExemptionReqMapper;
    @Autowired
     private ICshConContractService cshConContractService;
    @Autowired
    private FndCodingRuleValuesService fndCodingRuleValuesService;
    @Autowired
    private IReProcdefService reProcdefService;
    @Autowired(required = false)
    private IConDebtChangeReqCustomService iConDebtChangeReqCustomService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;
    @Override
    public HlsCusConDebtExemptionReq addChangeReq(IRequest iRequest, HlsCusConDebtExemptionReq conDebtExemptionReq) {
        if(iConDebtChangeReqCustomService != null && !iConDebtChangeReqCustomService.beforeChangeReq(iRequest,conDebtExemptionReq)){
            return conDebtExemptionReq;
        }
        HlsCusCshConContract cshConContract=new HlsCusCshConContract();
        cshConContract.setContract_id(conDebtExemptionReq.getContractId());
        HlsCusCshConContract conContract=cshConContractService.selectByPrimaryKey(iRequest,cshConContract);
        // lock con_contract
        databaseLockProvider.lock(cshConContract);
        String value = fndCodingRuleValuesService.getCodeRuleValue(iRequest,"CON_DEBT_EXEMPTION_REQ","STD","CON_DEBT_EXEMPTION_REQ", null);
        conDebtExemptionReq.setChangeReqNumber(value);
        conDebtExemptionReq.setBusinessType(conContract.getBusiness_type());
        conDebtExemptionReq.setDocumentCategory(conContract.getDocument_category());
        conDebtExemptionReq.setDocumentType(conContract.getDocument_type());
        conDebtExemptionReq.setReqStatus("NEW");
        ReProcdef reProcdefs = reProcdefService.queryReProcdef("CON_DEBT_EXEMPTION_WORK_FLOW","CON_CONTRACT");
        if(conDebtExemptionReq.getChangeReqId()==null){
            conDebtExemptionReq.set__status("add");
            conDebtExemptionReq=self().insertSelective(iRequest,conDebtExemptionReq);
        }else{
            conDebtExemptionReq.set__status("update");
            conDebtExemptionReq=self().updateByPrimaryKey(iRequest,conDebtExemptionReq);
        }
        if(iConDebtChangeReqCustomService != null){
            iConDebtChangeReqCustomService.afterChangeReq(iRequest,conDebtExemptionReq);
        }
        return conDebtExemptionReq;
    }

    @Override
    public List<HlsCusConDebtExemptionReq> selectConDebtExemptionReq(IRequest iRequest, Long contractId) {
        return conDebtExemptionReqMapper.selectConDebtExemptionReq(contractId);
    }
}
