package hls.core.csh.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.csh.mapper.HlsCusConExecuteMapper;
import hls.core.rpt.dto.RptReportDtl;
import hls.core.rpt.dto.RptReportHd;
import hls.core.rpt.mapper.RptReportDtlMapper;
import hls.core.rpt.service.IRptReportGetDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.csh.dto.HlsCusConExecute;
import hls.core.csh.service.IConExecuteService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class ConExecuteServiceImpl extends BaseServiceImpl<HlsCusConExecute> implements IConExecuteService, IRptReportGetDataService {
    @Autowired
    private HlsCusConExecuteMapper conExecuteMapper;
    @Autowired
    private RptReportDtlMapper rptReportDtlMapper;
    @Autowired
    private IConExecuteService conExecuteService;
    @Override
    public String getCode() {
        return "hls.core.csh.service.impl.ConExecuteServiceImpl";
    }
    @Override
    public void tempData(IRequest iRequest, RptReportHd rptReportHd) {
       //获取报表发布日期,传入报表发布日期
        HlsCusConExecute temp = new HlsCusConExecute();

        RptReportDtl rptReportDtl =new RptReportDtl();
        rptReportDtl.setReportDtlId(rptReportHd.getReportDtlId());
        temp.setReleaseDate(rptReportDtlMapper.selectByPrimaryKey(rptReportDtl).getReleaseDate());
        temp.setCompanyId(rptReportHd.getCompanyId());

        //查询需要的数据并做插入
        List<HlsCusConExecute> conExecutes = conExecuteMapper.queryTempDate(temp);
        if(conExecutes.size()>0){
            for(HlsCusConExecute conExecute:conExecutes){
                //设置报表的id,发布日期
                conExecute.setReportDtlId(rptReportHd.getReportDtlId());
                conExecute.setReleaseDate(rptReportDtlMapper.selectByPrimaryKey(rptReportDtl).getReleaseDate());
                conExecute.setCompanyId(rptReportHd.getCompanyId());
                //conExecute.set__status("add");
                conExecuteService.insertSelective(iRequest,conExecute);
            }
            /*conExecuteService.batchUpdate(iRequest,conExecutes);*/

        }
    }

}