package hls.core.csh.service.impl;

import java.util.ArrayList;
import java.util.List;

import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.hand.hap.system.service.impl.BaseServiceImpl;


import hls.core.csh.dto.HlsCusCshBankAccountBalance;
import hls.core.csh.mapper.HlsCusCshBankAccountBalanceMapper;
import hls.core.csh.service.CshBankAccountBalanceService;

@Service
@Transactional
public class CshBankAccountBalanceServiceImpl extends BaseServiceImpl<HlsCusCshBankAccountBalance> implements CshBankAccountBalanceService{

	@Autowired
    HlsCusCshBankAccountBalanceMapper cshBankAccountBalanceMapper;


	public List<HlsCusCshBankAccountBalance> getAllBankAccountBalance(HlsCusCshBankAccountBalance cshBankAccountBalance){
		List<HlsCusCshBankAccountBalance> list = cshBankAccountBalanceMapper.selectBankAccountBalanceAll(cshBankAccountBalance);
		return list;
	}

	public List<HlsCusCshBankAccountBalance> getAllBankAccountBalanceInfo(HlsCusCshBankAccountBalance cshBankAccountBalance){
		Long maxMonth = cshBankAccountBalance.getPeriodMonth();
		List<HlsCusCshBankAccountBalance> list = new ArrayList<HlsCusCshBankAccountBalance>();
		for(int i = 1; i <= maxMonth; i++)
		{
			HlsCusCshBankAccountBalance cshBankAccount = new HlsCusCshBankAccountBalance();
			cshBankAccountBalance.setPeriodMonth((long) i);
			cshBankAccount = cshBankAccountBalanceMapper.getCloseBankAccountBalance(cshBankAccountBalance).isEmpty()?  null :cshBankAccountBalanceMapper.getCloseBankAccountBalance(cshBankAccountBalance).get(0);
			if(cshBankAccount == null){
				cshBankAccount = new HlsCusCshBankAccountBalance();
			}
			cshBankAccount.setPeriodMonth((long) i);
			list.add(cshBankAccount);
		}
		return list;
	}

	public List<HlsCusCshBankAccountBalance> getCurrentMonthAccountInfo(HlsCusCshBankAccountBalance cshBankAccountBalance){
		List<HlsCusCshBankAccountBalance> list = cshBankAccountBalanceMapper.getCurrentMonthAccountInfo(cshBankAccountBalance);
		if(1 == cshBankAccountBalance.getPeriodMonth())
		{
			cshBankAccountBalance.setPeriodYear(cshBankAccountBalance.getPeriodYear()-1);
			cshBankAccountBalance.setPeriodMonth((long) 12);
		}
		else
		{
			cshBankAccountBalance.setPeriodMonth(cshBankAccountBalance.getPeriodMonth()-1);
		}
		HlsCusCshBankAccountBalance cshBankAccount = cshBankAccountBalanceMapper.getCloseBankAccountBalance(cshBankAccountBalance).size()==0?null:cshBankAccountBalanceMapper.getCloseBankAccountBalance(cshBankAccountBalance).get(0);

		for(int i = 0; i < list.size(); i++)
		{


			if(cshBankAccount == null){
				list.get(i).setOpeningBalance((double) 0);
			}
			else
			{
				list.get(i).setOpeningBalance(cshBankAccount.getBalance());
			}
		}
		return list;
	}
	@Override
	public HlsCusCshBankAccountBalance selectAccountBalance(@Param("bankAccountId")Long bankAccountId, @Param("periodYear")Long periodYear, @Param("periodMonth")Long periodMonth){
		return cshBankAccountBalanceMapper.selectAccountBalance(bankAccountId,periodYear,periodMonth);
	}
	@Override
	public HlsCusCshBankAccountBalance getCloseBankAccountBalance(HlsCusCshBankAccountBalance cshBankAccountBalance){
		return cshBankAccountBalanceMapper.getCloseBankAccountBalance(cshBankAccountBalance).get(0);
	}
	@Override
	public void updateBankAccountBalanceByKey(HlsCusCshBankAccountBalance accountBalance){
		cshBankAccountBalanceMapper.updateBankAccountBalanceByKey(accountBalance);
	}

	public void updateBankAccountBalance(HlsCusCshBankAccountBalance accountBalance){
		cshBankAccountBalanceMapper.updateBankAccountBalance(accountBalance);
	}
}

