package hls.core.csh.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.csh.dto.HlsCusCshBank;
import hls.core.csh.dto.HlsCusCshBankAccount;
import hls.core.csh.mapper.HlsCusCshBankAccountMapper;
import hls.core.csh.mapper.HlsCusCshBankMapper;
import hls.core.csh.service.CshBankAccountService;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import hls.core.csh.service.CshBankService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;


@Service
@Transactional
public class CshBankAccountServiceImpl extends BaseServiceImpl<HlsCusCshBankAccount> implements CshBankAccountService{

	@Autowired
    HlsCusCshBankAccountMapper mapper;
	@Autowired
	HlsCusCshBankMapper bankMapper;

	@Autowired
	CshBankService cshBankService;
	
	@Override
	public List<HlsCusCshBankAccount> selectAllCshBankAccount(Long bankAccountId) {
		List<HlsCusCshBankAccount> list = mapper.selectAllCshBankAccount(bankAccountId);
		return list;
	}
	
	public List<HlsCusCshBankAccount> selectCshBankAccountLov(Map<String, Object> params){
		return mapper.selectCshBankAccountLov(params);
	}
	
	@Override
	public List<HlsCusCshBankAccount> selectCshBankAccount(Map<String,Object> map) {
		Map<String, Object> params = new HashMap<String, Object>();
		final List<String> accountlist = new ArrayList<String>();
		final List<String> currencylist = new ArrayList<String>();
		boolean accountFlag = false;
		boolean currencyFlag = false;
		if(!map.get("accountFirstType").equals("N"))
		{
			accountFlag = true;
			accountlist.add((String) map.get("accountFirstType"));
		}
		if(!map.get("accountSecondType").equals("N"))
		{
			accountFlag = true;
			accountlist.add((String) map.get("accountSecondType"));
		}
		if(!map.get("accountThreeType").equals("N"))
		{
			accountFlag = true;
			accountlist.add((String) map.get("accountThreeType"));
		}
		if(!map.get("accountFourType").equals("N"))
		{
			accountFlag = true;
			accountlist.add((String) map.get("accountFourType"));
		}

		params.put("accountlist", accountlist);
		if(map.get("description") != null)
		{
			params.put("descriptionFlag", true);
		}
		params.put("description", (String) map.get("description"));
		
		if(!map.get("currencyFirstType").equals("N"))
		{
			currencyFlag = true;
			currencylist.add((String) map.get("currencyFirstType"));
		}
		if(!map.get("currencySecondType").equals("N"))
		{
			currencyFlag = true;
			currencylist.add((String) map.get("currencySecondType"));
		}
		if(!map.get("currencyThreeType").equals("N"))
		{
			currencyFlag = true;
			currencylist.add((String) map.get("currencyThreeType"));
		}
		params.put("currencylist", currencylist);
		params.put("accountFlag", accountFlag);
		params.put("currencyFlag", currencyFlag);
		params.put("companyId", map.get("companyId"));
		/*if(conContract.getContract_status().equals("N"))
		{
			params.put("flag", null);
			params.put("list", null);
			params.put("contract_id",conContract.getContract_id());
			return cshConContractMapper.getContractInfo(params);
		}
		else
		{
			params.put("flag", true);
			String[] status = conContract.getContract_status().split(",");
			for(int i = 0; i < status.length; i++)
			{
				list.add(status[i]);
			}
			params.put("list", list);
			return cshConContractMapper.getContractInfo(params);
		}*/
		
		return mapper.selectCshBankAccount(params);
	}

	@Override
	public List<HlsCusCshBankAccount> bankAccountInfoQuery(HlsCusCshBankAccount cshBankAccount) {
		// TODO Auto-generated method stub
		return mapper.bankAccountInfoQuery(cshBankAccount);
	}

	@Override
	public void save(IRequest requestContext, HlsCusCshBankAccount cshBankAccount) {
		HlsCusCshBank cshBank = new HlsCusCshBank();
		HlsCusCshBank param = new HlsCusCshBank();
		param.setBankCode(cshBankAccount.getBankCode());
		param = bankMapper.selectOne(param);

		if(param != null){
			cshBank = param;
		}else {
			//头行表都进行操作
			cshBank.setBankCode(cshBankAccount.getBankCode());
			cshBank.setBankName(cshBankAccount.getBankName());
			cshBank.setEnabledFlag("Y");

		}


		if(cshBankAccount != null) {
			if(cshBank.getBankId() == null) {

				cshBankService.insert(requestContext,cshBank);
			}else {

				cshBankService.updateByPrimaryKeySelective(requestContext,cshBank);
			}
			cshBankAccount.setBankId(cshBank.getBankId());

			if(cshBankAccount.getBankAccountId() == null) {
				self().insertSelective(requestContext,cshBankAccount);
			}else {
				self().updateByPrimaryKeySelective(requestContext,cshBankAccount);
			}
		}
	}

	@Override
	public List<HlsCusCshBankAccount> bankAccountQuery(HlsCusCshBankAccount cshBankAccount) {
		return mapper.bankAccountQuery(cshBankAccount);
	}

	public List<HlsCusCshBank> selectCshBankLov(Map<String, Object> params){
		return mapper.selectCshBankLov(params);
	}

	public List<HlsCusCshBank> bankInfoQuery(HlsCusCshBank cshBank) {
		// TODO Auto-generated method stub
		return mapper.bankInfoQuery(cshBank);
	}

	public List<HlsCusCshBank> bankInfoQuery2(Long bpId) {
		// TODO Auto-generated method stub
		return mapper.bankInfoQuery2(bpId);
	}
	public List<HlsCusCshBankAccount> queryFinanceBankAccount(HlsCusCshBankAccount cshBankAccount,int page,int pageSize){
		PageHelper.startPage(page,pageSize);
        return mapper.queryFinanceBankAccount(cshBankAccount);
	}

}
