package hls.core.csh.service.impl;

import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.csh.dto.HlsCusCshBank;
import hls.core.csh.dto.HlsCusCshBankAccount;
import hls.core.csh.mapper.HlsCusCshBankAccountMapper;
import hls.core.csh.mapper.HlsCusCshBankMapper;
import hls.core.csh.service.CshBankService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;


@Service
@Transactional
public class CshBankServiceImpl extends BaseServiceImpl<HlsCusCshBank> implements CshBankService{
    @Autowired
    private HlsCusCshBankMapper cshBankMapper;

    @Autowired
    private HlsCusCshBankAccountMapper cshBankAccountMapper;


    @Override
    public int batchDelete(List<HlsCusCshBank> list) {
        int t=0;
        HlsCusCshBankAccount cshBankAccount = new HlsCusCshBankAccount();

        for (HlsCusCshBank cshBank:list){
            cshBankAccount.setBankId(cshBank.getBankId());
            List<HlsCusCshBankAccount>  cshBankAccounts = cshBankAccountMapper.select(cshBankAccount);
            for (HlsCusCshBankAccount cs:cshBankAccounts) {
                cshBankAccountMapper.delete(cs);
            }
            cshBankMapper.delete(cshBank);
            t++;
        }
        return t;
    }

    @Override
    public List<HlsCusCshBank> bankCodeQuery(String bankCode) {
        return cshBankMapper.bankCodeQuery(bankCode);
    }
}
