package hls.core.csh.service.impl;

import java.util.*;

import com.github.pagehelper.PageHelper;
import hls.core.csh.dto.HlsCusCshPaymentReqHd;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.csh.mapper.HlsCusCshPaymentReqHdMapper;
import hls.core.csh.service.ICshPaymentReqHdService;

@Service
@Transactional
public class CshPaymentReqHdServiceImpl extends BaseServiceImpl<HlsCusCshPaymentReqHd> implements ICshPaymentReqHdService {

    @Autowired
    private HlsCusCshPaymentReqHdMapper mapper;

    @Override
    public List<HlsCusCshPaymentReqHd> queryAll(HlsCusCshPaymentReqHd paymentReqHd, int page, int pageSzie) {

        Map<String, Object> params = new HashMap<String, Object>();
        List<String> list_req = new ArrayList<String>();
        List<String> list_flag = new ArrayList<String>();
        String[] payment_req_status = null;
        String[] payment_flag = null;
        if (paymentReqHd.getPayment_req_status() != null) {
            payment_req_status = paymentReqHd.getPayment_req_status().split(",");
            for (int i = 0; i < payment_req_status.length; i++) {
                list_req.add(payment_req_status[i]);
            }
            params.put("list_req", list_req);
        }
        if (paymentReqHd.getPayment_flag() != null) {
            payment_flag = paymentReqHd.getPayment_flag().split(",");
            for (int j = 0; j < payment_flag.length; j++) {
                list_flag.add(payment_flag[j]);
            }
            params.put("list_flag", list_flag);
        }


        params.put("payment_req_id", paymentReqHd.getPayment_req_id());
        params.put("payment_req_number", paymentReqHd.getPayment_req_number());
        params.put("payment_amount_1", paymentReqHd.getPayment_amount_1());
        params.put("payment_amount_2", paymentReqHd.getPayment_amount_2());
        params.put("payment_amount_3", paymentReqHd.getPayment_amount_3());
        params.put("amount_from", paymentReqHd.getAmount_from());
        params.put("amount_to", paymentReqHd.getAmount_to());


        PageHelper.startPage(page,pageSzie);

        return mapper.queryAll(params);
    }

    @Override
    public HlsCusCshPaymentReqHd queryCshPaymentHdById(Long payment_req_id) {
        return mapper.queryCshPaymentHdById(payment_req_id);
    }

    @Override
    public List<HlsCusCshPaymentReqHd> queryApply(Long contractId) {
        return mapper.queryApply(contractId);
    }
}
