package hls.core.csh.service.impl;

import java.text.SimpleDateFormat;
import java.util.*;

import javax.servlet.http.HttpSession;

import hls.core.csh.dto.HlsCusCshPaymentReqHd;
import hls.core.csh.dto.HlsCusCshPaymentReqLn;
import hls.core.csh.mapper.HlsCusCshPaymentReqHdMapper;
import hls.core.lon.dto.HlsCusLonContract;
import hls.core.lon.dto.HlsCusLonContractWithdraw;
import hls.core.lon.mapper.HlsCusLonContractWithdrawMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.csh.dto.HlsCusCshApprovalQuantity;
import hls.core.csh.mapper.HlsCusCshPaymentReqLnMapper;
import hls.core.csh.service.ICshPaymentReqLnService;

 
@Service
@Transactional
public class CshPaymentReqLnServiceImpl extends BaseServiceImpl<HlsCusCshPaymentReqLn> implements ICshPaymentReqLnService{

	@Autowired
	private HlsCusCshPaymentReqLnMapper mapper;
	@Autowired
	private HlsCusCshPaymentReqHdMapper cusCshPaymentReqHdMapper;
	/* (non-Javadoc)
	 * @see hls.core.csh.service.ICshPaymentReqLnService#selectAllCshPaymentReq(hls.core.csh.dto.HlsCusCshPaymentReqLn)
	 */
	@Autowired
	private HlsCusLonContractWithdrawMapper withdrawMapper;
	@Override
	public List<HlsCusCshPaymentReqLn> selectCshPaymentReqLnByHd(HlsCusCshPaymentReqLn cshPaymentReqLn) {
		return mapper.selectCshPaymentReqLnByHd(cshPaymentReqLn);
	}

	@Override
	public List<HlsCusCshPaymentReqLn> selectCshPaymentReqLnDetailByLnID(HlsCusCshPaymentReqLn cshPaymentReqLn) {
	        String[] arr = cshPaymentReqLn.getLn_id_str().split("-");
		    //融资还款-一个申请头下可能有多行 但是页面上只有一个行id 所以在这里先根据行id判断对应的头下面有几个行
		    List<String> fullList = new ArrayList<>();
		    for(int i=0;i<arr.length;i++){
				HlsCusCshPaymentReqLn dto = new HlsCusCshPaymentReqLn ();
				dto.setPayment_req_ln_id(Long.parseLong(arr[i]));
				HlsCusCshPaymentReqLn resultDto = mapper.selectByPrimaryKey(dto);
				Long hdId = resultDto.getPayment_req_id();//头id
				String documentType = resultDto.getDocumentType();//类型
				//根据头id获取相应的行
				HlsCusCshPaymentReqLn reqLn = new HlsCusCshPaymentReqLn();
				reqLn.setPayment_req_id(hdId);
				List<HlsCusCshPaymentReqLn> reqLnList = new ArrayList<>();
				if("REPAYMENT_REQ".equals(documentType)){
					reqLnList = queryByPaymentReqId(reqLn);
				}else{
					reqLnList = mapper.select(reqLn);
				}
				for(HlsCusCshPaymentReqLn item:reqLnList){
					//循环添加行ID
					fullList.add(item.getPayment_req_ln_id().toString());
				}

			}
		   // List<String> list =  Arrays.asList(arr);//获取申请头idlist

	        if(fullList != null){
	        	List<HlsCusCshPaymentReqLn> lists = mapper.selectCshPaymentReqLnDetailByLnID(fullList);
	        	return lists;
	        }
		return null;
	}


	SimpleDateFormat dft = new SimpleDateFormat("yyyy-MM-dd");
	@Override  
	public List<HlsCusCshPaymentReqLn> selectLaunchApplication(HlsCusCshPaymentReqLn cshPaymentReqLn, HttpSession session){
		if("null".equalsIgnoreCase(cshPaymentReqLn.getPaymentReqStatus())){
			cshPaymentReqLn.setPaymentReqStatus(null);
		}
		Long companyId = (Long) session.getAttribute("companyId");
		cshPaymentReqLn.setCompanyId(companyId);
		Long fate = cshPaymentReqLn.getQueryTimeSolt();
		if (fate != null) {
			String endDate = calculationDate(fate);
			try {
				cshPaymentReqLn.setPayment_req_date(dft.parse(endDate));
			}catch (java.text.ParseException e){
				e.printStackTrace();
			}
			if(fate== 0){
				cshPaymentReqLn.setPayment_req_date(null);
			}
		}

		if("null".equalsIgnoreCase(cshPaymentReqLn.getDocumentType())){
			cshPaymentReqLn.setDocumentType(null);
		}
		return mapper.selectLaunchApplication(cshPaymentReqLn);
	}

	private String calculationDate(Long fate) {
		//SimpleDateFormat dft = new SimpleDateFormat("yyyy-MM-dd");
		Date beginDate = new Date();
		Calendar date = Calendar.getInstance();
		date.setTime(beginDate);
		if (fate == 7) {
			date.set(Calendar.DATE, date.get(Calendar.DATE) - 7);
		}
		if (fate == 30) {
			date.add(Calendar.MONTH, -1);
		}
		if (fate == 90) {
			date.add(Calendar.MONTH, -3);
		}
		String endDate = dft.format(date.getTime());
		return endDate;
	}

	@Override
	public HlsCusCshApprovalQuantity selectApprovalQuantity(HttpSession session){
		Long companyId = (Long) session.getAttribute("companyId");
		HlsCusCshPaymentReqLn cshPaymentReqLn = new HlsCusCshPaymentReqLn();
		cshPaymentReqLn.setCompanyId(companyId);
		return mapper.selectApprovalQuantity(cshPaymentReqLn);
	}

	@Override
	public List<HlsCusCshPaymentReqLn> selectLov(HlsCusCshPaymentReqLn cshPaymentReqLn) {
		return mapper.selectLov(cshPaymentReqLn);
	}

	@Override
	public List<HlsCusCshPaymentReqLn> selectLovContract(HlsCusCshPaymentReqLn cshPaymentReqLn) {
		return mapper.selectLovContract(cshPaymentReqLn);
	}

	@Override
	public List<HlsCusCshPaymentReqLn> queryAll(HlsCusCshPaymentReqLn cshPaymentReqLn) {
		return mapper.queryAll(cshPaymentReqLn);
	}
	/**
	 * 付款申请 - 单行 -明细
	 */
	@Override
	public List<HlsCusCshPaymentReqLn> queryDetail(HlsCusCshPaymentReqLn cshPaymentReqLn) {
		return mapper.queryDetail(cshPaymentReqLn);
	}

	/**
	 * 付款申请 - 单行 -明细
	 */
	@Override
	public List<HlsCusCshPaymentReqLn> queryOneDetail(HlsCusCshPaymentReqLn cshPaymentReqLn) {
		return mapper.queryOneDetail(cshPaymentReqLn);
	}

	@Override
	public List<HlsCusCshPaymentReqLn> selectCshPaymentReqLnDetailByLnID(List<String> ln_id) {
		return mapper.selectCshPaymentReqLnDetailByLnID(ln_id);
	}
	@Override
	public void updateAmountPaid(HlsCusCshPaymentReqLn cshPaymentReqLn){
		mapper.updateAmountPaid(cshPaymentReqLn);
	}
	@Override
	public void updatePaymentFlag(HlsCusCshPaymentReqLn cshPaymentReqLn){
		mapper.updatePaymentFlag(cshPaymentReqLn);
	}

	@Override
	public HlsCusCshPaymentReqLn queryCshPaymentLnByPreqId(Long payment_req_ln_id) {
		return mapper.queryCshPaymentLnByPreqId(payment_req_ln_id);
	}

	@Override
	public List<HlsCusCshPaymentReqLn> queryByHnId(HlsCusCshPaymentReqLn cshPaymentReqLn) {
		return mapper.queryByHnId(cshPaymentReqLn);
	}

	@Override
	public List<HlsCusCshPaymentReqLn> selectCshPaymentReqLn(HlsCusCshPaymentReqLn cshPaymentReqLn) {
		return mapper.selectCshPaymentReqLn(cshPaymentReqLn);
	}
	/*融资模块-还款维护-根据申请头ID获取相关行信息*/
	public List<HlsCusCshPaymentReqLn> queryByPaymentReqId(HlsCusCshPaymentReqLn cshPaymentReqLn){
		List<HlsCusCshPaymentReqLn> list = mapper.select(cshPaymentReqLn);
		//根据查到的提款id找到合同id
		Long withdrawId = list.get(0).getSource_doc_id();
		HlsCusLonContractWithdraw withdraw = new HlsCusLonContractWithdraw();
		withdraw.setWithdrawId(withdrawId);
		Long lonContractId = withdrawMapper.select(withdraw).get(0).getContractId();
		String repaymentIds ="";
		for(HlsCusCshPaymentReqLn item:list){
			item.setContract_id(lonContractId.toString());
			repaymentIds = repaymentIds+item.getSource_doc_line_id()+"-";

		}
		list.get(0).setRepaymentIds(repaymentIds);
		return list;

	}
}
