package hls.core.csh.service.impl;

import com.hand.hap.core.IRequest;
import hls.core.csh.dto.HlsCusConContractCashflow;
import hls.core.csh.dto.HlsCusCshTransaction;
import hls.core.csh.dto.HlsCusCshWriteOff;
import hls.core.csh.mapper.HlsCusConContractCashflowMapper;
import hls.core.csh.mapper.HlsCusCshDeductionMapper;
import hls.core.csh.mapper.HlsCusCshTransactionMapper;
import hls.core.csh.service.CshTransactionService;
import hls.core.gld.components.AbstractJeTrxService;
import hls.core.hls.components.CalculateUtil;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * Created by FJM on 2017/1/20.
 */
public class DeductionUtils {



    public static void UpdateCshTransaction(IRequest request, HlsCusCshWriteOff data, HlsCusCshTransactionMapper ctm, HlsCusCshDeductionMapper cshDeductionMapper, CshTransactionService cshTransactionService, Map<String, AbstractJeTrxService> serviceMap) {
        HlsCusCshTransaction ct = new HlsCusCshTransaction();
        ct.setTransactionId(data.getCshTransactionId());
        List<HlsCusCshTransaction> datas =  ctm.select(ct);

        if (data!=null && datas.size()>0){
            Double writeOff = data.getCshWriteOffAmount();//获取本次的核销金额
            Double writeOff2 = datas.get(0).getWriteOffAmount();//获取之前的核销金额总额
            Double transactionamount = datas.get(0).getTransactionAmount();//获取应收金额

            if (writeOff == null ){
                writeOff = new Double(0);
            }
            if (writeOff2 == null){
                writeOff2 = new Double(0);
            }
            if (transactionamount == null){
                transactionamount = new Double(0);
            }


            //防止null值相加报出异常
            HlsCusCshTransaction cshTransaction = ctm.selectByPrimaryKey(data.getCshTransactionId());
            Double writeOffAmount = cshTransaction.getWriteOffAmount();
            Double cshWriteOffAmount = data.getCshWriteOffAmount();
            HlsCusCshTransaction newTransaction = new HlsCusCshTransaction();
            BigDecimal w1 = new BigDecimal(Double.toString(writeOff));//未核金额
            BigDecimal w2 = new BigDecimal(Double.toString(writeOff2));//已核金额
//            if(w1.add(w2).doubleValue() == transactionamount){ //将csh_write_off.csh_write_off_amount累加
//
//                data.setTransactionId(data.getCshTransactionId());
//                data.setWriteOffFlag("FULL");
//                Date date = new Date();
//                data.setFullWriteOffDate(date);
//                newTransaction.setTransactionId(data.getCshTransactionId());
//                newTransaction.setWriteOffAmount(CalculateUtil.add(writeOffAmount,cshWriteOffAmount));
//                newTransaction.setWriteOffFlag("FULL");
//                newTransaction.setFullWriteOffDate(date);
//                cshTransactionService.updateByPrimaryKeySelective(request,newTransaction);
//            }
//            else if (w1.add(w2).doubleValue() == 0){
//
//                data.setTransactionId(data.getCshTransactionId());
//                data.setWriteOffFlag("NOT");
//                newTransaction.setTransactionId(data.getCshTransactionId());
//                newTransaction.setWriteOffAmount(CalculateUtil.add(writeOffAmount,cshWriteOffAmount));
//                newTransaction.setWriteOffFlag("NOT");
//                cshTransactionService.updateByPrimaryKeySelective(request,newTransaction);
//            }
//            else if (w1.add(w2).doubleValue() > transactionamount){
//                //抛出异常
//                throw  new IllegalArgumentException("核销金额不能大于现金事务金额！");
//            }else {
//                data.setTransactionId(data.getCshTransactionId());
//                data.setWriteOffFlag("PARTIAL");
//                newTransaction.setTransactionId(data.getCshTransactionId());
//                newTransaction.setWriteOffAmount(CalculateUtil.add(writeOffAmount,cshWriteOffAmount));
//                newTransaction.setWriteOffFlag("PARTIAL");
//                cshTransactionService.updateByPrimaryKeySelective(request,newTransaction);
//            }
           if (transactionamount==0) {
               //抛出异常
               throw new IllegalArgumentException("收款金额不能为0");
           }
            if(w1.doubleValue()==transactionamount){ //将csh_write_off.csh_write_off_amount累加

                data.setTransactionId(data.getCshTransactionId());
                data.setWriteOffFlag("FULL");
                Date date = new Date();
                data.setFullWriteOffDate(date);
                newTransaction.setTransactionId(data.getCshTransactionId());
                newTransaction.setWriteOffAmount(CalculateUtil.add(writeOffAmount,cshWriteOffAmount));
                newTransaction.setWriteOffFlag("FULL");
                newTransaction.setFullWriteOffDate(date);
                cshTransactionService.updateByPrimaryKeySelective(request,newTransaction);
            }
            else if (w1.doubleValue()<transactionamount){ //将csh_write_off.csh_write_off_amount累加
                data.setTransactionId(data.getCshTransactionId());
                data.setWriteOffFlag("FULL");
                Date date = new Date();
                data.setFullWriteOffDate(date);
                newTransaction.setTransactionId(data.getCshTransactionId());
                newTransaction.setWriteOffAmount(CalculateUtil.add(writeOffAmount,cshWriteOffAmount));
                newTransaction.setWriteOffFlag("FULL");
                newTransaction.setFullWriteOffDate(date);
                cshTransactionService.updateByPrimaryKeySelective(request,newTransaction);
            }
            else {
                 data.setTransactionId(data.getCshTransactionId());
                data.setWriteOffFlag("PARTIAL");
                newTransaction.setTransactionId(data.getCshTransactionId());
                newTransaction.setWriteOffAmount(CalculateUtil.add(writeOffAmount,cshWriteOffAmount));
                newTransaction.setWriteOffFlag("PARTIAL");
                cshTransactionService.updateByPrimaryKeySelective(request,newTransaction);
            }


//            //插入凭证事物流水表 by fjm 17.9.1
//            HlsCusCshTransaction cshTransaction = new HlsCusCshTransaction();
//            cshTransaction.setTransactionId(data.getTransactionId());
//            Long companyId = cshTransactionService.selectByPrimaryKey(request,cshTransaction).getCompanyId();
//            Map params = new HashMap<>();
//            params.put("jeTrxId",data.getTransactionId());
//            params.put("companyId",companyId);
//            params.put("contractId",data.getContractId());
//            params.put("sourceDoc","CON_CONTRACT");
//            AbstractJeTrxService jeTrxService = serviceMap.get("CSH_TRANSACTION");//获取CSH_TRANSACTION类型的接口实例
//            jeTrxService.process(request,params);

        }


    }


    public static void UpdateCshFlow(IRequest request, HlsCusCshWriteOff data, HlsCusConContractCashflowMapper con, HlsCusCshDeductionMapper cshDeductionMapper, CshTransactionService cshTransactionService) {
        HlsCusConContractCashflow csh = new HlsCusConContractCashflow();
        //判断cashflowId是否为空
        if (data.getCashflowId()!=null){
            csh.setCashflow_id(data.getCashflowId());
        }
        //根据上面获取的现金流ID，查询出对应的现金流数据
        List<HlsCusConContractCashflow> cashflow = con.select(csh);
        Double reciveM = null;//定义一个变量接受应收金额
        Double reciveP = null;//定义一个变量接受应收本金
        Double reciveI = null;//定义一个变量接受应收利息
        if (cashflow.size()>0){
            //获取应收金额，应收本金和应收利息
            reciveM = cashflow.get(0).getDue_amount();
            reciveP = cashflow.get(0).getPrincipal();
            reciveI = cashflow.get(0).getInterest();
            //判断获取的金额是否为空并且校验已收金额不大于应收金额,使用bigDecimal以防止精度丢失的问题
            if (data.getCshWriteOffAmount() != null && (new BigDecimal(Double.toString(data.getCshWriteOffAmount())).add(new BigDecimal(cashflow.get(0).getReceived_amount())).doubleValue()<=reciveM)){
                Double  principalM = null;
                Double  principalP = null;
                if (data.getWriteOffPrincipal()==null){
                    principalM = new Double(0);
                }else {
                    principalM = data.getWriteOffPrincipal();
                }
                if (cashflow.get(0).getReceived_principal()==null){
                    principalP = new Double(0);
                }else {
                    principalP = cashflow.get(0).getReceived_principal();
                }

                BigDecimal rM = new BigDecimal(Double.toString(reciveM));
                //BigDecimal rP = new BigDecimal(Double.toString(reciveP));

                BigDecimal pM = new BigDecimal(Double.toString(principalM));
                BigDecimal pP = new BigDecimal(Double.toString(principalP));
                if (cashflow.get(0).getPrincipal() != null && (pM.add(pP).doubleValue()<=reciveP)){
                    Double interestM = null;
                    Double interestP = null;
                    if (data.getWriteOffInterest() == null){
                        interestM = new Double(0);
                    }else {
                        interestM =  data.getWriteOffInterest();
                    }
                    if (cashflow.get(0).getReceived_interest() == null){
                        interestP = new Double(0);
                    }else {
                        interestP = cashflow.get(0).getReceived_interest();
                    }
                    BigDecimal iM = new BigDecimal(Double.toString(interestM));
                    BigDecimal iP = new BigDecimal(Double.toString(interestP));

                    if ( iM.add(iP).doubleValue()<=reciveI){
                        Date date = new Date();
                        data.setLastReceiveDate(date);
                        if ( cashflow.get(0).getDue_amount() == new BigDecimal(Double.toString(cashflow.get(0).getReceived_amount())).add(new BigDecimal(Double.toString(data.getCshWriteOffAmount()))).doubleValue()) {
                            data.setWriteOffFlag("FULL");
                            data.setFullWriteOffDate(date);
                        }else if(new BigDecimal(Double.toString(cashflow.get(0).getReceived_amount())).add(new BigDecimal(Double.toString(data.getCshWriteOffAmount()))).doubleValue() == 0){
                            data.setWriteOffFlag("NOT");
                        }else{
                            data.setWriteOffFlag("PARTIAL");
                        }
                        cshDeductionMapper.updateCshFlow(data);
                    }else {
                        //抛出异常？
                        throw new IllegalArgumentException("已收利息不能大于应收利息");
                    }
                }else {
                    //抛出异常？
                    throw new IllegalArgumentException("已收本金不能大于应收本金");
                }
            }else {
                //抛出异常?
                throw  new IllegalArgumentException("已收金额不能大于应收金额");

            }
        }

    }

}
