package hls.core.db.controllers;

import com.hand.hap.system.dto.ResponseData;
import hls.core.db.service.IExportDatabaseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-08-24
 * Time: 10:55
 */
@Controller
public class ExportDatabaseController {
    @Autowired
    private IExportDatabaseService exportDatabaseService;

    @RequestMapping("/database/table/export")
    public void exportTables(@RequestParam(name = "tables", required = false) List<String> tableNames,
                             HttpServletResponse response) {
        exportDatabaseService.exportTables(tableNames, response);
    }

    @RequestMapping("/database/datas/export")
    public void exportDatas(@RequestParam(name = "tables", required = false) List<String> tableNames,
                            HttpServletResponse response) {
        exportDatabaseService.exportDatas(tableNames, response);
    }

    @RequestMapping("/database/tablesAnddatas/export")
    public void exportTablesAndDatas(@RequestParam(name = "tables", required = false) List<String> tableNames,
                                     @RequestParam(name = "dataTables", required = false) List<String> dataTables,
                                     HttpServletResponse response) {
        exportDatabaseService.exportTablesAndDatas(tableNames, dataTables, response);
    }

    @RequestMapping("/database/table/query")
    @ResponseBody
    public ResponseData getAllTables(){
        return exportDatabaseService.queryTables();
    }
}
