package hls.core.db.controllers;

import com.hand.hap.mybatis.mapperhelper.MapperTemplate;
import com.hand.hap.mybatis.spring.MapperScannerConfigurer;
import com.hand.hap.system.controllers.BaseController;
import hls.core.db.components.MapperRefreshPlugin;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.File;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * mapper刷新的控制器,用于开发者调试用
 * Created by fjm on 2017/11/16.
 */
@RestController
public class MybatisRefreshController extends BaseController {

    @Autowired
    private MapperRefreshPlugin mapperRefreshPlugin;
    @Autowired
    private MapperScannerConfigurer scannerConfigurer;

    @RequestMapping("/mybatis/refresh")
    public Map mapperRefresh() {
        Map<Class<?>, MapperTemplate> registerMapper = scannerConfigurer.getMapperHelper().getRegisterMapper();
        if (registerMapper != null) {
            registerMapper.forEach((k, v) -> v.refreshEntityClassMap());
        }
        Map map = new HashMap<>();
        try {
            List<File> list = mapperRefreshPlugin.doRefresh();
            StringBuilder sb = new StringBuilder();
            for (File item : list) {
                sb.append(item.getName()).append(",");
            }
            if (sb.length() > 0)
                sb.deleteCharAt(sb.length() - 1);
            map.put("success", true);
            map.put("message", "mapper刷新成功,刷新文件:" + sb.toString());

        } catch (Exception e) {
            map.put("success", false);
            map.put("message", e.getMessage());
        }
        return map;
    }
}
