package hls.core.db.interceptor;


import org.apache.ibatis.executor.Executor;
import org.apache.ibatis.mapping.MappedStatement;
import org.apache.ibatis.plugin.*;

import java.util.Properties;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 * @Author: syj
 * @Description:
 * @Date: Created in 2017/12/14 15:52
 * @Modified By:
 */
@Intercepts({
        @Signature(type = Executor.class, method = "update", args = {
                MappedStatement.class, Object.class})})
public class SqlExceptionInterceptor implements Interceptor {
    private static ExecutorService executor = Executors.newFixedThreadPool(5);

    @Override
    public Object intercept(Invocation invocation) throws Throwable {

        try {
            return invocation.proceed();
        } catch (Exception e) {
            if(e.getCause().getMessage().contains("Data too long for column") || e.getCause().getMessage().contains("ORA-01461")){
                throw new IllegalArgumentException("填写的内容超过字段的最大字数限制！");
            }
            throw e;
        }
    }

    @Override
    public Object plugin(Object o) {
        return Plugin.wrap(o, this);
    }

    @Override
    public void setProperties(Properties properties) {

    }


}
