//package hls.core.db

import com.hand.hap.liquibase.MigrationHelper

//表结构
databaseChangeLog(logicalFilePath: "hls/core/db/liquibase.groovy") {
    println($/          _____                    _____                    _____     /$)
    println($/         /\    \                  /\    \                  /\    \    /$)
    println($/        /::\____\                /::\    \                /::\____\   /$)
    println($/       /:::/    /               /::::\    \              /:::/    /   /$)
    println($/      /:::/    /               /::::::\    \            /:::/    /    /$)
    println($/     /:::/    /               /:::/\:::\    \          /:::/    /     /$)
    println($/    /:::/____/               /:::/__\:::\    \        /:::/    /      /$)
    println($/   /::::\    \              /::::\   \:::\    \      /:::/    /       /$)
    println($/  /::::::\    \   _____    /::::::\   \:::\    \    /:::/    /        /$)
    println($/ /:::/\:::\    \ /\    \  /:::/\:::\   \:::\    \  /:::/    /         /$)
    println($//:::/  \:::\    /::\____\/:::/__\:::\   \:::\____\/:::/____/          /$)
    println($/\::/    \:::\  /:::/    /\:::\   \:::\   \::/    /\:::\    \          /$)
    println($/ \/____/ \:::\/:::/    /  \:::\   \:::\   \/____/  \:::\    \         /$)
    println($/          \::::::/    /    \:::\   \:::\    \       \:::\    \        /$)
    println($/           \::::/    /      \:::\   \:::\____\       \:::\    \       /$)
    println($/           /:::/    /        \:::\   \::/    /        \:::\    \      /$)
    println($/          /:::/    /          \:::\   \/____/          \:::\    \     /$)
    println($/         /:::/    /            \:::\    \               \:::\    \    /$)
    println($/        /:::/    /              \:::\____\               \:::\____\   /$)
    println($/        \::/    /                \::/    /                \::/    /   /$)
    println($/         \/____/                  \/____/                  \/____/    /$)
    println($/                                                                      /$)
    def migrationHelper = MigrationHelper.getInstance()
    migrationHelper.dbmigrate.delegate = delegate
    //上面的内容不需要改动,三个参数的含义分别是
    //"mysql"表示数据库类型
    //["com/hand/hap"] 表示本次要执行脚本的扫描路径,可以添加多个
    //executeDate表示对register脚本执行的日期控制，只执行以此日期开头的脚本，如果为all表示全部执行
    //["table", "data"] 表示在建表的同时初始化数据
    def dbType = "mysql";
    def dburl = System.properties.getProperty("db.url");
    //def executeDate = "all";
    def executeDate = "2018-01-28";
    dburl = dburl == null ? "" : dburl;
    if (dburl.startsWith("jdbc:oracle")) {
        dbType = "oracle";
    } else if (dburl.startsWith("jdbc:sqlserver")) {
        dbType = "sqlserver";
    }
    println(dburl)
    println(dbType)
    // 现在支持自动根据 db.url 参数检测数据库类型
//    migrationHelper.dbmigrate(dbType,["hls/core"] ,executeDate,["table", "data", "patch","register"])
    migrationHelper.dbmigrate(dbType,["hls/core"] ,executeDate,["register"])
    println("done")
}