package hls.core.db.utils;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by weck on 30/01/2018 4:07 PM
 *
 * 备份数据帮助类，设置DataBackupHelper.setNeedFilter(true/false)选择是否进行备份
 */
public final class DataBackupHelper {

    private static ThreadLocal<Boolean> localNeedFilter = new ThreadLocal<>();

    private static Logger logger = LoggerFactory.getLogger(DataBackupHelper.class);

    public DataBackupHelper() {
    }

    public static Boolean getNeedFilter() {
        return localNeedFilter.get();
    }

    public static void setNeedFilter(Boolean needFilter) {
        localNeedFilter.set(needFilter);
    }

    public static void clearNeedFilter() {
        localNeedFilter.remove();
    }
}
