package hls.core.document.utils;

import org.springframework.util.StringUtils;

import java.util.Iterator;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * Created by fjm on 2018/1/19.
 */
public class DocumentUtil {
    /**
     * 去除参数值为空的参数,并对参数map安装name排序,以保证url中参数位置交换时依然会跳转同一个url
     *
     * @return
     */
    public static Map<String, Object> removeNullParameterAndSort(Map<String, Object> parameterMap) {
        Iterator<String> iterator = parameterMap.keySet().iterator();
        //删除为空的参数
        while (iterator.hasNext()) {
            String key = iterator.next();
            Object o = parameterMap.get(key);
            if (StringUtils.isEmpty(o))
                iterator.remove();
        }
        //根据key进行排序
        parameterMap = parameterMap.entrySet()
                .stream()
                .sorted(Map.Entry.<String, Object>comparingByKey()
                        .reversed())
                .collect(Collectors.toMap(item -> item.getKey(), item -> item.getValue()));
        return parameterMap;
    }
}
