package hls.core.ease.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import hls.core.ease.mapper.EaseMapper;
import hls.core.ease.service.IEaseService;
import hls.core.hls.dto.HlsSystemNotice;
import hls.core.hls.dto.HlsUserRelationship;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * Created by fjm on 2018/1/4.
 */
@Transactional
@Service
public class EaseServiceImpl implements IEaseService{

    @Autowired
    EaseMapper easeMapper;

    /*查询我的待办*/
    @Override
    public List<HlsSystemNotice> selectNoticeMessageForEase(IRequest request, HlsSystemNotice hlsSystemNotice, int page, int pageSize) {
        PageHelper.startPage(page,pageSize);
        final List<HlsSystemNotice> noticeMessage = easeMapper.selectNoticeMessageForEase(hlsSystemNotice);
        Date time = new Date();
        noticeMessage.forEach(item -> {
            Double arrvialTime = Double.valueOf((time.getTime() - item.getNotice_datetime().getTime()) / (1000 * 60 * 60));
            item.setArrivalTime(arrvialTime);
        });
        return noticeMessage;
    }
    /*查询我的收藏*/
    @Override
    public List<HlsUserRelationship> getCollections(IRequest request, HlsUserRelationship relationship){
        return easeMapper.getCollectionsForEase(relationship);
    }
    /*查询收藏单据消息动态*/
    @Override
    public List<HlsSystemNotice> getCollectNoticeMessage(IRequest request, HlsSystemNotice hlsSystemNotice,int page,int pageSize) {
        PageHelper.startPage(page,pageSize);
        List<HlsSystemNotice> noticeMessage = easeMapper.getCollectNoticeMessage(hlsSystemNotice);
        return noticeMessage;
    }
    /*查询我的申请*/
    @Override
    public List<Map> queryMyApplication(Map map,int page,int pageSize) {
        PageHelper.startPage(page,pageSize);
        String[] statusList = null;
        if(map.get("approveStatus")!=null&&!"".equals(map.get("approveStatus"))){
            statusList = map.get("approveStatus").toString().split("-");
        }
        map.put("statusList",statusList);
        List<Map> applicationMessage = easeMapper.queryMyApplication(map);
        return applicationMessage;
    }
    /*查询我的审批*/
    @Override
    public List<Map> queryMyApprove(Map map,int page,int pageSize) {
        PageHelper.startPage(page,pageSize);
        String[] statusList = null;
        if(map.get("approveStatus")!=null&&!"".equals(map.get("approveStatus"))){
            statusList = map.get("approveStatus").toString().split("-");
        }
        map.put("statusList",statusList);
        List<Map> approveMessage = easeMapper.queryMyApprove(map);
        return approveMessage;
    }
    /*查询我的待办申请审批条数*/
    @Override
    public List<Map> queryMyListCount(Map map) {
        List<Map> countList = easeMapper.queryMyListCount(map);
        return countList;
    }
    /*查询事件屏蔽情况*/
    @Override
    public List<Map> queryEventCondition(Map map,int page,int pageSize) {
        PageHelper.startPage(page,pageSize);
        List<Map> eventList = easeMapper.queryEventCondition(map);
        return eventList;
    }
}
