package hls.core.fct.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fct.dto.HlsCusFctContractBp;
import hls.core.fct.service.FctContractBpService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class FctContractBpController extends BaseController {

    @Autowired
    private FctContractBpService service;

    @RequestMapping(value = "/fct/contract/bp/query")
    @ResponseBody
    public ResponseData query(HlsCusFctContractBp dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize,@RequestParam Long contractId) {
        if(contractId == null){
            contractId = 0L;
        }
        dto.setContractId(contractId);
        return new ResponseData(service.fctContractBpQuery(dto, page, pageSize));
    }

    @RequestMapping(value = "/fct/contract/bp/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusFctContractBp> dto, BindingResult result, HttpServletRequest request) {
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/fct/contract/bp/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusFctContractBp> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }
}