package hls.core.fct.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fct.dto.HlsCusFctContractQuotation;
import hls.core.fct.service.FctContractQuotationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class FctContractQuotationController extends BaseController {

    @Autowired
    private FctContractQuotationService service;


    @RequestMapping(value = "/fct/contract/quotation/query")
    @ResponseBody
    public ResponseData query(HlsCusFctContractQuotation dto, HttpServletRequest request,Long contractId) {
        IRequest requestContext = createRequestContext(request);
        if(contractId == null){
            contractId = 0L;
        }
        dto.setContractId(contractId);
        return new ResponseData(service.fctContractQuotationDetailQuery(dto));
    }

    @RequestMapping(value = "/fct/contract/quotation/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusFctContractQuotation> dto, BindingResult result, HttpServletRequest request) {
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/fct/contract/quotation/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusFctContractQuotation> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }
}