package hls.core.fct.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fct.dto.HlsCusFctContractWithdrawAtt;
import hls.core.fct.service.FctContractWithdrawAttService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class FctContractWithdrawAttController extends BaseController {

    @Autowired
    private FctContractWithdrawAttService service;


    @RequestMapping(value = "/fct/contract/withdraw/att/query")
    @ResponseBody
    public ResponseData query(HlsCusFctContractWithdrawAtt dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.selectConWithdrawAttachment(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/fct/contract/withdraw/att/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusFctContractWithdrawAtt> dto, BindingResult result, HttpServletRequest request) {
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/fct/contract/withdraw/att/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusFctContractWithdrawAtt> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }

    @RequestMapping(value = "/fct/contract/withdraw/content/query")
    @ResponseBody
    public ResponseData queryWithdrawContent(HttpServletRequest request, HlsCusFctContractWithdrawAtt dto) {
        List<HlsCusFctContractWithdrawAtt> list=service.queryWithdrawContent(dto);
        return new ResponseData(list);
    }
}