package hls.core.fct.controllers;

import hls.core.fct.dto.HlsCusFctContractWithdrawPt;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fct.dto.FctContractWithdrawPt;
import hls.core.fct.service.IFctContractWithdrawPtService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import org.springframework.validation.BindingResult;

import java.util.ArrayList;
import java.util.List;

    @Controller
    public class FctContractWithdrawPtController extends BaseController{

    @Autowired
    private IFctContractWithdrawPtService service;


    @RequestMapping(value = "/fct/contract/withdraw/pt/query")
    @ResponseBody
    public ResponseData query(HlsCusFctContractWithdrawPt dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/fct/contract/withdraw/pt/submit")
    @ResponseBody
public ResponseData update(@RequestBody List<HlsCusFctContractWithdrawPt> dto, BindingResult result, HttpServletRequest request){
getValidator().validate(dto, result);
if (result.hasErrors()) {
ResponseData responseData = new ResponseData(false);
responseData.setMessage(getErrorMessage(result, request));
return responseData;
}
        Long withdrawId=0L;
        IRequest requestCtx = createRequestContext(request);
        List<HlsCusFctContractWithdrawPt> fctContractWithdrawPtList=new ArrayList<>();
        for(HlsCusFctContractWithdrawPt dt:dto){
            if(dt.getWithdrawId()!=0){
                withdrawId=dt.getWithdrawId();
            }
            break;
        }
        int length=dto.size();
        for(HlsCusFctContractWithdrawPt dt:dto){
            if(dt.getProjectPaymentTermId()!=0){
                dt.set__status("update");
                fctContractWithdrawPtList.add(dt);
            }
            else if(dt.getProjectPaymentTermId()==0||dt.getProjectPaymentTermId()==null){
                dt.set__status("add");
                dt.setProjectPaymentTermId(1L);
                dt.setWithdrawId(withdrawId);
                fctContractWithdrawPtList.add(dt);
            }
        }
        fctContractWithdrawPtList=service.batchUpdate(requestCtx, fctContractWithdrawPtList);
        service.fctContractWithdrawPtSubmit(requestCtx,fctContractWithdrawPtList);
        return new ResponseData(fctContractWithdrawPtList);
    }
    @RequestMapping(value = "/fct/contract/withdraw/pt/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusFctContractWithdrawPt> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }