package hls.core.fct.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fct.dto.HlsCusFctContractWithdrawSpcl;
import hls.core.fct.service.FctContractWithdrawSpclService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

@Controller
public class FctContractWithdrawSpclController extends BaseController {

    @Autowired
    private FctContractWithdrawSpclService service;


    @RequestMapping(value = "/fct/contract/withdraw/spcl/query")
    @ResponseBody
    public ResponseData query(HlsCusFctContractWithdrawSpcl dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/fct/contract/withdraw/spcl/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusFctContractWithdrawSpcl> dto, BindingResult result, HttpServletRequest request) {
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        List<HlsCusFctContractWithdrawSpcl> fctContractWithdrawSpclList=new ArrayList<>();
        IRequest requestCtx = createRequestContext(request);
        for(HlsCusFctContractWithdrawSpcl dt:dto){
            if(dt.getWithdrawId()!=0){
                dt.set__status("add");
                fctContractWithdrawSpclList.add(dt);
            }

        }
        fctContractWithdrawSpclList=service.batchUpdate(requestCtx, fctContractWithdrawSpclList);
        service.fctContractWithdrawSpclSubmit(requestCtx,fctContractWithdrawSpclList);
        return new ResponseData(fctContractWithdrawSpclList);
    }

    @RequestMapping(value = "/fct/contract/withdraw/spcl/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusFctContractWithdrawSpcl> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }
}