package hls.core.fct.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fct.dto.HlsCusFctContractWithdrawTrx;
import hls.core.fct.service.FctContractWithdrawTrxService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

@Controller
public class FctContractWithdrawTrxController extends BaseController {

    @Autowired
    private FctContractWithdrawTrxService service;


    @RequestMapping(value = "/fct/contract/withdraw/trx/query")
    @ResponseBody
    public ResponseData query(HlsCusFctContractWithdrawTrx dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/fct/contract/withdraw/trx/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusFctContractWithdrawTrx> dto, BindingResult result, HttpServletRequest request) {
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/fct/contract/withdraw/trx/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, HlsCusFctContractWithdrawTrx dto) {
        service.fctContractWithdrawTrxDelete(dto);
        return new ResponseData();
    }
    @RequestMapping(value = "/fct/contract/withdraw/trx/contextQuery")
    @ResponseBody
    public ResponseData fctWithdrawTrxQuery(HlsCusFctContractWithdrawTrx dto) {
        List<HlsCusFctContractWithdrawTrx> list=new ArrayList<>();
        list=service.fctWithdrawTrxQuery(dto);
        return new ResponseData(list);
    }
}