package hls.core.fct.controllers;

import hls.core.fct.dto.HlsCusFctProjectBasicTrxAr;
import org.apache.commons.collections.map.HashedMap;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fct.dto.FctProjectBasicTrxAr;
import hls.core.fct.service.FctProjectBasicTrxArService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import org.springframework.validation.BindingResult;

import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Controller
    public class FctProjectBasicTrxArController extends BaseController{

    @Autowired
    private FctProjectBasicTrxArService service;


    /*@RequestMapping(value = "/fct/project/basic/trx/ar/query")
    @ResponseBody
    public ResponseData query(HlsCusFctProjectBasicTrxAr dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }*/
    @RequestMapping(value = "/fct/project/basic/trx/ar/query")
    @ResponseBody
    public ResponseData query(HlsCusFctProjectBasicTrxAr dto, Long basicTrxDtlId) {
        if(basicTrxDtlId==null){
            basicTrxDtlId=0L;
        }
        dto.setBasicTrxDtlId(basicTrxDtlId);
        return new ResponseData(service.fctProjectBasicTrxArQuery(dto));
    }

    @RequestMapping(value = "/fct/project/basic/trx/ar/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusFctProjectBasicTrxAr> dto, BindingResult result, HttpServletRequest request){
    getValidator().validate(dto, result);
    if (result.hasErrors()) {
    ResponseData responseData = new ResponseData(false);
    responseData.setMessage(getErrorMessage(result, request));
    return responseData;
    }
        IRequest requestCtx = createRequestContext(request);
        if(dto!=null){
            for(HlsCusFctProjectBasicTrxAr dt : dto){
                if(dt.getBasicTrxArId()==null||dt.getBasicTrxArId()==0){
                    dt.set__status("add");
                }
                else{
                    dt.set__status("update");
                }

            }
        }
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/fct/project/basic/trx/ar/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusFctProjectBasicTrxAr> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

    /*excel导入*/
    @RequestMapping(value = "/fct/trx/arExcelImportConfirm", method = RequestMethod.POST)
    public Map<String, Object> importConfirm(HttpServletRequest request, Long headerId,Long basicTrxDtlId) throws IOException {
        IRequest iRequest = createRequestContext(request);
        Map<String,Object> response = new HashMap<String,Object>();
        response.put("success", false);
        try {
            service.arExcelImportConfirm(iRequest, headerId,basicTrxDtlId);
            response.put("message", "导入成功");
            response.put("success", true);
        } catch (Exception e) {
            response.put("success", false);
            response.put("message", "导入失败！" + e.getMessage());
            e.printStackTrace();
        }
        return response;
    }
    }