package hls.core.fct.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fct.dto.*;
import hls.core.fct.service.FctProjectBasicTrxArService;
import hls.core.fct.service.FctProjectBasicTrxDtlService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

@Controller
public class FctProjectBasicTrxDtlController extends BaseController {

    @Autowired
    private FctProjectBasicTrxDtlService service;
    @Autowired
    private FctProjectBasicTrxArService fctProjectBasicTrxArService;

    //用款需求申请
    @RequestMapping(value = "/fct/contract/basic/trx/dtl/query")
    @ResponseBody
    public ResponseData contractTrx(HlsCusFctProjectBasicTrxDtl dto) {
        return new ResponseData(service.fctContractWithdrawTrxDtl(dto));
    }

    @RequestMapping(value = "/fct/project/basic/trx/dtl/meg/query")
    @ResponseBody
    public ResponseData megquery(HlsCusFctProjectBasicTrxDtl dto, @RequestParam Long basicTrxId, @RequestParam Long projectId) {
        if (basicTrxId == null) {
            basicTrxId = 0L;
        }
        if (projectId == null) {
            projectId = 0L;
        }
        dto.setBasicTrxId(basicTrxId);
        dto.setProjectId(projectId);
        return new ResponseData(service.projectBasicTrxDtlMegQuery(dto));

    }

    @RequestMapping(value = "/fct/project/basic/trx/dtl/query")
    @ResponseBody
    public ResponseData query(HlsCusFctProjectBasicTrxDtl dto, @RequestParam Long basicTrxDtlId) {
        if (basicTrxDtlId == null) {
            basicTrxDtlId = 0L;
        }
        dto.setBasicTrxDtlId(basicTrxDtlId);
        return new ResponseData(service.projectBasicTrxDtlQuery(dto));

    }

    @RequestMapping(value = "/fct/project/basic/trx/dtl/grid/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusFctProjectBasicTrxDtl> dto, HttpServletRequest request) {
        IRequest requestCtx = createRequestContext(request);
        if (dto != null) {
            for (FctProjectBasicTrxDtl dt : dto) {
                if (dt.getBasicTrxDtlId() == null || dt.getBasicTrxDtlId() == 0) {
                    dt.set__status("add");
                } else {
                    dt.set__status("update");
                }
            }
        }
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/fct/project/basic/trx/dtl/submit")
    @ResponseBody
    public List<HlsCusFctProjectBasicTrxDtl> update(@RequestBody(required = false) HlsCusFctProjectBasicTrxInfo dto, BindingResult result, HttpServletRequest request) {
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return null;
        }
        HlsCusFctProjectBasicTrxDtl fctProjectBasicTrxDtl = dto.getHlsCusFctProjectBasicTrxDtl();
        IRequest requesrCtx = createRequestContext(request);
        List<HlsCusFctProjectBasicTrxDtl> fctProjectBasicTrxDtlList = new ArrayList<HlsCusFctProjectBasicTrxDtl>();
        fctProjectBasicTrxDtlList.add(fctProjectBasicTrxDtl);
        List<HlsCusFctProjectBasicTrxAr> fctProjectBasicTrxArList = dto.getHlsCusFctProjectBasicTrxArList();
        if (dto != null) {
            if (fctProjectBasicTrxDtlList.size() != 0) {
                for (HlsCusFctProjectBasicTrxDtl dt : fctProjectBasicTrxDtlList) {
                    if (dt.getBasicTrxDtlId() == null || dt.getBasicTrxDtlId() == 0) {
                        dt.set__status("add");
                    } else {
                        dt.set__status("update");
                    }
                }
            }
            fctProjectBasicTrxDtlList = service.batchUpdate(requesrCtx, fctProjectBasicTrxDtlList);
            if (fctProjectBasicTrxArList.size() != 0) {
                for (HlsCusFctProjectBasicTrxAr ar : fctProjectBasicTrxArList) {
                    if (ar.getBasicTrxArId() == null || ar.getBasicTrxArId() == 0) {
                        ar.set__status("add");
                        ar.setBasicTrxDtlId(fctProjectBasicTrxDtlList.get(0).getBasicTrxDtlId());
                    } else {
                        ar.set__status("update");
                    }
                }
                fctProjectBasicTrxArService.batchUpdate(requesrCtx, fctProjectBasicTrxArList);
            }
        }
        return fctProjectBasicTrxDtlList;
    }

    @RequestMapping(value = "/fct/project/basic/trx/dtl/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusFctProjectBasicTrxDtl> dto) {
        for (HlsCusFctProjectBasicTrxDtl dt : dto) {
            Long basicTrxDtlId = dt.getBasicTrxDtlId();

            /*List<HlsCusFctProjectBasicTrxAr> hlsCusFctProjectBasicTrxArList = new ArrayList<HlsCusFctProjectBasicTrxAr>();
            HlsCusFctProjectBasicTrxAr hlsCusFctProjectBasicTrxAr = new HlsCusFctProjectBasicTrxAr();
            hlsCusFctProjectBasicTrxAr.setBasicTrxDtlId(basicTrxDtlId);
            hlsCusFctProjectBasicTrxArList.add(hlsCusFctProjectBasicTrxAr);*/

            HlsCusFctProjectBasicTrxAr hlsCusFctProjectBasicTrxAr = new HlsCusFctProjectBasicTrxAr();
            hlsCusFctProjectBasicTrxAr.setBasicTrxDtlId(basicTrxDtlId);
            fctProjectBasicTrxArService.arBatchDelete(hlsCusFctProjectBasicTrxAr);
        }
        service.batchDelete(dto);
        return new ResponseData();
    }
}