package hls.core.fct.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fct.dto.FctProjectBp;
import hls.core.fct.dto.HlsCusFctContract;
import hls.core.fct.dto.HlsCusFctProjectBp;
import hls.core.fct.service.FctProjectBpService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

@Controller
public class FctProjectBpController extends BaseController {

    @Autowired
    private FctProjectBpService service;


    /*@RequestMapping(value = "/fct/project/bp/query")
    @ResponseBody
    public ResponseData query(FctProjectBp dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }*/
    @RequestMapping(value = "/fct/project/bp/query")
    @ResponseBody
    public ResponseData creditLineDetailQuery(HlsCusFctProjectBp dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize) {
       Long projectId=dto.getProjectId();
        if(projectId==null){
            projectId=0L;
        }
        dto.setProjectId(projectId);
        return new ResponseData(service.fctProjectBpQuery(dto, page, pageSize));
    }

    @RequestMapping(value = "/fct/project/bpInfo/query")
    @ResponseBody
    public ResponseData queryBpInfo(List<FctProjectBp> dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                    @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.queryBpInfo(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/fct/project/bp/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusFctProjectBp> dto, HttpServletRequest request) {
        IRequest requestCtx = createRequestContext(request);
        if (dto != null) {
            for (HlsCusFctProjectBp dt : dto) {
                if (dt.getProjectBpId() == null || dt.getProjectBpId() == 0) {
                    dt.set__status("add");
                    dt.setInterestRepaymentParty(dt.getCreditGrantorParty());
                    dt.setPrincipalRepaymentParty(dt.getCreditGrantorParty());
                } else {
                    dt.set__status("update");
                }
            }
        }
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/fct/project/bp/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusFctProjectBp> dto) throws Exception{
//        if(dto.get(0).getCreditGrantorParty().equals("Y")){
//            throw new Exception("该商业伙伴是授信方！无法删除");
//        }else{
            service.batchDelete(dto);
       // }
        return new ResponseData();
    }

    @RequestMapping(value = "/fct/credit/bp/submit")
    @ResponseBody
    public ResponseData creditUpdate(@RequestBody List<HlsCusFctProjectBp> dto, HttpServletRequest request) {
        IRequest requestCtx = createRequestContext(request);
        if (dto != null) {
            for (HlsCusFctProjectBp dt : dto) {
                if (dt.getProjectBpId() == null || dt.getProjectBpId() == 0) {
                    dt.set__status("add");
                    if(dt.getCreditGrantorParty().equals("Y")){
                        HlsCusFctProjectBp fctProjectBp=new HlsCusFctProjectBp();
                        fctProjectBp.setProjectId(dt.getProjectId());
                        service.updateProjectBp(fctProjectBp);
                    }
                } else {
                    dt.set__status("update");
                    if(dt.getCreditGrantorParty().equals("Y")){
                        HlsCusFctProjectBp fctProjectBp=new HlsCusFctProjectBp();
                        fctProjectBp.setProjectId(dt.getProjectId());
                        service.updateProjectBp(fctProjectBp);
                    }
                }
            }
        }
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }
}