package hls.core.fct.controllers;

import hls.core.fct.dto.HlsCusFctProjectFinStatement;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fct.dto.FctProjectFinStatement;
import hls.core.fct.service.FctProjectFinStatementService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import org.springframework.validation.BindingResult;

import java.util.ArrayList;
import java.util.List;

    @Controller
    public class FctProjectFinStatementController extends BaseController{

    @Autowired
    private FctProjectFinStatementService service;


    @RequestMapping(value = "/fct/project/fin/statement/query")
    @ResponseBody
    public ResponseData query(HttpServletRequest request,Long projectId) {
        HlsCusFctProjectFinStatement hlsCusFctProjectFinStatement=new HlsCusFctProjectFinStatement();
        if(projectId==null){
            projectId=0L;
        }
        hlsCusFctProjectFinStatement.setProjectId(projectId);
        List<HlsCusFctProjectFinStatement> hlsCusFctProjectFinStatementList=new ArrayList<HlsCusFctProjectFinStatement>();
        hlsCusFctProjectFinStatementList=service.queryFctProjectFinStatement(hlsCusFctProjectFinStatement);
        return new ResponseData(hlsCusFctProjectFinStatementList);
    }

    @RequestMapping(value = "/fct/project/fin/statement/submit")
    @ResponseBody
public ResponseData update(@RequestBody List<HlsCusFctProjectFinStatement> dto, BindingResult result, HttpServletRequest request){
getValidator().validate(dto, result);
if (result.hasErrors()) {
ResponseData responseData = new ResponseData(false);
responseData.setMessage(getErrorMessage(result, request));
return responseData;
}
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/fct/project/fin/statement/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusFctProjectFinStatement> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    @RequestMapping(value = "/fct/project/fin/statement/queryByBpId")
    @ResponseBody
    public ResponseData queryFinStatement(Long bpId){
        List<HlsCusFctProjectFinStatement> fctProjectFinStatementList=new ArrayList<>();
        fctProjectFinStatementList=service.queryFinStatementByBpId(bpId);
        return new ResponseData(fctProjectFinStatementList);
    }
    }