package hls.core.fct.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fct.dto.FctProjectQuotation;
import hls.core.fct.dto.HlsCusFctProjectQuotation;
import hls.core.fct.service.FctProjectQuotationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class FctProjectQuotationController extends BaseController {

    @Autowired
    private FctProjectQuotationService service;


    @RequestMapping(value = "/fct/setup/project/quotation/detail/query")
    @ResponseBody
    public ResponseData creditLineDetailQuery(FctProjectQuotation dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, @RequestParam Long projectId) {
        if (projectId == null) {
            projectId = 0L;
        }
        dto.setProjectId(projectId);
        return new ResponseData(service.selectSetupProjectQuotation(dto, page, pageSize));
    }

    @RequestMapping(value = "/fct/project/quotation/query")
    @ResponseBody
    public ResponseData query(HlsCusFctProjectQuotation dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }
    @RequestMapping(value = "/fct/project/quotation/submit")
    @ResponseBody
    public ResponseData update(@RequestBody HlsCusFctProjectQuotation dto, BindingResult result, HttpServletRequest request) {
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = createRequestContext(request);
        service.updateByPrimaryKey(requestCtx,dto);
        return new ResponseData();
    }

    @RequestMapping(value = "/fct/project/quotation/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusFctProjectQuotation> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }
}