package hls.core.fct.controllers;

import com.github.pagehelper.PageHelper;
import com.hand.hap.attachment.dto.SysFile;
import com.hand.hap.core.IRequest;
import com.hand.hap.security.TokenUtils;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fct.dto.HlsCreditLineAttachment;
import hls.core.fct.dto.HlsCusHlsCreditLineAttachment;
import hls.core.fct.service.HlsCreditLineAttachmentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class HlsCreditLineAttachmentController extends BaseController {

    @Autowired
    private HlsCreditLineAttachmentService service;


    /*@RequestMapping(value = "/hls/credit/line/attachment/query")
    @ResponseBody
    public ResponseData query(HlsCreditLineAttachment dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }*/
    @RequestMapping(value = "/hls/credit/line/attachment/query")
    @ResponseBody
    public ResponseData creditLineDetailQuery(HlsCreditLineAttachment dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize) {
        Long creditLineId = dto.getCreditLineId();
        if (creditLineId == null) {
            creditLineId = 0L;
            dto.setCreditLineId(creditLineId);
        }
        //dto.setCreditLineId(creditLineId);
        return new ResponseData(service.creditLineAttachmentQuery(dto, page, pageSize));
    }

    @RequestMapping(value = "/hls/credit/line/attachment/risk/report/query")
    @ResponseBody
    public ResponseData riskReportQuery(HlsCreditLineAttachment dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest iRequest = createRequestContext(request);
        String[] fileTypeArr=dto.getSourceType().split("-");
        dto.setFileTypeArr(fileTypeArr);
        List<HlsCreditLineAttachment> list = service.riskAssessmentReportQuery(dto, page, pageSize);
        SysFile file = new SysFile();
        String securityKey = TokenUtils.getSecurityKey(request.getSession());
        for (HlsCreditLineAttachment f : list) {
            if(f.getFileId()==null||"".equals(f.getFileId())){

            }else{
                file.setFileId(Long.valueOf(f.getFileId()));
                f.set_token(TokenUtils.generateToken(securityKey, file));
            }
        }
        return new ResponseData(list);
    }

    @RequestMapping(value = "/hls/credit/line/attachment/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusHlsCreditLineAttachment> dto, BindingResult result, HttpServletRequest request) {
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/hls/credit/line/attachment/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusHlsCreditLineAttachment> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }
}