package hls.core.fct.controllers;

import hls.core.fct.dto.HlsCusHlsCreditLineChangeReq;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fct.service.HlsCreditLineChangeReqService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import org.springframework.validation.BindingResult;
import java.util.List;

    @Controller
    public class HlsCreditLineChangeReqController extends BaseController{

    @Autowired
    private HlsCreditLineChangeReqService service;


    @RequestMapping(value = "/hls/credit/line/change/req/query")
    @ResponseBody
    public ResponseData query(HlsCusHlsCreditLineChangeReq dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/hls/credit/line/change/req/submit")
    @ResponseBody
public ResponseData update(@RequestBody List<HlsCusHlsCreditLineChangeReq> dto, BindingResult result, HttpServletRequest request){
getValidator().validate(dto, result);
if (result.hasErrors()) {
ResponseData responseData = new ResponseData(false);
responseData.setMessage(getErrorMessage(result, request));
return responseData;
}
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/hls/credit/line/change/req/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusHlsCreditLineChangeReq> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    @RequestMapping(value = "/hls/credit/line/change/req/info")
    @ResponseBody
    public ResponseData queryCreditLineInfo(HttpServletRequest request,Long credditLineId){
            //service.batchDelete(dto);
            return new ResponseData();
    }
    @RequestMapping(value = "/hls/credit/line/change/req/history/info")
    @ResponseBody
    public ResponseData queryCreditLineInfo(Long creditLineId){
        HlsCusHlsCreditLineChangeReq hlsCreditLineChangeReq=new HlsCusHlsCreditLineChangeReq();
        hlsCreditLineChangeReq.setCreditLineId(creditLineId);
        return new ResponseData(service.changeHistoryReqQuery(hlsCreditLineChangeReq));
    }

    }