package hls.core.fct.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fct.dto.HlsCreditLineGuarantor;
import hls.core.fct.dto.HlsCusHlsCreditLineGuarantor;
import hls.core.fct.service.HlsCreditLineGuarantorService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class HlsCreditLineGuarantorController extends BaseController {

    @Autowired
    private HlsCreditLineGuarantorService service;

    @RequestMapping(value = "/hls/credit/line/guarantor/query")
    @ResponseBody
    public ResponseData creditLineDetailQuery( HlsCusHlsCreditLineGuarantor dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize) {
        Long creditLineId = dto.getCreditLineId();
        if (creditLineId == null) {
            creditLineId = 0L;
            dto.setCreditLineId(creditLineId);
        }
        return new ResponseData(service.creditLineGuarantorQuery(dto, page, pageSize));
    }

/*    @RequestMapping(value = "/hls/credit/line/guarantor/query")
    @ResponseBody
    public ResponseData query(HlsCreditLineGuarantor dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }*/

    @RequestMapping(value = "/hls/credit/line/guarantor/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusHlsCreditLineGuarantor> dto, HttpServletRequest request) {
        IRequest requestCtx = createRequestContext(request);
        if (dto != null) {
            for (HlsCreditLineGuarantor dt : dto) {
                if (dt.getCreditLineGuarantorId() == null || dt.getCreditLineGuarantorId() == 0) {
                    dt.set__status("add");
                } else {
                    dt.set__status("update");
                }
            }
        }
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/hls/credit/line/guarantor/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusHlsCreditLineGuarantor> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }
}