package hls.core.fct.dto;

/**
 * Auto Generated By Hap Code Generator
 **/

import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;
import org.hibernate.validator.constraints.Length;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

@ExtensionAttribute(disable = true)
@Table(name = "fct_contract")
public class FctContract extends BaseDTO {

    public static final String FIELD_CONTRACT_ID = "contractId";
    public static final String FIELD_COMPANY_ID = "companyId";
    public static final String FIELD_PROJECT_ID = "projectId";
    public static final String FIELD_SIGN_APPROVAL_ID = "signApprovalId";
    public static final String FIELD_DOCUMENT_TYPE = "documentType";
    public static final String FIELD_DOCUMENT_CATEGORY = "documentCategory";
    public static final String FIELD_BUSINESS_TYPE = "businessType";
    public static final String FIELD_CONTRACT_NUMBER = "contractNumber";
    public static final String FIELD_CONTRACT_NAME = "contractName";
    public static final String FIELD_CONTRACT_STATUS = "contractStatus";
    public static final String FIELD_CREDIT_LINE_ID = "creditLineId";
    public static final String FIELD_EMPLOYEE_ASSIGN_ID = "employeeAssignId";
    public static final String FIELD_EMPLOYEE_ID = "employeeId";
    public static final String FIELD_UNIT_ID = "unitId";
    public static final String FIELD_DESCRIPTION = "description";
    public static final String FIELD_CURRENCY = "currency";
    public static final String FIELD_AUTHORITY_RULE_STRING = "authorityRuleString";
    public static final String FIELD_PENALTY_RATE = "penaltyRate";
    public static final String FIELD_SIGN_DATE = "signDate";
    public static final String FIELD_SIGN_DESCRIPTION = "signDescription";


    @Id
    @GeneratedValue
    private Long contractId;

    private Long companyId;

    private Long projectId;

    private Long signApprovalId;

    @Length(max = 100)
    private String documentType;

    @Length(max = 100)
    private String documentCategory;

    @Length(max = 100)
    private String businessType;

    @Length(max = 255)
    private String contractNumber;

    @Length(max = 1000)
    private String contractName;

    @Length(max = 100)
    private String contractStatus;

    private Long creditLineId;

    private Long employeeAssignId;

    private Long employeeId;

    private Long unitId;

    @Length(max = 1000)
    private String description;

    @Length(max = 100)
    private String currency;

    @Length(max = 200)
    private String authorityRuleString;

    private Double penaltyRate;

    private Date signDate;

    @Length(max = 1000)
    private String signDescription;

    private Long bankAccountId;

    // 保理合同首页用到
    @Transient
    private String bpName;
    @Transient
    private Double financeAmount;
    @Transient
    private String documentCategoryDesc;
    @Transient
    private String documentTypeDesc;
    @Transient
    private String businessTypeDesc;
    @Transient
    private String fuzzyQueryParams;

    @Transient
    private String contractStatusDesc;
    @Transient
    private Long contractCount;
    @Transient
    private Long contractSumCount;
    @Transient
    private Double contractCountPercent;
    @Transient
    private Long currentMonthAppend;
    @Transient
    private Long projectAttachmentId;


    @Transient
    private String buyer;
    @Transient
    private String seller;
    @Transient
    private String creditDocumentType;
    @Transient
    private String creditDocumentTypeDesc;
    @Transient
    private Double leaseTerm;
    @Transient
    private Double intRate;
    @Transient
    private Double floatingWayRange;
    @Transient
    private String interestCalcDesc;
    @Transient
    private String interestCollectionDesc;
    @Transient
    private String floatingRangeDesc;
    @Transient
    private String guaranteeDesc;
    @Transient
    private String withdrawStatus;

    @Transient
    private String intRateTypeDesc;
    @Transient
    private Long contractBpId;

    @Transient
    private Double contractAvailableAmount;
    @Transient
    private Long bpId;

    public Long getBpId() {
        return bpId;
    }

    public void setBpId(Long bpId) {
        this.bpId = bpId;
    }

    public Double getContractAvailableAmount() {
        return contractAvailableAmount;
    }

    public void setContractAvailableAmount(Double contractAvailableAmount) {
        this.contractAvailableAmount = contractAvailableAmount;
    }

    public Long getContractBpId() {
        return contractBpId;
    }

    public void setContractBpId(Long contractBpId) {
        this.contractBpId = contractBpId;
    }

    public Long getBankAccountId() {
        return bankAccountId;
    }

    public void setBankAccountId(Long bankAccountId) {
        this.bankAccountId = bankAccountId;
    }

    public String getIntRateTypeDesc() {
        return intRateTypeDesc;
    }

    public void setIntRateTypeDesc(String intRateTypeDesc) {
        this.intRateTypeDesc = intRateTypeDesc;
    }

    public String getWithdrawStatus() {
        return withdrawStatus;
    }

    public void setWithdrawStatus(String withdrawStatus) {
        this.withdrawStatus = withdrawStatus;
    }

    public String getBuyer() {
        return buyer;
    }

    public void setBuyer(String buyer) {
        this.buyer = buyer;
    }

    public String getSeller() {
        return seller;
    }

    public void setSeller(String seller) {
        this.seller = seller;
    }

    public String getCreditDocumentType() {
        return creditDocumentType;
    }

    public void setCreditDocumentType(String creditDocumentType) {
        this.creditDocumentType = creditDocumentType;
    }

    public String getCreditDocumentTypeDesc() {
        return creditDocumentTypeDesc;
    }

    public void setCreditDocumentTypeDesc(String creditDocumentTypeDesc) {
        this.creditDocumentTypeDesc = creditDocumentTypeDesc;
    }

    public Double getLeaseTerm() {
        return leaseTerm;
    }

    public void setLeaseTerm(Double leaseTerm) {
        this.leaseTerm = leaseTerm;
    }

    public Double getIntRate() {
        return intRate;
    }

    public void setIntRate(Double intRate) {
        this.intRate = intRate;
    }

    public Double getFloatingWayRange() {
        return floatingWayRange;
    }

    public void setFloatingWayRange(Double floatingWayRange) {
        this.floatingWayRange = floatingWayRange;
    }

    public String getInterestCalcDesc() {
        return interestCalcDesc;
    }

    public void setInterestCalcDesc(String interestCalcDesc) {
        this.interestCalcDesc = interestCalcDesc;
    }

    public String getInterestCollectionDesc() {
        return interestCollectionDesc;
    }

    public void setInterestCollectionDesc(String interestCollectionDesc) {
        this.interestCollectionDesc = interestCollectionDesc;
    }

    public String getFloatingRangeDesc() {
        return floatingRangeDesc;
    }

    public void setFloatingRangeDesc(String floatingRangeDesc) {
        this.floatingRangeDesc = floatingRangeDesc;
    }

    public String getGuaranteeDesc() {
        return guaranteeDesc;
    }

    public void setGuaranteeDesc(String guaranteeDesc) {
        this.guaranteeDesc = guaranteeDesc;
    }

    // -------------------------------------------


    public Long getProjectAttachmentId() {
        return projectAttachmentId;
    }

    public void setProjectAttachmentId(Long projectAttachmentId) {
        this.projectAttachmentId = projectAttachmentId;
    }

    public String getContractStatusDesc() {
        return contractStatusDesc;
    }

    public void setContractStatusDesc(String contractStatusDesc) {
        this.contractStatusDesc = contractStatusDesc;
    }

    public Long getContractCount() {
        return contractCount;
    }

    public void setContractCount(Long contractCount) {
        this.contractCount = contractCount;
    }

    public Long getContractSumCount() {
        return contractSumCount;
    }

    public void setContractSumCount(Long contractSumCount) {
        this.contractSumCount = contractSumCount;
    }

    public Double getContractCountPercent() {
        return contractCountPercent;
    }

    public void setContractCountPercent(Double contractCountPercent) {
        this.contractCountPercent = contractCountPercent;
    }

    public Long getCurrentMonthAppend() {
        return currentMonthAppend;
    }

    public void setCurrentMonthAppend(Long currentMonthAppend) {
        this.currentMonthAppend = currentMonthAppend;
    }

    public String getBpName() {
        return bpName;
    }

    public void setBpName(String bpName) {
        this.bpName = bpName;
    }

    public Double getFinanceAmount() {
        return financeAmount;
    }

    public void setFinanceAmount(Double financeAmount) {
        this.financeAmount = financeAmount;
    }

    public String getDocumentCategoryDesc() {
        return documentCategoryDesc;
    }

    public void setDocumentCategoryDesc(String documentCategoryDesc) {
        this.documentCategoryDesc = documentCategoryDesc;
    }

    public String getDocumentTypeDesc() {
        return documentTypeDesc;
    }

    public void setDocumentTypeDesc(String documentTypeDesc) {
        this.documentTypeDesc = documentTypeDesc;
    }

    public String getBusinessTypeDesc() {
        return businessTypeDesc;
    }

    public void setBusinessTypeDesc(String businessTypeDesc) {
        this.businessTypeDesc = businessTypeDesc;
    }

    public String getFuzzyQueryParams() {
        return fuzzyQueryParams;
    }

    public void setFuzzyQueryParams(String fuzzyQueryParams) {
        this.fuzzyQueryParams = fuzzyQueryParams;
    }
     @Transient
     private String companyName;
     @Transient
     private String departmentName;
     @Transient
     private String managerName;
     @Transient
     private String creditTypeDesc;
     @Transient
     private String creditLineAmt;
     @Transient
     private String creditExposureAmt;

    public String getCreditLineAmt() {
        return creditLineAmt;
    }

    public void setCreditLineAmt(String creditLineAmt) {
        this.creditLineAmt = creditLineAmt;
    }

    public String getCreditExposureAmt() {
        return creditExposureAmt;
    }

    public void setCreditExposureAmt(String creditExposureAmt) {
        this.creditExposureAmt = creditExposureAmt;
    }

    public String getCompanyName() {
        return companyName;
    }

    public void setCompanyName(String companyName) {
        this.companyName = companyName;
    }

    public String getDepartmentName() {
        return departmentName;
    }

    public void setDepartmentName(String departmentName) {
        this.departmentName = departmentName;
    }

    public String getManagerName() {
        return managerName;
    }

    public void setManagerName(String managerName) {
        this.managerName = managerName;
    }

    public String getCreditTypeDesc() {
        return creditTypeDesc;
    }

    public void setCreditTypeDesc(String creditTypeDesc) {
        this.creditTypeDesc = creditTypeDesc;
    }

    public void setContractId(Long contractId) {
        this.contractId = contractId;
    }

    public Long getContractId() {
        return contractId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public Long getCompanyId() {
        return companyId;
    }

    public void setProjectId(Long projectId) {
        this.projectId = projectId;
    }

    public Long getProjectId() {
        return projectId;
    }

    public void setSignApprovalId(Long signApprovalId) {
        this.signApprovalId = signApprovalId;
    }

    public Long getSignApprovalId() {
        return signApprovalId;
    }

    public void setDocumentType(String documentType) {
        this.documentType = documentType;
    }

    public String getDocumentType() {
        return documentType;
    }

    public void setDocumentCategory(String documentCategory) {
        this.documentCategory = documentCategory;
    }

    public String getDocumentCategory() {
        return documentCategory;
    }

    public void setBusinessType(String businessType) {
        this.businessType = businessType;
    }

    public String getBusinessType() {
        return businessType;
    }

    public void setContractNumber(String contractNumber) {
        this.contractNumber = contractNumber;
    }

    public String getContractNumber() {
        return contractNumber;
    }

    public void setContractName(String contractName) {
        this.contractName = contractName;
    }

    public String getContractName() {
        return contractName;
    }

    public void setContractStatus(String contractStatus) {
        this.contractStatus = contractStatus;
    }

    public String getContractStatus() {
        return contractStatus;
    }

    public void setCreditLineId(Long creditLineId) {
        this.creditLineId = creditLineId;
    }

    public Long getCreditLineId() {
        return creditLineId;
    }

     public void setEmployeeAssignId(Long employeeAssignId){
         this.employeeAssignId = employeeAssignId;
     }

     public Long getEmployeeAssignId(){
         return employeeAssignId;
     }

     public void setEmployeeId(Long employeeId){
         this.employeeId = employeeId;
     }

     public Long getEmployeeId(){
         return employeeId;
     }

     public void setUnitId(Long unitId){
         this.unitId = unitId;
     }

     public Long getUnitId(){
         return unitId;
     }

     public void setDescription(String description){
         this.description = description;
     }

     public String getDescription(){
         return description;
     }

     public void setCurrency(String currency){
         this.currency = currency;
     }

     public String getCurrency(){
         return currency;
     }

     public void setAuthorityRuleString(String authorityRuleString){
         this.authorityRuleString = authorityRuleString;
     }

     public String getAuthorityRuleString(){
         return authorityRuleString;
     }

     public void setPenaltyRate(Double penaltyRate){
         this.penaltyRate = penaltyRate;
     }

     public Double getPenaltyRate(){
         return penaltyRate;
     }

     public void setSignDate(Date signDate){
         this.signDate = signDate;
     }

     public Date getSignDate(){
         return signDate;
     }

     public void setSignDescription(String signDescription){
         this.signDescription = signDescription;
     }

     public String getSignDescription(){
         return signDescription;
     }

     //提款字段
     @Transient
     private String contractBpName;//融资申请人
    @Transient
    private Double withdrawAmountSum;//累计受让金额
    @Transient
    private Double financeAmountSum;//审批总额度
    @Transient
    private Double withdrawAmountUsed;//累计已使用额度

    public String getContractBpName() {
        return contractBpName;
    }

    public void setContractBpName(String contractBpName) {
        this.contractBpName = contractBpName;
    }

    public Double getWithdrawAmountSum() {
        return withdrawAmountSum;
    }

    public void setWithdrawAmountSum(Double withdrawAmountSum) {
        this.withdrawAmountSum = withdrawAmountSum;
    }

    public Double getFinanceAmountSum() {
        return financeAmountSum;
    }

    public void setFinanceAmountSum(Double financeAmountSum) {
        this.financeAmountSum = financeAmountSum;
    }

    public Double getWithdrawAmountUsed() {
        return withdrawAmountUsed;
    }

    public void setWithdrawAmountUsed(Double withdrawAmountUsed) {
        this.withdrawAmountUsed = withdrawAmountUsed;
    }

    //项目字段
    @Transient
    private String projectNumber;
    @Transient
    private String projectManager;
    @Transient
    private String unitName;
    @Transient
    private String projectAssistantName;
    @Transient
    private Double creditAmount;

    public String getProjectNumber() {
        return projectNumber;
    }

    public void setProjectNumber(String projectNumber) {
        this.projectNumber = projectNumber;
    }

    public String getProjectManager() {
        return projectManager;
    }

    public void setProjectManager(String projectManager) {
        this.projectManager = projectManager;
    }

    public String getUnitName() {
        return unitName;
    }

    public void setUnitName(String unitName) {
        this.unitName = unitName;
    }

    public String getProjectAssistantName() {
        return projectAssistantName;
    }

    public void setProjectAssistantName(String projectAssistantName) {
        this.projectAssistantName = projectAssistantName;
    }

    public Double getCreditAmount() {
        return creditAmount;
    }

    public void setCreditAmount(Double creditAmount) {
        this.creditAmount = creditAmount;
    }
}
