package hls.core.fct.dto;

/**
 * Auto Generated By Hap Code Generator
 **/

import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;
import org.hibernate.validator.constraints.Length;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

@ExtensionAttribute(disable = true)
@Table(name = "fct_project_quotation")
public class FctProjectQuotation extends BaseDTO {

    public static final String FIELD_QUOTATAION_ID = "quotataionId";
    public static final String FIELD_PROJECT_ID = "projectId";
    public static final String FIELD_DESCRIPTION = "description";
    public static final String FIELD_STATUS = "status";
    public static final String FIELD_PRICE_LIST = "priceList";
    public static final String FIELD_FINANCE_AMOUNT = "financeAmount";
    public static final String FIELD_FINANCE_AMOUNT_RATIO = "financeAmountRatio";
    public static final String FIELD_LEASE_TERM = "leaseTerm";
    public static final String FIELD_LEASE_TIMES = "leaseTimes";
    public static final String FIELD_INT_RATE = "intRate";
    public static final String FIELD_INT_RATE_TYPE = "intRateType";
    public static final String FIELD_INTEREST_CALC_METHOD = "interestCalcMethod";
    public static final String FIELD_INTEREST_COLLECTION_METHOD = "interestCollectionMethod";
    public static final String FIELD_FLOATING_WAY = "floatingWay";
    public static final String FIELD_FLOATING_WAY_RANGE = "floatingWayRange";
    public static final String FIELD_FLOATING_CYCLE = "floatingCycle";
    public static final String FIELD_FLOATING_RANGE_METHOD = "floatingRangeMethod";
    public static final String FIELD_DESIRED_PERCENTAGE_RETURN = "desiredPercentageReturn";
    public static final String FIELD_GUARANTEE_METHOD = "guaranteeMethod";
    public static final String FIELD_DEBT_RECEIVABLE = "debtReceivable";


    @Id
    @GeneratedValue
    private Long quotataionId; //保理报价id

    private Long projectId; //保理项目ID

    @Length(max = 2000)
    private String description; //备注

    @Length(max = 100)
    private String status; //状态

    @Length(max = 100)
    private String priceList; //报价方案

    private Double financeAmount; //融资额

    private Float financeAmountRatio; //融资比例

    private Long leaseTerm; //期限

    private Long leaseTimes; //期数

    private Double intRate; //利率

    @Length(max = 100)
    private String intRateType; //利率类型(固定/浮动)

    @Length(max = 100)
    private String interestCalcMethod; //计息方式

    @Length(max = 100)
    private String interestCollectionMethod; //收息方式

    private String floatingWay; //浮动方式

    private String floatingWayRange; //浮动幅度

    private Long floatingCycle; //利率调整周期

    private String floatingRangeMethod; //调息规则

    private Float desiredPercentageReturn; //预期回报率

    private String guaranteeMethod; //担保方式

    private String debtReceivable; //应收账款数量


    private Double withdrawMaximumTerm;

    private Date financeMaturityDate;

    private Double exemptionPeriod;


    @Transient
    private String guaranteeDesc;//担保方式

    @Transient
    private String validFrom;

    @Transient
    private String intRateDesc;

    @Transient
    private String interestCalcDesc;//计息方式

    @Transient
    private String interestCollectionDesc;//收息方式

    @Transient
    private String floatingRangeDesc;//调息规则

    @Transient
    private String floatingDesc;//浮动方式

    @Transient
    private String debtReceivableDesc;//应收账款数量

    @Transient
    private String validTo;

    public Float getFinanceAmountRatio() {
        return financeAmountRatio;
    }

    public void setFinanceAmountRatio(Float financeAmountRatio) {
        this.financeAmountRatio = financeAmountRatio;
    }

    public Float getDesiredPercentageReturn() {
        return desiredPercentageReturn;
    }

    public void setDesiredPercentageReturn(Float desiredPercentageReturn) {
        this.desiredPercentageReturn = desiredPercentageReturn;
    }

    public String getInterestCalcMethod() {
        return interestCalcMethod;
    }

    public void setInterestCalcMethod(String interestCalcMethod) {
        this.interestCalcMethod = interestCalcMethod;
    }

    public String getFloatingWay() {
        return floatingWay;
    }

    public void setFloatingWay(String floatingWay) {
        this.floatingWay = floatingWay;
    }

    public String getFloatingWayRange() {
        return floatingWayRange;
    }

    public void setFloatingWayRange(String floatingWayRange) {
        this.floatingWayRange = floatingWayRange;
    }

    public Long getFloatingCycle() {
        return floatingCycle;
    }

    public void setFloatingCycle(Long floatingCycle) {
        this.floatingCycle = floatingCycle;
    }

    public String getFloatingRangeMethod() {
        return floatingRangeMethod;
    }

    public void setFloatingRangeMethod(String floatingRangeMethod) {
        this.floatingRangeMethod = floatingRangeMethod;
    }

    public String getGuaranteeMethod() {
        return guaranteeMethod;
    }

    public void setGuaranteeMethod(String guaranteeMethod) {
        this.guaranteeMethod = guaranteeMethod;
    }

    public String getDebtReceivable() {
        return debtReceivable;
    }

    public void setDebtReceivable(String debtReceivable) {
        this.debtReceivable = debtReceivable;
    }

    public String getIntRateDesc() {
        return intRateDesc;
    }

    public void setIntRateDesc(String intRateDesc) {
        this.intRateDesc = intRateDesc;
    }

    public String getInterestCalcDesc() {
        return interestCalcDesc;
    }

    public void setInterestCalcDesc(String interestCalcDesc) {
        this.interestCalcDesc = interestCalcDesc;
    }

    public String getInterestCollectionDesc() {
        return interestCollectionDesc;
    }

    public void setInterestCollectionDesc(String interestCollectionDesc) {
        this.interestCollectionDesc = interestCollectionDesc;
    }

    public String getFloatingRangeDesc() {
        return floatingRangeDesc;
    }

    public void setFloatingRangeDesc(String floatingRangeDesc) {
        this.floatingRangeDesc = floatingRangeDesc;
    }

    public String getFloatingDesc() {
        return floatingDesc;
    }

    public void setFloatingDesc(String floatingDesc) {
        this.floatingDesc = floatingDesc;
    }

    public String getDebtReceivableDesc() {
        return debtReceivableDesc;
    }

    public void setDebtReceivableDesc(String debtReceivableDesc) {
        this.debtReceivableDesc = debtReceivableDesc;
    }


    public String getGuaranteeDesc() {
        return guaranteeDesc;
    }

    public void setGuaranteeDesc(String guaranteeDesc) {
        this.guaranteeDesc = guaranteeDesc;
    }

    public String getValidFrom() {
        return validFrom;
    }

    public void setValidFrom(String validFrom) {
        this.validFrom = validFrom;
    }

    public String getValidTo() {
        return validTo;
    }

    public void setValidTo(String validTo) {
        this.validTo = validTo;
    }

    public void setQuotataionId(Long quotataionId) {
        this.quotataionId = quotataionId;
    }

    public Long getQuotataionId() {
        return quotataionId;
    }

    public void setProjectId(Long projectId) {
        this.projectId = projectId;
    }

    public Long getProjectId() {
        return projectId;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDescription() {
        return description;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getStatus() {
        return status;
    }

    public void setPriceList(String priceList) {
        this.priceList = priceList;
    }

    public String getPriceList() {
        return priceList;
    }

    public void setFinanceAmount(Double financeAmount) {
        this.financeAmount = financeAmount;
    }

    public Double getFinanceAmount() {
        return financeAmount;
    }

    public void setLeaseTerm(Long leaseTerm) {
        this.leaseTerm = leaseTerm;
    }

    public Long getLeaseTerm() {
        return leaseTerm;
    }

    public void setLeaseTimes(Long leaseTimes) {
        this.leaseTimes = leaseTimes;
    }

    public Long getLeaseTimes() {
        return leaseTimes;
    }

    public Double getIntRate() {
        return intRate;
    }

    public void setIntRate(Double intRate) {
        this.intRate = intRate;
    }

    public void setIntRateType(String intRateType) {
        this.intRateType = intRateType;
    }

    public String getIntRateType() {
        return intRateType;
    }

    public void setInterestCollectionMethod(String interestCollectionMethod) {
        this.interestCollectionMethod = interestCollectionMethod;
    }

    public String getInterestCollectionMethod() {
        return interestCollectionMethod;
    }

    public Double getWithdrawMaximumTerm() {
        return withdrawMaximumTerm;
    }

    public void setWithdrawMaximumTerm(Double withdrawMaximumTerm) {
        this.withdrawMaximumTerm = withdrawMaximumTerm;
    }

    public Date getFinanceMaturityDate() {
        return financeMaturityDate;
    }

    public void setFinanceMaturityDate(Date financeMaturityDate) {
        this.financeMaturityDate = financeMaturityDate;
    }

    public Double getExemptionPeriod() {
        return exemptionPeriod;
    }

    public void setExemptionPeriod(Double exemptionPeriod) {
        this.exemptionPeriod = exemptionPeriod;
    }
}

