package hls.core.fct.mapper;

import com.hand.hap.mybatis.common.Mapper;
import hls.core.fct.dto.HlsCusFctContractWithdraw;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;
import java.util.Map;

public interface FctContractWithdrawMapper<T extends HlsCusFctContractWithdraw> extends Mapper<HlsCusFctContractWithdraw> {
    List<HlsCusFctContractWithdraw> fctContractWithdrawDetailQuery(HlsCusFctContractWithdraw hlsCusFctContractWithdraw);
    List<HlsCusFctContractWithdraw> fctContractWithdrawDetailForSpcl(HlsCusFctContractWithdraw hlsCusFctContractWithdraw);
    // 保理 - 提款信息LOV
    List<HlsCusFctContractWithdraw> fctContractWithdrawInfoLov(HlsCusFctContractWithdraw hlsCusFctContractWithdraw);

    // 保理 - 提款信息(实际收款安排)LOV
    List<HlsCusFctContractWithdraw> fctContractWithdrawInfoWriteOffLov(HlsCusFctContractWithdraw hlsCusFctContractWithdraw);

    // 保理 - 提款信息(提前还款)LOV
    List<HlsCusFctContractWithdraw> fctContractWithdrawInfoETLov(HlsCusFctContractWithdraw hlsCusFctContractWithdraw);


    // 保理 - 提款信息(付款申请) LOV
    List<HlsCusFctContractWithdraw> fctContractWithdrawInfoAdvancesLov(HlsCusFctContractWithdraw hlsCusFctContractWithdraw);


    List<HlsCusFctContractWithdraw> fctContractWithdrawAprlDetail(HlsCusFctContractWithdraw hlsCusFctContractWithdraw);

    List<Map> fctContractHistoryQuery(HlsCusFctContractWithdraw hlsCusFctContractWithdraw);




    // 保理合同明细页面,- 付款申请历史清单查询
    List<HlsCusFctContractWithdraw> withdrawPaymentHistoryQuery(HlsCusFctContractWithdraw hlsCusFctContractWithdraw);

    // 保理合同明细页面,- 付款申请历史明细查询
    List<Map> paymentDetailQuery(HlsCusFctContractWithdraw hlsCusFctContractWithdraw);

    void updateWithdrawStatus(@Param("withdrawId")Long withdrawId, @Param("withdrawStatus") String withdrawStatus, @Param("userId")Long userId, @Param("date")Date date);

    List<HlsCusFctContractWithdraw> getWriteOffDateByWithdrawId(HlsCusFctContractWithdraw hlsCusFctContractWithdraw);


    List<HlsCusFctContractWithdraw> fctContractWithdrawCfQuery(HlsCusFctContractWithdraw hlsCusFctContractWithdraw);

    List<HlsCusFctContractWithdraw> selectNeedCalcPenaltyWithdraw(Long companyId);

    Long getWithdrawCount(Long contractId);
}