package hls.core.fct.service;

import com.hand.hap.core.IRequest;
import com.hand.hap.core.ProxySelf;
import com.hand.hap.system.service.IBaseService;
import hls.core.fct.dto.HlsCusFctContract;
import hls.core.fct.dto.HlsCusFctContractWithdraw;
import hls.core.fct.dto.HlsCusFctContractWithdrawCf;
import hls.core.fct.dto.HlsCusFctProject;

import java.text.ParseException;
import java.util.Date;
import java.util.List;

public interface FctContractService extends IBaseService<HlsCusFctContract>, ProxySelf<FctContractService> {

    //---------------------------------------------------------------------------------
    //合同签约
    //点击生成合同文本记录
    void createContractContent(IRequest iRequest, HlsCusFctProject hlsCusFctProject);

    //签约审批通过 将项目复制到合同
    List<HlsCusFctContract> createContractFromProject(IRequest iRequest, HlsCusFctProject hlsCusFctProject);

    //---------------------------------------------------------------------------------
    //合同管理

    // 保理合同管理首页grid查询
    List<HlsCusFctContract> fctContractDetailQuery(IRequest iRequest, HlsCusFctContract hlsCusFctContract, int page, int pageSize);

    // 保理合同管理首页-合同状态统计图
    List<HlsCusFctContract> selectFctContractCountByStatus(HlsCusFctContract hlsCusFctContract);

    //合同明细

    //授信占用 和 释放
    void creditOccupation(IRequest iRequest, HlsCusFctContract hlsCusFctContract);

    HlsCusFctContractWithdrawCf insertOutFlowCf(IRequest iRequest, HlsCusFctContractWithdraw hlsCusFctContractWithdraw,Date applyPayDate);

    //预收款安排制作 点击计算
    List<HlsCusFctContractWithdrawCf> createContractWithdrawCfAdvance(IRequest iRequest, HlsCusFctContractWithdraw hlsCusFctContractWithdraw) throws ParseException;

    //收款安排制作 点击计算
    List<HlsCusFctContractWithdrawCf> createContractWithdrawCfPayment(IRequest iRequest, HlsCusFctContractWithdraw hlsCusFctContractWithdraw) throws ParseException;

    //收款安排制作 重新计算
    List<HlsCusFctContractWithdrawCf> reCalcContractWithdrawCf(IRequest iRequest, List<HlsCusFctContractWithdrawCf> hlsCusFctContractWithdrawCfList) throws ParseException;


    //保理合同明细
    List<HlsCusFctContract> fctContractDetailLineQuery(HlsCusFctContract hlsCusFctContract);

    //提款单合同明细
    List<HlsCusFctContract> fctContractWithdrawQuery(HlsCusFctContract hlsCusFctContract);

    //判断合同管理明细界面， 用款申请点击状态
    String withdrawRequestStatus(Long contractId);

    //判断合同管理明细界面， 预收款安排点击状态
    String advancesReceivedStatus(Long contractId);

    //判断合同管理明细界面， 特殊情况申请  和   付款申请 点击状态
    String specialRequestAndPaymentRequestStatus(Long contractId);

    //判断合同管理明细界面， 实际收款安排 点击状态
    String collectionCashflowStatus(Long contractId);

    //判断合同管理明细界面， 提前还款 点击状态
    String earlyTerminateStatus(Long contractId);

    //判断合同管理明细界面， 合同结束申请 点击状态
    String contactTerminateStatus(Long contractId);

    //查询合同结束界面的合同信息
    List<HlsCusFctContract> selectContractDetailInfo(HlsCusFctContract hlsCusFctContract);

    //合同结束提交
    List<HlsCusFctContract> contractEndSubmit(IRequest iRequest,HlsCusFctContract fctContract);


}