package hls.core.fct.service;

import com.hand.hap.core.IRequest;
import com.hand.hap.core.ProxySelf;
import com.hand.hap.system.service.IBaseService;
import hls.core.fct.dto.FctProject;
import hls.core.fct.dto.HlsCusFctProject;
import hls.core.prj.dto.HlsCusHlsCreditLine;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.text.ParseException;
import java.util.List;
import java.util.Map;

public interface FctProjectService extends IBaseService<HlsCusFctProject>, ProxySelf<FctProjectService> {
    //业务立项统计图
    public List<FctProject> selectPrjStatusInfo(FctProject fctProject, HttpSession session);

    List<FctProject> selectAllSetupProject(IRequest requestContext, FctProject fctProject, int page, int pageSize) throws ParseException;

    List<FctProject> selectSetupProjectDetail(FctProject fctProject, int page, int pagesize);
    //---------------------------------------------------------------------------------
    //授信审批信息

    List<HlsCusFctProject> fctProjectDetailQuery(HlsCusFctProject fctProject);

    public List<HlsCusFctProject> queryFctCreditInfo(HlsCusFctProject fctProject);

    //前台明细界面 查询
    //本月新增
    Double currencyMonthAddQuery();

    //授信 总数，状态，数量
    Map<String, Integer> creditStatusQuery(Long companyId);

    void fctCreditSave(IRequest iRequest, HlsCusFctProject hlsCusFctProject);

    void fctCreditSubmit(IRequest iRequest, List<HlsCusFctProject> hlsCusFctProjectList);

    //立项创建之后 插入附件资料清单
    void hlsCreditAttachmentCreate(IRequest iRequest, HlsCusFctProject hlsCusFctProject);



    void fctContentSave(IRequest iRequest, HlsCusFctProject hlsCusFctProject);

    void fctContentSubmit(IRequest iRequest, List<HlsCusFctProject> hlsCusFctProjectList);

    public List<HlsCusFctProject> submitApproval(IRequest iRequest, List<HlsCusFctProject> hlsCusFctProjectList);
    void fctSignSubmit(IRequest iRequest, List<HlsCusFctProject> hlsCusFctProjectList);
    //立项创建事件
    public void addFctProjectEvent(IRequest iRequest,HlsCusFctProject hlsCusFctProject);
    //立项更新事件
    public void updateFctProjectEvent(IRequest iRequest,HlsCusFctProject hlsCusFctProject);


}