package hls.core.fct.service;

import com.hand.hap.core.IRequest;
import com.hand.hap.core.ProxySelf;
import com.hand.hap.system.service.IBaseService;
import hls.core.fct.dto.HlsCusFctContract;
import hls.core.fct.dto.HlsCusFctContractWithdraw;
import hls.core.fct.dto.HlsCusFctProject;
import hls.core.fct.dto.HlsCusFctProjectBasicTrx;
import hls.core.prj.dto.HlsCusHlsCreditLine;

import java.util.List;

public interface HlsCusFctWflCustomService extends IBaseService<HlsCusFctContractWithdraw>, ProxySelf<HlsCusFctWflCustomService>{

    //预计收款安排
    boolean beforeAdvanceSubmit(IRequest iRequest, HlsCusFctContractWithdraw hlsCusFctContractWithdraw);
    HlsCusFctContractWithdraw afterAdvanceSubmit(IRequest iRequest, HlsCusFctContractWithdraw hlsCusFctContractWithdraw);

    //用款需求申请工作流二开
    boolean beforeCashDemandSubmit(IRequest iRequest, HlsCusFctContractWithdraw hlsCusFctContractWithdraw);
    HlsCusFctContractWithdraw afterCashDemandSubmit(IRequest iRequest, HlsCusFctContractWithdraw hlsCusFctContractWithdraw);

    //实际收款安排工作流二开
    boolean beforeCollectCashSubmit(IRequest iRequest, HlsCusFctContractWithdraw hlsCusFctContractWithdraw);
    HlsCusFctContractWithdraw afterCollectCashSubmit(IRequest iRequest, HlsCusFctContractWithdraw hlsCusFctContractWithdraw);

    //付款申请工作流二开
    boolean beforePaymentSubmit(IRequest iRequest, HlsCusFctContractWithdraw hlsCusFctContractWithdraw);
    HlsCusFctContractWithdraw afterPaymentSubmit(IRequest iRequest, HlsCusFctContractWithdraw hlsCusFctContractWithdraw);
    //特殊情况申请工作流二开
    boolean beforeSpclPaySubmit(IRequest iRequest, HlsCusFctContractWithdraw hlsCusFctContractWithdraw);
    HlsCusFctContractWithdraw afterSpclPaySubmit(IRequest iRequest, HlsCusFctContractWithdraw hlsCusFctContractWithdraw);
    //项目核销工作流二开
    boolean beforeContractEndSubmit(IRequest iRequest, HlsCusFctContract fctContract);
    HlsCusFctContractWithdraw afterContractEndSubmit(IRequest iRequest, HlsCusFctContract fctContract);
    /**
     * 综合授信二开逻辑
     * Create by xj 18/01/09
     */
    boolean beforeCreditSubmit(IRequest iRequest, HlsCusHlsCreditLine hlsCusHlsCreditLine);
    HlsCusHlsCreditLine afterCreditSubmit(IRequest iRequest, HlsCusHlsCreditLine hlsCusHlsCreditLine);

    /**
     *综合授信变更
     */
    boolean beforeChangeReqSubmit(IRequest iRequest, HlsCusHlsCreditLine hlsCusHlsCreditLine);
    HlsCusHlsCreditLine afterChangeReqSubmit(IRequest iRequest, HlsCusHlsCreditLine hlsCusHlsCreditLine);

    //保理立项审批
    boolean beforeSave(IRequest iRequest, HlsCusFctProject fctProject);
    HlsCusFctProject afterSave(IRequest iRequest, HlsCusFctProject fctProject);
    boolean beforeProjectSubmit(IRequest iRequest, List<HlsCusFctProject> fctProjectList);
    HlsCusFctProject afterProjectSubmit(IRequest iRequest, List<HlsCusFctProject> fctProjectList);


    //合同文本审批
    boolean beforeContentSave(IRequest iRequest, HlsCusFctProject fctProject);
    HlsCusFctProject afterContentSave(IRequest iRequest, HlsCusFctProject fctProject);
    boolean beforeContentSubmit(IRequest iRequest, List<HlsCusFctProject> fctProjectList);
    HlsCusFctProject afterContentSubmit(IRequest iRequest, List<HlsCusFctProject> fctProjectList);


    //合同签约
    boolean beforeSignSave(IRequest iRequest, HlsCusFctProject fctProject);
    HlsCusFctProject afterSSave(IRequest iRequest, HlsCusFctProject fctProject);
    boolean beforeSignSubmit(IRequest iRequest, List<HlsCusFctProject> fctProjectList);
    HlsCusFctProject afterSignSubmit(IRequest iRequest, List<HlsCusFctProject> fctProjectList);

    //基础交易审批
    boolean beforeProjectSubmit(IRequest iRequest, HlsCusFctProjectBasicTrx hlsCusFctProjectBasicTrx);
    HlsCusFctProjectBasicTrx afterProjectSubmit(IRequest iRequest,HlsCusFctProjectBasicTrx hlsCusFctProjectBasicTrx);

    //保理授信审批
    boolean beforeFctCreditSubmit(IRequest iRequest, HlsCusFctProject hlsCusFctProject);
    HlsCusFctProject afterFctCreditSubmit(IRequest iRequest, HlsCusFctProject hlsCusFctProject);

    //实际收款安排制作计算二开逻辑
    boolean beforeCollectCalculateSubmit(IRequest iRequest,HlsCusFctContractWithdraw hlsCusFctContractWithdraw);
    HlsCusFctContractWithdraw afterCollectCalculateSubmit(IRequest iRequest, HlsCusFctContractWithdraw hlsCusFctContractWithdraw);

}