package hls.core.fct.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.fct.dto.HlsCusFctContractWithdrawAtt;
import hls.core.fct.mapper.HlsCusFctContractWithdrawAttMapper;
import hls.core.fct.service.FctContractWithdrawAttService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class FctContractWithdrawAttServiceImpl extends BaseServiceImpl<HlsCusFctContractWithdrawAtt> implements FctContractWithdrawAttService{

    @Autowired
    HlsCusFctContractWithdrawAttMapper mapper;

    @Override
    public List<HlsCusFctContractWithdrawAtt> selectConWithdrawAttachment(IRequest request, HlsCusFctContractWithdrawAtt fctContractWithdrawAtt, int page, int pageSize) {
        PageHelper.startPage(page,pageSize);
        return mapper.selectConWithdrawAttachment(fctContractWithdrawAtt);
    }

    @Override
    public List<HlsCusFctContractWithdrawAtt>  queryWithdrawContent(HlsCusFctContractWithdrawAtt fctContractWithdrawAtt){
        return mapper.queryWithdrawContent(fctContractWithdrawAtt);
    }

    @Override
    public void deleteWithdrawContent(HlsCusFctContractWithdrawAtt fctContractWithdrawAtt){
        mapper.deleteWithdrawContent(fctContractWithdrawAtt);
    }

}