package hls.core.fct.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.fct.dto.HlsCusFctProjectAttachment;
import hls.core.fct.mapper.HlsCusFctProjectAttachmentMapper;
import hls.core.fct.service.FctProjectAttachmentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class FctProjectAttachmentServiceImpl extends BaseServiceImpl<HlsCusFctProjectAttachment> implements FctProjectAttachmentService{

    @Autowired
    private HlsCusFctProjectAttachmentMapper mapper;

    @Override
    public List<HlsCusFctProjectAttachment> fctProjectAttachmentQuery(HlsCusFctProjectAttachment fctProjectAttachment, int page, int pagesize) {
        PageHelper.startPage(page,pagesize);
        return mapper.fctProjectAttachmentQuery(fctProjectAttachment);
    }

    @Override
    public List<HlsCusFctProjectAttachment> fctContractContentHistoryQuery(HlsCusFctProjectAttachment fctProjectAttachment, int page, int pagesize) {
        PageHelper.startPage(page,pagesize);
        return mapper.fctContractContentHistoryQuery(fctProjectAttachment);
    }

    @Override
    public List<HlsCusFctProjectAttachment> fctContractContentQuery(HlsCusFctProjectAttachment fctProjectAttachment, int page, int pagesize) {
        PageHelper.startPage(page,pagesize);
        return mapper.fctContractContentQuery(fctProjectAttachment);
    }

    @Override
    public List<HlsCusFctProjectAttachment> fctContractQuery(Long contractId, int page, int pagesize) {
        PageHelper.startPage(page,pagesize);
        return mapper.fctContractQuery(contractId);
    }

    @Override
    public List<HlsCusFctProjectAttachment> fctProjectAttachmentForSignProcessQuery(HlsCusFctProjectAttachment fctProjectAttachment) {
        return mapper.fctProjectAttachmentForSignProcessQuery(fctProjectAttachment);
    }


    //查询审批特有附件
    @Override
    public List<HlsCusFctProjectAttachment> fctCreAttQuery(HlsCusFctProjectAttachment fctProjectAttachment){
        return mapper.fctCreAttQuery(fctProjectAttachment);
    }

    @Override
    public List<HlsCusFctProjectAttachment> fctContractManagementContentQuery(HlsCusFctProjectAttachment fctProjectAttachment, int page, int pagesize) {
        PageHelper.startPage(page,pagesize);
        return mapper.fctContractManagementContentQuery(fctProjectAttachment);
    }

    @Override
    //计算其他协议下属附件
    public List<HlsCusFctProjectAttachment> fctProjectAttQuery(Long sourceId){
        return mapper.fctProjectAttQuery(sourceId);
    }
    @Override
    public List<HlsCusFctProjectAttachment> riskAssessmentReportFctQuery(HlsCusFctProjectAttachment fctProjectAttachment){
        return mapper.riskAssessmentReportFctQuery(fctProjectAttachment);
    }

}