package hls.core.fct.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.excel.ExcelException;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.fct.dto.HlsCusFctProjectBasicTrxAr;
import hls.core.fct.mapper.HlsCusFctProjectBasicTrxArMapper;
import hls.core.fnd.dto.FndInterfaceLines;
import hls.core.fnd.mapper.FndInterfaceLinesMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.fct.dto.FctProjectBasicTrxAr;
import hls.core.fct.service.FctProjectBasicTrxArService;
import org.springframework.transaction.annotation.Transactional;

import java.sql.SQLException;
import java.text.ParseException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
@Transactional(rollbackFor = Exception.class)
public class FctProjectBasicTrxArServiceImpl extends BaseServiceImpl<HlsCusFctProjectBasicTrxAr> implements FctProjectBasicTrxArService {
    @Autowired
    private HlsCusFctProjectBasicTrxArMapper mapper;

    @Autowired
    FndInterfaceLinesMapper fndInterfaceLinesMapper;

    @Autowired
    private FctProjectBasicTrxArService service;

    /*excel导入*/
    @Override
    public void arExcelImportConfirm(IRequest iRequest, Long hdId,Long basicTrxDtlId) throws ExcelException, SQLException {
        insertTable(iRequest, hdId, basicTrxDtlId);
    }


    @Override
    public void arBatchDelete(HlsCusFctProjectBasicTrxAr hlsCusFctProjectBasicTrxAr) {
        Long basicTrxDtlId = hlsCusFctProjectBasicTrxAr.getBasicTrxDtlId();
        mapper.arBatchDelete(basicTrxDtlId);
    }

    @Override
    public List<HlsCusFctProjectBasicTrxAr> fctProjectBasicTrxArQuery(HlsCusFctProjectBasicTrxAr hlsCusFctProjectBasicTrxAr) {
        return mapper.fctProjectBasicTrxArQuery(hlsCusFctProjectBasicTrxAr);
    }

    private void insertTable(IRequest iRequest, Long hdId, Long basicTrxDtlId) throws SQLException, ExcelException {
        //获取接口表数据
        FndInterfaceLines arInvoice = new FndInterfaceLines();
        arInvoice.setHeaderId(hdId);
        List<FndInterfaceLines> fndInterfaceLinesList = fndInterfaceLinesMapper.select(arInvoice);
        Map<String, String> params = new HashMap<String, String>();

        //先删除所有应收账款
        mapper.arBatchDelete(basicTrxDtlId);

        //插入头表
        for (int i = 3; i < fndInterfaceLinesList.size()-1; i++) {

            HlsCusFctProjectBasicTrxAr fctProjectBasicTrxAr = new HlsCusFctProjectBasicTrxAr();

            if(fndInterfaceLinesList.get(i).getAttributes_1().equals(" ")){
                break;
            }
            String seqNum = fndInterfaceLinesList.get(i).getAttributes_1().substring(0,fndInterfaceLinesList.get(i).getAttributes_1().indexOf("."));
            if(seqNum == null) {
                throw new ExcelException((String) null, "序号不能为空！", (Object[]) null);
            }
            fctProjectBasicTrxAr.setSeqNumber(Long.parseLong(seqNum));
            fctProjectBasicTrxAr.setTrxInvoiceName(fndInterfaceLinesList.get(i).getAttributes_2());
            fctProjectBasicTrxAr.setTrxInvoiceNumber(fndInterfaceLinesList.get(i).getAttributes_3());
            fctProjectBasicTrxAr.setTrxInvoiceAmount(Double.parseDouble(fndInterfaceLinesList.get(i).getAttributes_4()));
            fctProjectBasicTrxAr.setTrxContractNumber(fndInterfaceLinesList.get(i).getAttributes_5());
            fctProjectBasicTrxAr.setPaidAmount(Double.parseDouble(fndInterfaceLinesList.get(i).getAttributes_6()));
            fctProjectBasicTrxAr.setDeposit(Double.parseDouble(fndInterfaceLinesList.get(i).getAttributes_7()));
            fctProjectBasicTrxAr.setResidualTrxInvoiceAmt(Double.parseDouble(fndInterfaceLinesList.get(i).getAttributes_8()));
            fctProjectBasicTrxAr.setBasicTrxDtlId(basicTrxDtlId);

            service.insertSelective(iRequest,fctProjectBasicTrxAr);
        }
    }
}