package hls.core.fct.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.fct.dto.FctProjectBp;
import hls.core.fct.dto.FctProjectBpInfo;
import hls.core.fct.dto.HlsCusFctProjectBp;
import hls.core.fct.mapper.HlsCusFctProjectBpMapper;
import hls.core.fct.service.FctProjectBpService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class FctProjectBpServiceImpl extends BaseServiceImpl<HlsCusFctProjectBp> implements FctProjectBpService{

    @Autowired
    private HlsCusFctProjectBpMapper mapper;

    @Override
    public List<FctProjectBpInfo> queryBpInfo(IRequest requestContext, List<FctProjectBp> dto, int page, int pageSize) {
        PageHelper.startPage(page, pageSize);
        return mapper.queryBpInfo(dto.get(0).getProjectId());
    }

        @Override
        public List<HlsCusFctProjectBp> fctProjectBpQuery(HlsCusFctProjectBp fctProjectBp , int page, int pagesize) {
            PageHelper.startPage(page,pagesize);
            return mapper.fctProjectBpQuery(fctProjectBp);
        }

    @Override
    public void updateProjectBp(HlsCusFctProjectBp fctProjectBp){
        mapper.updateProjectBp(fctProjectBp);
    }
    }
