package hls.core.fct.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.fct.dto.FctProjectQuotation;
import hls.core.fct.dto.HlsCusFctProjectQuotation;
import hls.core.fct.mapper.HlsCusFctProjectQuotationMapper;
import hls.core.fct.service.FctProjectQuotationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class FctProjectQuotationServiceImpl extends BaseServiceImpl<HlsCusFctProjectQuotation> implements FctProjectQuotationService{

    @Autowired
    private HlsCusFctProjectQuotationMapper mapper;

    @Override
    public List<FctProjectQuotation> selectSetupProjectQuotation(FctProjectQuotation fctProjectQuotation, int page, int pagesize) {
        PageHelper.startPage(page,pagesize);
        return mapper.selectSetupProjectQuotation(fctProjectQuotation);
    }

    @Override
    public List<HlsCusFctProjectQuotation> fctProjectQuotationDetailQuery(HlsCusFctProjectQuotation fctProjectQuotation) {
        return mapper.fctProjectQuotationDetailQuery(fctProjectQuotation);
    }
}