package hls.core.fct.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.fct.dto.HlsCreditLineAttachment;
import hls.core.fct.dto.HlsCusHlsCreditLineAttachment;
import hls.core.fct.mapper.HlsCusHlsCreditLineAttachmentMapper;
import hls.core.fct.service.HlsCreditLineAttachmentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class HlsCreditLineAttachmentServiceImpl extends BaseServiceImpl<HlsCusHlsCreditLineAttachment> implements HlsCreditLineAttachmentService{
    @Autowired
    private HlsCusHlsCreditLineAttachmentMapper mapper;

    @Override
    public List<HlsCreditLineAttachment> creditLineAttachmentQuery(HlsCreditLineAttachment hlsCreditLineAttachment, int page, int pagesize) {
        PageHelper.startPage(page,pagesize);
        return mapper.creditLineAttachmentQuery(hlsCreditLineAttachment);
    }

    @Override
    public List<HlsCreditLineAttachment> riskAssessmentReportQuery(HlsCreditLineAttachment hlsCreditLineAttachment, int page, int pagesize) {
        PageHelper.startPage(page,pagesize);
        return mapper.riskAssessmentReportQuery(hlsCreditLineAttachment);
    }

}