package hls.core.fnd.controllers;

import hls.core.fnd.dto.FndCompany;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.CompanyAttribute;
import hls.core.fnd.service.ICompanyAttributeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import org.springframework.validation.BindingResult;
import java.util.List;

    @Controller
    public class CompanyAttributeController extends BaseController{

    @Autowired
    private ICompanyAttributeService service;


    @RequestMapping(value = "/fnd/company/attribute/query")
    @ResponseBody
    public ResponseData query(CompanyAttribute dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/fnd/company/attribute/submit")
    @ResponseBody
public ResponseData update(@RequestBody List<CompanyAttribute> dto, BindingResult result, HttpServletRequest request){
getValidator().validate(dto, result);
if (result.hasErrors()) {
ResponseData responseData = new ResponseData(false);
responseData.setMessage(getErrorMessage(result, request));
return responseData;
}
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/fnd/company/attribute/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<CompanyAttribute> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }


        @RequestMapping(value = "/fnd/company/infor/submitInfo")
        @ResponseBody
        public ResponseData updateInfo(@RequestBody List<FndCompany> dto, HttpServletRequest request){
            IRequest requestCtx = createRequestContext(request);
            List <FndCompany> datas = service.updateInfo(requestCtx,dto);
            return new  ResponseData(datas);
        }
    }