package hls.core.fnd.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.DocFileTempletType;
import hls.core.fnd.service.IDocFileTempletTypeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

    @Controller
    public class DocFileTempletTypeController extends BaseController{

    @Autowired
    private IDocFileTempletTypeService service;


    @RequestMapping(value = "/hls/doc/file/templet/type/query")
    @ResponseBody
    public ResponseData query(DocFileTempletType dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/hls/doc/file/templet/type/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<DocFileTempletType> dto) throws Exception{
        ResponseData rd = null;
        try {
            IRequest iRequest = createRequestContext(request);
            List<DocFileTempletType>  datas = service.batchUpdate(iRequest, dto);
            rd = new ResponseData(datas);
        }catch (Exception e){
            rd = new ResponseData(false);
            rd.setMessage("模板代码不可重复，请重新输入");
        }
        return rd;
    }


    @RequestMapping(value = "/hls/doc/file/templet/type/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<DocFileTempletType> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }