package hls.core.fnd.controllers;



import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.fnd.dto.FndBaseRate;
import hls.core.fnd.dto.FndBaseRateSet;
import hls.core.fnd.service.FndBaseRateService;

@Controller
public class FndBaseRateController extends BaseController{

	@Autowired
	FndBaseRateService fndBaseRateService;

	@RequestMapping("/fct/fnd/baserate/query")
	@ResponseBody
	public ResponseData selectRate(HttpServletRequest request,String baseRateType, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
								  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
		IRequest iRequest = createRequestContext(request);
		List<FndBaseRate> datas = fndBaseRateService.queryAllByBaseRateType(baseRateType);
		return new ResponseData(datas);
	}
	
	@RequestMapping("/fnd/baserate/query")
	@ResponseBody
	public ResponseData selectAll(HttpServletRequest request,@RequestBody(required = false) final FndBaseRate fndBaseRate, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
		IRequest iRequest = createRequestContext(request);
		List<FndBaseRate> datas = fndBaseRateService.queryAllByBaseRateSet(fndBaseRate.getBase_rate_set());
		return new ResponseData(datas);
	}
	
	@RequestMapping("/fnd/baserate/submit")
	@ResponseBody
	public ResponseData submit(HttpServletRequest request, @RequestBody List<FndBaseRate> fndBaseRates){
		IRequest iRequest = createRequestContext(request);
		System.out.println(fndBaseRates);
		fndBaseRateService.batchUpdate(iRequest, fndBaseRates);
		return new ResponseData();
	}
	
	@RequestMapping("/fnd/baserate/delete")
	@ResponseBody
	public ResponseData delete(HttpServletRequest request, List<FndBaseRate> fndBaseRate){
		IRequest iRequest = createRequestContext(request);
		fndBaseRateService.delete(fndBaseRate);;
		return new ResponseData();
	}
	
	
}
