package hls.core.fnd.controllers;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.fnd.dto.FndBaseRate;
import hls.core.fnd.dto.FndBaseRateSet;
import hls.core.fnd.dto.FndCompany;
import hls.core.fnd.service.FndBaseRateSetService;

@Controller
public class FndBaseRateSetController extends BaseController{

	@Autowired
	FndBaseRateSetService fndBaseRateSetService;
	
	@RequestMapping("/fnd/baserateset/query")
	@ResponseBody
	public ResponseData selectByQuery(HttpServletRequest request,final FndBaseRateSet fndBaseRateSet, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
		IRequest iRequest = createRequestContext(request);
		if(fndBaseRateSet.getSortname() == null)
		{
			fndBaseRateSet.setSortname("base_rate_type");
			fndBaseRateSet.setSortorder("asc");
		}
		PageHelper.startPage(page, pagesize);
		List<FndBaseRateSet> datas = fndBaseRateSetService.selectByQuery(fndBaseRateSet,page,pagesize);
		return new ResponseData(datas);
	}
	
	@RequestMapping("/fnd/baserateset/save")
	@ResponseBody
	public ResponseData saveHeadAndLine(HttpServletRequest request,@RequestBody FndBaseRateSet fndBaseRateSet, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){

		IRequest iRequest = createRequestContext(request);
		
		List<FndBaseRateSet> datas = fndBaseRateSetService.queryAll();
		
		System.out.println("这里是data");
		System.out.println(datas);
		
		List<FndBaseRate> fndbaserates = new ArrayList<FndBaseRate>();
		System.out.println(fndBaseRateSet);
		if(fndBaseRateSet.getFndBaseRate() != null)
		{
			for(FndBaseRate fndbaserate:fndBaseRateSet.getFndBaseRate())
			{
				FndBaseRate fndBaserate = fndbaserate;
				System.out.println(fndBaserate.toString());
				fndbaserates.add(fndBaserate);
			}
		}
		fndBaseRateSet.setEnabled_flag("Y");
		fndBaseRateSetService.batchChildUpdate(iRequest, fndBaseRateSet ,fndbaserates,datas);
		
		return new ResponseData();
		
	}
	
	@RequestMapping("/fnd/baserateset/getCount")
	@ResponseBody
	public ResponseData getCount(){
		return new ResponseData(fndBaseRateSetService.getCount());
	}

	/*融资合同-根据基础利率类型和融资期限查询利率值*/
	@RequestMapping("/fnd/baserateset/queryForFinanceContract")
	@ResponseBody
	public ResponseData queryForFinanceContract(HttpServletRequest request, @RequestBody FndBaseRateSet fndBaseRateSet){

		return new ResponseData(fndBaseRateSetService.queryForFinanceContract(fndBaseRateSet));
	}


}
	

