package hls.core.fnd.controllers;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.exception.TokenException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.fnd.dto.FndCity;
import hls.core.fnd.service.IFndCityService;
import hls.core.hls.service.FndProvinceService;


@Controller
public class FndCityControllers extends BaseController{

	@Autowired
	private IFndCityService cityService;
	
	@Autowired
	private FndProvinceService fndProvinceService;
	
	public  static List<FndCity> cityLists ;

	@RequestMapping(value="/fnd/city/query",method=RequestMethod.POST)
	@ResponseBody
	public ResponseData selectAll(HttpServletRequest request,final FndCity fndCity, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
		cityLists = null;
//		List<FndCity> lists =cityService.select(iRequest, fndCity, page, pagesize);
		if(fndCity.getProvince() == null || fndCity.getProvince() ==""){
			fndCity.setProvince(null);
		}
		if(fndCity.getFlag() != null && fndCity.getFlag() != "")
		{
			if(fndCity.getFlag().equals("1")){
				String temp_province = fndProvinceService.queryProvinceFirst();
				fndCity.setProvince(temp_province);
			}
		}
		PageHelper.startPage(page, pagesize);

		List<FndCity> lists =cityService.queryAll(fndCity);
		cityLists = lists;
		return new ResponseData(lists);
		
	}
	


//	@RequestMapping(value="/fnd/psave",method=RequestMethod.POST)
//	@ResponseBody
//	public String lookfor(String etype){
//		
//		boolean flag = cityService.saveProvinceCode(etype);
//		return flag;
//	}
	
	
	
	@RequestMapping(value="/fnd/city/submit",method=RequestMethod.POST)
	@ResponseBody
	public ResponseData submit(HttpServletRequest request,@RequestBody List<FndCity> list)throws TokenException {
		ResponseData rd = null;
		try {
		IRequest iRequest = createRequestContext(request);
		List<FndCity> lists = cityService.batchUpdate(iRequest, list);
		return new ResponseData(lists);
		}catch (Exception e) {
			rd = new ResponseData(false);
			rd.setMessage("市代码不可重复！");
			return rd;
		}
	}
	@RequestMapping(value="/fnd/city/remove",method=RequestMethod.POST)
	@ResponseBody
	public ResponseData remove(@RequestBody List<FndCity> lists){
		
		cityService.cascadingDeleteDistrict(lists);
		return new ResponseData();
	}
	
	@RequestMapping(value="/fnd/address/city/query",method=RequestMethod.POST)
	@ResponseBody
	public ResponseData addressQuery(FndCity fndCity){
		List<FndCity> lists =cityService.addressQuery(fndCity);
		return new ResponseData(lists);
	}
	
	
}
