package hls.core.fnd.controllers;

import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import com.hand.hap.core.exception.TokenException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.FndCodingRule;
import hls.core.fnd.service.FndCodingRuleService;

@Controller
public class FndCodingRuleController extends BaseController{

	@Autowired
	FndCodingRuleService fndCodingRuleService;
	
	@RequestMapping("/fnd/code/rule/query")
	@ResponseBody
	public ResponseData selectAll(HttpServletRequest request,final FndCodingRule fndCodingRule, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
		IRequest iRequest = createRequestContext(request);
		fndCodingRule.setCompanyId(iRequest.getCompanyId());
		List<FndCodingRule> datas = fndCodingRuleService.select(iRequest, fndCodingRule, page, pagesize);
		return new ResponseData(datas);
	}

	@RequestMapping("/fnd/all/code/rule/query")
	@ResponseBody
	public ResponseData queryAllRule(HttpServletRequest request,final FndCodingRule fndCodingRule, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
								  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
		IRequest iRequest = createRequestContext(request);
		List<FndCodingRule> datas = fndCodingRuleService.select(iRequest, fndCodingRule, 1, 0);
		return new ResponseData(datas);
	}
	
	@RequestMapping("/fnd/code/rule/submit")
	@ResponseBody
	public ResponseData submit(HttpServletRequest request, @RequestBody List<FndCodingRule> fndCodingRules,final HttpSession session)throws TokenException {
		ResponseData rd = null;
		try {
		IRequest iRequest = createRequestContext(request);
		Long companyId = Long.valueOf(String.valueOf(session.getAttribute("companyId")));
		
		for(FndCodingRule fndCodingRule:fndCodingRules)
		{
			fndCodingRule.setCompanyId(companyId);
		}
		
		return new ResponseData(fndCodingRuleService.batchUpdate(iRequest, fndCodingRules));
		}catch (Exception e) {
			rd = new ResponseData(false);
			rd.setMessage("编码规则代码不可重复！");
			return rd;
		}
	}
	
	@RequestMapping("/fnd/code/rule/delete")
	@ResponseBody
	public ResponseData delete(HttpServletRequest request, @RequestBody List<FndCodingRule> fndCodingRules,final HttpSession session){
		IRequest iRequest = createRequestContext(request);
		
		fndCodingRuleService.delete(iRequest, fndCodingRules.get(0));
		
		return new ResponseData();
	}
}
