package hls.core.fnd.controllers;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.fnd.dto.FndCodingRuleDetails;
import hls.core.fnd.service.FndCodingRuleDetailsService;

@Controller
public class FndCodingRuleDetailsController extends BaseController{

	@Autowired
	FndCodingRuleDetailsService fndCodingRruleDetailsService;
	
	@RequestMapping("/fnd/code/rule/detail/query")
	@ResponseBody
	public ResponseData selectAll(HttpServletRequest request,final FndCodingRuleDetails fndCodingRruleDetails, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
		IRequest iRequest = createRequestContext(request);
		List<FndCodingRuleDetails> datas = fndCodingRruleDetailsService.select(iRequest, fndCodingRruleDetails, page, pagesize);
		return new ResponseData(datas);
	}
	
	@RequestMapping("/fnd/code/rule/detail/submit")
	@ResponseBody
	public ResponseData submit(HttpServletRequest request, @RequestBody List<FndCodingRuleDetails> fndCodingRruleDetails){
		IRequest iRequest = createRequestContext(request);
		
		return new ResponseData(fndCodingRruleDetailsService.batchUpdate(iRequest, fndCodingRruleDetails));
	}
	
}
