package hls.core.fnd.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.FndCompany;
import hls.core.fnd.service.FndICompanyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import org.springframework.validation.BindingResult;
import java.util.List;

    @Controller
    public class FndCompanyController extends BaseController{

    @Autowired
    private FndICompanyService service;

    @RequestMapping(value = "/fnd/company/queryall")
    @ResponseBody
    public ResponseData selectList(HttpServletRequest request,FndCompany companyManagement,
                                   @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize
                                   ) {
        IRequest iRequest = createRequestContext(request);
        List<FndCompany> datas = service.queryAll(iRequest,companyManagement,page, pagesize);
        return new ResponseData(datas);
    }

        @RequestMapping(value = "/fnd/company/queryCompanyName")
        @ResponseBody
        public ResponseData queryCompanyName(HttpServletRequest request,FndCompany companyManagement,
                                       @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                       @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize)
        {
            IRequest iRequest = createRequestContext(request);
            Long companyId = iRequest.getCompanyId();
            companyManagement.setCompany_id(companyId);
            List<FndCompany> datas = service.queryAll(iRequest,companyManagement,page, pagesize);
            return new ResponseData(datas);
        }

    @RequestMapping(value = "/fnd/company/infor/submit")
    @ResponseBody
public ResponseData update(@RequestBody List<FndCompany> dto, BindingResult result, HttpServletRequest request){
getValidator().validate(dto, result);
if (result.hasErrors()) {
ResponseData responseData = new ResponseData(false);
responseData.setMessage(getErrorMessage(result, request));
return responseData;
}
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/fnd/company/infor/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<FndCompany> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

    }