package hls.core.fnd.controllers;

import com.hand.hap.core.exception.TokenException;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.FndCountry;
import hls.core.fnd.service.IFndCountryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import org.springframework.validation.BindingResult;
import java.util.List;

    @Controller
    public class FndCountryController extends BaseController{

    @Autowired
    private IFndCountryService service;


    @RequestMapping(value = "/fnd/country/query")
    @ResponseBody
    public ResponseData query(FndCountry dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));


    }

        @RequestMapping(value = "/fnd/country/by/query")
        @ResponseBody
        public ResponseData byQuery(FndCountry dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
            IRequest requestContext = createRequestContext(request);
            return new ResponseData(service.selectList(dto,page,pageSize));



        }

    @RequestMapping(value = "/fnd/country/submit")
    @ResponseBody
public ResponseData update(@RequestBody List<FndCountry> dto, BindingResult result, HttpServletRequest request)throws IllegalArgumentException {

        List<FndCountry> list = service.selectAll();
        for (FndCountry a : dto) {
            for (FndCountry d : list) {
                if (d.getCountry().equals(a.getCountry())) {
                    throw  new IllegalArgumentException("国家编码不能重复！");
                }
                if (d.getTwoCharacterCode().equals(a.getTwoCharacterCode())) {
                    throw  new IllegalArgumentException("两字符简码不能重复！");
                }
                if (d.getThreeCharacterCode().equals(a.getThreeCharacterCode())) {
                    throw  new IllegalArgumentException("三字符简码不能重复！");
                }
                if (d.getDigitalCode().equals(a.getDigitalCode())) {
                    throw  new IllegalArgumentException("数字代码不能重复！");
                }
            }
        }

            getValidator().validate(dto, result);
            if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
            }
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));

    }

    @RequestMapping(value = "/fnd/country/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<FndCountry> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }