package hls.core.fnd.controllers;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.core.exception.TokenException;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.fnd.dto.FndCity;
import hls.core.fnd.dto.FndDistrict;
import hls.core.fnd.dto.FndSysCodes;
import hls.core.fnd.service.FndDistrictService;
import hls.core.fnd.service.FndSysCodesService;
import hls.core.hls.dto.FndProvince;
import hls.core.hls.service.FndProvinceService;
import hls.core.sys.dto.SysFunctionResource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import java.util.List;

/**
 * Created by hailor on 16/6/2.
 */
@Controller
public class FndDistrictController extends BaseController {

	@Autowired
	private FndDistrictService fnd;
	
	@Autowired
	private FndProvinceService fndProvinceService;

	@RequestMapping("/FndDistrict/query")
	@ResponseBody
	public ResponseData selectList(HttpServletRequest request, FndDistrict fndDistrict,
			@RequestParam(defaultValue = DEFAULT_PAGE) int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {

		if (fndDistrict.getProvince() == null || fndDistrict.getProvince() == "") {
			fndDistrict.setProvince(null);
		}
		if (fndDistrict.getFlag() != null && fndDistrict.getFlag().equals("1")) {
			
			fndDistrict.setProvince(fndProvinceService.queryProvinceFirst());
		}
		
		if(fndDistrict.getCity()==null){
			List<FndCity> cityLists = FndCityControllers.cityLists; 
			fndDistrict.setCity(cityLists.get(0).getCity());
		}
		PageHelper.startPage(page, pagesize);
		List<FndDistrict> datas = fnd.queryByProvinceCity(fndDistrict);

		return new ResponseData(datas);
	}

	@RequestMapping(value = "/FndDistrict/submit", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData submit(HttpServletRequest request, @RequestBody List<FndDistrict> fndDistrict) throws TokenException {
		ResponseData rd = null;
		try {
		IRequest iRequest = createRequestContext(request);
		List<FndDistrict> datas = fnd.batchUpdate(iRequest, fndDistrict);
		return new ResponseData(datas);
		}catch (Exception e) {
			rd = new ResponseData(false);
			rd.setMessage("区县代码不可重复！");
			return rd;
		}
	}

	@RequestMapping(value = "/FndDistrict/delete", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData delete(HttpServletRequest request, @RequestBody List<FndDistrict> fndDistrict) {
		fnd.batchDelete(fndDistrict);
		return new ResponseData();
	}

	@RequestMapping(value = "/fnd/address/district/query", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData addressQuery(FndDistrict fndDistrict) {
		List<FndDistrict> lists = fnd.addressQuery(fndDistrict);
		return new ResponseData(lists);
	}

	// @RequestMapping(value = "/FndDistrict/queryLov", method =
	// RequestMethod.POST)
	// @ResponseBody
	// public ResponseData queryLov(FndCity fndCity) {
	// List<FndProvince> datas= fnd.queryLov(fndCity);
	// return new ResponseData(datas);
	// }
}
