package hls.core.fnd.controllers;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.exception.TokenException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.fnd.dto.FndCompany;
import hls.core.fnd.dto.FndLeaseChannel;
import hls.core.fnd.service.IFndLeaseChannelService;


@Controller
public class FndLeaseChannelController extends BaseController {

	@Autowired
	private IFndLeaseChannelService fndLeaseChannelService;
	IRequest iRequest;
	@RequestMapping(value = "/biz/query", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData selectList(HttpServletRequest request,HttpSession session, final FndLeaseChannel fndLeaseChannel,
			@RequestParam(defaultValue = DEFAULT_PAGE) final int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
		IRequest iRequest = createRequestContext(request);
		this.iRequest=iRequest;
		Long company_id = (Long) session.getAttribute("companyId");
		fndLeaseChannel.setCompany_id(company_id);
		PageHelper.startPage(page, pagesize);
		// List<FndLeaseChannel> list =
		// fndLeaseChannelService.selectAll(iRequest);
		List<FndLeaseChannel> list = fndLeaseChannelService.selectList(fndLeaseChannel);
		return new ResponseData(list);
	}

	@RequestMapping(value = "/biz/submit", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData submit(HttpServletRequest request, @RequestBody List<FndLeaseChannel> channel,HttpSession session)throws TokenException {
		ResponseData rd = null;
		try {
			IRequest iRequest = createRequestContext(request);
			Long company_id = (Long) session.getAttribute("companyId");
			for (int i = 0; i < channel.size(); i++) {
				channel.get(i).setCompany_id(company_id);
				if (channel.get(i).getLease_channel().trim().length() == 0) {
					channel.remove(i);
				}
			}
			List<FndLeaseChannel> list = fndLeaseChannelService.batchUpdate(iRequest, channel);
			list = fndLeaseChannelService.selectAll(this.iRequest);
			return new ResponseData(list);
		}
		catch (Exception e) {
			rd = new ResponseData(false);
			rd.setMessage("商业模式编码不可重复！");
			return rd;
		}
	}

	@RequestMapping(value = "/biz/remove", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData delete(HttpServletRequest request, @RequestBody List<FndLeaseChannel> lists) {
		IRequest iRequest = createRequestContext(request);
		fndLeaseChannelService.batchDelete(lists);
		return new ResponseData();
	}
	
	public FndCompany getFndCompany(Long company_id){
		return fndLeaseChannelService.getFndCompany(company_id);
	}

}
