package hls.core.fnd.controllers;


import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.core.exception.TokenException;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.fnd.dto.FndSysCodes;
import hls.core.fnd.dto.HLSCurrency;
import hls.core.fnd.service.FndSysCodesService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import java.util.List;

/**
 * Created by hailor on 16/6/2.
 */
@Controller
public class FndSysCodesController  extends BaseController{

    @Autowired
    private FndSysCodesService fnd;

    @RequestMapping("/FndSysCodes/query")
    @ResponseBody
    public ResponseData selectList(HttpServletRequest request,FndSysCodes fndSysCodes,
            @RequestParam(defaultValue = DEFAULT_PAGE) int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize,final HttpSession session) {
     
      IRequest iRequest = createRequestContext(request);
      /*demos.setCompany_id((long) request.getSession().getAttribute("company_id"));*/
      
      Long company_id = Long.valueOf(String.valueOf(session.getAttribute("companyId")));
   //  Long company_id =  (long) request.getSession().getAttribute("company_id");
      if (company_id != null) {
    	  fndSysCodes.setCompany_id(company_id);
	   }else{
		   fndSysCodes.setCompany_id(-1);
	   }
      
      List<FndSysCodes> datas = fnd.select(iRequest, fndSysCodes, page, pagesize);
      
        return new ResponseData(datas);
    }

    @RequestMapping("/FndSysCodes/by/query")
    @ResponseBody
    public ResponseData selectByQuery(HttpServletRequest request,final FndSysCodes fndSysCodes,
            @RequestParam(defaultValue = DEFAULT_PAGE) int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize,final HttpSession session) {
     
      IRequest iRequest = createRequestContext(request);
      /*demos.setCompany_id((long) request.getSession().getAttribute("company_id"));*/
      
      Long company_id = Long.valueOf(String.valueOf(session.getAttribute("companyId")));
   //  Long company_id =  (long) request.getSession().getAttribute("company_id");
      if (company_id != null) {
    	  fndSysCodes.setCompany_id(company_id);
	   }else{
		   fndSysCodes.setCompany_id(-1);
	   }
      PageHelper.startPage(page, pagesize);
      List<FndSysCodes> datas = fnd.selectByQuery(fndSysCodes);
      
      return new ResponseData(datas);
    }
    
    @RequestMapping(value = "/FndSysCodes/submit", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData submit(HttpServletRequest request, @RequestBody List<FndSysCodes> fndSysCodes,final HttpSession session)throws TokenException {
        ResponseData rd = null;
        try {
        IRequest iRequest = createRequestContext(request);
        Long company_id = Long.valueOf(String.valueOf(session.getAttribute("companyId")));
        for (FndSysCodes fndSysCodes2 : fndSysCodes) {
        	if (company_id != null) {
          	  fndSysCodes2.setCompany_id(company_id);
      	   }else{
      		   fndSysCodes2.setCompany_id(-1);
      	   }
		}
        List<FndSysCodes> datas = fnd.batchUpdate(iRequest, fndSysCodes);
        return new ResponseData(datas);
        }catch (Exception e) {
            rd = new ResponseData(false);
            rd.setMessage("税种代码不可重复！");
            return rd;
        }
    }

    @RequestMapping(value = "/FndSysCodes/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<FndSysCodes> fndSysCodes) {
    	fnd.batchDelete(fndSysCodes);
        return new ResponseData();
    }
}
