package hls.core.fnd.controllers;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.fnd.dto.FndLeaseChannel;
import hls.core.fnd.dto.FndUomCode;
import hls.core.fnd.service.IFndUomCodeService;


@Controller
public class FndUomCodeController extends BaseController{

	@Autowired
	IFndUomCodeService codeService;
	IRequest iRequest ;
	private String uom_type;
	
	@RequestMapping(value="/uom/code/query",method=RequestMethod.POST)
	@ResponseBody
	public ResponseData selectList(HttpServletRequest request,final FndUomCode fndUomCode, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
		IRequest iRequest = createRequestContext(request);
		this.iRequest = iRequest;
		List<FndUomCode> list = codeService.select(iRequest, fndUomCode, page, pagesize);
		uom_type=fndUomCode.getUom_type();
		return new ResponseData(list);
	}
	@RequestMapping(value="/uom/code/submit")
	@ResponseBody
	public ResponseData submit(HttpServletRequest request, @RequestBody List<FndUomCode> lists){
		IRequest iRequest =createRequestContext(request);
		List<FndUomCode> list = codeService.batchUpdate(iRequest, lists);
		FndUomCode fnd = new FndUomCode();
		fnd.setUom_type(uom_type);
//		list =codeService.select(this.iRequest, fnd, 1, 1);
		return new ResponseData(list);
	}
	@RequestMapping(value="/uom/code/remove")
	@ResponseBody
	public ResponseData remove(@RequestBody List<FndUomCode> Lists){
		codeService.batchDelete(Lists);
		return new  ResponseData();
	}
}
