package hls.core.fnd.controllers;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import com.hand.hap.core.exception.TokenException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.fnd.dto.FndLeaseChannel;
import hls.core.fnd.dto.FndSysCodes;
import hls.core.fnd.dto.FndUomCode;
import hls.core.fnd.dto.FndUomType;
import hls.core.fnd.service.IFndUomTypeService;

@Controller
public class FndUomTypeControllers extends BaseController{

	@Autowired
	private IFndUomTypeService fndUomTypeService;
	
	@RequestMapping("/uom/type/query")
	@ResponseBody
	public ResponseData selectByQuery(HttpServletRequest request,final FndUomType fndUomType, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
		IRequest iRequest=createRequestContext(request);
//		List<FndUomType> list = fndUomTypeService.selectAll(iRequest);
		PageHelper.startPage(page, pagesize);
		List<FndUomType> list = fndUomTypeService.selectByQuery(fndUomType);
		return new ResponseData(list);
	}
	
	
	@RequestMapping(value="/uom/type/submit")
	@ResponseBody
	public ResponseData submit(HttpServletRequest request,@RequestBody List<FndUomType> lists)throws TokenException {
		ResponseData rd = null;
		try {
		IRequest iRequest =createRequestContext(request);
		List<FndUomType> list = fndUomTypeService.batchUpdate(iRequest, lists);
		return new ResponseData(list);
		}catch (Exception e) {
			rd = new ResponseData(false);
			rd.setMessage("计量单位类型代码不可重复！");
			return rd;
		}
	}
	
	
	@RequestMapping(value="/uom/type/remove")
	@ResponseBody
	public ResponseData remove(@RequestBody List<FndUomType> Lists){
		fndUomTypeService.batchDelete(Lists);
		return new  ResponseData();
	}
}
