package hls.core.fnd.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.FndWorkCalendar;
import hls.core.fnd.service.IFndWorkCalendarService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import org.springframework.validation.BindingResult;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

    @Controller
    public class FndWorkCalendarController extends BaseController{

    @Autowired
    private IFndWorkCalendarService service;


    @RequestMapping(value = "/fnd/work/calendar/query")
    @ResponseBody
    public ResponseData query(FndWorkCalendar dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) throws ParseException {
        IRequest requestContext = createRequestContext(request);


        DateFormat dateFormat1 = new SimpleDateFormat("yyyy-MM-dd");
        Date myDate1 = dateFormat1.parse("2017-11-26");
        Date f  = service.CalendarDayAdjust(myDate1,"FORWARD");
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/fnd/work/calendar/submit")
    @ResponseBody
public ResponseData update(@RequestBody List<FndWorkCalendar> dto, BindingResult result, HttpServletRequest request){
getValidator().validate(dto, result);
if (result.hasErrors()) {
ResponseData responseData = new ResponseData(false);
responseData.setMessage(getErrorMessage(result, request));
return responseData;
}
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/fnd/work/calendar/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<FndWorkCalendar> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }