package hls.core.fnd.controllers;


import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.core.exception.TokenException;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.fnd.dto.HLSCurrency;
import hls.core.fnd.service.HLSCurrencyService;
import hls.core.hls.dto.BusinessCategory;
import hls.core.hls.service.IBusinessCgService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created by hailor on 16/6/2.
 */
@Controller
public class HLSCurrencyController  extends BaseController{

    @Autowired
    private HLSCurrencyService iLSCurrencyService;

    @RequestMapping("/hls_currency/query")
    @ResponseBody
    public ResponseData selectList(HttpServletRequest request,HLSCurrency condition,
                                   @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {
        IRequest iRequest = createRequestContext(request);
        condition.setEnabledFlag("Y");//查询启用的币种
       // System.out.println("111111");
        List<HLSCurrency> datas = iLSCurrencyService.select(iRequest, condition, page, pagesize);
        return new ResponseData(datas);
    }
    
    @RequestMapping(value = "/hls_currency/by/query", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData selectByQuery(HttpServletRequest request, final HLSCurrency condition,
                                   @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
        IRequest iRequest = createRequestContext(request);
       // System.out.println("111111");
        PageHelper.startPage(page, pagesize);
        List<HLSCurrency> datas = iLSCurrencyService.selectByQuery(condition,page,pagesize);
        return new ResponseData(datas);
    }

    @RequestMapping(value = "/hls_currency/submit", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData submit(HttpServletRequest request, @RequestBody List<HLSCurrency> demos)throws TokenException {
        ResponseData rd = null;
        try {
        IRequest iRequest = createRequestContext(request);
        List<HLSCurrency> datas = iLSCurrencyService.batchUpdate(iRequest, demos);
        return new ResponseData(datas);
        }catch (Exception e) {
            rd = new ResponseData(false);
            rd.setMessage("币种不可重复！");
            return rd;
        }
    }

    @RequestMapping(value = "/hls_currency/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HLSCurrency> demos) {
        IRequest iRequest = createRequestContext(request);
        iLSCurrencyService.batchDelete(demos);
        return new ResponseData();
    }
}
