package hls.core.fnd.controllers;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.HlsConFileTemplet;
import hls.core.fnd.service.HlsConFileTempletService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class HlsConFileTempletController extends BaseController {

    @Autowired
    HlsConFileTempletService hlsConFileTempletService;

    @RequestMapping(value = "/fnd/hlsconfiletemplet/query")
    @ResponseBody
    public ResponseData query(final HlsConFileTemplet hlsConFileTemplet, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(hlsConFileTempletService.selectList(hlsConFileTemplet));
    }

    @RequestMapping(value = "/fnd/hlsconfiletemplet/submit")
    @ResponseBody
    public ResponseData submit(@RequestBody final List<HlsConFileTemplet> hlsConFileTemplet, final BindingResult result,
                               final HttpServletRequest request){
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(hlsConFileTempletService.batchUpdate(requestContext, hlsConFileTemplet));
    }

    @RequestMapping(value = "/fnd/hlsconfiletemplet/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsConFileTemplet> hlsConFileTemplet) {
        hlsConFileTempletService.batchDelete(hlsConFileTemplet);
        return new ResponseData();
    }

}
