package hls.core.fnd.controllers;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.fnd.dto.HLSCurrency;
import hls.core.fnd.dto.HlsContact;
import hls.core.fnd.service.HlsContactService;

/**
 * Created by jianwen.zheng on 2017年3月14日
 */
@Controller
public class HlsContactController extends BaseController{

	@Autowired
	private HlsContactService contactService;
	
	/**
	 * 查询所有反馈信息
	 * @param contact
	 * @param page
	 * @param pagesize
	 * @param request
	 * @return
	 */
	@RequestMapping(value = "/fnd/hlsContact/query")
	@ResponseBody
	public ResponseData select(final HlsContact contact, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		List<HlsContact> list = contactService.selectAllHlsContact(createRequestContext(request), contact);
		return new ResponseData(list);
	}
	/**
	 * 保存反馈
	 * @param request
	 * @param contacts
	 * @return
	 */
	@RequestMapping(value = "/fnd/hlsContact/submit")
	@ResponseBody
	public Long submit(HttpServletRequest request, @RequestBody List<HlsContact> contacts) {
        IRequest iRequest = createRequestContext(request) ;
        Long contactId = contactService.saveSubmit(iRequest,contacts);
        return contactId;
	}
}
