package hls.core.fnd.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.HlsDocFileParaTable;
import hls.core.fnd.service.HlsDocFileParaTableService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: Jeffery
 * Date: 2017/4/19
 * Time: 21:09
 * To change this template use File | Settings | File Templates.
 */
@Controller
public class HlsDocFileParaTableController  extends BaseController {

    @Autowired
    HlsDocFileParaTableService HlsDocFileParaTableService;
    /**
     * Created with IntelliJ IDEA.
     * User: Jeffery
     * Date: 2017/4/18
     * Time: 15:30
     * To change this template use File | Settings | File Templates.
     * Com:合同模板参数定义页面列配置数据查询
     */
    @RequestMapping(value = "/con/hlsdocfileparatable/selectAll")
    @ResponseBody
    public ResponseData selecetListForTable(final HlsDocFileParaTable HlsDocFileParaTable,
                                            @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize,
                                            final HttpServletRequest request) {
        IRequest iRequest = createRequestContext(request) ;
        List<HlsDocFileParaTable> list = HlsDocFileParaTableService.selectList(HlsDocFileParaTable);
        HlsDocFileParaTable delTable = new HlsDocFileParaTable();
        return new ResponseData(list);
    }

    /**
     * Created with IntelliJ IDEA.
     * User: Jeffery
     * Date: 2017/4/18
     * Time: 15:30
     * To change this template use File | Settings | File Templates.
     * Com:合同模板参数定义页面列配置数据添加或更新
     */
    @RequestMapping(value = "/con/hlsdocfileparatable/addCon")
    @ResponseBody
    public ResponseData addCon(HttpServletRequest request, @RequestBody List<HlsDocFileParaTable> contacts, final BindingResult result) {
        IRequest iRequest = createRequestContext(request) ;
        getValidator().validate(contacts, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(HlsDocFileParaTableService.batchUpdate(requestContext, contacts));
    }

    /**
     * Created with IntelliJ IDEA.
     * User: Jeffery
     * Date: 2017/4/18
     * Time: 15:30
     * To change this template use File | Settings | File Templates.
     * Com:合同模板参数定义页面列配置数据删除
     */
    @RequestMapping(value = "/con/hlsdocfileparatable/delCon", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData deleteCon(HttpServletRequest request, @RequestBody List<HlsDocFileParaTable> contacts) {
        HlsDocFileParaTableService.batchDelete(contacts);
        return new ResponseData();
    }
}
