package hls.core.fnd.controllers;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.HlsDocFileTemplet;
import hls.core.fnd.service.HlsDocFileTempletService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class HlsDocFileTempletController extends BaseController {

    @Autowired
    HlsDocFileTempletService hlsDocFileTempletService;

    @RequestMapping(value = "/fnd/hlsdocfiletemplet/query")
    @ResponseBody
    public ResponseData query(final HlsDocFileTemplet hlsDocFileTemplet, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(hlsDocFileTempletService.selectList(requestContext,hlsDocFileTemplet,page,pagesize));
    }

    @RequestMapping(value = "/fnd/hlsdocfiletemplet/submit")
    @ResponseBody
    public ResponseData submit(@RequestBody final List<HlsDocFileTemplet> hlsDocFileTemplet, final BindingResult result,
                               final HttpServletRequest request){
        getValidator().validate(hlsDocFileTemplet, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(hlsDocFileTempletService.batchUpdate(requestContext, hlsDocFileTemplet));
    }

    @RequestMapping(value = "/fnd/hlsdocfiletemplet/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsDocFileTemplet> hlsDocFileTemplet) {
        hlsDocFileTempletService.batchDelete(hlsDocFileTemplet);

        return new ResponseData();
    }

    @RequestMapping(value = "/con/hlsdocfiletemplet/sign/submit")
    @ResponseBody
    public HlsDocFileTemplet signSubmit(HlsDocFileTemplet hlsDocFileTemplet, final BindingResult result,
                                            final HttpServletRequest request){

        IRequest requestContext = createRequestContext(request);
        return hlsDocFileTempletService.signSubmit(requestContext, hlsDocFileTemplet);
    }

}
