package hls.core.fnd.controllers;


import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.HlsDocFileTempletPara;
import hls.core.fnd.dto.HlsDocFileTmpParaLink;
import hls.core.fnd.service.HlsDocFileTempletParaService;
import hls.core.fnd.service.HlsDocFileTmpParaLinkService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class HlsDocFileTempletParaController extends BaseController {

    @Autowired
    HlsDocFileTempletParaService hlsDocFileTempletParaService;
    @Autowired
    HlsDocFileTmpParaLinkService hlsDocFileTmpParaLinkService;

    @RequestMapping(value = "/fnd/hlsDocFileTempletPara/submit")
    @ResponseBody
    public ResponseData submit(@RequestBody final List<HlsDocFileTempletPara> hlsDocFileTempletPara, final BindingResult result,
                               final HttpServletRequest request){
        getValidator().validate(hlsDocFileTempletPara, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(hlsDocFileTempletParaService.batchUpdate(requestContext, hlsDocFileTempletPara));
    }

    @RequestMapping(value = "/fnd/hlsDocFileTempletPara/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsDocFileTempletPara> hlsDocFileTempletPara) {
        hlsDocFileTempletParaService.batchDelete(hlsDocFileTempletPara);

        return new ResponseData();
    }

    /**
     * Created with IntelliJ IDEA.
     * User: Jeffery
     * Date: 2017/4/18
     * Time: 15:30
     * To change this template use File | Settings | File Templates.
     * Com:文件模板参数定义页面数据查询
     */
    @RequestMapping(value = "/con/hlsdocfiletemp/selectAll")
    @ResponseBody
    public ResponseData selecetAll(final HlsDocFileTempletPara Hlsdocfiletempletpara,
                                   @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize,
                                   final HttpServletRequest request) {
        IRequest iRequest = createRequestContext(request) ;
        List<HlsDocFileTempletPara> list = hlsDocFileTempletParaService.selectList(Hlsdocfiletempletpara,page,pagesize);
        return new ResponseData(list);
    }
    /**
     * Created with IntelliJ IDEA.
     * User: Jeffery
     * Date: 2017/4/18
     * Time: 15:30
     * To change this template use File | Settings | File Templates.
     * Com:文件模板参数定义页面数据添加
     */
    @RequestMapping(value = "/con/hlsdocfiletemp/addCon")
    @ResponseBody
    public ResponseData addCon(HttpServletRequest request, @RequestBody List<HlsDocFileTempletPara> contacts, final BindingResult result) {
        IRequest iRequest = createRequestContext(request) ;
        getValidator().validate(contacts, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(hlsDocFileTempletParaService.batchUpdate(requestContext, contacts));
    }

    /**
     * Created with IntelliJ IDEA.
     * User: Jeffery
     * Date: 2017/4/18
     * Time: 15:30
     * To change this template use File | Settings | File Templates.
     * Com:文件模板参数定义页面数据删除
     */
    @RequestMapping(value = "/con/hlsdocfiletemp/delCon", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData deleteCon(HttpServletRequest request, @RequestBody List<HlsDocFileTempletPara> contacts) {
        HlsDocFileTmpParaLink hlsDocFileTmpParaLink = new HlsDocFileTmpParaLink();
        hlsDocFileTmpParaLink.setTempletParaId(contacts.get(0).getTempletParaId());
        List<HlsDocFileTmpParaLink> list =  hlsDocFileTmpParaLinkService.queryTemParLinkByParId(hlsDocFileTmpParaLink);
        ResponseData rd = null;
        if(list.size()==0){
            hlsDocFileTempletParaService.batchDelete(contacts);
        }else {
            rd = new ResponseData(false);
            rd.setMessage("合同模板参数正在被使用中，删除失败");
        }
        return rd;
    }

}

