package hls.core.fnd.controllers;


import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.HlsDocFileTmpParaLink;
import hls.core.fnd.service.HlsDocFileTmpParaLinkService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class HlsDocFileTmpParaLinkController extends BaseController {

    @Autowired
    HlsDocFileTmpParaLinkService hlsDocFileTmpParaLinkService;

    @RequestMapping(value = "/fnd/hlsDocFileTmpParaLink/query")
    @ResponseBody
    public ResponseData query(final HlsDocFileTmpParaLink hlsDocFileTmpParaLink, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request) {
//        IRequest requestContext = createRequestContext(request);
//        return new ResponseData(hlsDocFileTmpParaLinkService.selectList(hlsDocFileTmpParaLink));
        IRequest iRequest = createRequestContext(request);
        List<HlsDocFileTmpParaLink> datas = hlsDocFileTmpParaLinkService.selectList(iRequest, hlsDocFileTmpParaLink,page, pagesize);
        return new ResponseData(datas);
    }

    @RequestMapping("/fnd/hlsDocFileTmpParaLink/queryLov")
    @ResponseBody
    public ResponseData queryLov(HttpServletRequest request,HlsDocFileTmpParaLink hlsDocFileTmpParaLink,
                                 @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                 @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {
        String bm_description = hlsDocFileTmpParaLink.getBookmarkDescription();
        String b_mark = hlsDocFileTmpParaLink.getBookmark();
        List<HlsDocFileTmpParaLink> datas = hlsDocFileTmpParaLinkService.queryLov(bm_description, b_mark);
        return new ResponseData(datas);
    }

    @RequestMapping(value = "/fnd/hlsDocFileTmpParaLink/submit")
    @ResponseBody
    public ResponseData submit(@RequestBody final List<HlsDocFileTmpParaLink> hlsDocFileTmpParaLink,
                               final HttpServletRequest request){
        ResponseData rd = null;
        try {
            IRequest iRequest = createRequestContext(request);
            List<HlsDocFileTmpParaLink> datas = hlsDocFileTmpParaLinkService.batchUpdate(iRequest, hlsDocFileTmpParaLink);
            rd = new ResponseData(datas);
        } catch (Exception e) {
            // TODO: handle exception
            rd = new ResponseData(false);
            rd.setMessage("不可分配重复的参数");
        }


        return rd;

//        IRequest requestContext = createRequestContext(request);
//        return new ResponseData(hlsDocFileTmpParaLinkService.batchUpdate(requestContext, hlsDocFileTmpParaLink));
    }

    @RequestMapping(value = "/fnd/hlsDocFileTmpParaLink/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsDocFileTmpParaLink> hlsDocFileTmpParaLink) {
        hlsDocFileTmpParaLinkService.batchDelete(hlsDocFileTmpParaLink);

        return new ResponseData();
    }
}
