package hls.core.fnd.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.HlsDocumentType;
import hls.core.fnd.service.HlsDocumentTypeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import org.springframework.validation.BindingResult;
import java.util.List;

    @Controller
    public class HlsDocumentTypeController extends BaseController{

    @Autowired
    private HlsDocumentTypeService service;


    @RequestMapping(value = "/hls/document/type/query")
    @ResponseBody
    public ResponseData query(HlsDocumentType dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }
    @RequestMapping(value = "/hls/document/documentType/query")
    @ResponseBody
    public ResponseData queryDocumentType(@RequestBody HlsDocumentType dto, HttpServletRequest request) {
           // IRequest requestContext = createRequestContext(request);
            return new ResponseData(service.queryDocumentTypeInfo(dto));
    }
    @RequestMapping(value = "/hls/document/businessType/query")
    @ResponseBody
    public ResponseData queryBusinessType(@RequestBody HlsDocumentType dto,HttpServletRequest request) {
           // IRequest requestContext = createRequestContext(request);
            return new ResponseData(service.queryBusinessTypeInfo(dto));
    }

    @RequestMapping(value = "/hls/document/type/submit")
    @ResponseBody
public ResponseData update(@RequestBody List<HlsDocumentType> dto, BindingResult result, HttpServletRequest request){
getValidator().validate(dto, result);
if (result.hasErrors()) {
ResponseData responseData = new ResponseData(false);
responseData.setMessage(getErrorMessage(result, request));
return responseData;
}
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/hls/document/type/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsDocumentType> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }