package hls.core.fnd.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.HlsFinStatementHd;
import hls.core.fnd.dto.HlsFinStatementLn;
import hls.core.fnd.dto.HlsFinStatementTmpltLn;
import hls.core.fnd.service.HlsFinStatementHdService;
import hls.core.fnd.service.HlsFinStatementLnService;
import org.apache.http.HttpRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;
import java.util.Map;

/**
 * Created by haibin on 2017/6/27.
 */
@Controller
public class HlsFinStatementHdController extends BaseController{
    @Autowired
    private HlsFinStatementHdService hlsFinStatementHdService;
    @Autowired
    private HlsFinStatementLnService hlsFinStatementLnService;

    @RequestMapping(value="/fnd/excel/query")
    @ResponseBody
    public ResponseData excelQuery(HlsFinStatementTmpltLn hlsFinStatementTmpltLn,
                                    @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                    @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize){
        List list=hlsFinStatementHdService.getList(hlsFinStatementTmpltLn,page,pagesize);
        return new ResponseData(list);
    }
    @RequestMapping(value="/fnd/clounm/query")
    @ResponseBody
    public ResponseData getClounm(HlsFinStatementTmpltLn hlsFinStatementTmpltLn){
        List<Map<String,String>> list=hlsFinStatementHdService.getClounm(hlsFinStatementTmpltLn);
        return new ResponseData(list);
    }

    @RequestMapping(value="/fnd/statement/submit")
    @ResponseBody
    public ResponseData statementSubmit(HttpServletRequest request, HttpSession session, HlsFinStatementTmpltLn hlsFinStatementTmpltLn){
        IRequest iRequest = createRequestContext(request);
        Long companyId=(Long) session.getAttribute("companyId");
        hlsFinStatementTmpltLn.setCompanyId(companyId);
        Boolean b=hlsFinStatementHdService.statementSubmit(iRequest,hlsFinStatementTmpltLn);
        return new ResponseData(b);
    }
    @RequestMapping(value="/fnd/hd/query")
    @ResponseBody
    public ResponseData hdQuery(HlsFinStatementHd hlsFinStatementHd,
                                @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize){
        List<HlsFinStatementHd> list=hlsFinStatementHdService.hdQuery(hlsFinStatementHd,page,pagesize);
        return new ResponseData(list);
    }

    @RequestMapping(value="/fnd/hd/guaran/query")
    @ResponseBody
    public ResponseData hdGuaranQuery(HlsFinStatementHd hlsFinStatementHd,
                                @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize){
        List<HlsFinStatementHd> list=hlsFinStatementHdService.hdGuaranQuery(hlsFinStatementHd,page,pagesize);
        return new ResponseData(list);
    }
    @RequestMapping(value="/fnd/hd/cloumnQuery")
    @ResponseBody
    public ResponseData hdCloumnQuery(HlsFinStatementHd hlsFinStatementHd){
        List<HlsFinStatementHd> list=hlsFinStatementHdService.hdColumnQuery(hlsFinStatementHd);
        return new ResponseData(list);
    }
    @RequestMapping(value="/fnd/ln/query")
    @ResponseBody
    public ResponseData lnQuery(HlsFinStatementLn hlsFinStatementLn,
                                @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize){
        List<HlsFinStatementLn> list=hlsFinStatementLnService.lnQuery(hlsFinStatementLn,page,pagesize);
        return new ResponseData(list);
    }
}
