package hls.core.fnd.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.HlsFinStatementTmpltHd;
import hls.core.fnd.dto.HlsFinStatementTmpltLn;
import hls.core.fnd.service.HlsFinStatementTmpltHdService;
import hls.core.fnd.service.HlsFinStatementTmpltLnService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

/**
 * Created by haibin on 2017/6/21.
 */
@Controller
public class HlsFinStatementTmpltHdController extends BaseController{
    @Autowired
    private HlsFinStatementTmpltHdService hlsFinStatementTmpltHdService;
    @Autowired
    private HlsFinStatementTmpltLnService finStatementTmpltLnService;

    @RequestMapping(value = "/fnd/FinStatement/query")
    @ResponseBody
    public ResponseData query(HttpServletRequest request, final HlsFinStatementTmpltHd hlsFinStatementTmpltHd,
                              @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize){
        IRequest iRequest = createRequestContext(request);
        List<HlsFinStatementTmpltHd> list= hlsFinStatementTmpltHdService.query(iRequest, hlsFinStatementTmpltHd,pagesize,page);
        return new ResponseData(list);
    }
    @RequestMapping(value = "/fnd/FinStatement/submit", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData submit(HttpSession session, HttpServletRequest request, @RequestBody List<HlsFinStatementTmpltHd> list) {
        IRequest iRequest = createRequestContext(request);
        Long companyId=(Long) session.getAttribute("companyId");
        for (HlsFinStatementTmpltHd hlsFinStatementTmpltHd :list ){
            hlsFinStatementTmpltHd.setCompanyId(companyId);
        }
        List<HlsFinStatementTmpltHd> datas = hlsFinStatementTmpltHdService.batchUpdate(iRequest, list);
        return new ResponseData(datas);
    }

    @RequestMapping(value = "/fnd/FinStatement/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsFinStatementTmpltHd> demos) {
        IRequest iRequest = createRequestContext(request);
        hlsFinStatementTmpltHdService.batchDelete(demos);
        return new ResponseData();
    }

    @RequestMapping(value = "/fnd/statementTmpltLn/query")
    @ResponseBody
    public ResponseData queryLn(HttpServletRequest request,final HlsFinStatementTmpltLn hlsFinStatementTmpltLn,
                              @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize){
        IRequest iRequest = createRequestContext(request);
        List<HlsFinStatementTmpltLn> list= finStatementTmpltLnService.query(iRequest, hlsFinStatementTmpltLn,pagesize,page);
        return new ResponseData(list);
    }
    @RequestMapping(value = "/fnd/statementTmpltLn/submit", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData submitLn(HttpSession session, HttpServletRequest request, @RequestBody List<HlsFinStatementTmpltLn> list) {
        IRequest iRequest = createRequestContext(request);
        List<HlsFinStatementTmpltLn> datas = finStatementTmpltLnService.batchUpdate(iRequest, list);
        return new ResponseData(datas);
    }

    @RequestMapping(value = "/fnd/statementTmpltLn/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData deleteLn(HttpServletRequest request, @RequestBody List<HlsFinStatementTmpltLn> demos) {
        IRequest iRequest = createRequestContext(request);
        finStatementTmpltLnService.batchDelete(demos);
        return new ResponseData();
    }

}
