package hls.core.fnd.controllers;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.cont.service.ConContractService;
import hls.core.fnd.dto.HlsInvoiceProfile;
import hls.core.fnd.dto.HlsPenaltyProfile;
import hls.core.fnd.service.HlsInvoiceProfileService;
import hls.core.fnd.service.HlsPenaltyProfileService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class HlsInvoiceProfileController extends BaseController {
    @Autowired
    HlsInvoiceProfileService hlsInvoiceProfileService;
    @Autowired
    ConContractService conContractService;
    @RequestMapping(value = "/fnd/HlsInvoiceProfile/query")
    @ResponseBody
    public ResponseData query(final HlsInvoiceProfile hlsInvoiceProfile, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        hlsInvoiceProfile.setCompanyId(requestContext.getCompanyId());
        return new ResponseData(hlsInvoiceProfileService.select(requestContext,hlsInvoiceProfile,page,pagesize));
    }
    @RequestMapping(value = "/fnd/HlsInvoiceProfile/submit")
    @ResponseBody
    public ResponseData submit(@RequestBody final List<HlsInvoiceProfile> hlsInvoiceProfiles, final BindingResult result,
                               final HttpServletRequest request){
        IRequest requestContext = createRequestContext(request);
        for (int i=0;i<hlsInvoiceProfiles.size(); i++){
            if(hlsInvoiceProfiles.get(i).getCompanyId() == null){
             hlsInvoiceProfiles.get(i).setCompanyId(new Long(requestContext.getCompanyId()));
            }
        }
        return new ResponseData(hlsInvoiceProfileService.batchUpdate(requestContext, hlsInvoiceProfiles));
    }
    @RequestMapping(value = "/fnd/HlsInvoiceProfile/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsInvoiceProfile> hlsInvoiceProfiles) {
        hlsInvoiceProfileService.deleteInvoiceProfile(hlsInvoiceProfiles);
        return new ResponseData();
    }
}
