package hls.core.fnd.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.HlsInvoiceProfileDtl;
import hls.core.fnd.service.HlsInvoiceProfileDtlService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class HlsInvoiceProfileDtlController extends BaseController {

    @Autowired
    HlsInvoiceProfileDtlService hlsInvoiceProfileDtlService;

    @RequestMapping(value = "/fnd/HlsInvoiceProfileDtl/query")
    @ResponseBody
    public ResponseData query(final HlsInvoiceProfileDtl hlsInvoiceProfileDtl, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(hlsInvoiceProfileDtlService.select(requestContext, hlsInvoiceProfileDtl, page, pagesize));
    }

    @RequestMapping(value = "/fnd/HlsInvoiceProfileDtl/submit", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData submit(@RequestBody final List<HlsInvoiceProfileDtl> hlsInvoiceProfileDtls, final BindingResult result,
                               final HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        getValidator().validate(hlsInvoiceProfileDtls, result);
        if (result.hasErrors()) {
            ResponseData rd = new ResponseData(false);
            rd.setMessage(getErrorMessage(result, request));
            return rd;
        }
        return new ResponseData(hlsInvoiceProfileDtlService.batchUpdate(requestContext, hlsInvoiceProfileDtls));
    }

    @RequestMapping(value = "/fnd/HlsInvoiceProfileDtl/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsInvoiceProfileDtl> hlsInvoiceProfileDtls) {
        hlsInvoiceProfileDtlService.batchDelete(hlsInvoiceProfileDtls);
        return new ResponseData();
    }
}
