package hls.core.fnd.controllers;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.cont.service.ConContractService;
import hls.core.fnd.dto.HlsPenaltyProfile;
import hls.core.fnd.service.HlsPenaltyProfileService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class HlsPenaltyProfileController extends BaseController {

    @Autowired
    HlsPenaltyProfileService hlsPenaltyProfileService;

    @Autowired
    ConContractService conContractService;

    @RequestMapping(value = "/fnd/HlsPenaltyProfile/query")
    @ResponseBody
    public ResponseData query(final HlsPenaltyProfile hlsPenaltyProfile, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(hlsPenaltyProfileService.selectList(requestContext,hlsPenaltyProfile));
    }

    @RequestMapping(value = "/fnd/HlsPenaltyProfile/submit")
    @ResponseBody
    public ResponseData submit(@RequestBody final List<HlsPenaltyProfile> hlsPenaltyProfile, final BindingResult result,
                               final HttpServletRequest request){
        IRequest requestContext = createRequestContext(request);
        for (int i=0;i<hlsPenaltyProfile.size(); i++){
             hlsPenaltyProfile.get(i).setCompanyId(requestContext.getCompanyId());
        }
        return new ResponseData(hlsPenaltyProfileService.batchUpdate(requestContext, hlsPenaltyProfile));
    }

    @RequestMapping(value = "/fnd/HlsPenaltyProfile/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsPenaltyProfile> hlsPenaltyProfile) {
        hlsPenaltyProfileService.deletePenaltyProfile(hlsPenaltyProfile);
        return new ResponseData();
    }


}
