package hls.core.fnd.controllers;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.HlsPenaltyProfileDtl;
import hls.core.fnd.service.HlsPenaltyProfileDtlService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class HlsPenaltyProfileDtlController extends BaseController {

    @Autowired
    HlsPenaltyProfileDtlService hlsPenaltyProfileDtlService;

    @RequestMapping(value = "/fnd/HlsPenaltyProfileDtl/query")
    @ResponseBody
    public ResponseData query(final HlsPenaltyProfileDtl hlsPenaltyProflieDtl, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(hlsPenaltyProfileDtlService.selectList(requestContext,hlsPenaltyProflieDtl));
    }

    @RequestMapping(value = "/fnd/HlsPenaltyProfileDtl/submit")
    @ResponseBody
    public ResponseData submit(@RequestBody final List<HlsPenaltyProfileDtl> hlsPenaltyProflieDtl, final BindingResult result,
                               final HttpServletRequest request){
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(hlsPenaltyProfileDtlService.batchUpdate(requestContext, hlsPenaltyProflieDtl));
    }

    @RequestMapping(value = "/fnd/HlsPenaltyProfileDtl/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsPenaltyProfileDtl> hlsPenaltyProflieDtl) {
        hlsPenaltyProfileDtlService.batchDelete(hlsPenaltyProflieDtl);

        return new ResponseData();
    }

    /*@RequestMapping(value = "/con/hlsdocfiletemplet/sign/submit")
    @ResponseBody
    public HlsPenaltyProfile signSubmit(HlsPenaltyProfile hlsPenaltyProfile, final BindingResult result,
                                            final HttpServletRequest request){

        IRequest requestContext = createRequestContext(request);
        return hlsPenaltyProfileService.signSubmit(requestContext, hlsPenaltyProfile);
    }*/

}
