package hls.core.fnd.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.PrjMeetingJudge;
import hls.core.fnd.service.PrjMeetingJudgeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

/**
 * Created by 罗宇娟 on 2017/5/11.
 */

@Controller
public class PrjMeetingJudgeController extends BaseController{

    @Autowired
    private PrjMeetingJudgeService prjMeetingJudgeService;

    @RequestMapping("/fnd/prjmeetingjudge/query")
    @ResponseBody
    public ResponseData selectDetail(HttpServletRequest request, final PrjMeetingJudge prjMeetingJudge, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                     @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize){
        IRequest iRequest = createRequestContext(request);
        List<PrjMeetingJudge> datas = prjMeetingJudgeService.selectList(iRequest,prjMeetingJudge,page,pagesize);
        return new ResponseData(datas);
    }

    @RequestMapping("/fnd/prjmeetingjudge/submit")
    @ResponseBody
    public ResponseData submit(HttpServletRequest request, @RequestBody List<PrjMeetingJudge> prjMeetingJudge){
        IRequest iRequest = createRequestContext(request);
        return new ResponseData(prjMeetingJudgeService.batchUpdate(iRequest, prjMeetingJudge));


    }

    @RequestMapping("/fnd/prjmeetingjudge/delete")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<PrjMeetingJudge> prjMeetingJudge,final HttpSession session) {
        IRequest iRequest = createRequestContext(request);
        prjMeetingJudgeService.delete(iRequest,prjMeetingJudge);

        return new ResponseData();
    }



}
