package hls.core.fnd.dto;

import java.util.Date;
import java.util.List;

import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.hand.hap.core.annotation.Children;
import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;

@SuppressWarnings("serial")
@ExtensionAttribute(disable=true)
@Table(name="fnd_base_rate_set")
public class FndBaseRateSet extends BaseDTO{

	
	@Children
	@Transient
	private List<FndBaseRate> fndBaseRate;
	
	@Transient
	private Date typeCount;
	
	public Date getTypeCount() {
		return typeCount;
	}
	public void setTypeCount(Date typeCount) {
		this.typeCount = typeCount;
	}
	public List<FndBaseRate> getFndBaseRate() {
		return fndBaseRate;
	}
	public void setFndBaseRate(List<FndBaseRate> fndBaseRate) {
		this.fndBaseRate = fndBaseRate;
	}
	public String getBase_rate_set() {
		return base_rate_set;
	}
	public void setBase_rate_set(String base_rate_set) {
		this.base_rate_set = base_rate_set;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public String getBase_rate_type() {
		return base_rate_type;
	}
	public void setBase_rate_type(String base_rate_type) {
		this.base_rate_type = base_rate_type;
	}
	public String getCurrency() {
		return currency;
	}
	public void setCurrency(String currency) {
		this.currency = currency;
	}
	public String getEnabled_flag() {
		return enabled_flag;
	}
	public void setEnabled_flag(String enabled_flag) {
		this.enabled_flag = enabled_flag;
	}
	public Date getValid_from() {
		return valid_from;
	}
	public void setValid_from(Date valid_from) {
		this.valid_from = valid_from;
	}
	public Date getValid_to() {
		return valid_to;
	}
	public void setValid_to(Date valid_to) {
		this.valid_to = valid_to;
	}
	@Id
	private String base_rate_set;
	private String description;
	private String base_rate_type;
	private String currency;
	private String enabled_flag;
	private Date valid_from;
	private Date valid_to;
    @Transient
	private String currencyName;//货币描述
     @Transient
	 private String addFlag;//表示是否新增的标志
    @Transient
	private String baseRateSetOld;//旧的主键
	@Transient
	private Long loanTerm;//融资期限
	@Transient
	private Double baseRate;//基础利率

	public Double getBaseRate() {
		return baseRate;
	}

	public void setBaseRate(Double baseRate) {
		this.baseRate = baseRate;
	}

	public Long getLoanTerm() {
		return loanTerm;
	}

	public void setLoanTerm(Long loanTerm) {
		this.loanTerm = loanTerm;
	}

	public String getBaseRateSetOld() {
		return baseRateSetOld;
	}

	public void setBaseRateSetOld(String baseRateSetOld) {
		this.baseRateSetOld = baseRateSetOld;
	}

	public String getAddFlag() {
		return addFlag;
	}

	public void setAddFlag(String addFlag) {
		this.addFlag = addFlag;
	}

	public String getCurrencyName() {
		return currencyName;
	}

	public void setCurrencyName(String currencyName) {
		this.currencyName = currencyName;
	}

	@Override
	public String toString() {
		return "FndBaseRateSet [fndBaseRate=" + fndBaseRate + ", base_rate_set=" + base_rate_set + ", description="
				+ description + ", base_rate_type=" + base_rate_type + ", currency=" + currency + ", enabled_flag="
				+ enabled_flag + ", valid_from=" + valid_from + ", valid_to=" + valid_to + "]";
	}


	
	
	
	
	
	
}
