package hls.core.fnd.dto;

import java.util.Date;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.hand.hap.mybatis.annotation.Condition;
import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;

/**
 * @Title: FndCompanyB
 * @Description:  公司 
 */
@SuppressWarnings("serial")
@ExtensionAttribute(disable = true)
@Table(name = "fnd_company")
public class FndCompany extends BaseDTO {
	@Id
	@GeneratedValue
	private Long company_id;  //公司	ID
	@Condition(operator = LIKE)
	private String company_code; //公司代码
	@Condition(operator = LIKE)
	private String company_short_name; //公司简称
	@Condition(operator = LIKE)
	private String company_full_name; //公司全称
	private String company_type; 	//公司类型
	private String parent_company_id; 	//上级公司ID
	@Transient
	private String parent_company_name;//上级公司名称
	private String business_scope; //经营范围
	private String address; //地址
	private String zipcode; //邮编
	private String fax;//传真
	private String phone;//电话
	private String contact_person;//联系人
	private String enabled_flag;//启用标志
	private String enterprise_unified_credit_code;//统一社会代码
	private String registered_capital;// 注册资本
	private String legalRepresentative;//法定代表人
	private Date establishment_date;//成立时间
	private Date operatingPeriodFrom;// 经营期限开始时间
	private Date operating_period_to;//经营期限结束时间
	private String basic_account_bank;//基本账户行
	private String basic_account_number;//基本账户码
	@Transient
	private String newCompany_code;//新建公司代码
	@Transient
	private String newCompany_name;//新建公司名称
	@Transient
	private String unit;
	@Transient
	private String quarters;
	@Transient
	private String employee;
	@Transient
	private String companyLovName;
	@Transient
	private String companyLovCode;
	@Transient
	private Long companyId;


	@Transient
	private String authorityRuleFlag;

	public String getAuthorityRuleFlag() {
		return authorityRuleFlag;
	}

	public void setAuthorityRuleFlag(String authorityRuleFlag) {
		this.authorityRuleFlag = authorityRuleFlag;
	}

	public Long getCompanyId() {
		return companyId;
	}

	public void setCompanyId(Long companyId) {
		this.companyId = companyId;
	}

	/**
	 * @return the companyLovCode
	 */
	public String getCompanyLovCode() {
		return companyLovCode;
	}

	/**
	 * @param companyLovCode the companyLovCode to set
	 */
	public void setCompanyLovCode(String companyLovCode) {
		this.companyLovCode = companyLovCode;
	}

	/**
	 * @return the companyLovName
	 */
	public String getCompanyLovName() {
		return companyLovName;
	}

	/**
	 * @param companyLovName the companyLovName to set
	 */
	public void setCompanyLovName(String companyLovName) {
		this.companyLovName = companyLovName;
	}

	/**
	 * @return the unit
	 */
	public String getUnit() {
		return unit;
	}

	/**
	 * @return the newCompany_code
	 */
	public String getNewCompany_code() {
		return newCompany_code;
	}
	/**
	 * @param newCompany_code the newCompany_code to set
	 */
	public void setNewCompany_code(String newCompany_code) {
		this.newCompany_code = newCompany_code;
	}
	/**
	 * @return the newCompany_name
	 */
	public String getNewCompany_name() {
		return newCompany_name;
	}
	/**
	 * @param newCompany_name the newCompany_name to set
	 */
	public void setNewCompany_name(String newCompany_name) {
		this.newCompany_name = newCompany_name;
	}
	/**
	 * @param unit the unit to set
	 */
	public void setUnit(String unit) {
		this.unit = unit;
	}

	/**
	 * @return the quarters
	 */
	public String getQuarters() {
		return quarters;
	}

	/**
	 * @param quarters the quarters to set
	 */
	public void setQuarters(String quarters) {
		this.quarters = quarters;
	}

	/**
	 * @return the employee
	 */
	public String getEmployee() {
		return employee;
	}

	/**
	 * @param employee the employee to set
	 */
	public void setEmployee(String employee) {
		this.employee = employee;
	}

	/**
	 * @return the parent_company_name
	 */
	public String getParent_company_name() {
		return parent_company_name;
	}

	/**
	 * @param parent_company_name the parent_company_name to set
	 */
	public void setParent_company_name(String parent_company_name) {
		this.parent_company_name = parent_company_name;
	}

	/**
	 * @return the basic_account_bank
	 */
	public String getBasic_account_bank() {
		return basic_account_bank;
	}

	/**
	 * @return the business_scope
	 */
	public String getBusiness_scope() {
		return business_scope;
	}



	/**
	 * @param business_scope the business_scope to set
	 */
	public void setBusiness_scope(String business_scope) {
		this.business_scope = business_scope;
	}



	/**
	 * @return the operating_period_to
	 */
	public Date getOperating_period_to() {
		return operating_period_to;
	}



	/**
	 * @param operating_period_to the operating_period_to to set
	 */
	public void setOperating_period_to(Date operating_period_to) {
		this.operating_period_to = operating_period_to;
	}



	/**
	 * @param basic_account_bank the basic_account_bank to set
	 */
	public void setBasic_account_bank(String basic_account_bank) {
		this.basic_account_bank = basic_account_bank;
	}

	/**
	 * @return the basic_account_number
	 */
	public String getBasic_account_number() {
		return basic_account_number;
	}

	/**
	 * @param basic_account_number the basic_account_number to set
	 */
	public void setBasic_account_number(String basic_account_number) {
		this.basic_account_number = basic_account_number;
	}

	/**
	 * @param address
	 *            the address to set
	 */
	public void setAddress(String address) {
		this.address = address;
	}

	/**
	 * @return the company_id
	 */
	public Long getCompany_id() {
		return company_id;
	}

	/**
	 * @param company_id
	 *            the company_id to set
	 */
	public void setCompany_id(Long company_id) {
		this.company_id = company_id;
	}

	/**
	 * @return the company_code
	 */
	public String getCompany_code() {
		return company_code;
	}

	/**
	 * @param company_code
	 *            the company_code to set
	 */
	public void setCompany_code(String company_code) {
		this.company_code = company_code;
	}

	/**
	 * @return the company_short_name
	 */
	public String getCompany_short_name() {
		return company_short_name;
	}

	/**
	 * @param company_short_name
	 *            the company_short_name to set
	 */
	public void setCompany_short_name(String company_short_name) {
		this.company_short_name = company_short_name;
	}

	/**
	 * @return the company_full_name
	 */
	public String getCompany_full_name() {
		return company_full_name;
	}

	/**
	 * @param company_full_name
	 *            the company_full_name to set
	 */
	public void setCompany_full_name(String company_full_name) {
		this.company_full_name = company_full_name;
	}

	/**
	 * @return the company_type
	 */
	public String getCompany_type() {
		return company_type;
	}

	/**
	 * @param company_type
	 *            the company_type to set
	 */
	public void setCompany_type(String company_type) {
		this.company_type = company_type;
	}

	/**
	 * @return the parent_company_id
	 */
	public String getParent_company_id() {
		return parent_company_id;
	}

	/**
	 * @param parent_company_id
	 *            the parent_company_id to set
	 */
	public void setParent_company_id(String parent_company_id) {
		this.parent_company_id = parent_company_id;
	}

	/**
	 * @return the zipcode
	 */
	public String getZipcode() {
		return zipcode;
	}

	/**
	 * @param zipcode
	 *            the zipcode to set
	 */
	public void setZipcode(String zipcode) {
		this.zipcode = zipcode;
	}

	/**
	 * @return the fax
	 */
	public String getFax() {
		return fax;
	}

	/**
	 * @param fax
	 *            the fax to set
	 */
	public void setFax(String fax) {
		this.fax = fax;
	}

	/**
	 * @return the phone
	 */
	public String getPhone() {
		return phone;
	}

	/**
	 * @param phone
	 *            the phone to set
	 */
	public void setPhone(String phone) {
		this.phone = phone;
	}

	/**
	 * @return the contact_person
	 */
	public String getContact_person() {
		return contact_person;
	}

	/**
	 * @param contact_person
	 *            the contact_person to set
	 */
	public void setContact_person(String contact_person) {
		this.contact_person = contact_person;
	}

	/**
	 * @return the enabled_flag
	 */
	public String getEnabled_flag() {
		return enabled_flag;
	}

	/**
	 * @param enabled_flag
	 *            the enabled_flag to set
	 */
	public void setEnabled_flag(String enabled_flag) {
		this.enabled_flag = enabled_flag;
	}

	/**
	 * @return the address
	 */
	public String getAddress() {
		return address;
	}

	/**
	 * @return the enterprise_unified_credit_code
	 */
	public String getEnterprise_unified_credit_code() {
		return enterprise_unified_credit_code;
	}

	/**
	 * @param enterprise_unified_credit_code
	 *            the enterprise_unified_credit_code to set
	 */
	public void setEnterprise_unified_credit_code(String enterprise_unified_credit_code) {
		this.enterprise_unified_credit_code = enterprise_unified_credit_code;
	}

	/**
	 * @return the registered_capital
	 */
	public String getRegistered_capital() {
		return registered_capital;
	}

	/**
	 * @param registered_capital
	 *            the registered_capital to set
	 */
	public void setRegistered_capital(String registered_capital) {
		this.registered_capital = registered_capital;
	}

	/**
	 * @return the legal_representative
	 */
	public String getLegalRepresentative() {
		return legalRepresentative;
	}

	/**
	 * @param legal_representative
	 *            the legal_representative to set
	 */
	public void setLegal_representative(String legalRepresentative) {
		this.legalRepresentative = legalRepresentative;
	}

	
	/**
	 * @return the establishment_date
	 */
	public Date getEstablishment_date() {
		return establishment_date;
	}

	/**
	 * @param establishment_date the establishment_date to set
	 */
	public void setEstablishment_date(Date establishment_date) {
		this.establishment_date = establishment_date;
	}

	/**
	 * @return the operatingPeriodFrom
	 */
	public Date getOperatingPeriodFrom() {
		return operatingPeriodFrom;
	}

	/**
	 * @param operatingPeriodFrom the operatingPeriodFrom to set
	 */
	public void setOperatingPeriodFrom(Date operatingPeriodFrom) {
		this.operatingPeriodFrom = operatingPeriodFrom;
	}

	/**
	 * @param legalRepresentative the legalRepresentative to set
	 */
	public void setLegalRepresentative(String legalRepresentative) {
		this.legalRepresentative = legalRepresentative;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "FndCompany [company_id=" + company_id + ", company_code=" + company_code + ", company_short_name="
				+ company_short_name + ", company_full_name=" + company_full_name + ", company_type=" + company_type
				+ ", parent_company_id=" + parent_company_id + ", parent_company_name=" + parent_company_name
				+ ", business_scope=" + business_scope + ", address=" + address + ", zipcode=" + zipcode + ", fax="
				+ fax + ", phone=" + phone + ", contact_person=" + contact_person + ", enabled_flag=" + enabled_flag
				+ ", enterprise_unified_credit_code=" + enterprise_unified_credit_code + ", registered_capital="
				+ registered_capital + ", legalRepresentative=" + legalRepresentative + ", establishment_date="
				+ establishment_date + ", operatingPeriodFrom=" + operatingPeriodFrom + ", operating_period_to="
				+ operating_period_to + ", basic_account_bank=" + basic_account_bank + ", basic_account_number="
				+ basic_account_number + ", unit=" + unit + ", quarters=" + quarters + ", employee=" + employee + "]";
	}
}
