package hls.core.fnd.dto;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.validation.constraints.NotNull;

import org.hibernate.validator.constraints.NotEmpty;

import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;
/**
 * 
 * @Title: HLSOrgUnit
 * @Description: 部门 
 *
 */
@SuppressWarnings("serial")
@ExtensionAttribute(disable=true)
@Table(name = "fnd_org_unit")
public class HLSOrgUnit extends BaseDTO{
	
	@Id
    @GeneratedValue
    private Long unitId;

	@NotNull
    private Long companyId;

	@NotEmpty
    private String unitCode;

	private String unitName;

    private String unitType;

    private Long parentUnitId;
    
    private Long chiefPositionId;

    @Transient
    private String parentUnitName;
    
    @Transient
    private String value;
    
    @Transient
    private String description;
    /**
	 * @return the chiefPositionId
	 */
	public Long getChiefPositionId() {
		return chiefPositionId;
	}

	/**
	 * @param chiefPositionId the chiefPositionId to set
	 */
	public void setChiefPositionId(Long chiefPositionId) {
		this.chiefPositionId = chiefPositionId;
	}

	public String getParentUnitName() {
		return parentUnitName;
	}

	public void setParentUnitName(String parentUnitName) {
		this.parentUnitName = parentUnitName;
	}

    public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}
	private String enabledFlag;

    public Long getUnitId() {
        return unitId;
    }

    public void setUnitId(Long unitId) {
        this.unitId = unitId;
    }

    public Long getCompanyId() {
        return companyId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public String getUnitCode() {
        return unitCode;
    }

    public void setUnitCode(String unitCode) {
        this.unitCode = unitCode == null ? null : unitCode.trim();
    }

    public String getUnitName() {
        return unitName;
    }

    public void setUnitName(String unitName) {
        this.unitName = unitName == null ? null : unitName.trim();
    }

    public String getUnitType() {
        return unitType;
    }

    public void setUnitType(String unitType) {
        this.unitType = unitType == null ? null : unitType.trim();
    }

    public Long getParentUnitId() {
        return parentUnitId;
    }

    public void setParentUnitId(Long parentUnitId) {
        this.parentUnitId = parentUnitId;
    }

    public String getEnabledFlag() {
        return enabledFlag;
    }

    public void setEnabledFlag(String enabledFlag) {
        this.enabledFlag = enabledFlag == null ? null : enabledFlag.trim();
    }
   
}