package hls.core.fnd.dto;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.validation.constraints.NotNull;

import org.hibernate.validator.constraints.NotEmpty;

import com.hand.hap.mybatis.annotation.Condition;
import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;
/**
 * 岗位
 * @Title: HLSPosition 
 *
 */
@SuppressWarnings("serial")
@ExtensionAttribute(disable=true)
@Table(name = "fnd_org_position")
public class HLSPosition extends BaseDTO{
	
	@Id
    @GeneratedValue
    private Long positionId;  //岗位ID
	@NotNull
    private Long unitId;  //部门ID
	@NotEmpty
	@Condition(operator = LIKE)
    private String positionCode;	//岗位代码
	@Condition(operator = LIKE)
    private String positionName;	//岗位名称
    private String chiefPositionFlag;//
	private String positionType;//	岗位类型
    private Long parentPositionId;//上级岗位ID
    private String enabledFlag;//	启用
    
    @Transient
    private String parentPositionName;
    @Transient
    private Long company_id;	//公司ID
    @Transient
    private String company_code;
    @Transient
    private String company_name;
    @Transient
    private Long unit_id;	//部门ID
    @Transient
    private String unit_code;
    @Transient
    private String unit_name;
    /**
	 * @return the company_id
	 */
	public Long getCompany_id() {
		return company_id;
	}

	/**
	 * @param company_id the company_id to set
	 */
	public void setCompany_id(Long company_id) {
		this.company_id = company_id;
	}

	/**
	 * @return the company_code
	 */
	public String getCompany_code() {
		return company_code;
	}

	/**
	 * @param company_code the company_code to set
	 */
	public void setCompany_code(String company_code) {
		this.company_code = company_code;
	}

	/**
	 * @return the company_name
	 */
	public String getCompany_name() {
		return company_name;
	}

	/**
	 * @param company_name the company_name to set
	 */
	public void setCompany_name(String company_name) {
		this.company_name = company_name;
	}

	/**
	 * @return the unit_id
	 */
	public Long getUnit_id() {
		return unit_id;
	}

	/**
	 * @param unit_id the unit_id to set
	 */
	public void setUnit_id(Long unit_id) {
		this.unit_id = unit_id;
	}

	/**
	 * @return the unit_code
	 */
	public String getUnit_code() {
		return unit_code;
	}

	/**
	 * @param unit_code the unit_code to set
	 */
	public void setUnit_code(String unit_code) {
		this.unit_code = unit_code;
	}

	/**
	 * @return the unit_name
	 */
	public String getUnit_name() {
		return unit_name;
	}

	/**
	 * @param unit_name the unit_name to set
	 */
	public void setUnit_name(String unit_name) {
		this.unit_name = unit_name;
	}

	public String getParentPositionName() {
		return parentPositionName;
	}

	public void setParentPositionName(String parentPositionName) {
		this.parentPositionName = parentPositionName;
	}

	public Long getPositionId() {
        return positionId;
    }

    public void setPositionId(Long positionId) {
        this.positionId = positionId;
    }
    
    public String getChiefPositionFlag() {
		return chiefPositionFlag;
	}

	public void setChiefPositionFlag(String chiefPositionFlag) {
		this.chiefPositionFlag = chiefPositionFlag;
	}

    public Long getUnitId() {
        return unitId;
    }

    public void setUnitId(Long unitId) {
        this.unitId = unitId;
    }

    public String getPositionCode() {
        return positionCode;
    }

    public void setPositionCode(String positionCode) {
        this.positionCode = positionCode == null ? null : positionCode.trim();
    }

    public String getPositionName() {
        return positionName;
    }

    public void setPositionName(String positionName) {
        this.positionName = positionName == null ? null : positionName.trim();
    }

    public String getPositionType() {
        return positionType;
    }

    public void setPositionType(String positionType) {
        this.positionType = positionType == null ? null : positionType.trim();
    }

    public Long getParentPositionId() {
        return parentPositionId;
    }

    public void setParentPositionId(Long parentPositionId) {
        this.parentPositionId = parentPositionId;
    }

    public String getEnabledFlag() {
        return enabledFlag;
    }

    public void setEnabledFlag(String enabledFlag) {
        this.enabledFlag = enabledFlag == null ? null : enabledFlag.trim();
    }

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "HLSPosition [positionId=" + positionId + ", unitId=" + unitId + ", positionCode=" + positionCode
				+ ", positionName=" + positionName + ", chiefPositionFlag=" + chiefPositionFlag + ", positionType="
				+ positionType + ", parentPositionId=" + parentPositionId + ", enabledFlag=" + enabledFlag
				+ ", parentPositionName=" + parentPositionName + ", company_id=" + company_id + ", company_code="
				+ company_code + ", company_name=" + company_name + ", unit_id=" + unit_id + ", unit_code=" + unit_code
				+ ", unit_name=" + unit_name + "]";
	}
}