package hls.core.fnd.dto;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;

/**
 * @Title: FndEmployeeAssigns
 * @Description:   员工分配DTO 
 *
 */
@SuppressWarnings("serial")
@ExtensionAttribute(disable=true)
@Table(name="fnd_employee_assigns")
public class HlsEmployeeAssigns extends BaseDTO{
	@Id
	@GeneratedValue
	private Long employee_assign_id;
	private Long company_id;  //公司ID
	private Long employee_id; //员工id
	private Long unit_id;		//部门ID
	private Long position_id;	//岗位ID
	private String enabled_flag;	//启用
	
	@Transient
	private String company_code;
	@Transient
	private String company_name;
	@Transient
	private String employee_code;
	@Transient
	private String employee_name;
	@Transient
	private String unit_name;
	@Transient
	private String unit_code;
	@Transient
	private String position_name;
	@Transient
	private String position_code;

	@Transient
	private Long user_id;
	@Transient
	private Long role_id;

	public Long getUser_id() {
		return user_id;
	}

	public void setUser_id(Long user_id) {
		this.user_id = user_id;
	}

	public Long getRole_id() {
		return role_id;
	}

	public void setRole_id(Long role_id) {
		this.role_id = role_id;
	}

	/**
	 * @return the position_code
	 */
	public String getPosition_code() {
		return position_code;
	}
	/**
	 * @param position_code the position_code to set
	 */
	public void setPosition_code(String position_code) {
		this.position_code = position_code;
	}
	/**
	 * @return the unit_code
	 */
	public String getUnit_code() {
		return unit_code;
	}
	/**
	 * @param unit_code the unit_code to set
	 */
	public void setUnit_code(String unit_code) {
		this.unit_code = unit_code;
	}
	/**
	 * @return the company_code
	 */
	public String getCompany_code() {
		return company_code;
	}
	/**
	 * @param company_code the company_code to set
	 */
	public void setCompany_code(String company_code) {
		this.company_code = company_code;
	}
	/**
	 * @return the employee_assign_id
	 */
	public Long getEmployee_assign_id() {
		return employee_assign_id;
	}
	/**
	 * @param employee_assign_id the employee_assign_id to set
	 */
	public void setEmployee_assign_id(Long employee_assign_id) {
		this.employee_assign_id = employee_assign_id;
	}
	/**
	 * @return the company_id
	 */
	public Long getCompany_id() {
		return company_id;
	}
	/**
	 * @param company_id the company_id to set
	 */
	public void setCompany_id(Long company_id) {
		this.company_id = company_id;
	}
	/**
	 * @return the employee_id
	 */
	public Long getEmployee_id() {
		return employee_id;
	}
	/**
	 * @param employee_id the employee_id to set
	 */
	public void setEmployee_id(Long employee_id) {
		this.employee_id = employee_id;
	}
	/**
	 * @return the unit_id
	 */
	public Long getUnit_id() {
		return unit_id;
	}
	/**
	 * @param unit_id the unit_id to set
	 */
	public void setUnit_id(Long unit_id) {
		this.unit_id = unit_id;
	}
	/**
	 * @return the position_id
	 */
	public Long getPosition_id() {
		return position_id;
	}
	/**
	 * @param position_id the position_id to set
	 */
	public void setPosition_id(Long position_id) {
		this.position_id = position_id;
	}
	/**
	 * @return the enabled_flag
	 */
	public String getEnabled_flag() {
		return enabled_flag;
	}
	/**
	 * @param enabled_flag the enabled_flag to set
	 */
	public void setEnabled_flag(String enabled_flag) {
		this.enabled_flag = enabled_flag;
	}
	/**
	 * @return the company_name
	 */
	public String getCompany_name() {
		return company_name;
	}
	/**
	 * @param company_name the company_name to set
	 */
	public void setCompany_name(String company_name) {
		this.company_name = company_name;
	}
	/**
	 * @return the employee_name
	 */
	public String getEmployee_name() {
		return employee_name;
	}
	/**
	 * @param employee_name the employee_name to set
	 */
	public void setEmployee_name(String employee_name) {
		this.employee_name = employee_name;
	}
	/**
	 * @return the unit_name
	 */
	public String getUnit_name() {
		return unit_name;
	}
	/**
	 * @param unit_name the unit_name to set
	 */
	public void setUnit_name(String unit_name) {
		this.unit_name = unit_name;
	}
	/**
	 * @return the position_name
	 */
	public String getPosition_name() {
		return position_name;
	}
	/**
	 * @param position_name the position_name to set
	 */
	public void setPosition_name(String position_name) {
		this.position_name = position_name;
	}
	
	/**
	 * @return the employee_code
	 */
	public String getEmployee_code() {
		return employee_code;
	}
	/**
	 * @param employee_code the employee_code to set
	 */
	public void setEmployee_code(String employee_code) {
		this.employee_code = employee_code;
	}
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "HlsEmployeeAssigns [employee_assign_id=" + employee_assign_id + ", company_id=" + company_id
				+ ", employee_id=" + employee_id + ", unit_id=" + unit_id + ", position_id=" + position_id
				+ ", enabled_flag=" + enabled_flag + ", company_code=" + company_code + ", company_name=" + company_name
				+ ", employee_code=" + employee_code + ", employee_name=" + employee_name + ", unit_name=" + unit_name
				+ ", unit_code=" + unit_code + ", position_name=" + position_name + ", position_code=" + position_code
				+ "]";
	}

}
