package hls.core.fnd.service;

import java.util.List;

import com.hand.hap.core.IRequest;
import com.hand.hap.core.ProxySelf;
import com.hand.hap.system.service.IBaseService;

import hls.core.fnd.dto.*;


public interface IFirmDefineService extends IBaseService<FndCompany>, ProxySelf<IFirmDefineService>{
	public void deleteChannel(String company_code);
	/**
	 * 查找公司信息
	 * @param fndCompany
	 * @return
	 */
	public List<FndCompany> selectList(FndCompany fndCompany);
	/**
	 * 修改公司信息
	 * @param company
	 */
	public void updateChannel(IRequest iRequest,FndCompany company);
	/**
	 * 根据公司ID，查询部门信息
	 * @param company_id
	 * @return
	 */
	public HLSOrgUnit selectFndOrgUnit(Long company_id);
	/**
	 * 保存部门信息
	 * @param hlsOrgUnit
	 */
	public void insertFndOrgUnit(HLSOrgUnit hlsOrgUnit);
	/**
	 * 根据部门ID，查询岗位信息
	 * @param unit
	 * @return
	 */
	public HLSPosition selectFndOrgRosition(Long unit);
	/**
	 * 保存部门信息
	 * @param hlsPosition
	 */
	public void insertFndOrgRosition(HLSPosition hlsPosition);
	/**
	 * 查询员工分配对应的信息
	 * @param company_id
	 * @return
	 */
	public HlsEmployeeAssigns selectFndEmployeeAssign(Long company_id);
	/**
	 * 保存员工分配表信息
	 * @param hlsEmployeeAssigns
	 */
	public void insertFndEmployeeAssign(HlsEmployeeAssigns hlsEmployeeAssigns);
	/**
	 * 查询员工信息
	 * @param employee_id
	 * @return
	 */
	public HlsEmployee selectFndEmployee(Long employee_id);
	/**
	 * 上级公司Lov数据查询
	 * @param fndCompany
	 * @return
	 */
	public List<FndCompany> selectLovList(FndCompany fndCompany);
	
}
