package hls.core.fnd.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.BaseDTO;
import com.hand.hap.system.dto.DTOStatus;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.fnd.dto.FndCompany;
import hls.core.fnd.mapper.CompanyAttributeMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.fnd.dto.CompanyAttribute;
import hls.core.fnd.service.ICompanyAttributeService;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class CompanyAttributeServiceImpl extends BaseServiceImpl<CompanyAttribute> implements ICompanyAttributeService{

    @Autowired
    private CompanyAttributeMapper companyAttributeMapper;

    @Override
    public List<FndCompany> updateInfo(IRequest request, List<FndCompany> companyManagement) {
        List<CompanyAttribute>  companyAttributeList = new ArrayList<CompanyAttribute>();

        for (FndCompany sys : companyManagement) {
            CompanyAttribute cam = new  CompanyAttribute();
            cam.setCompanyId(sys.getCompany_id());
            cam.setAuthorityRuleFlag(sys.getAuthorityRuleFlag());
            if (companyAttributeMapper.selectByPrimaryKey(cam) == null) {
                ICompanyAttributeService self = self();
                cam.set__status(DTOStatus.ADD);
            } else {
                cam.set__status(DTOStatus.UPDATE);
            }
                companyAttributeList.add(cam);

        }
        self().batchUpdate(request,companyAttributeList);

        return companyManagement;
    }
}