package hls.core.fnd.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.DTOStatus;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.fnd.mapper.DocFileTempletRuleMapper;
import hls.core.fnd.mapper.HlsDocFileTempletMapper;
import hls.core.ruleengine.dto.HlsRuleEngine;
import hls.core.ruleengine.mapper.HlsRuleEngineMapper;
import hls.core.ruleengine.service.IHlsRuleEngineService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.fnd.dto.DocFileTempletRule;
import hls.core.fnd.service.IDocFileTempletRuleService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional
public class DocFileTempletRuleServiceImpl extends BaseServiceImpl<DocFileTempletRule> implements IDocFileTempletRuleService{

    @Autowired
    private IHlsRuleEngineService service;

    @Autowired
    private HlsRuleEngineMapper ruleEngineMapper;

    @Autowired
    private DocFileTempletRuleMapper docFileTempletRuleMapper;

    @Override
    public List<DocFileTempletRule> batchUpdate(IRequest request, List<DocFileTempletRule> list) {
        for (DocFileTempletRule t : list) {
            HlsRuleEngine ruleEngine = new HlsRuleEngine();
            switch (t.get__status()) {
                case DTOStatus.ADD:
                    ruleEngine.setDataSourceId(t.getDataSourceId());
                    ruleEngine.setRuleEngineCode("FILE_"+t.getCompanyId().toString()+"_"+t.getTempletType());
                    ruleEngine.setRuleEngineName("FILE_"+t.getCompanyId().toString()+"_"+t.getTempletType());
                    ruleEngine.setRuleEngineType("CON.CONTRACT_FILE");
                    ruleEngine = service.self().insertSelective(request,ruleEngine);
                    t.setRuleEngineId(ruleEngine.getRuleEngineId());
                    insertSelective(request, t);
                    break;
                case DTOStatus.UPDATE:
                    ruleEngine.setRuleEngineId(t.getRuleEngineId());
                    ruleEngine = ruleEngineMapper.selectOne(ruleEngine);
                    ruleEngine.setDataSourceId(t.getDataSourceId());
                    service.updateByPrimaryKeySelective(request,ruleEngine);
                    updateByPrimaryKeySelective(request, t);
                    break;
                case DTOStatus.DELETE:
                    ruleEngine.setRuleEngineId(t.getRuleEngineId());
                    service.deleteByPrimaryKey(ruleEngine);
                    deleteByPrimaryKey(t);
                    break;
                default:
                    break;
            }
        }
        return list;
    }

    @Override
    public List<DocFileTempletRule> selectByFontCondition(IRequest request, DocFileTempletRule docFileTempletRule, int page, int pageSize) {
        PageHelper.startPage(page,pageSize);
        return docFileTempletRuleMapper.selectByFontCondition(docFileTempletRule);
    }
}