package hls.core.fnd.service.impl;


import java.util.List;

import com.hand.hap.core.IRequest;
import hls.core.fnd.dto.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.fnd.mapper.FirmDefineMapper;
import hls.core.fnd.service.IFirmDefineService;
 
@Service
@Transactional
public class FirmDefineServiceImpl extends BaseServiceImpl<FndCompany>implements IFirmDefineService {

	@Autowired
	private FirmDefineMapper mapper;
	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IFirmDefineService#deleteChannel(java.lang.String)
	 */
	@Override
	public void deleteChannel(String company_code) {
		mapper.deleteChannel(company_code);
	}
	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IFirmDefineService#updateChannel(hls.core.fnd.dto.FndCompany)
	 */
	@Override
	public void updateChannel(IRequest iRequest,FndCompany company) {
		self().updateByPrimaryKeySelective(iRequest,company);
	}
	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IFirmDefineService#selectList(hls.core.fnd.dto.FndCompany)
	 */
	@Override
	public List<FndCompany> selectList(FndCompany fndCompany) {
		return mapper.selectList(fndCompany);
	}
	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IFirmDefineService#selectFndOrgUnit(java.lang.Long)
	 */
	@Override
	public HLSOrgUnit selectFndOrgUnit(Long company_id) {
		return mapper.selectFndOrgUnit(company_id);
	}
	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IFirmDefineService#insertFndOrgUnit(hls.core.fnd.dto.HLSOrgUnit)
	 */
	@Override
	public void insertFndOrgUnit(HLSOrgUnit hlsOrgUnit) {
		mapper.insertFndOrgUnit(hlsOrgUnit);
	}
	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IFirmDefineService#selectFndOrgRosition(java.lang.Long)
	 */
	@Override
	public HLSPosition selectFndOrgRosition(Long unit) {
		return mapper.selectFndOrgRosition(unit);
	}
	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IFirmDefineService#insertFndOrgRosition(hls.core.fnd.dto.HLSPosition)
	 */
	@Override
	public void insertFndOrgRosition(HLSPosition hlsPosition) {
		mapper.insertFndOrgRosition(hlsPosition);
	}
	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IFirmDefineService#selectFndEmployeeAssign(java.lang.Long)
	 */
	@Override
	public HlsEmployeeAssigns selectFndEmployeeAssign(Long company_id) {
		return mapper.selectFndEmployeeAssign(company_id);
	}
	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IFirmDefineService#insertFndEmployeeAssign(hls.core.fnd.dto.HlsEmployeeAssigns)
	 */
	@Override
	public void insertFndEmployeeAssign(HlsEmployeeAssigns hlsEmployeeAssigns) {
		mapper.insertFndEmployeeAssign(hlsEmployeeAssigns);
	}
	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IFirmDefineService#selectFndEmployee(java.lang.Long)
	 */
	@Override
	public HlsEmployee selectFndEmployee(Long employee_id) {
		return mapper.selectFndEmployee(employee_id);
	}
	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IFirmDefineService#selectLovList(hls.core.fnd.dto.FndCompany)
	 */
	@Override
	public List<FndCompany> selectLovList(FndCompany fndCompany) {
		return mapper.selectLovList(fndCompany);
	}

}
