package hls.core.fnd.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.fnd.dto.FndBaseRate;
import hls.core.fnd.dto.FndBaseRateSet;
import hls.core.fnd.mapper.FndBaseRateMapper;
import hls.core.fnd.service.FndBaseRateService;



@Service
@Transactional
public class FndBaseRateServiceImpl extends BaseServiceImpl<FndBaseRate> implements FndBaseRateService{

	@Autowired
	FndBaseRateMapper mapper;
	
	@Override
	public void update(FndBaseRate fndBaseRate) {
		// TODO Auto-generated method stub
		mapper.updateByPrimaryKeySelective(fndBaseRate);
	}

	@Override
	public List<FndBaseRate> queryAllByBaseRateSet(String base_rate_set) {
		// TODO Auto-generated method stub
		List<FndBaseRate> fndRaseRate = mapper.selectByBaseRateSet(base_rate_set);
		return fndRaseRate;
	}

	@Override
	public List<FndBaseRate> queryAllByBaseRateType(String baseRateType) {
		// TODO Auto-generated method stub
		List<FndBaseRate> fndRaseRate = mapper.selectByBaseRateType(baseRateType);
		return fndRaseRate;
	}

	//循环删除
	@Override
	public void delete(List<FndBaseRate> fndBaseRate) {
		// TODO Auto-generated method stub
		for(FndBaseRate data:fndBaseRate)
		{
			mapper.deleteByPrimaryKey(data.getBase_rate_id());
		}
		
	}

	@Override
	public void insert(FndBaseRate fndBaseRate) {
		// TODO Auto-generated method stub
		mapper.insertSelective(fndBaseRate);
	}
	
	public void save(List<FndBaseRate> fndBaseRate)
	{
		for(FndBaseRate data:fndBaseRate)
		{
			if(data.getBase_rate_id() == null)
			{
				mapper.insertSelective(data);
			}
			else
			{
				mapper.updateByPrimaryKeySelective(data);
			}
		}
	}

}
