package hls.core.fnd.service.impl;

import java.util.List;

import org.activiti.bpmn.model.BooleanDataObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.fnd.dto.FndCity;
import hls.core.fnd.mapper.FndCityMapper;
import hls.core.fnd.service.IFirmDefineService;
import hls.core.fnd.service.IFndCityService;
import hls.core.hls.dto.FndProvince;


@Service
@Transactional
public class FndCityServiceImpl extends BaseServiceImpl<FndCity> implements IFndCityService{

	@Autowired
	private FndCityMapper mapper;

	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IFndCityService#queryLov(hls.core.fnd.dto.FndCity)
	 */
	@Override
	public List<FndProvince> queryLov(FndProvince fndProvince) {
		return mapper.queryLov(fndProvince);
	}

	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IFndCityService#queryAll()
	 */
	@Override
	public List<FndCity> queryAll(FndCity fndCity) {
		return mapper.queryAll(fndCity);
	}
	@Override
	public void cascadingDeleteDistrict(List<FndCity> lfndCity){
		
		if(lfndCity != null){
			for(FndCity fc : lfndCity){
				
				
				mapper.deleteDistrict(fc);
			}
			
			this.batchDelete(lfndCity);
		}
		
	}

	@Override
	public String queryCityCodeByAdd(String city, String province) {
		// TODO Auto-generated method stub
		return mapper.queryCityCodeByAdd(city,province);
	}

	@Override
	public List<FndCity> addressQuery(FndCity fndCity) {
		return mapper.addressQuery(fndCity);
	}

	@Override
	public String queryCityCode(String city) {
		// TODO Auto-generated method stub
		return mapper.queryCityCode(city);
	}
	

}
