package hls.core.fnd.service.impl;

import com.github.pagehelper.PageHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.fnd.dto.FndCodingRule;
import hls.core.fnd.mapper.FndCodingRuleDetailsMapper;
import hls.core.fnd.mapper.FndCodingRuleMapper;
import hls.core.fnd.service.FndCodingRuleService;

import java.util.List;

@Service
@Transactional
public class FndCodingRuleServiceImpl extends BaseServiceImpl<FndCodingRule> implements FndCodingRuleService{

	@Autowired
	FndCodingRuleMapper ruleMapper;
	@Autowired
	FndCodingRuleDetailsMapper rruleDetailsMapper;
	@Override
	public void delete(IRequest iRequest, FndCodingRule fndCodingRule) 
	{
		ruleMapper.delete(fndCodingRule);
		rruleDetailsMapper.deleteByCodeRuleId(fndCodingRule.getCodingRuleId());
	}

	@Override
	public List<FndCodingRule> select(IRequest request, FndCodingRule condition, int pageNum, int pageSize) {
		//return super.select(request, condition, pageNum, pageSize);
		PageHelper.startPage(pageNum, pageSize ,true,null,true);
		return mappers.get(0).select(condition);
	}
}
