package hls.core.fnd.service.impl;

import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.fnd.mapper.FndWorkCalendarMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.fnd.dto.FndWorkCalendar;
import hls.core.fnd.service.IFndWorkCalendarService;
import org.springframework.transaction.annotation.Transactional;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class FndWorkCalendarServiceImpl extends BaseServiceImpl<FndWorkCalendar> implements IFndWorkCalendarService{


    @Autowired
    private FndWorkCalendarMapper fndWorkCalendarMapper;


    /**
     *  获取指定日期的对应的休息日
     * @param  pDate
     * @param  adjustType （FORWARD：向前查找 ， BACKWARD：向后查找）
     * @return Date
     */
    @Override
    public Date CalendarDayAdjust(Date pDate, String adjustType) {
        Date oDate = null;
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(pDate);
        // 将传进来的时间去掉 时分秒
        calendar.set(Calendar.HOUR_OF_DAY, 0);
        calendar.set(Calendar.MINUTE, 0);
        calendar.set(Calendar.SECOND, 0);
        calendar.set(Calendar.MILLISECOND, 0);
        while (true) {
            FndWorkCalendar fndWorkCalendar = new FndWorkCalendar();
            fndWorkCalendar.setCalendarDay(calendar.getTime());
            fndWorkCalendar = fndWorkCalendarMapper.selectWorkCalendarByDate(fndWorkCalendar);
            if (fndWorkCalendar != null && "N".equals(fndWorkCalendar.getOffDayFlag())) {
                oDate = fndWorkCalendar.getCalendarDay();
                break;
            } else {
                int w = calendar.get(Calendar.DAY_OF_WEEK);
                if (w != 7 && w != 1) {
                    oDate = calendar.getTime();
                    break;
                }
            }
            if ("FORWARD".equals(adjustType.toUpperCase())) {
                calendar.add(Calendar.DATE, -1);
            } else if ("BACKWARD".equals(adjustType.toUpperCase())) {
                calendar.add(Calendar.DATE, 1);
            }
        }
        return oDate;
    }
}