package hls.core.fnd.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.fnd.dto.HLSOrgUnit;
import hls.core.fnd.mapper.HLSOrgUnitMapper;
import hls.core.fnd.service.HLSIOrgUnitService;

/**
 *  *author:jialong.zuo@hand-china.com on 2016/9/16.
 */
@Service
@Transactional
public class HLSOrgUnitServiceImpl extends BaseServiceImpl<HLSOrgUnit> implements HLSIOrgUnitService {

    @Autowired
    HLSOrgUnitMapper mapper;

    @Override
    public List<HLSOrgUnit> queryAll(IRequest requestContext, HLSOrgUnit unit, int page, int pagesize) {
        PageHelper.startPage(page, pagesize);
        return mapper.queryAll(unit);
    }

    @Override
    protected boolean useSelectiveUpdate() {
        return false;
    }

	@Override
	public List<String> queryAllName(HLSOrgUnit unit) {
		
		return mapper.queryAllName( unit);
	}
	
	@Override
	public Long selectById(HLSOrgUnit hlsOrgUnit) {
		
		return mapper.selectById(hlsOrgUnit);
	}

	@Override
	public List<HLSOrgUnit> queryLov(String lovCode) {
		
		return mapper.queryLov(lovCode);
	}

	@Override
	public void deletePosition(Long unitId) {
		mapper.deletePosition(unitId);
		
	}

	/* (non-Javadoc)
	 * @see hls.core.fnd.service.HLSIOrgUnitService#queryAll(hls.core.fnd.dto.HLSOrgUnit)
	 */
	@Override
	public List<HLSOrgUnit> queryAll(HLSOrgUnit unit) {
		// TODO Auto-generated method stub
		return mapper.queryAll(unit);
	}
}
