package hls.core.fnd.service.impl;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.fnd.dto.HlsContact;
import hls.core.fnd.mapper.HlsContactMapper;
import hls.core.fnd.service.HlsContactService;

/**
 * Created by jianwen.zheng on 2017年3月14日
 */
@Service
@Transactional
public class HlsContactServiceImpl extends BaseServiceImpl<HlsContact> implements HlsContactService{

	@Autowired
	private HlsContactMapper contactMapper;
	
	@Override
	public List<HlsContact> selectAllHlsContact(IRequest irRequest,HlsContact contact){
		if(contact.getContactType() != null) {
			String[] strs = contact.getContactType().split(",");
			contact.setContactTypes(Arrays.asList(strs));
		}
		List<HlsContact> list = contactMapper.selectAllHlsContact(contact);
		for (int i = 0; i < list.size(); i++) {
			String contactType = list.get(i).getContactType();
			list.get(i).setContactType(contactType.substring(0, contactType.length()-1));
		}
		return list;
	}

	/* (non-Javadoc)
	 * @see hls.core.fnd.service.HlsContactService#saveSubmit(com.hand.hap.core.IRequest, java.util.List)
	 */
	@Override
	public Long saveSubmit(IRequest iRequest, List<HlsContact> contacts) {
		Long ContactId =0L;
		HlsContact contact = contacts.get(0) ;
		contact = set(contact);
		contact.setContactUserId(iRequest.getUserId());
		//保存反馈信息
		List<HlsContact> list = new ArrayList<>();
		list.add(contact);
		self().batchUpdate(iRequest, list);
		ContactId = contacts.get(0).getContactId();
		return ContactId;
	}
	public HlsContact set(HlsContact contact){
		String[] strs = contact.getContactType().split(",");
		contact.setTypeUi("N");
		contact.setTypeUe("N");
		contact.setTypeOther("N");
		contact.setTypeBug("N");
		for (int i = 0; i < strs.length; i++) {
			if(strs[i].equalsIgnoreCase("UI")){
				contact.setTypeUi("Y");
			}
			if(strs[i].equalsIgnoreCase("UE")){
				contact.setTypeUe("Y");
			}
			if(strs[i].equalsIgnoreCase("other")){
				contact.setTypeOther("Y");
			}
			if(strs[i].equalsIgnoreCase("BUG")){
				contact.setTypeBug("Y");
			}
		}
		return contact;
	}
}
