package hls.core.fnd.service.impl;

import java.util.List;

import hls.core.fnd.dto.HlsEmployee;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.fnd.dto.HlsEmployeeAssigns;
import hls.core.fnd.mapper.IHlsEmployeeAssignsMapper;
import hls.core.fnd.service.IHlsEmployeeAssignsService;

/**
 * @Title: HlsEmployeeAssignsServiceImpl
 * @Description:  员工分配 
 *
 */
@Service
@Transactional
public class HlsEmployeeAssignsServiceImpl extends BaseServiceImpl<HlsEmployeeAssigns> implements IHlsEmployeeAssignsService{

	@Autowired
	private IHlsEmployeeAssignsMapper mapper;
	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IHlsEmployeeAssignsService#selectAllEmployeeAssigns(hls.core.fnd.dto.HlsEmployeeAssigns)
	 */
	@Override
	public List<HlsEmployeeAssigns> selectAllEmployeeAssigns(HlsEmployeeAssigns employeeAssigns) {
		return mapper.selectAllEmployeeAssigns(employeeAssigns);
	}
	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IHlsEmployeeAssignsService#getEmployee(java.lang.String)
	 */
	@Override
	public Long getEmployee(HlsEmployee employee) {
		return mapper.getEmployee(employee);
	}
	/* (non-Javadoc)
	 * @see hls.core.fnd.service.IHlsEmployeeAssignsService#selectFindDefault(hls.core.fnd.dto.HlsEmployeeAssigns)
	 */
	@Override
	public List<HlsEmployeeAssigns> selectFindDefault(HlsEmployeeAssigns employeeAssigns) {
		return mapper.selectFindDefault(employeeAssigns);
	}
}
