package hls.core.fnd.service.impl;

import java.util.List;

import hls.core.fnd.dto.HlsEmployee;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.hand.hap.core.IRequest;
import com.hand.hap.message.IMessagePublisher;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.fnd.mapper.HlsEmployeeMapper;
import hls.core.fnd.service.HLSIEmployeeService;

@Service
public class HlsEmployeeServiceImpl extends BaseServiceImpl<HlsEmployee> implements HLSIEmployeeService {

	@Autowired
    HlsEmployeeMapper employeeMapper;
	
    @Autowired
    private IMessagePublisher messagePublisher;
    

    @Override
    public List<HlsEmployee> batchUpdate(IRequest request, List<HlsEmployee> list) {
        super.batchUpdate(request, list);
        for (HlsEmployee e : list) {
            messagePublisher.publish("employee.change", e);
        }
        return list;
    }


	@Override
	public Long selectByCode(String code) {
		
		return employeeMapper.selectByCode(code);
	}


	/* (non-Javadoc)
	 * @see hls.core.fnd.service.HLSIEmployeeService#selectAll(hls.core.fnd.dto.HlsEmployee)
	 */
	@Override
	public List<HlsEmployee> selectAllEmployee(HlsEmployee employee) {
		return employeeMapper.selectAllEmployee(employee);
	}


	/* (non-Javadoc)
	 * @see hls.core.fnd.service.HLSIEmployeeService#selectEmploye(hls.core.fnd.dto.HlsEmployee)
	 */
	@Override
	public HlsEmployee selectEmploye(HlsEmployee employee) {
		return employeeMapper.selectEmploye(employee);
	}

}
