package hls.core.fnd.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.fnd.dto.HlsPenaltyProfile;
import hls.core.fnd.mapper.HlsPenaltyProfileMapper;
import hls.core.fnd.service.HlsPenaltyProfileService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by 罗宇娟 on 2017/6/22.
 */
@Service
public class HlsPenaltyProfileServiceImpl extends BaseServiceImpl<HlsPenaltyProfile> implements HlsPenaltyProfileService {
    @Autowired
    HlsPenaltyProfileMapper mapper;

    @Override
    public List<HlsPenaltyProfile> selectList(IRequest requestContext, HlsPenaltyProfile hlsPenaltyProfile) {
        hlsPenaltyProfile.setCompanyId(requestContext.getCompanyId());
        return mapper.selectList(hlsPenaltyProfile);
    }

    @Override
    public void deleteChildById(String penaltyProfile) {
        mapper.deleteChildById(penaltyProfile);
    }

    @Override
    public void deletePenaltyProfile(List<HlsPenaltyProfile> hlsList) {
        for (HlsPenaltyProfile h:hlsList) {
            if(h.getPenaltyProfile() !=null){
                this.deleteChildById(h.getPenaltyProfile());
            }
        }
        this.batchDelete(hlsList);
    }
}
