package hls.core.gld.components;

import com.hand.hap.core.AppContextInitListener;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * 凭证事物处理集合
 * Created by fjm on 2017/8/31.
 */
@Component
public class JeTrxCommonService implements AppContextInitListener{


    //spring容器上下文中所有的凭证事物接口实例,对应的key为凭证事物类型,前提是接口的实现类被扫描或者以bean的形式写在配置文件之中
    public static Map<String,AbstractJeTrxService> map = new HashMap<>();

    @Override
    public void contextInitialized(ApplicationContext applicationContext) {
        Map<String,? extends AbstractJeTrxService> jeTrxMaps = applicationContext.getBeansOfType(AbstractJeTrxService.class);
        jeTrxMaps.forEach((k,v)->map.put(v.getJeTrx(),v));
    }
}
