package hls.core.gld.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.AccountSegment;
import hls.core.gld.service.IAccountSegmentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

@Controller
public class AccountSegmentController extends BaseController {

    @Autowired
    private IAccountSegmentService service;


    @RequestMapping(value = "/gld/account/segment/query")
    @ResponseBody
    public ResponseData query(AccountSegment dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        dto.setCompanyId((Long) session.getAttribute("companyId"));
        return new ResponseData(service.query(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/gld/account/segment/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request, @RequestBody List<AccountSegment> dto) {
        IRequest requestCtx = createRequestContext(request);
        if (dto != null) {
            for (AccountSegment as : dto) {
                if (as.getCompanyId() == null || as.getCompanyId() == 0) {
                    as.set__status("add");
                } else {
                    as.set__status("update");
                }
            }
        }
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/gld/account/segment/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<AccountSegment> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }

    @RequestMapping(value = "/gld/account/segment/select")
    @ResponseBody
    public ResponseData select(AccountSegment dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                               @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session){
        IRequest requestContext = createRequestContext(request);
        dto.setCompanyId((Long) session.getAttribute("companyId"));
        return new ResponseData(service.selectJoin(requestContext, dto, page, pageSize));
    }
}