package hls.core.gld.controllers;

import hls.core.gld.exception.CodeException;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.AccountSet;
import hls.core.gld.service.IAccountSetService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

    @Controller
    public class AccountSetController extends BaseController{

    @Autowired
    private IAccountSetService service;


    @RequestMapping(value = "/gld/account/set/query")
    @ResponseBody
    public ResponseData query(AccountSet dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/gld/account/set/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<AccountSet> dto) throws CodeException {
        IRequest requestCtx = createRequestContext(request);

        List<AccountSet> list = new ArrayList<AccountSet>();
        try {
             list = service.batchUpdate(requestCtx, dto);
        }catch (Exception e){
            throw new CodeException();
        }

        return new ResponseData(list);
    }

    @RequestMapping(value = "/gld/account/set/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<AccountSet> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }


    @RequestMapping(value = "/gld/account/set/create")
    @ResponseBody
    public ResponseData createRelation(AccountSet dto,HttpServletRequest request){
        IRequest requestContext = createRequestContext(request);
        service.createRelation(dto,requestContext);
        return new ResponseData();
    }
    }