package hls.core.gld.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.ContractCashflow;
import hls.core.gld.service.IContractCashflowService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

    @Controller
    public class ContractCashflowController extends BaseController{

    @Autowired
    private IContractCashflowService service;


    @RequestMapping(value = "/gld/contract/cashflow/query")
    @ResponseBody
    public ResponseData query(ContractCashflow dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/gld/contract/cashflow/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<ContractCashflow> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/gld/contract/cashflow/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<ContractCashflow> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }