package hls.core.gld.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.ContractTrx;
import hls.core.gld.service.IContractTrxService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

    @Controller
    public class ContractTrxController extends BaseController{

    @Autowired
    private IContractTrxService service;


    @RequestMapping(value = "/gld/contract/trx/query")
    @ResponseBody
    public ResponseData query(ContractTrx dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/gld/contract/trx/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<ContractTrx> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/gld/contract/trx/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<ContractTrx> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    /*待分摊清单查询*/
    @RequestMapping(value = "/gld/contract/trx/queryWaitList")
    @ResponseBody
    public ResponseData queryWaitList(ContractTrx dto, HttpServletRequest request, HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        Long companyId = (Long) session.getAttribute("companyId");
        dto.setCompanyId(companyId);
        return new ResponseData(service.queryWaitList(dto));
    }
    }