package hls.core.gld.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.CostCenter;
import hls.core.gld.service.ICostCenterService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

@Controller
public class CostCenterController extends BaseController {

    @Autowired
    private ICostCenterService service;


    @RequestMapping(value = "/gld/cost/center/query")
    @ResponseBody
    public ResponseData query(CostCenter dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        Long companyId = (Long) session.getAttribute("companyId");
        dto.setCompanyId(companyId);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/gld/cost/center/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request, HttpSession session, @RequestBody List<CostCenter> dto) {
        IRequest requestCtx = createRequestContext(request);
        dto.forEach(item -> item.setCompanyId((Long) session.getAttribute("companyId")));
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/gld/cost/center/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<CostCenter> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }
}