package hls.core.gld.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.FinancialAttribute;
import hls.core.gld.service.IFinancialAttributeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.HashMap;
import java.util.List;

    @Controller
    public class FinancialAttributeController extends BaseController{

    @Autowired
    private IFinancialAttributeService service;


    @RequestMapping(value = "/gld/financial/attribute/query")
    @ResponseBody
    public ResponseData query(FinancialAttribute dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/gld/financial/attribute/submit")
    @ResponseBody
    public FinancialAttribute update(HttpServletRequest request,HttpSession session,@RequestBody List<FinancialAttribute> dto){
        IRequest requestCtx = createRequestContext(request);
        Long companyId = session.getAttribute("companyId")!=null? (Long) session.getAttribute("companyId") :null;
        FinancialAttribute item = dto.get(0);
        item.setCompanyId(companyId);
        return service.save(requestCtx,item);
    }

        /**修改分摊规则/
         *
         * @param request
         * @param dto
         * @return
         */
        @RequestMapping(value = "/gld/financial/attribute/save")
        @ResponseBody
        public ResponseData  save(HttpServletRequest request,@RequestBody List<FinancialAttribute> dto){
            IRequest requestCtx = createRequestContext(request);
            return new ResponseData(service.batchUpdate(requestCtx,dto));
        }
    @RequestMapping(value = "/gld/financial/attribute/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<FinancialAttribute> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }


    @RequestMapping(value = "/gld/financial/attribute/company_financial")
    @ResponseBody
    public HashMap companyFinancial(HttpServletRequest request, HttpSession session){

        Long companyId = session.getAttribute("companyId")!=null? (Long) session.getAttribute("companyId") :null;
        FinancialAttribute financialAttribute = new FinancialAttribute();
        financialAttribute.setCompanyId(companyId);
        return service.companyFinancial(financialAttribute);
    }

    }