package hls.core.gld.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.HlsCusGldLonContractTrx;
import hls.core.gld.service.IGldLonContractTrxService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

@Controller
public class GldLonContractTrxController extends BaseController {

    @Autowired
    private IGldLonContractTrxService service;


    @RequestMapping(value = "/gld/lon/contract/trx/query")
    @ResponseBody
    public ResponseData query(HlsCusGldLonContractTrx dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/gld/lon/contract/trx/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusGldLonContractTrx> dto, BindingResult result, HttpServletRequest request) {
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/gld/lon/contract/trx/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusGldLonContractTrx> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }

    /*待分摊清单查询*/
    @RequestMapping(value = "/gld/lon/contract/trx/queryWaitShareList")
    @ResponseBody
    public ResponseData queryWaitShareList(HlsCusGldLonContractTrx dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                           @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        Long companyId = Long.valueOf(String.valueOf(session.getAttribute("companyId")));
        dto.setCompanyId(companyId);
        return new ResponseData(service.queryWaitShareList(requestContext, dto, page, pageSize));
    }

}