package hls.core.gld.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.JeHdTemplate;
import hls.core.gld.service.IJeHdTemplateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.springframework.validation.BindingResult;
import java.util.List;

    @Controller
    public class JeHdTemplateController extends BaseController{

    @Autowired
    private IJeHdTemplateService service;


    @RequestMapping(value = "/gld/je/hd/template/query")
    @ResponseBody
    public ResponseData query(JeHdTemplate dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request,HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        Long companyId = (Long) session.getAttribute("companyId");
        dto.setCompanyId(companyId);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/gld/je/hd/template/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<JeHdTemplate> dto, BindingResult result, HttpServletRequest request,HttpSession session){
        Long companyId = (Long) session.getAttribute("companyId");
        for(JeHdTemplate item: dto){
            item.setCompanyId(companyId);
        }
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/gld/je/hd/template/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<JeHdTemplate> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }