package hls.core.gld.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.JeLine;
import hls.core.gld.service.IJeLineService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Controller
    public class JeLineController extends BaseController{

    @Autowired
    private IJeLineService service;


    @RequestMapping(value = "/gld/je/line/query")
    @ResponseBody
    public ResponseData query(JeLine dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        Long companyId = (Long) session.getAttribute("companyId");
        Map<String,Object> map = new HashMap<String,Object>();
        map.put("companyId",companyId);
        map.put("jeLineId",dto.getJeLineId());
        map.put("periodName",dto.getPeriodName());
        map.put("dateFrom",dto.getDateFrom());
        map.put("dateTo",dto.getDateTo());
        map.put("jeDescription",dto.getJeDescription());
        map.put("companyId",companyId);
        map.put("costCenterId",dto.getCostCenterId());
        map.put("accountCode",dto.getAccountCode());
        map.put("accountName",dto.getAccountName());
        map.put("amount",dto.getAmount());
        map.put("amountFrom",dto.getAmountFrom());
        map.put("amountTo",dto.getAmountTo());
        map.put("contractNumber",dto.getContractNumber());
        map.put("jeTrx",dto.getJeTrx());
        map.put("jeTrxDescription",dto.getJeTrxDescription());
        map.put("amountValue",dto.getAmountValue());
        map.put("contractNumberFrom",dto.getContractNumberFrom());
        map.put("contractNumberTo",dto.getContractNumberTo());
        map.put("periodFrom",dto.getPeriodFrom());
        map.put("periodTo",dto.getPeriodTo());
        map.put("jeStatusDescription",dto.getJeStatusDescription());
        map.put("jeHeadId",dto.getJeHeadId());
        String[] paramStatus = null;
        String[] paramJeTrx = null;
        String[] paramJeCreatedBy = null;
        if(dto.getJeStatus()!=null){
            paramStatus=dto.getJeStatus().split("、");
        }
        if(dto.getJeTrx()!=null){
            paramJeTrx=dto.getJeTrx().split("、");
        }
        if(dto.getJeCreatedByDesc()!=null){
            paramJeCreatedBy=dto.getJeCreatedByDesc().split("、");
            for(int i = 0;i<paramJeCreatedBy.length;i++){
                if(paramJeCreatedBy[i].equals("jeCreatedByMy")){
                    paramJeCreatedBy[i]=requestContext.getUserName();
                }
            }
        }
        map.put("paramStatus",paramStatus);
        map.put("paramJeTrx",paramJeTrx);
        map.put("paramJeCreatedBy",paramJeCreatedBy);
        return new ResponseData(service.query(map,page,pageSize));
    }
    @RequestMapping(value = "/gld/je/line/queryCompany")
    @ResponseBody
    public ResponseData queryCompany(JeLine dto, HttpSession session){
        Long companyId = (Long) session.getAttribute("companyId");
        dto.setCompanyId(companyId);
        return new ResponseData(service.queryCompany(dto));

    }
    @RequestMapping(value = "/gld/je/line/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<JeLine> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/gld/je/line/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<JeLine> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }