package hls.core.gld.controllers;

import hls.core.gld.dto.JeSegment;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.service.IJeSegmentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

    @Controller
    public class JeSegmentController extends BaseController{

    @Autowired
    private IJeSegmentService service;


    @RequestMapping(value = "/gld/je/segment/query")
    @ResponseBody
    public ResponseData query(JeSegment dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        dto.setCompanyId((Long) session.getAttribute("companyId"));
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/gld/je/segment/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<JeSegment> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/gld/je/segment/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<JeSegment> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }