package hls.core.gld.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.JeTemplate;
import hls.core.gld.service.IJeTemplateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

    @Controller
    public class JeTemplateController extends BaseController{

    @Autowired
    private IJeTemplateService service;


    @RequestMapping(value = "/gld/je/template/query")
    @ResponseBody
    public ResponseData query(JeTemplate dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        dto.setCompanyId((Long) session.getAttribute("companyId"));
        if(service.selectWithDesc(requestContext,dto,page,pageSize)==null){
            return new ResponseData();
        }else{
            return new ResponseData(service.selectWithDesc(requestContext,dto,page,pageSize));
        }

    }

    @RequestMapping(value = "/gld/je/template/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request, @RequestBody List<JeTemplate> dto, HttpSession session){
        IRequest requestCtx = createRequestContext(request);
        Long companyId = (Long)session.getAttribute("companyId");
        dto.forEach(item->{
            item.setCompanyId(companyId);
        });
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/gld/je/template/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<JeTemplate> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }