package hls.core.gld.controllers;

import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.JeRuleEngine;
import hls.core.gld.mapper.JeRuleEngineMapper;
import hls.core.gld.service.impl.JeTemplateLovService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;
import java.util.Map;

import static hls.core.csh.service.impl.CshWriteOffPaymentServiceImpl.list;

/**
 * Created by fjm on 2017/8/10.
 */
@Controller
@RequestMapping("/lov")
public class JeTemplateLovController extends BaseController {

    @Autowired
    JeTemplateLovService service;

    @Autowired
    JeRuleEngineMapper ruleEngineMapper;

    private static volatile JeRuleEngine jeRuleEngine = new JeRuleEngine();//定义变量,用于作为查询参数,获取数据源ID


    @RequestMapping("/je/template/company")
    @ResponseBody
    public ResponseData queryCompanyIdWithDs(@RequestParam(required = false) String jeTrx, @RequestParam(name = "companyName",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                             @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {

        Long dataSourceId = getDataSourceId(session, jeTrx);
        Map map = service.companyLov(dataSourceId, param, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;

    }

    @RequestMapping("/je/template/jeDate")
    @ResponseBody
    public ResponseData queryJeDate(@RequestParam(required = false) String jeTrx,@RequestParam(name = "companyName",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                    @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {

        Long dataSourceId = getDataSourceId(session, jeTrx);
        Map map = service.jeDateLov(dataSourceId, param, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;
    }

    @RequestMapping("/je/template/account")
    @ResponseBody
    public ResponseData queryAccountIdWithDs(@RequestParam(required = false) String jeTrx,@RequestParam(name = "accountName",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                             @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long dataSourceId = getDataSourceId(session, jeTrx);
        Map map = service.accountLov(dataSourceId, param, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;
    }

    @RequestMapping("/je/template/costCenter")
    @ResponseBody
    public ResponseData queryCostCenterIdWithDs(@RequestParam(required = false) String jeTrx,@RequestParam(name = "description",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                                @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {

        Long dataSourceId = getDataSourceId(session, jeTrx);
        Long companyId = (Long) session.getAttribute("companyId");
        Map map = service.costCentertLov(companyId, param, dataSourceId, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;

    }

    @RequestMapping("/je/template/currency")
    @ResponseBody
    public ResponseData queryCurrencyWithDs(@RequestParam(required = false) String jeTrx,@RequestParam(name = "currencyName",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {

        Long dataSourceId = getDataSourceId(session, jeTrx);
        Map map = service.currencyLov(dataSourceId, param, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;

    }

//    @RequestMapping("/je/template/drCr")
//    @ResponseBody
//    public ResponseData queryDrCr(@RequestParam(required = false) String jeTrx,@RequestParam(name = "companyName",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
//                                  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
//
//        Long dataSourceId = getDataSourceId(session, jeTrx);
//        Map map = service.drCrLov(dataSourceId, param, page, pageSize);
//        ResponseData rs = new ResponseData((List<?>) map.get("list"));
//        rs.setTotal((Long) map.get("total"));
//        return rs;
//
//    }

    @RequestMapping("/je/template/drAmount")
    @ResponseBody
    public ResponseData queryDrAmount(@RequestParam(required = false) String jeTrx,@RequestParam(name = "drAmountKey",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                      @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {

        Long dataSourceId = getDataSourceId(session, jeTrx);
        Map map = service.drAmount(dataSourceId, param, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;

    }

    @RequestMapping("/je/template/crAmount")
    @ResponseBody
    public ResponseData queryCrAmount(@RequestParam(required = false) String jeTrx,@RequestParam(name = "crAmountKey",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                      @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {

        Long dataSourceId = getDataSourceId(session, jeTrx);
        Map map = service.crAmount(dataSourceId, param, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;

    }

    @RequestMapping("/je/template/drFunctionAmount")
    @ResponseBody
    public ResponseData queryDrFunctionAmount(@RequestParam(required = false) String jeTrx,@RequestParam(name = "drFunctionAmountKey",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {

        Long dataSourceId = getDataSourceId(session, jeTrx);
        Map map = service.drFunctionAmount(dataSourceId, param, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;

    }

    @RequestMapping("/je/template/crFunctionAmount")
    @ResponseBody
    public ResponseData queryCrFunctionAmount(@RequestParam(required = false) String jeTrx,@RequestParam(name = "crFunctionAmountKey",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {

        Long dataSourceId = getDataSourceId(session, jeTrx);
        Map map = service.crFunctionAmount(dataSourceId, param, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;

    }


    @RequestMapping("/je/template/exchangeRate")
    @ResponseBody
    public ResponseData queryExchangeRate(@RequestParam(required = false) String jeTrx,@RequestParam(name = "exchangeRateKey",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                          @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {

        Long dataSourceId = getDataSourceId(session, jeTrx);
        Map map = service.exchangeRate(dataSourceId, param, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;
    }

    @RequestMapping("/je/template/segMent1")
    @ResponseBody
    public ResponseData querySegMent1(@RequestParam(required = false) String jeTrx,@RequestParam(name = "segmentCode1",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                      @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long dataSourceId = getDataSourceId(session, jeTrx);
        Long companyId = session.getAttribute("companyId") != null ? (Long) session.getAttribute("companyId") : 0L;
        Map map = service.segMent1(dataSourceId, param, companyId, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;
    }

    @RequestMapping("/je/template/segMent2")
    @ResponseBody
    public ResponseData querySegMent2(@RequestParam(required = false) String jeTrx,@RequestParam(name = "segmentCode2",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                      @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long dataSourceId = getDataSourceId(session, jeTrx);
        Long companyId = session.getAttribute("companyId") != null ? (Long) session.getAttribute("companyId") : 0L;
        Map map = service.segMent2(dataSourceId, param, companyId, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;
    }

    @RequestMapping("/je/template/segMent3")
    @ResponseBody
    public ResponseData querySegMent3(@RequestParam(required = false) String jeTrx,@RequestParam(name = "segmentCode3",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                      @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long dataSourceId = getDataSourceId(session, jeTrx);
        Long companyId = session.getAttribute("companyId") != null ? (Long) session.getAttribute("companyId") : 0L;
        Map map = service.segMent3(dataSourceId, param, companyId, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;
    }

    @RequestMapping("/je/template/segMent4")
    @ResponseBody
    public ResponseData querySegMent4(@RequestParam(required = false) String jeTrx,@RequestParam(name = "segmentCode4",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                      @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long dataSourceId = getDataSourceId(session, jeTrx);
        Long companyId = session.getAttribute("companyId") != null ? (Long) session.getAttribute("companyId") : 0L;
        Map map = service.segMent4(dataSourceId, param, companyId, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;
    }

    @RequestMapping("/je/template/segMent5")
    @ResponseBody
    public ResponseData querySegMent5(@RequestParam(required = false) String jeTrx,@RequestParam(name = "segmentCode5",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                      @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long dataSourceId = getDataSourceId(session, jeTrx);
        Long companyId = session.getAttribute("companyId") != null ? (Long) session.getAttribute("companyId") : 0L;
        Map map = service.segMent5(dataSourceId, param, companyId, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;
    }

    @RequestMapping("/je/template/segMent6")
    @ResponseBody
    public ResponseData querySegMent6(@RequestParam(required = false) String jeTrx,@RequestParam(name = "segmentCode6",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                      @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long dataSourceId = getDataSourceId(session, jeTrx);
        Long companyId = session.getAttribute("companyId") != null ? (Long) session.getAttribute("companyId") : 0L;
        Map map = service.segMent6(dataSourceId, param, companyId, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;
    }

    @RequestMapping("/je/template/segMent7")
    @ResponseBody
    public ResponseData querySegMent7(@RequestParam(required = false) String jeTrx,@RequestParam(name = "segmentCode7",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                      @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long dataSourceId = getDataSourceId(session, jeTrx);
        Long companyId = session.getAttribute("companyId") != null ? (Long) session.getAttribute("companyId") : 0L;
        Map map = service.segMent7(dataSourceId, param, companyId, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;
    }

    @RequestMapping("/je/template/segMent8")
    @ResponseBody
    public ResponseData querySegMent8(@RequestParam(required = false) String jeTrx,@RequestParam(name = "segmentCode8",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                      @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long dataSourceId = getDataSourceId(session, jeTrx);
        Long companyId = session.getAttribute("companyId") != null ? (Long) session.getAttribute("companyId") : 0L;
        Map map = service.segMent8(dataSourceId, param, companyId, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;
    }

    @RequestMapping("/je/template/segMent9")
    @ResponseBody
    public ResponseData querySegMent9(@RequestParam(required = false) String jeTrx,@RequestParam(name = "segmentCode9",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                      @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long dataSourceId = getDataSourceId(session, jeTrx);
        Long companyId = session.getAttribute("companyId") != null ? (Long) session.getAttribute("companyId") : 0L;
        Map map = service.segMent9(dataSourceId, param, companyId, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;
    }

    @RequestMapping("/je/template/segMent10")
    @ResponseBody
    public ResponseData querySegMent10(@RequestParam(required = false) String jeTrx,@RequestParam(name = "segmentCode10",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                       @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long dataSourceId = getDataSourceId(session, jeTrx);
        Long companyId = session.getAttribute("companyId") != null ? (Long) session.getAttribute("companyId") : 0L;
        Map map = service.segMent10(dataSourceId, param, companyId, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;
    }

    @RequestMapping("/je/template/JeHdRule")
    @ResponseBody
    public ResponseData queryJeHdRule(@RequestParam(required = false) String jeTrx,@RequestParam(name = "jeHdRuleValue",required = false) String param, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                      @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long dataSourceId = getDataSourceId(session, jeTrx);
        Map map = service.jeHdRule(dataSourceId, param, page, pageSize);
        ResponseData rs = new ResponseData((List<?>) map.get("list"));
        rs.setTotal((Long) map.get("total"));
        return rs;
    }

    /**
     * 根据session中的companyId和jetrx获取数据源ID,没有则返回为空
     *
     * @param session
     * @param jeTrx
     * @return
     */
    private Long getDataSourceId(HttpSession session, String jeTrx) {
        if (jeTrx != null && session != null) {
            jeRuleEngine.setCompanyId((Long) session.getAttribute("companyId"));
            jeRuleEngine.setJeTrx(jeTrx);
            JeRuleEngine result = ruleEngineMapper.selectOne(jeRuleEngine);
            return result.getDataSourceId();
        }
        return null;
    }


}
