package hls.core.gld.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.JeTrxDtl;
import hls.core.gld.service.IJeTrxDtlService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Controller
public class JeTrxDtlController extends BaseController {

    @Autowired
    private IJeTrxDtlService service;


    @RequestMapping(value = "/gld/je/trx/dtl/query")
    @ResponseBody
    public ResponseData query(JeTrxDtl dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/gld/je/trx/dtl/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request, @RequestBody List<JeTrxDtl> dto) {
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/gld/je/trx/dtl/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<JeTrxDtl> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }

    @RequestMapping(value = "/gld/je/trx/dtl/api")
    @ResponseBody
    public ResponseData madeTrxDtl(HttpServletRequest request) {
        HashMap map = new HashMap();
        IRequest requestCtx = createRequestContext(request);
        service.jeTrxMade(requestCtx,map);
        return new ResponseData();
    }

    @RequestMapping(value = "/gld/je/trx/dtl/createLine")
    @ResponseBody
    public ResponseData createJeLine(HttpServletRequest request,@RequestBody List<Long> ids) {
        IRequest requestCtx = createRequestContext(request);
        service.createJeLine(requestCtx,ids);
        return new ResponseData();
    }

    /*待生成清单查询*/
    @RequestMapping(value = "/gld/je/trx/dtl/queryWaitGenerate")
    @ResponseBody
    public ResponseData queryWaitGenerate(@RequestBody(required = false) JeTrxDtl dto, HttpServletRequest request,
                                          @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                          @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize) {
        IRequest requestContext = createRequestContext(request);
        Long companyId = requestContext.getCompanyId();
        dto.setCompanyId(companyId);
        return new ResponseData(service.waitGenerateList(dto,page,pagesize));
    }

    /**
     * 待生成清单综合查询
     * @param
     * @return
     */
    @RequestMapping(value = "/gld/gld320aJeTrxDtlnQuery")
    @ResponseBody
    public ResponseData gld320aJeTrxDtlQuery(JeTrxDtl jeTrxDtl, final HttpServletRequest request,
                                                   @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                                   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
        IRequest iRequest = createRequestContext(request);
        List<JeTrxDtl> list= service.gld320aJeTrxDtlQuery(jeTrxDtl,iRequest,page,pagesize);
        return new ResponseData(list);
    }

}

