package hls.core.gld.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.Period;
import hls.core.gld.service.IPeriodService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

@Controller
public class PeriodController extends BaseController {

    @Autowired
    private IPeriodService service;


    @RequestMapping(value = "/gld/period/query")
    @ResponseBody
    public ResponseData query(Period dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/gld/period/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request, @RequestBody List<Period> dto) {
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/gld/period/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<Period> dto) {

        List<Period> periods = new ArrayList<>();

        dto.forEach(child -> {
            Period period = new Period();
            period.setPeriodName(child.getPeriodName());
            periods.add(period);
        });

        service.batchDelete(periods);
        return new ResponseData();
    }

    @RequestMapping(value = "/gld/period/create")
    @ResponseBody
    public ResponseData create(HttpServletRequest request, @RequestBody HashMap param) {
        IRequest requestCtx = createRequestContext(request);
        service.periodCreate(requestCtx, param);
        return new ResponseData();
    }

    @RequestMapping(value = "/gld/period/query4lov")
    @ResponseBody
    public ResponseData query4lovPeriod(Period dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        Long companyId = (Long) session.getAttribute("companyId");
        dto.setCompanyId(companyId);
        return new ResponseData(service.periodQuery4Lov(requestContext, dto, page, pageSize));

    }
}