package hls.core.gld.controllers;

import hls.core.gld.exception.CodeException;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.PeriodSet;
import hls.core.gld.service.IPeriodSetService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

    @Controller
    public class PeriodSetController extends BaseController{

    @Autowired
    private IPeriodSetService service;


    @RequestMapping(value = "/gld/period/set/query")
    @ResponseBody
    public ResponseData query(PeriodSet dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/gld/period/set/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<PeriodSet> dto) throws CodeException {
        IRequest requestCtx = createRequestContext(request);

        List<PeriodSet> list = new ArrayList<PeriodSet>();
        try {
           list = service.batchUpdate(requestCtx, dto);
        }catch (Exception e){
            throw new CodeException();
        }

        return new ResponseData(list);
    }

    @RequestMapping(value = "/gld/period/set/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<PeriodSet> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }