package hls.core.gld.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.PeriodStatus;
import hls.core.gld.service.IPeriodStatusService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

@Controller
public class PeriodStatusController extends BaseController {

    @Autowired
    private IPeriodStatusService service;


    @RequestMapping(value = "/gld/period/status/query")
    @ResponseBody
    public ResponseData query(PeriodStatus dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    /*查询包括本月在内的上下两个月的期间信息*/
    @RequestMapping(value = "/gld/period/status/queryFivePeriod")
    @ResponseBody
    public ResponseData queryFivePeriod(PeriodStatus dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long companyId = (Long) session.getAttribute("companyId");
        dto.setCompanyId(companyId);
        return new ResponseData(service.queryFivePeriod(dto));
    }

    @RequestMapping(value = "/gld/period/status/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request, HttpSession session, @RequestBody List<PeriodStatus> dto) {
        IRequest requestCtx = createRequestContext(request);
        dto.forEach(item -> item.setCompanyId((Long) session.getAttribute("companyId")));
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/gld/period/status/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<PeriodStatus> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }
}