package hls.core.gld.controllers;

import hls.core.gld.exception.CodeException;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.gld.dto.SetOfBooks;
import hls.core.gld.service.ISetOfBooksService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

    @Controller
    public class SetOfBooksController extends BaseController{

    @Autowired
    private ISetOfBooksService service;


    @RequestMapping(value = "/gld/set/of/books/query")
    @ResponseBody
    public ResponseData query(SetOfBooks dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/gld/set/of/books/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<SetOfBooks> dto) throws CodeException {
        IRequest requestCtx = createRequestContext(request);

        List<SetOfBooks> list = new ArrayList<SetOfBooks>();
        try {
           list  = service.batchUpdate(requestCtx, dto);
        }catch (Exception e){
            throw new CodeException();
        }
        return new ResponseData(list);
    }

    @RequestMapping(value = "/gld/set/of/books/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<SetOfBooks> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

    @RequestMapping(value = "/gld/set/of/books/baseQuery")
    @ResponseBody
    public ResponseData baseQuery(SetOfBooks dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.baseSelect(requestContext,dto,page,pageSize));
    }
    }