package hls.core.gld.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.DTOStatus;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.gld.dto.Account;
import hls.core.gld.dto.AccountHierarchyDtl;
import hls.core.gld.mapper.AccountHierarchyDtlMapper;
import hls.core.gld.mapper.AccountHierarchyMapper;
import hls.core.gld.mapper.AccountMapper;
import hls.core.gld.service.IAccountHierarchyDtlService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.gld.dto.AccountHierarchy;
import hls.core.gld.service.IAccountHierarchyService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional
public class AccountHierarchyServiceImpl extends BaseServiceImpl<AccountHierarchy> implements IAccountHierarchyService{

    @Autowired
    private AccountMapper accountMapper;

    @Autowired
    private AccountHierarchyDtlMapper accountHierarchyDtlMapper;


    @Override
    public List<AccountHierarchy> batchUpdate(IRequest request, List<AccountHierarchy> list) {

        list.forEach(child->{

            Long accountId = child.getAccountId();
            Account account = new Account();
            account.setAccountId(accountId);
            Account parent = accountMapper.selectOne(account);
            Long parentId = parent.getAccountId();

            switch (child.get__status()){
                case DTOStatus.ADD:
                    this.insertSelective(request, child);
                    break;
                case DTOStatus.UPDATE:
                    if (useSelectiveUpdate()) {
                        this.updateByPrimaryKeySelective(request, child);
                    } else {
                        this.updateByPrimaryKey(request, child);
                    }
                    break;
                case DTOStatus.DELETE:
                    this.deleteByPrimaryKey(child);
                    AccountHierarchyDtl dtl = new AccountHierarchyDtl();
                    dtl.setParentAccountId(parentId);
                    accountHierarchyDtlMapper.delete(dtl);
                    break;
                default:
                    break;
            }
        });

        return list;
    }

}