package hls.core.gld.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.gld.dto.AccountHierarchy;
import hls.core.gld.dto.AccountHierarchyDtl;
import hls.core.gld.mapper.AccountHierarchyDtlMapper;
import hls.core.gld.mapper.AccountHierarchyMapper;
import hls.core.gld.mapper.AccountMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.gld.dto.Account;
import hls.core.gld.service.IAccountService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional
public class AccountServiceImpl extends BaseServiceImpl<Account> implements IAccountService{

    @Autowired
    private AccountMapper accountMapper;
    @Autowired
    private AccountHierarchyMapper accountHierarchyMapper;
    @Autowired
    private AccountHierarchyDtlMapper accountHierarchyDtlMapper;

    @Override
    public List<Account> treeView(Account account, IRequest request) {
        return accountMapper.gldTreeView(account);
    }

    @Override
    public int batchDelete(List<Account> list) {

        list.forEach(item->{
            Long accountId = item.getAccountId();
            AccountHierarchy accountHierarchy = new AccountHierarchy();
            accountHierarchy.setAccountId(accountId);
            AccountHierarchyDtl accountHierarchyDtl = new AccountHierarchyDtl();
            accountHierarchyDtl.setParentAccountId(accountId);
            accountHierarchyDtlMapper.delete(accountHierarchyDtl);
            accountHierarchyMapper.delete(accountHierarchy);
        });

        return super.batchDelete(list);
    }

}