package hls.core.gld.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.gld.dto.Account;
import hls.core.gld.dto.AccountSegment;
import hls.core.gld.dto.SetOfBooks;
import hls.core.gld.mapper.AccountMapper;
import hls.core.gld.mapper.AccountSegmentMapper;
import hls.core.gld.mapper.FinancialAttributeMapper;
import hls.core.gld.mapper.SetOfBooksMapper;
import hls.core.gld.service.IAccountSegmentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.gld.dto.FinancialAttribute;
import hls.core.gld.service.IFinancialAttributeService;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;

@Service
@Transactional
public class FinancialAttributeServiceImpl extends BaseServiceImpl<FinancialAttribute> implements IFinancialAttributeService{

    @Autowired
    private FinancialAttributeMapper financialAttributeMapper;
    @Autowired
    private AccountMapper accountMapper;
    @Autowired
    private SetOfBooksMapper setOfBooksMapper;
    @Autowired
    private IAccountSegmentService accountSegmentService;

    @Override
    public HashMap companyFinancial(FinancialAttribute financialAttribute) {
        return financialAttributeMapper.companyFinancial(financialAttribute);
    }

    @Override
    public FinancialAttribute save(IRequest request, FinancialAttribute financialAttribute) {

        financialAttributeMapper.insertSelective(financialAttribute);

        SetOfBooks setOfBooks = new SetOfBooks();
        setOfBooks.setSetOfBooksId(financialAttribute.getSetOfBooksId());

        setOfBooks = setOfBooksMapper.selectOne(setOfBooks);//查出对应的账套
        Long accountSetId = setOfBooks.getAccountSetId();//拿到账套ID

        Account account = new Account();
        account.setAccountSetId(accountSetId);

        List<Account> list = accountMapper.select(account);
        list.forEach(item->{
            AccountSegment accountSegment = new AccountSegment();
            accountSegment.setAccountId(item.getAccountId());
            accountSegment.setCompanyId(financialAttribute.getCompanyId());
            accountSegment.setSegment1("N");
            accountSegment.setSegment2("N");
            accountSegment.setSegment3("N");
            accountSegment.setSegment4("N");
            accountSegment.setSegment5("N");
            accountSegment.setSegment6("N");
            accountSegment.setSegment7("N");
            accountSegment.setSegment8("N");
            accountSegment.setSegment9("N");
            accountSegment.setSegment10("N");
            accountSegmentService.self().insertSelective(request,accountSegment);
        });

        return financialAttribute;
    }
}