package hls.core.gld.service.impl;

import com.github.pagehelper.PageHelper;
import hls.core.gld.mapper.JeTemplateLovMapper;
import hls.core.hls.dto.HlsDbDataSourceColumn;
import hls.core.hls.mapper.HlsDbDataSourceColumnMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 凭证模板LOV
 * Created by fjm on 2017/8/10.
 */
@Service
@Transactional(readOnly = true)
public class JeTemplateLovService {


    @Autowired
    private HlsDbDataSourceColumnMapper dataSourceColumnMapper;

    @Autowired
    private JeTemplateLovMapper jeTemplateLovMapper;


    /**
     * 获取数据源中定义的所有列
     *
     * @param dataSourceId
     * @return
     */
    private List<HlsDbDataSourceColumn> getColumn(Long dataSourceId) {
        HlsDbDataSourceColumn column = new HlsDbDataSourceColumn();
        column.setDataSourceId(dataSourceId);
        return dataSourceColumnMapper.select(column);
    }


    public Map companyLov(Long dataSourceId, String param, int page, int pageSize) {
        List<Map> maps = jeTemplateLovMapper.companyLovData(dataSourceId);
        if (param != null) {
            Map map = new HashMap<>();
            map.put("param", param);
            maps = queryLike(maps, map);
        }
        Map map = new HashMap<>();
        map.put("list", page(maps, page, pageSize));
        map.put("total", new Long((long) maps.size()));
        return map;
    }

    public Map accountLov(Long dataSourceId, String param, int page, int pageSize) {
        List<Map> maps = jeTemplateLovMapper.accountLovData(dataSourceId);
        if (param != null) {
            Map map = new HashMap<>();
            map.put("param", param);
            maps = queryLike(maps, map);
        }
        Map map = new HashMap<>();
        map.put("list", page(maps, page, pageSize));
        map.put("total", new Long((long) maps.size()));
        return map;
    }

    public Map costCentertLov(Long companyId, String param, Long dataSourceId, int page, int pageSize) {
        List<Map> maps = jeTemplateLovMapper.costCenterLovData(companyId, dataSourceId);
        if (param != null) {
            Map map = new HashMap<>();
            map.put("param", param);
            maps = queryLike(maps, map);
        }
        Map map = new HashMap<>();
        map.put("list", page(maps, page, pageSize));
        map.put("total", new Long((long) maps.size()));
        return map;
    }

    public Map currencyLov(Long dataSourceId, String param, int page, int pageSize) {
        List<Map> maps = jeTemplateLovMapper.currencyLovData(dataSourceId);
        if (param != null) {
            Map map = new HashMap<>();
            map.put("param", param);
            maps = queryLike(maps, map);
        }
        Map map = new HashMap<>();
        map.put("list", page(maps, page, pageSize));
        map.put("total", new Long((long) maps.size()));
        return map;
    }

    public Map jeDateLov(Long dataSourceId, String param, int page, int pageSize) {
        List<HlsDbDataSourceColumn> list = getColumn(dataSourceId);
        List<Map> maps = new ArrayList<>();
        list.forEach(item -> {
            Map map = new HashMap<>();
            map.put("jeDateKey", "TRX---" + item.getColumnName());
            map.put("jeDateValue", "数据源---" + item.getDescription());
            maps.add(map);
        });
        Map map = new HashMap<>();
        Map params = null;
        if (param!=null){
            params = new HashMap<>();
            params.put("param",param);
        }
        map.put("list", page(queryLike(maps,params), page, pageSize));
        map.put("total", new Long((long) list.size()));
        return map;
    }

    public Map drCrLov(Long dataSourceId, String param, int page, int pageSize) {
        List<HlsDbDataSourceColumn> list = getColumn(dataSourceId);
        List<Map> maps = new ArrayList<>();
        list.forEach(item -> {
            Map map = new HashMap<>();
            map.put("drCrKey", "TRX---" + item.getColumnName());
            map.put("drCrValue", "数据源---" + item.getDescription());
            maps.add(map);
        });
        Map map = new HashMap<>();
        Map params = null;
        if (param!=null){
            params = new HashMap<>();
            params.put("param",param);
        }
        map.put("list", page(queryLike(maps,params), page, pageSize));
        map.put("total", new Long((long) list.size()));
        return map;
    }


    public Map drAmount(Long dataSourceId, String param, int page, int pageSize) {
        List<HlsDbDataSourceColumn> list = getColumn(dataSourceId);
        List<Map> maps = new ArrayList<>();
        list.forEach(item -> {
            Map map = new HashMap<>();
            map.put("drAmountKey", "TRX---" + item.getColumnName());
            map.put("drAmountValue", "数据源---" + item.getDescription());
            maps.add(map);
        });
        Map map = new HashMap<>();
        Map params = null;
        if (param!=null){
            params = new HashMap<>();
            params.put("param",param);
        }
        map.put("list", page(queryLike(maps,params), page, pageSize));
        map.put("total", new Long((long) list.size()));
        return map;
    }

    public Map crAmount(Long dataSourceId, String param, int page, int pageSize) {
        List<HlsDbDataSourceColumn> list = getColumn(dataSourceId);
        List<Map> maps = new ArrayList<>();
        list.forEach(item -> {
            Map map = new HashMap<>();
            map.put("crAmountKey", "TRX---" + item.getColumnName());
            map.put("crAmountValue", "数据源---" + item.getDescription());
            maps.add(map);
        });
        Map map = new HashMap<>();
        Map params = null;
        if (param!=null){
            params = new HashMap<>();
            params.put("param",param);
        }
        map.put("list", page(queryLike(maps,params), page, pageSize));
        map.put("total", new Long((long) list.size()));
        return map;
    }

    public Map drFunctionAmount(Long dataSourceId, String param, int page, int pageSize) {
        List<HlsDbDataSourceColumn> list = getColumn(dataSourceId);
        List<Map> maps = new ArrayList<>();
        list.forEach(item -> {
            Map map = new HashMap<>();
            map.put("drFunctionAmountKey", "TRX---" + item.getColumnName());
            map.put("drFunctionAmountValue", "数据源---" + item.getDescription());
            maps.add(map);

        });
        Map map = new HashMap<>();
        Map params = null;
        if (param!=null){
            params = new HashMap<>();
            params.put("param",param);
        }
        map.put("list", page(queryLike(maps,params), page, pageSize));
        map.put("total", new Long((long) list.size()));
        return map;
    }

    public Map crFunctionAmount(Long dataSourceId, String param, int page, int pageSize) {
        List<HlsDbDataSourceColumn> list = getColumn(dataSourceId);
        List<Map> maps = new ArrayList<>();
        list.forEach(item -> {
            Map map = new HashMap<>();
            map.put("crFunctionAmountKey", "TRX---" + item.getColumnName());
            map.put("crFunctionAmountValue", "数据源---" + item.getDescription());
            maps.add(map);

        });
        Map map = new HashMap<>();
        Map params = null;
        if (param!=null){
            params = new HashMap<>();
            params.put("param",param);
        }
        map.put("list", page(queryLike(maps,params), page, pageSize));
        map.put("total", new Long((long) list.size()));
        return map;
    }

    public Map exchangeRate(Long dataSourceId, String param, int page, int pageSize) {
        List<HlsDbDataSourceColumn> list = getColumn(dataSourceId);
        List<Map> maps = new ArrayList<>();
        list.forEach(item -> {
            Map map = new HashMap<>();
            map.put("exchangeRateKey", "TRX---" + item.getColumnName());
            map.put("exchangeRateValue", "数据源---" + item.getDescription());
            maps.add(map);
        });
        Map map = new HashMap<>();
        Map params = null;
        if (param!=null){
            params = new HashMap<>();
            params.put("param",param);
        }
        map.put("list", page(queryLike(maps,params), page, pageSize));
        map.put("total", new Long((long) list.size()));
        return map;
    }


    public Map segMent1(Long dataSourceId, String param, Long companyId, int page, int pageSize) {
        List<Map> maps = jeTemplateLovMapper.segment1LovData(dataSourceId, companyId);
        if (param != null) {
            Map map = new HashMap<>();
            map.put("param", param);
            maps = queryLike(maps, map);
        }
        Map map = new HashMap<>();
        map.put("list", page(maps, page, pageSize));
        map.put("total", new Long((long) maps.size()));
        return map;
    }

    public Map segMent2(Long dataSourceId, String param, Long companyId, int page, int pageSize) {
        List<Map> maps = jeTemplateLovMapper.segment2LovData(dataSourceId, companyId);
        if (param != null) {
            Map map = new HashMap<>();
            map.put("param", param);
            maps = queryLike(maps, map);
        }
        Map map = new HashMap<>();
        map.put("list", page(maps, page, pageSize));
        map.put("total", new Long((long) maps.size()));
        return map;
    }

    public Map segMent3(Long dataSourceId, String param, Long companyId, int page, int pageSize) {
        List<Map> maps = jeTemplateLovMapper.segment3LovData(dataSourceId, companyId);
        if (param != null) {
            Map map = new HashMap<>();
            map.put("param", param);
            maps = queryLike(maps, map);
        }
        Map map = new HashMap<>();
        map.put("list", page(maps, page, pageSize));
        map.put("total", new Long((long) maps.size()));
        return map;
    }

    public Map segMent4(Long dataSourceId, String param, Long companyId, int page, int pageSize) {
        List<Map> maps = jeTemplateLovMapper.segment4LovData(dataSourceId, companyId);
        if (param != null) {
            Map map = new HashMap<>();
            map.put("param", param);
            maps = queryLike(maps, map);
        }
        Map map = new HashMap<>();
        map.put("list", page(maps, page, pageSize));
        map.put("total", new Long((long) maps.size()));
        return map;
    }

    public Map segMent5(Long dataSourceId, String param, Long companyId, int page, int pageSize) {
        List<Map> maps = jeTemplateLovMapper.segment5LovData(dataSourceId, companyId);
        if (param != null) {
            Map map = new HashMap<>();
            map.put("param", param);
            maps = queryLike(maps, map);
        }
        Map map = new HashMap<>();
        map.put("list", page(maps, page, pageSize));
        map.put("total", new Long((long) maps.size()));
        return map;
    }

    public Map segMent6(Long dataSourceId, String param, Long companyId, int page, int pageSize) {
        List<Map> maps = jeTemplateLovMapper.segment6LovData(dataSourceId, companyId);
        if (param != null) {
            Map map = new HashMap<>();
            map.put("param", param);
            maps = queryLike(maps, map);
        }
        Map map = new HashMap<>();
        map.put("list", page(maps, page, pageSize));
        map.put("total", new Long((long) maps.size()));
        return map;
    }

    public Map segMent7(Long dataSourceId, String param, Long companyId, int page, int pageSize) {
        List<Map> maps = jeTemplateLovMapper.segment7LovData(dataSourceId, companyId);
        if (param != null) {
            Map map = new HashMap<>();
            map.put("param", param);
            maps = queryLike(maps, map);
        }
        Map map = new HashMap<>();
        map.put("list", page(maps, page, pageSize));
        map.put("total", new Long((long) maps.size()));
        return map;
    }

    public Map segMent8(Long dataSourceId, String param, Long companyId, int page, int pageSize) {
        List<Map> maps = jeTemplateLovMapper.segment8LovData(dataSourceId, companyId);
        if (param != null) {
            Map map = new HashMap<>();
            map.put("param", param);
            maps = queryLike(maps, map);
        }
        Map map = new HashMap<>();
        map.put("list", page(maps, page, pageSize));
        map.put("total", new Long((long) maps.size()));
        return map;
    }

    public Map segMent9(Long dataSourceId, String param, Long companyId, int page, int pageSize) {
        List<Map> maps = jeTemplateLovMapper.segment9LovData(dataSourceId, companyId);
        if (param != null) {
            Map map = new HashMap<>();
            map.put("param", param);
            maps = queryLike(maps, map);
        }
        Map map = new HashMap<>();
        map.put("list", page(maps, page, pageSize));
        map.put("total", new Long((long) maps.size()));
        return map;
    }

    public Map segMent10(Long dataSourceId, String param, Long companyId, int page, int pageSize) {
        List<Map> maps = jeTemplateLovMapper.segment10LovData(dataSourceId, companyId);
        if (param != null) {
            Map map = new HashMap<>();
            map.put("param", param);
            maps = queryLike(maps, map);
        }
        Map map = new HashMap<>();
        map.put("list", page(maps, page, pageSize));
        map.put("total", new Long((long) maps.size()));
        return map;
    }

    public Map jeHdRule(Long dataSourceId, String param, int page, int pageSize) {
        List<Map> maps = jeTemplateLovMapper.jeHdRuleLovData(dataSourceId);
        if (param != null) {
            Map map = new HashMap<>();
            map.put("param", param);
            maps = queryLike(maps, map);
        }
        Map map = new HashMap<>();
        map.put("list", page(maps, page, pageSize));
        map.put("total", new Long((long) maps.size()));
        return map;
    }

    /**
     * 对手动拼接的list进行分页
     *
     * @param list
     * @param page
     * @param pageSize
     * @return
     */
    private List<Map> page(List<Map> list, int page, int pageSize) {
        if (list == null || list.isEmpty())
            return list;
        int from = pageSize * (page - 1);
        int to = pageSize * page;
        if (list.size() < to)
            return list.subList(from, list.size());
        return list.subList(from, to);
    }


    /**
     * list模拟模糊查询
     * @param mAllList 被查询列表
     * @param map 查询条件
     * @return
     */
    public List<Map> queryLike(final List<Map> mAllList, final Map map) {
        if (mAllList.isEmpty() || mAllList == null || map == null) {
            return mAllList;
        }
        final List<Map> result = new ArrayList<>();
        mAllList.forEach(item -> {
            item.forEach((K, V) -> {
                map.forEach((k, v) -> {
                    if (V.toString().indexOf(v.toString()) != -1) {//符合条件
                        if (result.contains(item))
                            return;
                        result.add(item);
                    }
                });
            });
        });

        return result;
    }

}
