package hls.core.gld.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import org.apache.commons.beanutils.BeanUtils;
import org.springframework.stereotype.Service;
import hls.core.gld.dto.JeTemplate;
import hls.core.gld.service.IJeTemplateService;
import org.springframework.transaction.annotation.Transactional;

import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.util.HashMap;
import java.util.List;


@Service
@Transactional
public class JeTemplateServiceImpl extends BaseServiceImpl<JeTemplate> implements IJeTemplateService {

    private HashMap<String, String> map = new HashMap<>();

    @Override
    public List<JeTemplate> selectWithDesc(IRequest requestContext, JeTemplate dto, int page, int pageSize) {
        List<JeTemplate> jeTemplates = select(requestContext, dto, page, pageSize);
        if (jeTemplates.size()>0){
            JeTemplate jeTemplate = jeTemplates.get(0);
            setDescByBeanUtil(jeTemplate);
            return jeTemplates;
        }else {
            return null;
        }

    }

    /**
     * 使用beanUtils把描述和值重新赋值
     * @param dto
     */
    private void setDescByBeanUtil(JeTemplate dto) {
        Class clazz = dto.getClass();
        Field[] fields = clazz.getDeclaredFields();//获取定义的所有字段
        for (Field field :
                fields) {
            String filedName = field.getName();
            if (filedName.endsWith("Desc")){//找出描述字段(以Desc结尾)
                try {
                    String filedCode = filedName.split("Desc")[0];//lov对应的字段名
                    String filedDesc = filedName;//描述字段名
                    String filedValue =  BeanUtils.getProperty(dto,filedCode);//字段上存储的值
                    splitDto(filedValue);
                    BeanUtils.setProperty(dto,filedCode,map.get("value"));
                    BeanUtils.setProperty(dto,filedDesc,map.get("desc"));
                }catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                }

            }

        }
    }


    /**
     * 根据|||拆分字段上的值与描述
     * @param param
     * @return
     */
    private HashMap<String, String> splitDto(String param) {
        if ((!"".equals(param)) && param != null) {
            String[] result = param.split("\\|\\|\\|");//分隔符号为|||
            if (result.length > 1) {//当值为xxxcode|||xxxdesc时
                map.put("value", result[0]);
                map.put("desc", result[1]);
            } else if (result.length == 1){//当值为xxxcode|||或者xxxcode时
                map.put("value", result[0]);
                map.put("desc", null);
            } else {//只有|||或者值不符合规范时
                map.put("value", null);
                map.put("desc", null);
            }
        } else {
            map.put("value", null);
            map.put("desc", null);
        }
        return map;
    }


}