package hls.core.gld.utils;

import java.util.List;

/**
 * 用于计算irr的工具类
 * Created by fjm on 2017/9/5.
 */
public class IrrUtil {

    public static double irr(List<Double> income) {
        return irr(income, 0.1D);
    }

    public static double irr(List<Double> values, double guess) {
        int maxIterationCount = 20;
        double absoluteAccuracy = 1.0E-007D;

        double x0 = guess;

        int i = 0;
        while (i < maxIterationCount) {
            double fValue = 0.0D;
            double fDerivative = 0.0D;
            for (int k = 0; k < values.size(); k++) {
                fValue += values.get(k) / Math.pow(1.0D + x0, k);
                fDerivative += -k * values.get(k) / Math.pow(1.0D + x0, k + 1);
            }
            double x1 = x0 - fValue / fDerivative;
            if (Math.abs(x1 - x0) <= absoluteAccuracy) {
                return x1;
            }
            x0 = x1;
            i++;
        }
        return (0.0D / 0.0D);
    }

}
