package hls.core.hls.bp.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.bp.dto.HlsCusBpMasterBadRecord;
import hls.core.hls.bp.service.HlsBpMasterBadRecordService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * Created by yang on 2016/11/25.
 */
@Controller
public class HlsBpMasterBadRecordController extends BaseController {



    @Autowired
    private HlsBpMasterBadRecordService service;

    @ResponseBody
    @RequestMapping(value="/hls/bp/master/badRecord/query")
    public ResponseData query(final HlsCusBpMasterBadRecord badRecord, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
        IRequest iRequest = createRequestContext(request);
        List<HlsCusBpMasterBadRecord> records = service.queryByNameOrCode(iRequest, badRecord, page, pagesize);

        return new ResponseData(records);
    }

    @ResponseBody
    @RequestMapping(value="/hls/bp/master/badRecord/crawler")
    public ResponseData crawler(final HttpServletRequest request){
        IRequest iRequest = createRequestContext(request);
        try {
            Map<String, Object> map = service.startCrawler(iRequest);
            return new ResponseData(true);
        } catch (Exception e) {
            Logger logger = LoggerFactory.getLogger(HlsBpMasterBadRecordController.class);
            logger.error("crawler failed");
            logger.error(e.getMessage());
        }
        return new ResponseData(false);
    }
}
