package hls.core.hls.bp.controllers;

import java.util.List;
import javax.servlet.http.HttpServletRequest;

import hls.core.hls.bp.dto.HlsCusBpMasterCompany;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.bp.service.HlsBpMasterCompanyService;

@Controller
public class HlsBpMasterCompanyController extends BaseController
{
	@Autowired
	private HlsBpMasterCompanyService service;
	
	
	@RequestMapping(value = "/hls/bp/company/query")
	@ResponseBody
	public ResponseData query(final HlsCusBpMasterCompany bpMasterCompany, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(service.select(requestContext, bpMasterCompany, page, pagesize));
	}
	
	@RequestMapping(value = "/hls/bp/company/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody final List<HlsCusBpMasterCompany> bpMasterCompanys, final BindingResult result,
                               final HttpServletRequest request){
		 	getValidator().validate(bpMasterCompanys, result);
	        if (result.hasErrors()) {
	            ResponseData responseData = new ResponseData(false);
	            responseData.setMessage(getErrorMessage(result, request));
	            return responseData;
	        }
	        IRequest requestContext = createRequestContext(request);
	        return new ResponseData(service.batchUpdate(requestContext, bpMasterCompanys));
	}
}
