package hls.core.hls.bp.controllers;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.hls.bp.dto.HlsCusBpMasterContactInfo;
import hls.core.hls.bp.service.HlsBpMasterContactInfoService;

@Controller
public class HlsBpMasterContactInfoController extends BaseController
{
	@Autowired
	private HlsBpMasterContactInfoService service;
	
	
	@RequestMapping(value = "/hls/bp/contactInfo/query")
	@ResponseBody
	public ResponseData query(final HlsCusBpMasterContactInfo bpMasterContactInfo, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(service.select(requestContext, bpMasterContactInfo, page, pagesize));
	}
	
	@RequestMapping(value = "/hls/bp/contactInfo/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody final List<HlsCusBpMasterContactInfo> bpMasterContactInfos, final BindingResult result,
                               final HttpServletRequest request){
		 	getValidator().validate(bpMasterContactInfos, result);
	        if (result.hasErrors()) {
	            ResponseData responseData = new ResponseData(false);
	            responseData.setMessage(getErrorMessage(result, request));
	            return responseData;
	        }
	        for(int i=0; i<bpMasterContactInfos.size();i++){
	        	bpMasterContactInfos.get(i).setBpId(bpMasterContactInfos.get(0).getBpId());
			}
	        IRequest requestContext = createRequestContext(request);
	        return new ResponseData(service.batchUpdate(requestContext, bpMasterContactInfos));
	}
}
