package hls.core.hls.bp.controllers;

import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.csh.dto.HlsCusConContractCashflow;
import hls.core.csh.dto.HlsCusCshConContract;
import hls.core.csh.dto.HlsCusCshFundStatistics;
import hls.core.csh.service.IConContractCashflowService;
import hls.core.csh.service.ICshConContractService;
import hls.core.hls.bp.dto.HlsCusBpMaster;
import hls.core.hls.bp.service.HlsBpMasterService;
import hls.core.hls.dto.HlsSystemEvent;
import hls.core.hls.service.HlsSystemEventService;
import hls.core.prj.dto.HlsCusPrjProject;
import hls.core.prj.dto.HlsCusPrjProjectTenant;
import hls.core.prj.service.PrjProjectService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

/**
 * Created by jianwen.zheng on 2017/3/8 0008.
 */
@Controller
public class HlsBpMasterDetailController extends BaseController {

    @Autowired
    private HlsBpMasterService hlsBpMasterService;
    @Autowired
    private ICshConContractService cshConContractService;
    @Autowired
    private IConContractCashflowService conContractCashflowService;
    @Autowired
    private HlsSystemEventService hlsSystemEventService;

    /**
     * 商业伙伴信息查询
     * @param request
     * @param hlsCusBpMaster
     * @param page
     * @param pagesize
     * @param session
     * @return
     */
    @RequestMapping(value = "/hls/BpMasterDetail/news/query")
    @ResponseBody
    public ResponseData news(HttpServletRequest request, final HlsCusBpMaster hlsCusBpMaster,
                             @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                             @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize,
                             HttpSession session){
        List<HlsCusBpMaster> list = hlsBpMasterService.selectAllBpMaster(hlsCusBpMaster,session);
        return new ResponseData(list);
    }

    /**
     * 查询出该商业伙伴最新4条记录
     * @param request
     * @param hlsCusBpMaster
     * @param session
     * @return
     */
    @RequestMapping(value = "/hls/BpMasterDetail/byConId/query")
    @ResponseBody
    public ResponseData selectBpMasterByConId(HttpServletRequest request, final HlsCusBpMaster hlsCusBpMaster, HttpSession session){
        List<HlsSystemEvent> hlsSystemEvent =  hlsSystemEventService.selectBpMasterByConId(hlsCusBpMaster.getBpId());
        return new ResponseData(hlsSystemEvent);
    }

    /**
     * 查询商业伙伴下最新创建的合同
     * @param request
     * @param hlsCusBpMaster
     * @param page
     * @param pagesize
     * @param session
     * @return
     */
    @RequestMapping(value = "/hls/BpMasterDetail/Apply/query")
    @ResponseBody
    public ResponseData apply(HttpServletRequest request,final HlsCusBpMaster hlsCusBpMaster,
                              @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize,
                              HttpSession session){
        HlsCusCshConContract cshConContract = new HlsCusCshConContract();
        cshConContract.setBp_id(hlsCusBpMaster.getBpId());
        List<HlsCusCshConContract> list = cshConContractService.selectUpToDateCshConConTract(cshConContract,session);
        return new ResponseData(list);
    }
    @Autowired
    private  PrjProjectService prjProjectService;
    /**
     * 查找出当前商业伙伴项目-承租人
     * @param request
     * @param prjProjectTenant
     * @param page
     * @param pagesize
     * @return
     */
    @RequestMapping(value = "/hls/BpMasterDetail/tenant/prjProhect/query")
    @ResponseBody
    public ResponseData selectAllTenantPrjProhect(HttpServletRequest request, final HlsCusPrjProjectTenant prjProjectTenant,
                                                  @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                                  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
        List<HlsCusPrjProject> list =  prjProjectService.selectAllTenantPrjProhect(prjProjectTenant,createRequestContext(request),page,pagesize);
        return new ResponseData(list);
    }

    /**
     *  查询商业伙伴下最新创建的起租
     * @param request
     * @param hlsCusBpMaster
     * @param page
     * @param pagesize
     * @param session
     * @return
     */
    @RequestMapping(value = "/hls/BpMasterDetail/onHire/query")
    @ResponseBody
    public ResponseData onHire(HttpServletRequest request,final HlsCusBpMaster hlsCusBpMaster,
                               @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                               @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize,
                               HttpSession session){
        HlsCusCshConContract cshConContract = new HlsCusCshConContract();
        cshConContract.setBp_id(hlsCusBpMaster.getBpId());
        List<HlsCusCshConContract> list = cshConContractService.selectOnHireCshconcontract(cshConContract,session);
        return new ResponseData(list);
    }

    /**
     * 查询商业伙伴下最新回收的租金
     * @param request
     * @param hlsCusBpMaster
     * @param page
     * @param pagesize
     * @param session
     * @return
     */
    @RequestMapping(value = "/hls/BpMasterDetail/hire/query")
    @ResponseBody
    public ResponseData Hire(HttpServletRequest request,final HlsCusBpMaster hlsCusBpMaster,
                             @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                             @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize,
                             HttpSession session){
        HlsCusConContractCashflow conContractCashflow = new HlsCusConContractCashflow();
        conContractCashflow.setPayment_bp_id(hlsCusBpMaster.getBpId());
        List<HlsCusConContractCashflow> list = conContractCashflowService.selectHireConContractCashflow(conContractCashflow,session);
        return new ResponseData(list);
    }

    /**
     * 查询商业伙伴明细概要
     * @param request
     * @param hlsCusBpMaster
     * @param session
     * @return
     */
    @RequestMapping(value = "/hls/BpMasterDetail/general/query")
    @ResponseBody
    public ResponseData general(HttpServletRequest request, final HlsCusBpMaster hlsCusBpMaster, HttpSession session){
        List<HlsCusBpMaster> list = hlsBpMasterService.selectGeneralBpMaster(hlsCusBpMaster,session);
        return new ResponseData(list);
    }

    /**
     * 查询商业伙伴明细 总逾期数
     * @param request
     * @param conContractCashflow
     * @param session
     * @return
     */
    @RequestMapping(value = "/hls/BpMasterDetail/overdue/query")
    @ResponseBody
    public HlsCusConContractCashflow overdue(HttpServletRequest request, final HlsCusConContractCashflow conContractCashflow, HttpSession session){
        HlsCusConContractCashflow ccc  = conContractCashflowService.selectOverdueCount(conContractCashflow,session);
        return ccc;
    }

    /**
     * 查询商业伙伴明细 合同清单 承租人时
     * @param request
     * @param hlsCusBpMaster
     * @param session
     * @return
     */
    @RequestMapping(value = "/hls/BpMasterDetail/bill/tenant/query")
    @ResponseBody
    public ResponseData bill(HttpServletRequest request, final HlsCusBpMaster hlsCusBpMaster, HttpSession session){
        List<HlsCusCshConContract> list = cshConContractService.selectCshConContract(hlsCusBpMaster.getBpId());
        return new ResponseData(list);
    }
    /**
     * 查询商业伙伴明细 合同清单 担保人时
     * @param request
     * @param hlsCusBpMaster
     * @param session
     * @return
     */
    @RequestMapping(value = "/hls/BpMasterDetail/bill/guarantor/query")
    @ResponseBody
    public ResponseData billguarantor(HttpServletRequest request, final HlsCusBpMaster hlsCusBpMaster, HttpSession session){
        List<HlsCusCshConContract> list = cshConContractService.selectCshConContractGuarantor(hlsCusBpMaster.getBpId());
        return new ResponseData(list);
    }
    /**
     * 查询商业伙伴下风险敞口
     * @param request
     * @param hlsCusBpMaster
     * @return
     */
    @RequestMapping(value = "/hls/BpMasterDetail/riskExposure/query")
    @ResponseBody
    public HlsCusCshFundStatistics riskExposure(HttpServletRequest request, final HlsCusBpMaster hlsCusBpMaster){
    	HlsCusCshFundStatistics cshFundStatistics = conContractCashflowService.selectRiskExposure(createRequestContext(request), hlsCusBpMaster);
    	return cshFundStatistics;
    }

    /**
     * 查询商业伙伴下风险敞口
     * @param request
     * @param hlsCusBpMaster
     * @return
     */
    @RequestMapping(value = "/hls/BpMasterDetail/riskExposure/guarantor/query")
    @ResponseBody
    public HlsCusCshFundStatistics riskExposureGuarantor(HttpServletRequest request, final HlsCusBpMaster hlsCusBpMaster){
        HlsCusCshFundStatistics cshFundStatistics = conContractCashflowService.selectRiskGuarantorExposure(createRequestContext(request), hlsCusBpMaster);
        return cshFundStatistics;
    }
}
