package hls.core.hls.bp.controllers;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.hls.bp.dto.HlsBpMasterRole;
import hls.core.hls.bp.service.HlsBpMasterRoleService;

@Controller
public class HlsBpMasterRoleController extends BaseController
{
	@Autowired
	private HlsBpMasterRoleService service;
	
	
	@RequestMapping(value = "/hls/bp/role/query")
	@ResponseBody
	public ResponseData query(final HlsBpMasterRole bpMasterRole, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		List<HlsBpMasterRole> datas = new ArrayList<HlsBpMasterRole>();
		if(!bpMasterRole.getBpType().toString().equals("") && bpMasterRole.getBpId().toString().equals("0")){
			datas = service.queryRoleType(requestContext, bpMasterRole, page, pagesize);
		}else if(!bpMasterRole.getBpType().toString().equals("") && !bpMasterRole.getBpId().toString().equals("0") && !bpMasterRole.getBpId().toString().equals("0")){
			datas = service.queryAll(requestContext, bpMasterRole, page, pagesize);
		}
		return new ResponseData(datas);
	}
	
	@RequestMapping(value = "/hls/bp/type/query")
	@ResponseBody
	public ResponseData queryAll(){
				
		return new ResponseData(service.selectType());
	}
	
	@RequestMapping(value = "/hls/bp/role/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody final List<HlsBpMasterRole> bpMasterRoles, final BindingResult result,
                               final HttpServletRequest request){
		 	getValidator().validate(bpMasterRoles, result);
	        if (result.hasErrors()) {
	            ResponseData responseData = new ResponseData(false);
	            responseData.setMessage(getErrorMessage(result, request));
	            return responseData;
	        }
/*	        List<String> bpTypes = null;
	        if(bpMasterRoles != null)
	        {
	        	bpTypes = service.selectRoleById(bpMasterRoles.get(0).getBpId());
	        }
	       
	        if(bpTypes == null || bpTypes.size() ==0){
	        	try {
					throw new Exception();
				} catch (Exception e) {
					e.printStackTrace();
				}
	        }*/
	        IRequest requestContext = createRequestContext(request);
	        return new ResponseData(service.batchUpdate(requestContext, bpMasterRoles));
	}
	
	//查询所有的商业伙伴类型
	@RequestMapping(value = "/hls/bp/allType/query")
	@ResponseBody
	public ResponseData selectAllType()
	{
		return new ResponseData(service.selectAllType());
	}
}
