package hls.core.hls.bp.mapper;

import com.hand.hap.mybatis.common.Mapper;
import hls.core.hls.bp.dto.HlsCusBpMaster;
import org.apache.ibatis.annotations.Param;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public interface HlsBpMasterMapper<T extends HlsCusBpMaster> extends Mapper<HlsCusBpMaster>{
	List<HlsCusBpMaster> queryById(Long bpId);

	List<HlsCusBpMaster> queryBpIds(Map<String, Object> params);
	
	String selectBpClass(String bpClass);

	String validateCredit(String enterpriseUnifiedCreditCode);

	String validateCardNo(String idCardNo);
	
	List<HlsCusBpMaster> selectBpCount();

	List<HlsCusBpMaster> editQuery(Long bpId);

	List<HlsCusBpMaster> masterDetailQuery(HlsCusBpMaster hlsCusBpMaster);

	List<HlsCusBpMaster> selectCreditLov(HlsCusBpMaster hlsCusBpMaster);

	List<HlsCusBpMaster> selectHlsBpMaster(HlsCusBpMaster hlsCusBpMaster);

	List<HlsCusBpMaster> queryByCodeOrName(HlsCusBpMaster bpMaster);

	List<HlsCusBpMaster> homeFirstQuery(@Param("userId")Long userId);

	List<HlsCusBpMaster> homeFirstQuery2(@Param("userId")Long userId,@Param("bpCategory")String bpCategory,@Param("bpType")String bpType);

	List<HlsCusBpMaster> homeThirdQuery(Long userId);

	List<HlsCusBpMaster> homeThirdQuery2(@Param("userId")Long userId,@Param("bpCategory")String bpCategory,@Param("bpType")String bpType);

	List<HlsCusBpMaster> homeFourQuery();

	List<HlsCusBpMaster> homeSecordQuery();

	List<HlsCusBpMaster> homeQuery(@Param("inputValue")String inputValue);

	List<HlsCusBpMaster> homeQuery2(@Param("inputValue")String inputValue);

	List<HlsCusBpMaster> countQuery();

	List<Map> queryRecieivedPayments(Map map);

	public List<HlsCusBpMaster> selectAllBpMaster(HlsCusBpMaster hlsCusBpMaster);

	public List<HlsCusBpMaster> selectGeneralBpMaster(HlsCusBpMaster hlsCusBpMaster);

	List<Map> invoicMessage(Map map);//开票信息
	List<HlsCusBpMaster> invoicDetail(HlsCusBpMaster hlsCusBpMaster);//开票记录

	List<HashMap> getBpInvoiceInfoByGroup(HashMap map);
	
	public List<HlsCusBpMaster> selectHlsBpMasterById(HlsCusBpMaster bpMaster);

	List<HlsCusBpMaster> getTenantBpInfo(HlsCusBpMaster bpMaster);
	List<HlsCusBpMaster> getGuarantorInfo(HlsCusBpMaster bpMaster);

	List<HlsCusBpMaster> contractBpQuery(@Param("contractId")Long contractId);

	List<Map> getAllCreditCount();

	List<HlsCusBpMaster> queryBpLov(HlsCusBpMaster bpMaster);

	List<HlsCusBpMaster> masterCreditDetailQuery(HlsCusBpMaster bpMaster);

	List<HlsCusBpMaster> queryBpByBpType(HlsCusBpMaster bpMaster);

	/*查询项目所属行业lov*/
	List<HlsCusBpMaster> queryIndustryLov(HlsCusBpMaster bpMaster);
}

