package hls.core.hls.bp.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import edu.uci.ics.crawler4j.crawler.CrawlConfig;
import edu.uci.ics.crawler4j.crawler.CrawlController;
import edu.uci.ics.crawler4j.fetcher.PageFetcher;
import edu.uci.ics.crawler4j.robotstxt.RobotstxtConfig;
import edu.uci.ics.crawler4j.robotstxt.RobotstxtServer;
import hls.core.hls.bp.crawler.Crawler;
import hls.core.hls.bp.dto.HlsCusBpMasterBadRecord;
import hls.core.hls.bp.mapper.HlsCusBpMasterBadRecordMapper;
import hls.core.hls.bp.service.HlsBpMasterBadRecordService;
import org.apache.http.message.BasicHeader;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

/**
 * Created by yang on 2016/11/25.
 */
@Service
@Transactional
public class HlsBpMasterBadRecordServiceImpl extends BaseServiceImpl<HlsCusBpMasterBadRecord> implements HlsBpMasterBadRecordService {
    @Autowired
    private HlsCusBpMasterBadRecordMapper mapper;

    private static Crawler crawler = null;
    private static Boolean isCrawling = false;

    @Override
    public List<HlsCusBpMasterBadRecord> queryByNameOrCode(IRequest iRequest, HlsCusBpMasterBadRecord record, int page, int pageSize) {
        PageHelper.startPage(page, pageSize);
        List<HlsCusBpMasterBadRecord> hlsCusBpMasterBadRecords = mapper.queryByNameOrCode(record);
        return hlsCusBpMasterBadRecords;
    }

    @Override
    public Map<String, Object> startCrawler(IRequest iRequest) throws Exception {
        // 先清除存留的static数据,
        Crawler.setNoCompanyInfo(true);
        Crawler.clearRecords();

        String path = "temp";
        CrawlConfig config = new CrawlConfig();
        config.setCrawlStorageFolder(path);
        config.setUserAgentString("Mozilla/5.0 (Windows NT 6.1; WOW64) " +
                "AppleWebKit/537.36 (KHTML, like Gecko) " +
                "Chrome/54.0.2840.99 Safari/537.36");

        Collection<BasicHeader> defaultHeaders = config.getDefaultHeaders();
        BasicHeader cookie = new BasicHeader("Cookie", "ant_stream_55dde5349653b=1480346697/2182501060");
        defaultHeaders.add(cookie);
        defaultHeaders.add(new BasicHeader("Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8"));
        defaultHeaders.add(new BasicHeader("Referer", "http://www.police.sh.cn/shga/ygjw/toXzcf"));
        defaultHeaders.add(new BasicHeader("Accept-Encoding", "gzip, deflate, sdch"));
        defaultHeaders.add(new BasicHeader("Host", "www.police.sh.cn"));
        defaultHeaders.add(new BasicHeader("Connection", "keep-alive"));

        config.setDefaultHeaders(defaultHeaders);
        PageFetcher pageFetcher = new PageFetcher(config);
        RobotstxtConfig robotstxtConfig = new RobotstxtConfig();
        RobotstxtServer robotstxtServer = new RobotstxtServer(robotstxtConfig, pageFetcher);
        CrawlController controller = new CrawlController(config, pageFetcher, robotstxtServer);

        controller.addSeed("http://www.police.sh.cn/shga/wzXxfbZfgkml/pagaList?pa=0150ec9ce81d4bde0b042ffef9fbb51b11b120eafe4fda67b52008cb1cb5eeb13f1f1f48cf7ba8d139266173c9d1d8a82334d0264a3110dce9c3b4f3251bb779bf3a00ca574997521e509e726093dbaf4e761432ef56538145b1f2eebf98bdaf5225949ee058061bb49bc6dc6185f58f&page=1&type=1");
        controller.startNonBlocking(Crawler.class, 10);
        controller.waitUntilFinish();

        List<HlsCusBpMasterBadRecord> records = Crawler.getRecords();
        for( HlsCusBpMasterBadRecord record : records){
            self().updateByPrimaryKey(iRequest,record);
        }
        return null;
    }


}


