package hls.core.hls.bp.service.impl;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.hls.bp.dto.HlsCusBpMasterRelation;
import hls.core.hls.bp.mapper.HlsCusBpMasterRelationMapper;
import hls.core.hls.bp.service.HlsBpMasterRelationService;
import hls.core.hls.dto.BPRelation;
import hls.core.hls.mapper.BPRelationMapper;

@Service
@Transactional
public class HlsBpMasterRelationServiceImpl extends BaseServiceImpl<HlsCusBpMasterRelation> implements HlsBpMasterRelationService{
	@Autowired
	HlsCusBpMasterRelationMapper mapper;
	
	@Autowired
	BPRelationMapper relationMapper;

	HlsCusBpMasterRelation relation;

	@Override
	public List<HlsCusBpMasterRelation> selectRelationType(Long bpId) {
		// TODO Auto-generated method stub
		return mapper.selectRelationType(bpId);
	}
	@Override
	public List<HlsCusBpMasterRelation> selectRelationCode(Long bpId) {
		// TODO Auto-generated method stub
		return mapper.selectRelationCode(bpId);
	}
	@Override
	public Long queryBpId(String bpCode, String bpName) {
		// TODO Auto-generated method stub
		return mapper.queryBpId(bpCode,bpName);
	}
	@Override
	public List<HlsCusBpMasterRelation> queryAll(IRequest requestContext, HlsCusBpMasterRelation bpMasterRelation, int page,
                                                 int pagesize) {
		// TODO Auto-generated method stub
		PageHelper.startPage(page, pagesize);
		return mapper.queryAll(bpMasterRelation);
	}
	@Override
	public List<HlsCusBpMasterRelation> queryAllType(IRequest requestContext, HlsCusBpMasterRelation bpMasterRelation, int page, int pagesize) {
		// TODO Auto-generated method stub
		PageHelper.startPage(page, pagesize);
		return mapper.queryAllType(bpMasterRelation);
	}
	@Override
	public void batchRelationDelete(List<HlsCusBpMasterRelation> lists) {
		
		if(lists != null)
		{
			for(HlsCusBpMasterRelation list:lists)
			{
				relation = new HlsCusBpMasterRelation();
				
				relation.setBpId(list.getRelationBpId());
				relation.setRelationBpId(list.getBpId());
				relation.setBpRelationType(list.getBpRelationType());
				
				mapper.deleteByPrimaryKey(list);
				mapper.deleteByPrimaryKey(relation);
			}
		}
		
	}
	@Override
	public List<HlsCusBpMasterRelation> batchRelationUpdate(IRequest requestContext, List<HlsCusBpMasterRelation> bpMasterRelations) {
		List<HlsCusBpMasterRelation>  brs = new ArrayList<HlsCusBpMasterRelation>();
		if(bpMasterRelations != null)
		{
			for(HlsCusBpMasterRelation list: bpMasterRelations)
			{
				relation = new HlsCusBpMasterRelation();
				
				relation.setBpId(list.getRelationBpId());
				relation.setRelationBpId(list.getBpId());
				
				BPRelation rm = relationMapper.selectByPrimaryKey(list.getBpRelationType());
				relation.setBpRelationType(rm.getBp_relation_type_op());
				
				self().insertSelective(requestContext,list);
				self().insertSelective(requestContext,relation);
				
				brs.add(list);
			}
		}
		
		return brs;
	}

	@Override
	public List<HlsCusBpMasterRelation> selectBpRelationType(IRequest requestContext, HlsCusBpMasterRelation bpMasterRelation) {
		// TODO Auto-generated method stub
		return mapper.selectBpRelationType(bpMasterRelation);
	}

}
