package hls.core.hls.bp.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.attachment.dto.Attachment;
import com.hand.hap.attachment.dto.SysFile;
import com.hand.hap.attachment.mapper.AttachmentMapper;
import com.hand.hap.attachment.mapper.SysFileMapper;
import com.hand.hap.core.IRequest;
import com.hand.hap.core.annotation.StdWho;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.cont.mapper.HlsCusConContractAttachmentMapper;
import hls.core.hls.bp.dto.HlsCusSysFile;
import hls.core.hls.bp.mapper.HlsCusSysFileMapper;
import hls.core.hls.bp.service.HlsSysFileService;
import hls.core.hls.bp.service.IFileAndAttachService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

@Service
@Transactional
public class HlsSysFileServiceImpl extends BaseServiceImpl<HlsCusSysFile> implements HlsSysFileService{

	@Autowired
	HlsCusSysFileMapper mapper;


	@Autowired
	HlsCusConContractAttachmentMapper contractAttachmentMapper;
	@Autowired
	AttachmentMapper attachmentMapper;
	
    @Autowired
    private SysFileMapper sysFileMapper;

	@Autowired(required = false)
	private IFileAndAttachService iFileAndAttachService;
	
	@Override
	public List<HlsCusSysFile> queryAll(IRequest requestContext, HlsCusSysFile sysFile, int page, int pagesize) {
		PageHelper.startPage(page, pagesize);
		return mapper.queryAll(sysFile);
	}

	@Override
	public void insertFileAndAttach(IRequest requestContext, Attachment attach , @StdWho SysFile sysFile) {
		if (iFileAndAttachService != null) {
			iFileAndAttachService.beforeUpdate(requestContext, attach, sysFile);
		}
		Attachment params = new Attachment();
        params.setSourceType(attach.getSourceType());
        params.setSourceKey(attach.getSourceKey());
        params = attachmentMapper.selectAttachment(params);
        if (params == null) {
            attach.setStartActiveDate(new Date());
            attach.setEndActiveDate(new Date());
            attachmentMapper.insertSelective(attach);
            params = attach;
        }

        sysFile.setAttachmentId(params.getAttachmentId());
        
        sysFileMapper.insertSelective(sysFile);
		if (iFileAndAttachService != null) {
			iFileAndAttachService.afterUpdate(requestContext, attach, sysFile);
		}
	}

	@Override
	public HlsCusSysFile queryByAttachmentId(Long attachmentId) {
		return mapper.queryByAttachmentId(attachmentId);
	}

	@Override
	public List<HlsCusSysFile> selectAllContent(IRequest requestContext, HlsCusSysFile sysFile, int page, int pagesize) {
		PageHelper.startPage(page, pagesize);
		return mapper.selectAllContent(sysFile.getSourceKey()!=null?Long.valueOf(sysFile.getSourceKey()):null);
	}

	@Override
	public List<HlsCusSysFile> selectAllConContent(IRequest requestContext, HlsCusSysFile sysFile, int page, int pagesize) {
		PageHelper.startPage(page, pagesize);
		return mapper.selectAllConContent(sysFile.getSourceKey()!=null?Long.valueOf(sysFile.getSourceKey()):null);
	}

	@Override
	public List<HlsCusSysFile> queryUka(IRequest requestContext, HlsCusSysFile sysFile, int page, int pagesize) {
		PageHelper.startPage(page, pagesize);
		return mapper.queryUka(sysFile.getSourceKey()!=null?Long.valueOf(sysFile.getSourceKey()):null);
	}

	@Override
	public List<HlsCusSysFile> selectByAttachmentId(Long attachmentId) {
		return mapper.selectByAttachmentId(attachmentId);
	}
}
