package hls.core.hls.components;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hand.hap.core.IRequest;
import hls.core.hls.dto.*;
import hls.core.hls.mapper.*;
import hls.core.hls.service.IFndScoreResultDtlService;
import hls.core.hls.service.IFndScoreResultService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * Created by fjm on 2017/6/30.
 */


@Transactional(rollbackFor = Exception.class)
public class CustomerLevelCaculator {

    private Long scoreTargetId; //评分指标ID
    private Long scoreTemplateLnId; //评分指标模板行ID
    private Long scoreTargetValueId; //评分指标值ID
    private FndScoreResultDtl scoreResultDtl;//每一层的数据
    private HlsDbDataSourceColumn hlsDbDataSourceColumn;//通用数据源字段表
    private HlsScoreTarget hlsScoreTarget;//评分指标
    private String columnName;//ds中的columnName字段
    private String targetValueType;//指标值类型
    private FndScoreTemplateLnValue fndScoreTemplateLnValue = new FndScoreTemplateLnValue();//模板行值
    private StringBuffer sqlpart;
    private StringBuffer sqlparam;

    @Autowired
    private FndScoreTemplateHdValueMapper fndScoreTemplateHdValueMapper;
    @Autowired
    private FndScoreTemplateLnMapper fndScoreTemplateLnMapper;
    @Autowired
    private FndScoreTemplateLnValueMapper fndScoreTemplateLnValueMapper;
    @Autowired
    private IFndScoreResultDtlService fndScoreResultDtlService;
    @Autowired
    private HlsDbDataSourceColumnMapper hlsDbDataSourceColumnMapper;
    @Autowired
    private HlsScoreTargetMapper hlsScoreTargetMapper;
    @Autowired
    private IFndScoreResultService fndScoreResultService;
    @Autowired
    private FndScoreResultMapper fndScoreResultMapper;
    @Autowired
    private FndScoreTargetValuesMapper fndScoreTargetValuesMapper;
    @Autowired
    private FndScoreResultDtlMapper fndScoreResultDtlMapper;

    /*
    初次评级计算入口
     */
    public Long calEntry(IRequest request, Long scoreTemplateHdId, JSONObject jsonObject) {

        FndScoreResult result = new FndScoreResult();

        result = fndScoreResultService.insert(request, result);

        FndScoreTemplateHdValue fnd = new FndScoreTemplateHdValue();
        fnd.setScoreTemplateHdId(scoreTemplateHdId);

        Double totalGrad = this.calMain(scoreTemplateHdId, null, jsonObject, result.getScoreResultId(), request);

        String scoreGrade = "";

        //String description = "";

        List<FndScoreTemplateHdValue> FndScoreTemplateHdValues = fndScoreTemplateHdValueMapper.select(fnd);


        for (FndScoreTemplateHdValue child :
                FndScoreTemplateHdValues) {
            String leftBracket = child.getLeftBracket();
            String rightBracket = child.getRightBracket();
            String fromValue = child.getFromValue();
            String toValue = child.getToValue();

            if ("(".equals(child.getLeftBracket())) {
                leftBracket = "<";
            } else if ("[".equals(child.getLeftBracket())) {
                leftBracket = "<=";
            } else if (child.getLeftBracket() == null || "".equals(child.getLeftBracket())) {
                leftBracket = "";
            } else {
                throw new IllegalArgumentException("区间左定义出现错误");
            }

            if (")".equals(child.getRightBracket())) {
                rightBracket = "<";
            } else if ("]".equals(child.getRightBracket())) {
                rightBracket = "<=";
            } else if (child.getRightBracket() == null || "".equals(child.getRightBracket())) {
                rightBracket = "";
            } else {
                throw new IllegalArgumentException("区间右定义出现错误");
            }

            fromValue = child.getFromValue();
            if (fromValue == null)
                fromValue = "0";
            toValue = child.getToValue();
            if (toValue == null)
                toValue = "0";
            sqlparam = new StringBuffer("");
            //拼接出一个sql条件类似于  and fromValue<paramValue<toValue
            if ("".equals(leftBracket) && "0".equals(fromValue)) {
                sqlparam.append("and").append(" ").append(totalGrad.toString()).append(rightBracket).append(toValue);
            } else if ("0".equals(toValue) && "".equals(rightBracket)) {
                sqlparam.append("and").append(" ").append(fromValue).append(leftBracket).append(totalGrad.toString());
            } else {
                sqlparam.append("and").append(" ").append(fromValue).append(leftBracket).append(totalGrad.toString()).append(" and ").append(totalGrad.toString()).append(rightBracket).append(toValue);
            }
            Map map = new HashMap<>();
            map.put("scoreTemplateHdId", scoreTemplateHdId);
            map.put("sqlparam", sqlparam);
            List<FndScoreTemplateHdValue> list = fndScoreTemplateHdValueMapper.getHdValue(map);
            if (list.size() > 0 && list != null) {
                scoreGrade = child.getScoreGrade();
                //description = child.getDescription();
                break;
            }
        }
        /*
        param total_grad scoreTemplateHdId
        根据fnd_score_template_hd_value 匹配并得到总得分的评级
        */
        result.setScoreValue(totalGrad);
        result.setScoreGrade(scoreGrade);
        result.setScoreTemplateHdId(scoreTemplateHdId);
        //result.setDescription(description);
        result.setObjectVersionNumber(null);

        result = fndScoreResultService.self().updateByPrimaryKey(request, result);

        return result.getScoreResultId();
    }


    /*
    主观修改后评级重算入口
     */
    public void entrySec(IRequest request, Long scoreResultId) {

        FndScoreResult fndScoreResult = new FndScoreResult();
        fndScoreResult.setScoreResultId(scoreResultId);
        fndScoreResult = fndScoreResultMapper.selectOne(fndScoreResult);

        Long hid = fndScoreResult.getScoreTemplateHdId();

        Double scorevalue = this.calc(request, scoreResultId, null);

        String scoreGrade = "";

        //String description = "";

        FndScoreTemplateHdValue fnd = new FndScoreTemplateHdValue();
        fnd.setScoreTemplateHdId(hid);
        List<FndScoreTemplateHdValue> FndScoreTemplateHdValues = fndScoreTemplateHdValueMapper.select(fnd);

        for (FndScoreTemplateHdValue child :
                FndScoreTemplateHdValues) {
            String leftBracket = child.getLeftBracket();
            String rightBracket = child.getRightBracket();
            String fromValue = child.getFromValue();
            String toValue = child.getToValue();

            if ("(".equals(child.getLeftBracket())) {
                leftBracket = "<";
            } else if ("[".equals(child.getLeftBracket())) {
                leftBracket = "<=";
            } else if (child.getLeftBracket() == null || "".equals(child.getLeftBracket())) {
                leftBracket = "";
            } else {
                throw new IllegalArgumentException("区间左定义出现错误");
            }

            if (")".equals(child.getRightBracket())) {
                rightBracket = "<";
            } else if ("]".equals(child.getRightBracket())) {
                rightBracket = "<=";
            } else if (child.getRightBracket() == null || "".equals(child.getRightBracket())) {
                rightBracket = "";
            } else {
                throw new IllegalArgumentException("区间右定义出现错误");
            }

            fromValue = child.getFromValue();
            if (fromValue == null)
                fromValue = "0";
            toValue = child.getToValue();
            if (toValue == null)
                toValue = "0";
            sqlparam = new StringBuffer("");

            if ("".equals(leftBracket) && "0".equals(fromValue)) {
                sqlparam.append("and").append(" ").append(scorevalue.toString()).append(rightBracket).append(toValue);
            } else if ("0".equals(toValue) && "".equals(rightBracket)) {
                sqlparam.append("and").append(" ").append(fromValue).append(leftBracket).append(scorevalue.toString());
            } else {
                sqlparam.append("and").append(" ").append(fromValue).append(leftBracket).append(scorevalue.toString()).append(" and ").append(scorevalue.toString()).append(rightBracket).append(toValue);
            }
            Map map = new HashMap<>();
            map.put("scoreTemplateHdId", hid);
            map.put("sqlparam", sqlparam);
            List<FndScoreTemplateHdValue> list = fndScoreTemplateHdValueMapper.getHdValue(map);
            if (list.size() > 0 && list != null) {
                scoreGrade = child.getScoreGrade();
                //description = child.getDescription();
                break;
            }
        }

        fndScoreResult.setScoreValue(scorevalue);
        fndScoreResult.setScoreGrade(scoreGrade);
        fndScoreResult.setScoreTemplateHdId(hid);
        //fndScoreResult.setDescription(description);

        fndScoreResultService.self().updateByPrimaryKey(request, fndScoreResult);

    }

    public Double calc(IRequest iRequest, Long scoreResultId, Long parentId) {
        FndScoreResultDtl dtl = new FndScoreResultDtl();
        dtl.setScoreResultId(scoreResultId);
        List<FndScoreResultDtl> dtls = null;
        List<FndScoreTemplateLn> fndScoreTemplateLns;//当前层所有的模板行的数据
        FndScoreTemplateLn fstln = new FndScoreTemplateLn();
        if (parentId == null) {
            dtls = new ArrayList<>();
            FndScoreResult f = new FndScoreResult();
            f.setScoreResultId(scoreResultId);
            FndScoreResult fsr = fndScoreResultMapper.selectOne(f);
            fstln.setScoreTemplateHdId(fsr.getScoreTemplateHdId());//将获取的模板头的id设置到模板行对象上,用于查询出一个模板头对应的模板行的所有数据
            fndScoreTemplateLns = fndScoreTemplateLnMapper.selectLevelOne(fstln);
            for (FndScoreTemplateLn child :
                    fndScoreTemplateLns) {
                Long lineId = child.getScoreTemplateLnId();
                FndScoreResultDtl fsrd = new FndScoreResultDtl();
                fsrd.setScoreTemplateLnId(lineId);
                fsrd.setScoreResultId(scoreResultId);
                dtls.add(fndScoreResultDtlMapper.selectOne(fsrd));
            }
        } else {
            dtls = new ArrayList<>();
            fstln.setParentLnId(parentId);
            fndScoreTemplateLns = fndScoreTemplateLnMapper.select(fstln);
            for (FndScoreTemplateLn child :
                    fndScoreTemplateLns) {
                Long lineId = child.getScoreTemplateLnId();
                FndScoreResultDtl fsrd = new FndScoreResultDtl();
                fsrd.setScoreTemplateLnId(lineId);
                fsrd.setScoreResultId(scoreResultId);
                dtls.add(fndScoreResultDtlMapper.selectOne(fsrd));
            }
        }

//        // 找到底层节点时退出递归
//        if(dtls == null || dtls.size() < 1){
//            return 0D;
//        }
        // 计算当前层数节点值
        Double totalScore = 0D;
        Double targetScore = 0D;
        for (FndScoreResultDtl d : dtls) {
            if ("N".equals(d.getSummaryFlag())) {
                targetScore = d.getTargetScore();
            } else {
                targetScore = calc(iRequest, scoreResultId, d.getScoreTemplateLnId());
            }

            // 从数据库重新查询出改节点的数据信息
            FndScoreResultDtl newScore = fndScoreResultDtlMapper.selectByPrimaryKey(d.getScoreResultDtlId());
            newScore.setTargetScore(CalculateUtil.mul(newScore.getWeigthValue(), targetScore));
            fndScoreResultDtlService.self().updateByPrimaryKeySelective(iRequest, newScore);
            totalScore = CalculateUtil.add(newScore.getTargetScore(), totalScore);

        }
        return totalScore;
    }


    private Double calMain(Long scoreTemplateHdId, Long parentLnId, JSONObject jsonObject, Long scoreResultId, IRequest request) {

        Double total_score_value = 0D;//本层的总分
        Double dtl_score_value = 0D;//某个明细指标的得分

        HashMap map = new HashMap();

        FndScoreTemplateLn fstln = new FndScoreTemplateLn();

        List<FndScoreTemplateLn> fndScoreTemplateLns;//当前层所有的模板行的数据

        fstln.setScoreTemplateHdId(scoreTemplateHdId);//将获取的模板头的id设置到模板行对象上,用于查询出一个模板头对应的模板行的所有数据

        if (parentLnId != null) {
            fstln.setParentLnId(parentLnId);
            fndScoreTemplateLns = fndScoreTemplateLnMapper.select(fstln);//根据模板的头ID以及parentId找到对应的所有的模板行
        } else { //第一层的parentLnId肯定是为空的
            fndScoreTemplateLns = fndScoreTemplateLnMapper.selectLevelOne(fstln);//查询模板的第一层有哪些模板行数据
        }

        for (FndScoreTemplateLn fndScoreTemplateLn :   //因为一个模板头下可能有多个行,一个模板行下也可能有多个模板行,将获取到的模板行数据循环
                fndScoreTemplateLns) {

            if ("N".equals(fndScoreTemplateLn.getEnabledFlag()))
                continue;

            scoreResultDtl = new FndScoreResultDtl();

            Long sid = null;//定义一个sid用来记录scoreTargetValueId的值

            Long dsColumnId = fndScoreTemplateLn.getDataSourceColumnId();//获取ds中的columnId
            /*
            JSON去取得columnName对应的值,取得分数
            ...
            */
            String value = "";

            if (dsColumnId != null) { //如果dsColumnId的值为空,说明本层没有数据源字段,所以不能通过json拿到对应的数据

                hlsDbDataSourceColumn = new HlsDbDataSourceColumn();
                hlsDbDataSourceColumn.setDataSourceColumnId(dsColumnId);
//                hlsDbDataSourceColumn = hlsDbDataSourceColumnMapper.selectOne(hlsDbDataSourceColumn);
                hlsDbDataSourceColumn = hlsDbDataSourceColumnMapper.selectByPrimaryKey(hlsDbDataSourceColumn);
                columnName = hlsDbDataSourceColumn.getColumnName();//获取columnName

                Long dsId = hlsDbDataSourceColumn.getDataSourceId();//数据源ID为json数据的key

                JSONObject defaultJson = JSON.parseObject(JSON.toJSONString(jsonObject.get(dsId.toString())));
                if (defaultJson != null) {
                    JSONObject defaultValue = JSON.parseObject(JSON.toJSONString(defaultJson.get("default")));
                    if (defaultValue != null) {
                        value = (defaultValue.get(columnName) != null ? defaultValue.get(columnName) : "").toString();//此处待定*************
                        if ("null".equals(value))
                            value = null;
                    } else {
                        throw new IllegalArgumentException("json中的default中没有对应的值");
                    }
                } else {
                    throw new IllegalArgumentException("json中数据id无对应的数据");
                }

            }


            if ("N".equals(fndScoreTemplateLn.getSummaryFlag())) { //当flag为N的时候就是非汇总状态,这一层是最底层,从此开始计算

                if (dsColumnId != null) {
                    map = this.calcDtl(fndScoreTemplateLn, value);//calcDtl方法返回的map中包含了value和grade,可以根据需要取得

                    sid = (Long) map.get("scoreTargetValueId");//非汇总层才能选择指标值,所以只要费汇总层才能有sid

                    dtl_score_value = (Double) map.get("value") != null ? (Double) map.get("value") : 0D;

                    String dtl_score_grade = (String) map.get("grade");

                    scoreResultDtl.setTargetScoreGrade(dtl_score_grade);//非汇总指标有评级
                } else {

                    scoreResultDtl.setTargetScoreGrade(null);
                }

            } else if ("Y".equals(fndScoreTemplateLn.getSummaryFlag())) {//flag为Y则是汇总状态,需要往下一层递归

                dtl_score_value = calMain(scoreTemplateHdId, fndScoreTemplateLn.getScoreTemplateLnId(), jsonObject, scoreResultId, request);
                scoreResultDtl.setTargetScoreGrade(null);//汇总指标暂时只有得分,没有评级

            } else {

                throw new IllegalArgumentException("汇总指标取值错误");

            }

            dtl_score_value = CalculateUtil.mul(dtl_score_value, fndScoreTemplateLn.getWeigthValue() != null ? fndScoreTemplateLn.getWeigthValue() : 0D);

            total_score_value = CalculateUtil.add(dtl_score_value, total_score_value);

            /*
            将每个模板的计算结果插入fnd_score_result_dtl
             */
            scoreResultDtl.setScoreResultId(scoreResultId);
            scoreResultDtl.setParentResultDtlId(scoreResultDtl.getScoreResultDtlId());
            scoreResultDtl.setScoreTemplateLnId(fndScoreTemplateLn.getScoreTemplateLnId());
            scoreResultDtl.setSummaryFlag(fndScoreTemplateLn.getSummaryFlag());
            scoreResultDtl.setScoreTargetId(fndScoreTemplateLn.getScoreTargetId());
            scoreResultDtl.setWeigthValue(fndScoreTemplateLn.getWeigthValue());
            scoreResultDtl.setTargetValue(value);//此处的值暂时不详 7.3
            if (sid != null) //sid为空时不处理
                scoreResultDtl.setScoreTargetValueId(sid);
            else
                scoreResultDtl.setScoreTargetValueId(null);
            scoreResultDtl.setTargetScore(dtl_score_value);
            scoreResultDtl.setTargetScoreOriginal(dtl_score_value);
            scoreResultDtl.setScoreResultDtlId(null);

            fndScoreResultDtlService.self().insert(request, scoreResultDtl);

            //scoreResultDtl = new FndScoreResultDtl();

        }

        return total_score_value;

    }

    private HashMap calcDtl(FndScoreTemplateLn fndScoreTemplateLn, String value) {
        HashMap hash = new HashMap();

        scoreTargetId = fndScoreTemplateLn.getScoreTargetId();//从模板行上拿到评分指标的ID

        hlsScoreTarget = new HlsScoreTarget();
        hlsScoreTarget.setScoreTargetId(scoreTargetId);


        targetValueType = hlsScoreTargetMapper.selectOne(hlsScoreTarget).getTargetValueType();//获取指标值的类型


        if (value != null) {
            //不同的指标值类型,调用的方法不同
            if ("REGION".equals(targetValueType)) {

                hash = this.calRegion(fndScoreTemplateLn, hash, value);

            } else if ("CHAR".equals(targetValueType)) {

                hash = this.calChar(fndScoreTemplateLn, hash, value);

            } else if (targetValueType == null) {
                throw new IllegalArgumentException("指标值类型丢失");
            }

        }
        return hash;
    }

    private HashMap calChar(FndScoreTemplateLn fndScoreTemplateLn, HashMap hash, String dsvalue) {

        scoreTemplateLnId = fndScoreTemplateLn.getScoreTemplateLnId();
        fndScoreTemplateLnValue.setScoreTemplateLnId(scoreTemplateLnId);
        List<FndScoreTemplateLnValue> fndScoreTemplateLnValues = fndScoreTemplateLnValueMapper.select(fndScoreTemplateLnValue);

        //此处的情境指标类型为 字符
        //1.先获取所有的模板对应的所有的指标值
        Long stid = fndScoreTemplateLn.getScoreTargetId();
        FndScoreTargetValues fndScoreTargetValues = new FndScoreTargetValues();
        fndScoreTargetValues.setScoreTargetId(stid);
        fndScoreTargetValues.setFixedTargetValue(dsvalue);  //此处的数据由数据源提供
        fndScoreTargetValues = fndScoreTargetValuesMapper.selectOne(fndScoreTargetValues);

        //2.获取对应的指标值的id
        Long id = fndScoreTargetValues.getScoreTargetValueId();

        for (FndScoreTemplateLnValue child :
                fndScoreTemplateLnValues) {
            if (id.longValue() == child.getScoreTargetValueId().longValue()) {//获得的指标值ID与行值上的指标ID一致时,下一步

                scoreTargetValueId = child.getScoreTargetValueId();//去取得评分指标值的ID

                String grade = child.getScoreGrade();
                Double value = child.getScoreValue();
                Long scoreTargetValueId = child.getScoreTargetValueId();

                hash.put("scoreTargetValueId", scoreTargetValueId);
                hash.put("grade", grade);
                hash.put("value", value);

                break;
            }
        }

        return hash;
    }

    private HashMap calRegion(FndScoreTemplateLn fndScoreTemplateLn, HashMap hash, String dsValue) {

        scoreTemplateLnId = fndScoreTemplateLn.getScoreTemplateLnId();
        fndScoreTemplateLnValue.setScoreTemplateLnId(scoreTemplateLnId);
        List<FndScoreTemplateLnValue> fndScoreTemplateLnValues = fndScoreTemplateLnValueMapper.select(fndScoreTemplateLnValue);

        //此处的情境指标类型为 区间
        //1.先获取所有的模板对应的所有的指标值
        Long stid = fndScoreTemplateLn.getScoreTargetId();
        FndScoreTargetValues fndScoreTargetValues = new FndScoreTargetValues();
        fndScoreTargetValues.setScoreTargetId(stid);

        //找到所有的评分指标值
        List<FndScoreTargetValues> list = fndScoreTargetValuesMapper.select(fndScoreTargetValues);

        String paramValue;
        if (dsValue == null||"".equalsIgnoreCase(dsValue)){
             paramValue = "0";
        }else {
             paramValue = dsValue;//从数据源获取的分数
        }

        //对所有的评分指标值进行遍历 outer外层循环
        outer:
        for (FndScoreTargetValues child :
                list) {

            String leftBracket;
            String rightBracket;
            String fromValue;
            String toValue;
            if ("(".equals(child.getLeftBracket())) {
                leftBracket = "<";
            } else if ("[".equals(child.getLeftBracket())) {
                leftBracket = "<=";
            } else if (child.getLeftBracket() == null || "".equals(child.getLeftBracket())) {
                leftBracket = "";
            } else {
                throw new IllegalArgumentException("区间左定义出现错误");
            }

            if (")".equals(child.getRightBracket())) {
                rightBracket = "<";
            } else if ("]".equals(child.getRightBracket())){
                rightBracket = "<=";
            } else if (child.getRightBracket() == null || "".equals(child.getRightBracket())) {
                rightBracket = "";
            } else {
                throw new IllegalArgumentException("区间右定义出现错误");
            }

            fromValue = child.getFromValue();
            if (fromValue == null)
                fromValue = "0";
            toValue = child.getToValue();
            if (toValue == null)
                toValue = "0";
            sqlpart = new StringBuffer("");
            //拼接出一个sql条件  and fromValue< paramValue and paramValue<toValue
            if ("".equals(leftBracket) && "0".equals(fromValue)) {
                sqlpart.append("and").append(" ").append(paramValue).append(rightBracket).append(toValue);
            } else if ("0".equals(toValue) && "".equals(rightBracket)) {
                sqlpart.append("and").append(" ").append(fromValue).append(leftBracket).append(paramValue);
            } else {
                sqlpart.append("and").append(" ").append(fromValue).append(leftBracket).append(paramValue).append(" and ").append(paramValue).append(rightBracket).append(toValue);
            }
            Map sqlMap = new HashMap<>();
            sqlMap.put("sqlPart", sqlpart.toString());
            sqlMap.put("scoreTargetId", stid);

            List<FndScoreTargetValues> res = fndScoreTargetValuesMapper.getTargetValueObj(sqlMap);//当评分条件符合时,list的size为1
            if (res.size() > 0 && res != null) {
                inner:
                for (FndScoreTemplateLnValue fstlv : //inner内层循环
                        fndScoreTemplateLnValues) {
                    if (child.getScoreTargetValueId().longValue() == fstlv.getScoreTargetValueId().longValue()) {
                        String grade = fstlv.getScoreGrade();
                        Double value = fstlv.getScoreValue();
                        Long scoreTargetValueId = child.getScoreTargetValueId();

                        hash.put("scoreTargetValueId", scoreTargetValueId);
                        hash.put("grade", grade);
                        hash.put("value", value);

                        break outer;//直接跳出两层循环
                    }
                }
            }
        }
        return hash;

    }

}
