package hls.core.hls.controllers;


import com.hand.hap.core.IRequest;
import com.hand.hap.core.exception.TokenException;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.hls.dto.BusinessCategory;
import hls.core.hls.service.IBusinessCgService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created by hailor on 16/6/2.
 */
@Controller
public class BusinessCgController  extends BaseController{

    @Autowired
    private IBusinessCgService iBusinessCgService;

    @RequestMapping("/hls_businessCg/query")
    @ResponseBody
    public ResponseData selectList(HttpServletRequest request, BusinessCategory businessCategory,
                                   @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {
        IRequest iRequest = createRequestContext(request);
       // System.out.println("111111");
        List<BusinessCategory> datas = iBusinessCgService.selectList(businessCategory,page,pagesize);
        return new ResponseData(datas);
    }

    @RequestMapping(value = "/hls_businessCg/submit", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData submit(HttpServletRequest request, @RequestBody List<BusinessCategory> demos)throws TokenException {
        ResponseData rd = null;
        try {
        IRequest iRequest = createRequestContext(request);
        List<BusinessCategory> datas = iBusinessCgService.batchUpdate(iRequest, demos);
        return new ResponseData(datas);
        }catch (Exception e) {
            rd = new ResponseData(false);
            rd.setMessage("商业伙伴类别不可重复！");
            return rd;
        }
    }

    @RequestMapping(value = "/hls_businessCg/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<BusinessCategory> demos) {
        IRequest iRequest = createRequestContext(request);
        iBusinessCgService.businessMasterBatchDelete(demos);
        
        return new ResponseData();
    }

    @RequestMapping("/usage/category/query")
    @ResponseBody
    public ResponseData usageCategory() {
        List<BusinessCategory> datas = iBusinessCgService.usageCategory();
        return new ResponseData(datas);
    }


    @RequestMapping("/bp/master/other/query")
    @ResponseBody
    public ResponseData bpMasterOtherQuery(HttpServletRequest request, BusinessCategory businessCategory,
                                   @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {
        IRequest iRequest = createRequestContext(request);
        List<BusinessCategory> datas = iBusinessCgService.bpMasterOtherQuery(businessCategory,page,pagesize);
        return new ResponseData(datas);
    }
}
