package hls.core.hls.controllers;

import hls.core.hls.dto.BusinessType;
import hls.core.hls.dto.BusinessTypeWork;
import hls.core.hls.service.IBusinessTyService;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created by hailor on 16/6/2.
 */
@Controller
public class BusinessTyController  extends BaseController{

    @Autowired
    private IBusinessTyService iBusinessTyService;

    @RequestMapping("/hls_businessType/query")
    @ResponseBody
    public ResponseData selectList(HttpServletRequest request, BusinessTypeWork businessTypeWork,
                                   @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {
        IRequest iRequest = createRequestContext(request);
       // System.out.println("111111");
        List<BusinessTypeWork> datas = iBusinessTyService.selectList(businessTypeWork);
        return new ResponseData(datas);
    }

    @RequestMapping(value = "/hls_businessType/submit", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData submit(HttpServletRequest request, @RequestBody List<BusinessTypeWork> demos) {
        IRequest iRequest = createRequestContext(request);
        List<BusinessTypeWork> datas = iBusinessTyService.batchUpdate(iRequest, demos);
        return new ResponseData(datas);
    }

    @RequestMapping(value = "/hls_businessType/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<BusinessTypeWork> demos) {
        IRequest iRequest = createRequestContext(request);
        iBusinessTyService.batchDelete(demos);
        return new ResponseData();
    }
}
