package hls.core.hls.controllers;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.hls.dto.BusinessType;
import hls.core.hls.dto.DocumentType;
import hls.core.hls.service.BusinessTypeService;


@Controller
public class BusinessTypeController extends BaseController{
	
	@Autowired
	private BusinessTypeService businessTypeService;
	
	
	@RequestMapping(value = "/fnd200/businessType/query")
	@ResponseBody
	public ResponseData query(final BusinessType businessType, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(businessTypeService.selectList(businessType));
	}
	
	@RequestMapping(value = "/fnd200/businessType/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody final List<BusinessType> businessType, final BindingResult result,
            final HttpServletRequest request){
		 	getValidator().validate(businessType, result);
	        if (result.hasErrors()) {
	            ResponseData responseData = new ResponseData(false);
	            responseData.setMessage(getErrorMessage(result, request));
	            return responseData;
	        }
	        IRequest requestContext = createRequestContext(request);
	        
	        return new ResponseData(businessTypeService.batchUpdate(requestContext, businessType));
	}
	
	@RequestMapping(value="/fnd200/businessType/remove")
	@ResponseBody
	public ResponseData remove(@RequestBody List<BusinessType> businessType){
		businessTypeService.batchDelete(businessType);
		
		return new  ResponseData();
	}
	
}
