package hls.core.hls.controllers;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import com.hand.hap.core.exception.TokenException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.fnd.dto.FndUomType;
import hls.core.hls.dto.DocumentCategory;
import hls.core.hls.service.DocumentCategoryService;


@Controller
public class DocumentCategoryController extends BaseController{
	
	@Autowired
	private DocumentCategoryService documentCategoryService;




	@RequestMapping(value = "/fnd200/category/query")
	@ResponseBody
	public ResponseData query(DocumentCategory documentCategory, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE)  int pagesize,  HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(documentCategoryService.selectList(documentCategory,page, pagesize));

		//return new ResponseData(documentCategoryService.select(requestContext, documentCategory, page, pagesize));
	}
	
	@RequestMapping(value = "/fnd200/category/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody final List<DocumentCategory> documentCategory, final BindingResult result,
            final HttpServletRequest request) throws TokenException {
		ResponseData rd = null;

		 	getValidator().validate(documentCategory, result);
	        if (result.hasErrors()) {
	            ResponseData responseData = new ResponseData(false);
	            responseData.setMessage(getErrorMessage(result, request));
	            return responseData;
	        }
		try {
	        IRequest requestContext = createRequestContext(request);
	        return new ResponseData(documentCategoryService.batchUpdate(requestContext, documentCategory));
		} catch (Exception e) {
			rd = new ResponseData(false);
			rd.setMessage("单据类别不可重复！");
			return rd;
		}

	}
	
	@RequestMapping(value="/fnd200/category/remove")
	@ResponseBody
	public ResponseData remove(@RequestBody List<DocumentCategory> documentCategory){
		documentCategoryService.cascadingDeleteDocumentCategory(documentCategory);
		return new  ResponseData();
	}
	
}
