package hls.core.hls.controllers;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.hls.dto.DocumentStatus;
import hls.core.hls.service.DocumentStatusService;


@Controller
public class DocumentStatusController extends BaseController{
	
	@Autowired
	private DocumentStatusService documentStatusService;
	
	
	@RequestMapping(value = "/fnd200/status/query")
	@ResponseBody
	public ResponseData query(final DocumentStatus documentStatus, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(documentStatusService.selectList(documentStatus));
	}
	
	@RequestMapping(value = "/fnd200/status/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody final List<DocumentStatus> documentStatus, final BindingResult result,
            final HttpServletRequest request){
		 	getValidator().validate(documentStatus, result);
	        if (result.hasErrors()) {
	            ResponseData responseData = new ResponseData(false);
	            responseData.setMessage(getErrorMessage(result, request));
	            return responseData;
	        }
	        IRequest requestContext = createRequestContext(request);
	        
	        return new ResponseData(documentStatusService.batchUpdate(requestContext, documentStatus));
	}
	
	@RequestMapping(value="/fnd200/status/remove")
	@ResponseBody
	public ResponseData remove(@RequestBody List<DocumentStatus> documentCategory){
		documentStatusService.batchDelete(documentCategory);
		return new  ResponseData();
	}
}
