package hls.core.hls.controllers;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.hls.dto.DocumentCategory;
import hls.core.hls.dto.DocumentType;
import hls.core.hls.service.DocumentTypeService;


@Controller
public class DocumentTypeController extends BaseController{
	
	@Autowired
	private DocumentTypeService documentTypeService;
	
	
	@RequestMapping(value = "/fnd200/type/query")
	@ResponseBody
	public ResponseData query(final DocumentType documentType, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(documentTypeService.selectList(documentType));
	}
	
	@RequestMapping(value = "/fnd200/type/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody final List<DocumentType> documentType, final BindingResult result,
            final HttpServletRequest request){
		 	getValidator().validate(documentType, result);
	        if (result.hasErrors()) {
	            ResponseData responseData = new ResponseData(false);
	            responseData.setMessage(getErrorMessage(result, request));
	            return responseData;
	        }
	        IRequest requestContext = createRequestContext(request);
	        
	        return new ResponseData(documentTypeService.batchUpdate(requestContext, documentType));
	}
	
	@RequestMapping(value="/fnd200/type/remove")
	@ResponseBody
	public ResponseData remove(@RequestBody List<DocumentType> documentType){
		documentTypeService.batchDelete(documentType);
		
		return new  ResponseData();
	}
}
