package hls.core.hls.controllers;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.exception.TokenException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.hls.dto.FndProvince;
import hls.core.hls.service.FndProvinceService;


@Controller
public class FndProvinceController extends BaseController{
	
	@Autowired
	private FndProvinceService fndProvinceService;
	
	@RequestMapping(value = "/fnd/province/query")
	@ResponseBody
	public ResponseData query(final FndProvince fndProvince, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
//		List<FndProvince> list = fndProvinceService.select(requestContext, fndProvince, page, pagesize);
		PageHelper.startPage(page, pagesize);

		List<FndProvince> list =fndProvinceService.selectAllFndProvince(fndProvince, page, pagesize, request);
		return new ResponseData(list);
	}
	
	@RequestMapping(value = "/fnd/province/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody final List<FndProvince> fndProvince, final BindingResult result,
            final HttpServletRequest request)throws TokenException {
		ResponseData rd = null;
		try {
		 	getValidator().validate(fndProvince, result);
	        if (result.hasErrors()) {
	            ResponseData responseData = new ResponseData(false);
	            responseData.setMessage(getErrorMessage(result, request));
	            return responseData;
	        }
	        IRequest requestContext = createRequestContext(request);
	        return new ResponseData(fndProvinceService.batchUpdate(requestContext, fndProvince));
		}catch (Exception e) {
			rd = new ResponseData(false);
			rd.setMessage("省代码不可重复！");
			return rd;
		}
	}
	
	@RequestMapping(value = "/fnd/province/delete", method = RequestMethod.POST)
	@ResponseBody
	public ResponseData delete(HttpServletRequest request, @RequestBody List<FndProvince> provinceList) {
		fndProvinceService.cascadingDeleteDistrictDefine(provinceList);
		return new ResponseData();
	}

}
