package hls.core.hls.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.dto.FndScoreResult;
import hls.core.hls.service.IFndScoreResultService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class FndScoreResultController extends BaseController {

@Autowired
private IFndScoreResultService service;


// 获取结果分数
@RequestMapping(value = "/fnd/score/result/queryById")
@ResponseBody
public ResponseData queryFndScoreResult(FndScoreResult dto) {
    List<FndScoreResult> listGather =  service.queryFndScoreResult(dto.getScoreResultId());
    return new ResponseData(listGather);
}

@RequestMapping(value = "/fnd/score/result/query")
@ResponseBody
public ResponseData query(FndScoreResult dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                          @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
    IRequest requestContext = createRequestContext(request);
    return new ResponseData(service.select(requestContext,dto,page,pageSize));
}


@RequestMapping(value = "/fnd/score/result/remove")
@ResponseBody
public ResponseData delete(HttpServletRequest request, @RequestBody List<FndScoreResult> dto){
    service.batchDelete(dto);
    return new ResponseData();
}
}