package hls.core.hls.controllers;


import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.dto.FndScoreTargetValues;
import hls.core.hls.service.IFndScoreTargetValuesService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

    @Controller
    public class FndScoreTargetValuesController extends BaseController{

    @Autowired
    private IFndScoreTargetValuesService service;


    @RequestMapping(value = "/fnd/score/target/values/query")
    @ResponseBody
    public ResponseData query(FndScoreTargetValues dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/fnd/score/target/values/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<FndScoreTargetValues> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/fnd/score/target/values/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<FndScoreTargetValues> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }