package hls.core.hls.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.dto.FndScoreTemplateDbSource;
import hls.core.hls.service.IFndScoreTemplateDbSourceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Controller
    public class FndScoreTemplateDbSourceController extends BaseController{

    @Autowired
    private IFndScoreTemplateDbSourceService service;


    @RequestMapping(value = "/fnd/score/template/db/source/query")
    @ResponseBody
    public ResponseData query(FndScoreTemplateDbSource dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/fnd/score/template/db/source/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<FndScoreTemplateDbSource> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/fnd/score/template/db/source/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<FndScoreTemplateDbSource> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

    @RequestMapping(value = "/fnd/score/template/db/source/combobox")
    public @ResponseBody ResponseData combDs(HttpServletRequest request){
        return new ResponseData(service.combDs());
    }

    @RequestMapping(value = "/fnd/score/template/db/source/queryByHId")
    @ResponseBody
    public ResponseData queryByHId(Long scoreTemplateHdId, @RequestBody Map<String,Object> map, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
        map.put("SCORE_DATE", df.format(new Date()));
        List<Long> list = new ArrayList<>();
        list.add(service.fndScoreTemplateDbSource(requestContext,scoreTemplateHdId,map));
        return new ResponseData(list);
    }


}