package hls.core.hls.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.dto.FndScoreTemplateHdValue;
import hls.core.hls.service.IFndScoreTemplateHdValueService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

    @Controller
    public class FndScoreTemplateHdValueController extends BaseController{

    @Autowired
    private IFndScoreTemplateHdValueService service;


    @RequestMapping(value = "/fnd/score/template/hd/value/query")
    @ResponseBody
    public ResponseData query(FndScoreTemplateHdValue dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.query(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/fnd/score/template/hd/value/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<FndScoreTemplateHdValue> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/fnd/score/template/hd/value/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<FndScoreTemplateHdValue> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }