package hls.core.hls.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.dto.FndScoreTemplateLn;
import hls.core.hls.service.IFndScoreTemplateLnService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

    @Controller
    public class FndScoreTemplateLnController extends BaseController{

    @Autowired
    private IFndScoreTemplateLnService service;


    @RequestMapping(value = "/fnd/score/template/ln/query")
    @ResponseBody
    public ResponseData query(FndScoreTemplateLn dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

        @RequestMapping(value = "/fnd/score/template/ln/querylevelone")
        @ResponseBody
        public ResponseData querylevleone(FndScoreTemplateLn dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
            IRequest requestContext = createRequestContext(request);
            return new ResponseData(service.selectLevelOne(requestContext,dto,page,pageSize));
        }


        @RequestMapping(value = "/fnd/score/template/ln/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<FndScoreTemplateLn> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/fnd/score/template/ln/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<FndScoreTemplateLn> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

    // 获取行id 用来判断指标大类的父类
    @RequestMapping(value = "/fnd/score/result/dtl/byHdId")
    @ResponseBody
    public ResponseData selectscoreTemplateLnId( Long scoreTemplateHdId){
        List<FndScoreTemplateLn>  list = service.selectLnRoot(scoreTemplateHdId);
        return new ResponseData(list);
    }

    @RequestMapping(value = "/fnd/score/result/dtl/queryByLnId")
    @ResponseBody
    public ResponseData query(FndScoreTemplateLn fndScoreTemplateLn) {
        List<FndScoreTemplateLn> listGather = service.queryScoreTemplateLn(fndScoreTemplateLn);
        return new ResponseData(listGather);
    }


    }