package hls.core.hls.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.dto.FndScoreTemplateLnValue;
import hls.core.hls.service.IFndScoreTemplateLnValueService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

    @Controller
    public class FndScoreTemplateLnValueController extends BaseController{

    @Autowired
    private IFndScoreTemplateLnValueService service;


    @RequestMapping(value = "/fnd/score/template/ln/value/query")
    @ResponseBody
    public ResponseData query(FndScoreTemplateLnValue dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/fnd/score/template/ln/value/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<FndScoreTemplateLnValue> dto){
        IRequest requestCtx = createRequestContext(request);
        ResponseData rs;
        try {
            rs = new ResponseData(service.batchUpdate(requestCtx, dto));
        }catch (Exception e){
            rs = new ResponseData(false);
            rs.setMessage("非法的数据录入");
        }
            return rs;

    }

    @RequestMapping(value = "/fnd/score/template/ln/value/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<FndScoreTemplateLnValue> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }