package hls.core.hls.controllers;

import com.hand.hap.core.exception.TokenException;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.dto.FndScoreTempletType;
import hls.core.hls.service.IFndScoreTempletTypeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

    @Controller
    public class FndScoreTempletTypeController extends BaseController{

    @Autowired
    private IFndScoreTempletTypeService service;


    @RequestMapping(value = "/fnd/score/template/type/query")
    @ResponseBody
    public ResponseData query(FndScoreTempletType dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request,HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        Long companyId = (Long) session.getAttribute("companyId");
        dto.setCompanyId(companyId);
        return new ResponseData(service.query(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/fnd/score/template/type/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request, HttpSession session, @RequestBody List<FndScoreTempletType> dto)throws TokenException {
        ResponseData rd = null;
        try {
        IRequest requestCtx = createRequestContext(request);
        Long companyId = (Long) session.getAttribute("companyId");
        for (FndScoreTempletType tar:
                dto) {
            if (companyId!=null){
                tar.setCompanyId(companyId);
            }
        }
        return new ResponseData(service.batchUpdate(requestCtx, dto));
        }catch (Exception e) {
            rd = new ResponseData(false);
            rd.setMessage("类型代码不可重复！");
            return rd;
        }
    }

    @RequestMapping(value = "/fnd/score/template/type/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<FndScoreTempletType> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }