package hls.core.hls.controllers;


import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.hls.dto.HlsCashflowItem;
import hls.core.hls.service.HlsCfItemService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created by hailor on 16/6/2.
 */
@Controller
public class HlsCfItemController  extends BaseController{

    @Autowired
    private HlsCfItemService hlsCfItemService;

    @RequestMapping("/HlsCfItem/query")
    @ResponseBody
    public ResponseData selectList(HttpServletRequest request,HlsCashflowItem cfl_type,
            @RequestParam(defaultValue = DEFAULT_PAGE) int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {
      IRequest iRequest = createRequestContext(request);
      List<HlsCashflowItem> datas = hlsCfItemService.selectList(cfl_type);
        return new ResponseData(datas);
    }

    @RequestMapping(value = "/HlsCfItem/submit", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData submit(HttpServletRequest request, @RequestBody List<HlsCashflowItem> demos) {
        IRequest iRequest = createRequestContext(request);
        List<HlsCashflowItem> datas = hlsCfItemService.batchUpdate(iRequest, demos);
        return new ResponseData(datas);
    }

    @RequestMapping(value = "/HlsCfItem/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCashflowItem> demos) {
    	hlsCfItemService.batchDelete(demos);
        return new ResponseData();
    }
}
