package hls.core.hls.controllers;



import com.hand.hap.core.IRequest;
import com.hand.hap.core.exception.TokenException;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.hls.dto.Hls_Cashflow_Type;
import hls.core.hls.service.HlsCfTypeService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created by hailor on 16/6/2.
 */
@Controller
public class HlsCfTypeController  extends BaseController{

    @Autowired
    private HlsCfTypeService hlsCfTypeService;

    @RequestMapping("/HlsCfType/query")
    @ResponseBody
    public ResponseData selectList(HttpServletRequest request,Hls_Cashflow_Type hlsCashflowType,
            @RequestParam(defaultValue = DEFAULT_PAGE) int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {
     
      IRequest iRequest = createRequestContext(request);

      List<Hls_Cashflow_Type> datas = hlsCfTypeService.selectList(hlsCashflowType,page,pagesize);

      
        return new ResponseData(datas);
    }
    @RequestMapping(value = "/HlsCfType/submit", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData submit(HttpServletRequest request, @RequestBody List<Hls_Cashflow_Type> demos) throws TokenException {
        ResponseData rd = null;
        try {
        IRequest iRequest = createRequestContext(request);
        List<Hls_Cashflow_Type> datas = hlsCfTypeService.batchUpdate(iRequest, demos);
        return new ResponseData(datas);
        } catch (Exception e) {
            rd = new ResponseData(false);
            rd.setMessage("现金流类型不可重复！");
            return rd;
        }
    }

    @RequestMapping(value = "/HlsCfType/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<Hls_Cashflow_Type> demos) {
    	hlsCfTypeService.cascadingDeleteCfType(demos);
        return new ResponseData();
    }
}
