package hls.core.hls.controllers;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.exception.DayEndDateNullException;
import hls.core.hls.exception.DayEndTypeNullException;
import hls.core.hls.service.HlsDayEndService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.Map;
@Controller
public class HlsDayEndController extends BaseController{
	@Autowired
	private HlsDayEndService hlsDayEndService;
	/**
	 * 日结
	 * 传入参数：日结日， 日结类型 dayEndType：penalty (只进行罚息计算，那么跟着传入合同号), all (全部动作)
	 */
	@RequestMapping(value = "/hls/dayEnd/submit")
	@ResponseBody
	public ResponseData submit(@RequestBody Map map, final BindingResult result, final HttpServletRequest request, HttpSession session)throws DayEndTypeNullException,DayEndDateNullException
	{
		if (result.hasErrors()) {
			ResponseData responseData = new ResponseData(false);
			responseData.setMessage(getErrorMessage(result, request));
			return responseData;
		}
		Long companyId = (Long) session.getAttribute("companyId");
		map.put("companyId", companyId);
		hlsDayEndService.excEndDay(map);
		return new ResponseData();
	}
}
