package hls.core.hls.controllers;

import hls.core.hls.dto.HlsDbDataSource;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.dto.HlsDbDataSourceColumn;
import hls.core.hls.service.IHlsDbDataSourceColumnService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class HlsDbDataSourceColumnController extends BaseController {

    @Autowired
    private IHlsDbDataSourceColumnService service;


    @RequestMapping(value = "/hls/db/data/source/column/query")
    @ResponseBody
    public ResponseData query(HlsDbDataSourceColumn dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.query(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/hls/db/data/source/column/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request, @RequestBody List<HlsDbDataSourceColumn> dto) {
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/hls/db/data/source/column/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsDbDataSourceColumn> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }

    @RequestMapping(value = "/hls/db/data/source/column/generate")
    @ResponseBody
    public ResponseData generate(HttpServletRequest request,HlsDbDataSource dto) {
        return service.generateColumns(createRequestContext(request),dto);
    }
}