package hls.core.hls.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.dto.HlsDbDataSourceTbWh;
import hls.core.hls.service.IHlsDbDataSourceTbWhService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

    @Controller
    public class HlsDbDataSourceTbWhController extends BaseController{

    @Autowired
    private IHlsDbDataSourceTbWhService service;


    @RequestMapping(value = "/hls/db/data/source/tb/wh/query")
    @ResponseBody
    public ResponseData query(HlsDbDataSourceTbWh dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/hls/db/data/source/tb/wh/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<HlsDbDataSourceTbWh> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/hls/db/data/source/tb/wh/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsDbDataSourceTbWh> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }