package hls.core.hls.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.dto.HlsScoreCalculation;
import hls.core.hls.service.IHlsScoreCalculationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Controller
public class HlsScoreCalculationController extends BaseController {

@Autowired
private IHlsScoreCalculationService service;

@RequestMapping(value = "/hls/score/calculation/chooseTime")
@ResponseBody
public ResponseData chooseTime(Long scoreTemplateHdId) {
    return new ResponseData(service.chooseTime(scoreTemplateHdId));
}



@RequestMapping(value = "/hls/score/calculation/selectListOfHsc")
@ResponseBody
public ResponseData query(HlsScoreCalculation dto) {
    return new ResponseData(service.selectListOfHsc(dto));
}

@RequestMapping(value = "/hls/score/calculation/query")
@ResponseBody
public ResponseData query(HlsScoreCalculation dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                          @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
    IRequest requestContext = createRequestContext(request);
    return new ResponseData(service.select(requestContext,dto,page,pageSize));
}

@RequestMapping(value = "/hls/score/calculation/submit")
@ResponseBody
public ResponseData update(HttpServletRequest request, @RequestBody List<HlsScoreCalculation> dto){
    IRequest requestCtx = createRequestContext(request);
    return new ResponseData(service.batchUpdate(requestCtx, dto));
}

@RequestMapping(value = "/hls/score/calculation/remove")
@ResponseBody
public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsScoreCalculation> dto){
    service.batchDelete(dto);
    return new ResponseData();
}

    // 评分计算表
    @RequestMapping(value = "/hls/score/calculation/insertsc")
    @ResponseBody
    public ResponseData update(HttpServletRequest request, @RequestBody HlsScoreCalculation dto) throws ParseException {
        IRequest requestCtx = createRequestContext(request);
        dto.setScoreDate(new Date());
        dto =  service.insert(requestCtx,dto);
        List<HlsScoreCalculation> list = new ArrayList<>();
        list.add(dto);
        return new ResponseData(list);
    }


    @RequestMapping(value = "/hls/score/calculation/bpMasterScoreInfo/query")
    @ResponseBody
    public ResponseData bpMasterScoreInfo(HttpServletRequest request, Long bpId, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                          @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize){
        return new ResponseData(service.bpMasterScoreInfo(bpId,page,pageSize));
    }
}