package hls.core.hls.controllers;

import com.hand.hap.core.exception.TokenException;
import hls.core.hls.dto.HlsScoreTarget;
import hls.core.hls.service.IHlsScoreTargetService;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

    @Controller
    public class HlsScoreTargetController extends BaseController{

    @Autowired
    private IHlsScoreTargetService service;


    @RequestMapping(value = "/hls/score/target/query")
    @ResponseBody
    public ResponseData query(HttpSession session,HlsScoreTarget dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        Long companyId = (Long) session.getAttribute("companyId");
        dto.setCompanyId(companyId);
        return new ResponseData(service.query(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/hls/score/target/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<HlsScoreTarget> dto, HttpSession session)throws TokenException {
        ResponseData rd = null;
        try {
        IRequest requestCtx = createRequestContext(request);
        Long companyId = (Long) session.getAttribute("companyId");
        for (HlsScoreTarget tar:
             dto) {
            if (companyId!=null){
                tar.setCompanyId(companyId);
            }
        }
        return new ResponseData(service.batchUpdate(requestCtx, dto));
        }catch (Exception e) {
            rd = new ResponseData(false);
            rd.setMessage("指标代码不可重复！");
            return rd;
        }
    }

    @RequestMapping(value = "/hls/score/target/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsScoreTarget> dto){
        service.deleteHl(dto);
        return new ResponseData();
    }
    }