package hls.core.hls.controllers;

import hls.core.hls.bp.dto.HlsCusBpMaster;
import hls.core.hls.dto.HlsSystemNotice;
import hls.core.hls.dto.HlsSystemNoticeOwner;
import hls.core.hls.dto.HlsUserRelationship;
import hls.core.hls.service.HlsSystemNoticeOwnerService;
import hls.core.hls.service.HlsSystemNoticeService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import hls.core.hls.service.IHlsUserRelationshipService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import java.util.List;


@Controller
public class HlsSystemNoticeController extends BaseController{

	@Autowired
	private HlsSystemNoticeService hsnService;
	@Autowired
	private IHlsUserRelationshipService IHlsUserRelationshipService;
	@Autowired
	private HlsSystemNoticeOwnerService hlsSystemNoticeOwnerService;

	@RequestMapping(value = "/hls/system/notice/query")
	@ResponseBody
	public ResponseData query(final HlsSystemNotice hsn, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(hsnService.selectUserNotice(requestContext.getUserId()));
	}

	/**
	 * Created with IntelliJ IDEA.
	 * User: Jeffery
	 * Date: 2017/5/10
	 * Time: 15:29
	 * To change this template use File | Settings | File Templates.
	 */
	@RequestMapping(value = "/hls/systemBox/notice/query")
	@ResponseBody
	public ResponseData queryBox(final HlsSystemNotice hsn, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
							  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		hsn.setUserId(requestContext.getUserId());
		List<HlsSystemNotice> list = hsnService.selectUserBoxNotice(hsn);
		return new ResponseData(list);
	}

	@RequestMapping(value = "/hls/system/noticeById/query")
	@ResponseBody
	public ResponseData queryById(final HlsSystemNotice hsn, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
								  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(hsnService.selectNoticeById(hsn.getNotice_id()));
	}

	@RequestMapping(value = "/hls/system/noticeById/update")
	@ResponseBody
	public ResponseData updateById(final HlsSystemNotice hsn, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
								  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		hsnService.updateById(requestContext,hsn.getNotice_id());
		return new ResponseData();
	}


	@RequestMapping(value= "/hls/system/noticeMessage/query")
	@ResponseBody
	public List<HlsSystemNotice> getNoticeMessage(HttpServletRequest request,@RequestParam(defaultValue = DEFAULT_PAGE) int page,
												  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize){
		IRequest requestContext = createRequestContext(request);
		HlsSystemNotice hlsSystemNotice = new HlsSystemNotice();
		hlsSystemNotice.setUserId(requestContext.getUserId());
		return hsnService.getNoticeMessage(hlsSystemNotice);
	}

	@RequestMapping(value = "/hls/system/NoticeCountAndRadio/query")
	@ResponseBody
	public ResponseData getNoticeCountAndRadio(HttpServletRequest request, HlsSystemNotice hlsSystemNotice,
											   @RequestParam(defaultValue = DEFAULT_PAGE) int page,
											   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize){
		IRequest requestContext = createRequestContext(request);
		hlsSystemNotice.setUserId(requestContext.getUserId());
		List<HlsSystemNotice> datas = hsnService.getNoticeCountAndRadio( hlsSystemNotice);
		return new ResponseData(datas);
	}

	@RequestMapping(value= "/hls/system/todoNoticeMessage/query")
	@ResponseBody
	public List<HlsSystemNotice> getTodoNoticeMessage(HttpServletRequest request,@RequestParam(defaultValue = DEFAULT_PAGE) int page,
												  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
		IRequest requestContext = createRequestContext(request);
		return hsnService.getTodoNoticeMessage();
	}


	/**
	 * 消息推送-统计图
	 * @return
	 */
	@RequestMapping(value = "/hls/system/noticeTypeInfo/query")
	@ResponseBody
	public List<HlsSystemNotice> selectNoticeTypeInfo(final HlsSystemNotice hlsSystemNotice,HttpSession session){
		List<HlsSystemNotice> clist = hsnService.selectNoticeTypeInfo(hlsSystemNotice,session);
		return clist;
	}

	@RequestMapping(value = "/hls/system/totalCount/query")
	@ResponseBody
	public List<HlsSystemNotice> getTotalNoticeCount(){
		List<HlsSystemNotice> hlsSystemNotice = hsnService.getTotalNoticeCount();
		return hlsSystemNotice;
	}

	/**
	 * User:Jeffery
	 * Time:20170511
	 * Conttent:查询最近五天消息及待办/未读总数
	 * @param request
	 * @param page
	 * @param pagesize
	 * @return
	 */
	@RequestMapping(value = "/hls/system/fivedays/notice/query")
	@ResponseBody
	public ResponseData querySevenDaysNotice(final HlsSystemNotice hsn, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
							  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		hsn.setUserId(requestContext.getUserId());
		List<HlsSystemNotice> list = hsnService.selectFiveDaysNotice(hsn);
		return new ResponseData(list);
	}

	/**
	 * User:Jeffery
	 * Time:20170512
	 * Conttent:查询当前用户所有单据
	 * @param request
	 * @param page
	 * @param pagesize
	 * @return
	 */
	@RequestMapping(value = "/hls/user/alldoc/query")
	@ResponseBody
	public ResponseData queryAllDoc(final HlsSystemNotice hsn, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
										@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize,
									final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		hsn.setUserId(requestContext.getUserId());
		List<HlsSystemNotice> list = hsnService.selectUserAllDoc(hsn);
		return new ResponseData(list);
	}

	/**
	 * User:Jeffery
	 * Time:20170515
	 * Conttent:添加好友
	 * @param request
	 * @return
	 */
	@RequestMapping(value = "/hls/user/add/friends")
	@ResponseBody
	public ResponseData addFriends(@RequestBody final List<HlsUserRelationship> hlsUserRelationships,
											    final BindingResult result,
											    final HttpServletRequest request){
		getValidator().validate(hlsUserRelationships, result);
		if (result.hasErrors()) {
			ResponseData responseData = new ResponseData(false);
			responseData.setMessage(getErrorMessage(result, request));
			return responseData;
		}
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(IHlsUserRelationshipService.batchUpdate(requestContext, hlsUserRelationships));
	}

	/**
	 * User:Jeffery
	 * Time:20170515
	 * Conttent:删除好友
	 * @param request
	 * @return
	 */
	@RequestMapping(value = "/hls/user/del/friends")
	@ResponseBody
	public ResponseData delFriends(@RequestBody final List<HlsUserRelationship> hlsUserRelationships,
								   final HttpServletRequest request){
		IHlsUserRelationshipService.batchDelete(hlsUserRelationships);
		return new ResponseData();
	}

	/**
	 * User:Jeffery
	 * Time:20170526
	 * Conttent:标记readFlag为已读
	 * @param request
	 * @param page
	 * @param pagesize
	 * @return
	 */
	@RequestMapping(value = "/hls/ntcie/readflag/set")
	@ResponseBody
	public ResponseData setReadFlag(final HlsSystemNotice hsn, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
									@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize,
									final HttpServletRequest request) {
		IRequest requestContext = createRequestContext(request);
		List<HlsSystemNotice> noticeList = hsnService.selectNoticeById(Long.parseLong(hsn.getQueryTermValue()));
		HlsSystemNoticeOwner hlsSystemNoticeOwner = new HlsSystemNoticeOwner();
		hlsSystemNoticeOwner.setNotice_id(noticeList.get(0).getNotice_id());
		hlsSystemNoticeOwner.setOwner_user_id(requestContext.getUserId());
		List<HlsSystemNoticeOwner> hlsSystemNoticeOwnerList = hlsSystemNoticeOwnerService.queryOwnerNoticeById(hlsSystemNoticeOwner);
		if(hlsSystemNoticeOwnerList.size()==0){
			hlsSystemNoticeOwnerList.add(hlsSystemNoticeOwner);
			hlsSystemNoticeOwnerList.get(0).set__status("add");
		}else {
			hlsSystemNoticeOwnerList.get(0).set__status("update");
		}
		hlsSystemNoticeOwnerList.get(0).setRead_flag("Y");
		hlsSystemNoticeOwnerService.batchUpdate(requestContext,hlsSystemNoticeOwnerList);
		return new ResponseData();
	}

	/**
	 * User:Jeffery
	 * Time:20170526
	 * Conttent:查询已读未读
	 * @param request
	 * @param page
	 * @param pagesize
	 * @return
	 */
	@RequestMapping(value = "/hls/query/notice/todo")
	@ResponseBody
	public ResponseData queryThreeNoticeAndTodo(final HlsSystemNotice hsn, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
							  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		hsn.setUserId(requestContext.getUserId());
		return new ResponseData(hsnService.selectThreeNoticeAndTodo(hsn));
	}

	/**
	 * User:Jeffery
	 * Time:20170512
	 * Conttent:查询当前用户所有单据
	 * @param request
	 * @return
	 */
	@RequestMapping(value = "/hls/query/addinfo/by/bpid")
	@ResponseBody
	public ResponseData queryAllInfoByInfo(final HlsCusBpMaster hbm, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		List<HlsSystemNotice> hsnList = hsnService.queyAllInfoByBpId(hbm.getBpId());
		return new ResponseData(hsnList);
	}

	/**
	 * Created with IntelliJ IDEA.
	 * User: Jeffery
	 * Date: 2017/11/30
	 * Time: 18:29
	 * To change this template use File | Settings | File Templates.
	 */
	@RequestMapping(value = "/set/notice/read")
	@ResponseBody
	public ResponseData setNoticeRead(final HlsSystemNotice hsn, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		hsn.setUserId(hsn.getUserId());
		hlsSystemNoticeOwnerService.setNoticeRead(requestContext,hsn);
		return new ResponseData(true);
	}

}