package hls.core.hls.controllers;

import com.hand.hap.core.impl.RequestHelper;
import hls.core.hls.dto.HlsCusHlsSystemNoticeFilter;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.dto.HlsSystemNoticeFilter;
import hls.core.hls.service.IHlsSystemNoticeFilterService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import org.springframework.validation.BindingResult;
import java.util.List;
import java.util.stream.Collectors;

@Controller
    public class HlsSystemNoticeFilterController extends BaseController{

    @Autowired
    private IHlsSystemNoticeFilterService service;


    @RequestMapping(value = "/hls/system/notice/filter/query")
    @ResponseBody
    public ResponseData query(HlsCusHlsSystemNoticeFilter dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = RequestHelper.getCurrentRequest();
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/hls/system/notice/filter/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusHlsSystemNoticeFilter> dto, BindingResult result, HttpServletRequest request){
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = RequestHelper.getCurrentRequest();
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/hls/system/notice/filter/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusHlsSystemNoticeFilter> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

    /*根据用户id修改是否过滤标志（新增or修改）*/
    @RequestMapping(value = "/hls/system/notice/filter/changeFilterFlag")
    @ResponseBody
    public ResponseData changeFilterFlag(@RequestBody List<HlsCusHlsSystemNoticeFilter> list, BindingResult result, HttpServletRequest request){
        IRequest requestCtx = RequestHelper.getCurrentRequest();
        list.stream().map(item->{
            item.setUserId(requestCtx.getUserId());
            return item;
        }).collect(Collectors.toList());
        return new ResponseData(service.batchUpdate(requestCtx, list));
    }
    }