package hls.core.hls.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.dto.DocumentType;
import hls.core.hls.dto.HlsSystemNotice;
import hls.core.hls.dto.HlsSystemNoticeReply;
import hls.core.hls.service.HlsSystemNoticeReplyService;
import hls.core.hls.service.HlsSystemNoticeService;
import hls.core.sys.dto.SysModule;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by syj on 2017/2/17.
 */
@Controller
public class HlsSystemNoticeReplyController extends BaseController{
    @Autowired
    private HlsSystemNoticeReplyService hlsSystemNoticeReplyService;
    @Autowired
    private HlsSystemNoticeService hlsSystemNoticeService;

    @RequestMapping(value = "/hls/system/notice/reply/query")
    @ResponseBody
    public ResponseData queryByNoticeId(final HlsSystemNoticeReply hlsSystemNoticeReply, @RequestParam(defaultValue = DEFAULT_PAGE)final int page,
                                                      @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(hlsSystemNoticeReplyService.selectNoticeReplyByNoticeId(hlsSystemNoticeReply.getNoticeId()));
    }


    @RequestMapping(value = "/hls/system/notice/reply/submit")
    @ResponseBody
    public ResponseData submit(@RequestBody List<HlsSystemNoticeReply> hlsSystemNoticeReply,
                               final HttpServletRequest request){
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(hlsSystemNoticeReplyService.batchUpdate(requestContext,hlsSystemNoticeReply));
    }

    @RequestMapping(value = "/rpt/get/system/notice")
    @ResponseBody
    public ResponseData getNoice(final HlsSystemNotice hlsSystemNotice, final HttpServletRequest request){
        List<HlsSystemNotice> list = hlsSystemNoticeService.queryByDocAndId(hlsSystemNotice);
        return new ResponseData(list);
    }

}
