package hls.core.hls.service.impl;
import com.github.pagehelper.PageHelper;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import groovy.time.BaseDuration.From;
import hls.core.hls.dto.BusinessCategory;
import hls.core.hls.mapper.BusinessCgMapper;
import hls.core.hls.mapper.BusinessTyMapper;
import hls.core.hls.service.IBusinessCgService;
import hls.core.hls.service.IBusinessTyService;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class BusinessCgServiceImpl extends BaseServiceImpl<BusinessCategory> implements IBusinessCgService {

	@Autowired
	BusinessCgMapper businessCgMapper;
	
	@Autowired
	BusinessTyMapper businessTyMapper;


	@Override
	public void businessMasterBatchDelete(List<BusinessCategory> demos) {
		this.batchDelete(demos);
		for(BusinessCategory bc :demos){
			businessTyMapper.deleteBusinessTy(bc.getBp_category());
		}
	}

	@Override
	public List<BusinessCategory> selectList(BusinessCategory businessCategory,int page,int pagesize) {
		PageHelper.startPage(page, pagesize);
		return businessCgMapper.selectList(businessCategory);
	}

	@Override
	public List<BusinessCategory> bpMasterOtherQuery(BusinessCategory businessCategory,int page,int pagesize) {
		PageHelper.startPage(page, pagesize);
		return businessCgMapper.bpMasterOtherQuery(businessCategory);
	}

	@Override
	public List<BusinessCategory> usageCategory() {
		return businessCgMapper.usageCategory();
	}

/*    @Autowired
    private BusinessCgMapper businessCgMapper ;

    public List<BusinessCategory>  getAllCgService() {
    	List<BusinessCategory> list = null;
    	try {
			list=businessCgMapper.selectAllCategory();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return list;
	}*/
}
