package hls.core.hls.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.hand.hap.core.IRequest;
import com.hand.hap.message.IMessagePublisher;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.hls.dto.BusinessType;
import hls.core.hls.mapper.BusinessTypeMapper;
import hls.core.hls.service.BusinessTypeService;

@Service
public class BusinessTypeServiceImpl extends BaseServiceImpl<BusinessType> implements BusinessTypeService {

	@Autowired
	BusinessTypeMapper businessTypeMapper;
	
    @Autowired
    private IMessagePublisher messagePublisher;
    

    @Override
    public List<BusinessType> batchUpdate(IRequest request, List<BusinessType> list) {
        super.batchUpdate(request, list);
        for (BusinessType e : list) {
            messagePublisher.publish("e.change", e);
        }
        return list;
    }
    @Override
    public List<BusinessType> selectList(BusinessType businessType){
        return businessTypeMapper.selectList(businessType);
    }

}
