package hls.core.hls.service.impl;

import java.util.List;

import com.github.pagehelper.PageHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.hand.hap.core.IRequest;
import com.hand.hap.message.IMessagePublisher;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.hls.dto.Division;
import hls.core.hls.mapper.DivisionMapper;
import hls.core.hls.service.DivisionService;

@Service
public class DivisionServiceImpl extends BaseServiceImpl<Division> implements DivisionService {

	@Autowired
	DivisionMapper divisionMapper;
	
    @Autowired
    private IMessagePublisher messagePublisher;
    

    @Override
    public List<Division> batchUpdate(IRequest request, List<Division> list) {
        super.batchUpdate(request, list);
        for (Division e : list) {
            messagePublisher.publish("e.change", e);
        }
        return list;
    }


    @Override
    public List<Division> selectList(Division division,int page, int pagesize) {

        PageHelper.startPage(page, pagesize);
        return divisionMapper.selectList(division);
    }
}
