package hls.core.hls.service.impl;

import java.util.List;

import com.github.pagehelper.PageHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.hand.hap.core.IRequest;
import com.hand.hap.message.IMessagePublisher;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.hls.dto.DocumentCategory;
import hls.core.hls.mapper.DocumentCategoryMapper;
import hls.core.hls.service.DocumentCategoryService;

@Service
@Transactional
public class DocumentCategoryServiceImpl extends BaseServiceImpl<DocumentCategory> implements DocumentCategoryService {

	@Autowired
	DocumentCategoryMapper documentCategoryMapper;
	
    @Autowired
    private IMessagePublisher messagePublisher;
    

    @Override
    public List<DocumentCategory> batchUpdate(IRequest request, List<DocumentCategory> list) {
        super.batchUpdate(request, list);
        for (DocumentCategory e : list) {
            messagePublisher.publish("e.change", e);
        }
        return list;
    }


	@Override
	public void deleteBusinessType(String documentCategory) {
		documentCategoryMapper.deleteBusinessType(documentCategory);
		
	}


	@Override
	public void deleteDocumentType(String documentCategory) {
		documentCategoryMapper.deleteDocumentType(documentCategory);
		
	}


	@Override
	public void deleteDocumentStatus(String documentCategory) {
		// TODO Auto-generated method stub
		documentCategoryMapper.deleteDocumentStatus(documentCategory);
		
	}



	@Override
	public void cascadingDeleteDocumentCategory(List<DocumentCategory> documentCategory) {
		// TODO Auto-generated method stub
		this.batchDelete(documentCategory);
		for(int i=0 ;i<documentCategory.size();i++)
		{
			this.deleteBusinessType(documentCategory.get(i).getDocumentCategory());
			this.deleteDocumentType(documentCategory.get(i).getDocumentCategory());
			this.deleteDocumentStatus(documentCategory.get(i).getDocumentCategory());
		}
		
	}

	@Override
	public List<DocumentCategory> selectList(DocumentCategory documentCategory,int page, int pageSize) {
		PageHelper.startPage(page, pageSize);
		return documentCategoryMapper.selectList(documentCategory);
	}


}
