package hls.core.hls.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.hand.hap.core.IRequest;
import com.hand.hap.message.IMessagePublisher;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.hls.dto.DocumentStatus;
import hls.core.hls.mapper.DocumentStatusMapper;
import hls.core.hls.service.DocumentStatusService;

@Service
public class DocumentStatusServiceImpl extends BaseServiceImpl<DocumentStatus> implements DocumentStatusService {

	@Autowired
	DocumentStatusMapper documentStatusMapper;
	
    @Autowired
    private IMessagePublisher messagePublisher;
    

    @Override
    public List<DocumentStatus> batchUpdate(IRequest request, List<DocumentStatus> list) {
        super.batchUpdate(request, list);
        for (DocumentStatus e : list) {
            messagePublisher.publish("e.change", e);
        }
        return list;
    }


    @Override
    public List<DocumentStatus> selectList(DocumentStatus documentStatus) {
        return documentStatusMapper.selectList(documentStatus);
    }
}
