package hls.core.hls.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.hand.hap.core.IRequest;
import com.hand.hap.message.IMessagePublisher;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.hls.dto.DocumentType;
import hls.core.hls.mapper.DocumentTypeMapper;
import hls.core.hls.service.DocumentTypeService;

@Service
public class DocumentTypeServiceImpl extends BaseServiceImpl<DocumentType> implements DocumentTypeService {

	@Autowired
	DocumentTypeMapper documentTypeMapper;
	
    @Autowired
    private IMessagePublisher messagePublisher;
    

    @Override
    public List<DocumentType> batchUpdate(IRequest request, List<DocumentType> list) {
        super.batchUpdate(request, list);
        for (DocumentType e : list) {
            messagePublisher.publish("e.change", e);
        }
        return list;
    }


    @Override
    public List<DocumentType> selectList(DocumentType documentType) {
        return documentTypeMapper.selectList(documentType);
    }
}
