package hls.core.hls.service.impl;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.collections.IteratorUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.hls.dto.FndProvince;
import hls.core.hls.mapper.FndProvinceMapper;
import hls.core.hls.service.FndProvinceService;

@Service
@Transactional
public class FndProvinceServiceImpl extends BaseServiceImpl<FndProvince> implements FndProvinceService {

	@Autowired
	private FndProvinceMapper mapper;
	
	private List<FndProvince> provList;
	
	@Override
	public List<FndProvince> selectAllFndProvince(FndProvince fndProvince,int page,
              int pagesize, final HttpServletRequest request){
		 List<FndProvince> provinceList = mapper.selectAllFndProvince(fndProvince);
		 if(provList!=null){
			 provinceList= set(provinceList);
		 }
		 return provinceList;
	}
	
	public List<FndProvince> set(List<FndProvince> list){
		for (int i = 0; i < list.size(); i++) {
			FndProvince fndProvince = list.get(i);
			if(provList.indexOf(fndProvince)>0){
				list.remove(i);
			}
		}
		return list;
	}
	
	
	@Override
	public void cascadingDeleteDistrictDefine(List<FndProvince> provinceList) {
		provList = provinceList;
		this.batchDelete(provinceList);
		for (FndProvince ofp : provinceList) {
			mapper.deleteCity(ofp.getProvince());
			mapper.deleteDistrict(ofp.getProvince());
		}
	}

	@Override
	public String queryProvinceCode(String province) {
		return mapper.queryProvinceCode(province);
	}

	@Override
	public String queryProvinceFirst() {
		return mapper.queryProvinceFirst();
	}


}
