package hls.core.hls.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.hls.components.CustomerLevelCaculator;
import hls.core.hls.dto.FndScoreResultDtl;
import hls.core.hls.dto.FndScoreTargetValues;
import hls.core.hls.dto.HlsScoreCalculation;
import hls.core.hls.mapper.FndScoreResultDtlMapper;
import hls.core.hls.service.IFndScoreResultDtlService;
import hls.core.hls.service.IFndScoreResultService;
import hls.core.hls.service.IFndScoreTargetValuesService;
import hls.core.hls.service.IHlsScoreCalculationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

@Service
@Transactional
public class FndScoreResultDtlServiceImpl extends BaseServiceImpl<FndScoreResultDtl> implements IFndScoreResultDtlService{


    @Autowired
    FndScoreResultDtlMapper mapper;

    @Autowired
    IFndScoreResultDtlService fndScoreResultDtlService;

    @Autowired
    IFndScoreTargetValuesService fndScoreTargetValuesService;

    @Autowired
    IHlsScoreCalculationService hlsScoreCalculationService;

    @Autowired
    IFndScoreResultService fndScoreResultService;

    @Autowired
    CustomerLevelCaculator customerLevelCaculator;






    @Override
    public void  saveFnd(IRequest iRequest, FndScoreResultDtl fndt){


        if(null != fndt.getRefndScoreResultDtls()){

            for(FndScoreResultDtl f:fndt.getRefndScoreResultDtls()){
                f.setTargetScoreOriginal(f.getTargetScore());
                fndScoreResultDtlService.updateByPrimaryKeySelective(iRequest,f);

                FndScoreTargetValues fndScoreTargetValues = new FndScoreTargetValues();
                fndScoreTargetValues.setScoreTargetValueId(f.getScoreTargetValueId());
                //  fndScoreTargetValues.setDescription(f.getDescriptions());
                fndScoreTargetValuesService.updateByPrimaryKeySelective(iRequest,fndScoreTargetValues);
            }
        }


        HlsScoreCalculation hlsScoreCalculation = new HlsScoreCalculation();
        hlsScoreCalculation.setScoreDate(new Date());
        hlsScoreCalculation.setScoreId(fndt.getScoreId());
        hlsScoreCalculationService.updateByPrimaryKeySelective(iRequest,hlsScoreCalculation);

        customerLevelCaculator.entrySec(iRequest,fndt.getScoreResultId());


        fndt.getFndScoreResult().set__status("update");
        fndScoreResultService.updateByPrimaryKeySelective(iRequest,fndt.getFndScoreResult());

    }

    @Override
    public List<FndScoreResultDtl> selectscoreTemplateLnId(Long scoreTemplateHdId) {
        return mapper.selectscoreTemplateLnId(scoreTemplateHdId);
    }

    @Override
    public Double selectTotalScore(FndScoreResultDtl fndScoreResultDtl) {
        return mapper.totalScore(fndScoreResultDtl);
    }
}