package hls.core.hls.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.hls.components.CustomerLevelCaculator;
import hls.core.hls.components.Datasource2Json;
import hls.core.hls.mapper.FndScoreTemplateDbSourceMapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.hls.dto.FndScoreTemplateDbSource;
import hls.core.hls.service.IFndScoreTemplateDbSourceService;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
@Transactional
public class FndScoreTemplateDbSourceServiceImpl extends BaseServiceImpl<FndScoreTemplateDbSource> implements IFndScoreTemplateDbSourceService{

    @Resource
    private FndScoreTemplateDbSourceMapper fndScoreTemplateDbSourceMapper;


    @Autowired
    Datasource2Json datasource2Json;

    @Autowired
    CustomerLevelCaculator customerLevelCaculator;


    @Override
    public List<HashMap> combDs() {
        return fndScoreTemplateDbSourceMapper.combDs();
    }

    @Override
    public Long fndScoreTemplateDbSource(IRequest iRequest, Long scoreTemplateHdId, Map<String,Object> map) {

        List<Long> listHId =  fndScoreTemplateDbSourceMapper.sourceId(scoreTemplateHdId);

        Long ScoreResultId = null;

        Map<String,Object> maps = new HashMap<>();
        for (int i = 0 ; i < listHId.size(); i++){
            maps.put(listHId.get(i).toString(),map);
        }

        try {
            String data  =  datasource2Json.executeSQLs4Json(listHId,maps);    // 获取数据源

            JSONObject jsonObject = JSONObject.parseObject(data);
            ScoreResultId = customerLevelCaculator.calEntry(iRequest,scoreTemplateHdId,jsonObject);

            return ScoreResultId;

        } catch (IOException e) {

            e.printStackTrace();

        }

        return ScoreResultId;
    }
}