package hls.core.hls.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.hls.dto.*;
import hls.core.hls.mapper.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.hls.service.IFndScoreTemplateHdService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional
public class FndScoreTemplateHdServiceImpl extends BaseServiceImpl<FndScoreTemplateHd> implements IFndScoreTemplateHdService{

    @Autowired
    private FndScoreTemplateHdMapper fndScoreTemplateHdMapper;
    @Autowired
    private FndScoreTemplateHdValueMapper fndScoreTemplateHdValueMapper;
    @Autowired
    private FndScoreTemplateLnMapper fndScoreTemplateLnMapper;
    @Autowired
    private FndScoreTemplateLnValueMapper fndScoreTemplateLnValueMapper;
    @Autowired
    private FndScoreTemplateDbSourceMapper fndScoreTemplateDbSourceMapper;

    @Override
    public List<FndScoreTemplateHd> selectList(FndScoreTemplateHd fndScoreTemplateHd) {

        return fndScoreTemplateHdMapper.selectList(fndScoreTemplateHd);
    }


    @Override
    public List<HlsDbDataSourceColumn> dbCloumnData(FndScoreTemplateHd dto) {
        return fndScoreTemplateHdMapper.dbCloumnData(dto);
    }

    @Override
    public List<FndScoreTemplateHd> query(IRequest request, FndScoreTemplateHd fndScoreTemplateHd, int page, int pageSize) {
        PageHelper.startPage(page,pageSize);
        return fndScoreTemplateHdMapper.query(fndScoreTemplateHd);
    }

    @Override
    public void deleteChild(List<FndScoreTemplateHd> fndScoreTemplateHds) {
        for (FndScoreTemplateHd f:
             fndScoreTemplateHds) {
            FndScoreTemplateHdValue fth = new FndScoreTemplateHdValue();
            fth.setScoreTemplateHdId(f.getScoreTemplateHdId());
            for (FndScoreTemplateHdValue fsthv:
            fndScoreTemplateHdValueMapper.select(fth)) {
                fndScoreTemplateHdValueMapper.delete(fth);
            }

            FndScoreTemplateLn fstl = new FndScoreTemplateLn();
            fstl.setScoreTemplateHdId(f.getScoreTemplateHdId());
            for (FndScoreTemplateLn ftl:
                 fndScoreTemplateLnMapper.select(fstl)) {
                FndScoreTemplateLnValue fstlv = new FndScoreTemplateLnValue();
                fstlv.setScoreTemplateLnId(ftl.getScoreTemplateLnId());
                for (FndScoreTemplateLnValue fstlvs:
                fndScoreTemplateLnValueMapper.select(fstlv)) {
                    fndScoreTemplateLnValueMapper.delete(fstlvs);
                }

                fndScoreTemplateLnMapper.delete(ftl);
            }
            FndScoreTemplateDbSource fstds = new FndScoreTemplateDbSource();
            fstds.setScoreTemplateHdId(f.getScoreTemplateHdId());
            fndScoreTemplateDbSourceMapper.delete(fstds);

            fndScoreTemplateHdMapper.delete(f);
        }
    }
}