package hls.core.hls.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.hls.dto.FndScoreTemplateLnValue;
import hls.core.hls.mapper.FndScoreTemplateLnMapper;
import hls.core.hls.mapper.FndScoreTemplateLnValueMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.hls.dto.FndScoreTemplateLn;
import hls.core.hls.service.IFndScoreTemplateLnService;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

@Service
@Transactional
public class FndScoreTemplateLnServiceImpl extends BaseServiceImpl<FndScoreTemplateLn> implements IFndScoreTemplateLnService{

    @Autowired
    private FndScoreTemplateLnValueMapper fndScoreTemplateLnValueMapper;

    @Autowired
    private FndScoreTemplateLnMapper fndScoreTemplateLnMapper;

    public List<FndScoreTemplateLn> select(IRequest request, FndScoreTemplateLn condition, int pageNum, int pageSize) {
        PageHelper.startPage(pageNum, pageSize);
        return fndScoreTemplateLnMapper.select(condition);
    }

    @Override
    public List<FndScoreTemplateLn> selectLevelOne(IRequest requestContext, FndScoreTemplateLn condition, int pageNum, int pageSize) {
        PageHelper.startPage(pageNum, pageSize);
        return fndScoreTemplateLnMapper.selectLevelOne(condition);
    }

    @Override
    public void deleteChild(List<FndScoreTemplateLn> fndScoreTemplateLns) {
        for (FndScoreTemplateLn fstl:
             fndScoreTemplateLns) {
            FndScoreTemplateLnValue fstlv = new FndScoreTemplateLnValue();
            fstlv.setScoreTemplateLnId(fstl.getScoreTemplateLnId());
            for (FndScoreTemplateLnValue fstlvs:
                 fndScoreTemplateLnValueMapper.select(fstlv)) {
                fndScoreTemplateLnValueMapper.delete(fstlv);
            }
            fndScoreTemplateLnMapper.delete(fstl);
        }

    }

    @Override
    public List<FndScoreTemplateLn> queryScoreTemplateLn(FndScoreTemplateLn fndScoreTemplateLn) {

        List<FndScoreTemplateLn> list = fndScoreTemplateLnMapper.queryScoreTemplateLn(fndScoreTemplateLn);
        List<FndScoreTemplateLn> list2 = new ArrayList<>();

        String TempTargetName = null;


        list2 = recordTreeToList(list,list2,TempTargetName);

        List<FndScoreTemplateLn> result = new ArrayList<>();

        for (FndScoreTemplateLn fnd: list2){
            if( fnd.getSummaryFlag()!=null && fnd.getSummaryFlag().equals("N")){
                result.add(fnd);
            }
        }

        return result;
    }
    private static List<FndScoreTemplateLn> recordTreeToList(List<FndScoreTemplateLn> list,List<FndScoreTemplateLn> relist,String targetName){

        for (FndScoreTemplateLn fnd: list){
            if(fnd.getScoreTemplateLn().size() >= 0){

                List<FndScoreTemplateLn> fndArray = fnd.getScoreTemplateLn();

                fnd.setTargetName(targetName);
                relist.add(fnd);
                recordTreeToList(fndArray,relist,fnd.getFirstTargetName());
            }
        }
        return relist;
    }



    @Override
    public List<FndScoreTemplateLn> selectLnRoot(Long scoreTemplateHdId) {
        return fndScoreTemplateLnMapper.selectLnRoot(scoreTemplateHdId);
    }


}