package hls.core.hls.service.impl;
import com.hand.hap.core.AppContextInitListener;
import hls.core.csh.mapper.HlsCusConContractCashflowMapper;
import hls.core.hls.exception.DayEndDateNullException;
import hls.core.hls.exception.DayEndTypeNullException;
import hls.core.hls.service.HlsDayEndCommon;
import hls.core.hls.service.HlsDayEndService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

@Service
@Transactional(rollbackFor = {Exception.class, RuntimeException.class})
public class HlsDayEndServiceImpl implements HlsDayEndService,AppContextInitListener {
    @Autowired
    HlsCusConContractCashflowMapper cashFlowMapper;

    private Map<String, HlsDayEndCommon> dayEndReg = new HashMap<>();



    @Override
    public void excEndDay(Map map)throws DayEndTypeNullException,DayEndDateNullException {
        //Long companyId = (Long) session.getAttribute("companyId");
        //map.put("companyId", companyId);
        String dayEndType = map.get("dayEndType").toString();
        if(dayEndType == ""){
            throw new DayEndTypeNullException();
        }
        if(map.get("dayEndDate") == null){
            throw new DayEndDateNullException();
        }
        if(map.get("jobExecute") == null){
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            try {
                Date date = sdf.parse(map.get("dayEndDate").toString());
                map.put("dayEndDate",date);
            } catch (ParseException e) {
                e.printStackTrace();
            }
        }
        HlsDayEndCommon hlsDayEndCommon = dayEndReg.get(dayEndType);
        hlsDayEndCommon.process(map);

//        //有合同ID,就查出该合同对应的现金流出来
//        if(map.get("contractId") != null){
//            List<HlsCusConContractCashflowMapper> ConContractCashFlowList = cashFlowMapper.selectAllConContractCashflow();
//            HlsDayEndCommon hlsDayEndCommon = dayEndReg.get(dayEndType);
//        }
    }

    @Override
    public void contextInitialized(ApplicationContext appCtx) {
        Map<String, HlsDayEndCommon> map = appCtx.getBeansOfType(HlsDayEndCommon.class);
        map.forEach((k, v) -> {
            dayEndReg.put(v.getDayEndType(), v);
        });

    }
}
