package hls.core.hls.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.hls.dto.HlsDbDataSourceColumn;
import hls.core.hls.dto.HlsDbDataSourcePara;
import hls.core.hls.mapper.HlsDbDataSourceColumnMapper;
import hls.core.hls.mapper.HlsDbDataSourceMapper;
import hls.core.hls.mapper.HlsDbDataSourceParaMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.hls.dto.HlsDbDataSource;
import hls.core.hls.service.IHlsDbDataSourceService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional
public class HlsDbDataSourceServiceImpl extends BaseServiceImpl<HlsDbDataSource> implements IHlsDbDataSourceService{

    @Autowired
    private HlsDbDataSourceMapper hlsDbDataSourceMapper;
    @Autowired
    private HlsDbDataSourceColumnMapper hlsDbDataSourceColumnMapper;
    @Autowired
    private HlsDbDataSourceParaMapper hlsDbDataSourceParaMapper;

    @Override
    public List<HlsDbDataSource> dataSource(HlsDbDataSource dto) {
        return hlsDbDataSourceMapper.select(dto);
    }

    public List<HlsDbDataSource> query(IRequest request, HlsDbDataSource dto, int page, int pageSize){
        PageHelper.startPage(page,pageSize);
        return hlsDbDataSourceMapper.query(dto);
    }

    @Override
    public void deleteChild(List<HlsDbDataSource> list) {
        for (HlsDbDataSource hds:
             list) {
            HlsDbDataSourceColumn hddsc = new HlsDbDataSourceColumn();
            hddsc.setDataSourceId(hds.getDataSourceId());
            for (HlsDbDataSourceColumn hddscs:
                 hlsDbDataSourceColumnMapper.select(hddsc)) {
                 hlsDbDataSourceColumnMapper.delete(hddscs);
            }
            HlsDbDataSourcePara hddsp = new HlsDbDataSourcePara();
            hddsp.setDataSourceId(hds.getDataSourceId());
            for (HlsDbDataSourcePara hddsps:
                 hlsDbDataSourceParaMapper.select(hddsp)) {
                 hlsDbDataSourceParaMapper.delete(hddsps);
            }
            hlsDbDataSourceMapper.delete(hds);
        }
    }

}