package hls.core.hls.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.excel.ExcelException;
import com.hand.hap.excel.dto.ColumnInfo;
import com.hand.hap.generator.service.impl.DBUtil;
import hls.core.fnd.dto.FndInterfaceHeaders;
import hls.core.fnd.dto.FndInterfaceLines;
import hls.core.fnd.mapper.FndInterfaceHeadersMapper;
import hls.core.fnd.mapper.FndInterfaceLinesMapper;
import hls.core.fnd.service.FndInterfaceHeadersService;
import hls.core.fnd.service.FndInterfaceLinesService;
import hls.core.hls.service.HlsBeanRefUtilService;
import hls.core.hls.service.HlsExcelCommonService;
import hls.core.hls.service.HlsExcelService;
import org.apache.poi.hssf.usermodel.HSSFDataFormat;
import org.apache.poi.hssf.usermodel.HSSFDateUtil;
import org.apache.poi.openxml4j.exceptions.InvalidFormatException;
import org.apache.poi.ss.usermodel.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.sql.DataSource;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.InvocationTargetException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by Administrator on 2017/4/11.
 */
@Service
@Transactional
public class HlsExcelCommonServiceImpl implements HlsExcelCommonService {
    @Autowired
    @Qualifier("dataSource")
    DataSource dataSource;
    private Sheet sheet;
    private Row row;

    @Override
    public void loadExcel(InputStream fs, String tableName,Sheet sheet){
        List columnInfos = null;

        try {
            columnInfos = this.readColumnType(tableName);
        } catch (SQLException var64) {
            var64.printStackTrace();
        }

        int batchCount = 0;
        String sql = "insert into " + tableName + " (";
        Row row1 = sheet.getRow(1);
        if(!this.isContains(columnInfos, row1)) {
        } else {
            Iterator iterator = row1.cellIterator();

            while(iterator.hasNext()) {
                Cell iterator1 = (Cell)iterator.next();
                if(!iterator1.equals((Object)null) && !iterator1.toString().equals("") && !iterator1.toString().equals(" ")) {
                    sql = sql + iterator1.toString() + ",";
                }
            }

            sql = sql.substring(0, sql.length() - 1) + ") values(";
            Iterator var71 = row1.cellIterator();

            while(var71.hasNext()) {
                sql = sql + "?,";
                var71.next();
            }

            sql = sql.substring(0, sql.length() - 1) + ")";
            Connection conn = null;

            try {
                Connection e = this.dataSource.getConnection();
                Throwable e1 = null;

                try {
                    conn = e;
                    e.setAutoCommit(false);
                    PreparedStatement stmt = e.prepareStatement(sql);
                    Throwable var16 = null;

                    try {
                            byte key = 2;
                            for(int j = key; j < sheet.getLastRowNum() + 1; ++j) {
                                Row rows = sheet.getRow(j);
                                Iterator iterator3 = row1.cellIterator();

                                for(int ii = 1; iterator3.hasNext(); ++ii) {
                                    Cell cell = (Cell)iterator3.next();
                                    if(!cell.equals((Object)null) && !cell.toString().equals("") && !cell.toString().equals(" ")) {
                                        String type = "STRING";
                                        Iterator cells = columnInfos.iterator();

                                        while(cells.hasNext()) {
                                            ColumnInfo columnInfo = (ColumnInfo)cells.next();
                                            if(columnInfo.getName().toUpperCase().equals(cell.toString().toUpperCase())) {
                                                type = columnInfo.getType();
                                                break;
                                            }
                                        }

                                        Cell var72 = rows.getCell(cell.getColumnIndex());
                                        byte var26;
                                        if(null != var72) {
                                            var26 = -1;
                                            switch(type.hashCode()) {
                                                case -2034720975:
                                                    if(type.equals("DECIMAL")) {
                                                        var26 = 10;
                                                    }
                                                    break;
                                                case -1981034679:
                                                    if(type.equals("NUMBER")) {
                                                        var26 = 7;
                                                    }
                                                    break;
                                                case -1718637701:
                                                    if(type.equals("DATETIME")) {
                                                        var26 = 2;
                                                    }
                                                    break;
                                                case -1618932450:
                                                    if(type.equals("INTEGER")) {
                                                        var26 = 8;
                                                    }
                                                    break;
                                                case -1453246218:
                                                    if(type.equals("TIMESTAMP")) {
                                                        var26 = 1;
                                                    }
                                                    break;
                                                case -594415409:
                                                    if(type.equals("TINYINT")) {
                                                        var26 = 11;
                                                    }
                                                    break;
                                                case 72655:
                                                    if(type.equals("INT")) {
                                                        var26 = 5;
                                                    }
                                                    break;
                                                case 2090926:
                                                    if(type.equals("DATE")) {
                                                        var26 = 0;
                                                    }
                                                    break;
                                                case 2575053:
                                                    if(type.equals("TIME")) {
                                                        var26 = 3;
                                                    }
                                                    break;
                                                case 66988604:
                                                    if(type.equals("FLOAT")) {
                                                        var26 = 9;
                                                    }
                                                    break;
                                                case 1959128815:
                                                    if(type.equals("BIGINT")) {
                                                        var26 = 4;
                                                    }
                                                    break;
                                                case 2022338513:
                                                    if(type.equals("DOUBLE")) {
                                                        var26 = 6;
                                                    }
                                            }

                                            switch(var26) {
                                                case 0:
                                                case 1:
                                                case 2:
                                                case 3:
                                                    try {
                                                        stmt.setDate(ii, new java.sql.Date(var72.getDateCellValue().getTime()));
                                                        break;
                                                    } catch (IllegalStateException var63) {
                                                        var63.printStackTrace();
                                                        throw new ExcelException((String)null, var72.toString() + " 数据类型错误: " + (j + 1) + "行" + (var72.getColumnIndex() + 1) + "列,期待的类型: " + type, (Object[])null);
                                                    }
                                                case 4:
                                                case 5:
                                                case 6:
                                                case 7:
                                                case 8:
                                                case 9:
                                                case 10:
                                                case 11:
                                                    try {
                                                        stmt.setInt(ii, (int)var72.getNumericCellValue());
                                                        break;
                                                    } catch (IllegalStateException var62) {
                                                        var62.printStackTrace();
                                                        throw new ExcelException((String)null, var72.toString() + " 数据类型错误: " + (j + 1) + "行" + (var72.getColumnIndex() + 1) + "列,期待的类型: " + type, (Object[])null);
                                                    }
                                                default:
                                                    var72.setCellType(1);
                                                    stmt.setString(ii, var72.getStringCellValue());
                                            }
                                        } else {
                                            String var73 = type.toUpperCase();
                                            var26 = -1;
                                            switch(var73.hashCode()) {
                                                case -2034720975:
                                                    if(var73.equals("DECIMAL")) {
                                                        var26 = 6;
                                                    }
                                                    break;
                                                case -1838656495:
                                                    if(var73.equals("STRING")) {
                                                        var26 = 1;
                                                    }
                                                    break;
                                                case -1718637701:
                                                    if(var73.equals("DATETIME")) {
                                                        var26 = 8;
                                                    }
                                                    break;
                                                case -1618932450:
                                                    if(var73.equals("INTEGER")) {
                                                        var26 = 3;
                                                    }
                                                    break;
                                                case -1453246218:
                                                    if(var73.equals("TIMESTAMP")) {
                                                        var26 = 10;
                                                    }
                                                    break;
                                                case 2067286:
                                                    if(var73.equals("CHAR")) {
                                                        var26 = 2;
                                                    }
                                                    break;
                                                case 2090926:
                                                    if(var73.equals("DATE")) {
                                                        var26 = 7;
                                                    }
                                                    break;
                                                case 2575053:
                                                    if(var73.equals("TIME")) {
                                                        var26 = 9;
                                                    }
                                                    break;
                                                case 954596061:
                                                    if(var73.equals("VARCHAR")) {
                                                        var26 = 0;
                                                    }
                                                    break;
                                                case 1959128815:
                                                    if(var73.equals("BIGINT")) {
                                                        var26 = 4;
                                                    }
                                                    break;
                                                case 2022338513:
                                                    if(var73.equals("DOUBLE")) {
                                                        var26 = 5;
                                                    }
                                            }

                                            switch(var26) {
                                                case 0:
                                                case 1:
                                                    stmt.setNull(ii, 12);
                                                    break;
                                                case 2:
                                                    stmt.setNull(ii, 1);
                                                    break;
                                                case 3:
                                                    stmt.setNull(ii, 4);
                                                    break;
                                                case 4:
                                                    stmt.setNull(ii, -5);
                                                    break;
                                                case 5:
                                                    stmt.setNull(ii, 8);
                                                    break;
                                                case 6:
                                                    stmt.setNull(ii, 3);
                                                    break;
                                                case 7:
                                                case 8:
                                                case 9:
                                                case 10:
                                                    stmt.setNull(ii, 91);
                                            }
                                        }
                                    }
                                }

                                stmt.addBatch();
                                ++batchCount;
                                if(batchCount >= 100) {
                                    this.insertData(stmt);
                                    batchCount = 0;
                                }
                            }

                            if(batchCount > 0) {
                                this.insertData(stmt);
                            }

                        conn.commit();
                    } catch (Throwable var66) {
                        var16 = var66;
                        throw var66;
                    } finally {
                        if(stmt != null) {
                            if(var16 != null) {
                                try {
                                    stmt.close();
                                } catch (Throwable var61) {
                                    var16.addSuppressed(var61);
                                }
                            } else {
                                stmt.close();
                            }
                        }

                    }
                } catch (Throwable var68) {
                    e1 = var68;
                } finally {
                    if(e != null) {
                        if(e1 != null) {
                            try {
                                e.close();
                            } catch (Throwable var60) {
                                e1.addSuppressed(var60);
                            }
                        } else {
                            e.close();
                        }
                    }

                }
            } catch (SQLException var70) {
                var70.printStackTrace();

                try {
                    conn.rollback();
                } catch (SQLException var59) {
                    var59.printStackTrace();
                }
            }
        }
    }

    private void insertData(PreparedStatement statement) throws ExcelException {
        try {
            statement.executeBatch();
        } catch (SQLException var3) {
            var3.printStackTrace();
            throw new ExcelException((String)null, "数据插入失败: " + var3.getMessage(), (Object[])null);
        }
    }

    public List<ColumnInfo> readColumnType(String tableName) throws SQLException {
        ArrayList columnInfos = new ArrayList();
        Connection connection = this.dataSource.getConnection();
        Throwable var4 = null;

        try {
            ResultSet resultSet = DBUtil.getTableColumnInfo(tableName, connection.getMetaData());

            while(resultSet.next()) {
                ColumnInfo columnInfo = new ColumnInfo();
                String typeName = resultSet.getString("TYPE_NAME");
                String columnName = resultSet.getString("COLUMN_NAME");
                columnInfo.setName(columnName);
                columnInfo.setType(typeName);
                columnInfos.add(columnInfo);
            }
        } catch (Throwable var16) {
            var4 = var16;
            throw var16;
        } finally {
            if(connection != null) {
                if(var4 != null) {
                    try {
                        connection.close();
                    } catch (Throwable var15) {
                        var4.addSuppressed(var15);
                    }
                } else {
                    connection.close();
                }
            }

        }

        return columnInfos;
    }

    private boolean isContains(List<ColumnInfo> columnInfos, Row rowTalbeName) {
        boolean result = true;
        Iterator iterator = rowTalbeName.cellIterator();

        while(iterator.hasNext()) {
            boolean key = false;
            Cell cell = (Cell)iterator.next();
            Iterator var7 = columnInfos.iterator();

            while(var7.hasNext()) {
                ColumnInfo columnInfo = (ColumnInfo)var7.next();
                if(!cell.equals((Object)null) && !cell.equals("") && !cell.equals(" ") && columnInfo.getName().toUpperCase().equals(cell.toString().toUpperCase())) {
                    key = true;
                }
            }

            if(!key) {
                result = false;
                break;
            }
        }

        return result;
    }
}
