package hls.core.hls.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.hls.dto.HlsScoreCalculation;
import hls.core.hls.mapper.HlsScoreCalculationMapper;
import hls.core.hls.service.IHlsScoreCalculationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional
public class HlsScoreCalculationServiceImpl extends BaseServiceImpl<HlsScoreCalculation> implements IHlsScoreCalculationService {


    @Autowired
    HlsScoreCalculationMapper hlsScoreCalculationMapper;

    @Override
    public List<HlsScoreCalculation> selectListOfHsc(HlsScoreCalculation hlsScoreCalculation) {

        return hlsScoreCalculationMapper.selectListOfHsc(hlsScoreCalculation);
    }

/*    @Override
    public boolean checkFiscalDate(String fiscalYear, String fiscalMonth) {

        Long scoreId = hlsScoreCalculationMapper.checkFiscalDate(fiscalYear,fiscalMonth);

        if(scoreId == null){
            return false;
        }else {
            return true;
        }
    }*/



    @Override
    public List<HlsScoreCalculation> chooseTime(Long scoreTemplateHdId) {
        return hlsScoreCalculationMapper.chooseTime(scoreTemplateHdId);
    }


    @Override
    public List<HlsScoreCalculation> bpMasterScoreInfo(Long bpId, int page, int pagesize) {
        PageHelper.startPage(page, pagesize);
        return hlsScoreCalculationMapper.bpMasterScoreInfo(bpId);
    }
}