package hls.core.hls.service.impl;


import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.hls.dto.FndScoreTargetValues;
import hls.core.hls.dto.HlsScoreTarget;
import hls.core.hls.mapper.FndScoreTargetValuesMapper;
import hls.core.hls.mapper.HlsScoreTargetMapper;
import hls.core.hls.service.IHlsScoreTargetService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional
public class HlsScoreTargetServiceImpl extends BaseServiceImpl<HlsScoreTarget> implements IHlsScoreTargetService {

    @Autowired
    private HlsScoreTargetMapper hlsScoreTargetMapper;
    @Autowired
    private FndScoreTargetValuesMapper fndScoreTargetValuesMapper;

    @Override
    public List<HlsScoreTarget> query(IRequest request, HlsScoreTarget dto, int page, int pageSize) {
        PageHelper.startPage(page,pageSize);
        return hlsScoreTargetMapper.query(dto);
    }

    @Override
    public void deleteHl(List<HlsScoreTarget> list) {
        FndScoreTargetValues childMap = new FndScoreTargetValues();
        for (HlsScoreTarget child:
             list) {
            childMap.setScoreTargetId(child.getScoreTargetId());
            fndScoreTargetValuesMapper.delete(childMap);
            hlsScoreTargetMapper.delete(child);
        }
    }
}