package hls.core.hls.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.hls.dto.HlsDocAuthority;
import hls.core.hls.dto.HlsSystemEvent;
import hls.core.hls.dto.HlsSystemNotice;
import hls.core.hls.dto.HlsUserRelationship;
import hls.core.hls.mapper.HlsSystemEventMapper;
import hls.core.hls.service.HlsSystemEventService;
import hls.core.hls.service.HlsSystemNoticeService;
import hls.core.hls.service.IHlsDocAuthorityService;
import hls.core.hls.service.IHlsUserRelationshipService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.persistence.Transient;
import java.util.List;

/**
 * Created by gaoyang on 2017-2-6.
 */
@Service
@Transactional
public class HlsSystemEventServiceImpl extends BaseServiceImpl<HlsSystemEvent> implements HlsSystemEventService{

    /*@Autowired
    private HlsSystemEventService hlsSystemEventService;*/
    @Autowired
    private IHlsDocAuthorityService docAuthorityService;
    @Autowired
    private IHlsUserRelationshipService hlsUserRelationshipService;
    @Autowired
    private HlsSystemNoticeService hlsSystemNoticeService;
    @Autowired
    private HlsSystemEventMapper hlsSystemEventMapper;


    @Override
    public void batchSave(IRequest iRequest, List<HlsSystemEvent> hse, List<HlsDocAuthority> hda, List<HlsUserRelationship> hur, List<HlsSystemNotice> hsn) {

        self().batchUpdate(iRequest,hse);
        if(hda.size()>0) {
            docAuthorityService.batchUpdate(iRequest, hda);
        }
        if(hur.size()>0){
            hlsUserRelationshipService.batchUpdate(iRequest,hur);
        }
        hlsSystemNoticeService.batchUpdate(iRequest,hsn);
    }

    @Override
    public List<HlsSystemEvent> selectSystemEventByConId(long contractId) {
        return hlsSystemEventMapper.selectSystemEventByConId(contractId);
    }
    @Override
    public List<HlsSystemEvent> selectBpMasterByConId(long bpId){
        return hlsSystemEventMapper.selectBpMasterByConId(bpId);
    }
}
