package hls.core.hls.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.hls.dto.HlsSystemNotice;
import hls.core.hls.mapper.HlsSystemNoticeMapper;
import hls.core.hls.service.HlsSystemNoticeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpSession;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;

@Service
public class HlsSystemServiceImpl extends BaseServiceImpl<HlsSystemNotice> implements HlsSystemNoticeService {

    @Autowired
    HlsSystemNoticeMapper hsnm;

    @Override
    public List<HlsSystemNotice> selectUserNotice(Long user_id) {
        // TODO Auto-generated method stub
        return hsnm.selectUserNotice(user_id);
    }

    @Override
    public List<HlsSystemNotice> getNoticeMessage(HlsSystemNotice hlsSystemNotice) {
        PageHelper.startPage(1, 4);
        final List<HlsSystemNotice> noticeMessage = hsnm.getNoticeMessage(hlsSystemNotice);
        Date time = new Date();
        noticeMessage.forEach(item -> {
            Double arrvialTime = Double.valueOf((time.getTime() - item.getNotice_datetime().getTime()) / (1000 * 60 * 60));
            item.setArrivalTime(arrvialTime);
        });
        return noticeMessage;
    }

    @Override
    public List<HlsSystemNotice> getNoticeCountAndRadio(HlsSystemNotice hlsSystemNotice) {
        return hsnm.getNoticeCountAndRadio(hlsSystemNotice);
    }

    @Override
    public List<HlsSystemNotice> getTodoNoticeMessage() {
        List<HlsSystemNotice> todoNoticeMessage = hsnm.getTodoNoticeMessage();
        Date time = new Date();
        todoNoticeMessage.forEach(item -> {
            Double arrvialTime = Double.valueOf((time.getTime() - item.getNotice_datetime().getTime()) / (1000 * 60));
            item.setArrivalTime(arrvialTime);
        });
        return todoNoticeMessage;
    }

    @Override
    public List<HlsSystemNotice> selectConNotice(HlsSystemNotice hlsSystemNotice, int page, int pageSize) {
        // TODO Auto-generated method stub
        PageHelper.startPage(page, pageSize);
        return hsnm.selectConNotice(hlsSystemNotice);
    }

    @Override
    public List<HlsSystemNotice> selectLonNotice(HlsSystemNotice hlsSystemNotice, int page, int pageSize) {
        // TODO Auto-generated method stub
        PageHelper.startPage(page, pageSize);
        return hsnm.selectLonNotice(hlsSystemNotice);
    }

    @Override
    public List<HlsSystemNotice> selectLonWithdrawNotice(HlsSystemNotice hlsSystemNotice, int page, int pageSize) {
        // TODO Auto-generated method stub
        PageHelper.startPage(page, pageSize);
        return hsnm.selectLonWithdrawNotice(hlsSystemNotice);
    }

    @Override
    public List<HlsSystemNotice> selectNoticeById(Long notice_id) {
        return hsnm.selectNoticeById(notice_id);
    }

    @Override
    public void updateById(IRequest requestContext, Long notice_id) {
        HlsSystemNotice hsn = new HlsSystemNotice();
        hsn.setNotice_id(notice_id);
        hsn.setRead_flag("Y");
        self().updateByPrimaryKeySelective(requestContext, hsn);
    }

    @Override
    public List<HlsSystemNotice> selectNoticeTypeInfo(HlsSystemNotice hlsSystemNotice, HttpSession session) {
        hlsSystemNotice.setSource_document_id((Long) session.getAttribute("sourceDocumentId"));
        return hsnm.selectNoticeTypeInfo(hlsSystemNotice);
    }

    @Override
    public List<HlsSystemNotice> getTotalNoticeCount() {
        return hsnm.getTotalNoticeCount();
    }

    @Override
    public List<HlsSystemNotice> selectPrjNotice(IRequest iRequest, int page, int pageSize) {
        PageHelper.startPage(page, pageSize);
        Long companyId = iRequest.getCompanyId();
        List<HlsSystemNotice> list = new ArrayList<>();
        list = hsnm.selectPrjNotice(companyId);
        for (int i = 0; i < list.size(); i++) {
            try {
                Date prjDate = list.get(i).getNotice_datetime();
                Date now = new Date();
                Long differ = (now.getTime() - prjDate.getTime()) / 3600;//获取时间差
                if (differ >= 0 && differ <= 60) {
                    list.get(i).setNotice_datetime_differ(differ.toString());
                } else if (differ < 0) {
                    list.get(i).setNotice_datetime_differ("1");
                } else {
                    SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
                    String dateString = formatter.format(prjDate);
                    list.get(i).setNotice_datetime_differ(dateString);
                }
            } catch (Exception ex) {

            }
        }


        return list;
    }

    @Override
    public List<HlsSystemNotice> selectUserBoxNotice(HlsSystemNotice hlsSystemNotice) {
        // TODO Auto-generated method stub
        return hsnm.selectUserBoxNotice(hlsSystemNotice);
    }

    @Override
    public List<HlsSystemNotice> selectSendNotice(HlsSystemNotice hlsSystemNotice) {
        // TODO Auto-generated method stub
        return hsnm.selectSendNotice(hlsSystemNotice);
    }

    @Override
    public List<HlsSystemNotice> selectFiveDaysNotice(HlsSystemNotice hlsSystemNotice) {
        // TODO Auto-generated method stub
        return hsnm.selectFiveDaysNotice(hlsSystemNotice);
    }

    @Override
    public List<HlsSystemNotice> selectUserAllDoc(HlsSystemNotice hlsSystemNotice) {
        return hsnm.selectUserAllDoc(hlsSystemNotice);
    }

    @Override
    public List<HlsSystemNotice> selectThreeNoticeAndTodo(HlsSystemNotice hlsSystemNotice) {
        return hsnm.selectThreeNoticeAndTodo(hlsSystemNotice);
    }

    @Override
    public List<HlsSystemNotice> queryNoticeByTodoAndDocId(Long source_document_id) {
        return hsnm.queryNoticeByTodoAndDocId(source_document_id);
    }

    @Override
    public List<HlsSystemNotice> queyAllInfoByBpId(Long source_document_id) {
        return hsnm.queyAllInfoByBpId(source_document_id);
    }

    @Override
    public List<HlsSystemNotice> queryByDocAndId(HlsSystemNotice hlsSystemNotice) {
        return hsnm.queryByDocAndId(hlsSystemNotice);
    }

    @Override
    public List<HlsSystemNotice> selectFctProjectCreditNotice(HlsSystemNotice hlsSystemNotice, int page, int pageSize) {
        PageHelper.startPage(page, pageSize);
        hlsSystemNotice.setSource_event("FCT_PROJECT_CREDIT.");
        hlsSystemNotice.setSource_module("FCT");
        return hsnm.selectDocumentNotice(hlsSystemNotice);
    }

    @Override
    public List<HlsSystemNotice> selectFctProjectSignNotice(HlsSystemNotice hlsSystemNotice, int page, int pageSize) {
        PageHelper.startPage(page, pageSize);

        hlsSystemNotice.setSource_event("FCT_CONTRACT_CONTENT.");
        hlsSystemNotice.setSource_module("FCT");
        List<HlsSystemNotice> hlsSystemNoticeList1 = hsnm.selectDocumentNotice(hlsSystemNotice);
        hlsSystemNotice.setSource_event("FCT_CONTRACT_SIGN.");
        hlsSystemNotice.setSource_module("FCT");
        List<HlsSystemNotice> hlsSystemNoticeList2 = hsnm.selectDocumentNotice(hlsSystemNotice);
        List<HlsSystemNotice> hlsSystemNoticeList = new ArrayList<HlsSystemNotice>();
        hlsSystemNoticeList.addAll(hlsSystemNoticeList1);
        hlsSystemNoticeList.addAll(hlsSystemNoticeList2);
        //时间转换
        Collections.sort(hlsSystemNoticeList, new Comparator<HlsSystemNotice>() {
            public int compare(HlsSystemNotice h1, HlsSystemNotice h2) {
                return h2.getNotice_datetime().compareTo(h1.getNotice_datetime());
            }
        });
        if(hlsSystemNoticeList.size()<pageSize -1){
            hlsSystemNoticeList = hlsSystemNoticeList.subList(0,hlsSystemNoticeList.size());
        }else {
            hlsSystemNoticeList = hlsSystemNoticeList.subList(0, pageSize - 1);
        }

        return hlsSystemNoticeList;
    }

    @Override
    public List<HlsSystemNotice> selectFctContractManagerNotice(HlsSystemNotice hlsSystemNotice, int page, int pageSize) {


        hlsSystemNotice.setSource_event("FCT_WITHDRAW_REQUEST.");
        hlsSystemNotice.setSource_module("FCT");
        List<HlsSystemNotice> hlsSystemNoticeList1 = hsnm.selectDocumentNotice(hlsSystemNotice);
        hlsSystemNotice.setSource_event("FCT_PAYMENT_REQUEST.");
        hlsSystemNotice.setSource_module("FCT");
        List<HlsSystemNotice> hlsSystemNoticeList2 = hsnm.selectDocumentNotice(hlsSystemNotice);

        hlsSystemNotice.setSource_event("FCT_ADVANCES_RECEIVED.");
        hlsSystemNotice.setSource_module("FCT");
        List<HlsSystemNotice> hlsSystemNoticeList3 = hsnm.selectDocumentNotice(hlsSystemNotice);
        hlsSystemNotice.setSource_event("FCT_SPECIAL_REQUEST.");
        hlsSystemNotice.setSource_module("FCT");
        List<HlsSystemNotice> hlsSystemNoticeList4 = hsnm.selectDocumentNotice(hlsSystemNotice);


        List<HlsSystemNotice> hlsSystemNoticeList = new ArrayList<HlsSystemNotice>();
        hlsSystemNoticeList.addAll(hlsSystemNoticeList1);
        hlsSystemNoticeList.addAll(hlsSystemNoticeList2);
        hlsSystemNoticeList.addAll(hlsSystemNoticeList3);
        hlsSystemNoticeList.addAll(hlsSystemNoticeList4);

        Collections.sort(hlsSystemNoticeList, new Comparator<HlsSystemNotice>() {
            public int compare(HlsSystemNotice h1, HlsSystemNotice h2) {
                return h2.getNotice_datetime().compareTo(h1.getNotice_datetime());
            }
        });
        if(hlsSystemNoticeList.size()<pageSize -1){
            hlsSystemNoticeList = hlsSystemNoticeList.subList(0,hlsSystemNoticeList.size());
        }else {
            hlsSystemNoticeList = hlsSystemNoticeList.subList(0, pageSize - 1);
        }
        return hlsSystemNoticeList;
    }
    @Override
    public List<HlsSystemNotice> selectFctNotice(HlsSystemNotice hlsSystemNotice, int page, int pageSize) {
        hlsSystemNotice.setSource_event("FCT_PROJECT_BASIC_TRX");
        hlsSystemNotice.setSource_module("FCT");
        List<HlsSystemNotice> hlsSystemNoticeList = hsnm.selectDocumentNotice(hlsSystemNotice);

        Collections.sort(hlsSystemNoticeList, new Comparator<HlsSystemNotice>() {
            public int compare(HlsSystemNotice h1, HlsSystemNotice h2) {
                return h2.getNotice_datetime().compareTo(h1.getNotice_datetime());
            }
        });
        if(hlsSystemNoticeList.size()<pageSize -1){
            hlsSystemNoticeList = hlsSystemNoticeList.subList(0,hlsSystemNoticeList.size());
        }else {
            hlsSystemNoticeList = hlsSystemNoticeList.subList(0, pageSize - 1);
        }
        return hlsSystemNoticeList;
    }
}
