package hls.core.info.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.info.dto.HlsDebtDeductionHeader;
import hls.core.info.service.HlsDebtDeductionHeaderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * Created by Administrator on 2017/3/31.
 */
@Controller
public class HlsDebtDeductionHeaderController extends BaseController {
    @Autowired
    private HlsDebtDeductionHeaderService debtDeductionHeaderService;

    @RequestMapping(value = "/hls/debt/header/query")
    @ResponseBody
    public ResponseData query(HttpServletRequest request, @RequestBody Map map, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(debtDeductionHeaderService.query(requestContext, map, page, pagesize));
    }

    @RequestMapping(value = "/hls/debt/header/queryHeadData")
    @ResponseBody
    public ResponseData selectDebetDeductionHeadData(final HlsDebtDeductionHeader debtDeductionHeader, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
        IRequest requestContext = createRequestContext(request);
        List<HlsDebtDeductionHeader> list = debtDeductionHeaderService.selectDebetDeductionHeadData(requestContext, debtDeductionHeader, page, pagesize);
        return new ResponseData(list);
    }
}
