package hls.core.info.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.info.dto.HlsDebtDeductionHeader;
import hls.core.info.dto.HlsDebtDeductionLine;
import hls.core.info.service.HlsDebtDeductionLineService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * Created by Administrator on 2017/3/31.
 */
@Controller
public class HlsDebtDeductionLineController extends BaseController {

    @Autowired
    HlsDebtDeductionLineService debtDeductionLineService;

    @RequestMapping(value = "/hls/debt/line/query")
    @ResponseBody
    public ResponseData query(HttpServletRequest request,@RequestBody Map map, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
        IRequest requestContext = createRequestContext(request);
        List<HlsDebtDeductionLine> list = null;
        if(map.get("groupMonth")== null ||  map.get("groupMonth")== "")
        {
            list= debtDeductionLineService.queryYear(requestContext, map, page, pagesize);
        }else
        {
            list= debtDeductionLineService.queryMonth(requestContext, map, page, pagesize);
        }
        return new ResponseData(list);
    }

    @Autowired
    private HlsDebtDeductionLineService hlsDebtDeductionLineService;

    @RequestMapping(value = "/hls/debt/line/queryLineData")
    @ResponseBody
    public ResponseData selectDebetDeductionHeadData(final HlsDebtDeductionLine hlsDebtDeductionLine, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                                     @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
        IRequest requestContext = createRequestContext(request);
        List<HlsDebtDeductionLine> list = hlsDebtDeductionLineService.selectDebtDecutionLineData(hlsDebtDeductionLine,requestContext , page, pagesize);
        return new ResponseData(list);
    }
}
