package hls.core.info.service.impl;

import com.hand.hap.core.IRequest;
import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.info.dto.HlsDebtDeductionHeader;
import hls.core.info.dto.HlsDebtDeductionLine;
import hls.core.info.mapper.HlsDebtDeductionLineMapper;
import hls.core.info.service.HlsDebtDeductionHeaderService;
import hls.core.info.service.HlsDebtDeductionLineService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * Created by Administrator on 2017/3/31.
 */
@Service
@Transactional
public class HlsDebtDeductionLineServiceImpl extends BaseServiceImpl<HlsDebtDeductionLine> implements HlsDebtDeductionLineService {
    @Autowired
    private HlsDebtDeductionLineMapper mapper;

    @Override
    public List<HlsDebtDeductionLine> selectDebtDecutionLineData(HlsDebtDeductionLine hlsDebtDeductionLine, IRequest iRequest, int page, int pagesize) {
        PageHelper.startPage(page,pagesize);
        return mapper.selectDebtDecutionLineData(hlsDebtDeductionLine);
    }

    @Override
    public List<HlsDebtDeductionLine> queryYear(IRequest requestContext, Map map, int page, int pagesize) {
        PageHelper.startPage(page,pagesize);
        return mapper.queryYear(map);
    }

    @Override
    public List<HlsDebtDeductionLine> queryMonth(IRequest requestContext, Map map, int page, int pagesize) {
        PageHelper.startPage(page,pagesize);
        return mapper.queryMonth(map);
    }
}
