package hls.core.init.components;

import com.hand.hap.core.AppContextInitListener;
import hls.core.init.exception.CheckFileException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

import java.io.File;
import java.util.Arrays;
import java.util.LinkedList;

/**
 * Created by gaoyang on 17/9/21.
 */
@Component
public class HlsCusCheckFile implements AppContextInitListener{

    private Logger logger = LoggerFactory.getLogger(this.getClass());
    String path = this.getClass().getResource("/").getPath().replaceAll("target/core/WEB-INF/classes/","src/main");

    private boolean checkFileName(String fileName){
        Boolean isValidate = true;
        if((fileName.endsWith(".java")||fileName.endsWith(".css")||fileName.endsWith(".js"))&&!fileName.startsWith("HlsCus")){
            isValidate= false;
            logger.info("-----------"+fileName+"-----------------");
        }else if(fileName.endsWith(".xml")){
            if(fileName=="rabbitmq.xml"||fileName=="applicationContext-custom.xml"||fileName=="logback.xml"){
                isValidate = true;
            }else if(fileName.startsWith("applicationContext")&&!"applicationContext-custom.xml".equals(fileName)){
                isValidate = false;
                logger.info("-----------"+fileName+"-----------------");
            }
        }
        return isValidate;
    }

    private void checkFile(){
        if(path.indexOf("src/main")==-1){
            return;
        }
        LinkedList<File> Files = GetDirectory(path);
        for (File file : Files) {
            String fileName = file.getName();
            if(!checkFileName(fileName)){
                try {
                    throw new CheckFileException();
                } catch (CheckFileException e) {
                    logger.error(e.getMessage(),e);
                    System.exit(1);
                }
            }
        }
    }

    public static LinkedList<File> GetDirectory(String path) {
        File file = new File(path);
        LinkedList<File> Dirlist = new LinkedList<File>(); // 保存待遍历文件夹的列表
        LinkedList<File> fileList = new LinkedList<File>();
        GetOneDir(file, Dirlist, fileList);// 调用遍历文件夹根目录文件的方法
        File tmp;
        while (!Dirlist.isEmpty()) {
            tmp = (File) Dirlist.removeFirst();// 从文件夹列表中删除第一个文件夹，并返回该文件夹赋给tmp变量
            GetOneDir(tmp, Dirlist, fileList);

        }
        return fileList;
    }

    private static void GetOneDir(File file, LinkedList<File> Dirlist,
                                  LinkedList<File> fileList) {
        // 每个文件夹遍历都会调用该方法
        File[] files = file.listFiles();

        if (files == null || files.length == 0) {
            return;
        }
        for (File f : files) {
            if (f.isDirectory()) {
                Dirlist.add(f);
            } else {
                fileList.add(f);
            }
        }
    }

    @Override
    public void contextInitialized(ApplicationContext applicationContext){
        File file = new File(path+"/java/hls/core/init/components/HlsCusCheckFile.java");
        if(file.exists()){
            return;
        }
        checkFile();
    }
}

