package hls.core.interceptor;

import com.hand.hap.core.IRequest;
import com.hand.hap.core.impl.RequestHelper;
import hls.core.sys.dto.SysUserAllocation;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.util.Enumeration;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-10-16
 * Time: 16:44
 */
public class RequestContextInterceptor extends HandlerInterceptorAdapter {
    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) {
        HttpSession session = request.getSession(false);
        if (session == null) {
            return true;
        }
        IRequest iRequest = RequestHelper.createServiceRequest(request);
        Enumeration<String> attributeNames = session.getAttributeNames();
        while (attributeNames.hasMoreElements()) {
            String attributeName = attributeNames.nextElement();
            Object value = session.getAttribute(attributeName);
            iRequest.setAttribute(attributeName, value);
        }
        if(request.getParameter("wflRuleControlFlag")!=null){
            iRequest.setAttribute("wflRuleControlFlag", request.getParameter("wflRuleControlFlag"));
        }
        Object allocationId = session.getAttribute(SysUserAllocation.FIELD_ALLOCATION_ID);
        if (allocationId != null) {
            iRequest.setAttribute(IRequest.MDC_PREFIX.concat(SysUserAllocation.FIELD_ALLOCATION_ID), allocationId);
        }
        RequestHelper.setCurrentRequest(iRequest);
        return true;
    }
}
