package hls.core.job;

import com.hand.hap.core.IRequest;
import com.hand.hap.job.AbstractJob;
import org.quartz.JobExecutionContext;

/**
 * 构造一个含有IRequest对象的方法,使得在调度任务时,可以持有一个IRequest对象(包含的用户信息为job的创建者的信息)
 * Created by fjm on 2017/8/4.
 */
public abstract class AbstractJobWithIRequest extends AbstractJob{

    @Override
    public void safeExecute(JobExecutionContext jobExecutionContext) throws Exception {
        IRequest request = (IRequest) jobExecutionContext.getMergedJobDataMap().get("requestContext");
        safeExecuteWithIRequest(jobExecutionContext,request);
    }


    /**
     * 使用IRequest,可以自动的更新who字段(业务表中的时间)
     * @param jobExecutionContext
     * @param iRequest
     */
    public abstract void safeExecuteWithIRequest(JobExecutionContext jobExecutionContext, IRequest iRequest);
}
