package hls.core.job.controllers;

import hls.core.job.service.ISchTaskAuthorizeService;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.job.dto.JobTaskAuthorize;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

    @Controller
    public class SchTaskAuthorizeController extends BaseController{

    @Autowired
    private ISchTaskAuthorizeService service;


    @RequestMapping(value = "/hls/sch/task/authorize/query")
    @ResponseBody
    public ResponseData query(JobTaskAuthorize dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/hls/sch/task/authorize/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<JobTaskAuthorize> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/hls/sch/task/authorize/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<JobTaskAuthorize> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }