package hls.core.lon.components;

import com.hand.hap.core.IRequest;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.service.ConContractService;
import hls.core.lon.dto.HlsCusLonContract;
import hls.core.lon.mapper.HlsCusLonContractMapper;
import hls.core.lon.service.ILonContractService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventCommonService;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.HashMap;
import java.util.Map;

abstract class AbstractLonContractEventHandler implements SysEventCommonService {
    private static final String DOCUMENT_CATEGORY = "LON_CONTRACT";

    public String getMessage(String userDesc, String documentName, String documentNumber){
        if (documentName == null)
            documentName = "";
        return userDesc+getSuffixMsg()+documentName+"("+documentNumber+") "+"。";
    }

    abstract String getSuffixMsg();

    abstract String getNoticeTitle();

    public long getLevel() {
        return 2L;
    }

    public String getSourceModel() {
        return SysEventCodeUtil.PROPERTITY_SOURCEMODULE_LON;
    }

    public String getRelation() {
        return SysEventCodeUtil.PROPERTITY_RELATIONTYPE_P2D;
    }

    @Override
    public String getDocumentCategory() {
        return DOCUMENT_CATEGORY;
    }

    public String getDocumentType(){
        return "";
    }


    @Override
    public void notice(DelegateExecution delegateExecution, String status) {

    }
}
