package hls.core.lon.components;

import com.hand.hap.core.IRequest;
import hls.core.lon.dto.HlsCusLonContract;
import hls.core.lon.mapper.HlsCusLonContractMapper;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import hls.core.sys.service.SysUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by fjm on 2017/11/22.
 */
@Component
public class LonContractCreateEventHandler extends AbstractLonContractEventHandler{

    @Autowired
    private SysUserService sysUserService;
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private HlsCusLonContractMapper lonContractMapper;

    @Override
    String getSuffixMsg() {
        return "创建了融资合同：";
    }

    @Override
    String getNoticeTitle() {
        return "融资合同-创建";
    }

    @Override
    public String getEventCode() {
        return SysEventCodeUtil.PROPERTY_LON_CONTRACT_CREATE;
    }

    @Override
    public void process(IRequest iRequest, Long documentId, String documentCategory, String documentType, Map<String, Object> params) {
        if (params == null) {
            params = new HashMap<>();
        }
        HlsCusLonContract lonContract = lonContractMapper.selectByPrimaryKey(documentId);
        SysUser sysUser = sysUserService.selectUserById(iRequest.getUserId());
        String message = getMessage(sysUser.getDescription(), lonContract.getContractName(), lonContract.getContractNumber());
        params.put("message", message);
        params.put("noticeTitle", getNoticeTitle());
        params.put("level", getLevel());
        params.put("noticeType", "NOTICE");
        sysEventService.eventSave(iRequest, documentId, getDocumentCategory(), getDocumentType(), getSourceModel(), getEventCode(), getRelation(), params);
    }
}
