package hls.core.lon.components;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.IBaseService;
import hls.core.hls.components.DocumentChangeCommon;
import org.apache.commons.beanutils.BeanUtils;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import java.lang.reflect.InvocationTargetException;
import java.util.function.Consumer;

/**
 * Created by fjm on 2017/11/8.
 */
@Component
public class LonSaveComponent {

    public static final String LON_CONTRACT = "lon_contract";//融资合同表名
    public static final String CONTRACT_ID = "contractId";//融资dto对应的合同id字段

    /**
     * 融资模块通用保存方法
     *
     * @param request
     * @param t
     * @param service
     * @param consumer 根据需求使用consumer函数修改传入dto的属性
     * @param <T>
     * @param updateBySelective 根据flag判断,为true则使用updateByPrimaryKeySelective,否则使用updateByPrimaryKey
     * @return
     */
    public <T> T commonSaveMethod(IRequest request, T t, IBaseService<T> service, Consumer<T> consumer, boolean updateBySelective) {
        if (t == null)
            return t;
        try {
            String tableName = DocumentChangeCommon.getTableName(t.getClass());
            String idFliedName = DocumentChangeCommon.getIdFliedByAnnotations(t.getClass());
            String idValue = BeanUtils.getProperty(t, idFliedName);
            if (consumer != null)
                consumer.accept(t);
            if (!StringUtils.isEmpty(BeanUtils.getProperty(t, CONTRACT_ID)) || LON_CONTRACT.equalsIgnoreCase(tableName)) {
                if (StringUtils.isEmpty(idValue)) {
                    service.insertSelective(request, t);
                } else {
                    if (updateBySelective){
                        service.updateByPrimaryKeySelective(request, t);
                    }else {
                        service.updateByPrimaryKey(request, t);
                    }
                }
            }
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        } catch (InvocationTargetException e) {
            e.printStackTrace();
        } catch (NoSuchMethodException e) {
            e.printStackTrace();
        }
        return t;
    }
}
