package hls.core.lon.controllers;

import hls.core.lon.dto.HlsCusCreditContract;
import org.apache.wss4j.dom.handler.RequestData;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.lon.dto.CreditContract;
import hls.core.lon.service.ICreditContractService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.springframework.validation.BindingResult;

import java.util.ArrayList;
import java.util.List;

@Controller
public class CreditContractController extends BaseController {

    @Autowired
    private ICreditContractService service;

    @RequestMapping(value = "/lon/credit/contract/beforeQuery")
    @ResponseBody
    public ResponseData unitSelect(HlsCusCreditContract creditContract, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long companyId = (Long) session.getAttribute("companyId");
        creditContract.setCompanyId(companyId);
        if (creditContract.getLonTypes() != null) {
            String[] lonTypeStatus = creditContract.getLonTypes().split(",");
            creditContract.setLonTypeStatus(lonTypeStatus);
        }
        if (creditContract.getCreditTypes() != null) {
            String[] creditTypeStatus = creditContract.getCreditTypes().split(",");
            creditContract.setCreditTypeStatus(creditTypeStatus);
        }
        if (creditContract.getCreditLineAmts() != null) {
            String[] creditLineStatus = creditContract.getCreditLineAmts().split(",");
            Double[] creditLineAmtStatus = new Double[creditLineStatus.length];
            for (int i = 0; i < creditLineStatus.length; i++) {
                Double amt = Double.parseDouble(creditLineStatus[i]);
                creditLineAmtStatus[i] = amt;
            }
            creditContract.setCreditLineAmtStatus(creditLineAmtStatus);
        }
        if(creditContract.getMinAmt() == null && creditContract.getMaxAmt() == null)
        {
            if(creditContract.getCreditLineAmts() != null)
            {
                String[] financeAmountInfo =  creditContract.getCreditLineAmts().split(",");

                if(financeAmountInfo.length ==1)
                {
                    if("1000".equals(financeAmountInfo[0]))
                    {
                        creditContract.setMaxAmt(10000000d);
                    }else if("5000".equals(financeAmountInfo[0]))
                    {
                        creditContract.setMinAmt(10000000d);
                        creditContract.setMaxAmt(50000000d);
                    }else
                    {
                        creditContract.setMinAmt(50000000d);
                        creditContract.setMaxAmt(100000000d);
                    }
                }else if(financeAmountInfo.length ==2)
                {
                    if("1000".equals(financeAmountInfo[0]) && "5000".equals(financeAmountInfo[1]))
                    {
                        creditContract.setMaxAmt(50000000d);
                    }else if("5000".equals(financeAmountInfo[0]) && "10000".equals(financeAmountInfo[1]))
                    {
                        creditContract.setMinAmt(10000000d);
                        creditContract.setMaxAmt(100000000d);
                    }else
                    {
                        creditContract.setMinAmt(50000000d);
                        creditContract.setMaxAmt(100000000d);
                        creditContract.setAmMax(10000000d);
                    }
                }else
                {
                    creditContract.setMaxAmt(100000000d);

                }
            }
        }
        List<HlsCusCreditContract> list = service.unitSelect(creditContract, page, pageSize);
        return new ResponseData(list);
    }

    @RequestMapping(value = "/lon/credit/contract/creditQuery")
    @ResponseBody
    public ResponseData lonSelect(HlsCusCreditContract creditContract, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long companyId = (Long) session.getAttribute("companyId");
        creditContract.setCompanyId(companyId);
        List<HlsCusCreditContract> list = service.unitSelect(creditContract, page, pageSize);
        return new ResponseData(list);
    }

    @RequestMapping(value = "/lon/credit/contract/selectBp")
    @ResponseBody
    public ResponseData selectBp(HlsCusCreditContract creditContract, HttpServletRequest request, HttpSession session) {
        Long companyId = (Long) session.getAttribute("companyId");
        creditContract.setCompanyId(companyId);
        List<HlsCusCreditContract> list = service.selectBp(creditContract);
        return new ResponseData(list);
    }

    @RequestMapping(value = "/lon/credit/contract/selectBpChart")
    @ResponseBody
    public ResponseData selectBpChart(HlsCusCreditContract creditContract, HttpServletRequest request, HttpSession session) {
        Long companyId = (Long) session.getAttribute("companyId");
        creditContract.setCompanyId(companyId);
        List<HlsCusCreditContract> list = service.selectBpChart(creditContract);
        return new ResponseData(list);
    }

    @RequestMapping(value = "/lon/credit/contract/query")
    @ResponseBody
    public ResponseData query(HlsCusCreditContract dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/lon/credit/contract/update")
    @ResponseBody
    public ResponseData batchupdate(@RequestBody HlsCusCreditContract creditContract, final BindingResult result, HttpServletRequest request, HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        service.save(requestContext, creditContract);
        List<CreditContract> creditContractList = new ArrayList<CreditContract>();
        creditContractList.add(creditContract);
        return new ResponseData(creditContractList);
    }

    @RequestMapping(value = "/lon/credit/contract/creditUpdate")
    @ResponseBody
    public ResponseData batchupdate2(@RequestBody List<HlsCusCreditContract> creditContractList, final BindingResult result, HttpServletRequest request, HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        for (HlsCusCreditContract creditContract : creditContractList) {
            service.save(requestContext, creditContract);
        }
        List<HlsCusCreditContract> creditContractListNew = new ArrayList<HlsCusCreditContract>();
        creditContractListNew = creditContractList;
        return new ResponseData(creditContractListNew);
    }

    @RequestMapping(value = "/lon/credit/contract/delete")
    @ResponseBody
    public void creditLineDelete(@RequestBody List<HlsCusCreditContract> creditContractList, final BindingResult result, HttpServletRequest request, HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        HlsCusCreditContract creditContract = creditContractList.get(0);
        service.delete(requestContext, creditContract);
    }

    @RequestMapping(value = "/lon/credit/contract/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusCreditContract> dto, BindingResult result, HttpServletRequest request) {
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }


    @RequestMapping(value = "/lon/credit/contract/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusCreditContract> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }

    /*合同创建维护-lov框查询方法*/
    @RequestMapping(value = "/lon/credit/contract/queryLovInfo")
    @ResponseBody
    public ResponseData queryLovInfo(HlsCusCreditContract creditContract, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                     @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, HttpSession session) {
        Long companyId = session.getAttribute("companyId") != null ? (Long) session.getAttribute("companyId") : 0L;
        creditContract.setCompanyId(companyId);
        List<HlsCusCreditContract> list = service.queryLovInfo(creditContract, page, pageSize);
        return new ResponseData(list);
    }

    @RequestMapping(value = "/lon/credit/contract/selectBpName")
    @ResponseBody
    public ResponseData selectBpName(HlsCusCreditContract creditContract, HttpServletRequest request, HttpSession session) {
        List<HlsCusCreditContract> list = service.selectBpName(creditContract);
        return new ResponseData(list);
    }
}