package hls.core.lon.controllers;

import hls.core.lon.dto.HlsCusCreditLineAttachment;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.lon.dto.CreditLineAttachment;
import hls.core.lon.service.ICreditLineAttachmentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.springframework.validation.BindingResult;
import java.util.List;

    @Controller
    public class CreditLineAttachmentController extends BaseController{

    @Autowired
    private ICreditLineAttachmentService service;


    @RequestMapping(value = "/hls2/credit/line/attachment/query")
    @ResponseBody
    public ResponseData query(HlsCusCreditLineAttachment dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/hls2/credit/line/attachment/sign")
    @ResponseBody
    public CreditLineAttachment sign(HlsCusCreditLineAttachment creditLineAttachment , final BindingResult result , final HttpServletRequest request, final HttpSession session){
        IRequest requestContext = createRequestContext(request);
        return service.sign(requestContext,creditLineAttachment);
    }


    @RequestMapping(value = "/hls2/credit/line/attachment/submit")
    @ResponseBody
public ResponseData update(@RequestBody List<HlsCusCreditLineAttachment> dto, BindingResult result, HttpServletRequest request){
getValidator().validate(dto, result);
if (result.hasErrors()) {
ResponseData responseData = new ResponseData(false);
responseData.setMessage(getErrorMessage(result, request));
return responseData;
}
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/hls2/credit/line/attachment/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusCreditLineAttachment> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
        @RequestMapping(value = "/hls2/credit/line/attachment/detail/query")
        @ResponseBody
        public ResponseData queryDetail(final HlsCusCreditLineAttachment creditLineAttachment, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
            IRequest requestContext = createRequestContext(request);
            List<HlsCusCreditLineAttachment> list = service.queryDetail(requestContext,creditLineAttachment,page,pagesize);
            return new ResponseData(list);
        }
    }