package hls.core.lon.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.bp.dto.HlsCusBpMaster;
import hls.core.lon.service.ILonBankService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

@Controller
public class LonBankController extends BaseController {

    @Autowired
    private ILonBankService lonBankService;

    /*------------授信机构综合查询----------------*/
    @RequestMapping(value = "/hls/lon/bank/lonBankQuery")
    @ResponseBody
    public ResponseData lonBankQuery(final HlsCusBpMaster bpMaster, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request, final HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        Long companyId = Long.valueOf(String.valueOf(session.getAttribute("companyId")));
        Long userId = requestContext.getUserId();

        List<HlsCusBpMaster> hlsCusBpMasters = lonBankService.lonBankQuery(requestContext, bpMaster, page, pagesize, companyId, userId);

        return new ResponseData(hlsCusBpMasters);
    }
}
