package hls.core.lon.controllers;

import hls.core.lon.dto.HlsCusLonContractPurpose;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.lon.dto.LonContractPurpose;
import hls.core.lon.service.ILonContractPurposeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

import org.springframework.validation.BindingResult;

import java.util.List;

@Controller
public class LonContractPurposeController extends BaseController {

    @Autowired
    private ILonContractPurposeService service;


    @RequestMapping(value = "/lon/contract/purpose/query")
    @ResponseBody
    public ResponseData queryLonContractPur(HlsCusLonContractPurpose dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.selectLonContractPur(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/lon/contract/purpose/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusLonContractPurpose> dto, BindingResult result, HttpServletRequest request) {
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/lon/contract/purpose/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusLonContractPurpose> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }

    @RequestMapping(value = "/lon/contract/purpose/default/query")
    @ResponseBody
    public ResponseData query(HlsCusLonContractPurpose dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.selectLonContractPur(requestContext, dto, page, pageSize));
    }
}