package hls.core.lon.dto;

/**
 * Auto Generated By Hap Code Generator
 **/

import javax.persistence.GeneratedValue;
import javax.persistence.Id;

import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import org.apache.xml.security.binding.xmlenc11.PRFAlgorithmIdentifierType;
import org.hibernate.validator.constraints.Length;

import javax.persistence.Table;
import javax.persistence.Transient;

import com.hand.hap.system.dto.BaseDTO;
import org.springframework.transaction.annotation.Transactional;

@ExtensionAttribute(disable = true)
@Table(name = "lon_contract")
public class LonContract extends BaseDTO {

    public static final String FIELD_CONTRACT_ID = "contractId";
    public static final String FIELD_COMPANY_ID = "companyId";
    public static final String FIELD_DOCUMENT_TYPE = "documentType";
    public static final String FIELD_DOCUMENT_CATEGORY = "documentCategory";
    public static final String FIELD_BUSINESS_TYPE = "businessType";
    public static final String FIELD_CONTRACT_NUMBER = "contractNumber";
    public static final String FIELD_CONTRACT_NAME = "contractName";
    public static final String FIELD_CONTRACT_STATUS = "contractStatus";
    public static final String FIELD_CREDIT_CONTRACT_ID = "creditContractId";
    public static final String FIELD_CREDIT_LINE_ID = "creditLineId";
    public static final String FIELD_CURRENCY = "currency";
    public static final String FIELD_CREDIT_BP_ID = "creditBpId";
    public static final String FIELD_ORIGINAL_CONTRACT_NUMBER = "originalContractNumber";
    public static final String FIELD_FINANCE_AMOUNT = "financeAmount";
    public static final String FIELD_WITHDRAW_BANK_ACCOUNT_ID = "withdrawBankAccountId";
    public static final String FIELD_REPAYMENT_BANK_ACCOUNT_ID = "repaymentBankAccountId";
    public static final String FIELD_DESCRIPTION = "description";


    @Id
    @GeneratedValue
    private Long contractId; //融资合同ID

    private Long companyId; //公司ID

    @Length(max = 100)
    private String documentType; //单据类型

    @Length(max = 100)
    private String documentCategory; //单据类别

    @Length(max = 100)
    private String businessType; //业务类型

    @Length(max = 255)
    private String contractNumber; //融资合同编号

    @Length(max = 500)
    private String contractName; //融资合同名称

    @Length(max = 100)
    private String contractStatus; //融资合同状态

    private Long creditContractId; //授信合同ID

    private Long creditLineId; //额度ID

    @Length(max = 100)
    private String currency; //币种

    private Long creditBpId; //债权人ID

    @Length(max = 255)
    private String originalContractNumber; //原始合同号

    private Double financeAmount; //融资金额

    private Long withdrawBankAccountId; //提款账户ID

    private Long repaymentBankAccountId; //还款账户ID

    @Length(max = 500)
    private String description; //说明

    @Transient
    private String creditBpName;//债权人名称

    @Transient
    private String businessDesc;//融资方式

    @Transient
    private String contractStatusDesc;//融资合同状态

    @Transient
    private String creditContractNumber;//

    @Transient
    private String creditContractName;//授信合同号

    @Transient
    private String creditLineDesc;//额度类型

    @Transient
    private String withdrawBankAccountName;//提款账户名

    @Transient
    private String withdrawBankAccountNumber;//提款账号

    @Transient
    private String repaymentBankAccountName;//还款账户名

    @Transient
    private String repaymentBankAccountNumber;//还款账号

    @Transient
    private String withdrawBankName;//还款银行名字

    @Transient
    private String withdrawBankAccountBranchName;//还款分行名字

    @Transient
    private Double withdrawApprovedAmount;//已提款金额

    @Transient
    private Double withdrawLeftAmount;//剩余可提款金额

    @Transient
    private Double loanRate;//融资利率

    @Transient
    private String documentTypeDesc;//单据名称

    @Transient
    private String currencyName;//币种描述

    @Transient
    private String documentTypes;//综合查询-融资方式

    @Transient
    private String contractStatuses;//综合查询-合同状态

    @Transient
    private String amtFirst;//综合查询-1百万以下

    @Transient
    private String amtSecond;//综合查询-1百万到5百万

    @Transient
    private String amtThird;//综合查询-5百万到1千万

    @Transient
    private Double amtFrom;//综合查询-金额从

    @Transient
    private Double amtTo;//综合查询-金额到

    @Transient
    private String manager;//综合查询-项目经理


    public String getManager() {
        return manager;
    }

    public void setManager(String manager) {
        this.manager = manager;
    }

    public String getDocumentTypes() {
        return documentTypes;
    }

    public void setDocumentTypes(String documentTypes) {
        this.documentTypes = documentTypes;
    }

    public String getContractStatuses() {
        return contractStatuses;
    }

    public void setContractStatuses(String contractStatuses) {
        this.contractStatuses = contractStatuses;
    }

    public String getAmtFirst() {
        return amtFirst;
    }

    public void setAmtFirst(String amtFirst) {
        this.amtFirst = amtFirst;
    }

    public String getAmtSecond() {
        return amtSecond;
    }

    public void setAmtSecond(String amtSecond) {
        this.amtSecond = amtSecond;
    }

    public String getAmtThird() {
        return amtThird;
    }

    public void setAmtThird(String amtThird) {
        this.amtThird = amtThird;
    }

    public Double getAmtFrom() {
        return amtFrom;
    }

    public void setAmtFrom(Double amtFrom) {
        this.amtFrom = amtFrom;
    }

    public Double getAmtTo() {
        return amtTo;
    }

    public void setAmtTo(Double amtTo) {
        this.amtTo = amtTo;
    }

    public String getCurrencyName() {
        return currencyName;
    }

    public void setCurrencyName(String currencyName) {
        this.currencyName = currencyName;
    }

    public String getDocumentTypeDesc() {
        return documentTypeDesc;
    }

    public void setDocumentTypeDesc(String documentTypeDesc) {
        this.documentTypeDesc = documentTypeDesc;
    }

    public Double getLoanRate() {
        return loanRate;
    }

    public void setLoanRate(Double loanRate) {
        this.loanRate = loanRate;
    }

    public Double getWithdrawLeftAmount() {
        return withdrawLeftAmount;
    }

    public void setWithdrawLeftAmount(Double withdrawLeftAmount) {
        this.withdrawLeftAmount = withdrawLeftAmount;
    }

    public Double getWithdrawApprovedAmount() {
        return withdrawApprovedAmount;
    }

    public void setWithdrawApprovedAmount(Double withdrawApprovedAmount) {
        this.withdrawApprovedAmount = withdrawApprovedAmount;
    }

    public String getWithdrawBankName() {
        return withdrawBankName;
    }

    public void setWithdrawBankName(String withdrawBankName) {
        this.withdrawBankName = withdrawBankName;
    }

    public String getWithdrawBankAccountBranchName() {
        return withdrawBankAccountBranchName;
    }

    public void setWithdrawBankAccountBranchName(String withdrawBankAccountBranchName) {
        this.withdrawBankAccountBranchName = withdrawBankAccountBranchName;
    }

    public String getCreditContractName() {
        return creditContractName;
    }

    public void setCreditContractName(String creditContractName) {
        this.creditContractName = creditContractName;
    }

    public String getCreditContractNumber() {
        return creditContractNumber;
    }

    public void setCreditContractNumber(String creditContractNumber) {
        this.creditContractNumber = creditContractNumber;
    }

    public String getCreditLineDesc() {
        return creditLineDesc;
    }

    public void setCreditLineDesc(String creditLineDesc) {
        this.creditLineDesc = creditLineDesc;
    }

    public String getRepaymentBankAccountName() {
        return repaymentBankAccountName;
    }

    public void setRepaymentBankAccountName(String repaymentBankAccountName) {
        this.repaymentBankAccountName = repaymentBankAccountName;
    }

    public String getRepaymentBankAccountNumber() {
        return repaymentBankAccountNumber;
    }

    public void setRepaymentBankAccountNumber(String repaymentBankAccountNumber) {
        this.repaymentBankAccountNumber = repaymentBankAccountNumber;
    }

    public String getWithdrawBankAccountName() {
        return withdrawBankAccountName;
    }

    public void setWithdrawBankAccountName(String withdrawBankAccountName) {
        this.withdrawBankAccountName = withdrawBankAccountName;
    }

    public String getWithdrawBankAccountNumber() {
        return withdrawBankAccountNumber;
    }

    public void setWithdrawBankAccountNumber(String withdrawBankAccountNumber) {
        this.withdrawBankAccountNumber = withdrawBankAccountNumber;
    }

    public String getBusinessDesc() {
        return businessDesc;
    }

    public void setBusinessDesc(String businessDesc) {
        this.businessDesc = businessDesc;
    }

    public String getContractStatusDesc() {
        return contractStatusDesc;
    }

    public void setContractStatusDesc(String contractStatusDesc) {
        this.contractStatusDesc = contractStatusDesc;
    }

    public String getCreditBpName() {
        return creditBpName;
    }

    public void setCreditBpName(String creditBpName) {
        this.creditBpName = creditBpName;
    }

    public void setContractId(Long contractId) {
        this.contractId = contractId;
    }

    public Long getContractId() {
        return contractId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public Long getCompanyId() {
        return companyId;
    }

    public void setDocumentType(String documentType) {
        this.documentType = documentType;
    }

    public String getDocumentType() {
        return documentType;
    }

    public void setDocumentCategory(String documentCategory) {
        this.documentCategory = documentCategory;
    }

    public String getDocumentCategory() {
        return documentCategory;
    }

    public void setBusinessType(String businessType) {
        this.businessType = businessType;
    }

    public String getBusinessType() {
        return businessType;
    }

    public void setContractNumber(String contractNumber) {
        this.contractNumber = contractNumber;
    }

    public String getContractNumber() {
        return contractNumber;
    }

    public void setContractName(String contractName) {
        this.contractName = contractName;
    }

    public String getContractName() {
        return contractName;
    }

    public void setContractStatus(String contractStatus) {
        this.contractStatus = contractStatus;
    }

    public String getContractStatus() {
        return contractStatus;
    }

    public void setCreditContractId(Long creditContractId) {
        this.creditContractId = creditContractId;
    }

    public Long getCreditContractId() {
        return creditContractId;
    }

    public void setCreditLineId(Long creditLineId) {
        this.creditLineId = creditLineId;
    }

    public Long getCreditLineId() {
        return creditLineId;
    }

    public void setCurrency(String currency) {
        this.currency = currency;
    }

    public String getCurrency() {
        return currency;
    }

    public void setCreditBpId(Long creditBpId) {
        this.creditBpId = creditBpId;
    }

    public Long getCreditBpId() {
        return creditBpId;
    }

    public void setOriginalContractNumber(String originalContractNumber) {
        this.originalContractNumber = originalContractNumber;
    }

    public String getOriginalContractNumber() {
        return originalContractNumber;
    }

    public void setFinanceAmount(Double financeAmount) {
        this.financeAmount = financeAmount;
    }

    public Double getFinanceAmount() {
        return financeAmount;
    }

    public void setWithdrawBankAccountId(Long withdrawBankAccountId) {
        this.withdrawBankAccountId = withdrawBankAccountId;
    }

    public Long getWithdrawBankAccountId() {
        return withdrawBankAccountId;
    }

    public void setRepaymentBankAccountId(Long repaymentBankAccountId) {
        this.repaymentBankAccountId = repaymentBankAccountId;
    }

    public Long getRepaymentBankAccountId() {
        return repaymentBankAccountId;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDescription() {
        return description;
    }

}
