package hls.core.lon.dto;

import com.fasterxml.jackson.annotation.JsonIgnore;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

/**
 * Created by fjm on 2017/11/7.
 * 用于融资合同新建的保存
 */
public class LonContractPkg implements Serializable {
    private HlsCusLonContract lonContract;

    private HlsCusLonContractQuotation lonContractQuotation;

    private List<HlsCusLonContractWithdraw> lonContractWithdraws;

    private List<HlsCusLonContractRepayment> lonContractRepayments;

    private List<HlsCusLonContractPurpose> lonContractPurposes;

    private List<HlsCusLonContractPledge> lonContractPledges;

    private List<HlsCusLonContractAttachment> lonContractAttachments;

    private String message;

    private Boolean success;

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public Boolean getSuccess() {
        return success;
    }

    public void setSuccess(Boolean success) {
        this.success = success;
    }

    public HlsCusLonContract getLonContract() {
        return lonContract;
    }

    public void setLonContract(HlsCusLonContract lonContract) {
        this.lonContract = lonContract;
    }

    public List<HlsCusLonContractAttachment> getLonContractAttachments() {
        return lonContractAttachments;
    }

    public void setLonContractAttachments(List<HlsCusLonContractAttachment> lonContractAttachments) {
        this.lonContractAttachments = lonContractAttachments;
    }

    public List<HlsCusLonContractPledge> getLonContractPledges() {
        return Optional.ofNullable(lonContractPledges).orElseGet(ArrayList<HlsCusLonContractPledge>::new);
    }

    public void setLonContractPledges(List<HlsCusLonContractPledge> lonContractPledges) {
        this.lonContractPledges = lonContractPledges;
    }

    public List<HlsCusLonContractPurpose> getLonContractPurposes() {
        return lonContractPurposes;
    }

    public void setLonContractPurposes(List<HlsCusLonContractPurpose> lonContractPurposes) {
        this.lonContractPurposes = lonContractPurposes;
    }

    public HlsCusLonContractQuotation getLonContractQuotation() {
        return lonContractQuotation;
    }

    public void setLonContractQuotation(HlsCusLonContractQuotation lonContractQuotation) {
        this.lonContractQuotation = lonContractQuotation;
    }

    public List<HlsCusLonContractRepayment> getLonContractRepayments() {
        return lonContractRepayments;
    }

    public void setLonContractRepayments(List<HlsCusLonContractRepayment> lonContractRepayments) {
        this.lonContractRepayments = lonContractRepayments;
    }

    public List<HlsCusLonContractWithdraw> getLonContractWithdraws() {
        return lonContractWithdraws;
    }

    public void setLonContractWithdraws(List<HlsCusLonContractWithdraw> lonContractWithdraws) {
        this.lonContractWithdraws = lonContractWithdraws;
    }

    /*使用注解,避免出现重复的json数据*/
    @JsonIgnore
    public HlsCusLonContract getLonContractByOptional(){
        return Optional.ofNullable(lonContract).orElseGet(HlsCusLonContract::new);
    }

    @JsonIgnore
    public List<HlsCusLonContractAttachment> getLonContractAttachmentsByOptional() {
        return Optional.ofNullable(lonContractAttachments).orElseGet(ArrayList<HlsCusLonContractAttachment>::new);
    }

    @JsonIgnore
    public List<HlsCusLonContractPledge> getLonContractPledgesByOptional() {
        return Optional.ofNullable(lonContractPledges).orElseGet(ArrayList<HlsCusLonContractPledge>::new);
    }

    @JsonIgnore
    public List<HlsCusLonContractPurpose> getLonContractPurposesByOptional() {
        return Optional.ofNullable(lonContractPurposes).orElseGet(ArrayList<HlsCusLonContractPurpose>::new);
    }

    @JsonIgnore
    public HlsCusLonContractQuotation getLonContractQuotationByOptional() {
        return Optional.ofNullable(lonContractQuotation).orElseGet(HlsCusLonContractQuotation::new);
    }

    @JsonIgnore
    public List<HlsCusLonContractRepayment> getLonContractRepaymentsByOptional() {
        return Optional.ofNullable(lonContractRepayments).orElseGet(ArrayList<HlsCusLonContractRepayment>::new);
    }

    @JsonIgnore
    public List<HlsCusLonContractWithdraw> getLonContractWithdrawsByOptional() {
        return Optional.ofNullable(lonContractWithdraws).orElseGet(ArrayList<HlsCusLonContractWithdraw>::new);
    }
}
