package hls.core.lon.dto;

/**
 *  KeyWord注解用于标志报价中修改的关键字段
 * 如果发生修改,则删除对应的还款记录,重新生成
 * Auto Generated By Hap Code Generator
 **/

import javax.persistence.GeneratedValue;
import javax.persistence.Id;

import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import hls.core.lon.annotation.KeyWord;
import org.hibernate.validator.constraints.Length;

import javax.persistence.Table;

import com.hand.hap.system.dto.BaseDTO;

import java.util.Date;
import javax.validation.constraints.NotNull;

@ExtensionAttribute(disable = true)
@Table(name = "lon_contract_quotation")
public class LonContractQuotation extends BaseDTO {

    public static final String FIELD_QUOTATION_ID = "quotationId";
    public static final String FIELD_CONTRACT_ID = "contractId";
    public static final String FIELD_DESCRIPTION = "description";
    public static final String FIELD_STATUS = "status";
    public static final String FIELD_PRICE_LIST = "priceList";
    public static final String FIELD_START_ACTIVE_DATE = "startActiveDate";
    public static final String FIELD_END_ACTIVE_DATE = "endActiveDate";
    public static final String FIELD_INT_RATE_TYPE = "intRateType";
    public static final String FIELD_BASE_RATE_TYPE = "baseRateType";
    public static final String FIELD_BASE_RATE = "baseRate";
    public static final String FIELD_LOAN_RATE = "loanRate";
    public static final String FIELD_FLOATING_WAY = "floatingWay";
    public static final String FIELD_FLOATING_WAY_RANGE = "floatingWayRange";
    public static final String FIELD_INTEREST_CYCLE = "interestCycle";
    public static final String FIELD_FLOATING_RANGE_METHOD = "floatingRangeMethod";
    public static final String FIELD_INTEREST_CALC_METHOD = "interestCalcMethod";
    public static final String FIELD_INTEREST_PAYMENT_DATE = "interestPaymentDate";


    @Id
    @GeneratedValue
    private Long quotationId; //融资报价id

    @KeyWord
    @NotNull
    private Long contractId; //融资合同ID

    @Length(max = 2000)
    private String description; //备注

    @KeyWord
    @Length(max = 100)
    private String status; //状态

    @KeyWord
    @Length(max = 100)
    private String priceList; //报价方案

    @KeyWord
    private Date startActiveDate; //生效日期

    @KeyWord
    private Date endActiveDate; //失效日期

    @KeyWord
    @Length(max = 100)
    private String intRateType; //利率类型(固定/浮动)(syscode:LON.INT_RATE_TYPE)

    @KeyWord
    @Length(max = 100)
    private String baseRateType; //基础利率类型

    @KeyWord
    private Double baseRate; //基准利率

    @KeyWord
    private Double loanRate; //执行利率

    @KeyWord
    @Length(max = 100)
    private String floatingWay; //浮动方式(上浮/上调)(syscode:LON.FLOATING_WAY)

    @KeyWord
    private Double floatingWayRange; //浮动幅度

    @KeyWord
    @Length(max = 100)
    private String interestCycle; //结息周期(月/季/半年/年)(syscode:LON.INTEREST_CYCLE)

    @KeyWord
    @Length(max = 100)
    private String floatingRangeMethod; //调息规则(次日/次期)(syscode:LON.FLOATING_RANGE_METHOD)

    @KeyWord
    @Length(max = 100)
    private String interestCalcMethod; //计息方式(剩余本金/归还本金)(syscode:LON.INTEREST_CALC_METHOD)

    @KeyWord
    private Long interestPaymentDate; //付息日

    @KeyWord
    private Long loanTimes;//融资期数
    @KeyWord
    private Double loanTerm;//融资期限（年）

    @KeyWord
    private Long interestCalcDate;//结息日

    @KeyWord
    private String principalCycle;//还本周期(月/季/半年/年)(syscode:LON.PRINCIPAL_CYCLE)

    @KeyWord
    private Long principalPaymentDate;//还本日

    public Long getLoanTimes() {
        return loanTimes;
    }

    public void setLoanTimes(Long loanTimes) {
        this.loanTimes = loanTimes;
    }

    public Double getLoanTerm() {
        return loanTerm;
    }

    public void setLoanTerm(Double loanTerm) {
        this.loanTerm = loanTerm;
    }


    public String getPrincipalCycle() {
        return principalCycle;
    }

    public void setPrincipalCycle(String principalCycle) {
        this.principalCycle = principalCycle;
    }

    public Long getInterestCalcDate() {
        return interestCalcDate;
    }

    public void setInterestCalcDate(Long interestCalcDate) {
        this.interestCalcDate = interestCalcDate;
    }

    public Long getPrincipalPaymentDate() {
        return principalPaymentDate;
    }

    public void setPrincipalPaymentDate(Long principalPaymentDate) {
        this.principalPaymentDate = principalPaymentDate;
    }

    public void setQuotationId(Long quotationId) {
        this.quotationId = quotationId;
    }

    public Long getQuotationId() {
        return quotationId;
    }

    public void setContractId(Long contractId) {
        this.contractId = contractId;
    }

    public Long getContractId() {
        return contractId;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDescription() {
        return description;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getStatus() {
        return status;
    }

    public void setPriceList(String priceList) {
        this.priceList = priceList;
    }

    public String getPriceList() {
        return priceList;
    }

    public void setStartActiveDate(Date startActiveDate) {
        this.startActiveDate = startActiveDate;
    }

    public Date getStartActiveDate() {
        return startActiveDate;
    }

    public void setEndActiveDate(Date endActiveDate) {
        this.endActiveDate = endActiveDate;
    }

    public Date getEndActiveDate() {
        return endActiveDate;
    }

    public void setIntRateType(String intRateType) {
        this.intRateType = intRateType;
    }

    public String getIntRateType() {
        return intRateType;
    }

    public void setBaseRateType(String baseRateType) {
        this.baseRateType = baseRateType;
    }

    public String getBaseRateType() {
        return baseRateType;
    }

    public void setBaseRate(Double baseRate) {
        this.baseRate = baseRate;
    }

    public Double getBaseRate() {
        return baseRate;
    }

    public void setLoanRate(Double loanRate) {
        this.loanRate = loanRate;
    }

    public Double getLoanRate() {
        return loanRate;
    }

    public void setFloatingWay(String floatingWay) {
        this.floatingWay = floatingWay;
    }

    public String getFloatingWay() {
        return floatingWay;
    }

    public void setFloatingWayRange(Double floatingWayRange) {
        this.floatingWayRange = floatingWayRange;
    }

    public Double getFloatingWayRange() {
        return floatingWayRange;
    }

    public void setInterestCycle(String interestCycle) {
        this.interestCycle = interestCycle;
    }

    public String getInterestCycle() {
        return interestCycle;
    }

    public void setFloatingRangeMethod(String floatingRangeMethod) {
        this.floatingRangeMethod = floatingRangeMethod;
    }

    public String getFloatingRangeMethod() {
        return floatingRangeMethod;
    }

    public void setInterestCalcMethod(String interestCalcMethod) {
        this.interestCalcMethod = interestCalcMethod;
    }

    public String getInterestCalcMethod() {
        return interestCalcMethod;
    }

    public void setInterestPaymentDate(Long interestPaymentDate) {
        this.interestPaymentDate = interestPaymentDate;
    }

    public Long getInterestPaymentDate() {
        return interestPaymentDate;
    }

}
