package hls.core.lon.dto;

/**
 * Auto Generated By Hap Code Generator
 **/

import javax.persistence.GeneratedValue;
import javax.persistence.Id;

import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import org.hibernate.validator.constraints.Length;

import javax.persistence.Table;

import com.hand.hap.system.dto.BaseDTO;

import java.time.LocalDate;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.Transient;
import javax.validation.constraints.NotNull;

@ExtensionAttribute(disable = true)
@Table(name = "lon_contract_repayment")
public class LonContractRepayment extends BaseDTO {

    public static final String FIELD_REPAYMENT_ID = "repaymentId";
    public static final String FIELD_WITHDRAW_ID = "withdrawId";
    public static final String FIELD_CONTRACT_ID = "contractId";
    public static final String FIELD_TIMES = "times";
    public static final String FIELD_CF_ITEM = "cfItem";
    public static final String FIELD_CF_TYPE = "cfType";
    public static final String FIELD_CF_DIRECTION = "cfDirection";
    public static final String FIELD_CF_STATUS = "cfStatus";
    public static final String FIELD_DUE_DATE = "dueDate";
    public static final String FIELD_DUE_AMOUNT = "dueAmount";
    public static final String FIELD_WRITE_OFF_FLAG = "writeOffFlag";
    public static final String FIELD_WRITE_OFF_AMOUNT = "writeOffAmount";
    public static final String FIELD_INTEREST_PERIOD_DAYS = "interestPeriodDays";
    public static final String FIELD_INTEREST_ACCRUAL_BALANCE = "interestAccrualBalance";


    @Id
    @GeneratedValue
    private Long repaymentId; //融资还款id

    @NotNull
    private Long withdrawId; //融资提款id

    @NotNull
    private Long contractId; //融资合同ID

    private Long times; //期数

    private Long cfItem; //现金流项目

    private Long cfType; //现金流类型

    @Length(max = 100)
    private String cfDirection; //现金流方向（INFLOW/OUTFLOW）(syscode：HLS.CASHFLOW_DIRECTION)

    @Length(max = 100)
    private String cfStatus; //现金流状态（BLOCK/冻结 、RELEASE/下达、CANCEL/取消） （syscode：HLS.CASHFLOW_STATUS）

    private Date dueDate; //还款日期

    private Double dueAmount; //还款金额

    @Length(max = 20)
    private String writeOffFlag; //核销标志（NOT/PARTIAL/FULL/NA）(syscode:LON.WRITE_OFF_FLAG)

    private Double writeOffAmount; //核销金额

    private Long interestPeriodDays; //计息天数

    private Double interestAccrualBalance; //计息余额

    private Date plannedDueDate; //还款日期(计划)

    private Double plannedDueAmount; //还款金额(计划)

    @Transient
    private String cfTypeDesc;//现金流类型描述

    @Transient
    private String cfItemDesc;//现金流项目描述

    @Transient
    private String withdrawNumber;//提款编号

    @Transient
    private String writeOffFlagDesc;//核销标志描述

    @Transient
    private LocalDate startLocalDate;//指代还款的开始日期(用于计算)

    @Transient
    private Long paymentReqId;//申请id
    @Transient
    private Long paymentReqLineId;//申请行id
    @Transient
    private String paymentReqNumber;//申请编号
    @Transient
    private Date creationDate;//申请日期
    @Transient
    private String contractNumber;//合同编号
    @Transient
    private String contractName;//合同名称
    @Transient
    private String bpName;//债券人
    @Transient
    private String description;//还款项目
    @Transient
    private String paymentReqStatus;//申请状态
    @Transient
    private Long year;
    @Transient
    private Long month;
    @Transient
    private String queryObject;
    @Transient
    private String queryMessage;
    @Transient
    private Long companyId;
    @Transient
    private Double remainPaybackAmount;//剩余未还款金额（实际还款金额-核销金额）
    @Transient
    private  Double approvedAmount;//已申请金额（付款申请行的汇总）
    @Transient
    private String[] repaymentIdList;//查询参数  还款编号列表
    @Transient
    private String repaymentIds;//查询参数 还款编号拼接字符串（-分隔）
    @Transient
    private Double applyAmount;//某一次还款申请的本次申请金额
    @Transient
    private  String currency;//还款申请-币种
    @Transient
    private Long bpId;//还款申请-债权人
    @Transient
    private Long withdrawBankAccountId;//还款申请-还款账户id
    @Transient
    private String withdrawBankAccountName;//还款申请-还款账户名称
    @Transient
    private String withdrawBankAccountNumber;//还款申请-还款账户账号
    @Transient
    private String withdrawBankAccountBranchName;//还款申请-还款账户分行名称
    @Transient
    private String withdrawBankName;//还款申请-还款账户银行名称
    @Transient
    private String paymentStatus;//申请状态（工作流状态）
    @Transient
    private String cshItems;//综合查询-现金流项目
    @Transient
    private String statuses;//综合查询-申请状态
    @Transient
    private String repAmtFirst;//还款金额1百万以下
    @Transient
    private String repAmtSecond;//还款金额1百万到5百万
    @Transient
    private String repAmtThird;//还款金额5百万到1千万
    @Transient
    private Double amtFrom;//金额从
    @Transient
    private Double amtTo;//金额到
    @Transient
    private String creditContractName;//授信合同号
    @Transient
    private Long paymentReqLnId;//付款申请行id
    @Transient
    private List listCashItem;
    @Transient
    private List listStatus;
    @Transient
    private Double withdrawAmount;//提款金额

    public Double getWithdrawAmount() {
        return withdrawAmount;
    }

    public void setWithdrawAmount(Double withdrawAmount) {
        this.withdrawAmount = withdrawAmount;
    }

    public List getListCashItem() {
        return listCashItem;
    }

    public void setListCashItem(List listCashItem) {
        this.listCashItem = listCashItem;
    }

    public List getListStatus() {
        return listStatus;
    }

    public void setListStatus(List listStatus) {
        this.listStatus = listStatus;
    }

    public Long getPaymentReqLnId() {
        return paymentReqLnId;
    }

    public void setPaymentReqLnId(Long paymentReqLnId) {
        this.paymentReqLnId = paymentReqLnId;
    }

    public String getCreditContractName() {
        return creditContractName;
    }

    public void setCreditContractName(String creditContractName) {
        this.creditContractName = creditContractName;
    }

    public String getCshItems() {
        return cshItems;
    }

    public void setCshItems(String cshItems) {
        this.cshItems = cshItems;
    }

    public String getStatuses() {
        return statuses;
    }

    public void setStatuses(String statuses) {
        this.statuses = statuses;
    }

    public String getRepAmtFirst() {
        return repAmtFirst;
    }

    public void setRepAmtFirst(String repAmtFirst) {
        this.repAmtFirst = repAmtFirst;
    }

    public String getRepAmtSecond() {
        return repAmtSecond;
    }

    public void setRepAmtSecond(String repAmtSecond) {
        this.repAmtSecond = repAmtSecond;
    }

    public String getRepAmtThird() {
        return repAmtThird;
    }

    public void setRepAmtThird(String repAmtThird) {
        this.repAmtThird = repAmtThird;
    }

    public Double getAmtFrom() {
        return amtFrom;
    }

    public void setAmtFrom(Double amtFrom) {
        this.amtFrom = amtFrom;
    }

    public Double getAmtTo() {
        return amtTo;
    }

    public void setAmtTo(Double amtTo) {
        this.amtTo = amtTo;
    }

    public String getPaymentStatus() {
        return paymentStatus;
    }

    public void setPaymentStatus(String paymentStatus) {
        this.paymentStatus = paymentStatus;
    }

    public Long getPaymentReqLineId() {
        return paymentReqLineId;
    }

    public void setPaymentReqLineId(Long paymentReqLineId) {
        this.paymentReqLineId = paymentReqLineId;
    }

    public String getWithdrawBankName() {
        return withdrawBankName;
    }

    public void setWithdrawBankName(String withdrawBankName) {
        this.withdrawBankName = withdrawBankName;
    }

    public Long getWithdrawBankAccountId() {
        return withdrawBankAccountId;
    }

    public void setWithdrawBankAccountId(Long withdrawBankAccountId) {
        this.withdrawBankAccountId = withdrawBankAccountId;
    }

    public String getWithdrawBankAccountName() {
        return withdrawBankAccountName;
    }

    public void setWithdrawBankAccountName(String withdrawBankAccountName) {
        this.withdrawBankAccountName = withdrawBankAccountName;
    }

    public String getWithdrawBankAccountNumber() {
        return withdrawBankAccountNumber;
    }

    public void setWithdrawBankAccountNumber(String withdrawBankAccountNumber) {
        this.withdrawBankAccountNumber = withdrawBankAccountNumber;
    }

    public String getWithdrawBankAccountBranchName() {
        return withdrawBankAccountBranchName;
    }

    public void setWithdrawBankAccountBranchName(String withdrawBankAccountBranchName) {
        this.withdrawBankAccountBranchName = withdrawBankAccountBranchName;
    }

    public Long getBpId() {
        return bpId;
    }

    public void setBpId(Long bpId) {
        this.bpId = bpId;
    }

    public String getCurrency() {
        return currency;
    }

    public void setCurrency(String currency) {
        this.currency = currency;
    }

    public Double getApplyAmount() {
        return applyAmount;
    }

    public void setApplyAmount(Double applyAmount) {
        this.applyAmount = applyAmount;
    }

    public String[] getRepaymentIdList() {
        return repaymentIdList;
    }

    public void setRepaymentIdList(String[] repaymentIdList) {
        this.repaymentIdList = repaymentIdList;
    }

    public String getRepaymentIds() {
        return repaymentIds;
    }

    public void setRepaymentIds(String repaymentIds) {
        this.repaymentIds = repaymentIds;
    }

    public Double getApprovedAmount() {
        return approvedAmount;
    }

    public void setApprovedAmount(Double approvedAmount) {
        this.approvedAmount = approvedAmount;
    }

    public Double getRemainPaybackAmount() {
        return remainPaybackAmount;
    }

    public void setRemainPaybackAmount(Double remainPaybackAmount) {
        this.remainPaybackAmount = remainPaybackAmount;
    }

    public Date getPlannedDueDate() {
        return plannedDueDate;
    }

    public void setPlannedDueDate(Date plannedDueDate) {
        this.plannedDueDate = plannedDueDate;
    }

    public Double getPlannedDueAmount() {
        return plannedDueAmount;
    }

    public void setPlannedDueAmount(Double plannedDueAmount) {
        this.plannedDueAmount = plannedDueAmount;
    }

    public Long getCompanyId() {
        return companyId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public Long getYear() {
        return year;
    }

    public void setYear(Long year) {
        this.year = year;
    }

    public Long getMonth() {
        return month;
    }

    public void setMonth(Long month) {
        this.month = month;
    }

    public String getQueryObject() {
        return queryObject;
    }

    public void setQueryObject(String queryObject) {
        this.queryObject = queryObject;
    }

    public String getQueryMessage() {
        return queryMessage;
    }

    public void setQueryMessage(String queryMessage) {
        this.queryMessage = queryMessage;
    }

    public Long getPaymentReqId() {
        return paymentReqId;
    }

    public void setPaymentReqId(Long paymentReqId) {
        this.paymentReqId = paymentReqId;
    }

    public String getPaymentReqNumber() {
        return paymentReqNumber;
    }

    public void setPaymentReqNumber(String paymentReqNumber) {
        this.paymentReqNumber = paymentReqNumber;
    }

    @Override
    public Date getCreationDate() {
        return creationDate;
    }

    @Override
    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    public String getContractNumber() {
        return contractNumber;
    }

    public void setContractNumber(String contractNumber) {
        this.contractNumber = contractNumber;
    }

    public String getContractName() {
        return contractName;
    }

    public void setContractName(String contractName) {
        this.contractName = contractName;
    }

    public String getBpName() {
        return bpName;
    }

    public void setBpName(String bpName) {
        this.bpName = bpName;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getPaymentReqStatus() {
        return paymentReqStatus;
    }

    public void setPaymentReqStatus(String paymentReqStatus) {
        this.paymentReqStatus = paymentReqStatus;
    }

    public LocalDate getStartLocalDate() {
        return startLocalDate;
    }

    public void setStartLocalDate(LocalDate startLocalDate) {
        this.startLocalDate = startLocalDate;
    }

    public String getWriteOffFlagDesc() {
        return writeOffFlagDesc;
    }

    public void setWriteOffFlagDesc(String writeOffFlagDesc) {
        this.writeOffFlagDesc = writeOffFlagDesc;
    }

    public String getCfItemDesc() {
        return cfItemDesc;
    }

    public void setCfItemDesc(String cfItemDesc) {
        this.cfItemDesc = cfItemDesc;
    }

    public String getCfTypeDesc() {
        return cfTypeDesc;
    }

    public void setCfTypeDesc(String cfTypeDesc) {
        this.cfTypeDesc = cfTypeDesc;
    }

    public String getWithdrawNumber() {
        return withdrawNumber;
    }

    public void setWithdrawNumber(String withdrawNumber) {
        this.withdrawNumber = withdrawNumber;
    }

    public void setRepaymentId(Long repaymentId) {
        this.repaymentId = repaymentId;
    }

    public Long getRepaymentId() {
        return repaymentId;
    }

    public void setWithdrawId(Long withdrawId) {
        this.withdrawId = withdrawId;
    }

    public Long getWithdrawId() {
        return withdrawId;
    }

    public void setContractId(Long contractId) {
        this.contractId = contractId;
    }

    public Long getContractId() {
        return contractId;
    }

    public void setTimes(Long times) {
        this.times = times;
    }

    public Long getTimes() {
        return times;
    }

    public void setCfItem(Long cfItem) {
        this.cfItem = cfItem;
    }

    public Long getCfItem() {
        return cfItem;
    }

    public void setCfType(Long cfType) {
        this.cfType = cfType;
    }

    public Long getCfType() {
        return cfType;
    }

    public void setCfDirection(String cfDirection) {
        this.cfDirection = cfDirection;
    }

    public String getCfDirection() {
        return cfDirection;
    }

    public void setCfStatus(String cfStatus) {
        this.cfStatus = cfStatus;
    }

    public String getCfStatus() {
        return cfStatus;
    }

    public void setDueDate(Date dueDate) {
        this.dueDate = dueDate;
    }

    public Date getDueDate() {
        return dueDate;
    }

    public void setDueAmount(Double dueAmount) {
        this.dueAmount = dueAmount;
    }

    public Double getDueAmount() {
        return dueAmount;
    }

    public void setWriteOffFlag(String writeOffFlag) {
        this.writeOffFlag = writeOffFlag;
    }

    public String getWriteOffFlag() {
        return writeOffFlag;
    }

    public void setWriteOffAmount(Double writeOffAmount) {
        this.writeOffAmount = writeOffAmount;
    }

    public Double getWriteOffAmount() {
        return writeOffAmount;
    }

    public void setInterestPeriodDays(Long interestPeriodDays) {
        this.interestPeriodDays = interestPeriodDays;
    }

    public Long getInterestPeriodDays() {
        return interestPeriodDays;
    }

    public void setInterestAccrualBalance(Double interestAccrualBalance) {
        this.interestAccrualBalance = interestAccrualBalance;
    }

    public Double getInterestAccrualBalance() {
        return interestAccrualBalance;
    }

}
