package hls.core.lon.dto;

/**
 * Auto Generated By Hap Code Generator
 **/

import javax.persistence.GeneratedValue;
import javax.persistence.Id;

import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import org.hibernate.validator.constraints.Length;

import javax.persistence.Table;

import com.hand.hap.system.dto.BaseDTO;

import java.util.Date;
import javax.persistence.Transient;
import javax.validation.constraints.NotNull;

@ExtensionAttribute(disable = true)
@Table(name = "lon_contract_withdraw")
public class LonContractWithdraw extends BaseDTO {

    public static final String FIELD_WITHDRAW_ID = "withdrawId";
    public static final String FIELD_CONTRACT_ID = "contractId";
    public static final String FIELD_COMPANY_ID = "companyId";
    public static final String FIELD_DOCUMENT_TYPE = "documentType";
    public static final String FIELD_DOCUMENT_CATEGORY = "documentCategory";
    public static final String FIELD_BUSINESS_TYPE = "businessType";
    public static final String FIELD_WITHDRAW_NUMBER = "withdrawNumber";
    public static final String FIELD_WITHDRAW_NAME = "withdrawName";
    public static final String FIELD_WITHDRAW_STATUS = "withdrawStatus";
    public static final String FIELD_CF_ITEM = "cfItem";
    public static final String FIELD_CF_TYPE = "cfType";
    public static final String FIELD_CF_DIRECTION = "cfDirection";
    public static final String FIELD_CF_STATUS = "cfStatus";
    public static final String FIELD_DUE_DATE = "dueDate";
    public static final String FIELD_DUE_AMOUNT = "dueAmount";
    public static final String FIELD_WRITE_OFF_FLAG = "writeOffFlag";
    public static final String FIELD_WRITE_OFF_AMOUNT = "writeOffAmount";
    public static final String FIELD_DESCRIPTION = "description";


    @Id
    @GeneratedValue
    private Long withdrawId; //融资提款id

    @NotNull
    private Long contractId; //融资合同ID

    private Long companyId; //公司ID

    @Length(max = 100)
    private String documentType; //单据类型

    @Length(max = 100)
    private String documentCategory; //单据类别

    @Length(max = 100)
    private String businessType; //业务类型

    @Length(max = 250)
    private String withdrawNumber; //提款编号

    @Length(max = 500)
    private String withdrawName; //提款名称

    @Length(max = 100)
    private String withdrawStatus; //提款状态

    private Long cfItem; //提款现金流项目

    private Long cfType; //提款现金流类型

    @Length(max = 100)
    private String cfDirection; //提款现金流方向（INFLOW/OUTFLOW）(syscode：HLS.CASHFLOW_DIRECTION)

    @Length(max = 100)
    private String cfStatus; //提款现金流状态（BLOCK/冻结 、RELEASE/下达、CANCEL/取消） （syscode：HLS.CASHFLOW_STATUS）

    private Date dueDate; //提款日期

    private Double dueAmount; //提款金额

    @Length(max = 20)
    private String writeOffFlag; //核销标志（NOT/PARTIAL/FULL/NA）(syscode:LON.WRITE_OFF_FLAG)

    private Double writeOffAmount; //核销金额

    @Length(max = 500)
    private String description; //说明

    @Transient
    private String contractName;//合同名称

    @Transient
    private String contractNumber;//合同编号

    @Transient
    private String creditBpName;//商业伙伴名称

    @Transient
    private String withdrawStatusDesc;//状态描述

    @Transient
    private String withdrawAli;//查询字段,用于关键字查询

    @Transient
    private Double amountFrom;//查询字段,用于金额区间查询

    @Transient
    private Double amountTo;//查询字段,用于金额区间查询

    @Transient
    private Date conditionDate;//查询用字段

    @Transient
    private String timeCondition;//时间查询条件,一周,一个月,三个月

    @Transient
    private String contractStatus;//合同状态

    @Transient
    private Double dueAmount2;//提款金额
    @Transient
    private Double paidAmount;//已还金额
    @Transient
    private String bpName;//债权人
    @Transient
    private String queryItem;//提款信息用于查询字段
    @Transient
    private Double rate;

    @Transient
    private String creditContractNumber; //授信合同号



    public String getContractStatus() {
        return contractStatus;
    }

    public void setContractStatus(String contractStatus) {
        this.contractStatus = contractStatus;
    }

    public Double getRate() {
        return rate;
    }

    public void setRate(Double rate) {
        this.rate = rate;
    }

    public String getQueryItem() {
        return queryItem;
    }

    public void setQueryItem(String queryItem) {
        this.queryItem = queryItem;
    }

    public Double getDueAmount2() {
        return dueAmount2;
    }

    public void setDueAmount2(Double dueAmount2) {
        this.dueAmount2 = dueAmount2;
    }

    public Double getPaidAmount() {
        return paidAmount;
    }

    public void setPaidAmount(Double paidAmount) {
        this.paidAmount = paidAmount;
    }

    public String getBpName() {
        return bpName;
    }

    public void setBpName(String bpName) {
        this.bpName = bpName;
    }

    public String getTimeCondition() {
        return timeCondition;
    }

    public void setTimeCondition(String timeCondition) {
        this.timeCondition = timeCondition;
    }

    public Date getConditionDate() {
        return conditionDate;
    }

    public void setConditionDate(Date conditionDate) {
        this.conditionDate = conditionDate;
    }

    public Double getAmountTo() {
        return amountTo;
    }

    public void setAmountTo(Double amountTo) {
        this.amountTo = amountTo;
    }

    public Double getAmountFrom() {
        return amountFrom;
    }

    public void setAmountFrom(Double amountFrom) {
        this.amountFrom = amountFrom;
    }

    public String getWithdrawAli() {
        return withdrawAli;
    }

    public void setWithdrawAli(String withdrawAli) {
        this.withdrawAli = withdrawAli;
    }

    public String getWithdrawStatusDesc() {
        return withdrawStatusDesc;
    }

    public void setWithdrawStatusDesc(String withdrawStatusDesc) {
        this.withdrawStatusDesc = withdrawStatusDesc;
    }

    public String getCreditBpName() {
        return creditBpName;
    }

    public void setCreditBpName(String creditBpName) {
        this.creditBpName = creditBpName;
    }

    public String getContractNumber() {
        return contractNumber;
    }

    public void setContractNumber(String contractNumber) {
        this.contractNumber = contractNumber;
    }

    public String getContractName() {
        return contractName;
    }

    public void setContractName(String contractName) {
        this.contractName = contractName;
    }

    public void setWithdrawId(Long withdrawId) {
        this.withdrawId = withdrawId;
    }

    public Long getWithdrawId() {
        return withdrawId;
    }

    public void setContractId(Long contractId) {
        this.contractId = contractId;
    }

    public Long getContractId() {
        return contractId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public Long getCompanyId() {
        return companyId;
    }

    public void setDocumentType(String documentType) {
        this.documentType = documentType;
    }

    public String getDocumentType() {
        return documentType;
    }

    public void setDocumentCategory(String documentCategory) {
        this.documentCategory = documentCategory;
    }

    public String getDocumentCategory() {
        return documentCategory;
    }

    public void setBusinessType(String businessType) {
        this.businessType = businessType;
    }

    public String getBusinessType() {
        return businessType;
    }

    public void setWithdrawNumber(String withdrawNumber) {
        this.withdrawNumber = withdrawNumber;
    }

    public String getWithdrawNumber() {
        return withdrawNumber;
    }

    public void setWithdrawName(String withdrawName) {
        this.withdrawName = withdrawName;
    }

    public String getWithdrawName() {
        return withdrawName;
    }

    public void setWithdrawStatus(String withdrawStatus) {
        this.withdrawStatus = withdrawStatus;
    }

    public String getWithdrawStatus() {
        return withdrawStatus;
    }

    public void setCfItem(Long cfItem) {
        this.cfItem = cfItem;
    }

    public Long getCfItem() {
        return cfItem;
    }

    public void setCfType(Long cfType) {
        this.cfType = cfType;
    }

    public Long getCfType() {
        return cfType;
    }

    public void setCfDirection(String cfDirection) {
        this.cfDirection = cfDirection;
    }

    public String getCfDirection() {
        return cfDirection;
    }

    public void setCfStatus(String cfStatus) {
        this.cfStatus = cfStatus;
    }

    public String getCfStatus() {
        return cfStatus;
    }

    public void setDueDate(Date dueDate) {
        this.dueDate = dueDate;
    }

    public Date getDueDate() {
        return dueDate;
    }

    public void setDueAmount(Double dueAmount) {
        this.dueAmount = dueAmount;
    }

    public Double getDueAmount() {
        return dueAmount;
    }

    public void setWriteOffFlag(String writeOffFlag) {
        this.writeOffFlag = writeOffFlag;
    }

    public String getWriteOffFlag() {
        return writeOffFlag;
    }

    public void setWriteOffAmount(Double writeOffAmount) {
        this.writeOffAmount = writeOffAmount;
    }

    public Double getWriteOffAmount() {
        return writeOffAmount;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDescription() {
        return description;
    }

    public String getCreditContractNumber() {
        return creditContractNumber;
    }

    public void setCreditContractNumber(String creditContractNumber) {
        this.creditContractNumber = creditContractNumber;
    }
}
