package hls.core.lon.service;

import com.hand.hap.core.IRequest;
import com.hand.hap.core.ProxySelf;
import com.hand.hap.system.service.IBaseService;
import hls.core.lon.dto.HlsCusLonContractRepayment;
import hls.core.lon.dto.HlsCusLonContractWithdraw;

import javax.servlet.http.HttpSession;
import java.util.Date;
import java.util.List;

public interface ILonContractRepaymentService extends IBaseService<HlsCusLonContractRepayment>, ProxySelf<ILonContractRepaymentService> {

    List<HlsCusLonContractRepayment> createRepaymentRecord(IRequest request, HlsCusLonContractWithdraw lonContractWithdraw);

    List<HlsCusLonContractRepayment> selectLonContractRep(IRequest request, HlsCusLonContractRepayment hlsCusLonContractRepayment, int page, int pageSize);

    List<HlsCusLonContractRepayment> getOrCreateLonContractRepayment(IRequest request, HlsCusLonContractRepayment hlsCusLonContractRepayment, int page, int pageSize);

    List<HlsCusLonContractRepayment> getRepaymentRecordsByInterestCycle(List<HlsCusLonContractRepayment> lonContractRepaymentList, Date startActiveDate, Date endActiveDate);

    List<HlsCusLonContractRepayment> getRepaymentRecordsByInterestCycle(Long times, Long interestCalcDate, Date startDate, Date endDate, String interestCycle);
    /*首页还款明细查询*/
    List<HlsCusLonContractRepayment> queryRep(IRequest request, HlsCusLonContractRepayment hlsCusLonContractRepayment, int page, int pageSize);

    /*还款创建明细-重置计息余额*/
    List<HlsCusLonContractRepayment> resetInterestBalance(List<HlsCusLonContractRepayment> list);

    /*还款申请提交审批*/
    void repaymentApproval(IRequest request, HttpSession session, List<HlsCusLonContractRepayment> list);

    /*还款综合查询*/
    List<HlsCusLonContractRepayment> unitQueryRep(IRequest request, HlsCusLonContractRepayment hlsCusLonContractRepayment, int page, int pageSize);

}