package hls.core.lon.service;

import com.hand.hap.core.IRequest;
import com.hand.hap.core.ProxySelf;
import com.hand.hap.system.service.IBaseService;
import hls.core.lon.dto.HlsCusLonContract;
import hls.core.lon.dto.HlsCusLonContractPkg;
import hls.core.lon.dto.LonContractPkg;
import hls.core.lon.exception.AmoutOverdueException;
import hls.core.lon.exception.DateInvalidException;

import java.util.List;
import java.util.Map;

public interface ILonContractService extends IBaseService<HlsCusLonContract>, ProxySelf<ILonContractService> {
    List<Map> queryLonConBoardData(Long companyId);

    List<HlsCusLonContract> queryLonContract(IRequest request, HlsCusLonContract lonContract, int page, int pageSize);

    void saveLonContract(IRequest request, HlsCusLonContractPkg lonContractPkg) throws AmoutOverdueException, DateInvalidException;

    HlsCusLonContractPkg selectLonContractFormData(IRequest request, HlsCusLonContract lonContract);

    /*提交审批*/
    List<HlsCusLonContract> submitApproval(IRequest request, List<HlsCusLonContract> lonContractList);

    HlsCusLonContract queryLonContractDetail(IRequest request, HlsCusLonContract lonContract);

    /*综合查询*/
    List<HlsCusLonContract> lonContractQuery(IRequest request, HlsCusLonContract lonContract, int page, int pageSize);
}