package hls.core.lon.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.lon.dto.HlsCusCreditLineAttachment;
import hls.core.lon.mapper.CreditLineAttachmentMapper;
import hls.core.lon.mapper.HlsCusCreditLineAttachmentMapper;
import hls.core.lon.service.IUpdateCreditLineAttachService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.lon.dto.CreditLineAttachment;
import hls.core.lon.service.ICreditLineAttachmentService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class CreditLineAttachmentServiceImpl extends BaseServiceImpl<HlsCusCreditLineAttachment> implements ICreditLineAttachmentService {
    @Autowired
    private HlsCusCreditLineAttachmentMapper mapper;
    @Autowired(required = false)
    private IUpdateCreditLineAttachService creditLineAttachService;

    @Override
    public List<HlsCusCreditLineAttachment> queryDetail(IRequest requestContext, HlsCusCreditLineAttachment creditLineAttachment, int page, int pagesize) {
        PageHelper.startPage(page, pagesize);

        return mapper.queryDetail(creditLineAttachment);
    }

    @Override
    public HlsCusCreditLineAttachment sign(IRequest iRequest, HlsCusCreditLineAttachment creditLineAttachment) {
        if (creditLineAttachService != null && !creditLineAttachService.beforeUpdate(iRequest, creditLineAttachment)) {
            return new HlsCusCreditLineAttachment();
        }
        self().insertSelective(iRequest, creditLineAttachment);
        if (creditLineAttachService != null ) {
            creditLineAttachService.afterUpdate(iRequest, creditLineAttachment);
        }
        return creditLineAttachment;
    }
}