package hls.core.lon.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.hls.bp.dto.HlsCusBpMaster;
import hls.core.lon.mapper.HlsCusLonBankMapper;
import hls.core.lon.service.ILonBankService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by 陈昊 on 2017/12/1.
 */
@Service
public class LonBankServiceImpl extends BaseServiceImpl<HlsCusBpMaster> implements ILonBankService {
    @Autowired
    HlsCusLonBankMapper hlsCusLonBankMapper;

    @Override
    public List<HlsCusBpMaster> lonBankQuery(IRequest requestContext, HlsCusBpMaster bpMaster, int page, int pagesize, Long companyId, Long userId) {
        PageHelper.startPage(page, pagesize);

        String[] orgTypes = null;
        String[] bpTypes = null;
        String[] collectFlag = null;
        if(bpMaster.getOrgType() != null){
            orgTypes = bpMaster.getOrgType().split("、");
        }
        if (bpMaster.getBpType() != null) {
            bpTypes = bpMaster.getBpType().split("、");
        }
        if (bpMaster.getCollectFlag() != null) {
            collectFlag = bpMaster.getCollectFlag().split("、");
        }

        Map<String, Object> params = new HashMap<String, Object>(8);

        params.put("bpTypes", bpTypes);
        params.put("orgTypes", orgTypes);
        params.put("collectFlag", collectFlag);
        params.put("bpCode", bpMaster.getBpCode());
        params.put("bpName", bpMaster.getBpName());
        params.put("extraNam", bpMaster.getExtraNam());
        //params.put("companyId", companyId);
        params.put("userId", userId);

        return hlsCusLonBankMapper.lonBankQuery(params);
    }


}
