package hls.core.lon.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.mapper.HlsCusConContractMapper;
import hls.core.lon.dto.HlsCusLonContractPledge;
import hls.core.lon.mapper.HlsCusLonContractPledgeMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.lon.service.ILonContractPledgeService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class LonContractPledgeServiceImpl extends BaseServiceImpl<HlsCusLonContractPledge> implements ILonContractPledgeService {

    public static final String CON_CONTRACT = "con_contract";
    @Autowired
    private HlsCusConContractMapper contractMapper;

    @Override
    public List<HlsCusLonContractPledge> selectLonContractPle(IRequest request, HlsCusLonContractPledge lonContractPledge, int page, int pageSize) {
        PageHelper.startPage(page, pageSize);
        List<HlsCusLonContractPledge> lonContractPledges = mappers.get(0).select(lonContractPledge);
        lonContractPledges.forEach(item -> {
            if (CON_CONTRACT.equalsIgnoreCase(item.getPledgeDocCategory()) && item.getPledgeDocId() != null) {
                HlsCusConContract contract = contractMapper.selectByPrimaryKey(item.getPledgeDocId());
                if (contract != null){
                    item.setPledgeDocName(contract.getContractName());
                    item.setPledgeDocNumber(contract.getContractNumber());
                }
            }
        });
        return lonContractPledges;
    }
}