package hls.core.lon.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.mapper.HlsCusConContractMapper;
import hls.core.lon.dto.HlsCusLonContractPurpose;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.lon.service.ILonContractPurposeService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class LonContractPurposeServiceImpl extends BaseServiceImpl<HlsCusLonContractPurpose> implements ILonContractPurposeService {

    public static final String CON_CONTRACT = "con_contract";
    @Autowired
    private HlsCusConContractMapper contractMapper;

    @Override
    public List<HlsCusLonContractPurpose> selectLonContractPur(IRequest request, HlsCusLonContractPurpose lonContractPurpose, int page, int pageSize) {
        PageHelper.startPage(page, pageSize);
        List<HlsCusLonContractPurpose> lonContractPurposes = mappers.get(0).select(lonContractPurpose);
        lonContractPurposes.forEach(item -> {
            if (CON_CONTRACT.equalsIgnoreCase(item.getPurposeDocCategory()) && item.getPurposeDocId() != null) {
                HlsCusConContract contract = contractMapper.selectByPrimaryKey(item.getPurposeDocId());
                if (contract != null){
                    item.setPurposeDocName(contract.getContractName());
                    item.setPurposeDocNumber(contract.getContractNumber());
                }
            }
        });
        return lonContractPurposes;
    }
}