package hls.core.mail.service.impl;

import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.mail.dto.MailingList;
import hls.core.mail.mapper.MailingListMapper;
import hls.core.mail.service.IMailingListService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class MailingListServiceImpl extends BaseServiceImpl<MailingList> implements IMailingListService{

    @Autowired
    private MailingListMapper mailingListMapper;
    /**
     * 查询sys_mailing_list里未发送邮件
     * @return
     */
    @Override
    public List<MailingList> selectSendMailList() {
        return mailingListMapper.selectSendMailList();
    }

    /**
     * 更新已发送邮件
     * @param mailingList
     */
    @Override
    public void updateSendMail(MailingList mailingList) {
        mailingListMapper.updateSendMail(mailingList);
    }

    /**
     * 更新未发送邮件
     * @param mailingList
     */
    @Override
    public void updateUnsendMail(MailingList mailingList) {
        mailingListMapper.updateUnsendMail(mailingList);
    }
}