package hls.core.mq.components;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
public class RsaKeyComponent {

    private static String serverPrivateKey;
    private static String serverPublicKey;
    private static String clientPublicKey;

    @Value("${mq.server.privateKey}")
    public void setServerPrivateKey(String serverPrivateKey) {
        RsaKeyComponent.serverPrivateKey = serverPrivateKey;
    }

    @Value("${mq.server.publicKey}")
    public void setServerPublicKey(String serverPublicKey) {
        RsaKeyComponent.serverPublicKey = serverPublicKey;
    }

    @Value("${mq.client.publicKey}")
    public void setClientPublicKey(String clientPublicKey) {
        RsaKeyComponent.clientPublicKey = clientPublicKey;
    }

    public static String getServerPrivateKey() {
        return serverPrivateKey;
    }

    public static String getServerPublicKey() {
        return serverPublicKey;
    }

    public static String getClientPublicKey() {
        return clientPublicKey;
    }
}
