package hls.core.mq.controllers;

import com.hand.hap.system.controllers.BaseController;
import hls.core.mq.dto.HlsRabbitExchange;
import hls.core.mq.dto.HlsRabbitExchangeQueue;
import hls.core.mq.service.IRabbitProducerService;
import com.alibaba.fastjson.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

/**
 * Created by gaoyang on 2017/4/23.
 */

@Controller
@RequestMapping(value="/hls/mq")
public class HlsProducerController extends BaseController{
    @Autowired(required = false)
    private IRabbitProducerService iRabbitProducerService;

    @ResponseBody
    @RequestMapping("/publishMessage")
    public void sendTopicMessage(HttpServletRequest request, @RequestBody JSONObject json){
        iRabbitProducerService.sendMessage(json);
    }

    @ResponseBody
    @RequestMapping("/createQueue")
    public void createQueue(HttpServletRequest request, @RequestParam HlsRabbitExchangeQueue hlsRabbitExchangeQueue){
        iRabbitProducerService.createQueue(hlsRabbitExchangeQueue);
    }


    @ResponseBody
    @RequestMapping("/createExchange")
    public void createExchange(HttpServletRequest request, @RequestParam HlsRabbitExchange hlsRabbitExchange ){
        iRabbitProducerService.createExchange(hlsRabbitExchange);
    }


}
