package hls.core.mq.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.mq.dto.HlsRabbitExchange;
import hls.core.mq.service.HlsRabbitExchangeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

/**
 * Created by Administrator on 2017/4/27.
 */
@Controller
public class HlsRabbitExchangeController extends BaseController{

    @Autowired
    private HlsRabbitExchangeService rabbitExchangeService;

    @RequestMapping("/hls/mq/exchange/query")
    @ResponseBody
    public ResponseData selectDetail(HttpServletRequest request, final HlsRabbitExchange rabbitExchange, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
        IRequest iRequest = createRequestContext(request);
        List<HlsRabbitExchange> datas = rabbitExchangeService.select(iRequest, rabbitExchange, page, pagesize);
        return new ResponseData(datas);
    }

    @RequestMapping("/hls/mq/exchange/submit")
    @ResponseBody
         public ResponseData submit(HttpServletRequest request, @RequestBody List<HlsRabbitExchange> hlsRabbitExchange){
         IRequest iRequest = createRequestContext(request);
         List<HlsRabbitExchange> list = rabbitExchangeService.save(iRequest,hlsRabbitExchange);
         return new ResponseData(list);

    }

    @RequestMapping("/hls/mq/exchange/delete")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsRabbitExchange> rabbitExchanges,final HttpSession session){
        IRequest iRequest = createRequestContext(request);
        rabbitExchangeService.delete(iRequest, rabbitExchanges);
        return new ResponseData();
    }
}
