package hls.core.mq.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.mq.dto.HlsRabbitExchangeQueue;
import hls.core.mq.service.HlsRabbitExchangeQueueService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

/**
 * Created by Administrator on 2017/4/27.
 */
@Controller
public class HlsRabbitExchangeQueueController extends BaseController{
    @Autowired
    private HlsRabbitExchangeQueueService rabbitExchangeQueueService;

    @RequestMapping("/hls/mq/exchange/queue/query")
    @ResponseBody
    public ResponseData selectDetail(HttpServletRequest request, final HlsRabbitExchangeQueue rabbitExchangeQueue, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                     @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
        IRequest iRequest = createRequestContext(request);
        List<HlsRabbitExchangeQueue> datas = rabbitExchangeQueueService.select(iRequest, rabbitExchangeQueue, page, pagesize);
        return new ResponseData(datas);
    }

    @RequestMapping("/hls/mq/exchange/queue/detail/query")
    @ResponseBody
    public ResponseData queryDetail(HttpServletRequest request){
        IRequest iRequest = createRequestContext(request);
        List<HlsRabbitExchangeQueue> datas = rabbitExchangeQueueService.queryDetail();
        return new ResponseData(datas);
    }

    @RequestMapping("/hls/mq/exchange/queue/submit")
    @ResponseBody
    public ResponseData submit(HttpServletRequest request, @RequestBody List<HlsRabbitExchangeQueue> rabbitExchangeQueues){
        IRequest iRequest = createRequestContext(request);
        List<HlsRabbitExchangeQueue> list = rabbitExchangeQueueService.save(iRequest, rabbitExchangeQueues);
        return new ResponseData(list);
    }

    @RequestMapping("/hls/mq/exchange/queue/delete")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsRabbitExchangeQueue> rabbitExchangeQueues,final HttpSession session){
        IRequest iRequest = createRequestContext(request);
        rabbitExchangeQueueService.batchUpdate(iRequest,rabbitExchangeQueues);
        return new ResponseData();
    }
}
