package hls.core.mq.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import hls.core.mq.dto.ResponseInfo;
import hls.core.mq.service.IRabbitMessageConsumerService;
import hls.core.mq.service.IRabbitProducerService;
import hls.core.mq.util.RabbitMQUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.ParseException;

/**
 * Created by gaoyang on 2017/4/23.
 */

@Service
public class ConsumerDemoServiceImpl implements IRabbitMessageConsumerService {

    @Autowired(required = false)
    private IRabbitProducerService iRabbitProducerService;

    @Override
    public String getApiName() {
        return "demoMQ";
    }

    @Override
    public void process(JSONObject var) {
        //业务处理
        //返回消息
        ResponseInfo responseInfo = null;
        try {
            responseInfo = RabbitMQUtils.getResposeInfo(var);
        } catch (ParseException e) {
            e.printStackTrace();
        }

        JSONObject respose = JSON.parseObject(JSON.toJSONString(responseInfo));

        iRabbitProducerService.sendMessage(respose);

    }
}
