package hls.core.mq.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.mq.dto.HlsRabbitExchange;
import hls.core.mq.dto.HlsRabbitExchangeQueue;
import hls.core.mq.mapper.HlsRabbitExchangeMapper;
import hls.core.mq.mapper.HlsRabbitExchangeQueueMapper;
import hls.core.mq.service.HlsRabbitExchangeQueueService;
import hls.core.mq.service.HlsRabbitExchangeService;
import hls.core.mq.service.IRabbitProducerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by Administrator on 2017/4/27.
 */
@Service
@Transactional
public class HlsRabbitExchangeQueueServiceImpl extends BaseServiceImpl<HlsRabbitExchangeQueue> implements HlsRabbitExchangeQueueService {
    @Autowired
    private HlsRabbitExchangeQueueMapper mapper;

    @Autowired(required = false)
    private IRabbitProducerService iRabbitProducerService;

    @Override
    public List<HlsRabbitExchangeQueue> queryDetail() {
        return mapper.queryDetail();
    }

    @Override
    public List<HlsRabbitExchangeQueue> save(IRequest iRequest, List<HlsRabbitExchangeQueue> hlsRabbitExchangeQueue) {
        if(hlsRabbitExchangeQueue != null){
            for (HlsRabbitExchangeQueue hlsRabbitExchangeQueues :hlsRabbitExchangeQueue) {
                iRabbitProducerService.createQueue(hlsRabbitExchangeQueues);
            }
        }
        List<HlsRabbitExchangeQueue> list= self().batchUpdate(iRequest,hlsRabbitExchangeQueue);

        return list;
    }
}
