package hls.core.mq.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.mq.dto.HlsRabbitExchange;
import hls.core.mq.mapper.HlsRabbitExchangeMapper;
import hls.core.mq.mapper.HlsRabbitExchangeQueueMapper;
import hls.core.mq.service.HlsRabbitExchangeService;
import hls.core.mq.service.IRabbitProducerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by Administrator on 2017/4/27.
 */
@Service
@Transactional
public class HlsRabbitExchangeServiceImpl extends BaseServiceImpl<HlsRabbitExchange> implements HlsRabbitExchangeService {
    @Autowired
    private HlsRabbitExchangeQueueMapper queueServiceMapper;

    @Autowired(required = false)
    private IRabbitProducerService iRabbitProducerService;


    @Override
    public void delete(IRequest iRequest, List<HlsRabbitExchange> rabbitExchanges) {
        for(HlsRabbitExchange rabbitExchange:rabbitExchanges)
        {
            queueServiceMapper.deleteQueue(rabbitExchange.getExchangeId());
        }
        self().batchUpdate(iRequest,rabbitExchanges);
    }



    @Override
    public List<HlsRabbitExchange> save(IRequest iRequest, List<HlsRabbitExchange> hlsRabbitExchange) {
        if(hlsRabbitExchange != null){
            for (HlsRabbitExchange hlsRabbitExchanges :hlsRabbitExchange) {
                iRabbitProducerService.createExchange(hlsRabbitExchanges);
            }
        }
            List<HlsRabbitExchange> list = self().batchUpdate(iRequest, hlsRabbitExchange);

            return list;

    }

}
