package hls.core.mq.service.impl;

import com.hand.hap.core.AppContextInitListener;
import hls.core.mq.dto.HlsRabbitExchangeQueue;
import hls.core.mq.service.HlsRabbitExchangeQueueService;
import hls.core.mq.service.IRabbitProducerService;
import org.springframework.amqp.rabbit.connection.ConnectionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by gaoyang on 2017/4/27.
 */
@Service
public class IRabbitListenerInitService implements AppContextInitListener{

    @Autowired(required = false)
    private ConnectionFactory connectionFactory;
    @Autowired(required = false)
    private HlsRabbitExchangeQueueService hlsRabbitExchangeQueueService;
    @Autowired(required = false)
    private IRabbitProducerService iRabbitProducerService;

    private boolean convertBoolean(String flag){
        if("Y".equals(flag)){
            return true;
        }else{
            return false;
        }
    }

    @Override
    public void contextInitialized(ApplicationContext applicationContext) {
        if(connectionFactory!=null) {
            List<HlsRabbitExchangeQueue> list = hlsRabbitExchangeQueueService.queryDetail();
            if (list != null) {
                for (HlsRabbitExchangeQueue detail : list) {
                    iRabbitProducerService.createQueue(detail);
                }
            }
        }
    }
}
