package hls.core.plugin.fengbao.controllers;

import java.util.HashMap;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.client.RestTemplate;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

@Controller()
public class GetCompanyRelationUrlController extends BaseController {

	@Autowired
	private RestTemplate template;

	@RequestMapping(value = "/fengbao/company/relation")
	@ResponseBody
	public HashMap relationQuery(HttpServletRequest request,
			 String companyOrg,  String apikey) {

		IRequest iRequest = createRequestContext(request);
		String url = "http://data.riskstorm.com/v1/company/{companyOrg}/relation?apikey={apikey}";
		HashMap<String, String> map = template.getForObject(url, HashMap.class, companyOrg,
				apikey);
		return map;
	}

	@RequestMapping(value = "/fengbao/company/search")
	@ResponseBody
	public HashMap companySerach(HttpServletRequest request,
						 String keyWord,  String apikey) {

		IRequest iRequest = createRequestContext(request);
		String url = "http://data.riskstorm.com/v1/company/search?apikey={apikey}";
		HashMap<String, String> map = template.getForObject(url, HashMap.class, keyWord,
				apikey);
		return map;
	}

	@RequestMapping(value = "/fengbao/company/org/search")
	@ResponseBody
	public HashMap companyOrgSerach(HttpServletRequest request,
								 String companyOrg,  String apikey) {

		IRequest iRequest = createRequestContext(request);
		String url = "http://data.riskstorm.com/v1/company/{companyOrg}?apikey={apikey}";
		HashMap<String, String> map = template.getForObject(url, HashMap.class, companyOrg,
				apikey);
		return map;
	}


}
