package hls.core.prj.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.prj.dto.HlsCusHlsDocumentVersion;
import hls.core.prj.service.HlsDocumentVersionService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

    @Controller
    public class HlsDocumentVersionController extends BaseController{

    @Autowired
    private HlsDocumentVersionService service;


    @RequestMapping(value = "/hls/document/version/query")
    @ResponseBody
    public ResponseData query(HlsCusHlsDocumentVersion dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/hls/document/version/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<HlsCusHlsDocumentVersion> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/hls/document/version/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusHlsDocumentVersion> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

        /**
         * 项目保存历史版本
         *
         * @return
         */
        @RequestMapping(value = "/prj/projectH/savePrjProjectVersion", method = RequestMethod.POST)
        @ResponseBody
        public ResponseData saveNormalProjectFromCreditProject(@RequestBody HlsCusHlsDocumentVersion hlsDocumentVersion, HttpServletRequest request) {
            IRequest requestContext = createRequestContext(request);
            List<HlsCusHlsDocumentVersion> hlsDocumentVersionList=new ArrayList<HlsCusHlsDocumentVersion>();
            HlsCusHlsDocumentVersion rHlsDocumentVersion = service.savePrjProjectVersion(hlsDocumentVersion.getSourceEvent(),hlsDocumentVersion.getSourceDocumentId(),hlsDocumentVersion.getSourceUserId(),requestContext);
            hlsDocumentVersionList.add(rHlsDocumentVersion);
            return new ResponseData(hlsDocumentVersionList);
        }

    }