package hls.core.prj.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.prj.dto.HlsCusPrjProjectAttachment;
import hls.core.prj.service.PrjProjectAttachmentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class PrjProjectAttachmentController extends BaseController {


    @Autowired
    private PrjProjectAttachmentService service;

    @RequestMapping(value = "/prj/project/attachment/query")
    @ResponseBody
    public ResponseData query(HlsCusPrjProjectAttachment dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/prj/project/attachment/submit")
    @ResponseBody
    public ResponseData submit(@RequestBody final List<HlsCusPrjProjectAttachment> dto, final BindingResult result, final HttpServletRequest request) {

        //getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/prj/project/attachment/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusPrjProjectAttachment> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }

    @RequestMapping(value = "/prj/project/sign/submit")
    @ResponseBody
    public HlsCusPrjProjectAttachment signSubmit(HlsCusPrjProjectAttachment prjProjectAttachment, final BindingResult result,
                                                 final HttpServletRequest request){

        IRequest requestContext = createRequestContext(request);
        return service.signSubmit(requestContext, prjProjectAttachment);
    }


    @RequestMapping(value = "/prj/project/attachment/detail/query")
    @ResponseBody
    public ResponseData detailQuery(HlsCusPrjProjectAttachment dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                    @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize) {
        System.out.println(service.prjProjectAttachmentDetailQuery(dto, page, pageSize));
        return new ResponseData(service.prjProjectAttachmentDetailQuery(dto, page, pageSize));
    }


}