package hls.core.prj.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.prj.dto.HlsCusPrjProjectGuarantorH;
import hls.core.prj.service.PrjProjectGuarantorHService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

    @Controller
    public class PrjProjectGuarantorHController extends BaseController{

    @Autowired
    private PrjProjectGuarantorHService service;


    @RequestMapping(value = "/prj/project/guarantor/h/query")
    @ResponseBody
    public ResponseData query(HlsCusPrjProjectGuarantorH dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/prj/project/guarantor/h/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<HlsCusPrjProjectGuarantorH> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/prj/project/guarantor/h/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusPrjProjectGuarantorH> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }