package hls.core.prj.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.prj.dto.HlsCusPrjProjectLeaseItem;
import hls.core.prj.service.PrjProjectLeaseItemService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class PrjProjectLeaseItemController extends BaseController {

    @Autowired
    private PrjProjectLeaseItemService service;


    @RequestMapping(value = "/prj/project/lease/item/query")
    @ResponseBody
    public ResponseData query(HlsCusPrjProjectLeaseItem dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/prj/project/lease/item/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request, @RequestBody List<HlsCusPrjProjectLeaseItem> dto) {
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/prj/project/lease/item/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusPrjProjectLeaseItem> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }

    @RequestMapping(value = "/prj/project/lease/item/detail/query")
    @ResponseBody
    public ResponseData detailQuery(HlsCusPrjProjectLeaseItem dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                    @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, @RequestParam(defaultValue = "0") Long _projectId) {

        if(_projectId == null){
            _projectId = 0L;
        }
        if(dto.getProjectId() == null)
        {
            dto.setProjectId(_projectId);
        }

        return new ResponseData(service.prjProjectLeaseItemDetailQuery(dto, page, pageSize));
    }
}