package hls.core.prj.controllers;

import hls.core.prj.mapper.HlsCusPrjProjectMeetingMapper;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.prj.dto.HlsCusPrjProjectMeeting;
import hls.core.prj.service.PrjProjectMeetingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Controller
    public class PrjProjectMeetingController extends BaseController{

    @Autowired
    private PrjProjectMeetingService service;
    @Autowired
    private HlsCusPrjProjectMeetingMapper prjProjectMeetingMapper;
    @Autowired
    private PrjProjectMeetingService prjProjectMeetingService;


    @RequestMapping(value = "/prj/project/meeting/query")
    @ResponseBody
    public ResponseData query(HlsCusPrjProjectMeeting dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        List<HlsCusPrjProjectMeeting> listMeet = service.select(requestContext,dto,page,pageSize);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/prj/project/meeting/info/query")
    @ResponseBody
    public ResponseData queryInfo(HlsCusPrjProjectMeeting dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        List<HlsCusPrjProjectMeeting> list = service.queryInfo(requestContext,dto,page,pageSize);
        return new ResponseData(list);
    }

    @RequestMapping(value = "/prj/project/meeting/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<HlsCusPrjProjectMeeting> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/prj/project/meeting/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusPrjProjectMeeting> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

        @RequestMapping(value = "/prj/project/meeting/detail/save")
        @ResponseBody
        public ResponseData save(HttpServletRequest request,@RequestBody Map<String,Object> maps){
            IRequest requestCtx = createRequestContext(request);
            service.save(requestCtx,maps);
            return new ResponseData();
        }

    @RequestMapping(value = "/prj/project/meeting/query/byprjid")
    @ResponseBody
    public List<HlsCusPrjProjectMeeting> queyMeeting(HlsCusPrjProjectMeeting dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                                     @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        List<HlsCusPrjProjectMeeting> prjProjectMeetingList = prjProjectMeetingMapper.queryPrjProjectMeetingByProjectId(dto);
        return prjProjectMeetingList;
    }

    @RequestMapping(value = "/prj/project/update/comment")
    @ResponseBody
    public ResponseData updateComment(HlsCusPrjProjectMeeting dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                      @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestCtx = createRequestContext(request);
        HlsCusPrjProjectMeeting prjProjectMeeting = prjProjectMeetingService.queryMeetingByMeetingId(dto);
        prjProjectMeeting.set__status("update");
        prjProjectMeeting.setMeetingComments(dto.getMeetingComments());
        List<HlsCusPrjProjectMeeting> list = new ArrayList<>();
        list.add(prjProjectMeeting);
        prjProjectMeetingService.batchUpdate(requestCtx,list);
        return new ResponseData();
    }

    @RequestMapping(value = "/prj/project/query/comment")
    @ResponseBody
    public List<HlsCusPrjProjectMeeting> queryMeetingByMeetingId(HlsCusPrjProjectMeeting dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                                                 @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestCtx = createRequestContext(request);
        HlsCusPrjProjectMeeting prjProjectMeeting = prjProjectMeetingService.queryMeetingByMeetingId(dto);
        List<HlsCusPrjProjectMeeting> list = new ArrayList<>();
        list.add(prjProjectMeeting);
        return list;
    }


}