package hls.core.prj.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.prj.dto.HlsCusPrjProjectMeetingJudge;
import hls.core.prj.service.PrjProjectMeetingJudgeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

    @Controller
    public class PrjProjectMeetingJudgeController extends BaseController{

    @Autowired
    private PrjProjectMeetingJudgeService service;

    @RequestMapping(value = "/prj/project/meeting/judge/query")
    @ResponseBody
    public ResponseData query(HlsCusPrjProjectMeetingJudge dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/prj/project/meeting/judge/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<HlsCusPrjProjectMeetingJudge> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/prj/project/meeting/judge/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusPrjProjectMeetingJudge> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

    @RequestMapping(value = "/prj/project/meeting/judge/approve/result/query")
    @ResponseBody
    public HlsCusPrjProjectMeetingJudge queryApprovedResult(HlsCusPrjProjectMeetingJudge dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                                            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return service.queryApprovedResult(requestContext,dto.getProjectId());
    }

    @RequestMapping(value = "/prj/project/meeting/judge/detail/query")
    @ResponseBody
    public ResponseData queryDetail(HlsCusPrjProjectMeetingJudge dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                    @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        List<HlsCusPrjProjectMeetingJudge> list = service.queryDetail(requestContext,dto.getProjectId(),page,pageSize);
        return new ResponseData(list);
    }

    @RequestMapping(value = "/prj/project/meeting/judge/user/query")
    @ResponseBody
    public ResponseData queryUser(HlsCusPrjProjectMeetingJudge dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        if("".equalsIgnoreCase(dto.getDoubleFlag()))
        {
            return new ResponseData();
        }else
        {
            List<HlsCusPrjProjectMeetingJudge> list = service.queryUser(requestContext,dto.getProjectId(),page,pageSize);
            return new ResponseData(list);
        }
    }

    @RequestMapping(value = "/prj/project/meeting/query/judge/byid")
    @ResponseBody
    public List<HlsCusPrjProjectMeetingJudge> queryJudgeByJudgeId(HlsCusPrjProjectMeetingJudge dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                                                  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        return service.queryJudgeByJudgeId(dto);
    }

    @RequestMapping(value = "/prj/project/meeting/query/all/judge")
    @ResponseBody
    public ResponseData queryAllJudge(HlsCusPrjProjectMeetingJudge dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page, @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        List<HlsCusPrjProjectMeetingJudge> list =service.queryAllJudge();
        return new ResponseData(list);
    }
}