package hls.core.prj.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.prj.dto.HlsCusPrjQuotationCashflow;
import hls.core.prj.service.PrjQuotationCashflowService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

    @Controller
    public class PrjQuotationCashflowController extends BaseController{

    @Autowired
    private PrjQuotationCashflowService service;


    @RequestMapping(value = "/prj/quotation/cashflow/query")
    @ResponseBody
    public ResponseData query(HlsCusPrjQuotationCashflow dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/prj/quotation/cashflow/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<HlsCusPrjQuotationCashflow> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/prj/quotation/cashflow/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusPrjQuotationCashflow> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

    @RequestMapping(value = "/prj/quotation/cashflow/by/projectId/query")
    @ResponseBody
    public ResponseData queryPrjQuotationCashflowByProjectId(HlsCusPrjQuotationCashflow dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                                             @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, Long _projectId, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        if(_projectId != null)
        {
            dto.setQuotationId(_projectId);
        }
        return new ResponseData(service.queryPrjQuotationCashflowByProjectId(dto,page,pageSize));
    }

    }