package hls.core.prj.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.prj.dto.HlsCusPrjTenantHistEvolution;
import hls.core.prj.service.PrjTenantHistEvolutionService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
public class PrjTenantHistEvolutionController extends BaseController {

    @Autowired
    private PrjTenantHistEvolutionService service;


    @RequestMapping(value = "/prj/tenant/hist/evolution/query")
    @ResponseBody
    public ResponseData query(HlsCusPrjTenantHistEvolution dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/prj/tenant/hist/evolution/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request, @RequestBody List<HlsCusPrjTenantHistEvolution> dto) {
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/prj/tenant/hist/evolution/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusPrjTenantHistEvolution> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }

    @RequestMapping(value = "/prj/tenant/hist/evolution/detail/query")
    @ResponseBody
    public ResponseData detailQuery(HlsCusPrjTenantHistEvolution dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                    @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, @RequestParam(defaultValue = "0") Long _projectId, @RequestParam(defaultValue = "0") Long bpId) {
        if(_projectId == null){
            _projectId = 0L;
        }
        if(bpId == null){
            bpId = 0L;
        }
        dto.setProjectId(_projectId);
        dto.setBpId(bpId);
        return new ResponseData(service.prjTenantHistEvolutionDetailQuery(dto, page, pageSize));
    }
}