package hls.core.prj.controllers;

import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.service.ConContractService;
import hls.core.prj.dto.HlsCusPrjProject;
import hls.core.prj.service.PrjProjectService;
import hls.core.prj.service.PrjTaskService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created with IntelliJ IDEA.
 * User: Jeffery
 * Date: 2017/8/24
 * Time: 19:08
 * To change this template use File | Settings | File Templates.
 */

@Controller
public class prjTaskController extends BaseController {
    @Autowired
    private PrjTaskService prjTaskService;
    @Autowired
    private PrjProjectService prjProjectService;
    @Autowired
    private ConContractService conContractService;
    /**
     * CreateUser：Jeffery
     * Date：2017-08-18 16:44:39
     * 查询项目/合同
     * @return
     */
    @RequestMapping(value = "/query/prj/con/task")
    @ResponseBody
    public ResponseData queryConPrjTask(HlsCusConContract dto, HttpServletRequest request){
        String conctractId = dto.getContractId()!=0 ? dto.getContractId().toString() : null;
        String projectId = dto.getProjectId() != 0 ? dto.getProjectId().toString() : null;
        List<Map> listMap = prjTaskService.queryPrjConTask(conctractId,projectId);
        return new ResponseData(listMap);
    }

    /**
     * CreateUser：Jeffery
     * Date：2017-08-22 10:39:39
     * 查询项目/合同
     * @return
     */
    @RequestMapping(value = "/query/all/prj/con")
    @ResponseBody
    public ResponseData queryAllPrjCon(HlsCusConContract dto, HttpServletRequest request){
        String conctractId = dto.getContractId()!=0 ? dto.getContractId().toString() : null;
        String projectId = dto.getProjectId() != 0 ? dto.getProjectId().toString() : null;
        Map<String,List<Map>> listMap = prjTaskService.queryAllPrjConById(conctractId,projectId);
        List<Map> list = new ArrayList<>();
        list.add(listMap);
        return new ResponseData(list);
    }

    /*
    * 根据项目id查询工作流流程id

    * */
    @RequestMapping(value = "/query/task/info/getprocInstIdByPrjId")
    @ResponseBody
    public ResponseData getprocInstIdByPrjId(@RequestBody(required = false) HlsCusPrjProject dto, HttpServletRequest request){
        List<Map> listMap = prjTaskService.getprocInstIdByPrjId(dto.getProjectId());
        return new ResponseData(listMap);
    }
    /**
     * CreateUser：Jeffery
     * Date：2017-08-22 10:39:39
     * 查询项目/合同
     * @return
     */
    @RequestMapping(value = "/query/task/info/by/{processInstanceId}")
    @ResponseBody
    public ResponseData queryTask(@PathVariable String processInstanceId, HttpServletRequest request){
        List<Map> listMap = prjTaskService.queryTaskInfo(processInstanceId);
        return new ResponseData(listMap);
    }

    /**
     * CreateUser：Jeffery
     * Date：2017-08-22 10:39:39
     * 查询项目/合同
     * @return
     */
    @RequestMapping(value = "/query/con/pay/info")
    @ResponseBody
    public ResponseData queryConPayInfo(HlsCusConContract dto, HttpServletRequest request){
        String conctractId = dto.getContractId()!=0 ? dto.getContractId().toString() : null;
        String projectId = dto.getProjectId() != 0 ? dto.getProjectId().toString() : null;
        List<Map> listMap = prjTaskService.queryConPayInfo(conctractId,projectId);
        return new ResponseData(listMap);
    }

    /**
     * CreateUser：Jeffery
     * Date：2017-08-22 10:39:39
     * 查询项目/合同
     * @return
     */
    @RequestMapping(value = "/query/prj/by/info/{cpId}/{type}")
    @ResponseBody
    public ResponseData queryPrj(@PathVariable String cpId,@PathVariable String type, HttpServletRequest request){
        List<Object> list = new ArrayList<>();
        if(type.equals("CON_CONTRACT")){
            HlsCusConContract conContract = conContractService.squerConContractById(Long.parseLong(cpId));
            list.add(conContract);
        }
        if(type.equals("PRJ_PROJECT")){
            HlsCusPrjProject prjProject = prjProjectService.selectPrjById(Long.parseLong(cpId));
            list.add(prjProject);
        }
        return new ResponseData(list);
    }

}
