package hls.core.prj.dto;

/**
 * Auto Generated By Hap Code Generator
 **/

import javax.persistence.GeneratedValue;
import javax.persistence.Id;

import com.hand.hap.core.annotation.Children;
import com.hand.hap.mybatis.annotation.Condition;
import com.hand.hap.mybatis.annotation.ExtensionAttribute;

import javax.persistence.Table;

import com.hand.hap.system.dto.BaseDTO;

import java.util.Date;
import java.util.List;
import javax.persistence.Transient;
import javax.validation.constraints.NotNull;

import org.hibernate.validator.constraints.NotEmpty;

@ExtensionAttribute(disable = true)
@Table(name = "prj_project")
public class PrjProject extends BaseDTO {
    @Id
    @GeneratedValue
    private Long projectId;

    @NotNull
    private Long companyId;

    private String documentType;

    private String documentCategory;

    private String businessType;

    @NotEmpty
    @Condition(operator = LIKE)
    private String projectNumber;

    @Condition(operator = LIKE)
    private String projectName;

    private String projectStatus;

    private String leaseChannel;

    private String division;

    private Long employeeId;

    private Long unitId;

    private Long financeAmount;

    private Date leaseStartDate;

    private String financingPurpose;

    private String currency;

    private String comprehensiveOpinion;

    private String authorityRuleString;

    private String leaseItemType;

    public String getAuthorityRuleString() {
        return authorityRuleString;
    }

    public void setAuthorityRuleString(String authorityRuleString) {
        this.authorityRuleString = authorityRuleString;
    }

    @Transient
    private List divisionParam;
    @Transient
    private List prjTypeParam;
    @Transient
    private List prjStatusParam;

    @Transient
    private Long userId;

    @Transient
    private Long bpId;
    @Transient
    private String bpName;
    @Transient
    private String bpNumber;
    @Transient
    private String tenantName;
    @Transient
    private String documentTypeDesc;
    @Transient
    private String projectStatusDesc;

    @Transient
    private String creditLineAmtFormat;
    @Transient
    private String creditExposureAmtFormat;

    @Transient
    private Double creditLineAmt;
    @Transient
    private Double creditExposureAmt;

    @Transient
    private Integer creditExposureQty;

    @Transient
    private String collectFlag;

    @Transient
    private String projectMeetingId;
    @Transient
    private String companyFullName;

    @Transient
    private String tenantBpIdList;


    public String getTenantBpIdList() {
        return tenantBpIdList;
    }

    public void setTenantBpIdList(String tenantBpIdList) {
        this.tenantBpIdList = tenantBpIdList;
    }

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public String getCompanyFullName() {
        return companyFullName;
    }

    public void setCompanyFullName(String companyFullName) {
        this.companyFullName = companyFullName;
    }

    public String getProjectMeetingId() {
        return projectMeetingId;
    }

    public void setProjectMeetingId(String projectMeetingId) {
        this.projectMeetingId = projectMeetingId;
    }

    public String getCollectFlag() {
        return collectFlag;
    }

    public void setCollectFlag(String collectFlag) {
        this.collectFlag = collectFlag;
    }

    public String getCreditLineAmtFormat() {
        return creditLineAmtFormat;
    }

    public void setCreditLineAmtFormat(String creditLineAmtFormat) {
        this.creditLineAmtFormat = creditLineAmtFormat;
    }

    public String getCreditExposureAmtFormat() {
        return creditExposureAmtFormat;
    }

    public void setCreditExposureAmtFormat(String creditExposureAmtFormat) {
        this.creditExposureAmtFormat = creditExposureAmtFormat;
    }

    public Double getCreditLineAmt() {
        return creditLineAmt;
    }

    public void setCreditLineAmt(Double creditLineAmt) {
        this.creditLineAmt = creditLineAmt;
    }

    public Double getCreditExposureAmt() {
        return creditExposureAmt;
    }

    public void setCreditExposureAmt(Double creditExposureAmt) {
        this.creditExposureAmt = creditExposureAmt;
    }

    public Integer getCreditExposureQty() {
        return creditExposureQty;
    }

    public void setCreditExposureQty(Integer creditExposureQty) {
        this.creditExposureQty = creditExposureQty;
    }

    public Date getValidFrom() {
        return validFrom;
    }

    public void setValidFrom(Date validFrom) {
        this.validFrom = validFrom;
    }

    public Date getValidTo() {
        return validTo;
    }

    public void setValidTo(Date validTo) {
        this.validTo = validTo;
    }

    @Transient

    private Date validFrom;
    @Transient
    private Date validTo;

    public String getTenantName() {
        return tenantName;
    }

    public void setTenantName(String tenantName) {
        this.tenantName = tenantName;
    }

    public String getDocumentTypeDesc() {
        return documentTypeDesc;
    }

    public void setDocumentTypeDesc(String documentTypeDesc) {
        this.documentTypeDesc = documentTypeDesc;
    }

    public String getProjectStatusDesc() {
        return projectStatusDesc;
    }

    public void setProjectStatusDesc(String projectStatusDesc) {
        this.projectStatusDesc = projectStatusDesc;
    }

    public String getBpName() {
        return bpName;
    }

    public void setBpName(String bpName) {
        this.bpName = bpName;
    }

    public String getBpNumber() {
        return bpNumber;
    }

    public void setBpNumber(String bpNumber) {
        this.bpNumber = bpNumber;
    }

    public List getDivisionParam() {
        return divisionParam;
    }

    public void setDivisionParam(List divisionParam) {
        this.divisionParam = divisionParam;
    }

    public List getPrjTypeParam() {
        return prjTypeParam;
    }

    public void setPrjTypeParam(List prjTypeParam) {
        this.prjTypeParam = prjTypeParam;
    }

    public List getPrjStatusParam() {
        return prjStatusParam;
    }

    public void setPrjStatusParam(List prjStatusParam) {
        this.prjStatusParam = prjStatusParam;
    }

    //报价
    @Transient
    private Long quotationId;

    @Transient
    private String sourceDocumentCategory;

    @Transient
    private Long sourceDocumentId;

    @Transient
    private String description;

    @Transient
    private String status;

    @Transient
    private String priceList;

    @Transient
    private Double leaseItemAmount;

    @Transient
    private Long leaseTimes;

    @Transient
    private Long annualPayTimes;

    @Transient
    private Double irr;


    @Children
    @Transient
    private List<HlsCusPrjProjectAttachment> prjProjectAttachments;

    @Children
    @Transient
    private List<HlsCusPrjProjectTenant> prjProjectTenants;

    @Children
    @Transient
    private List<HlsCusPrjProjectGuarantor> prjProjectGuarantors;

    @Children
    @Transient
    private List<HlsCusPrjProjectLeaseItem> prjProjectLeaseItems;

    @Children
    @Transient
    private List<HlsCusPrjProjectMortgage> prjProjectMortgages;

    @Children
    @Transient
    private List<HlsCusPrjProjectMeeting> prjProjectMeetings;

    @Children
    @Transient
    private List<HlsCusPrjProjectMeetingJudge> prjProjectMeetingJudges;

    @Transient
    private List<HlsCusPrjTenantHistEvolution> prjTenantHistEvolutions;

    @Transient
    private List<HlsCusPrjTenantStockStructure> prjTenantStockStructures;

    @Transient
    private List<HlsCusPrjTenantStockHolding> prjTenantStockHoldings;

    @Transient
    private List<HlsCusPrjTenantSupplier> prjTenantSuppliers;

    @Transient
    private List<HlsCusPrjTenantSalesCustomer> prjTenantSalesCustomers;

    @Transient
    private String businessTypeDesc;

    public String getHclDescription() {
        return hclDescription;
    }

    public void setHclDescription(String hclDescription) {
        this.hclDescription = hclDescription;
    }

    @Transient
    private String divisionDesc;
    @Transient
    private String leaseChannelDesc;
    @Transient
    private String hclDescription;

    @Transient
    private String params;

    public String getParams() {
        return params;
    }

    public void setParams(String params) {
        this.params = params;
    }

    public String getBusinessTypeDesc() {
        return businessTypeDesc;
    }

    public void setBusinessTypeDesc(String businessTypeDesc) {
        this.businessTypeDesc = businessTypeDesc;
    }

    public String getDivisionDesc() {
        return divisionDesc;
    }

    public void setDivisionDesc(String divisionDesc) {
        this.divisionDesc = divisionDesc;
    }

    public String getLeaseChannelDesc() {
        return leaseChannelDesc;
    }

    public void setLeaseChannelDesc(String leaseChannelDesc) {
        this.leaseChannelDesc = leaseChannelDesc;
    }

    public void setProjectId(Long projectId) {
        this.projectId = projectId;
    }


    public List<HlsCusPrjProjectAttachment> getPrjProjectAttachments() {
        return prjProjectAttachments;
    }

    public void setPrjProjectAttachments(List<HlsCusPrjProjectAttachment> prjProjectAttachments) {
        this.prjProjectAttachments = prjProjectAttachments;
    }

    public Long getProjectId() {
        return projectId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public Long getCompanyId() {
        return companyId;
    }

    public void setDocumentType(String documentType) {
        this.documentType = documentType;
    }

    public String getDocumentType() {
        return documentType;
    }

    public void setDocumentCategory(String documentCategory) {
        this.documentCategory = documentCategory;
    }

    public String getDocumentCategory() {
        return documentCategory;
    }

    public void setBusinessType(String businessType) {
        this.businessType = businessType;
    }

    public String getBusinessType() {
        return businessType;
    }

    public void setProjectNumber(String projectNumber) {
        this.projectNumber = projectNumber;
    }

    public String getProjectNumber() {
        return projectNumber;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectStatus(String projectStatus) {
        this.projectStatus = projectStatus;
    }

    public String getProjectStatus() {
        return projectStatus;
    }

    public void setLeaseChannel(String leaseChannel) {
        this.leaseChannel = leaseChannel;
    }

    public String getLeaseChannel() {
        return leaseChannel;
    }

    public void setDivision(String division) {
        this.division = division;
    }

    public String getDivision() {
        return division;
    }

    public void setEmployeeId(Long employeeId) {
        this.employeeId = employeeId;
    }

    public Long getEmployeeId() {
        return employeeId;
    }

    public void setUnitId(Long unitId) {
        this.unitId = unitId;
    }

    public Long getUnitId() {
        return unitId;
    }

    public void setFinanceAmount(Long financeAmount) {
        this.financeAmount = financeAmount;
    }

    public Long getFinanceAmount() {
        return financeAmount;
    }

    public Date getLeaseStartDate() {
        return leaseStartDate;
    }

    public void setLeaseStartDate(Date leaseStartDate) {
        this.leaseStartDate = leaseStartDate;
    }

    public void setFinancingPurpose(String financingPurpose) {
        this.financingPurpose = financingPurpose;
    }

    public String getFinancingPurpose() {
        return financingPurpose;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDescription() {
        return description;
    }

    public List<HlsCusPrjProjectTenant> getPrjProjectTenants() {
        return prjProjectTenants;
    }

    public void setPrjProjectTenants(List<HlsCusPrjProjectTenant> prjProjectTenants) {
        this.prjProjectTenants = prjProjectTenants;
    }

    public List<HlsCusPrjProjectGuarantor> getPrjProjectGuarantors() {
        return prjProjectGuarantors;
    }

    public void setPrjProjectGuarantors(List<HlsCusPrjProjectGuarantor> prjProjectGuarantors) {
        this.prjProjectGuarantors = prjProjectGuarantors;
    }

    public List<HlsCusPrjProjectLeaseItem> getPrjProjectLeaseItems() {
        return prjProjectLeaseItems;
    }

    public void setPrjProjectLeaseItems(List<HlsCusPrjProjectLeaseItem> prjProjectLeaseItems) {
        this.prjProjectLeaseItems = prjProjectLeaseItems;
    }

    public List<HlsCusPrjProjectMortgage> getPrjProjectMortgages() {
        return prjProjectMortgages;
    }

    public void setPrjProjectMortgages(List<HlsCusPrjProjectMortgage> prjProjectMortgages) {
        this.prjProjectMortgages = prjProjectMortgages;
    }

    public List<HlsCusPrjProjectMeeting> getPrjProjectMeetings() {
        return prjProjectMeetings;
    }

    public void setPrjProjectMeetings(List<HlsCusPrjProjectMeeting> prjProjectMeetings) {
        this.prjProjectMeetings = prjProjectMeetings;
    }

    public List<HlsCusPrjProjectMeetingJudge> getPrjProjectMeetingJudges() {
        return prjProjectMeetingJudges;
    }

    public void setPrjProjectMeetingJudges(List<HlsCusPrjProjectMeetingJudge> prjProjectMeetingJudges) {
        this.prjProjectMeetingJudges = prjProjectMeetingJudges;
    }

    public Long getQuotationId() {
        return quotationId;
    }

    public void setQuotationId(Long quotationId) {
        this.quotationId = quotationId;
    }

    public String getSourceDocumentCategory() {
        return sourceDocumentCategory;
    }

    public void setSourceDocumentCategory(String sourceDocumentCategory) {
        this.sourceDocumentCategory = sourceDocumentCategory;
    }

    public Long getSourceDocumentId() {
        return sourceDocumentId;
    }

    public void setSourceDocumentId(Long sourceDocumentId) {
        this.sourceDocumentId = sourceDocumentId;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getPriceList() {
        return priceList;
    }

    public void setPriceList(String priceList) {
        this.priceList = priceList;
    }

    public Double getLeaseItemAmount() {
        return leaseItemAmount;
    }

    public void setLeaseItemAmount(Double leaseItemAmount) {
        this.leaseItemAmount = leaseItemAmount;
    }

    public Long getLeaseTimes() {
        return leaseTimes;
    }

    public void setLeaseTimes(Long leaseTimes) {
        this.leaseTimes = leaseTimes;
    }

    public Long getAnnualPayTimes() {
        return annualPayTimes;
    }

    public void setAnnualPayTimes(Long annualPayTimes) {
        this.annualPayTimes = annualPayTimes;
    }

    public Double getIrr() {
        return irr;
    }

    public void setIrr(Double irr) {
        this.irr = irr;
    }

    public String getCurrency() {
        return currency;
    }

    public void setCurrency(String currency) {
        this.currency = currency;
    }

    public String getComprehensiveOpinion() {
        return comprehensiveOpinion;
    }

    public void setComprehensiveOpinion(String comprehensiveOpinion) {
        this.comprehensiveOpinion = comprehensiveOpinion;
    }

    public List<HlsCusPrjTenantHistEvolution> getPrjTenantHistEvolutions() {
        return prjTenantHistEvolutions;
    }

    public void setPrjTenantHistEvolutions(List<HlsCusPrjTenantHistEvolution> prjTenantHistEvolutions) {
        this.prjTenantHistEvolutions = prjTenantHistEvolutions;
    }

    public List<HlsCusPrjTenantStockStructure> getPrjTenantStockStructures() {
        return prjTenantStockStructures;
    }

    public void setPrjTenantStockStructures(List<HlsCusPrjTenantStockStructure> prjTenantStockStructures) {
        this.prjTenantStockStructures = prjTenantStockStructures;
    }

    public List<HlsCusPrjTenantStockHolding> getPrjTenantStockHoldings() {
        return prjTenantStockHoldings;
    }

    public void setPrjTenantStockHoldings(List<HlsCusPrjTenantStockHolding> prjTenantStockHoldings) {
        this.prjTenantStockHoldings = prjTenantStockHoldings;
    }

    public List<HlsCusPrjTenantSupplier> getPrjTenantSuppliers() {
        return prjTenantSuppliers;
    }

    public void setPrjTenantSuppliers(List<HlsCusPrjTenantSupplier> prjTenantSuppliers) {
        this.prjTenantSuppliers = prjTenantSuppliers;
    }

    public List<HlsCusPrjTenantSalesCustomer> getPrjTenantSalesCustomers() {
        return prjTenantSalesCustomers;
    }

    public void setPrjTenantSalesCustomers(List<HlsCusPrjTenantSalesCustomer> prjTenantSalesCustomers) {
        this.prjTenantSalesCustomers = prjTenantSalesCustomers;
    }

    public Long getBpId() {
        return bpId;
    }

    public void setBpId(Long bpId) {
        this.bpId = bpId;
    }

    public String getLeaseItemType() {
        return leaseItemType;
    }

    public void setLeaseItemType(String leaseItemType) {
        this.leaseItemType = leaseItemType;
    }
}


