package hls.core.prj.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.hls.bp.dto.HlsCusBpReport;
import hls.core.hls.bp.mapper.HlsBpReportMapper;
import hls.core.hls.service.HlsBeanRefUtilService;
import hls.core.prj.dto.*;
import hls.core.prj.mapper.*;
import hls.core.prj.service.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
@Transactional
public class HlsBpReportHServiceImpl extends BaseServiceImpl<HlsCusHlsBpReportH> implements HlsBpReportHService{
    @Autowired
    private   HlsBpReportMapper  hlsBpReportMapper;
    @Autowired
    private HlsBeanRefUtilService hlsBeanRefUtilService;
    @Autowired
    private HlsCusPrjTenantHistEvolutionMapper prjTenantHistEvolutionMapper;
    @Autowired
    private  PrjTenantHistEvolutionHService prjTenantHistEvolutionHService;
    @Autowired
    private HlsCusPrjTenantStockStructureMapper prjTenantStockStructureMapper;
   @Autowired
    private PrjTenantStockStructureHService prjTenantStockStructureHService;
    @Autowired
    private HlsCusPrjTenantStockHoldingMapper prjTenantStockHoldingMapper;
    @Autowired
    private PrjTenantStockHoldingHService prjTenantStockHoldingHService;
    @Autowired
    private HlsCusPrjTenantSupplierMapper prjTenantSupplierMapper;
    @Autowired
    private PrjTenantSupplierHService prjTenantSupplierHService;
    @Autowired
    private HlsCusPrjTenantSalesCustomerMapper prjTenantSalesCustomerMapper;
    @Autowired
    private PrjTenantSalesCustomerHService  prjTenantSalesCustomerHService;
    //项目项下商业伙伴信息历史版本
    @Override
   public void saveHlsBpReportHistory(Long projectId,Long versionId,IRequest iRequest){
        HlsCusBpReport hlsCusBpReport =new HlsCusBpReport();
        hlsCusBpReport.setSourceDocumentId(projectId);
        hlsCusBpReport.setDocumentCategory("PRJ_PROJECT");
        List<HlsCusBpReport> hlsCusBpReportList =hlsBpReportMapper.hlsBpReportDetailQuery(hlsCusBpReport);
        if(hlsCusBpReportList.size()>0){
            for(int i = 0; i< hlsCusBpReportList.size(); i++){
                Map<String,String> map=new HashMap<String,String>();
                map=hlsBeanRefUtilService.getFieldValueMap(hlsCusBpReportList.get(i));
                map.put("versionId",versionId.toString());
                HlsCusHlsBpReportH hlsBpReportH=new HlsCusHlsBpReportH();
                hlsBeanRefUtilService.setFieldValue(hlsBpReportH,map);
                self().insertSelective(iRequest,hlsBpReportH);
                //承租人历史沿革
                savePrjTenantHistEvolutionHistory(hlsCusBpReportList.get(i).getBpReportId(),versionId,iRequest);
                //承租人股权结构-主要股东
                savePrjTenantStockStructureH(hlsCusBpReportList.get(i).getBpReportId(),versionId,iRequest);
                //承租人股权结构-控股情况
                savePrjTenantStockHoldingHistory(hlsCusBpReportList.get(i).getBpReportId(),versionId,iRequest);
                //承租人经营情况-前五大销售客户
                savePrjTenantSupplierHistory(hlsCusBpReportList.get(i).getBpReportId(),versionId,iRequest);
                savePrjTenantSalesCustomerHistory(hlsCusBpReportList.get(i).getBpReportId(),versionId,iRequest);
            }
        }
    }
    //承租人历史沿革
    void savePrjTenantHistEvolutionHistory(Long bpReportId,Long versionId,IRequest iRequest){
        HlsCusPrjTenantHistEvolution prjTenantHistEvolution=new HlsCusPrjTenantHistEvolution();
        prjTenantHistEvolution.setBpReportId(bpReportId);
        List<HlsCusPrjTenantHistEvolution> prjTenantHistEvolutionList=prjTenantHistEvolutionMapper.prjTenantHistEvolutionQueryByReportId(prjTenantHistEvolution);
       if(prjTenantHistEvolutionList.size()>0){
           for(int i=0;i<prjTenantHistEvolutionList.size();i++){
               Map<String,String> map=new HashMap<String,String>();
               map=hlsBeanRefUtilService.getFieldValueMap(prjTenantHistEvolutionList.get(i));
               map.put("versionId",versionId.toString());
               HlsCusPrjTenantHistEvolutionH prjTenantHistEvolutionH=new HlsCusPrjTenantHistEvolutionH();
               hlsBeanRefUtilService.setFieldValue(prjTenantHistEvolutionH,map);
               prjTenantHistEvolutionHService.insertSelective(iRequest,prjTenantHistEvolutionH);
           }
       }
    }

    //承租人股权结构-主要股东
    void savePrjTenantStockStructureH(Long bpReportId,Long versionId,IRequest iRequest){
        HlsCusPrjTenantStockStructure prjTenantStockStructure=new HlsCusPrjTenantStockStructure();
        prjTenantStockStructure.setBpReportId(bpReportId);
        List<HlsCusPrjTenantStockStructure>  prjTenantStockStructureList=prjTenantStockStructureMapper.prjTenantStockStructureQueryByReportId(prjTenantStockStructure);
        if(prjTenantStockStructureList.size()>0){
            for(int i=0;i<prjTenantStockStructureList.size();i++){
                Map<String,String> map=new HashMap<String,String>();
                map=hlsBeanRefUtilService.getFieldValueMap(prjTenantStockStructureList.get(i));
                map.put("versionId",versionId.toString());
                HlsCusPrjTenantStockStructureH prjTenantStockStructureH=new HlsCusPrjTenantStockStructureH();
                hlsBeanRefUtilService.setFieldValue(prjTenantStockStructureH,map);
                prjTenantStockStructureHService.insertSelective(iRequest,prjTenantStockStructureH);
            }
        }
    }

    //承租人股权结构-控股情况
    void savePrjTenantStockHoldingHistory(Long bpReportId,Long versionId,IRequest iRequest){
        HlsCusPrjTenantStockHolding prjTenantStockHolding=new HlsCusPrjTenantStockHolding();
        prjTenantStockHolding.setBpReportId(bpReportId);
        List<HlsCusPrjTenantStockHolding>  prjTenantStockHoldingList=prjTenantStockHoldingMapper.prjTenantStockHoldingQueryByReportId(prjTenantStockHolding);
        if(prjTenantStockHoldingList.size()>0){
            for(int i=0;i<prjTenantStockHoldingList.size();i++){
                Map<String,String> map=new HashMap<String,String>();
                map=hlsBeanRefUtilService.getFieldValueMap(prjTenantStockHoldingList.get(i));
                map.put("versionId",versionId.toString());
                HlsCusPrjTenantStockHoldingH prjTenantStockHoldingH=prjTenantStockHoldingH=new HlsCusPrjTenantStockHoldingH();
                hlsBeanRefUtilService.setFieldValue(prjTenantStockHoldingH,map);
                prjTenantStockHoldingHService.insertSelective(iRequest,prjTenantStockHoldingH);
            }
        }
    }
    //承租人经营情况-前五大供应商
    void savePrjTenantSupplierHistory(Long bpReportId,Long versionId,IRequest iRequest){
        HlsCusPrjTenantSupplier prjTenantSupplier=new HlsCusPrjTenantSupplier();
        prjTenantSupplier.setBpReportId(bpReportId);
        List<HlsCusPrjTenantSupplier> prjTenantSupplierList=prjTenantSupplierMapper.prjTenantSupplierQueryByReportId(prjTenantSupplier);
        if(prjTenantSupplierList.size()>0){
            for(int i=0;i<prjTenantSupplierList.size();i++){
                Map<String,String> map=new HashMap<String,String>();
                map=hlsBeanRefUtilService.getFieldValueMap(prjTenantSupplierList.get(i));
                map.put("versionId",versionId.toString());
                HlsCusPrjTenantSupplierH prjTenantSupplierH=new HlsCusPrjTenantSupplierH();
                hlsBeanRefUtilService.setFieldValue(prjTenantSupplierH,map);
                prjTenantSupplierHService.insertSelective(iRequest,prjTenantSupplierH);
            }
        }
    }

    //承租人经营情况-前五大销售客户
   void  savePrjTenantSalesCustomerHistory(Long bpReportId,Long versionId,IRequest iRequest){
       HlsCusPrjTenantSalesCustomer prjTenantSalesCustomer =new HlsCusPrjTenantSalesCustomer();
       prjTenantSalesCustomer.setBpReportId(bpReportId);
       List<HlsCusPrjTenantSalesCustomer> prjTenantSalesCustomerList=prjTenantSalesCustomerMapper.prjTenantSalesCustomerQueryByReportId(prjTenantSalesCustomer);
       if(prjTenantSalesCustomerList.size()>0){
           for(int i=0;i<prjTenantSalesCustomerList.size();i++){
               Map<String,String> map=new HashMap<String,String>();
               map=hlsBeanRefUtilService.getFieldValueMap(prjTenantSalesCustomerList.get(i));
               map.put("versionId",versionId.toString());
               HlsCusPrjTenantSalesCustomerH prjTenantSalesCustomerH=new HlsCusPrjTenantSalesCustomerH();
               hlsBeanRefUtilService.setFieldValue(prjTenantSalesCustomerH,map);
               prjTenantSalesCustomerHService.insertSelective(iRequest,prjTenantSalesCustomerH);
           }
       }
   }
}