package hls.core.prj.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.prj.dto.HlsCusPrjProject;
import hls.core.prj.mapper.HlsCusHlsDocumentVersionMapper;
import hls.core.prj.mapper.HlsCusPrjProjectMapper;
import hls.core.prj.service.PrjProjectHService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.prj.dto.HlsCusHlsDocumentVersion;
import hls.core.prj.service.HlsDocumentVersionService;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;

@Service
@Transactional
public class HlsDocumentVersionServiceImpl extends BaseServiceImpl<HlsCusHlsDocumentVersion> implements HlsDocumentVersionService{
    @Autowired
    private HlsCusHlsDocumentVersionMapper hlsDocumentVersionMapper;

    @Autowired
    private PrjProjectHService prjProjectHService;

    @Autowired
    private HlsCusPrjProjectMapper prjProjectMapper;
    /**
     * 项目保存版本
     *
     * @param sourceEvent 触发事件
     * @param ProjectId 项目id
     * @param sourceUserId 来源单据用户id
     */
    @Override
  public HlsCusHlsDocumentVersion savePrjProjectVersion(String sourceEvent, Long ProjectId, Long sourceUserId, IRequest iRequest){
      HlsCusHlsDocumentVersion hlsDocumentVersion =new HlsCusHlsDocumentVersion();
      hlsDocumentVersion.setSourceDocumentCategory("PRJ_PROJECT");
      hlsDocumentVersion.setSourceDocumentId(ProjectId);
      hlsDocumentVersion.setSourceEvent(sourceEvent);
      hlsDocumentVersion.setSourceUserId(sourceUserId);
        //先取当前时间
        hlsDocumentVersion.setVersionDate(new Date());
      self().insertSelective(iRequest,hlsDocumentVersion);
        Long  versionId=hlsDocumentVersion.getVersionId();
        //获取项目信息

        HlsCusPrjProject prjProject= prjProjectMapper.selectByPrimaryKey(ProjectId);
        //保存项目版本信息
        prjProjectHService.saveProjectHistoryInfo(prjProject,versionId,iRequest);
      return hlsDocumentVersion;
  }
}