package hls.core.prj.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.prj.dto.*;
import hls.core.prj.mapper.*;
import hls.core.prj.service.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import hls.core.hls.service.HlsBeanRefUtilService;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
@Transactional
public class PrjProjectHServiceImpl extends BaseServiceImpl<HlsCusPrjProjectH> implements PrjProjectHService{
    @Autowired
    private HlsBeanRefUtilService hlsBeanRefUtilService;
    @Autowired
    private HlsCusPrjQuotationMapper prjQuotationMapper;
    @Autowired
    private PrjQuotationHService prjQuotationHService;
    @Autowired
    private HlsCusPrjQuotationCashflowMapper prjQuotationCashflowMapper;
    @Autowired
    private PrjQuotationCashflowHService prjQuotationCashflowHService;
    @Autowired
    private HlsCusPrjProjectTenantMapper prjProjectTenantMapper;
    @Autowired
    private PrjProjectTenantHService prjProjectTenantHService;
    @Autowired
    private HlsCusPrjProjectGuarantorMapper prjProjectGuarantorMapper;
    @Autowired
    private PrjProjectGuarantorHService prjProjectGuarantorHService;
    @Autowired
    private HlsCusPrjProjectLeaseItemMapper prjProjectLeaseItemMapper;
    @Autowired
    private  PrjProjectLeaseItemHService prjProjectLeaseItemHService;
    @Autowired
    private HlsCusPrjProjectMortgageMapper prjProjectMortgageMapper;
    @Autowired
    private PrjProjectMortgageHService prjProjectMortgageHService;
    @Autowired
    private HlsBpReportHService hlsBpReportHService;
    @Autowired
    private HlsCusPrjProjectMeetingMapper prjProjectMeetingMapper;
    @Autowired
    private PrjProjectMeetingHService prjProjectMeetingHService;
    @Autowired
    private HlsCusPrjProjectMeetingJudgeMapper prjProjectMeetingJudgeMapper;
    @Autowired
    private  PrjProjectMeetingJudgeHService prjProjectMeetingJudgeHService;
    @Override
  public HlsCusPrjProjectH saveProjectHistoryInfo(HlsCusPrjProject prjProject, Long versionId, IRequest iRequest){
        HlsCusPrjProjectH prjProjectH=new HlsCusPrjProjectH();
        Map<String,String> projectMap=new HashMap<String,String>();
        projectMap=hlsBeanRefUtilService.getFieldValueMap(prjProject);
        projectMap.put("versionId",versionId.toString());
        hlsBeanRefUtilService.setFieldValue(prjProjectH,projectMap);
        self().insertSelective(iRequest,prjProjectH);
        //项目报价
        savePrjQuotationHistory(prjProject,versionId,iRequest);
        //承租人
        savePrjProjectTenantHistory(prjProject,versionId,iRequest);
        //担保人
        savePrjProjectGuarantorHistory(prjProject,versionId,iRequest);
        //租赁物
        savPrjProjectLeaseItemHistory(prjProject,versionId,iRequest);
        //抵制押物
        savePrjProjectMortgageH(prjProject,versionId,iRequest);
        //上会信息
        savePrjProjectMeetingHistory(prjProject,versionId,iRequest);
        //商业伙伴项下基本信息
        hlsBpReportHService.saveHlsBpReportHistory(prjProject.getProjectId(),versionId,iRequest);
        return  prjProjectH;
    }

    //项目报价历史版本
    void savePrjQuotationHistory(HlsCusPrjProject prjProject, Long versionId, IRequest iRequest){
        HlsCusPrjQuotation prjQuotation=new HlsCusPrjQuotation();
        prjQuotation.setProjectId(prjProject.getProjectId());
        List<HlsCusPrjQuotation> prjQuotationList=prjQuotationMapper.prjQuotationDetailQuery(prjQuotation);
        if(prjQuotationList.size()>0){
            for(int i=0;i<prjQuotationList.size();i++){
                Map<String,String> map=new HashMap<String,String>();
                map=hlsBeanRefUtilService.getFieldValueMap(prjQuotationList.get(i));
                map.put("versionId",versionId.toString());
                HlsCusPrjQuotationH prjQuotationH=new HlsCusPrjQuotationH();
                hlsBeanRefUtilService.setFieldValue(prjQuotationH,map);
                prjQuotationHService.insertSelective(iRequest,prjQuotationH);
                savePrjQuotationCashflowHistory(prjQuotationList.get(i).getQuotationId(),versionId,iRequest);
            }
        }
    }
     //报价现金流历史
    void savePrjQuotationCashflowHistory(Long quotationId,Long versionId, IRequest iRequest){
        HlsCusPrjQuotationCashflow prjQuotationCashflowQ=new HlsCusPrjQuotationCashflow();
        prjQuotationCashflowQ.setQuotationId(quotationId);
        List<HlsCusPrjQuotationCashflow> prjQuotationCashflowList=prjQuotationCashflowMapper.queryPrjQuotationCashflowByQuotationId(prjQuotationCashflowQ);
        if(prjQuotationCashflowList.size()>0){
            for(int i=0;i<prjQuotationCashflowList.size();i++){
                Map<String,String> map=new HashMap<String,String>();
                map=hlsBeanRefUtilService.getFieldValueMap(prjQuotationCashflowList.get(i));
                map.put("versionId",versionId.toString());
                HlsCusPrjQuotationCashflowH prjQuotationCashflowH=new HlsCusPrjQuotationCashflowH();
                hlsBeanRefUtilService.setFieldValue(prjQuotationCashflowH,map);
                prjQuotationCashflowHService.insertSelective(iRequest,prjQuotationCashflowH);
            }
        }
    }

    //prj_project_tenant_h承租人
    void  savePrjProjectTenantHistory(HlsCusPrjProject prjProject, Long versionId, IRequest iRequest){
        HlsCusPrjProjectTenant prjProjectTenant=new HlsCusPrjProjectTenant();
        prjProjectTenant.setProjectId(prjProject.getProjectId());
       List<HlsCusPrjProjectTenant> prjProjectTenantList= prjProjectTenantMapper.prjProjectTenantDetailInfo(prjProjectTenant);
        if(prjProjectTenantList.size()>0){
            for(int i=0;i<prjProjectTenantList.size();i++){
                Map<String,String> map=new HashMap<String,String>();
                map=hlsBeanRefUtilService.getFieldValueMap(prjProjectTenantList.get(i));
                map.put("versionId",versionId.toString());
                HlsCusPrjProjectTenantH prjProjectTenantH=new HlsCusPrjProjectTenantH();
                hlsBeanRefUtilService.setFieldValue(prjProjectTenantH,map);
                prjProjectTenantHService.insertSelective(iRequest,prjProjectTenantH);
            }
        }
    }

    //prj_project_guarantor_h担保人
    void  savePrjProjectGuarantorHistory(HlsCusPrjProject prjProject, Long versionId, IRequest iRequest){
        HlsCusPrjProjectGuarantor prjProjectGuarantor=new HlsCusPrjProjectGuarantor();
        prjProjectGuarantor.setProjectId(prjProject.getProjectId());
        List<HlsCusPrjProjectGuarantor> prjProjectGuarantorList=prjProjectGuarantorMapper.prjProjectGuarantorDetailQuery(prjProjectGuarantor);
        if(prjProjectGuarantorList.size()>0){
            for(int i=0;i<prjProjectGuarantorList.size();i++){
                Map<String,String> map=new HashMap<String,String>();
                map=hlsBeanRefUtilService.getFieldValueMap(prjProjectGuarantorList.get(i));
                map.put("versionId",versionId.toString());
                HlsCusPrjProjectGuarantorH prjProjectGuarantorH=new HlsCusPrjProjectGuarantorH();
                hlsBeanRefUtilService.setFieldValue(prjProjectGuarantorH,map);
                prjProjectGuarantorHService.insertSelective(iRequest,prjProjectGuarantorH);
            }
        }

    }

    void savPrjProjectLeaseItemHistory (HlsCusPrjProject prjProject, Long versionId, IRequest iRequest){
        HlsCusPrjProjectLeaseItem prjProjectLeaseItem=new HlsCusPrjProjectLeaseItem();
        prjProjectLeaseItem.setProjectId(prjProject.getProjectId());
        List<HlsCusPrjProjectLeaseItem> prjProjectLeaseItemList=prjProjectLeaseItemMapper.prjProjectLeaseItemDetailQuery(prjProjectLeaseItem);
        if(prjProjectLeaseItemList.size()>0){
            for(int i=0;i<prjProjectLeaseItemList.size();i++){
                Map<String,String> map=new HashMap<String,String>();
                map=hlsBeanRefUtilService.getFieldValueMap(prjProjectLeaseItemList.get(i));
                map.put("versionId",versionId.toString());
                HlsCusPrjProjectLeaseItemH prjProjectLeaseItemH=new HlsCusPrjProjectLeaseItemH();
                hlsBeanRefUtilService.setFieldValue(prjProjectLeaseItemH,map);
                prjProjectLeaseItemHService.insertSelective(iRequest,prjProjectLeaseItemH);
            }
        }
    }

    void savePrjProjectMortgageH(HlsCusPrjProject prjProject, Long versionId, IRequest iRequest){
        HlsCusPrjProjectMortgage prjProjectMortgage=new HlsCusPrjProjectMortgage();
        prjProjectMortgage.setProjectId(prjProject.getProjectId());
        List<HlsCusPrjProjectMortgage>  prjProjectMortgageList=prjProjectMortgageMapper.prjProjectMortgageMapperDetailQuery(prjProjectMortgage);
        if(prjProjectMortgageList.size()>0){
            for(int i=0;i<prjProjectMortgageList.size();i++){
                Map<String,String> map=new HashMap<String,String>();
                map=hlsBeanRefUtilService.getFieldValueMap(prjProjectMortgageList.get(i));
                map.put("versionId",versionId.toString());
                HlsCusPrjProjectMortgageH prjProjectMortgageH=new HlsCusPrjProjectMortgageH();
                hlsBeanRefUtilService.setFieldValue(prjProjectMortgageH,map);
                prjProjectMortgageHService.insertSelective(iRequest,prjProjectMortgageH);
            }
        }
    }
  //项目上会信息
   void  savePrjProjectMeetingHistory(HlsCusPrjProject prjProject, Long versionId, IRequest iRequest){
       HlsCusPrjProjectMeeting prjProjectMeeting=new HlsCusPrjProjectMeeting();
       prjProjectMeeting.setProjectId(prjProject.getProjectId());
       List<HlsCusPrjProjectMeeting>  prjProjectMeetingList= prjProjectMeetingMapper.queryPrjProjectMeetingByProjectId(prjProjectMeeting);
       if(prjProjectMeetingList.size()>0){
           for(int i=0;i<prjProjectMeetingList.size();i++){
               Map<String,String> map=new HashMap<String,String>();
               map=hlsBeanRefUtilService.getFieldValueMap(prjProjectMeetingList.get(i));
               map.put("versionId",versionId.toString());
               HlsCusPrjProjectMeetingH prjProjectMeetingH=new HlsCusPrjProjectMeetingH();
               hlsBeanRefUtilService.setFieldValue(prjProjectMeetingH,map);
               prjProjectMeetingHService.insertSelective(iRequest,prjProjectMeetingH);
               savePrjProjectMeetingJudgeHistory(prjProjectMeetingList.get(i).getProjectMeetingId(),versionId,iRequest);
           }
       }
   }

   //项目上会评委意见表
    void  savePrjProjectMeetingJudgeHistory(Long projectMeetingId,Long versionId, IRequest iRequest){
        HlsCusPrjProjectMeetingJudge prjProjectMeetingJudge=new HlsCusPrjProjectMeetingJudge();
        prjProjectMeetingJudge.setProjectMeetingId(projectMeetingId);
        List <HlsCusPrjProjectMeetingJudge>  prjProjectMeetingJudgeList=prjProjectMeetingJudgeMapper.queryPrjProjectMeetingJudgeByProjectMeetingId(prjProjectMeetingJudge);
       if(prjProjectMeetingJudgeList.size()>0){
           for(int i=0;i<prjProjectMeetingJudgeList.size();i++){
               Map<String,String> map=new HashMap<String,String>();
               map=hlsBeanRefUtilService.getFieldValueMap(prjProjectMeetingJudgeList.get(i));
               map.put("versionId",versionId.toString());
               HlsCusPrjProjectMeetingJudgeH PrjProjectMeetingJudgeH=new HlsCusPrjProjectMeetingJudgeH();
               hlsBeanRefUtilService.setFieldValue(PrjProjectMeetingJudgeH,map);
               prjProjectMeetingJudgeHService.insertSelective(iRequest,PrjProjectMeetingJudgeH);
           }
       }
    }

}