package hls.core.prj.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.prj.mapper.HlsCusPrjProjectMeetingJudgeMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.prj.dto.HlsCusPrjProjectMeetingJudge;
import hls.core.prj.service.PrjProjectMeetingJudgeService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional
public class PrjProjectMeetingJudgeServiceImpl extends BaseServiceImpl<HlsCusPrjProjectMeetingJudge> implements PrjProjectMeetingJudgeService{

    @Autowired
    private HlsCusPrjProjectMeetingJudgeMapper projectMeetingJudgeMapper;
    @Override
    public HlsCusPrjProjectMeetingJudge queryApprovedResult(IRequest requestContext, Long projectId) {
        return projectMeetingJudgeMapper.queryApprovedResult(projectId);
    }

    @Override
    public List<HlsCusPrjProjectMeetingJudge> queryDetail(IRequest requestContext, Long projectId, int page, int pageSize) {
        PageHelper.startPage(page,pageSize);
        return projectMeetingJudgeMapper.queryDetail(projectId);
    }

    @Override
    public List<HlsCusPrjProjectMeetingJudge> queryUser(IRequest requestContext, Long projectId, int page, int pageSize) {
        PageHelper.startPage(page,pageSize);
        return projectMeetingJudgeMapper.queryUser(projectId);
    }

    @Override
    public List<HlsCusPrjProjectMeetingJudge> queryJudgeByJudgeId(HlsCusPrjProjectMeetingJudge p) {
        return projectMeetingJudgeMapper.queryJudgeByJudgeId(p);
    }

    @Override
    public List<HlsCusPrjProjectMeetingJudge> queryAllJudge() {
        return projectMeetingJudgeMapper.queryAllJudge();
    }

    @Override
    public void deleteByMeetId(Long projectMeetingId) {
        projectMeetingJudgeMapper.deleteByMeetId(projectMeetingId);
    }
}