package hls.core.prj.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.prj.dto.HlsCusPrjProjectMeetingJudge;
import hls.core.prj.mapper.HlsCusPrjProjectMeetingMapper;
import hls.core.prj.service.PrjProjectMeetingJudgeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.prj.dto.HlsCusPrjProjectMeeting;
import hls.core.prj.service.PrjProjectMeetingService;
import org.springframework.transaction.annotation.Transactional;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Service
@Transactional
public class PrjProjectMeetingServiceImpl extends BaseServiceImpl<HlsCusPrjProjectMeeting> implements PrjProjectMeetingService{
    @Autowired
    private PrjProjectMeetingJudgeService projectMeetingJudgeService;
    @Autowired
    private HlsCusPrjProjectMeetingMapper mapper;
    @Override
    public void save(IRequest requestCtx, Map<String, Object> maps) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
        HlsCusPrjProjectMeeting projectMeeting = new HlsCusPrjProjectMeeting();
        Map map1 = (Map)maps.get("form");
        if(map1 != null & !"".equalsIgnoreCase(map1.get("meetingName").toString()) && !"".equalsIgnoreCase(map1.get("meetingLocation").toString()))
        {
            try {
                projectMeeting.setMeetingDate(sdf.parse(map1.get("meetingDate").toString()));
            } catch (ParseException e) {
                e.printStackTrace();
            }
            projectMeeting.setProjectId(Long.parseLong(map1.get("projectId").toString()));
            projectMeeting.setMeetingStatus("NEW");
            projectMeeting.setMeetingName((String)map1.get("meetingName"));
            projectMeeting.setMeetingLocation((String)map1.get("meetingLocation"));
            projectMeeting.setNumberOfJudges(Long.parseLong(map1.get("numberOfJudges").toString()));
            projectMeeting.setAnonymousFlag((String)map1.get("anonymousFlag"));
            HlsCusPrjProjectMeeting meeting = mapper.selectTimes(projectMeeting.getProjectId());
            if(meeting == null) {
                projectMeeting.setMeetingTimes(1L);
            }else {
                projectMeeting.setMeetingTimes(meeting.getMeetingTimes()+1);
            }

            if("".equalsIgnoreCase(map1.get("projectMeetingId").toString())) {
                projectMeeting = self().insertSelective(requestCtx,projectMeeting);
            }else {
                projectMeeting.setProjectMeetingId(Long.parseLong(map1.get("projectMeetingId").toString()));
                projectMeeting = self().updateByPrimaryKeySelective(requestCtx,projectMeeting);
            }
        }
        if(!("").equals(map1.get("projectMeetingId").toString())){
            projectMeetingJudgeService.deleteByMeetId(Long.parseLong(map1.get("projectMeetingId").toString()));
        }
        List list = (ArrayList)maps.get("grid");
        Map map2 = null;
        HlsCusPrjProjectMeetingJudge projectMeetingJudge;
        for(int j=0;j<list.size();j++)
        {
           map2 = (Map)list.get(j);
           if(map2 != null)
           {
               projectMeetingJudge = new HlsCusPrjProjectMeetingJudge();
               projectMeetingJudge.setProjectMeetingId(projectMeeting.getProjectMeetingId());
               if(map2.get("judgeUserAllocationId")!= null) {
                   projectMeetingJudge.setJudgeUserAllocationId(Long.parseLong(map2.get("judgeUserAllocationId").toString()));
               }
               if(map2.get("judgeUserId")!= null) {
                   projectMeetingJudge.setJudgeUserId(Long.parseLong(map2.get("judgeUserId").toString()));
               }
               projectMeetingJudge.setDirectorFlag(map2.get("directorFlag").toString());
               projectMeetingJudge.setProjectId(projectMeeting.getProjectId());
               projectMeetingJudgeService.insertSelective(requestCtx,projectMeetingJudge);
           }
        }
    }

    @Override
    public List<HlsCusPrjProjectMeeting> queryInfo(IRequest requestContext, HlsCusPrjProjectMeeting dto, int page, int pageSize) {
        return mapper.queryInfo(dto.getProjectId());
    }

    @Override
    public HlsCusPrjProjectMeeting queryMeetingByMeetingId(HlsCusPrjProjectMeeting p) {
        return mapper.queryMeetingByMeetingId(p);
    }
}