package hls.core.prj.service.impl;

import com.alibaba.fastjson.JSON;
import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.calc.service.HlsCalcExcelImportUtilService;
import hls.core.prj.dto.HlsCusPrjQuotation;
import hls.core.prj.mapper.HlsCusPrjQuotationCashflowMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.prj.dto.HlsCusPrjQuotationCashflow;
import hls.core.prj.service.PrjQuotationCashflowService;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

@Service
@Transactional
public class PrjQuotationCashflowServiceImpl extends BaseServiceImpl<HlsCusPrjQuotationCashflow> implements PrjQuotationCashflowService {
    @Autowired
    private HlsCalcExcelImportUtilService hlsCalcExcelImportUtilService;
    @Autowired
    private HlsCusPrjQuotationCashflowMapper prjQuotationCashflowMapper;


    //报价计算结束后 更新其他费用项的期数
    private HlsCusPrjQuotationCashflow updateOtherCfItemTimes(HlsCusPrjQuotationCashflow cashflow) {
        if (cashflow.getCfItem() == 0 || cashflow.getCfItem() == 2 || cashflow.getCfItem() == 3 || cashflow.getCfItem() == 5 || cashflow.getCfItem() == 6) {
            cashflow.setTimes(0L);
        } else if (cashflow.getCfItem() == 8) {
            cashflow.setTimes(cashflow.getTimes());
        }
        return cashflow;
    }

    //从报价器复制到项目现金流表
    @Override
    public List<HlsCusPrjQuotationCashflow> saveCalc2PrjQuotationCashflow(IRequest requestContext, HlsCusPrjQuotation prjQuotation) throws Exception {
        List<Object> ObjectList = hlsCalcExcelImportUtilService.getExcelToCalcLnTable(requestContext, prjQuotation.getSheets(), prjQuotation.getPriceList(), "prj", Integer.parseInt(prjQuotation.getLeaseTimes().toString()), prjQuotation.getSourceDocumentCategory());
        List<HlsCusPrjQuotationCashflow> prjQuotationCashflowList = new ArrayList<>();
        for (int i = 0; i < ObjectList.size(); i++) {
            String s = JSON.toJSONString(ObjectList.get(i));
            HlsCusPrjQuotationCashflow prjQuotationCashflow = JSON.parseObject(s, HlsCusPrjQuotationCashflow.class);
            prjQuotationCashflow.setQuotationId(prjQuotation.getQuotationId());
            //下达
            prjQuotationCashflow.setCfStatus("RELEASE");
            //新增
            prjQuotationCashflow.set__status("add");
            //prjQuotationCashflow = updateOtherCfItemTimes(prjQuotationCashflow);
            prjQuotationCashflowList.add(prjQuotationCashflow);
        }
        //删除这个quotation项下现金流
        prjQuotationCashflowMapper.deleteByQuotationId(prjQuotation.getQuotationId());
        //重新插入
        self().batchUpdate(requestContext, prjQuotationCashflowList);
        return prjQuotationCashflowList;
    }

    public List<HlsCusPrjQuotationCashflow> queryPrjQuotationCashflowByProjectId(HlsCusPrjQuotationCashflow prjQuotationCashflow, int page, int pagesize) {
        PageHelper.startPage(page, pagesize);
        return prjQuotationCashflowMapper.queryPrjQuotationCashflowByProjectId(prjQuotationCashflow);
    }
}