package hls.core.prj.service.impl;

import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.mapper.HlsCusConContractMapper;
import hls.core.hls.mapper.HlsSystemNoticeMapper;
import hls.core.prj.mapper.HlsCusPrjTaskMapper;
import hls.core.prj.service.PrjTaskService;
import org.activiti.engine.impl.persistence.entity.UserEntity;
import org.activiti.engine.impl.persistence.entity.data.UserDataManager;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created with IntelliJ IDEA.
 * User: Jeffery
 * Date: 2017/8/18
 * Time: 15:59
 * To change this template use File | Settings | File Templates.
 */
@Service
@Transactional
public class PrjTaskServiceImpl implements PrjTaskService{
    @Autowired
    private HlsCusPrjTaskMapper prjTaskMapper;
    @Autowired
    private HlsCusConContractMapper conContractMapper;
    @Autowired
    private HlsSystemNoticeMapper hlsSystemNoticeMapper;
    @Autowired
    private UserDataManager userDataManager;

    @Override
    public List<Map> queryPrjConTask(String contractId, String projectId) {
        return prjTaskMapper.queryPrjConTask(contractId,projectId);
    }

    @Override
    public Map<String,List<Map>> queryAllPrjConById(String contractId, String projectId) {
        Map<String,List<Map>> listMap = new HashMap<>();
        if(projectId==null){
            //如果project是空 根据合同id查询出projectid
            HlsCusConContract cc  = new HlsCusConContract();
            cc.setContractId(Long.parseLong(contractId));
            Long projectIdByCc =  conContractMapper.select(cc).get(0).getProjectId();
            projectId = projectIdByCc.toString();
        }
        listMap.put("PRJ",prjTaskMapper.queryPrj(contractId,projectId));
        listMap.put("CON",prjTaskMapper.queryCon(contractId,projectId));
        listMap.put("PRJ_MEET",prjTaskMapper.queryPrjMeet(contractId,projectId));
        listMap.put("CON_CANCEL",prjTaskMapper.queryConCancel(contractId,projectId));
        listMap.put("CON_CHANGE",prjTaskMapper.queryConChange(contractId,projectId));
        listMap.put("CON_INCEPT",prjTaskMapper.queryConIncept(contractId,projectId));
        listMap.put("CON_CHANGE_CF",prjTaskMapper.queryConChangeCf(contractId,projectId));
        listMap.put("CON_SIGN",prjTaskMapper.queryConSign(contractId,projectId));
        listMap.put("CON_PAY",prjTaskMapper.queryConPay(contractId,projectId));
        listMap.put("CON_END",prjTaskMapper.queryConEnd(contractId,projectId));
        listMap.put("CON_CSH",prjTaskMapper.queryConCsh(contractId,projectId));
        listMap.put("CON_CSH_PAY",prjTaskMapper.queryCshPaid(contractId,projectId));
        listMap.put("NOTICE",hlsSystemNoticeMapper.queryPrjByid(contractId,projectId));
        return listMap;
    }

    public String getEmployeeName(String userId) {
        UserEntity userEntity = userDataManager.findById(userId);
        if (userEntity != null && StringUtils.isNotEmpty(userEntity.getFirstName())) {
            return userEntity.getFirstName();
        }
        return userId;
    }

    @Override
    public List<Map> queryTaskInfo(String processInstanceId) {
        List<Map> listMap = prjTaskMapper.queryTaskInfo(processInstanceId);
        if(listMap.size()>0){
            for (int i=0;i<listMap.size();i++){
                if(listMap.get(i).get("assignee")!=null){
                    listMap.get(i).put("assigneeName",getEmployeeName(listMap.get(i).get("assignee").toString()));
                }
            }
        }
        return listMap;
    }

    @Override
    public List<Map> queryConPayInfo(String contractId, String projectId) {
        List<Map> listMap = prjTaskMapper.queryConPayInfo(contractId,projectId);
        if(listMap.size()>0){
            for (int i=0;i<listMap.size();i++){
                if(listMap.get(i).get("taskUser")!=null){
                    listMap.get(i).put("taskUserName",getEmployeeName(listMap.get(i).get("taskUser").toString()));
                }
                if(listMap.get(i).get("paymentFlag").equals("FULL")){
                    listMap.get(i).put("paymentFlagName","完全核销");
                }else if(listMap.get(i).get("paymentFlag").equals("NOT")){
                    listMap.get(i).put("paymentFlagName","未核销");
                }else {
                    listMap.get(i).put("paymentFlagName","部分核销");
                }
            }
        }
        return listMap;
    }
    public List<Map> getprocInstIdByPrjId(Long projectId){
        return prjTaskMapper.getprocInstIdByPrjId(projectId);
    }
}
