package hls.core.reportform.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.reportform.dto.Attr;
import hls.core.reportform.service.IAttrService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import org.springframework.validation.BindingResult;
import java.util.List;

    @Controller
    public class AttrController extends BaseController{

        @Autowired
        private IAttrService service;


        @RequestMapping(value = "/reportform/attr/query")
        @ResponseBody
        public ResponseData query(Attr dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
            IRequest requestContext = createRequestContext(request);
            return new ResponseData(service.select(requestContext,dto,page,pageSize));
        }



    @RequestMapping(value = "/reportform/attr/{reportId}/query")
    @ResponseBody
    public ResponseData queryById(Attr dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request, @PathVariable("reportId") long reportId) {
        IRequest requestContext = createRequestContext(request);

        return new ResponseData(service.queryById(reportId));
    }

        @RequestMapping(value = "/reportform/attr/{reportId}/submit")
        @ResponseBody
        public ResponseData update(@RequestBody List<Attr> dto, BindingResult result, HttpServletRequest request,@PathVariable("reportId") long reportId){
            getValidator().validate(dto, result);
            if (result.hasErrors()) {
                ResponseData responseData = new ResponseData(false);
                responseData.setMessage(getErrorMessage(result, request));
                return responseData;
            }
            for(Attr attr:dto){
                attr.setReportId(reportId);
            }
            IRequest requestCtx = createRequestContext(request);
            return new ResponseData(service.batchUpdate(requestCtx, dto));
        }

        @RequestMapping(value = "/reportform/attr/{reportId}/remove")
        @ResponseBody
        public ResponseData delete(HttpServletRequest request,@RequestBody List<Attr> dto){
            service.batchDelete(dto);
            return new ResponseData();
        }
    }