package hls.core.rpt.components;

import com.hand.hap.core.IRequest;
import hls.core.rpt.dto.RptReportDtl;
import hls.core.rpt.dto.RptReportHd;
import hls.core.rpt.service.RptReportDtlService;
import hls.core.rpt.service.RptReportHdService;
import hls.core.sys.event.service.SysEventCommonService;
import hls.core.sys.event.service.SysEventService;
import org.activiti.engine.delegate.DelegateExecution;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;

/**
 * Created with IntelliJ IDEA.
 * User: Jeffery
 * Date: 2017/8/22
 * Time: 17:30
 * To change this template use File | Settings | File Templates.
 */
abstract class AbstractRptReportEventHandler implements SysEventCommonService {
    @Autowired
    private RptReportHdService rptReportHdService;
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private RptReportDtlService rptReportDtlService;

    @Override
    public String getDocumentCategory() {
        return null;
    }

    @Override
    public void process(IRequest iRequest, Long documentId, String documentCategory, String documentType, Map<String, Object> params) {
        if (params == null) {
            params = new HashMap<>();
        }
        RptReportDtl rptReportDtl = new RptReportDtl();
        rptReportDtl.setReportDtlId(documentId);
        List<RptReportDtl> listDtl = rptReportDtlService.queryDtlInfoById(rptReportDtl);
        RptReportHd rptHd = new RptReportHd();
        rptHd.setReportId(listDtl.get(0).getReportId());
        List<RptReportHd> listHd = rptReportHdService.queryRptReportHdInfoById(rptHd);
        String message = "";
        String noticeTitle = "";
        if(listHd.get(0).getReleaseBy()!=null && !Objects.equals(listHd.get(0).getReleaseBy(), "")){
            message =listHd.get(0).getReleaseBy()+"发布报表";
        }else {
            message ="智能系统发布报表";
        }
        noticeTitle = "报表推送";
        params.put("message", message);
        params.put("noticeTitle", noticeTitle);
        params.put("level", 2L);
        params.put("noticeType", "NOTICE");
        sysEventService.eventSave(iRequest, documentId, documentCategory, documentType, "RPT", getEventCode(), "P2D", params);
    }
    @Override
    public void notice(DelegateExecution delegateExecution, String status) {

    }
}
