package hls.core.rpt.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.dto.HlsUserRelationship;
import hls.core.hls.service.HlsSystemNoticeService;
import hls.core.hls.service.IHlsUserRelationshipService;
import hls.core.rpt.dto.*;
import hls.core.rpt.service.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.ArrayList;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: Jeffery
 * Date: 2017/7/6
 * Time: 16:23
 * To change this template use File | Settings | File Templates.
 */
@Controller
public class RptReportDtlController extends BaseController {
    @Autowired
    private RptReportDtlService rptReportDtlService;
    @Autowired
    private RptReportHdService rptReportHdService;
    @Autowired
    private RptReportGradeService rptReportGradeService;
    @Autowired
    private IHlsUserRelationshipService iHlsUserRelationshipService;
    @Autowired
    private RptReportAuthorityService rptReportAuthorityService;
    @Autowired
    private RptReportKeywordService rptReportKeywordService;
    @Autowired
    private HlsSystemNoticeService hlsSystemNoticeService;

    @RequestMapping(value = "/rpt/query/all")
    @ResponseBody
    public ResponseData queryAl(RptReportDtl rptReportDtl, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        List<RptReportDtl> list = rptReportDtlService.queryDtlAllInfo();
        return new ResponseData(list);
    }

    @RequestMapping(value = "/rpt/query/rpthd/byId")
    @ResponseBody
    public ResponseData queryRptHdById(RptReportHd rptReportHd, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        List<RptReportHd> list = rptReportHdService.queryRptReportHdInfoById(rptReportHd);
        return new ResponseData(list);
    }

    /*
    * 查询我的推送
    * */
    @RequestMapping(value = "/rpt/query/push/userid")
    @ResponseBody
    public ResponseData queryByUserId(RptReportHd rptReportHd, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        rptReportHd.setUserId(requestContext.getUserId());
        List<RptReportHd> list = rptReportHdService.queryPushByUserId(rptReportHd);
        return new ResponseData(list);
    }

    /*
     * 查询我的收藏
     * */
    @RequestMapping(value = "/rpt/query/collect/userid")
    @ResponseBody
    public ResponseData queryPushByUserId(RptReportHd rptReportHd, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        rptReportHd.setUserId(requestContext.getUserId());
        List<RptReportHd> list = rptReportHdService.queryCollectByUserId(rptReportHd);
        return new ResponseData(list);
    }

    @RequestMapping(value = "/rpt/query/subscribe/userid")
    @ResponseBody
    public ResponseData querySubscribeByUserId(RptReportHd rptReportHd, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        rptReportHd.setUserId(requestContext.getUserId());
        List<RptReportHd> list = rptReportHdService.querySubscribe(rptReportHd);
        return new ResponseData(list);
    }

    @RequestMapping(value = "/rpt/query/by/subscribe")
    @ResponseBody
    public ResponseData queryBySubscribe(RptReportHd rptReportHd, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        List<RptReportHd> list = rptReportHdService.queryBySubscribe(requestContext.getUserId());
        return new ResponseData(list);
    }

    @RequestMapping(value = "/rpt/query/by/grade")
    @ResponseBody
    public ResponseData queryByGrade(RptReportHd rptReportHd, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        List<RptReportHd> list = rptReportHdService.queryByGrade(requestContext.getUserId());
        return new ResponseData(list);
    }

    @RequestMapping(value = "/rpt/query/by/date")
    @ResponseBody
    public ResponseData queryByDate(RptReportHd rptReportHd, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        List<RptReportHd> list = rptReportHdService.queryAllByDate(requestContext.getUserId());
        return new ResponseData(list);
    }

    @RequestMapping(value = "/rpt/query/allinfo/reportid")
    @ResponseBody
    public ResponseData queryAllInfoByReportId(RptReportHd rptReportHd, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        List<RptReportHd> list = rptReportHdService.selectAllInfo(Long.toString(requestContext.getUserId()), Long.toString(rptReportHd.getReportId()));
        return new ResponseData(list);
    }

    @RequestMapping(value = "/save/report/star")
    @ResponseBody
    public ResponseData saveReportStar(RptReportHd rptReportHd, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        RptReportGrade rptReportGrade = new RptReportGrade();
        rptReportGrade.setGrade(Math.round(rptReportHd.getGrade()));
        rptReportGrade.setDescription(rptReportHd.getGradedescription());
        rptReportGrade.setUserId(requestContext.getUserId());
        rptReportGrade.setReportId(rptReportHd.getReportId());
        if(rptReportHd.getSaveFlag().equals("true")){
            rptReportGrade.set__status("add");
            List<RptReportGrade> listGrade = new ArrayList<>();
            listGrade.add(rptReportGrade);
            rptReportGradeService.batchUpdate(requestContext, listGrade);
        }else if(rptReportHd.getSaveFlag().equals("false")){
            rptReportGrade.set__status("update");
            rptReportGradeService.updateGrade(rptReportGrade);
        }
        List<RptReportHd> list = rptReportHdService.selectAllInfo(Long.toString(requestContext.getUserId()), Long.toString(rptReportHd.getReportId()));
        return new ResponseData(list);
    }

    @RequestMapping(value = "/update/subscribe/by/reportId")
    @ResponseBody
    public ResponseData updateSubscribe(RptReportHd rptReportHd, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        HlsUserRelationship hlsUserRelationship = new HlsUserRelationship();
        hlsUserRelationship.setRelationDocumentCategory("RPT_REPORT");
        hlsUserRelationship.setRelationDocumentId(rptReportHd.getReportId());
        hlsUserRelationship.setRelationType("P2D");
        hlsUserRelationship.setUserId(requestContext.getUserId());
        hlsUserRelationship.set__status("add");
        List<HlsUserRelationship> listRelationShip = new ArrayList<>();
        listRelationShip.add(hlsUserRelationship);
        listRelationShip = iHlsUserRelationshipService.batchUpdate(requestContext, listRelationShip);
        return new ResponseData(listRelationShip);
    }

    @RequestMapping(value = "/delete/subscribe/by/reportId")
    @ResponseBody
    public ResponseData deleteByReportId(RptReportHd rptReportHd, HttpServletRequest request) {
        ResponseData rd = null;
        IRequest requestContext = createRequestContext(request);
        HlsUserRelationship hlsUserRelationship = new HlsUserRelationship();
        hlsUserRelationship.setUserId(requestContext.getUserId());
        hlsUserRelationship.setRelationDocumentId(rptReportHd.getReportId());
        hlsUserRelationship.setRelationDocumentCategory("RPT_REPORT");
        hlsUserRelationship.setRelationType("P2D");
        try {
            rptReportHdService.deleteByReportId(hlsUserRelationship);
            rd = new ResponseData(true);
            rd.setMessage("成功取消订阅");
        } catch (Exception e) {
            rd = new ResponseData(false);
            rd.setMessage("取消订阅失败");
        }
        return rd;
    }

    @RequestMapping(value = "/rpt/collect/detail/report")
    @ResponseBody
    public ResponseData collectReport(RptReportHd rptReportHd, HttpServletRequest request) {
        ResponseData rd = null;
        IRequest requestContext = createRequestContext(request);
        HlsUserRelationship hlsUserRelationship = new HlsUserRelationship();
        hlsUserRelationship.setUserId(requestContext.getUserId());
        hlsUserRelationship.setRelationDocumentId(rptReportHd.getReportDtlId());
        hlsUserRelationship.setSourceEvent("RPT_REPORT_DTL");
        hlsUserRelationship.setRelationType("P2D");
        List<HlsUserRelationship> list = iHlsUserRelationshipService.queryDetailByreportId(hlsUserRelationship);
        if (list.size() > 0) {
            iHlsUserRelationshipService.deleteByPrimaryKey(list.get(0));
            rd = new ResponseData(false);
            rd.setMessage("成功取消收藏");
        } else {
            hlsUserRelationship.set__status("add");
            list.add(hlsUserRelationship);
            iHlsUserRelationshipService.batchUpdate(requestContext, list);
            rd = new ResponseData(true);
            rd.setMessage("收藏成功");
        }
        return rd;
    }

    @RequestMapping(value = "/rpt/report/submit")
    @ResponseBody
    public ResponseData submit(@RequestBody final List<RptReportHd> rptReportHdList,
                               final HttpServletRequest request, final HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        Long companyId = Long.valueOf(String.valueOf(session.getAttribute("companyId")));
        if(rptReportHdList.get(0).getReportId() != null){
            rptReportHdList.get(0).set__status("update");
        }else {
            rptReportHdList.get(0).setReleaseUserId(requestContext.getUserId());
            rptReportHdList.get(0).set__status("add");
        }
        rptReportHdList.get(0).setCompanyId(companyId);
        rptReportHdList.get(0).setReleaseUserId(requestContext.getUserId());
        String currentkeyWord = rptReportHdList.get(0).getKeyWord();
        List<RptReportHd> returnList = rptReportHdService.batchUpdate(requestContext, rptReportHdList);
        List<RptReportKeyword> rptReportKeywordList = new ArrayList<>();
        if(currentkeyWord != null){
            String[] key= currentkeyWord.split("，|,|;|；");
            for(int i=0;i<key.length;i++){
                RptReportKeyword rptReportKeyword = new RptReportKeyword();
                rptReportKeyword.setKeyWord(key[i].toString());
                rptReportKeyword.setReportId(returnList.get(0).getReportId());
                List<RptReportKeyword> listKey = rptReportKeywordService.queryByKeyAndId(rptReportKeyword);
                if(listKey!=null && listKey.size()>0){
                    rptReportKeyword.set__status("update");
                }else {
                    rptReportKeyword.set__status("add");
                }
                rptReportKeywordList.add(rptReportKeyword);
            }
            rptReportKeywordService.batchUpdate(requestContext,rptReportKeywordList);
        }
        return new ResponseData(returnList);
    }

    @RequestMapping(value = "/rpt/report/authority/submit")
    @ResponseBody
    public ResponseData authoritySubmit(@RequestBody final List<RptReportAuthority> rptReportAuthorityList, final BindingResult result,
                                        final HttpServletRequest request) {
        List<RptReportAuthority> reportAuthorityList = rptReportAuthorityList;
        IRequest requestContext = createRequestContext(request);
        reportAuthorityList = rptReportAuthorityService.batchUpdate(requestContext, reportAuthorityList);
        return new ResponseData(reportAuthorityList);
    }

    @RequestMapping(value = "/rpt/report/update")
    @ResponseBody
    public ResponseData rptHdUpdate(final RptReportHd rptReportHd, final HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        List<RptReportHd> rptReportHdList = rptReportHdService.queryRptReportHdInfoById(rptReportHd);
        rptReportHdList.get(0).set__status("update");
        rptReportHdList.get(0).setJobId(rptReportHd.getJobId());
        rptReportHdList.get(0).setJobName(rptReportHd.getJobName());
        rptReportHdList = rptReportHdService.batchUpdate(requestContext,rptReportHdList);
        return new ResponseData(rptReportHdList);
    }
}
