package hls.core.rpt.controllers;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.rpt.dto.RptReportDtl;
import hls.core.rpt.dto.RptReportGrade;
import hls.core.rpt.dto.RptReportHd;
import hls.core.rpt.dto.RptReportKeyword;
import hls.core.rpt.service.RptReportGradeService;
import hls.core.rpt.service.RptReportHdService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: Jeffery
 * Date: 2017/8/8
 * Time: 14:47
 * To change this template use File | Settings | File Templates.
 */
@Controller
public class RptReportHdController extends BaseController {
    @Autowired
    private RptReportHdService rptReportHdService;
    @Autowired
    private RptReportGradeService rptReportGradeService;

    @RequestMapping(value = "/get/all/report/by/date")
    @ResponseBody
    public ResponseData queryAl(RptReportHd rptReportHd, HttpServletRequest request,@RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize,final HttpSession session) {
        PageHelper.startPage(page,pageSize);
        rptReportHd.setCompanyId(Long.parseLong(session.getAttribute("companyId").toString()));
        List<RptReportHd> list = rptReportHdService.queryRptIdByTime(rptReportHd);
        return new ResponseData(list);
    }

    @RequestMapping(value = "/rpt/report/hd/submit")
    @ResponseBody
    public ResponseData submit(@RequestBody final List<RptReportHd> rptReportHdList,
                               final HttpServletRequest request, final HttpSession session) {
        IRequest requestContext = createRequestContext(request);
        Long companyId = (Long) session.getAttribute("companyId");
        for(RptReportHd index:rptReportHdList){
            index.setCompanyId(companyId);
        }
        List<RptReportHd> list = rptReportHdService.batchUpdate(requestContext,rptReportHdList);
        return new ResponseData(list);
    }

    @RequestMapping(value = "/rpt/report/com/query/all")
    @ResponseBody
    public ResponseData queryAllCom(RptReportGrade rptReportGrade, final HttpServletRequest request) {
        List<RptReportGrade> listGrade = rptReportGradeService.queryAllComment(rptReportGrade);
        return new ResponseData(listGrade);
    }
}
