package hls.core.rpt.dto;

import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;
import com.mysql.jdbc.Blob;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.validation.constraints.NotNull;
import java.util.Date;

/**
 * Created with IntelliJ IDEA.
 * User: Jeffery
 * Date: 2017/7/6
 * Time: 13:56
 * To change this template use File | Settings | File Templates.
 */
@ExtensionAttribute(disable = true)
@Table(name = "rpt_report_hd")
public class RptReportHd extends BaseDTO {
    @Id
    @GeneratedValue
    private Long reportId;
    @NotNull
    private String reportCode;

    private Long companyId;
    private String reportName;
    private String reportDescription;
    private String reportType;
    private String reportLogo;
    private String keyWord;
    private String authorityType;
    private String releaseFrequency;
    private Date startDate;
    private Date endDate;
    private Long releaseUserId;
    private Long functionId;
    private String jobName;
    private Long jobId;
    private String releaseBy;
    private String rptProgram;
    private String rptHtml;

    /*RptReportDtl*/
    @Transient
    private Long reportDtlId;
    @Transient
    private Date releaseDate;

    /*RptReportGrade*/
    @Transient
    private String gradedescription;
    @Transient
    private Double grade;

    /*RptReportAuthority*/
    @Transient
    private Long reportAuthorityId;
    @Transient
    private Long authorityCompanyId;
    @Transient
    private Long unitId;
    @Transient
    private Long positionId;
    @Transient
    private Date authorityStartDate;
    @Transient
    private Date authorityEndDate;

    /*RptReportDtlOwner*/
    @Transient
    private Long reportDtlOwnerId;
    @Transient
    private Long ownerUserId;
    @Transient
    private String readFlag;
    @Transient
    private Long ownerGrade;
    @Transient
    private String ownerDescription;

    /*不存表页面交互参数*/
    @Transient
    private Long userId;
    @Transient
    private Long distanceTime;
    @Transient
    private Long subscribeCount;
    @Transient
    private String subscribeFlag;
    @Transient
    private String getVal;
    @Transient
    private String collectFlag;
    @Transient
    private String imgUrl;
    @Transient
    private String imgName;
    @Transient
    private String scheduleName;
    @Transient
    private String reportTypeDesc;
    @Transient
    private String saveFlag;

    public String getSaveFlag() {
        return saveFlag;
    }

    public void setSaveFlag(String saveFlag) {
        this.saveFlag = saveFlag;
    }

    public String getReportTypeDesc() {
        return reportTypeDesc;
    }

    public void setReportTypeDesc(String reportTypeDesc) {
        this.reportTypeDesc = reportTypeDesc;
    }

    public String getScheduleName() {
        return scheduleName;
    }

    public void setScheduleName(String scheduleName) {
        this.scheduleName = scheduleName;
    }

    public String getReleaseBy() {
        return releaseBy;
    }

    public void setReleaseBy(String releaseBy) {
        this.releaseBy = releaseBy;
    }

    public String getRptProgram() {
        return rptProgram;
    }

    public void setRptProgram(String rptProgram) {
        this.rptProgram = rptProgram;
    }

    public String getRptHtml() {
        return rptHtml;
    }

    public void setRptHtml(String rptHtml) {
        this.rptHtml = rptHtml;
    }

    public String getJobName() {
        return jobName;
    }

    public void setJobName(String jobName) {
        this.jobName = jobName;
    }

    public Long getJobId() {
        return jobId;
    }

    public void setJobId(Long jobId) {
        this.jobId = jobId;
    }

    public String getImgName() {
        return imgName;
    }

    public void setImgName(String imgName) {
        this.imgName = imgName;
    }

    public String getImgUrl() {
        return imgUrl;
    }

    public void setImgUrl(String imgUrl) {
        this.imgUrl = imgUrl;
    }

    public String getCollectFlag() {return collectFlag;}

    public void setCollectFlag(String collectFlag) {this.collectFlag = collectFlag;}

    public String getGetVal() {return getVal;}

    public void setGetVal(String getVal) {this.getVal = getVal;}

    public String getSubscribeFlag() {return subscribeFlag;}

    public void setSubscribeFlag(String subscribeFlag) {this.subscribeFlag = subscribeFlag;}

    public Long getReportAuthorityId() {
        return reportAuthorityId;
    }

    public void setReportAuthorityId(Long reportAuthorityId) {
        this.reportAuthorityId = reportAuthorityId;
    }

    public Long getAuthorityCompanyId() {
        return authorityCompanyId;
    }

    public void setAuthorityCompanyId(Long authorityCompanyId) {
        this.authorityCompanyId = authorityCompanyId;
    }

    public Long getUnitId() {
        return unitId;
    }

    public void setUnitId(Long unitId) {
        this.unitId = unitId;
    }

    public Long getPositionId() {
        return positionId;
    }

    public void setPositionId(Long positionId) {
        this.positionId = positionId;
    }

    public Date getAuthorityStartDate() {
        return authorityStartDate;
    }

    public void setAuthorityStartDate(Date authorityStartDate) {
        this.authorityStartDate = authorityStartDate;
    }

    public Date getAuthorityEndDate() {
        return authorityEndDate;
    }

    public void setAuthorityEndDate(Date authorityEndDate) {
        this.authorityEndDate = authorityEndDate;
    }

    public Long getReportDtlOwnerId() {
        return reportDtlOwnerId;
    }

    public void setReportDtlOwnerId(Long reportDtlOwnerId) {
        this.reportDtlOwnerId = reportDtlOwnerId;
    }

    public Long getOwnerUserId() {
        return ownerUserId;
    }

    public void setOwnerUserId(Long ownerUserId) {
        this.ownerUserId = ownerUserId;
    }

    public String getReadFlag() {
        return readFlag;
    }

    public void setReadFlag(String readFlag) {
        this.readFlag = readFlag;
    }

    public Long getOwnerGrade() {
        return ownerGrade;
    }

    public void setOwnerGrade(Long ownerGrade) {
        this.ownerGrade = ownerGrade;
    }

    public String getOwnerDescription() {
        return ownerDescription;
    }

    public void setOwnerDescription(String ownerDescription) {
        this.ownerDescription = ownerDescription;
    }

    public Long getSubscribeCount() {return subscribeCount;}

    public void setSubscribeCount(Long subscribeCount) {this.subscribeCount = subscribeCount;}

    public Double getGrade() {return grade;}

    public void setGrade(Double grade) {this.grade = grade;}

    public String getGradedescription() {
        return gradedescription;
    }

    public void setGradedescription(String gradedescription) {
        this.gradedescription = gradedescription;
    }

    public Long getDistanceTime() {
        return distanceTime;
    }

    public void setDistanceTime(Long distanceTime) {
        this.distanceTime = distanceTime;
    }

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public Long getReportDtlId() {
        return reportDtlId;
    }

    public Date getReleaseDate() {
        return releaseDate;
    }

    public void setReleaseDate(Date releaseDate) {
        this.releaseDate = releaseDate;
    }

    public void setReportDtlId(Long reportDtlId) {
        this.reportDtlId = reportDtlId;
    }

    public String getReportLogo() {
        return reportLogo;
    }

    public void setReportLogo(String reportLogo) {
        this.reportLogo = reportLogo;
    }

    public Long getReportId() {
        return reportId;
    }

    public void setReportId(Long reportId) {
        this.reportId = reportId;
    }

    public Long getCompanyId() {
        return companyId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public String getReportCode() {
        return reportCode;
    }

    public void setReportCode(String reportCode) {
        this.reportCode = reportCode;
    }

    public String getReportName() {
        return reportName;
    }

    public void setReportName(String reportName) {
        this.reportName = reportName;
    }

    public String getReportDescription() {
        return reportDescription;
    }

    public void setReportDescription(String reportDescription) {
        this.reportDescription = reportDescription;
    }

    public String getReportType() {
        return reportType;
    }

    public void setReportType(String reportType) {
        this.reportType = reportType;
    }

    public String getKeyWord() {
        return keyWord;
    }

    public void setKeyWord(String keyWord) {
        this.keyWord = keyWord;
    }

    public String getAuthorityType() {
        return authorityType;
    }

    public void setAuthorityType(String authorityType) {
        this.authorityType = authorityType;
    }

    public String getReleaseFrequency() {
        return releaseFrequency;
    }

    public void setReleaseFrequency(String releaseFrequency) {
        this.releaseFrequency = releaseFrequency;
    }

    public Date getStartDate() {
        return startDate;
    }

    public void setStartDate(Date startDate) {
        this.startDate = startDate;
    }

    public Date getEndDate() {
        return endDate;
    }

    public void setEndDate(Date endDate) {
        this.endDate = endDate;
    }

    public Long getReleaseUserId() {
        return releaseUserId;
    }

    public void setReleaseUserId(Long releaseUserId) {
        this.releaseUserId = releaseUserId;
    }

    public Long getFunctionId() {
        return functionId;
    }

    public void setFunctionId(Long functionId) {
        this.functionId = functionId;
    }
}
