package hls.core.rpt.service.impl;

import com.hand.hap.core.IRequest;
import hls.core.hls.dto.HlsUserRelationship;
import hls.core.hls.service.IHlsUserRelationshipService;
import hls.core.rpt.dto.RptReportDtl;
import hls.core.rpt.service.RptReportEventService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: Jeffery
 * Date: 2017/8/22
 * Time: 19:16
 * To change this template use File | Settings | File Templates.
 */
@Service
@Transactional
public class RptReportEventServiceImpl implements RptReportEventService {
    @Autowired
    private IHlsUserRelationshipService iHlsUserRelationshipService;
    @Override
    public void saveRelation(IRequest iRequest, String eventCode, RptReportDtl rptReportDtl) {
        //关系表
        HlsUserRelationship hus = new HlsUserRelationship();
        hus.setRelationDocumentId(rptReportDtl.getReportId());
        List<HlsUserRelationship> listHur = iHlsUserRelationshipService.queryCollUserByRptId(hus);
        HlsUserRelationship hlsUserRelationship = new HlsUserRelationship();
        hlsUserRelationship.setRelationDocumentCategory("REPORT_DTL");
        hlsUserRelationship.setRelationDocumentId(rptReportDtl.getReportDtlId());
        hlsUserRelationship.setSourceEvent(eventCode);
        hlsUserRelationship.setRelationType("P2D");
        hlsUserRelationship.setSourceModule("RPT");
        hlsUserRelationship.set__status("add");
        if(listHur!=null && listHur.size()>0){
            for (int i=0;i<listHur.size();i++){
                if(!listHur.get(i).getUserId().equals(iRequest.getUserId())){
                    hlsUserRelationship.setUserId(listHur.get(i).getUserId());
                    List<HlsUserRelationship> listCurrent = new ArrayList<>();
                    listCurrent.add(hlsUserRelationship);
                    iHlsUserRelationshipService.batchUpdate(iRequest,listCurrent);
                }
            }
        }else {
            hlsUserRelationship.setUserId(0L);
            List<HlsUserRelationship> listCurrent = new ArrayList<>();
            listCurrent.add(hlsUserRelationship);
            iHlsUserRelationshipService.batchUpdate(iRequest,listCurrent);
        }
    }

}
