package hls.core.rpt.service.impl;

import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.hls.dto.HlsUserRelationship;
import hls.core.rpt.dto.RptReportGrade;
import hls.core.rpt.dto.RptReportHd;
import hls.core.rpt.mapper.RptReportHdMapper;
import hls.core.rpt.service.RptReportHdService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigInteger;
import java.util.Date;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: Jeffery
 * Date: 2017/7/6
 * Time: 16:14
 * To change this template use File | Settings | File Templates.
 */
@Service
@Transactional
public class RptReportHdServiceImpl extends BaseServiceImpl<RptReportHd> implements RptReportHdService{
    @Autowired
    private RptReportHdMapper rptReportHdMapper;

    @Override
    public List<RptReportHd> querySubscribe(RptReportHd rptReportHd) {
        return rptReportHdMapper.querySubscribe(rptReportHd);
    }

    @Override
    public List<RptReportHd> queryBySubscribe(Long userId) {
        return rptReportHdMapper.queryBySubscribe(userId);
    }

    @Override
    public List<RptReportHd> queryByGrade(Long userId) {
        return rptReportHdMapper.queryByGrade(userId);
    }

    @Override
    public List<RptReportHd> queryAllByDate(Long userId) {
        return rptReportHdMapper.queryAllByDate(userId);
    }

    @Override
    public List<RptReportHd> selectAllInfo(String userId,String reportId) {
        return rptReportHdMapper.selectAllInfo(userId,reportId);
    }

    @Override
    public void deleteByReportId(HlsUserRelationship hlsUserRelationship) {
        rptReportHdMapper.deleteByReportId(hlsUserRelationship);
    }

    @Override
    public List<RptReportHd> queryPushByUserId(RptReportHd rptReportHd) {
        List<RptReportHd> rptReportHds = rptReportHdMapper.queryPushByUserId(rptReportHd);
        Date time = new Date();
        rptReportHds.forEach(item->{
            item.setDistanceTime((time.getTime() - item.getReleaseDate().getTime())/(1000 * 60 * 60));
            //如果collectFlag是空 表示未关注 将collectFlag置为N
            if(item.getCollectFlag()==null){
                item.setCollectFlag("N");
            }
        });
        return rptReportHdMapper.queryPushByUserId(rptReportHd);
    }

    @Override
    public List<RptReportHd> queryCollectByUserId(RptReportHd rptReportHd) {
        List<RptReportHd> rptReportHds = rptReportHdMapper.queryCollectByUserId(rptReportHd);
        Date time = new Date();
        rptReportHds.forEach(item->{
            item.setDistanceTime((time.getTime() - item.getReleaseDate().getTime())/(1000 * 60 * 60));

        });
        return rptReportHds;
    }

    @Override
    public List<RptReportHd> queryRptReportHdInfoById(RptReportHd rptReportHd) {
        return rptReportHdMapper.queryRptReportHdInfoById(rptReportHd);
    }

    @Override
    public List<RptReportHd> queryRptIdByTime(RptReportHd rptReportHd) {
        return rptReportHdMapper.queryRptIdByTime(rptReportHd);
    }

    @Override
    public List<RptReportHd> queryByNameAndCode(RptReportHd rptReportHd) {
        return rptReportHdMapper.queryByNameAndCode(rptReportHd);
    }
}
