package hls.core.ruleengine.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.ruleengine.dto.GldJeRuleEngineExtend;
import hls.core.ruleengine.dto.HlsCusGldJeRuleEngineExtend;
import hls.core.ruleengine.dto.HlsRuleEngine;
import hls.core.ruleengine.service.IGldJeRuleEngineExtendService;
import hls.core.ruleengine.service.IHlsRuleEngineService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

@Controller
@RequestMapping(value = "/gld/je/engine/extend")
public class GldJeRuleEngineExtendController extends BaseController {

    @Autowired
    private IGldJeRuleEngineExtendService service;


    @RequestMapping(value = "/query")
    @ResponseBody
    public ResponseData query(HlsCusGldJeRuleEngineExtend dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/select")
    @ResponseBody
    public ResponseData select(HlsCusGldJeRuleEngineExtend dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                               @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.selectWithDesc(requestContext, dto, page, pageSize));
    }


    @RequestMapping(value = "/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request, @RequestBody List<HlsCusGldJeRuleEngineExtend> dto) {
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusGldJeRuleEngineExtend> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }
}