package hls.core.ruleengine.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.ruleengine.dto.HlsRuleEngine;
import hls.core.ruleengine.service.IHlsRuleEngineService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

@Controller
    @RequestMapping(value = "/hls/rule/engine")
    public class HlsRuleEngineController extends BaseController{

    @Autowired
    private IHlsRuleEngineService service;


    @RequestMapping(value = "/query")
    @ResponseBody
    public ResponseData query(HlsRuleEngine dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/selectInfo/query")
    @ResponseBody
    public ResponseData selectInfo(HlsRuleEngine dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.selectInfo(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<HlsRuleEngine> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsRuleEngine> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

    @RequestMapping(value = "/resultLov")
    @ResponseBody
    public ResponseData resultLov(HttpServletRequest request,@RequestParam Map param){
        IRequest requestCtx = createRequestContext(request);
        List<Map<String, Object>> hlsResultList = service.getHlsRuleEngine(requestCtx,param);
        return new ResponseData(hlsResultList);
    }
    }