package hls.core.ruleengine.controllers;

import com.alibaba.fastjson.JSONObject;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.ruleengine.dto.HlsRuleEngineRoute;
import hls.core.ruleengine.service.IHlsRuleEngineRouteService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
@RequestMapping(value = "/hls/rule/engine")
public class HlsRuleEngineRouteController extends BaseController{

    @Autowired
    private IHlsRuleEngineRouteService service;


    @RequestMapping(value = "/route/query")
    @ResponseBody
    public ResponseData query(HlsRuleEngineRoute dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/route/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<HlsRuleEngineRoute> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/route/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsRuleEngineRoute> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

    @RequestMapping(value = "/routetree/query")
    @ResponseBody
    public ResponseData routeDetailQuery(HlsRuleEngineRoute dto, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.getEngineRouteTree(requestContext,dto.getRuleEngineId()));
    }

    @RequestMapping(value = "/routetree/submit")
    @ResponseBody
    public ResponseData routeDetailSubmit(@RequestBody JSONObject json, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.saveEngineRouteTree(requestContext,json.getJSONArray("treeData"),json.getJSONArray("deleteTreeData")));
    }

    @RequestMapping(value = "/routetree/remove")
    @ResponseBody
    public ResponseData routeDetailRemove(@RequestParam Long routeId, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        service.removeEngineRouteTree(requestContext,routeId);
        return new ResponseData();
    }
}