package hls.core.ruleengine.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.ruleengine.dto.HlsRuleEngineRouteResult;
import hls.core.ruleengine.service.IHlsRuleEngineRouteResultService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

    @Controller
    @RequestMapping(value = "/hls/rule/engine/route/result")
    public class HlsRuleEngineRouteResultController extends BaseController{

    @Autowired
    private IHlsRuleEngineRouteResultService service;


    @RequestMapping(value = "/query")
    @ResponseBody
    public ResponseData query(HlsRuleEngineRouteResult dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/routequery")
    @ResponseBody
    public ResponseData routeQuery(HlsRuleEngineRouteResult dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.selectRouteResultByRouteId(dto.getRouteId()));
    }

    @RequestMapping(value = "/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<HlsRuleEngineRouteResult> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsRuleEngineRouteResult> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }