package hls.core.ruleengine.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.ruleengine.dto.RuleEngineType;
import hls.core.ruleengine.service.IRuleEngineTypeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

    @Controller
    public class RuleEngineTypeController extends BaseController{

    @Autowired
    private IRuleEngineTypeService service;


    @RequestMapping(value = "/hls/rule/engine/type/query")
    @ResponseBody
    public ResponseData query(RuleEngineType dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

        @RequestMapping(value = "/hls/rule/engine/type/engineTypeQuery")
        @ResponseBody
        public ResponseData engineTypeQuery(RuleEngineType dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
            IRequest requestContext = createRequestContext(request);
            return new ResponseData(service.engineTypeQuery(requestContext,dto,page,pageSize));
        }

    @RequestMapping(value = "/hls/rule/engine/type/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<RuleEngineType> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/hls/rule/engine/type/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<RuleEngineType> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }