package hls.core.svc.controllers;

import hls.core.svc.beans.Service;
import hls.core.svc.components.ServiceExecutor;
import hls.core.svc.components.SqlExecutor;
import hls.core.svc.utils.ParamUtils;
import hls.core.svc.utils.ServiceParser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Controller;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.RequestMapping;

import javax.servlet.http.HttpServletRequest;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-12-04
 * Time: 10:34
 */
@Controller
public class ServiceController {
    @Autowired
    private ApplicationContext context;
    @Autowired
    private SqlExecutor executor;
    @Autowired
    private ServiceExecutor serviceExecutor;

    @RequestMapping("/**/*.svc")
    public void testUrl(HttpServletRequest request) {
        StringBuilder sb = new StringBuilder(request.getRequestURI());
        // delete '/' from start and '.svc' at end
        String s = sb.delete(sb.length() - ".svc".length(), sb.length()).deleteCharAt(0).toString();
        String svcPath = StringUtils.replace(s, "/", ".");
        try {
            ParamUtils.setCurrentHttpRequest(request);
            Service service = ServiceParser.parseService(svcPath);
            serviceExecutor.execute(service);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
