package hls.core.sys.components;

import com.hand.hap.security.CustomAuthenticationSuccessHandler;
import com.hand.hap.security.service.impl.CustomUserDetailsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.stereotype.Component;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;

/**
 * 根据用户名制造session,并跳转到角色选择页面
 *
 * Created by fjm on 2018/1/16.
 */
@Component
public class HlsAuthenticationComponent {
    @Autowired
    private CustomUserDetailsService userDetailsService;
    @Autowired
    private CustomAuthenticationSuccessHandler successHandler;

    public String handlerLogin(HttpServletRequest request, HttpServletResponse response, String username){
        UserDetails userDetails = userDetailsService.loadUserByUsername(username);
        UsernamePasswordAuthenticationToken usernamePasswordAuthenticationToken = new UsernamePasswordAuthenticationToken(userDetails, null, userDetails.getAuthorities());
        SecurityContextHolder.getContext().setAuthentication(usernamePasswordAuthenticationToken);
        try {
            successHandler.onAuthenticationSuccess(request,response,usernamePasswordAuthenticationToken);
            HttpSession session = request.getSession(false);
            String id = session.getId();
            return id;
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ServletException e) {
            e.printStackTrace();
        }
        return null;
    }


}
