package hls.core.sys.controllers;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.beans.factory.support.DefaultListableBeanFactory;
import org.springframework.context.support.AbstractRefreshableApplicationContext;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;
import org.springframework.web.context.support.XmlWebApplicationContext;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-12-25
 * Time: 9:31
 */
@Controller
public class ContextController {
    @RequestMapping("/context/refresh")
    @ResponseBody
    public void refreshContext(HttpServletRequest request) {
        ServletContext servletContext = request.getServletContext();
        WebApplicationContext context = WebApplicationContextUtils.getWebApplicationContext(servletContext);
        if (context instanceof AbstractRefreshableApplicationContext) {
            ((AbstractRefreshableApplicationContext) context).refresh();
        }
    }

    @RequestMapping("/bean/refresh")
    @ResponseBody
    public List<String> refreshBean(HttpServletRequest request, String beans) {
        ArrayList<String> beanNames = new ArrayList<>();
        if (StringUtils.isEmpty(beans)) {
            return beanNames;
        }
        ServletContext servletContext = request.getServletContext();
        XmlWebApplicationContext context = (XmlWebApplicationContext) WebApplicationContextUtils.getWebApplicationContext(servletContext);
        DefaultListableBeanFactory beanFactory = (DefaultListableBeanFactory) context.getBeanFactory();
        for (String bean : StringUtils.split(beans, ",")) {
            if (beanFactory.containsBeanDefinition(bean)) {
                beanNames.add(bean);
                BeanDefinition beanDefinition = beanFactory.getBeanDefinition(bean);
                beanFactory.registerBeanDefinition(bean, beanDefinition);
            }
        }
        return beanNames;
    }
}
