package hls.core.sys.controllers;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.sys.dto.SysFunctionResource;
import hls.core.sys.service.SysFunctionResourceService;
import hls.core.sys.service.SysModuleService;

@Controller()
public class SysFunctionResourceController extends BaseController {

	@Autowired
	private SysFunctionResourceService service;
	
	@Autowired
	private SysModuleService SmService;

	@RequestMapping(value = "/sys/page/query")
	@ResponseBody
	public ResponseData query(HttpServletRequest request, SysFunctionResource sysFunctionResource,
			@RequestParam(defaultValue = DEFAULT_PAGE) int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {

	     IRequest iRequest = createRequestContext(request);
	        List<SysFunctionResource> datas = service.queryAll(iRequest, sysFunctionResource, page, pagesize);
	        return new ResponseData(datas);
	}

	@RequestMapping(value = "/sys/page/submit")
	@ResponseBody
	public ResponseData update(HttpServletRequest request,
			@RequestBody List<SysFunctionResource> list) {
		IRequest iRequest = createRequestContext(request);

		List<SysFunctionResource> lists = service.batchUpdate(iRequest, list);
		return new ResponseData(lists);
	}

	@RequestMapping(value = "/sys/page/remove")
	@ResponseBody
	public ResponseData delete(HttpServletRequest request,
			@RequestBody List<SysFunctionResource> list) {
		service.batchDelete(list);
		return new ResponseData();
	}
}
