package hls.core.sys.controllers;

import hls.core.sys.dto.SysLayoutRoleModule;
import org.docx4j.wml.P;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.sys.dto.SysLayoutModule;
import hls.core.sys.service.ISysLayoutModuleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

import org.springframework.validation.BindingResult;

import java.util.ArrayList;
import java.util.List;

@Controller
public class SysLayoutModuleController extends BaseController {

    @Autowired
    private ISysLayoutModuleService service;


    @RequestMapping(value = "/sys/layout/module/query")
    @ResponseBody
    public ResponseData query(SysLayoutModule dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/sys/layout/module/submit")
    @ResponseBody
    public ResponseData layoutMoudleSubmit(@RequestBody SysLayoutModule  sysLayoutModule , BindingResult result, HttpServletRequest request) {
        getValidator().validate(sysLayoutModule, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = createRequestContext(request);

        List<SysLayoutModule> list = new ArrayList<SysLayoutModule>();
        list.add(service.layoutMoudleSubmit(requestCtx,sysLayoutModule));
        return new ResponseData(list);
    }

    @RequestMapping(value = "/sys/layout/module/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<SysLayoutModule> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }
}