package hls.core.sys.controllers;

import hls.core.sys.dto.SysLayoutModule;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.sys.dto.SysLayoutRoleModule;
import hls.core.sys.service.ISysLayoutRoleModuleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import org.springframework.validation.BindingResult;

import java.util.ArrayList;
import java.util.List;

    @Controller
    public class SysLayoutRoleModuleController extends BaseController{

    @Autowired
    private ISysLayoutRoleModuleService service;


    @RequestMapping(value = "/sys/layout/role/module/query")
    @ResponseBody
    public ResponseData query(SysLayoutRoleModule dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/sys/layout/role/module/submit")
    @ResponseBody
public ResponseData update(@RequestBody List<SysLayoutRoleModule> dto, BindingResult result, HttpServletRequest request){
getValidator().validate(dto, result);
if (result.hasErrors()) {
ResponseData responseData = new ResponseData(false);
responseData.setMessage(getErrorMessage(result, request));
return responseData;
}
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/sys/layout/role/module/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody SysLayoutRoleModule sysLayoutRoleModule){
        service.batchDeleteLayoutConfig(sysLayoutRoleModule);
        return new ResponseData();
    }

        @RequestMapping(value = "/sys/layout/role/submit")
        @ResponseBody
        public ResponseData layoutRoleSubmit(@RequestBody SysLayoutRoleModule item, BindingResult result, HttpServletRequest request) {
            getValidator().validate(item, result);
            if (result.hasErrors()) {
                ResponseData responseData = new ResponseData(false);
                responseData.setMessage(getErrorMessage(result, request));
                return responseData;
            }
            IRequest requestCtx = createRequestContext(request);
            List<SysLayoutRoleModule> list = new ArrayList<SysLayoutRoleModule>();
            list.add(service.layoutRoleSubmit(requestCtx,item));
            return new ResponseData(list);
        }




    }