package hls.core.sys.controllers;

import java.util.List;

import hls.core.sys.dto.SysFunction;
import hls.core.sys.dto.SysModule;
import hls.core.sys.service.SysFunctionResourceService;
import hls.core.sys.service.SysFunctionService;
import hls.core.sys.service.SysModuleService;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

@Controller()
@RequestMapping(value = "/sys")
public class SysModuleController extends BaseController {

	@Autowired
	private SysFunctionService SfService;
	
	@Autowired
	private SysFunctionResourceService service;
	
	@Autowired
	private SysModuleService SmService;

	@RequestMapping(value = "/module/query")
	@ResponseBody
	public ResponseData query(HttpServletRequest request, SysModule sm,
			@RequestParam(defaultValue = DEFAULT_PAGE) int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {
		return new ResponseData(SmService.queryAll(sm));
	}

	@RequestMapping(value = "/module/submit")
	@ResponseBody
	public ResponseData update(HttpServletRequest request,
			@RequestBody List<SysModule> list) {
		ResponseData rd = null;
		try {
			IRequest iRequest = createRequestContext(request);
			List<SysModule> lists = SmService.batchUpdate(iRequest, list);
			rd = new ResponseData(lists);
		} catch (Exception e) {
			// TODO: handle exception
			rd = new ResponseData(false);
			rd.setMessage("模块代码不可重复");
		}
		
		return rd;
	}

	@RequestMapping(value = "/module/remove")
	@ResponseBody
	public ResponseData delete(HttpServletRequest request,
			@RequestBody List<SysModule> list) {
		SmService.batchDelete(list);
		
		for(int i=0;i<list.size();i++)
		{
			List<SysFunction> listIds = SfService.selectByModuleCode(list.get(i).getModuleCode());
			
			for(int j=0;j<listIds.size();j++)
			{
				service.deletePage(listIds.get(j).getFunctionId());
			}
			
			SmService.deleteFunction(list.get(i).getModuleCode());
			
		}
		return new ResponseData();
	}
	
    @RequestMapping(value = "/module/lov/query")
    @ResponseBody
    public ResponseData queryLov(String url,String name){
    	    	
    	return new ResponseData(SmService.queryLov(url,name));
    	
    }

	@RequestMapping(value = "/module/query/home/page")
	@ResponseBody
	public ResponseData homePageIdByUrlName(HttpServletRequest request, SysModule sm){
		return new ResponseData(SmService.getHomePageIdByUrlName(sm));
	}
}
