package hls.core.sys.controllers;


import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.DTOStatus;
import com.hand.hap.system.dto.ResponseData;

import hls.core.sys.dto.SysRole;
import hls.core.sys.dto.SysRoleManagement;
import hls.core.sys.service.SysRoleManagementService;
import hls.core.sys.service.SysRoleService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DuplicateKeyException;
import org.springframework.stereotype.Controller;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

import java.util.List;

/**
 * Created by hailor on 16/6/2.
 */
@Controller
public class SysRoleController  extends BaseController{

    @Autowired
    private SysRoleService sys;
    
    @Autowired
    private SysRoleManagementService srms;
    @RequestMapping("/SysRole/query")
    @ResponseBody
    public ResponseData selectList(HttpServletRequest request,SysRole sysRole,
            @RequestParam(defaultValue = DEFAULT_PAGE) int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {
     
    	 IRequest iRequest = createRequestContext(request);

         List<SysRole> datas = sys.select(iRequest, sysRole, page, pagesize);
		//List<SysRole> datas = sys.selectList(iRequest, sysRole, page, pagesize);
           return new ResponseData(datas);
    }

	@RequestMapping("/SysRole/roleQuery")
	@ResponseBody
	public ResponseData roleQuery(HttpServletRequest request,SysRole sysRole,
								   @RequestParam(defaultValue = DEFAULT_PAGE) int page,
								   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {
		IRequest iRequest = createRequestContext(request);
		List<SysRole> datas = sys.roleQuery(iRequest,sysRole,page, pagesize);
		return new ResponseData(datas);
	}


	@SuppressWarnings("finally")
	@RequestMapping(value = "/SysRole/submit", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData submit(HttpServletRequest request, @RequestBody final List<SysRole> sysRole,final BindingResult result) {
    	
    	ResponseData rd = null;
    	try {
    		IRequest iRequest = createRequestContext(request);
    		List<SysRole>  datas = sys.batchUpdate(iRequest, sysRole);
            rd = new ResponseData(datas);
		} catch (DuplicateKeyException e) {
			// TODO: handle exception
			rd = new ResponseData(false);
			rd.setMessage("角色代码不可重复");
		}finally {
			return rd;
		}
    	/*IRequest iRequest = createRequestContext(request);
		List<SysRole>  datas = sys.batchUpdate(iRequest, sysRole);
        rd = new ResponseData(datas);*/
    }

    @RequestMapping(value = "/SysRole/delete", method = RequestMethod.POST)
    @ResponseBody
	@Transactional
    public ResponseData delete(HttpServletRequest request, @RequestBody List<SysRole> sysRole) {
		for (SysRole  sr:sysRole) {
			if (sr.getRole_id()!=null){
				sys.deleteByChiledId(sr.getRole_id());
			}
		}

    	sys.batchDelete(sysRole);
        return new ResponseData();
    }
    
    @RequestMapping(value = "/SysRole/addHL", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData addHL(HttpServletRequest request,@RequestBody List<SysRole> sysRole,BindingResult result){
		ResponseData rd = null;
		try{
			List<SysRole> datas = sys.addHL(sysRole);
			rd = new ResponseData(datas);
		}catch (Exception e){
			rd = new ResponseData(false);

			rd.setMessage("一个账户不可分配重复的模块");
		}

    	 return rd;
    }
     
   @RequestMapping(value="/SysRole/copy",method = RequestMethod.POST)
   @ResponseBody
   @Transactional
   public ResponseData copyRole(HttpServletRequest request,@RequestBody List<SysRole> sysRoles,Long roleId){
	    IRequest iRequest = createRequestContext(request);
	    List<SysRole> datas = sys.batchUpdate(iRequest, sysRoles);
	    List<SysRoleManagement> sysRoleManagements = null;
	    for (SysRole sysRole : datas) {
			if (sysRole.getRole_id()!=null) {
			     SysRoleManagement sRoleModule =new SysRoleManagement();
			     sRoleModule.setRole_id(roleId);
				sysRoleManagements = srms.select(iRequest, sRoleModule, 1, 10);
				if (sysRoleManagements != null) {
					for (SysRoleManagement sysRoleManagement : sysRoleManagements) {
						sysRoleManagement.setRole_id(datas.get(0).getRole_id());
						sysRoleManagement.set__status(DTOStatus.ADD);
					}
				}	
			}
		}
	    if (sysRoleManagements != null) {
	    	srms.batchUpdate(iRequest, sysRoleManagements);
		}
	    
	   return new ResponseData(datas);
   }
   
   @RequestMapping(value="/SysRole/copyNew",method = RequestMethod.POST)
   @ResponseBody
   public ResponseData copy(HttpServletRequest request,@RequestBody List<SysRole> sysRoles,String roleName,String roleCode) {
	   IRequest iRequest = createRequestContext(request);
	   SysRole obj = new SysRole();
	   obj.setRole_name(roleName);
	   obj.setRole_code(roleCode);
	   List<SysRole> sr = sys.select(iRequest, obj, 1, 10);
	   Long roleId = sr.get(0).getRole_id();
	return copyRole(request, sysRoles, roleId);
}
}
