package hls.core.sys.controllers;


import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.DTOStatus;
import com.hand.hap.system.dto.ResponseData;

import hls.core.sys.dto.SysRoleManagement;
import hls.core.sys.service.SysRoleManagementService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

import java.util.List;

/**
 * Created by hailor on 16/6/2.
 */
@Controller
public class SysRoleManagementController extends BaseController{

    @Autowired
    private SysRoleManagementService sys;

    @RequestMapping("/SysRoleModule/query")
    @ResponseBody
    public ResponseData selectList(HttpServletRequest request,SysRoleManagement sysRoleManagement,
            @RequestParam(defaultValue = DEFAULT_PAGE) int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {
     
    	 IRequest iRequest = createRequestContext(request);
         List<SysRoleManagement> datas = sys.queryAll(iRequest, sysRoleManagement,page, pagesize);
           return new ResponseData(datas);
    }
    
    @RequestMapping("/SysRoleModule/queryLov")
    @ResponseBody
    public ResponseData queryLov(HttpServletRequest request,SysRoleManagement sysRoleManagement,
            @RequestParam(defaultValue = DEFAULT_PAGE) int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {
    	String m_name = sysRoleManagement.getModule_name();
    	String m_code = sysRoleManagement.getModule_code();
           List<SysRoleManagement> datas = sys.queryLov(m_name,m_code);
           return new ResponseData(datas);
    }

    @RequestMapping(value = "/SysRoleModule/submit", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData submit(HttpServletRequest request, @RequestBody List<SysRoleManagement> sysRoleManagements) {
    	ResponseData rd = null;
    	try {
    		 IRequest iRequest = createRequestContext(request);
             for(SysRoleManagement sys  : sysRoleManagements ) {
                 if ("N".equals(sys.getEnabled_flag())) {
                     sys.set__status("delete");
                 }else{
                     sys.set__status("add");
                 }
             }

    	     List<SysRoleManagement> datas = sys.batchUpdate(iRequest, sysRoleManagements);
    	     rd = new ResponseData(datas);
		} catch (Exception e) {
			// TODO: handle exception
			rd = new ResponseData(false);
			rd.setMessage("一个角色不可分配重复的模块");
		}
    	
       
        return rd;
    }

    @RequestMapping(value = "/SysRoleModule/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<SysRoleManagement> sysRoleManagement) {
    	sys.batchDelete(sysRoleManagement);
        return new ResponseData();
    }
    @RequestMapping("/SysRoleModule/copy")
    @ResponseBody
    public ResponseData sysRoleCopy(HttpServletRequest request,String role_code,Long keyId,
            @RequestParam(defaultValue = DEFAULT_PAGE) int page,
            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {
    	IRequest iRequest = createRequestContext(request);
    	SysRoleManagement srm = new SysRoleManagement();
    	srm.setRole_id(keyId);
    	List<SysRoleManagement> data = sys.select(iRequest, srm, page, pagesize);
    	
    	for (SysRoleManagement sysdata : data) {
			sysdata.setRole_id(sys.selectRoleId(role_code));
			sysdata.set__status(DTOStatus.ADD);
		}
    	sys.deleteSysrole(sys.selectRoleId(role_code));
    	System.out.println(data.get(0).getModule_code());
    	List<SysRoleManagement> datas = sys.batchUpdate(iRequest, data);
    	return new ResponseData(datas);
    }
    
    /**
     * 主界面菜单数据获取.
     *
     * @param request
     *            HttpServletRequest
     * @return object
     */
    @RequestMapping("/SysRoleModule/menus")
    @ResponseBody
    public Object getMenuTree(HttpServletRequest request,SysRoleManagement sysRoleManagement) {
        return sys.selectRoleModules(createRequestContext(request),sysRoleManagement);
    }

}
