package hls.core.sys.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.sys.dto.SysRoleModuleExcludeFunc;
import hls.core.sys.service.ISysRoleModuleExcludeFuncService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import org.springframework.validation.BindingResult;
import java.util.List;

    @Controller
    public class SysRoleModuleExcludeFuncController extends BaseController{

    @Autowired
    private ISysRoleModuleExcludeFuncService service;


    @RequestMapping(value = "/sys/role/module/exclude/func/query")
    @ResponseBody
    public ResponseData query(SysRoleModuleExcludeFunc dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/sys/role/module/exclude/func/submit")
    @ResponseBody
public ResponseData update(@RequestBody List<SysRoleModuleExcludeFunc> dto, BindingResult result, HttpServletRequest request){
getValidator().validate(dto, result);
if (result.hasErrors()) {
ResponseData responseData = new ResponseData(false);
responseData.setMessage(getErrorMessage(result, request));
return responseData;
}
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/sys/role/module/exclude/func/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<SysRoleModuleExcludeFunc> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }