package hls.core.sys.controllers;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import hls.core.fnd.dto.HlsEmployee;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.fnd.dto.FndCompany;
import hls.core.fnd.dto.HLSOrgUnit;
import hls.core.fnd.dto.HLSPosition;
import hls.core.fnd.service.HLSIEmployeeService;
import hls.core.fnd.service.HLSIOrgUnitService;
import hls.core.fnd.service.HLSIPositionService;
import hls.core.fnd.service.IFirmDefineService;
import hls.core.sys.dto.SysRole;
import hls.core.sys.dto.SysUserAllocation;
import hls.core.sys.service.SysRoleService;
import hls.core.sys.service.SysUserAllocationService;

/**
 * Created by hailor on 16/6/2.
 */
@Controller
public class SysUserAllocationController  extends BaseController{
	
	@Autowired
	private SysUserAllocationService service;
    
	@Autowired
	private SysUserAllocationService allocationService;
	
	@Autowired
	private HLSIEmployeeService employeeService;
	@Autowired
	private HLSIOrgUnitService orgUnitService;
	@Autowired
	private HLSIPositionService positionService;
	@Autowired
	private IFirmDefineService firmDefineService;
	@Autowired
	private SysRoleService sysRoleService;
	@RequestMapping(value = "/sys/allocation/query")
	@ResponseBody
	public ResponseData query(HttpServletRequest request, SysUserAllocation sysUserAllocation,
			@RequestParam(defaultValue = DEFAULT_PAGE) int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {

	     IRequest iRequest = createRequestContext(request);
	        List<SysUserAllocation> datas = service.select(iRequest, sysUserAllocation, page, pagesize);
	        return new ResponseData(datas);
	}

	@SuppressWarnings("finally")
	@RequestMapping(value = "/sys/allocation/submit")
	@ResponseBody
	public ResponseData update(HttpServletRequest request,
			@RequestBody List<SysUserAllocation> list,BindingResult result){
		/*getValidator().validate(list, result);
		if (result.hasErrors()) {
			 ResponseData rd = new ResponseData(false);
	         rd.setMessage("重复定义用户,请核对您的数据");
	         return rd;
		}else{
			IRequest iRequest = createRequestContext(request);
			for (SysUserAllocation sysUserAllocation : list) {
			   sysUserAllocation = this.getAllocation(iRequest, sysUserAllocation);
			}
			List<SysUserAllocation> lists = service.batchUpdate(iRequest, list);
			return new ResponseData(lists);
		}*/
		ResponseData rd = null;
		try {
			IRequest iRequest = createRequestContext(request);
/*			for (SysUserAllocation sysUserAllocation : list) {
			   sysUserAllocation = this.getAllocation(iRequest, sysUserAllocation);
			}*/
			List<SysUserAllocation> lists = service.batchUpdate(iRequest, list);
			rd = new ResponseData(lists);
		} catch (Exception e) {
			// TODO: handle exception
			rd = new ResponseData(false);
	        rd.setMessage("重复定义,请核对您的数据");
	        
		}finally {
			return rd;
		}
		
	}
	
private SysUserAllocation getAllocation(IRequest iRequest, SysUserAllocation allocation) {
		
		FndCompany company = new FndCompany();
		company.setCompany_code(allocation.getCompanyCode());
		company.setCompany_full_name(allocation.getCompanyFullName());
		List<FndCompany> companyList = firmDefineService.select(iRequest, company, 1, 10);
		Long cpId = null;
		if (companyList!=null) {
			cpId = companyList.get(0).getCompany_id();
		}
		
		HlsEmployee employee = new HlsEmployee();
		employee.setEmployeeCode(allocation.getEmployeeCode());
		
		HLSOrgUnit orgUnit = new HLSOrgUnit();
		orgUnit.setUnitCode(allocation.getUnitCode());
		orgUnit.setCompanyId(cpId);
		List<HLSOrgUnit> orgUnitList = orgUnitService.select(iRequest, orgUnit, 1, 10);
		Long UnId = null;
		if (orgUnitList!=null) {
			UnId = orgUnitList.get(0).getUnitId();
		}
		
		HLSPosition position = new HLSPosition();
		position.setPositionCode(allocation.getPositionCode());
		position.setUnit_id(UnId);
		
		SysRole sysRole = new SysRole();
		sysRole.setRole_code(allocation.getRoleCode());
		

		List<HLSPosition> positionList = positionService.select(iRequest, position, 1, 10);
		List<SysRole> sysRoleList = sysRoleService.select(iRequest, sysRole, 1, 10);
		

		 employee.setCompanyId(cpId);
		List<HlsEmployee> employeeList = employeeService.select(iRequest, employee, 1, 10);
		if(allocation.getEmployeeCode() != null && employeeList.size() ==1 && positionList != null)
		{
			Long  employeeAssignId = allocationService.selectEmployeeAssignId(companyList.get(0).getCompany_id(),
					employeeList.get(0).getEmployeeId(),orgUnitList.get(0).getUnitId(),
					positionList.get(0).getPositionId());
			
			allocation.setCompanyId(companyList.get(0).getCompany_id());
			allocation.setEmployeeAssignId(employeeAssignId);
		}
		
		if(allocation.getRoleCode() !=null && sysRoleList.size() ==1)
		{
			allocation.setRoleId(sysRoleList.get(0).getRole_id());
		}
		
		return allocation;
	}

     
	@RequestMapping(value = "/sys/allocation/remove")
	@ResponseBody
	public ResponseData delete(HttpServletRequest request,
			@RequestBody List<SysUserAllocation> list) {
		
		service.batchDelete(list);
		return new ResponseData();
	}
	
	@RequestMapping(value = "/hlssys/assign/query")
	@ResponseBody
	public ResponseData assignQuery() {
		
		return new ResponseData(service.assignQuery());
	}
	
	@RequestMapping(value = "/allocation/edit/query")
	@ResponseBody
	public ResponseData editQuery(Long userId,Long allocationId) {
		List<SysUserAllocation> list = service.editQuery(userId,allocationId);
		for (int i = 0; i < list.size(); i++) {
			SysUserAllocation sys = list.get(i);
			if(sys.getUnitName()!=null||sys.getPositionName()!=null){
				list.get(i).setUnit_position(sys.getUnitName()+"-"+sys.getPositionName()+"-"+sys.getName());
			}
		}
		return new ResponseData(list);
	}
}
