package hls.core.sys.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.fnd.dto.PrjMeetingJudge;
import hls.core.sys.dto.SysUserAuthorityRule;
import hls.core.sys.service.SysUserAuthorityRuleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created by 罗宇娟 on 2017/5/15.
 */
@Controller
public class SysUserAuthorityRuleController extends BaseController{

    @Autowired
    private SysUserAuthorityRuleService sysService;
    @RequestMapping("/fnd/authority/query")
    @ResponseBody
    public ResponseData selectAuthorityList(HttpServletRequest request,final SysUserAuthorityRule sysUserAuthorityRule, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                     @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize){
        IRequest iRequest = createRequestContext(request);
//       List<SysUserAuthorityRule> datas = sysService.select(iRequest,sysUserAuthorityRule,page,pagesize);
        List<SysUserAuthorityRule> datas = sysService.selectList(iRequest,sysUserAuthorityRule,page,pagesize);
        return new ResponseData(datas);
    }

    @RequestMapping("/fnd/authority/submit")
    @ResponseBody
    public ResponseData submit(HttpServletRequest request, @RequestBody List<SysUserAuthorityRule> sysUserAuthorityRule){
        IRequest iRequest = createRequestContext(request);
        return sysService.saveSysUserAuthorityRules(sysUserAuthorityRule, iRequest);
    }

    @RequestMapping(value = "/fnd/authority/delete", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<SysUserAuthorityRule> sysUserAuthorityRule) {
        sysService.batchDelete(sysUserAuthorityRule);

        return new ResponseData();
    }
}
