package hls.core.sys.controllers;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import hls.core.fnd.dto.HlsEmployee;
import hls.core.hls.dto.HlsSystemNotice;
import hls.core.hls.dto.HlsUserRelationship;
import hls.core.hls.service.IHlsUserRelationshipService;
import hls.core.sys.event.service.SysNoticePushService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.DTOStatus;
import com.hand.hap.system.dto.ResponseData;

import hls.core.fnd.dto.FndCompany;
import hls.core.fnd.dto.HLSOrgUnit;
import hls.core.fnd.dto.HLSPosition;
import hls.core.fnd.service.HLSIEmployeeService;
import hls.core.fnd.service.HLSIOrgUnitService;
import hls.core.fnd.service.HLSIPositionService;
import hls.core.fnd.service.IFirmDefineService;
import hls.core.sys.dto.SysRole;
import hls.core.sys.dto.SysUser;
import hls.core.sys.dto.SysUserAllocation;
import hls.core.sys.service.SysRoleService;
import hls.core.sys.service.SysUserAllocationService;
import hls.core.sys.service.SysUserService;

/**
 * Created by hailor on 16/6/2.
 */
@Controller
public class SysUserController  extends BaseController{
	
	@Autowired
	private SysUserService service;
	@Autowired
	private SysUserAllocationService allocationService;
	@Autowired
	private HLSIEmployeeService employeeService;
	@Autowired
	private HLSIOrgUnitService orgUnitService;
	@Autowired
	private HLSIPositionService positionService;
	@Autowired
	private IFirmDefineService firmDefineService;
	@Autowired
	private SysRoleService sysRoleService;
	@Autowired
	private SysNoticePushService SysNoticePushService;
	@Autowired
	private IHlsUserRelationshipService iHlsUserRelationshipService;
	

	@RequestMapping(value = "/hlssys/query")
	@ResponseBody
	public ResponseData query(HttpServletRequest request, SysUser sysUser,
			@RequestParam(defaultValue = DEFAULT_PAGE) int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {

	     IRequest iRequest = createRequestContext(request);
	        List<SysUser> datas = service.select(iRequest, sysUser, page, pagesize);
		/*sysUser.setUserId(iRequest.getUserId());
		List<SysUser> datas = service.selectList(sysUser);*/
	        return new ResponseData(datas);
	}

	/*---------用户查询--------*/
	@RequestMapping(value = "/hlssys/userQuery")
	@ResponseBody
	public ResponseData userQuery(HttpServletRequest request, SysUser sysUser,
							  @RequestParam(defaultValue = DEFAULT_PAGE) int page,
							  @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pagesize) {

		IRequest iRequest = createRequestContext(request);
		List<SysUser> datas = service.userQuery(iRequest, sysUser, page, pagesize);
		return new ResponseData(datas);
	}

	class DescriptionException extends Exception {}

	@RequestMapping(value = "/hlssys/submit")
	@ResponseBody
	public ResponseData update(HttpServletRequest request,@RequestBody List<SysUser> list) throws DescriptionException{
		ResponseData rd = null;
		try {
			IRequest iRequest = createRequestContext(request);
			for(int i=0; i<list.size(); i++){
				if(list.get(i).getDescription()==null){
					throw new DescriptionException();//抛出异常
				}
			}
			List<SysUser> datas = service.batchUpdate(iRequest, list);
			
			rd = new ResponseData(datas);
		}catch (DescriptionException e2){
			rd = new ResponseData(false);

			rd.setMessage("描述为必输项");
		} catch (Exception e) {
			// TODO: handle exception
		    rd = new ResponseData(false);
		    
		    rd.setMessage("账户不可重复，请重新输入");
		}
		return rd;
	}


	private SysUserAllocation getAllocation(IRequest iRequest, SysUserAllocation allocation) {
		
		FndCompany company = new FndCompany();
		company.setCompany_code(allocation.getCompanyCode());
		company.setCompany_full_name(allocation.getCompanyFullName());
		List<FndCompany> companyList = firmDefineService.select(iRequest, company, 1, 10);
		Long cpId = null;
		if (companyList!=null) {
			cpId = companyList.get(0).getCompany_id();
		}
		
		HlsEmployee employee = new HlsEmployee();
		employee.setEmployeeCode(allocation.getEmployeeCode());
		
		HLSOrgUnit orgUnit = new HLSOrgUnit();
		orgUnit.setUnitCode(allocation.getUnitCode());
		orgUnit.setCompanyId(cpId);
		List<HLSOrgUnit> orgUnitList = orgUnitService.select(iRequest, orgUnit, 1, 10);
		Long UnId = null;
		if (orgUnitList!=null) {
			UnId = orgUnitList.get(0).getUnitId();
		}
		
		HLSPosition position = new HLSPosition();
		position.setPositionCode(allocation.getPositionCode());
		position.setUnit_id(UnId);
		
		SysRole sysRole = new SysRole();
		sysRole.setRole_code(allocation.getRoleCode());
		

		List<HLSPosition> positionList = positionService.select(iRequest, position, 1, 10);
		List<SysRole> sysRoleList = sysRoleService.select(iRequest, sysRole, 1, 10);
		

		 employee.setCompanyId(cpId);
		List<HlsEmployee> employeeList = employeeService.select(iRequest, employee, 1, 10);
		if(allocation.getEmployeeCode() != null && employeeList.size() ==1 && positionList != null)
		{
			Long  employeeAssignId = allocationService.selectEmployeeAssignId(companyList.get(0).getCompany_id(),
					employeeList.get(0).getEmployeeId(),orgUnitList.get(0).getUnitId(),
					positionList.get(0).getPositionId());
			
			allocation.setCompanyId(companyList.get(0).getCompany_id());
			allocation.setEmployeeAssignId(employeeAssignId);
		}
		
		if(allocation.getRoleCode() !=null && sysRoleList.size() ==1)
		{
			allocation.setRoleId(sysRoleList.get(0).getRole_id());
		}
		
		return allocation;
	}

	@RequestMapping(value = "/hlssys/remove")
	@ResponseBody
	@Transactional
	public ResponseData delete(HttpServletRequest request,
			@RequestBody List<SysUser> list) {
		for (SysUser sysUser : list) {
			if (sysUser.getUserId()!=null) {
                 service.deleteChildByUserId(sysUser.getUserId());
			}		
		}
		service.batchDelete(list);
		
		return new ResponseData();
	}
	
	@RequestMapping(value = "/hlssys/edit/query")
	@ResponseBody
	public ResponseData selectEdit(Long userId) {
		return new ResponseData(service.selectEdit(userId));
	}
     
	@RequestMapping(value = "/hlssys/submitHL")
	@ResponseBody
	@Transactional
	public ResponseData updateHL(HttpServletRequest request,@RequestBody List<SysUser> sysUser) {
		IRequest iRequest = createRequestContext(request);

		List<SysUserAllocation> allocations = new ArrayList<SysUserAllocation>();
		for (SysUser list : sysUser) {
			if(list.getSysUserAllocation() != null)
			{

				for(SysUserAllocation allocation:list.getSysUserAllocation())
				{
					SysUserAllocation sysAllocation = getAllocation(iRequest,allocation);
					sysAllocation.set__status(DTOStatus.ADD);
					allocations.add(sysAllocation);
				}
			}


		}
		sysUser.get(0).set__status(DTOStatus.ADD);
		service.batchChildUpdate(iRequest, sysUser.get(0) ,allocations);

		return new ResponseData(sysUser);
	}

	/**
	 * User:Jeffery
	 * Time:20170512
	 * Conttent:查询所有好友
	 * @param request
	 * @param page
	 * @param pagesize
	 * @return
	 */
	@RequestMapping(value = "/hls/user/friends/query")
	@ResponseBody
	public ResponseData queryAllFriends(final SysUser user, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
										@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		user.setUserId(requestContext.getUserId());
		List<SysUser> list = service.selectUserFriends(user);
		return new ResponseData(list);
	}

	/**
	 * User:Jeffery
	 * Time:20170515
	 * Conttent:查询所有用户
	 * @param request
	 * @param page
	 * @param pagesize
	 * @return
	 */
	@RequestMapping(value = "/hls/user/person/query")
	@ResponseBody
	public ResponseData queryAllPerson(final SysUser user, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
										@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(service.selectAllPerson(user));
	}

    /**
	 * User:Jeffery
	 * Time:20170516
	 * Conttent:实时弹出框
	 * @param request
	 * @param page
	 * @param pagesize
	 * @return
	 * */

	@RequestMapping(value = "/hls/user/send/notice")
	@ResponseBody
	public List<HlsSystemNotice> getSendNotice(final HlsSystemNotice hsn, @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
									   @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		List<HlsSystemNotice> list = SysNoticePushService.getUserNotice(requestContext.getUserId());
		return list;
	}

	/**
	 * User:Jeffery
	 * Time:201708131944
	 * Conttent:分享给好友
	 * @param request
	 * @return
	 * */

	@RequestMapping(value = "/hls/add/share/friend")
	@ResponseBody
	public ResponseData addShare(final HlsUserRelationship hlsUserRelationship, final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		List<HlsUserRelationship> addShareList = new ArrayList<>();
		List<String> friendsList = hlsUserRelationship.getFriendsList();
		for(int i=1;i<friendsList.size();i++){
			HlsUserRelationship hur = new HlsUserRelationship();
			hur.setRelationDocumentId(Long.parseLong(friendsList.get(0)));
			hur.setSourceEvent("RPT_REPORT_SHARE");
			hur.setRelationDocumentCategory("REPORT_DTL");
			hur.setRelationType("P2D");
			hur.setSourceModule("RPT");
			hur.setUserId(Long.parseLong(friendsList.get(i)));
			List<HlsUserRelationship> hurList = iHlsUserRelationshipService.queryDetailByreportIdAndUserId(hur);
			if(hurList==null || hurList.size()==0){
				hur.set__status("add");
				addShareList.add(hur);
			}
		}
		try {
			addShareList = iHlsUserRelationshipService.batchUpdate(requestContext,addShareList);
		}catch (Exception e){

		}
		return new ResponseData(addShareList);
	}
}
