package hls.core.sys.controllers;

import hls.core.sys.dto.HlsCusSysUserVisitHistory;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.sys.dto.SysUserVisitHistory;
import hls.core.sys.service.ISysUserVisitHistoryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

import org.springframework.validation.BindingResult;

import java.util.List;

@Controller
public class SysUserVisitHistoryController extends BaseController {

    @Autowired
    private ISysUserVisitHistoryService service;


    @RequestMapping(value = "/sys/user/visit/history/query")
    @ResponseBody
    public ResponseData query(HlsCusSysUserVisitHistory dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/sys/user/visit/history/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<HlsCusSysUserVisitHistory> dto, BindingResult result, HttpServletRequest request) {
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/sys/user/visit/history/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<HlsCusSysUserVisitHistory> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }

    /*查询最常访问的模块*/
    @RequestMapping(value = "/sys/user/visit/history/queryMostVisitModule")
    @ResponseBody
    public ResponseData queryMostVisitModule(HlsCusSysUserVisitHistory dto,HttpServletRequest request, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                             @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.queryMostVisitModule(requestContext, dto,page,pageSize));
    }
    /*查询最近访问的单据*/
    @RequestMapping(value = "/sys/user/visit/history/queryRecentVisitDoc")
    @ResponseBody
    public ResponseData queryRecentVisitDoc(HlsCusSysUserVisitHistory dto,HttpServletRequest request, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                                            @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize){
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.queryRecentVisitDoc(requestContext, dto,page,pageSize));
    }
}