package hls.core.sys.dto;

import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.validation.constraints.NotNull;

import com.hand.hap.mybatis.annotation.Condition;
import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;

@ExtensionAttribute(disable=true)
@Table(name = "sys_module")
public class SysModule extends BaseDTO {
	
	public Long getResourceId() {
		return resourceId;
	}

	public void setResourceId(Long resourceId) {
		this.resourceId = resourceId;
	}

	@Id
	@Condition(operator = LIKE)
    private String moduleCode;

	@NotNull
	@Condition(operator = LIKE)
    private String moduleName;
	
	private String moduleDescription;

    private String enabledFlag;

	private String moduleSerialNumber;

	private Long homepageResourceId;
    
    private String moduleIcon;

	private String backgroundColor;

	private String openMode;




	public String getModuleDescription() {
		return moduleDescription;
	}

	public void setModuleDescription(String moduleDescription) {
		this.moduleDescription = moduleDescription;
	}

	public String getModuleIcon() {
		return moduleIcon;
	}

	public void setModuleIcon(String moduleIcon) {
		this.moduleIcon = moduleIcon;
	}


	@Transient
    private String homepageResourceName;
    
    @Transient
    private Long resourceId;
	@Condition(operator = LIKE)
    @Transient
    private String url;
	@Condition(operator = LIKE)
    @Transient
    private String name;

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getHomepageResourceName() {
		return homepageResourceName;
	}

	public void setHomepageResourceName(String homepageResourceName) {
		this.homepageResourceName = homepageResourceName;
	}

	public String getModuleCode() {
		return moduleCode;
	}

	public void setModuleCode(String moduleCode) {
		this.moduleCode = moduleCode;
	}

	public String getModuleName() {
		return moduleName;
	}

	public void setModuleName(String moduleName) {
		this.moduleName = moduleName;
	}

	public String getEnabledFlag() {
		return enabledFlag;
	}

	public void setEnabledFlag(String enabledFlag) {
		this.enabledFlag = enabledFlag;
	}

	public Long getHomepageResourceId() {
		return homepageResourceId;
	}

	public void setHomepageResourceId(Long homepageResourceId) {
		this.homepageResourceId = homepageResourceId;
	}

	public String getBackgroundColor() {
		return backgroundColor;
	}

	public void setBackgroundColor(String backgroundColor) {
		this.backgroundColor = backgroundColor;
	}


	public String getModuleSerialNumber() {
		return moduleSerialNumber;
	}

	public void setModuleSerialNumber(String moduleSerialNumber) {
		this.moduleSerialNumber = moduleSerialNumber;
	}

	public String getOpenMode() {
		return openMode;
	}

	public void setOpenMode(String openMode) {
		this.openMode = openMode;
	}
}