package hls.core.sys.dto;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.hand.hap.core.annotation.Children;
import com.hand.hap.mybatis.annotation.Condition;
import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;

@SuppressWarnings("serial")
@ExtensionAttribute(disable=true)
@Table(name="sys_role_b")
public class SysRole extends BaseDTO implements Serializable{
	@Id
	@GeneratedValue
	private Long role_id;
	@Id
	@Condition(operator = LIKE)
	private String role_code;
	@Condition(operator = LIKE)
	private String role_name;
	private Date start_active_date;
	private Date end_active_date;
	@Transient
	private String queryCondition;

	@Transient
	private String queryFlag;  //查询标志位，标记精确查询与模糊查询

	public String getQueryCondition() {
		return queryCondition;
	}

	public void setQueryCondition(String queryCondition) {
		this.queryCondition = queryCondition;
	}

	
	@Children
    @Transient
    private List<SysRoleManagement> sysRoleManagements;
	
	public Date getStart_active_date() {
		return start_active_date;
	}
	public List<SysRoleManagement> getSysRoleManagements() {
		return sysRoleManagements;
	}
	public void setSysRoleManagements(List<SysRoleManagement> sysRoleManagements) {
		this.sysRoleManagements = sysRoleManagements;
	}
	public void setStart_active_date(Date start_active_date) {
		this.start_active_date = start_active_date;
	}
	public Date getEnd_active_date() {
		return end_active_date;
	}
	public void setEnd_active_date(Date end_active_date) {
		this.end_active_date = end_active_date;
	}
	public Long getRole_id() {
		return role_id;
	}
	public void setRole_id(Long role_id) {
		this.role_id = role_id;
	}
	public String getRole_code() {
		return role_code;
	}
	public void setRole_code(String role_code) {
		this.role_code = role_code;
	}
	public String getRole_name() {
		return role_name;
	}
	public void setRole_name(String role_name) {
		this.role_name = role_name;
	}

	public String getQueryFlag() {
		return queryFlag;
	}

	public void setQueryFlag(String queryFlag) {
		this.queryFlag = queryFlag;
	}
}
