package hls.core.sys.dto;

import java.util.Date;
import java.util.List;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.hand.hap.core.annotation.Children;
import com.hand.hap.mybatis.annotation.Condition;
import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;

@ExtensionAttribute(disable=true)
@Table(name = "sys_user")
public class SysUser extends BaseDTO{
	
	@Id
	@GeneratedValue
    private Long userId;
	
	private Long userType;

    @Condition(operator = LIKE)
	private String userName;
    @Condition(operator = LIKE)
	private String description;

	private String passwordEncrypted;

    private String email;

    private String phone;

    private Date startActiveDate;

    private Date endActiveDate;

    private String status;
    
    @Transient
    private String password;

	private String frozenFlag;

    private Date frozenDate;

    private String passwordLifespanType;

    private Long passwordLifespanDays;

    private Long passwordLifespanTimes;

    private Date lastLoginDate;

    private Date lastPasswordUpdateDate;
    @Transient
    private String companyFullName;
    @Transient
    private String positionName;
    @Transient
    private String unitName;
    @Transient
    private Long relationId;
    @Transient
    private Long relationUserId;
    @Transient
    private String userDescrip;

    public String getUserDescrip() {
        return userDescrip;
    }

    public void setUserDescrip(String userDescrip) {
        this.userDescrip = userDescrip;
    }

    public Long getRelationUserId() {
        return relationUserId;
    }

    public void setRelationUserId(Long relationUserId) {
        this.relationUserId = relationUserId;
    }

    public Long getRelationId() {
        return relationId;
    }

    public void setRelationId(Long relationId) {
        this.relationId = relationId;
    }

    public String getCompanyFullName() {
        return companyFullName;
    }

    public void setCompanyFullName(String companyFullName) {
        this.companyFullName = companyFullName;
    }

    public String getPositionName() {
        return positionName;
    }

    public void setPositionName(String positionName) {
        this.positionName = positionName;
    }

    public String getUnitName() {
        return unitName;
    }

    public void setUnitName(String unitName) {
        this.unitName = unitName;
    }

    @Transient
    private String queryCondition;
    public String getQueryCondition() {
        return queryCondition;
    }

    public void setQueryCondition(String queryCondition) {
        this.queryCondition = queryCondition== null ? null: queryCondition.trim();
    }
    
   @Transient
    @Children
    List<SysUserAllocation> sysUserAllocation ;

    public List<SysUserAllocation> getSysUserAllocation() {
		return sysUserAllocation;
	}

	public void setSysUserAllocation(List<SysUserAllocation> sysUserAllocation) {
		this.sysUserAllocation = sysUserAllocation;
	} 

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}
	
    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName == null ? null : userName.trim();
    }

    public String getPasswordEncrypted() {
        return passwordEncrypted;
    }

    public void setPasswordEncrypted(String passwordEncrypted) {
        this.passwordEncrypted = passwordEncrypted == null ? null : passwordEncrypted.trim();
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email == null ? null : email.trim();
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone == null ? null : phone.trim();
    }

    public Date getStartActiveDate() {
        return startActiveDate;
    }

    public void setStartActiveDate(Date startActiveDate) {
        this.startActiveDate = startActiveDate;
    }

    public Date getEndActiveDate() {
        return endActiveDate;
    }

    public void setEndActiveDate(Date endActiveDate) {
        this.endActiveDate = endActiveDate;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status == null ? null : status.trim();
    }

    public String getFrozenFlag() {
        return frozenFlag;
    }

    public void setFrozenFlag(String frozenFlag) {
        this.frozenFlag = frozenFlag == null ? null : frozenFlag.trim();
    }



    public String getPasswordLifespanType() {
        return passwordLifespanType;
    }

    public void setPasswordLifespanType(String passwordLifespanType) {
        this.passwordLifespanType = passwordLifespanType == null ? null : passwordLifespanType.trim();
    }

    public Long getPasswordLifespanDays() {
        return passwordLifespanDays;
    }

    public void setPasswordLifespanDays(Long passwordLifespanDays) {
        this.passwordLifespanDays = passwordLifespanDays;
    }

    public Long getPasswordLifespanTimes() {
        return passwordLifespanTimes;
    }

    public void setPasswordLifespanTimes(Long passwordLifespanTimes) {
        this.passwordLifespanTimes = passwordLifespanTimes;
    }

    public Date getLastLoginDate() {
        return lastLoginDate;
    }

    public void setLastLoginDate(Date lastLoginDate) {
        this.lastLoginDate = lastLoginDate;
    }

    public Date getLastPasswordUpdateDate() {
        return lastPasswordUpdateDate;
    }

    public void setLastPasswordUpdateDate(Date lastPasswordUpdateDate) {
        this.lastPasswordUpdateDate = lastPasswordUpdateDate;
    }
    public Long getUserType() {
		return userType;
	}

	public void setUserType(Long userType) {
		this.userType = userType;
	}
	
    public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public Date getFrozenDate() {
		return frozenDate;
	}

	public void setFrozenDate(Date frozenDate) {
		this.frozenDate = frozenDate;
	}
}