package hls.core.sys.dto;

import java.util.Date;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.hand.hap.account.service.IRole;
import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;

@ExtensionAttribute(disable=true)
@Table(name = "sys_user_allocation")
public class SysUserAllocation extends BaseDTO implements IRole {
	
	public static final String FIELD_ALLOCATION_ID = "allocationId";
	public static final String FIELD_ROLE_ID = "roleId";
	public static final String FIELD_ROLE_NAME = "roleName";
	public static final String FIELD_COMPANY_NAME = "companyName";
	public static final String FIELD_EMAIL = "email";
	public static final String FIELD_COMPANY_ID = "companyId";
	public static final String FIELD_POSITION_ID = "positionId";
	public static final String FIELD_UNIT_ID = "unitId";
	public static final String FIELD_EMPLOYEEASSIGNID = "employeeAssignId";
	public static final String FIELD_EMPLOYEENAME = "employeeName";
	public static final String FIELD_POSITIONNAME = "positionName";
	public static final String FIELD_POSITIONCODE = "positionCode";
	public static final String FIELD_UNITCODE = "unitCode";
	public static final String FIELD_UNITNAME = "unitName";
	public static final String SYS_DATE = "sysDate";
	public static final String DESCRIPTION = "description";
	@Id
	@GeneratedValue
    private Long allocationId;

    private Long roleId;

    private Long userId;

    private Long companyId;

    private Long employeeAssignId;

    private Date validDateFrom;

    private Date validDateTo;
    
    private String enabledFlag;
    
	@Transient
	private String companyCode ;
    @Transient
    private String companyFullName ;
    @Transient
	private  String companyShortName;
    @Transient
    private String roleCode ;
    @Transient
    private String roleName ;
    @Transient
    private String unitId ;
    @Transient
    private String unitCode ;
    @Transient
    private String unitName ;
    @Transient
    private String positionId ;
    @Transient
    private String positionCode ;
    @Transient
    private String positionName ;
    @Transient
    private String employeeId ;
    @Transient
    private String employeeCode ;
	@Transient
	private String name ;
	@Transient
	private String unit_position;
	@Transient
	private String email;

	public String getSysDate() {
		return sysDate;
	}

	public void setSysDate(String sysDate) {
		this.sysDate = sysDate;
	}

	@Transient
	private String sysDate;
    
    public String getEnabledFlag() {
		return enabledFlag;
	}

	public String getUnitId() {
		return unitId;
	}

	public void setUnitId(String unitId) {
		this.unitId = unitId;
	}

	public String getPositionId() {
		return positionId;
	}

	public void setPositionId(String positionId) {
		this.positionId = positionId;
	}

	public String getEmployeeId() {
		return employeeId;
	}

	public void setEmployeeId(String employeeId) {
		this.employeeId = employeeId;
	}

	public void setEnabledFlag(String enabledFlag) {
		this.enabledFlag = enabledFlag;
	}
	
    public String getUnit_position() {
		return unit_position;
	}

	public void setUnit_position(String unit_position) {
		this.unit_position = unit_position;
	}

	public String getEmployeeCode() {
		return employeeCode;
	}

	public void setEmployeeCode(String employeeCode) {
		this.employeeCode = employeeCode;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

    public String getCompanyCode() {
		return companyCode;
	}

	public void setCompanyCode(String companyCode) {
		this.companyCode = companyCode;
	}

	public String getCompanyFullName() {
		return companyFullName;
	}

	public void setCompanyFullName(String companyFullName) {
		this.companyFullName = companyFullName;
	}

	public String getCompanyShortName() {
		return companyShortName;
	}

	public void setCompanyShortName(String companyShortName) {
		this.companyShortName = companyShortName;
	}

	public String getRoleCode() {
		return roleCode;
	}

	public void setRoleCode(String roleCode) {
		this.roleCode = roleCode;
	}

	public String getRoleName() {
		return roleName;
	}

	public void setRoleName(String roleName) {
		this.roleName = roleName;
	}

	public String getUnitCode() {
		return unitCode;
	}

	public void setUnitCode(String unitCode) {
		this.unitCode = unitCode;
	}

	public String getUnitName() {
		return unitName;
	}

	public void setUnitName(String unitName) {
		this.unitName = unitName;
	}

	public String getPositionCode() {
		return positionCode;
	}

	public void setPositionCode(String positionCode) {
		this.positionCode = positionCode;
	}

	public String getPositionName() {
		return positionName;
	}

	public void setPositionName(String positionName) {
		this.positionName = positionName;
	}

	public Long getAllocationId() {
        return allocationId;
    }

    public void setAllocationId(Long allocationId) {
        this.allocationId = allocationId;
    }

    public Long getRoleId() {
        return roleId;
    }

    public void setRoleId(Long roleId) {
        this.roleId = roleId;
    }

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public Long getCompanyId() {
        return companyId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public Long getEmployeeAssignId() {
		return employeeAssignId;
	}

	public void setEmployeeAssignId(Long employeeAssignId) {
		this.employeeAssignId = employeeAssignId;
	}

	public Date getValidDateFrom() {
        return validDateFrom;
    }

    public void setValidDateFrom(Date validDateFrom) {
        this.validDateFrom = validDateFrom;
    }

    public Date getValidDateTo() {
        return validDateTo;
    }

    public void setValidDateTo(Date validDateTo) {
        this.validDateTo = validDateTo;
    }

	@Override
	public boolean isActive() {
		// TODO Auto-generated method stub
		return true;
	}

	@Override
	public boolean isEnabled() {
		// TODO Auto-generated method stub
		return true;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}
}