package hls.core.sys.event.service.impl;

import com.hand.hap.core.IRequest;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.service.ConContractService;
import hls.core.csh.dto.HlsCusConContractCashflow;
import hls.core.csh.dto.HlsCusCshPaymentReqLn;
import hls.core.csh.service.IConContractCashflowService;
import hls.core.csh.service.ICshPaymentReqLnService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventCommonService;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

/**
 * Created by Administrator on 2017/4/19.
 */
@Service
@Transactional
public class CshPaymentReqEventServiceImpl implements SysEventCommonService {
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private SysUserService userService;
    @Autowired
    private ICshPaymentReqLnService iCshPaymentReqLnService;
    @Autowired
    private ConContractService conContractService;
    @Autowired
    private IConContractCashflowService conContractCashflowService;

    private static final String documentCategory = "CSH_PAYMENT_REQ";
    private static String sourceModule = "CSH";
    private static String eventCode = "WFL.TO_DO";
    private static String RelationType = "P2D";

    @Override
    public String getDocumentCategory() {
        return documentCategory;
    }

    @Override
    public String getEventCode() {
        return eventCode;
    }

    @Override
    public void process(IRequest iRequest,Long documentId,String documentCategory,String documentType,Map<String,Object> params) {
        sysEventService.eventSave(iRequest,documentId,documentCategory,documentType,sourceModule,eventCode,RelationType,params);
    }

    @Override
    public void notice(DelegateExecution delegateExecution, String status) {
        IRequest iRequest = (IRequest)delegateExecution.getVariable("iRequest");
        String documentCategory = (String)delegateExecution.getVariable("documentCategory");
        Long documentId = (Long)delegateExecution.getVariable("documentId");
        String startUserName = (String)delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(startUserName);
        String  pName = (String)delegateExecution.getVariable("pName");
        HlsCusCshPaymentReqLn cshPaymentReqLn = (HlsCusCshPaymentReqLn)delegateExecution.getVariable("cshPaymentReqLn");
        List<HlsCusConContractCashflow> conContractCashflowlist = new ArrayList<>();
        if(("CON_CONTRACT").equals(cshPaymentReqLn.getSource_doc_category())){
            conContractCashflowlist = conContractCashflowService.queryConContratCashFlowById(cshPaymentReqLn.getSource_doc_line_id());
        }
        HlsCusConContract conContract = conContractService.squerConContractById(cshPaymentReqLn.getSource_doc_id());
        String noticeEventCode = "";
        Map<String,Object> params = new HashMap<String,Object>();
        params.put("noticeType","NOTICE");
        params.put("url","");
        params.put("level",2L);
        params.put("pName",pName);
        params.put("name",delegateExecution.getCurrentFlowElement().getName());

        if("START".equalsIgnoreCase(status))
        {
            noticeEventCode ="WFL.START";
            if(documentCategory.equals("CON_CONTRACT")){
                params.put("message",conContract.getContractName()+"第"+conContractCashflowlist.get(0).getTimes()+"期"+cshPaymentReqLn.getCf_item());
                params.put("noticeTitle",pName+"提交审批成功");
            }else {
                params.put("message",conContract.getContractName());
                params.put("noticeTitle",pName+"提交审批成功");
            }

        }else  if("APPROVE".equalsIgnoreCase(status)){
            noticeEventCode ="WFL.APPROVE";
            if(documentCategory.equals("CON_CONTRACT")){
                params.put("message",conContract.getContractName()+"第"+conContractCashflowlist.get(0).getTimes()+"期"+cshPaymentReqLn.getCf_item());
                params.put("noticeTitle",pName+"审批成功");
            }else {
                params.put("message",conContract.getContractName());
                params.put("noticeTitle",pName+"审批成功");
            }

        }else if("FINISH".equalsIgnoreCase(status)){
            noticeEventCode ="WFL_FINISH";
            if(documentCategory.equals("CON_CONTRACT")){
                params.put("message",conContract.getContractName()+"第"+conContractCashflowlist.get(0).getTimes()+"期"+cshPaymentReqLn.getCf_item());
                params.put("noticeTitle",pName+"审批完成");
            }else {
                params.put("message",conContract.getContractName());
                params.put("noticeTitle",pName+"审批完成");
            }

        }
        if(sysUser != null)
        {
            iRequest.setUserId(sysUser.getUserId());
        }
        sysEventService.eventSave(iRequest,documentId,documentCategory,"",sourceModule,noticeEventCode,RelationType,params);
    }
}
