package hls.core.sys.event.service.impl;

import com.hand.hap.core.IRequest;
import hls.core.fct.dto.HlsCusFctProject;
import hls.core.fct.service.FctProjectService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventCommonService;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by Administrator on 2017/4/24.
 */
@Service
@Transactional
public class FctProjectCreditEventServiceImpl implements SysEventCommonService {
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private SysUserService userService;

    @Autowired
    private FctProjectService fctProjectService;

    private static final String documentCategory = "FCT_PROJECT_CREDIT";
    private static String sourceModule = "FCT";
    private static String eventCode = "WFL.TO_DO";
    private static String RelationType = "P2D";

    @Override
    public String getDocumentCategory() {
        return documentCategory;
    }

    @Override
    public String getEventCode() {
        return null;
    }

    @Override
    public void process(IRequest iRequest, Long documentId, String documentCategory, String documentType, Map<String, Object> params) {
        documentCategory = "FCT_PROJECT";
        sysEventService.eventSave(iRequest,documentId,documentCategory,documentType,sourceModule,eventCode,RelationType,params);
    }

    @Override
    public void notice(DelegateExecution delegateExecution, String status) {
        IRequest iRequest = (IRequest)delegateExecution.getVariable("iRequest");
        String documentCategory = (String)delegateExecution.getVariable("documentCategory");
        Long documentId = (Long)delegateExecution.getVariable("documentId");
        Long projectId = (Long)delegateExecution.getVariable("projectId");
        String startUserName = (String)delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(startUserName);
        HlsCusFctProject prjProject = new HlsCusFctProject();
        prjProject.setProjectId(projectId);
        prjProject    = fctProjectService.selectByPrimaryKey(iRequest,prjProject);
        String  pName = (String)delegateExecution.getVariable("pName");
        String noticeEventCode = "";
        Map<String,Object> params = new HashMap<String,Object>();
        params.put("noticeType","NOTICE");
        params.put("url","");
        params.put("level",2L);
        params.put("pName",pName);
        params.put("name",delegateExecution.getCurrentFlowElement().getName());

        if("START".equalsIgnoreCase(status))
        {
            noticeEventCode ="WFL.START";
            params.put("message",prjProject.getProjectName());
            params.put("noticeTitle",pName+"提交审批成功");
        }else  if("APPROVE".equalsIgnoreCase(status)){
            noticeEventCode ="WFL.APPROVE";
            params.put("message",prjProject.getProjectName());
            params.put("noticeTitle",pName+"-"+delegateExecution.getCurrentFlowElement().getName()+"审批成功");
        }else if("FINISH".equalsIgnoreCase(status)){
            noticeEventCode ="WFL_FINISH";
            params.put("message","授信审批申请"+prjProject.getProjectName()+"审批完成");
            params.put("noticeTitle",pName+"审批完成");
        }
        if(sysUser != null)
        {
            iRequest.setUserId(sysUser.getUserId());
        }
        documentCategory = "FCT_PROJECT_CREDIT";
        sysEventService.eventSave(iRequest,documentId,documentCategory,"",sourceModule,noticeEventCode,RelationType,params);
    }
}
