package hls.core.sys.event.service.impl;

import com.hand.hap.core.IRequest;
import hls.core.prj.dto.HlsCusPrjProject;
import hls.core.prj.mapper.HlsCusPrjProjectMapper;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventCommonService;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.Map;
import com.hand.hap.activiti.service.*;

/**
 * Created by Administrator on 2017/4/19.
 */
@Service
@Transactional
public class ProjectEventServiceImpl implements SysEventCommonService {

    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private SysUserService userService;
    @Autowired
    private IActivitiService activitiService;
    @Autowired
    private HlsCusPrjProjectMapper prjProjectMapper;

    private static final String documentCategory = "PRJ_PROJECT";
    private static String sourceModule = "PRJ";
    private static String eventCode = "WFL.TO_DO";
    private static String RelationType = "P2D";

    @Override
    public String getDocumentCategory() {
        return documentCategory;
    }

    @Override
    public String getEventCode() {
        return eventCode;
    }

    @Override
    public void process(IRequest iRequest, Long documentId, String documentCategory, String documentType,Map<String,Object> params) {
        sysEventService.eventSave(iRequest,documentId,documentCategory,documentType,sourceModule,eventCode,RelationType,params);
    }

    @Override
    public void notice(DelegateExecution delegateExecution, String status) {
        IRequest iRequest = (IRequest)delegateExecution.getVariable("iRequest");
        String documentCategory = (String)delegateExecution.getVariable("documentCategory");
        Long documentId = (Long)delegateExecution.getVariable("documentId");
        String startUserName = (String)delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(startUserName);
        String  pName = (String)delegateExecution.getVariable("pName");
        String noticeEventCode = "";
        Map<String,Object> params = new HashMap<String,Object>();
        params.put("noticeType","NOTICE");
        params.put("url","");
        params.put("level",2L);
        params.put("pName",pName);
        params.put("name",delegateExecution.getCurrentFlowElement().getName());
        HlsCusPrjProject prjProject = prjProjectMapper.selectPrjById(documentId);
        if("START".equalsIgnoreCase(status))
        {
            noticeEventCode ="WFL.START";
            params.put("message",pName+"-"+prjProject.getProjectName());
            params.put("noticeTitle","工作流开始");
        }else  if("APPROVE".equalsIgnoreCase(status)){
            noticeEventCode ="WFL.APPROVE";
            params.put("message",pName+"-"+prjProject.getProjectName());
            params.put("noticeTitle",delegateExecution.getCurrentFlowElement().getName()+"审批成功");
        }else if("FINISH".equalsIgnoreCase(status)){
            noticeEventCode ="WFL.FINISH";
            params.put("message",pName+"-"+prjProject.getProjectName()+"审批结束");
            params.put("noticeTitle","工作流结束");
        }
        if(sysUser != null)
        {
            iRequest.setUserId(sysUser.getUserId());
        }
        sysEventService.eventSave(iRequest,documentId,documentCategory,"",sourceModule,noticeEventCode,RelationType,params);
    }



}
