package hls.core.sys.event.service.impl;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import hls.core.hls.dto.HlsSystemNotice;
import hls.core.sys.event.service.SysNoticePushService;
import hls.core.sys.mapper.SysUserMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.HashOperations;
import org.springframework.data.redis.core.ListOperations;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by gaoyang on 17/5/11.
 */
@Service
public class SysNoticePushServiceImpl implements SysNoticePushService {

    @Resource(name = "v2redisTemplate")
    private HashOperations<String, String, Object> hashOperations;
    @Resource(name = "v2redisTemplate")
    private ListOperations<String, String> listOperations;
    @Autowired
    private ObjectMapper objectMapper;
    private static final String HLS_QUEUE = "hls:queue-";

    @Override
    public void sendUserNotice(Long userId, HlsSystemNotice hlsSystemNotice) {
//        String hashKey = "messageBox-" + userId.toString() + "-" + System.currentTimeMillis() + "-" + Math.random();
//        String key = "messageBox-" + userId.toString();
//        hashOperations.put(hashKey, "userId", hlsSystemNotice);
//        listOperations.rightPush(key, hashKey);
        String key = HLS_QUEUE+userId;
        hlsSystemNotice.setAction("NOTICE");
        try {
            String s = objectMapper.writeValueAsString(hlsSystemNotice);
            listOperations.leftPush(key,s);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
    }

    @Override
    public List<HlsSystemNotice> getUserNotice(Long userId) {
        String key = "messageBox-" + userId.toString();
        List<HlsSystemNotice> retList = new ArrayList<HlsSystemNotice>();
        List<String> keys = listOperations.range(key, 0, -1);
        for (int i = 0; i < keys.size(); i++) {
            if (i == 5) {
                break;
            }
            boolean rep = true;
            boolean currentUserTodo = false;
            HlsSystemNotice hlsSystemNotice = (HlsSystemNotice) hashOperations.get(keys.get(i), "userId");
            for (int m = 0; m < retList.size(); m++) {
                if (retList.get(m)!=null && retList.get(m).getNotice_id()!=null && retList.get(m).getNotice_id() == hlsSystemNotice.getNotice_id()) {
                    rep = false;
                }
            }
            if (hlsSystemNotice!=null && hlsSystemNotice.getNotice_type() !=null && hlsSystemNotice.getNotice_type() == "TO_DO") {
                if (hlsSystemNotice.getSource_user_id() == userId) {
                    currentUserTodo = true;
                } else {
                    currentUserTodo = false;
                }
            } else {
                currentUserTodo = true;
            }
            if (rep && currentUserTodo) {
                retList.add(hlsSystemNotice);
            }
            listOperations.remove(key,1,keys.get(i));
            hashOperations.delete(keys.get(i),"userId");
        }
        return retList.size()>0 ? retList : new ArrayList<HlsSystemNotice>(0);
    }
}

