package hls.core.sys.service.impl;

import java.util.List;

import hls.core.sys.dto.SysRoleModuleExcludeFunc;
import hls.core.sys.service.ISysRoleModuleExcludeFuncService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.sys.dto.SysFunction;
import hls.core.sys.mapper.SysFunctionMapper;
import hls.core.sys.service.SysFunctionService;

@Service
@Transactional
public class SysFunctionServiceImpl extends BaseServiceImpl<SysFunction> implements SysFunctionService {

    @Autowired
    SysFunctionMapper mapper;


	@Autowired
	ISysRoleModuleExcludeFuncService srmefService;
    
	@Override
	public void deleteById(Long id) {
		mapper.deleteById(id);
	}

	@Override
	public List<SysFunction> queryAll(IRequest requestContext, SysFunction sysFunction, int page, int pagesize) {
		PageHelper.startPage(page, pagesize);
		if(sysFunction.getFunctionType() != null && !"".equals(sysFunction.getFunctionType())){
			sysFunction.setFunctionTypeArr(sysFunction.getFunctionType().split(","));
		}
		return mapper.queryAll(sysFunction);
	}

	@Override
	public List<SysFunction> selectByModuleCode(String moduleCode) {
		// TODO Auto-generated method stub
		return mapper.selectByModuleCode(moduleCode);
	}

	@Override
	public List<SysFunction> queryByModuleCode(String moduleCode,String isHomePage) {
		// TODO Auto-generated method stub
		return mapper.queryByModuleCode(moduleCode,isHomePage);
	}

	@Override
	public List<SysFunction> queryAllFunctionRelateRole(IRequest iRequest, SysFunction sysFunction, int page, int pageSize) {
		PageHelper.startPage(page, pageSize);
		return mapper.queryAllFunctionRelateRole(sysFunction);
	}

	@Override
	public List<SysFunction> updateFunctionRelateRole(IRequest requestContext, List<SysFunction> dto) {
		if(dto != null && dto.size() > 0){
			Long roleId = requestContext.getRoleId();
			for(SysFunction sysFunction : dto ){
				SysRoleModuleExcludeFunc srmef = new SysRoleModuleExcludeFunc();
				srmef.setRoleId(roleId);
				srmef.setModuleCode(sysFunction.getModuleCode());
				srmef.setFunctionId(sysFunction.getFunctionId());
				if("N".equals(sysFunction.getEnabledFlag())){
					// sys_role_module_exclude_func表中不存在对应记录
					// insert
					srmef.set__status("add");
					srmefService.insertSelective(requestContext,srmef);
				}
				else{
					// delete
					srmefService.deleteByPrimaryKey(srmef);
				}
			}
		}




		return dto;
	}

	@Override
	public List<SysFunction> widgeQuery(IRequest requestContext, Long roleId,String moduleCode) {
		return mapper.widgeQuery(roleId,moduleCode);
	}

}
