package hls.core.sys.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import com.hls.core.sys.dto.Layout;
import com.hls.core.sys.mapper.LayoutMapper;
import com.hls.core.sys.service.ILayoutService;
import hls.core.sys.mapper.SysLayoutModuleMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.sys.dto.SysLayoutModule;
import hls.core.sys.service.ISysLayoutModuleService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class SysLayoutModuleServiceImpl extends BaseServiceImpl<SysLayoutModule> implements ISysLayoutModuleService {

    @Autowired
    ILayoutService layoutService;

    @Autowired
    LayoutMapper layoutMapper;

    @Autowired
    SysLayoutModuleMapper sysLayoutModuleMapper;

    @Override
    public SysLayoutModule layoutMoudleSubmit(IRequest iRequest, SysLayoutModule item) {
        List<SysLayoutModule> t =  sysLayoutModuleMapper.select(item);
        Layout layout = new Layout();
        if (t == null || t.size() == 0){
            item.set__status("add");
            self().insertSelective(iRequest,item);
            layout.setLayoutCode(item.getLayoutCode());
            layout.setLayoutName(item.getLayoutCode());
            layout.setEnabledFlag("Y");
            layout.set__status("add");
            layoutService.insertSelective(iRequest,layout);
            item.setLayoutId(layout.getLayoutId());
        }else{
            layout.setLayoutCode(item.getLayoutCode());
            List<Layout> layouts =  layoutMapper.select(layout);
            if(layouts.size() > 0){
                item.setLayoutId(layouts.get(0).getLayoutId());
            }
        }
        return item;
    }
}