package hls.core.sys.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import com.hls.core.sys.dto.Layout;
import com.hls.core.sys.mapper.LayoutMapper;
import com.hls.core.sys.service.ILayoutService;
import hls.core.sys.mapper.SysLayoutRoleModuleMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.sys.dto.SysLayoutRoleModule;
import hls.core.sys.service.ISysLayoutRoleModuleService;
import org.springframework.transaction.annotation.Transactional;

import javax.swing.*;
import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class SysLayoutRoleModuleServiceImpl extends BaseServiceImpl<SysLayoutRoleModule> implements ISysLayoutRoleModuleService{

    @Autowired
    ILayoutService layoutService;

    @Autowired
    LayoutMapper layoutMapper;

    @Autowired
    SysLayoutRoleModuleMapper sysLayoutRoleModuleMapper;

    @Override
    public SysLayoutRoleModule layoutRoleSubmit(IRequest iRequest, SysLayoutRoleModule item) {
            List<SysLayoutRoleModule> t =  sysLayoutRoleModuleMapper.select(item);
            Layout layout = new Layout();
            if (t == null || t.size() == 0){
                item.set__status("add");
                self().insertSelective(iRequest,item);

                layout.setLayoutCode(item.getLayoutCode());
                layout.setLayoutName(item.getLayoutCode());
                layout.setEnabledFlag("Y");
                layout.set__status("add");
                layoutService.insertSelective(iRequest,layout);
                item.setLayoutId(layout.getLayoutId());
            }else{
                layout.setLayoutCode(item.getLayoutCode());
                List<Layout> layouts =  layoutMapper.select(layout);
                if(layouts.size() > 0){
                    item.setLayoutId(layouts.get(0).getLayoutId());
                }
            }
        return item;
    }

    @Override
    public void batchDeleteLayoutConfig(SysLayoutRoleModule item) {
        if(item != null){
            Layout layout = new Layout();
            layout.setLayoutCode(item.getLayoutCode());
            layout.setLayoutName(item.getLayoutCode());

            // 删除sys_layout表 layout code 对应的记录
            layoutMapper.delete(layout);

            // 删除 layout_role_module表记录,
            sysLayoutRoleModuleMapper.delete(item);
        }
    }
}