package hls.core.sys.service.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.sys.dto.SysRoleManagement;
import hls.core.sys.mapper.SysRoleManagementMapper;
import hls.core.sys.service.SysRoleManagementService;

@Service
@Transactional
public class SysRoleManagementServiceImpl extends BaseServiceImpl<SysRoleManagement>
		implements SysRoleManagementService {
	@Autowired
	private SysRoleManagementMapper sys;

	@Override
	public List<SysRoleManagement> queryAll(IRequest request, SysRoleManagement sysRoleManagement, int pageNum, int pageSize) {
		// TODO Auto-generated method stub
		PageHelper.startPage(pageNum, pageSize);
		return sys.queryAll(sysRoleManagement);
	}

	@Override
	public List<SysRoleManagement> queryLov(String m_name, String m_code) {
		// TODO Auto-generated method stub
		return sys.queryLov(m_name,m_code);
	}

	@Override
	public Long selectRoleId(String role_code) {
		// TODO Auto-generated method stub
		return sys.selectRoleId(role_code);
	}

	@Override
	public void deleteSysrole(Long selectRoleId) {
		// TODO Auto-generated method stub
		sys.deleteSysrole(selectRoleId);
	}

	@Override
	public List<SysRoleManagement> selectRoleModules(IRequest request,SysRoleManagement dto) {
		Long RoleId = request.getRoleId();
		dto.setRole_id(RoleId);
		List<SysRoleManagement> srm = sys.querySysRoleModule(dto);
		if(srm.size()>0){
			HashMap<Object, Object> objectObjectHashMap = new HashMap<>();
			objectObjectHashMap.put("roleId",RoleId);
			objectObjectHashMap.put("userId",request.getUserId());
			List<Map> layoutList = sys.querySysUserLayout(objectObjectHashMap);
			for(SysRoleManagement sysRoleManagement:srm){
				List<Map> menuLayout = new ArrayList<>();
				for(Map layoutMap:layoutList){
					if(layoutMap.get("moduleCode").equals(sysRoleManagement.getMenu_code())){
						menuLayout.add(layoutMap);
					}
				}
				int currentSeq=0;
				for(int i=0;i<menuLayout.size();i++){
					if(i==0){
						currentSeq = Integer.parseInt(menuLayout.get(i).get("seq").toString());
						sysRoleManagement.setLayoutCode(menuLayout.get(i).get("layoutCode").toString());
						continue;
					}
//					int tempSeq=Integer.parseInt(menuLayout.get(i).get("seq").toString());
//					if(tempSeq==1){
//						sysRoleManagement.setLayoutCode(menuLayout.get(i).get("layoutCode").toString());
//						break;
//					}else{
//						if(tempSeq<currentSeq){
//							sysRoleManagement.setLayoutCode(menuLayout.get(i).get("layoutCode").toString());
//						}
//					}
					int seq = Integer.parseInt(menuLayout.get(i).get("seq").toString());
					if(seq > currentSeq){
						currentSeq = seq;
						sysRoleManagement.setLayoutCode(menuLayout.get(i).get("layoutCode").toString());
					}
				}
			}
		}
		return srm;
	};

}
