package hls.core.sys.service.impl;

import java.util.List;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import hls.core.sys.dto.SysRoleManagement;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.hand.hap.system.service.impl.BaseServiceImpl;

import hls.core.sys.dto.SysRole;
import hls.core.sys.mapper.SysRoleMapper;
import hls.core.sys.mapper.SysRoleManagementMapper;
import hls.core.sys.service.SysRoleService;

@Service
@Transactional
public class SysRoleServiceImpl extends BaseServiceImpl<SysRole> implements SysRoleService {

	@Autowired
	private SysRoleMapper sysRoleMapper;
	@Autowired
	private SysRoleManagementMapper sysRoleManagementMapper;
	
	@Override
	public List<SysRole> addHL(List<SysRole> sysRole) {
		// TODO Auto-generated method stub
		for (SysRole sysRole2 : sysRole) {
			if (sysRole2.getRole_id() == null) {
				createHead(sysRole2);
			}
		}
		return sysRole;
		
	}

	@Override
	protected boolean useSelectiveUpdate() {
		return false;
	}

	@Override
	public void deleteByChiledId(Long Id) {
		if (Id != null){
			sysRoleMapper.deleteByChildId(Id);
		}
	}

	@Override
	public List<SysRole> selectList(IRequest requestContext, SysRole sysRole, int page, int pagesize) {
		PageHelper.startPage(page, pagesize);
		sysRole.setRole_code(sysRole.getQueryCondition());
		sysRole.setRole_name(sysRole.getQueryCondition());
		return sysRoleMapper.seleteList(sysRole);
	}


	private void createHead(SysRole sysRole){
		sysRoleMapper.insertSelective(sysRole);
		if (sysRole.getSysRoleManagements() != null) {
			 saveLine(sysRole);
		}
		
	}
	
	private void saveLine(SysRole sysRole){
		for (SysRoleManagement srm : sysRole.getSysRoleManagements()) {
			if (srm.getRole_id() == null) {
				srm.setRole_id(sysRole.getRole_id());
				sysRoleManagementMapper.insertSelective(srm);
			}
		}
	}

	@Override
	public List<SysRole> roleQuery(IRequest requestContext, SysRole sysRole,int page, int pagesize) {
		PageHelper.startPage(page, pagesize);
		return sysRoleMapper.roleQuery(sysRole);
	}
}
