package hls.core.sys.service.impl;

import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.sys.dto.HlsCusSysUserVisitHistory;
import hls.core.sys.mapper.HlsCusSysUserVisitHistoryMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.sys.service.ISysUserVisitHistoryService;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class SysUserVisitHistoryServiceImpl extends BaseServiceImpl<HlsCusSysUserVisitHistory> implements ISysUserVisitHistoryService {
    @Autowired
    private HlsCusSysUserVisitHistoryMapper mapper;

    @Override
    public HlsCusSysUserVisitHistory saveHistory(IRequest request, HlsCusSysUserVisitHistory sysUserVisitHistory) {
        Long userId = request.getUserId();
        Long allocationId = request.getAttribute("allocationId");
        sysUserVisitHistory.setUserId(userId);
        sysUserVisitHistory.setUserAllocationId(allocationId);
        sysUserVisitHistory.setVisitDatetime(new Date());

        HlsCusSysUserVisitHistory queryParam = new HlsCusSysUserVisitHistory();
        queryParam.setUserId(userId);
        queryParam.setUserAllocationId(allocationId);
        queryParam.setVisitType(sysUserVisitHistory.getVisitType());
        queryParam.setVisitTypeSource(sysUserVisitHistory.getVisitTypeSource());
        queryParam.setVisitTypeSourceId(sysUserVisitHistory.getVisitTypeSourceId());

        List<HlsCusSysUserVisitHistory> select = mappers.get(0).select(queryParam);
        if (select.isEmpty() || "MODULE".equalsIgnoreCase(sysUserVisitHistory.getVisitType())){
            sysUserVisitHistory = self().insertSelective(request, sysUserVisitHistory);
        } else {
            sysUserVisitHistory.setHistoryId(select.stream().findFirst().get().getHistoryId());
            self().updateByPrimaryKeySelective(request,sysUserVisitHistory);
        }
        return sysUserVisitHistory;
    }

    /*
    * 查询最常访问的模块
    * */
    @Override
    public List<HlsCusSysUserVisitHistory> queryMostVisitModule(IRequest request, HlsCusSysUserVisitHistory sysUserVisitHistory, int page, int pageSize) {
        Long userId = request.getUserId();
        Long allocationId = request.getAttribute("allocationId");
        sysUserVisitHistory.setUserId(userId);
        sysUserVisitHistory.setUserAllocationId(allocationId);
        PageHelper.startPage(page, pageSize);
        return mapper.queryMostVisitModule(sysUserVisitHistory);
    }

    /*查询最近访问的单据*/
    @Override
    public List<HlsCusSysUserVisitHistory> queryRecentVisitDoc(IRequest request, HlsCusSysUserVisitHistory sysUserVisitHistory, int page, int pageSize) {
        Long userId = request.getUserId();
        Long allocationId = request.getAttribute("allocationId");
        sysUserVisitHistory.setUserId(userId);
        sysUserVisitHistory.setUserAllocationId(allocationId);
        PageHelper.startPage(page, pageSize);
        return mapper.queryRecentVisitDoc(sysUserVisitHistory);
    }
}