package hls.core.user.controllers;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;

import hls.core.user.dto.LoginUserInfo;
import hls.core.user.service.LoginUserInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import java.util.ArrayList;
import java.util.List;


@Controller
public class LoginUserInfoController extends BaseController{
    @Autowired
    private LoginUserInfoService loginUserInfoService;

    @RequestMapping(value = "/fct/LoginUserInfo/query", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData query(final HttpServletRequest request, HttpSession session){
        IRequest requestContext = createRequestContext(request);
        String employeeCode= (String)session.getAttribute("employeeCode");
        List<LoginUserInfo> loginUserInfo=loginUserInfoService.queryUserInfo(employeeCode);
        return new ResponseData(loginUserInfo);
    }

    @RequestMapping(value = "/fct/LoginUserInfoByEmpId/query", method = RequestMethod.POST)
    @ResponseBody
    public ResponseData queryEmpInfo(final HttpServletRequest request,Long employeeId,Long unitId,HttpSession session){
        IRequest requestContext = createRequestContext(request);

        List<LoginUserInfo> loginUserInfoList=new ArrayList<LoginUserInfo>();
        LoginUserInfo dto=new LoginUserInfo();
        dto.setEmployeeId(employeeId);
        dto.setUnitId(unitId);
        loginUserInfoList=loginUserInfoService.queryUserInfoByEmpId(dto);
        return new ResponseData(loginUserInfoList);
    }
}
