package hls.core.vat.calculate.service.impl;

import java.util.HashMap;
import java.util.Map;

import hls.core.vat.dto.HlsCusAcrInvoiceHd;
import org.springframework.stereotype.Service;
import com.hand.hap.core.IRequest;
import hls.core.vat.calculate.service.InvoiceCalculateCommon;

@Service
public class LeaseBackBeforeFreeholdServiceImpl implements InvoiceCalculateCommon{

	//直租动产
	private static final String invoiceCalculateType = "LEASEBACK_BEFORE_FREEHOLD";
	
	@Override
	public String getInvoiceCalculateType() {
		return invoiceCalculateType;
	}

	@Override
	public Map<String, Object> process(IRequest iRequest, HlsCusAcrInvoiceHd acrInvoiceHd) {
		Map<String, Object> map = new HashMap<String, Object>();
		
		switch (acrInvoiceHd.getCfItem().toString()) {
		case "5":
			map.put("taxTypeRate", "");
			map.put("invoicekind", "RECEIPT");
			break;
		default:
			map.put("taxTypeRate", "0.05");
			map.put("invoicekind", "");
			break;
		}
		
		return map;
	}

}
