package hls.core.vat.components;

import com.hand.hap.core.IRequest;
import hls.core.cont.dto.ConContractTenant;
import hls.core.cont.mapper.ConContractTenantMapper;
import hls.core.hls.bp.dto.HlsCusBpMaster;
import hls.core.hls.bp.mapper.HlsBpMasterMapper;
import hls.core.hls.bp.mapper.HlsCusBpMasterMapper;
import hls.core.sys.event.service.SysEventCommonService;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import org.activiti.engine.delegate.DelegateExecution;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-08-21
 * Time: 14:22
 */
abstract class AbstractAcrInvoiceEventHandler implements SysEventCommonService {
    @Autowired
    private ConContractTenantMapper conContractTenantMapper;
    @Autowired
    private HlsCusBpMasterMapper hlsCusBpMasterMapper;
    @Autowired
    private SysEventService sysEventService;

    abstract String getMessage(String invoiceNum, String bpName, String amt);

    abstract String getNoticeTitle();

    public Long getLevel() {
        return 2L;
    }

    public String getInvoiceNum(Map<String, Object> params) {
        return params.get("invoiceNum").toString();
    }

    public String getAmt(Map<String, Object> params) {
        return params.get("amt").toString();
    }

    public String getSourceModel() {
        return SysEventCodeUtil.PROPERTITY_SOURCEMODULE_ACR;
    }

    public String getRelation() {
        return SysEventCodeUtil.PROPERTITY_RELATIONTYPE_P2D;
    }

    @Override
    public String getDocumentCategory() {
        return null;
    }

    @Override
    public void process(IRequest iRequest, Long documentId, String documentCategory, String documentType, Map<String, Object> params) {
        ConContractTenant conContractTenant = new ConContractTenant();
        conContractTenant.setContractId(documentId);
        List<ConContractTenant> select = conContractTenantMapper.select(conContractTenant);
        StringBuilder stringBuilder = new StringBuilder();
        if(select != null && !select.isEmpty()){
            for (ConContractTenant contractTenant : select) {
                HlsCusBpMaster hlsCusBpMaster = new HlsCusBpMaster();
                hlsCusBpMaster.setBpId(contractTenant.getTenantBpId());
                hlsCusBpMaster = hlsCusBpMasterMapper.selectByPrimaryKey(hlsCusBpMaster);
                stringBuilder.append(hlsCusBpMaster.getBpName()).append(",");
            }
        }
        if(stringBuilder.lastIndexOf(",") == stringBuilder.length() -1){
            stringBuilder.deleteCharAt(stringBuilder.length() - 1);
        }

        String message = getMessage(getInvoiceNum(params), stringBuilder.toString(), getAmt(params));

        params.put("message", message);
        params.put("noticeTitle", getNoticeTitle());
        params.put("level", getLevel());
        params.put("noticeType", "NOTICE");

        sysEventService.eventSave(iRequest, documentId, documentCategory, documentType, getSourceModel(), getEventCode(), getRelation(), params);

    }

    @Override
    public void notice(DelegateExecution delegateExecution, String status) {

    }
}
