package hls.core.vat.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.vat.dto.HlsCusAcpInvoiceHd;
import hls.core.vat.service.AcpInvoiceHdService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

@Controller
public class AcpInvoiceHdController extends BaseController {
	@Autowired
	private AcpInvoiceHdService service;
	@RequestMapping(value = "/vat/acp/detail/query")
	@ResponseBody
	public ResponseData acpInvoiceQuery(HttpServletRequest request,@RequestBody Map<String,String> map,
			@RequestParam(defaultValue = DEFAULT_PAGE) final int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
		return new ResponseData(service.acpInvoiceQuery(map));
	}
	
	
	@RequestMapping(value = "/vat/acp/detail/scale/query")
	@ResponseBody
	public ResponseData acpInvoiceScaleQuery(HttpServletRequest request){
		return new ResponseData(service.acpInvoiceScaleQuery());
	}
	
	@RequestMapping(value = "/vat/acp/invoiced/totle/query")
	@ResponseBody
	public ResponseData acpInvoicedTotleQuery(HttpServletRequest request){
		return new ResponseData(service.acpInvoicedTotleQuery());
	}

	@RequestMapping(value = "/vat/acp/invoiced/group/query")
	@ResponseBody
	public ResponseData acpInvoicedGroupQuery(final HttpServletRequest request){
		IRequest requestContext = createRequestContext(request);
		List<HlsCusAcpInvoiceHd> list = service.acpInvoicedGroupQuery(requestContext);
		return new ResponseData(list);
	}
}
