package hls.core.vat.controllers;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import hls.core.hls.service.HlsExcelService;
import hls.core.vat.dto.HlsCusAcpInvoiceLn;
import hls.core.vat.service.AcpInvoiceLnService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

@Controller
public class AcpInvoiceLnController extends BaseController {
	@Autowired
	private AcpInvoiceLnService service;
	@Autowired
	HlsExcelService hlsExcelService;
	@Autowired
	AcpInvoiceLnService acpInvoiceLnService;

	@RequestMapping(value = "/vat/acp/detail/ln/query")
	@ResponseBody
	public ResponseData acpInvoiceLnQuery(HttpServletRequest request,HlsCusAcpInvoiceLn acpInvoiceLn,
			@RequestParam(defaultValue = DEFAULT_PAGE) final int page,
			@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
		IRequest requestContext = createRequestContext(request);
		return new ResponseData(service.acpInvoiceLnQuery(acpInvoiceLn));
	}

	@RequestMapping(value = "/vat/acp/invoiceExcelImportConfirm", method = RequestMethod.POST)
	public Map<String, Object> importConfirm(HttpServletRequest request, Long headerId) throws IOException {
		IRequest iRequest = createRequestContext(request);
		Map<String, Object> response = new HashMap<String, Object>();
		response.put("success", false);
		try {
			acpInvoiceLnService.acpInvoiceExcelImport(iRequest, headerId);
			response.put("message", "导入成功");
			response.put("success", true);
		} catch (Exception e) {
			response.put("success", false);
			response.put("message", "导入失败！" + e.getMessage());
			e.printStackTrace();
		}
		return response;
	}

	@RequestMapping(value = "/vat/acp/selectAcpInvoiceDetail")
	@ResponseBody
	public ResponseData selectAcpInvoiceDetail(HttpServletRequest request,@RequestBody Map map,
											@RequestParam(defaultValue = DEFAULT_PAGE) final int page,
											@RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pagesize){
		IRequest iRequest = createRequestContext(request);
		return new ResponseData(acpInvoiceLnService.selectAcpInvoiceDetail(map,iRequest,page,pagesize));
	}


	
}
