package hls.core.vat.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.core.vat.dto.HlsCusInvoiceAttribute;
import hls.core.vat.service.IInvoiceAttributeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

    @Controller
    public class InvoiceAttributeController extends BaseController{

    @Autowired
    private IInvoiceAttributeService service;


    @RequestMapping(value = "/vat/invoice/attribute/query")
    @ResponseBody
    public ResponseData query(HlsCusInvoiceAttribute dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        dto.setCompanyId(requestContext.getCompanyId());
        return new ResponseData(service.query(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/vat/invoice/attribute/submit")
    @ResponseBody
    public ResponseData update(HttpServletRequest request,@RequestBody List<HlsCusInvoiceAttribute> dto){
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/vat/invoice/attribute/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<HlsCusInvoiceAttribute> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }
    }