package hls.core.vat.dto;

import com.hand.hap.core.annotation.Children;
import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-09-30
 * Time: 9:48
 */
@ExtensionAttribute(disable = true)
@Table(name = "acp_invoice_hd")
public class AcpInvoiceHd extends BaseDTO {

    @Id
    @GeneratedValue
    private Long invoiceHdId;

    private Long companyId;

    private String documentNumber;

    private String documentType;

    private String documentCategory;

    private String businessType;

    private String billingMethod;

    private String invoiceKind;

    private Long bpId;

    private String bpName;

    private String bpTaxRegistryNum;

    private String bpAddressPhoneNum;

    private String bpBankAccount;

    private String description;

    private double totalAmount;

    private double netAmount;

    private double taxAmount;

    private String currency;

    private Date invoiceDate;

    private String invoiceNumber;

    private String invoiceStatus;

    private String reversedFlag;

    private Date reverseDate;

    private Long sourceInvoiceHeaderId;

    private Date confirmedDate;

    private Long confirmedBy;

    private Date postedDate;

    private Long postedBy;

    @Transient
    private Long contractId;
    @Transient
    private Long cashflowId;
    @Transient
    private double writeOffDueAmount;
    @Transient
    private double writeOffInterest;
    @Transient
    private double writeOffPrincipal;
    @Transient
    private double totalInterest;
    @Transient
    private String cashflowIdStr;
    @Transient
    private Long ranks;

    @Transient
    private double specialNum;
    @Transient
    private double normalNum;

    public double getSpecialNum() {
        return specialNum;
    }

    public void setSpecialNum(double specialNum) {
        this.specialNum = specialNum;
    }

    public double getNormalNum() {
        return normalNum;
    }

    public void setNormalNum(double normalNum) {
        this.normalNum = normalNum;
    }

    public List<HlsCusAcrInvoiceLn> getAcrInvoiceLnList() {
        return acrInvoiceLnList;
    }

    @Transient
    private String companyFullName;
    @Transient
    private String contractName;
    @Transient
    private String contractNumber;

    public String getCompanyFullName() {
        return companyFullName;
    }

    public void setAcrInvoiceLnList(List<HlsCusAcrInvoiceLn> acrInvoiceLnList) {
        this.acrInvoiceLnList = acrInvoiceLnList;
    }

    @Transient
    private String invoiceKindDesc;

    public String getInvoiceKindDesc() {
        return invoiceKindDesc;
    }

    public void setInvoiceKindDesc(String invoiceKindDesc) {
        this.invoiceKindDesc = invoiceKindDesc;
    }

    @Transient
    private String cfItemDesc;
    @Transient
    private Long cfItem;

    public String getCfItemDesc() {
        return cfItemDesc;
    }

    public void setCfItemDesc(String cfItemDesc) {
        this.cfItemDesc = cfItemDesc;
    }

    public Long getCfItem() {
        return cfItem;
    }

    public void setCfItem(Long cfItem) {
        this.cfItem = cfItem;
    }

    @Transient
    @Children
    List<HlsCusAcrInvoiceLn> acrInvoiceLnList;

    public Long getRanks() {
        return ranks;
    }

    public void setRanks(Long ranks) {
        this.ranks = ranks;
    }

    public void setCompanyFullName(String companyFullName) {
        this.companyFullName = companyFullName;
    }

    public String getContractName() {
        return contractName;
    }

    public void setContractName(String contractName) {
        this.contractName = contractName;
    }

    public String getContractNumber() {
        return contractNumber;
    }

    public void setContractNumber(String contractNumber) {
        this.contractNumber = contractNumber;
    }


    @Transient
    private Double diffAmount;


    @Transient
    private Long times;

    @Transient
    private Double billingAmount;

    @Transient
    private String diff;

    @Transient
    private String flag;

    @Transient
    private Long count;

    @Transient
    private String cashflowItems;
    @Transient
    private Double amountFrom;

    @Transient
    private Double amountTo;
    @Transient
    private String contractInfo;

    @Transient
    private Long timesFrom;

    @Transient
    private Long timesTo;

    public String getFlag() {
        return flag;
    }

    public Long getCount() {
        return count;
    }

    public void setCount(Long count) {
        this.count = count;
    }

    public String getCashflowItems() {
        return cashflowItems;
    }

    public void setCashflowItems(String cashflowItems) {
        this.cashflowItems = cashflowItems;
    }

    public Double getAmountFrom() {
        return amountFrom;
    }

    public void setAmountFrom(Double amountFrom) {
        this.amountFrom = amountFrom;
    }

    public Double getAmountTo() {
        return amountTo;
    }

    public void setAmountTo(Double amountTo) {
        this.amountTo = amountTo;
    }

    public String getContractInfo() {
        return contractInfo;
    }

    public void setContractInfo(String contractInfo) {
        this.contractInfo = contractInfo;
    }

    public Long getTimesFrom() {
        return timesFrom;
    }

    public void setTimesFrom(Long timesFrom) {
        this.timesFrom = timesFrom;
    }

    public Long getTimesTo() {
        return timesTo;
    }

    public void setTimesTo(Long timesTo) {
        this.timesTo = timesTo;
    }

    public void setFlag(String flag) {
        this.flag = flag;
    }

    public String getDiff() {
        return diff;
    }

    public void setDiff(String diff) {
        this.diff = diff;
    }

    public Double getDiffAmount() {
        return diffAmount;
    }

    public void setDiffAmount(Double diffAmount) {
        this.diffAmount = diffAmount;
    }

    public Long getTimes() {
        return times;
    }

    public void setTimes(Long times) {
        this.times = times;
    }

    public Double getBillingAmount() {
        return billingAmount;
    }

    public void setBillingAmount(Double billingAmount) {
        this.billingAmount = billingAmount;
    }

    //发票头分组表示
    // 1，按照合同分组
    //2.按照现金流分组
    //3按照商业伙伴分组
    @Transient
    private int groupByFlag;

    @Transient
    private List<Long> queryList;

    public String getCashflowIdStr() {
        return cashflowIdStr;
    }

    public void setCashflowIdStr(String cashflowIdStr) {
        this.cashflowIdStr = cashflowIdStr;
    }

    public int getGroupByFlag() {
        return groupByFlag;
    }

    public void setGroupByFlag(int groupByFlag) {
        this.groupByFlag = groupByFlag;
    }

    public List<Long> getQueryList() {
        return queryList;
    }

    public void setQueryList(List<Long> queryList) {
        this.queryList = queryList;
    }

    public Long getContractId() {
        return contractId;
    }

    public void setContractId(Long contractId) {
        this.contractId = contractId;
    }

    public Long getCashflowId() {
        return cashflowId;
    }

    public void setCashflowId(Long cashflowId) {
        this.cashflowId = cashflowId;
    }

    public double getWriteOffDueAmount() {
        return writeOffDueAmount;
    }

    public void setWriteOffDueAmount(double writeOffDueAmount) {
        this.writeOffDueAmount = writeOffDueAmount;
    }

    public double getWriteOffInterest() {
        return writeOffInterest;
    }

    public void setWriteOffInterest(double writeOffInterest) {
        this.writeOffInterest = writeOffInterest;
    }

    public double getWriteOffPrincipal() {
        return writeOffPrincipal;
    }

    public void setWriteOffPrincipal(double writeOffPrincipal) {
        this.writeOffPrincipal = writeOffPrincipal;
    }

    public double getTotalInterest() {
        return totalInterest;
    }

    public void setTotalInterest(double totalInterest) {
        this.totalInterest = totalInterest;
    }

    public double getTotalPrincipal() {
        return totalPrincipal;
    }

    public void setTotalPrincipal(double totalPrincipal) {
        this.totalPrincipal = totalPrincipal;
    }

    @Transient
    private double totalPrincipal;


    public Long getInvoiceHdId() {
        return invoiceHdId;
    }

    public void setInvoiceHdId(Long invoiceHdId) {
        this.invoiceHdId = invoiceHdId;
    }

    public Long getCompanyId() {
        return companyId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public String getDocumentNumber() {
        return documentNumber;
    }

    public void setDocumentNumber(String documentNumber) {
        this.documentNumber = documentNumber == null ? null : documentNumber.trim();
    }

    public String getDocumentType() {
        return documentType;
    }

    public void setDocumentType(String documentType) {
        this.documentType = documentType == null ? null : documentType.trim();
    }

    public String getDocumentCategory() {
        return documentCategory;
    }

    public void setDocumentCategory(String documentCategory) {
        this.documentCategory = documentCategory == null ? null : documentCategory.trim();
    }

    public String getBusinessType() {
        return businessType;
    }

    public void setBusinessType(String businessType) {
        this.businessType = businessType == null ? null : businessType.trim();
    }

    public String getBillingMethod() {
        return billingMethod;
    }

    public void setBillingMethod(String billingMethod) {
        this.billingMethod = billingMethod == null ? null : billingMethod.trim();
    }

    public String getInvoiceKind() {
        return invoiceKind;
    }

    public void setInvoiceKind(String invoiceKind) {
        this.invoiceKind = invoiceKind == null ? null : invoiceKind.trim();
    }

    public Long getBpId() {
        return bpId;
    }

    public void setBpId(Long bpId) {
        this.bpId = bpId;
    }

    public String getBpName() {
        return bpName;
    }

    public void setBpName(String bpName) {
        this.bpName = bpName == null ? null : bpName.trim();
    }

    public String getBpTaxRegistryNum() {
        return bpTaxRegistryNum;
    }

    public void setBpTaxRegistryNum(String bpTaxRegistryNum) {
        this.bpTaxRegistryNum = bpTaxRegistryNum == null ? null : bpTaxRegistryNum.trim();
    }

    public String getBpAddressPhoneNum() {
        return bpAddressPhoneNum;
    }

    public void setBpAddressPhoneNum(String bpAddressPhoneNum) {
        this.bpAddressPhoneNum = bpAddressPhoneNum == null ? null : bpAddressPhoneNum.trim();
    }

    public String getBpBankAccount() {
        return bpBankAccount;
    }

    public void setBpBankAccount(String bpBankAccount) {
        this.bpBankAccount = bpBankAccount == null ? null : bpBankAccount.trim();
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description == null ? null : description.trim();
    }

    public double getTotalAmount() {
        return totalAmount;
    }

    public void setTotalAmount(double totalAmount) {
        this.totalAmount = totalAmount;
    }

    public double getNetAmount() {
        return netAmount;
    }

    public void setNetAmount(double netAmount) {
        this.netAmount = netAmount;
    }

    public double getTaxAmount() {
        return taxAmount;
    }

    public void setTaxAmount(double taxAmount) {
        this.taxAmount = taxAmount;
    }

    public String getCurrency() {
        return currency;
    }

    public void setCurrency(String currency) {
        this.currency = currency == null ? null : currency.trim();
    }

    public Date getInvoiceDate() {
        return invoiceDate;
    }

    public void setInvoiceDate(Date invoiceDate) {
        this.invoiceDate = invoiceDate;
    }

    public String getInvoiceNumber() {
        return invoiceNumber;
    }

    public void setInvoiceNumber(String invoiceNumber) {
        this.invoiceNumber = invoiceNumber == null ? null : invoiceNumber.trim();
    }

    public String getInvoiceStatus() {
        return invoiceStatus;
    }

    public void setInvoiceStatus(String invoiceStatus) {
        this.invoiceStatus = invoiceStatus == null ? null : invoiceStatus.trim();
    }

    public String getReversedFlag() {
        return reversedFlag;
    }

    public void setReversedFlag(String reversedFlag) {
        this.reversedFlag = reversedFlag == null ? null : reversedFlag.trim();
    }

    public Date getReverseDate() {
        return reverseDate;
    }

    public void setReverseDate(Date reverseDate) {
        this.reverseDate = reverseDate;
    }

    public Long getSourceInvoiceHeaderId() {
        return sourceInvoiceHeaderId;
    }

    public void setSourceInvoiceHeaderId(Long sourceInvoiceHeaderId) {
        this.sourceInvoiceHeaderId = sourceInvoiceHeaderId;
    }


    public Long getConfirmedBy() {
        return confirmedBy;
    }

    public void setConfirmedBy(Long confirmedBy) {
        this.confirmedBy = confirmedBy;
    }

    public Date getConfirmedDate() {
        return confirmedDate;
    }

    public void setConfirmedDate(Date confirmedDate) {
        this.confirmedDate = confirmedDate;
    }

    public Date getPostedDate() {
        return postedDate;
    }

    public void setPostedDate(Date postedDate) {
        this.postedDate = postedDate;
    }

    public Long getPostedBy() {
        return postedBy;
    }

    public void setPostedBy(Long postedBy) {
        this.postedBy = postedBy;
    }

}
