package hls.core.vat.dto;

import com.alibaba.fastjson.annotation.JSONField;
import com.hand.hap.core.annotation.Children;
import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-09-30
 * Time: 9:52
 */
@ExtensionAttribute(disable=true)
@Table(name = "acr_invoice_hd")
public class AcrInvoiceHd extends BaseDTO {

    @Id
    @GeneratedValue
    private Long invoiceHdId;

    private Long companyId;

    private String documentNumber;

    private String documentType;

    private String documentCategory;

    private String businessType;

    private String billingMethod;

    private String invoiceKind;

    private Long bpId;

    private String bpName;

    private String bpTaxRegistryNum;

    private String bpAddressPhoneNum;

    private String bpBankAccount;

    private String description;

    private Double totalAmount;

    private Double netAmount;

    private Double taxAmount;

    private String currency;
    @JSONField(format = "yyyy-MM-dd")
    private Date invoiceDate;

    private String invoiceNumber;

    private String invoiceStatus;

    private String reversedFlag;

    private Date reverseDate;

    private Long sourceInvoiceHeaderId;

    private Date confirmedDate;

    private Long confirmedBy;

    private Date postedDate;

    private Long postedBy;

    @Transient
    private Long contractId;
    @Transient
    private Long cashflowId;
    @Transient
    private Double writeOffDueAmount;
    @Transient
    private double writeOffInterest;
    @Transient
    private double writeOffPrincipal;
    @Transient
    private double totalInterest;
    @Transient
    private String cashflowIdStr;
    @Transient
    private Long ranks;
    @Transient
    private double billingAmount;
    @Transient
    private double dueAmount;
    @Transient
    private Double receivedPrincipal;
    @Transient
    private Date signDate;
    @Transient
    private String division;
    @Transient
    private String invoiceCalculateType;
    @Transient
    private String taxpayerType;

    @Transient
    private String cashflowIds;
    @Transient
    private String netAmountFlag1;
    @Transient
    private String netAmountFlag2;
    @Transient
    private String netAmountFlag3;
    @Transient
    private String netAmountFlag4;
    @Transient
    private String netAmountFlag5;
    @Transient
    private String netAmountFlag6;
    @Transient
    private String netAmountFlag7;

    @Transient
    private String amountFlag1;
    @Transient
    private String amountFlag2;
    @Transient
    private String amountFlag3;
    @Transient
    private String amountFlag4;
    @Transient
    private String amountFrom;
    @Transient
    private String amountTo;

    @Transient
    private String netAmountbz;
    @Transient
    private String taxAmountTotalbz;
    @Transient
    private String taxAmountbz;
    // 税率
    @Transient
    private String taxAmountFlag1;
    @Transient
    private String taxAmountFlag2;
    @Transient
    private String taxAmountFlag3;
    @Transient
    private String taxAmountFlag4;
    @Transient
    private String taxAmountFlag5;
    @Transient
    private String taxAmountFlag6;
    @Transient
    private String taxAmountFlag7;
    @Transient
    private Double taxAmountFrom;
    @Transient
    private Double taxAmountTo;
    // 税价合计
    @Transient
    private String taxAmountTotalFlag1;
    @Transient
    private String taxAmountTotalFlag2;
    @Transient
    private String taxAmountTotalFlag3;
    @Transient
    private String taxAmountTotalFlag4;
    @Transient
    private String taxAmountTotalFlag5;
    @Transient
    private String taxAmountTotalFlag6;
    @Transient
    private String taxAmountTotalFlag7;
    @Transient
    private Double taxAmountTotalFrom;
    @Transient
    private Double taxAmountTotalTo;
    @Transient
    private String organization1;
    @Transient
    private List invoiceAmount;
    @Transient
    private List taxAmounts;
    @Transient
    private List taxAmountTotal;
    @Transient
    private int page;
    @Transient
    private int pagesize;
    @Transient
    private Date invoiceDateFrom;
    @Transient
    private Date invoiceDateTo;

    @Transient
    private String purchasingUnit;
    @Transient
    private String taxpayerNumber;

    @Transient
    private Long bsCfItem;
    @Transient
    private String paramStr;
    @Transient
    private String bsCfItemDesc;

    @Transient
    private String mergeRentalFlag;
    @Transient
    private int vatModifyFlag;

    @Transient
    private List invoiceIdParam;

    @Transient
    private String bpInfo;

    @Transient
    private String[] invoiceKindParam;

    @Transient
    private Double totalAmountFrom;

    @Transient
    private List<Long> cfItemList;

    @Transient
    private String productName;

    @Transient
    private Double totalAmountTo;
    @Transient
    private String lnBoxNumber;

    @Transient
    private String companyName;

    @Transient
    private String sourceType;

    @Transient
    private Long sourceId;

    @Transient
    private Date receiptDate;

    public String getCompanyName() {
        return companyName;
    }

    public void setCompanyName(String companyName) {
        this.companyName = companyName;
    }

    public String getSourceType() {
        return sourceType;
    }

    public void setSourceType(String sourceType) {
        this.sourceType = sourceType;
    }


    public String getParamStr() {
        return paramStr;
    }

    public void setParamStr(String paramStr) {
        this.paramStr = paramStr;
    }

    public String getLnBoxNumber() {
        return lnBoxNumber;
    }

    public void setLnBoxNumber(String lnBoxNumber) {
        this.lnBoxNumber = lnBoxNumber;
    }

    public String getProductName() {
        return productName;
    }

    public void setProductName(String productName) {
        this.productName = productName;
    }

    public String getBsCfItemDesc() {
        return bsCfItemDesc;
    }

    public void setBsCfItemDesc(String bsCfItemDesc) {
        this.bsCfItemDesc = bsCfItemDesc;
    }

    public List<Long> getCfItemList() {
        return cfItemList;
    }

    public void setCfItemList(List<Long> cfItemList) {
        this.cfItemList = cfItemList;
    }

    public String getBpInfo() {
        return bpInfo;
    }

    public void setBpInfo(String bpInfo) {
        this.bpInfo = bpInfo;
    }

    public String[] getInvoiceKindParam() {
        return invoiceKindParam;
    }

    public void setInvoiceKindParam(String[] invoiceKindParam) {
        this.invoiceKindParam = invoiceKindParam;
    }

    public Double getTotalAmountFrom() {
        return totalAmountFrom;
    }

    public void setTotalAmountFrom(Double totalAmountFrom) {
        this.totalAmountFrom = totalAmountFrom;
    }

    public Double getTotalAmountTo() {
        return totalAmountTo;
    }

    public void setTotalAmountTo(Double totalAmountTo) {
        this.totalAmountTo = totalAmountTo;
    }

    public String getTaxpayerNumber() {
        return taxpayerNumber;
    }

    public void setTaxpayerNumber(String taxpayerNumber) {
        this.taxpayerNumber = taxpayerNumber;
    }

    public void setTotalAmount(Double totalAmount) {
        this.totalAmount = totalAmount;
    }

    public void setNetAmount(Double netAmount) {
        this.netAmount = netAmount;
    }


    public List getInvoiceIdParam() {
        return invoiceIdParam;
    }

    public void setInvoiceIdParam(List invoiceIdParam) {
        this.invoiceIdParam = invoiceIdParam;
    }

    public int getVatModifyFlag() {
        return vatModifyFlag;
    }

    public void setVatModifyFlag(int vatModifyFlag) {
        this.vatModifyFlag = vatModifyFlag;
    }

    public Long getBsCfItem() {
        return bsCfItem;
    }

    public void setBsCfItem(Long bsCfItem) {
        this.bsCfItem = bsCfItem;
    }

    public String getMergeRentalFlag() {
        return mergeRentalFlag;
    }

    public void setMergeRentalFlag(String mergeRentalFlag) {
        this.mergeRentalFlag = mergeRentalFlag;
    }

    public String getPurchasingUnit() {
        return purchasingUnit;
    }

    public void setPurchasingUnit(String purchasingUnit) {
        this.purchasingUnit = purchasingUnit;
    }

    public Date getInvoiceDateFrom() {
        return invoiceDateFrom;
    }

    public void setInvoiceDateFrom(Date invoiceDateFrom) {
        this.invoiceDateFrom = invoiceDateFrom;
    }

    public Date getInvoiceDateTo() {
        return invoiceDateTo;
    }

    public void setInvoiceDateTo(Date invoiceDateTo) {
        this.invoiceDateTo = invoiceDateTo;
    }

    public Double getReceivedPrincipal() {
        return receivedPrincipal;
    }

    public void setReceivedPrincipal(Double receivedPrincipal) {
        this.receivedPrincipal = receivedPrincipal;
    }

    public String getAmountFlag1() {
        return amountFlag1;
    }

    public void setAmountFlag1(String amountFlag1) {
        this.amountFlag1 = amountFlag1;
    }

    public String getAmountFlag2() {
        return amountFlag2;
    }

    public void setAmountFlag2(String amountFlag2) {
        this.amountFlag2 = amountFlag2;
    }

    public String getAmountFlag3() {
        return amountFlag3;
    }

    public void setAmountFlag3(String amountFlag3) {
        this.amountFlag3 = amountFlag3;
    }

    public String getAmountFlag4() {
        return amountFlag4;
    }

    public void setAmountFlag4(String amountFlag4) {
        this.amountFlag4 = amountFlag4;
    }

    public String getAmountFrom() {
        return amountFrom;
    }

    public void setAmountFrom(String amountFrom) {
        this.amountFrom = amountFrom;
    }

    public String getAmountTo() {
        return amountTo;
    }

    public void setAmountTo(String amountTo) {
        this.amountTo = amountTo;
    }

    public List getInvoiceAmount() {
        return invoiceAmount;
    }

    public String getNetAmountbz() {
        return netAmountbz;
    }

    public void setNetAmountbz(String netAmountbz) {
        this.netAmountbz = netAmountbz;
    }

    public String getTaxAmountTotalbz() {
        return taxAmountTotalbz;
    }

    public void setTaxAmountTotalbz(String taxAmountTotalbz) {
        this.taxAmountTotalbz = taxAmountTotalbz;
    }

    public String getTaxAmountbz() {
        return taxAmountbz;
    }

    public void setTaxAmountbz(String taxAmountbz) {
        this.taxAmountbz = taxAmountbz;
    }

    public void setInvoiceAmount(List invoiceAmount) {
        this.invoiceAmount = invoiceAmount;
    }

    public List getTaxAmounts() {
        return taxAmounts;
    }

    public void setTaxAmounts(List taxAmounts) {
        this.taxAmounts = taxAmounts;
    }

    public List getTaxAmountTotal() {
        return taxAmountTotal;
    }

    public int getPage() {
        return page;
    }

    public void setPage(int page) {
        this.page = page;
    }

    public int getPagesize() {
        return pagesize;
    }

    public void setPagesize(int pagesize) {
        this.pagesize = pagesize;
    }

    public void setTaxAmountTotal(List taxAmountTotal) {
        this.taxAmountTotal = taxAmountTotal;
    }

    public String getOrganization1() {
        return organization1;
    }

    public void setOrganization1(String organization1) {
        this.organization1 = organization1;
    }

    public String getTaxAmountTotalFlag1() {
        return taxAmountTotalFlag1;
    }

    public void setTaxAmountTotalFlag1(String taxAmountTotalFlag1) {
        this.taxAmountTotalFlag1 = taxAmountTotalFlag1;
    }

    public String getTaxAmountTotalFlag2() {
        return taxAmountTotalFlag2;
    }

    public void setTaxAmountTotalFlag2(String taxAmountTotalFlag2) {
        this.taxAmountTotalFlag2 = taxAmountTotalFlag2;
    }

    public String getTaxAmountTotalFlag3() {
        return taxAmountTotalFlag3;
    }

    public void setTaxAmountTotalFlag3(String taxAmountTotalFlag3) {
        this.taxAmountTotalFlag3 = taxAmountTotalFlag3;
    }

    public String getTaxAmountTotalFlag4() {
        return taxAmountTotalFlag4;
    }

    public void setTaxAmountTotalFlag4(String taxAmountTotalFlag4) {
        this.taxAmountTotalFlag4 = taxAmountTotalFlag4;
    }

    public String getTaxAmountTotalFlag5() {
        return taxAmountTotalFlag5;
    }

    public void setTaxAmountTotalFlag5(String taxAmountTotalFlag5) {
        this.taxAmountTotalFlag5 = taxAmountTotalFlag5;
    }

    public String getTaxAmountTotalFlag6() {
        return taxAmountTotalFlag6;
    }

    public void setTaxAmountTotalFlag6(String taxAmountTotalFlag6) {
        this.taxAmountTotalFlag6 = taxAmountTotalFlag6;
    }

    public String getTaxAmountTotalFlag7() {
        return taxAmountTotalFlag7;
    }

    public void setTaxAmountTotalFlag7(String taxAmountTotalFlag7) {
        this.taxAmountTotalFlag7 = taxAmountTotalFlag7;
    }

    public String getTaxAmountFlag1() {
        return taxAmountFlag1;
    }

    public void setTaxAmountFlag1(String taxAmountFlag1) {
        this.taxAmountFlag1 = taxAmountFlag1;
    }

    public String getTaxAmountFlag2() {
        return taxAmountFlag2;
    }

    public void setTaxAmountFlag2(String taxAmountFlag2) {
        this.taxAmountFlag2 = taxAmountFlag2;
    }

    public String getTaxAmountFlag3() {
        return taxAmountFlag3;
    }

    public void setTaxAmountFlag3(String taxAmountFlag3) {
        this.taxAmountFlag3 = taxAmountFlag3;
    }

    public String getTaxAmountFlag4() {
        return taxAmountFlag4;
    }

    public void setTaxAmountFlag4(String taxAmountFlag4) {
        this.taxAmountFlag4 = taxAmountFlag4;
    }

    public String getTaxAmountFlag5() {
        return taxAmountFlag5;
    }

    public void setTaxAmountFlag5(String taxAmountFlag5) {
        this.taxAmountFlag5 = taxAmountFlag5;
    }

    public String getTaxAmountFlag6() {
        return taxAmountFlag6;
    }

    public void setTaxAmountFlag6(String taxAmountFlag6) {
        this.taxAmountFlag6 = taxAmountFlag6;
    }

    public String getTaxAmountFlag7() {
        return taxAmountFlag7;
    }

    public void setTaxAmountFlag7(String taxAmountFlag7) {
        this.taxAmountFlag7 = taxAmountFlag7;
    }

    public String getNetAmountFlag1() {
        return netAmountFlag1;
    }

    public void setNetAmountFlag1(String netAmountFlag1) {
        this.netAmountFlag1 = netAmountFlag1;
    }

    public String getNetAmountFlag2() {
        return netAmountFlag2;
    }

    public void setNetAmountFlag2(String netAmountFlag2) {
        this.netAmountFlag2 = netAmountFlag2;
    }

    public String getNetAmountFlag3() {
        return netAmountFlag3;
    }

    public void setNetAmountFlag3(String netAmountFlag3) {
        this.netAmountFlag3 = netAmountFlag3;
    }

    public String getNetAmountFlag4() {
        return netAmountFlag4;
    }

    public void setNetAmountFlag4(String netAmountFlag4) {
        this.netAmountFlag4 = netAmountFlag4;
    }

    public String getNetAmountFlag5() {
        return netAmountFlag5;
    }

    public void setNetAmountFlag5(String netAmountFlag5) {
        this.netAmountFlag5 = netAmountFlag5;
    }

    public String getNetAmountFlag6() {
        return netAmountFlag6;
    }

    public void setNetAmountFlag6(String netAmountFlag6) {
        this.netAmountFlag6 = netAmountFlag6;
    }

    public String getNetAmountFlag7() {
        return netAmountFlag7;
    }

    public void setNetAmountFlag7(String netAmountFlag7) {
        this.netAmountFlag7 = netAmountFlag7;
    }

    @Transient
    private Double netAmountFrom;
    @Transient
    private Double netAmountTo;

    public Double getTaxAmountFrom() {
        return taxAmountFrom;
    }

    public void setTaxAmountFrom(Double taxAmountFrom) {
        this.taxAmountFrom = taxAmountFrom;
    }

    public Double getTaxAmountTo() {
        return taxAmountTo;
    }

    public void setTaxAmountTo(Double taxAmountTo) {
        this.taxAmountTo = taxAmountTo;
    }

    public Double getTaxAmountTotalFrom() {
        return taxAmountTotalFrom;
    }

    public void setTaxAmountTotalFrom(Double taxAmountTotalFrom) {
        this.taxAmountTotalFrom = taxAmountTotalFrom;
    }

    public Double getTaxAmountTotalTo() {
        return taxAmountTotalTo;
    }

    public void setTaxAmountTotalTo(Double taxAmountTotalTo) {
        this.taxAmountTotalTo = taxAmountTotalTo;
    }

    public Double getNetAmountFrom() {
        return netAmountFrom;
    }

    public void setNetAmountFrom(Double netAmountFrom) {
        this.netAmountFrom = netAmountFrom;
    }

    public Double getNetAmountTo() {
        return netAmountTo;
    }

    public void setNetAmountTo(Double netAmountTo) {
        this.netAmountTo = netAmountTo;
    }

    public String getCashflowIds() {
        return cashflowIds;
    }

    public void setCashflowIds(String cashflowIds) {
        this.cashflowIds = cashflowIds;
    }

    public String getTaxpayerType() {
        return taxpayerType;
    }

    public void setTaxpayerType(String taxpayerType) {
        this.taxpayerType = taxpayerType;
    }

    public Date getSignDate() {
        return signDate;
    }

    public void setSignDate(Date signDate) {
        this.signDate = signDate;
    }

    public String getDivision() {
        return division;
    }

    public void setDivision(String division) {
        this.division = division;
    }

    public String getInvoiceCalculateType() {
        return invoiceCalculateType;
    }

    public void setInvoiceCalculateType(String invoiceCalculateType) {
        this.invoiceCalculateType = invoiceCalculateType;
    }

    public double getBillingAmount() {
        return billingAmount;
    }

    public void setBillingAmount(double billingAmount) {
        this.billingAmount = billingAmount;
    }

    public double getDueAmount() {
        return dueAmount;
    }

    public void setDueAmount(double dueAmount) {
        this.dueAmount = dueAmount;
    }

    public double getRadio() {
        return radio;
    }

    public void setRadio(double radio) {
        this.radio = radio;
    }

    @Transient

    private double radio;

    public List<HlsCusAcrInvoiceLn> getAcrInvoiceLnList() {
        return acrInvoiceLnList;
    }

    @Transient
    private String companyFullName;
    @Transient
    private String contractName;
    @Transient
    private String contractNumber;

    public String getCompanyFullName() {
        return companyFullName;
    }

    public void setAcrInvoiceLnList(List<HlsCusAcrInvoiceLn> acrInvoiceLnList) {
        this.acrInvoiceLnList = acrInvoiceLnList;
    }

    @Transient
    private String invoiceKindDesc;

    public String getInvoiceKindDesc() {
        return invoiceKindDesc;
    }

    public void setInvoiceKindDesc(String invoiceKindDesc) {
        this.invoiceKindDesc = invoiceKindDesc;
    }

    @Transient
    private String cfItemDesc;
    @Transient
    private Long cfItem;

    public String getCfItemDesc() {
        return cfItemDesc;
    }

    public void setCfItemDesc(String cfItemDesc) {
        this.cfItemDesc = cfItemDesc;
    }

    public Long getCfItem() {
        return cfItem;
    }

    public void setCfItem(Long cfItem) {
        this.cfItem = cfItem;
    }

    @Transient
    @Children
    List<HlsCusAcrInvoiceLn> acrInvoiceLnList;

    public Long getRanks() {
        return ranks;
    }

    public void setRanks(Long ranks) {
        this.ranks = ranks;
    }

    public void setCompanyFullName(String companyFullName) {
        this.companyFullName = companyFullName;
    }

    public String getContractName() {
        return contractName;
    }

    public void setContractName(String contractName) {
        this.contractName = contractName;
    }

    public String getContractNumber() {
        return contractNumber;
    }

    public void setContractNumber(String contractNumber) {
        this.contractNumber = contractNumber;
    }

    @Transient
    private String groupByFlag;

    @Transient
    private String lnGroupByFlag;

    @Transient
    private List<Long> queryList;

    @Transient
    private Long times;

    @Transient
    private Long cfType;

    @Transient
    private Double billingPrincipal;
    @Transient
    private Double billingInterest;


    public Double getBillingPrincipal() {
        return billingPrincipal;
    }

    public void setBillingPrincipal(Double billingPrincipal) {
        this.billingPrincipal = billingPrincipal;
    }

    public Double getBillingInterest() {
        return billingInterest;
    }

    public void setBillingInterest(Double billingInterest) {
        this.billingInterest = billingInterest;
    }

    public Long getTimes() {
        return times;
    }

    public void setTimes(Long times) {
        this.times = times;
    }

    public Long getCfType() {
        return cfType;
    }

    public void setCfType(Long cfType) {
        this.cfType = cfType;
    }

    public String getLnGroupByFlag() {
        return lnGroupByFlag;
    }

    public void setLnGroupByFlag(String lnGroupByFlag) {
        this.lnGroupByFlag = lnGroupByFlag;
    }

    public String getCashflowIdStr() {
        return cashflowIdStr;
    }

    public void setCashflowIdStr(String cashflowIdStr) {
        this.cashflowIdStr = cashflowIdStr;
    }

    public String getGroupByFlag() {
        return groupByFlag;
    }

    public void setGroupByFlag(String groupByFlag) {
        this.groupByFlag = groupByFlag;
    }

    public List<Long> getQueryList() {
        return queryList;
    }

    public void setQueryList(List<Long> queryList) {
        this.queryList = queryList;
    }

    public Long getContractId() {
        return contractId;
    }

    public void setContractId(Long contractId) {
        this.contractId = contractId;
    }

    public Long getCashflowId() {
        return cashflowId;
    }

    public void setCashflowId(Long cashflowId) {
        this.cashflowId = cashflowId;
    }

    public Double getWriteOffDueAmount() {
        return writeOffDueAmount;
    }

    public void setWriteOffDueAmount(Double writeOffDueAmount) {
        this.writeOffDueAmount = writeOffDueAmount;
    }

    public double getWriteOffInterest() {
        return writeOffInterest;
    }

    public void setWriteOffInterest(double writeOffInterest) {
        this.writeOffInterest = writeOffInterest;
    }

    public double getWriteOffPrincipal() {
        return writeOffPrincipal;
    }

    public void setWriteOffPrincipal(double writeOffPrincipal) {
        this.writeOffPrincipal = writeOffPrincipal;
    }

    public double getTotalInterest() {
        return totalInterest;
    }

    public void setTotalInterest(double totalInterest) {
        this.totalInterest = totalInterest;
    }

    public double getTotalPrincipal() {
        return totalPrincipal;
    }

    public void setTotalPrincipal(double totalPrincipal) {
        this.totalPrincipal = totalPrincipal;
    }

    @Transient
    private double totalPrincipal;

    @Transient
    private String sourceDocumentCategory;

    @Transient
    private Long sourceDocumentId;


    @Transient
    private Double principal;
    @Transient
    private Double interest;
    @Transient
    private Double receivedAmount;
    @Transient
    private Double receivedInterest;
    @Transient
    private Double taxTypeRate;
    @Transient
    private String taxableServiceName;

    public String getTaxableServiceName() {
        return taxableServiceName;
    }

    public void setTaxableServiceName(String taxableServiceName) {
        this.taxableServiceName = taxableServiceName;
    }

    public Double getTaxTypeRate() {
        return taxTypeRate;
    }

    public void setTaxTypeRate(Double taxTypeRate) {
        this.taxTypeRate = taxTypeRate;
    }

    public Double getPrincipal() {
        return principal;
    }

    public void setPrincipal(Double principal) {
        this.principal = principal;
    }

    public Double getInterest() {
        return interest;
    }

    public void setInterest(Double interest) {
        this.interest = interest;
    }

    public Double getReceivedAmount() {
        return receivedAmount;
    }

    public void setReceivedAmount(Double receivedAmount) {
        this.receivedAmount = receivedAmount;
    }

    public Double getReceivedInterest() {
        return receivedInterest;
    }

    public void setReceivedInterest(Double receivedInterest) {
        this.receivedInterest = receivedInterest;
    }

    public String getSourceDocumentCategory() {
        return sourceDocumentCategory;
    }

    public void setSourceDocumentCategory(String sourceDocumentCategory) {
        this.sourceDocumentCategory = sourceDocumentCategory;
    }

    public Long getSourceDocumentId() {
        return sourceDocumentId;
    }

    public void setSourceDocumentId(Long sourceDocumentId) {
        this.sourceDocumentId = sourceDocumentId;
    }

    public Long getInvoiceHdId() {
        return invoiceHdId;
    }

    public void setInvoiceHdId(Long invoiceHdId) {
        this.invoiceHdId = invoiceHdId;
    }

    public Long getCompanyId() {
        return companyId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public String getDocumentNumber() {
        return documentNumber;
    }

    public void setDocumentNumber(String documentNumber) {
        this.documentNumber = documentNumber == null ? null : documentNumber.trim();
    }

    public String getDocumentType() {
        return documentType;
    }

    public void setDocumentType(String documentType) {
        this.documentType = documentType == null ? null : documentType.trim();
    }

    public String getDocumentCategory() {
        return documentCategory;
    }

    public void setDocumentCategory(String documentCategory) {
        this.documentCategory = documentCategory == null ? null : documentCategory.trim();
    }

    public String getBusinessType() {
        return businessType;
    }

    public void setBusinessType(String businessType) {
        this.businessType = businessType == null ? null : businessType.trim();
    }

    public String getBillingMethod() {
        return billingMethod;
    }

    public void setBillingMethod(String billingMethod) {
        this.billingMethod = billingMethod == null ? null : billingMethod.trim();
    }

    public String getInvoiceKind() {
        return invoiceKind;
    }

    public void setInvoiceKind(String invoiceKind) {
        this.invoiceKind = invoiceKind == null ? null : invoiceKind.trim();
    }

    public Long getBpId() {
        return bpId;
    }

    public void setBpId(Long bpId) {
        this.bpId = bpId;
    }

    public String getBpName() {
        return bpName;
    }

    public void setBpName(String bpName) {
        this.bpName = bpName == null ? null : bpName.trim();
    }

    public String getBpTaxRegistryNum() {
        return bpTaxRegistryNum;
    }

    public void setBpTaxRegistryNum(String bpTaxRegistryNum) {
        this.bpTaxRegistryNum = bpTaxRegistryNum == null ? null : bpTaxRegistryNum.trim();
    }

    public String getBpAddressPhoneNum() {
        return bpAddressPhoneNum;
    }

    public void setBpAddressPhoneNum(String bpAddressPhoneNum) {
        this.bpAddressPhoneNum = bpAddressPhoneNum == null ? null : bpAddressPhoneNum.trim();
    }

    public String getBpBankAccount() {
        return bpBankAccount;
    }

    public void setBpBankAccount(String bpBankAccount) {
        this.bpBankAccount = bpBankAccount == null ? null : bpBankAccount.trim();
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description == null ? null : description.trim();
    }


    public Double getTotalAmount() {
        return totalAmount;
    }

    public Double getNetAmount() {
        return netAmount;
    }

    public Double getTaxAmount() {
        return taxAmount;
    }

    public void setTaxAmount(Double taxAmount) {
        this.taxAmount = taxAmount;
    }

    public String getCurrency() {
        return currency;
    }

    public void setCurrency(String currency) {
        this.currency = currency == null ? null : currency.trim();
    }

    public Date getInvoiceDate() {
        return invoiceDate;
    }

    public void setInvoiceDate(Date invoiceDate) {
        this.invoiceDate = invoiceDate;
    }

    public String getInvoiceNumber() {
        return invoiceNumber;
    }

    public void setInvoiceNumber(String invoiceNumber) {
        this.invoiceNumber = invoiceNumber == null ? null : invoiceNumber.trim();
    }

    public String getInvoiceStatus() {
        return invoiceStatus;
    }

    public void setInvoiceStatus(String invoiceStatus) {
        this.invoiceStatus = invoiceStatus == null ? null : invoiceStatus.trim();
    }

    public String getReversedFlag() {
        return reversedFlag;
    }

    public void setReversedFlag(String reversedFlag) {
        this.reversedFlag = reversedFlag == null ? null : reversedFlag.trim();
    }

    public Date getReverseDate() {
        return reverseDate;
    }

    public void setReverseDate(Date reverseDate) {
        this.reverseDate = reverseDate;
    }

    public Long getSourceInvoiceHeaderId() {
        return sourceInvoiceHeaderId;
    }

    public void setSourceInvoiceHeaderId(Long sourceInvoiceHeaderId) {
        this.sourceInvoiceHeaderId = sourceInvoiceHeaderId;
    }


    public Long getConfirmedBy() {
        return confirmedBy;
    }

    public void setConfirmedBy(Long confirmedBy) {
        this.confirmedBy = confirmedBy;
    }

    public Date getConfirmedDate() {
        return confirmedDate;
    }

    public void setConfirmedDate(Date confirmedDate) {
        this.confirmedDate = confirmedDate;
    }

    public Date getPostedDate() {
        return postedDate;
    }

    public void setPostedDate(Date postedDate) {
        this.postedDate = postedDate;
    }

    public Long getPostedBy() {
        return postedBy;
    }

    public void setPostedBy(Long postedBy) {
        this.postedBy = postedBy;
    }

    public Date getReceiptDate() {
        return receiptDate;
    }

    public void setReceiptDate(Date receiptDate) {
        this.receiptDate = receiptDate;
    }

    public Long getSourceId() {
        return sourceId;
    }

    public void setSourceId(Long sourceId) {
        this.sourceId = sourceId;
    }
}
