package hls.core.vat.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.vat.dto.HlsCusAcpInvoiceHd;
import hls.core.vat.mapper.HlsCusAcpInvoiceHdMapper;
import hls.core.vat.service.AcpInvoiceHdService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

@Service
@Transactional
public class AcpInvoiceHdServiceImpl extends BaseServiceImpl<HlsCusAcpInvoiceHd> implements AcpInvoiceHdService {
    @Autowired
    HlsCusAcpInvoiceHdMapper mapper;


    @Override
    public List<HlsCusAcpInvoiceHd> acpInvoiceQuery(Map<String, String> map) {

        Map<String, Object> params = new HashMap<String, Object>();


        params.put("count", map.get("count"));
        params.put("diff", map.get("diff"));
        params.put("flag", map.get("flag"));

        String[] Items = null;

        if (map.get("cashflowItems") != "") {
            Items = map.get("cashflowItems").split("、");


        }
        params.put("cashflowItems", Items);
        params.put("amountFrom", map.get("amountFrom"));
        params.put("amountTo", map.get("amountTo"));
        params.put("contractInfo", map.get("contractInfo"));
        params.put("timesFrom", map.get("timesFrom"));
        params.put("timesTo", map.get("timesTo"));


        return mapper.acpInvoiceQuery(params);
    }

    public List<HlsCusAcpInvoiceHd> acpInvoiceScaleQuery() {
        return mapper.acpInvoiceScaleQuery();
    }

    public List<HlsCusAcpInvoiceHd> acpInvoicedTotleQuery() {
        List<HlsCusAcpInvoiceHd> list = mapper.acpInvoicedTotleQuery();
        List<HlsCusAcpInvoiceHd> list1 = new LinkedList<HlsCusAcpInvoiceHd>();
        HlsCusAcpInvoiceHd[] cpInvoiceHds = new HlsCusAcpInvoiceHd[6];
        for (int i = 0; i < cpInvoiceHds.length; i++) {
            cpInvoiceHds[i] = new HlsCusAcpInvoiceHd();
        }
        cpInvoiceHds[0].setCfItem((long) (-99));
        cpInvoiceHds[0].setTotalAmount((double) 0);
        cpInvoiceHds[1].setCfItem((long) 1);
        cpInvoiceHds[1].setTotalAmount((double) 0);
        cpInvoiceHds[2].setCfItem((long) 2);
        cpInvoiceHds[2].setTotalAmount((double) 0);
        cpInvoiceHds[3].setCfItem((long) 3);
        cpInvoiceHds[3].setTotalAmount((double) 0);
        cpInvoiceHds[4].setCfItem((long) 8);
        cpInvoiceHds[4].setTotalAmount((double) 0);
        cpInvoiceHds[5].setCfItem((long) 9);
        cpInvoiceHds[5].setTotalAmount((double) 0);

        double sum = 0;
        for (int i = 0; i < list.size(); i++) {
            HlsCusAcpInvoiceHd acp = list.get(i);
            if (acp.getCfItem() == 1 || acp.getCfItem() == 2 || acp.getCfItem() == 3 || acp.getCfItem() == 8 || acp.getCfItem() == 9) {
                for (int j = 0; j < cpInvoiceHds.length; j++) {
                    if (acp.getCfItem() == cpInvoiceHds[j].getCfItem())
                        cpInvoiceHds[j] = acp;
                    cpInvoiceHds[j].setSpecialNum(acp.getSpecialNum());
                    cpInvoiceHds[j].setNormalNum(acp.getNormalNum());
                }
            }
            else
            {
                sum = sum + acp.getTotalAmount();
            }
        }
        cpInvoiceHds[0].setTotalAmount(sum);
        for (int i = 0; i < cpInvoiceHds.length; i++) {
            list1.add(cpInvoiceHds[i]);
        }
        return list1;
    }

    @Override
    public List<HlsCusAcpInvoiceHd> acpInvoicedGroupQuery(IRequest requestContext) {
        Long companyId = requestContext.getCompanyId();
        return mapper.acpInvoicedGroupQuery(companyId);
    }

}
