package hls.core.vat.service.impl;

import java.math.BigDecimal;
import java.util.*;

import hls.core.vat.dto.HlsCusAcrInvoiceHd;
import hls.core.vat.dto.HlsCusAcrInvoiceLn;
import hls.core.vat.mapper.HlsCusAcrInvoiceHdMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import hls.core.vat.mapper.HlsCusAcrInvoiceLnMapper;
import hls.core.vat.service.AcrInvoiceCommon;

@Service
@Transactional
public class AcrInvoiceCashflowServiceImpl implements AcrInvoiceCommon {

    @Autowired
    HlsCusAcrInvoiceHdMapper mapper;

    @Autowired
    HlsCusAcrInvoiceLnMapper ldMapper;

    private static final String groupByFlag = "CASHFLOW";

    @Override
    public String getGroupByFlag() {
        return groupByFlag;
    }

    @Override
    public List<HlsCusAcrInvoiceHd> query(IRequest iRequest, HlsCusAcrInvoiceHd acrInvoiceHd, int page, int pagesize) {
        PageHelper.startPage(page, pagesize);
        List<HlsCusAcrInvoiceHd> maps = mapper.queryAcrHdFromConCash(acrInvoiceHd);
        HlsCusAcrInvoiceHd invoiceHd = null;
        if (maps.size() != 0) {
            for (int i = 0; i < maps.size(); i++) {
                String[] cashflowIds = maps.get(i).getCashflowId().toString().split(",");
                Map<String, Object> cashflowIdMap = new HashMap<String, Object>();
                cashflowIdMap.put("cashflowIds",  cashflowIds);
                cashflowIdMap.put("cfItem",maps.get(i).getCfItem());
                List<HlsCusAcrInvoiceLn> lnList = ldMapper.queryAcrLnFromCashFlow(cashflowIdMap);
                maps.get(i).setNetAmount(maps.get(i).getTotalAmount());
                double sumAmount = 0d;
                if (lnList.size() != 0) {
                    String taxableServiceName = "";
//                    for (int k = 0; k < lnList.size(); k++) {
//                        //本金
//                        if(maps.get(i).getCfItem().compareTo(100L) ==0 ){
//                            lnList.get(k).setNetAmount(divide(lnList.get(k).getReceivedPrincipal(), add(1d, lnList.get(k).getTaxTypeRate())));
//                            lnList.get(k).setReceivedAmount(lnList.get(k).getReceivedPrincipal());
//                            lnList.get(k).setTotalAmount(lnList.get(k).getReceivedPrincipal());
//                            lnList.get(k).setReceivedInterest(0L);
//                            lnList.get(k).setValidateAmount(lnList.get(k).getReceivedPrincipal());
//                            lnList.get(k).setCfItem(100L);
//                            lnList.get(k).setCfItemDesc("本金");
//                        }
//                        //利息
//                        else if(maps.get(i).getCfItem().compareTo(101L) ==0 ){
//                            lnList.get(k).setNetAmount(divide(lnList.get(k).getReceivedInterest(), add(1d, lnList.get(k).getTaxTypeRate())));
//                            lnList.get(k).setReceivedAmount(lnList.get(k).getReceivedInterest());
//                            lnList.get(k).setTotalAmount(lnList.get(k).getReceivedInterest());
//                            lnList.get(k).setReceivedPrincipal(0L);
//                            lnList.get(k).setValidateAmount(lnList.get(k).getReceivedInterest());
//                            lnList.get(k).setCfItem(101L);
//                            lnList.get(k).setCfItemDesc("利息");
//                        }
//                        if (lnList.get(k).getTaxTypeRate() == null) {
//                            lnList.get(k).setTaxTypeRate(0d);
//                            lnList.get(k).setNetAmount(lnList.get(k).getReceivedInterest());
//                            lnList.get(k).setValidateAmount(lnList.get(k).getReceivedInterest());
//                        } else {
//                            lnList.get(k).setNetAmount(divide(lnList.get(k).getReceivedAmount(), add(1d, lnList.get(k).getTaxTypeRate())));
//                            lnList.get(k).setValidateAmount(lnList.get(k).getReceivedAmount());
//                        }
//
//
//                        if (lnList.get(k).getMergeRentalFlag().equals('Y')) {
//                            if (taxableServiceName.equals("")) {
//                                taxableServiceName = lnList.get(k).getTaxableServiceName();
//                            }
//                            lnList.get(k).setProductName(taxableServiceName);
//                        } else {
//                            lnList.get(k).setProductName(lnList.get(k).getTaxableServiceName());
//
//                        }
//                        lnList.get(k).setAcrInvoiceHdRanks(maps.get(i).getRanks());
//                        lnList.get(k).setTaxAmount(multiply(lnList.get(k).getNetAmount(), lnList.get(k).getTaxTypeRate()));
//                        lnList.get(k).setTotalAmount(lnList.get(k).getReceivedAmount());
//                        sumAmount = add(sumAmount, lnList.get(k).getTotalAmount());
//                    }
                }
                maps.get(i).setAcrInvoiceLnList(lnList);
                maps.get(i).setTotalAmount(sumAmount);
            }
        }
        return maps;
    }



    private double add(Double a, Double b) {
        BigDecimal aa = new BigDecimal(a.toString());
        BigDecimal bb = new BigDecimal(b.toString());

        return aa.add(bb).setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
    }
    private double subtract(Double a, Double b) {
        BigDecimal aa = new BigDecimal(a.toString());
        BigDecimal bb = new BigDecimal(b.toString());

        return aa.subtract(bb).setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
    }
    private double divide(Double a, Double b) {
        BigDecimal aa = new BigDecimal(a.toString());
        BigDecimal bb = new BigDecimal(b.toString());
        return aa.divide(bb, 3, BigDecimal.ROUND_HALF_UP).doubleValue();
    }
    public Double multiply(Double a, Double b) {
        BigDecimal aa = new BigDecimal(a.toString());
        BigDecimal bb = new BigDecimal(b.toString());

        return aa.multiply(bb).setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
    }
//    private List<HlsCusAcrInvoiceHd> principalAndInterestSplit(List<HlsCusConContractCashflow> cashflowList){
//
//        if (cashflowList != null && cashflowList.size() > 0) {
//            Iterator<HlsCusConContractCashflow> iterator = cashflowList.iterator();
//            while (iterator.hasNext()) {
//                HlsCusConContractCashflow next = iterator.next();
//                // 以现金流为维度，判断cfItem 是否等于1,否不处理
//                if (next.getCf_item().compareTo(1L) == 0 && next.getCf_item().compareTo(next.getBsCfItem()) != 0  && next.getVatModifyFlag() != 1) {
//                    //BsCfItem不等于cfItem说明配置的开票规则将租金分成了本金和利息
//                    //找到对应的两条现金流,确定它们的 mergeRentalFlag 字段是否都为 Y
//                    HlsCusAcrInvoiceHd acrInvoiceHd = null;
//                    for (HlsCusConContractCashflow ccc2 : cashflowList) {
//                        if (next.getCashflow_id().compareTo(ccc2.getC()) == 0  && next.getBsCfItem().compareTo(ccc2.getBsCfItem()) != 0) {
//                            acrInvoiceHd = ccc2;
//                        }
//                    }
//                    if (acrInvoiceHd != null) {
//                        //mergeRentalFlag 字段都为 Y ,则从List中删除一条cashflow
//                        if (acrInvoiceHd.getMergeRentalFlag().equals("Y") && next.getMergeRentalFlag().equals("Y")) {
//                            iterator.remove();
//                        }
//                        //否则修改销项发票头,100的改为本金,101的改为利息, 更新modifyFlag为1
//                        else {
//                            if (next.getBsCfItem().compareTo(100L) == 0 ) {
//                                next.setCfItem(100L);
//                                next.setWriteOffDueAmount(next.getWriteOffPrincipal());
//                                next.setWriteOffInterest(0L);
//                                next.setTotalAmount(next.getTotalPrincipal());
//                                next.setTotalInterest(0L);
//                                next.setVatModifyFlag(1);
//
//                                acrInvoiceHd.setCfItem(101L);
//                                acrInvoiceHd.setWriteOffDueAmount(acrInvoiceHd.getWriteOffInterest());
//                                acrInvoiceHd.setWriteOffPrincipal(0L);
//                                acrInvoiceHd.setTotalAmount(acrInvoiceHd.getWriteOffInterest());
//                                acrInvoiceHd.setWriteOffPrincipal(0L);
//                                acrInvoiceHd.setVatModifyFlag(1);
//
//                            }else if (next.getBsCfItem().compareTo(101L) == 0){
//                                acrInvoiceHd.setCfItem(100L);
//                                acrInvoiceHd.setWriteOffDueAmount(acrInvoiceHd.getWriteOffPrincipal());
//                                acrInvoiceHd.setWriteOffInterest(0L);
//                                acrInvoiceHd.setTotalAmount(acrInvoiceHd.getTotalPrincipal());
//                                acrInvoiceHd.setTotalInterest(0L);
//                                acrInvoiceHd.setVatModifyFlag(1);
//
//                                next.setCfItem(101L);
//                                next.setWriteOffDueAmount(next.getWriteOffInterest());
//                                next.setWriteOffPrincipal(0L);
//                                next.setTotalAmount(next.getWriteOffInterest());
//                                next.setWriteOffPrincipal(0L);
//                                next.setVatModifyFlag(1);
//                            }
//
//                        }
//                    }
//                }
//            }
//        }
//        Iterator<HlsCusAcrInvoiceHd> iterator2 = AcrInvoiceHdList.iterator();
//        while (iterator2.hasNext()) {
//            HlsCusAcrInvoiceHd next2 = iterator2.next();
//            if(next2.getWriteOffDueAmount().compareTo(0d) == 0 ){
//                iterator2.remove();
//            }
//        }
//        return  AcrInvoiceHdList;
//    }




}
