package hls.core.vat.service.impl;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import hls.core.fnd.service.FndCodingRuleValuesService;
import hls.core.vat.dto.AcrReceiptLn;
import hls.core.vat.service.IAcrReceiptLnService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import hls.core.vat.dto.AcrReceiptHd;
import hls.core.vat.service.IAcrReceiptHdService;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.util.*;

@Service
@Transactional(rollbackFor = Exception.class)
public class AcrReceiptHdServiceImpl extends BaseServiceImpl<AcrReceiptHd> implements IAcrReceiptHdService {


    @Autowired
    private FndCodingRuleValuesService fndCodingRuleValuesService;

    @Autowired
    private IAcrReceiptLnService accrReceiptLnService;


    @Override
    public void receiptCreate(IRequest iRequest, List<AcrReceiptHd> dto) {
            if(dto != null && dto.size() > 0 ){
                AcrReceiptHd acrReceiptHd = new AcrReceiptHd();
                acrReceiptHd.setCompanyId(iRequest.getCompanyId());
                acrReceiptHd.setReceiptDate(new Date());
                acrReceiptHd.setBpId(dto.get(0).getBpId());
                acrReceiptHd.setCurrency(dto.get(0).getCurrency());

                acrReceiptHd.setBusinessType("RECEIPT");
                acrReceiptHd.setDocumentType("RECEIPT");
                acrReceiptHd.setDocumentCategory("AR_RECEIPT");
                Map<String, String> params = new HashMap<String, String>();
                acrReceiptHd.setDocumentNumber(fndCodingRuleValuesService.getCodeRuleValue(iRequest, acrReceiptHd.getDocumentCategory(), acrReceiptHd.getDocumentType(), acrReceiptHd.getBusinessType(), params));
                acrReceiptHd.setReceiptStatus("NEW");
                acrReceiptHd.setTotalAmount(0d);
                dto.forEach(item ->{
                    acrReceiptHd.setTotalAmount(acrReceiptHd.getTotalAmount()+item.getAmount());
                });
                self().insert(iRequest,acrReceiptHd);

                List<AcrReceiptLn> acrReceiptLnList = new ArrayList<AcrReceiptLn>();
                dto.forEach(item -> {
                    AcrReceiptLn acrReceiptLn = new AcrReceiptLn();
                    acrReceiptLn.set__status("add");
                    acrReceiptLn.setReceiptHdId(item.getReceiptHdId());
                    acrReceiptLn.setSourceType(item.getSourceType());
                    acrReceiptLn.setSourceId(item.getSourceId());
                    acrReceiptLn.setAmount(item.getAmount());
                    acrReceiptLn.setReceiptHdId(acrReceiptHd.getReceiptHdId());
                    acrReceiptLnList.add(acrReceiptLn);

                });
                accrReceiptLnService.batchUpdate(iRequest,acrReceiptLnList);
            }
    }

//    @Override
//    public void gatheringReceiptCreate(IRequest iRequest, List<AcrReceiptHd> dto) {
//
//    }
}