package hls.core.websocket.components;

import com.hand.hap.message.websocket.WebSocketSessionManager;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.socket.TextMessage;
import org.springframework.web.socket.WebSocketSession;

import java.io.IOException;
import java.util.List;

/**
 * Created by fjm on 2018/1/24.
 */
@Component
public class MessageBoxManager {

    @Autowired
    private WebSocketSessionManager webSocketSessionManager;

    @Autowired
    private ObjectMapper objectMapper;

    public void onMessage(Object message,Long userId){
        List<WebSocketSession> session = webSocketSessionManager.getSession(userId);
        try {
            String s = objectMapper.writeValueAsString(message);
            session.forEach(item -> {
                try {
                    item.sendMessage(new TextMessage(s));
                } catch (IOException e) {
                    e.printStackTrace();
                }
            });
        } catch (IOException e) {
            e.printStackTrace();
        }


    }

}
