package hls.core.wfl.components;

import com.hand.hap.core.IRequest;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.mapper.HlsCusConContractMapper;
import hls.core.hls.dto.DocumentType;
import hls.core.hls.mapper.DocumentTypeMapper;
import hls.core.sys.event.service.SysEventCommonService;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import org.activiti.engine.delegate.DelegateExecution;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Map;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-08-21
 * Time: 19:29
 */
abstract class AbstractPaymentReqEventHandler implements SysEventCommonService {
    @Autowired
    private HlsCusConContractMapper conContractMapper;
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private DocumentTypeMapper documentTypeMapper;

    abstract String getMessage(String source,String contractName, String contractNum, String currency, String amount);

    abstract String getNoticeTitle();

    public long getLevel() {
        return 2L;
    }

    public String getSourceModel() {
        return SysEventCodeUtil.PROPERTITY_SOURCEMODULE_CSH;
    }

    public String getRelation() {
        return SysEventCodeUtil.PROPERTITY_RELATIONTYPE_P2D;
    }

    public String getCurrency(Map<String, Object> params) {
        return params.get("currency").toString();
    }

    public String getAmount(Map<String, Object> params) {
        return params.get("amount").toString();
    }

    @Override
    public String getDocumentCategory() {
        return null;
    }

    @Override
    public void process(IRequest iRequest, Long documentId, String documentCategory, String documentType, Map<String, Object> params) {
        String contractName = null;
        String contractNum = null;
        String source = null;
        DocumentType dt = new DocumentType();
        dt.setDocumentCategory(documentCategory);
        dt.setDocumentType(documentType);
        dt = documentTypeMapper.selectOne(dt);
        source = dt.getDescription();
        switch (documentCategory) {
            case "CON_CONTRACT":
                HlsCusConContract conContract = new HlsCusConContract();
                conContract.setContractId(documentId);
                conContract = conContractMapper.selectByPrimaryKey(conContract);
                contractName = conContract.getContractName();
                contractNum = conContract.getContractNumber();
                break;
            default:
                contractName = "";
                contractNum = "";
                break;
        }
        String message = getMessage(source, contractName, contractNum, getCurrency(params), getAmount(params));
        params.put("message", message);
        params.put("noticeTitle", getNoticeTitle());
        params.put("level", getLevel());
        params.put("noticeType", "NOTICE");

        sysEventService.eventSave(iRequest, documentId, documentCategory, documentType, getSourceModel(), getEventCode(), getRelation(), params);

    }

    @Override
    public void notice(DelegateExecution delegateExecution, String status) {

    }
}
