package hls.core.wfl.service.impl;

import com.hand.hap.core.AppContextInitListener;
import com.hand.hap.core.IRequest;
import hls.core.wfl.service.IActivitiCommonService;
import hls.core.wfl.service.IActivitiStartService;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;

/**
 * Created by Administrator on 2017/4/17.
 */

@Service
@Transactional
public class ActivitiStartServiceImpl implements AppContextInitListener,  IActivitiStartService {
    private Map<String, IActivitiCommonService> commonService = new HashMap<String, IActivitiCommonService>();

    @Override
    public void contextInitialized(ApplicationContext applicationContext) {
        Map<String, IActivitiCommonService> map = applicationContext.getBeansOfType(IActivitiCommonService.class);

        map.forEach((k, v) -> {
            commonService.put(v.getWorkFlowType(), v);
        });
    }

    @Override
    public void start(IRequest iRequest, List list, Map params) {

        String type = (String)params.get("workFlowType");
        IActivitiCommonService service = commonService.get(type);

        if(service != null)
        {
            service.process(iRequest,list,params);
        }
    }
}
