package hls.core.wfl.service.impl;

import com.hand.hap.activiti.dto.ReProcdef;
import com.hand.hap.activiti.service.IReProcdefService;
import com.hand.hap.core.IRequest;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.dto.HlsCusConContractChangeReq;
import hls.core.cont.service.ConContractChangeService;
import hls.core.cont.service.ConContractService;
import hls.core.csh.dto.HlsCusCshConContract;
import hls.core.lon.dto.HlsCusLonContractWithdraw;
import hls.core.sys.dto.SysUser;
import hls.core.sys.service.SysUserService;
import hls.core.wfl.service.IActivitiCommonService;
import org.activiti.rest.service.api.engine.variable.RestVariable;
import org.activiti.rest.service.api.runtime.process.ProcessInstanceCreateRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.hand.hap.activiti.service.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created by Administrator on 2017/4/18.
 */
@Service
@Transactional
public class ConChangeActivitiStartServiceImpl implements IActivitiCommonService {
    private static final String workFlowType = "CONTRACT_CHANGE";
    @Autowired
    private IActivitiService activitiService;
    @Autowired
    private IReProcdefService reProcdefService;
    @Autowired
    private ConContractService conContractService;
    @Autowired
    private SysUserService sysUserService;
    @Autowired
    private ConContractChangeService conContractChangeService;

    @Override
    public String getWorkFlowType() {
        return workFlowType;
    }

    @Override
    public void process(IRequest iRequest, List list, Map params) {
        ProcessInstanceCreateRequest processInstanceCreateRequest = getProcessInstanceCreateRequest((HlsCusConContractChangeReq) list.get(0), iRequest, params);

        activitiService.startProcess(iRequest, processInstanceCreateRequest);
    }

    private ProcessInstanceCreateRequest getProcessInstanceCreateRequest(HlsCusConContractChangeReq contractChangeReq, IRequest iRequest, Map params) {
        ProcessInstanceCreateRequest createRequest = new ProcessInstanceCreateRequest();
        ReProcdef reProcdefs = reProcdefService.queryReProcdef("CONTRACT_CHANGE_WORK_FLOW", "CON_CONTRACT");
        SysUser sysUser = sysUserService.selectUserById(iRequest.getUserId());
        String id = reProcdefs.getId_();
        String name = reProcdefs.getName_();
        createRequest.setProcessDefinitionId(id);
        createRequest.setBusinessKey(contractChangeReq.getChangeReqId().toString());
        String earlyTerminationFlag = contractChangeReq.getEarlyTerminationFlag();

        List<RestVariable> variables = new ArrayList<RestVariable>();
        List<RestVariable> transientVariables = new ArrayList<RestVariable>();
        RestVariable restVariable1 = new RestVariable();
        RestVariable restVariable2 = new RestVariable();
        RestVariable restVariable3 = new RestVariable();
        RestVariable restVariable4 = new RestVariable();
        RestVariable restVariable13 = new RestVariable();

        restVariable13.setName("startUserDescription");
        restVariable13.setValue(sysUser.getDescription());
        variables.add(restVariable13);

        restVariable1.setName("processDefinitionId");
        restVariable1.setValue(id);
        variables.add(restVariable1);

        restVariable2.setName("contractChangeReq");
        restVariable2.setValue(contractChangeReq);
        variables.add(restVariable2);

        restVariable3.setName("iRequest");
        restVariable3.setValue(iRequest);
        variables.add(restVariable3);

        restVariable4.setName("startUserName");
        restVariable4.setValue(iRequest.getEmployeeCode());
        variables.add(restVariable4);

        RestVariable restVariable5 = new RestVariable();
        RestVariable restVariable6 = new RestVariable();
        RestVariable restVariable7 = new RestVariable();

        restVariable5.setName("documentCategory");
        restVariable5.setValue("CON_CONTRACT_CHANGE");
        variables.add(restVariable5);
        restVariable6.setName("documentType");
        restVariable6.setValue("");
        variables.add(restVariable6);
        restVariable7.setName("documentId");
        restVariable7.setValue(contractChangeReq.getChangeReqId());
        variables.add(restVariable7);

        HlsCusCshConContract conContract = (HlsCusCshConContract) params.get("cshConContract");
        RestVariable restVariable8 = new RestVariable();
        restVariable8.setName("conContract");
        restVariable8.setValue(conContract);
        variables.add(restVariable8);

        RestVariable restVariable9 = new RestVariable();
        restVariable9.setName("pName");
        restVariable9.setValue(name);
        variables.add(restVariable9);

        RestVariable restVariable10 = new RestVariable();
        restVariable10.setName("contractId");
        restVariable10.setValue(contractChangeReq.getContractId());
        variables.add(restVariable10);

        HlsCusConContract conContract1 = conContractService.squerConContractById(contractChangeReq.getContractId());
        RestVariable restVariable11 = new RestVariable();
        restVariable11.setName("contractNumber");
        restVariable11.setValue(conContract1.getContractNumber());
        variables.add(restVariable11);

        RestVariable restVariable12 = new RestVariable();
        restVariable12.setName("contractName");
        restVariable12.setValue(conContract1.getContractName());
        variables.add(restVariable12);

        RestVariable restVariable14 = new RestVariable();
        restVariable14.setName("earlyTerminationFlag");
        restVariable14.setValue(earlyTerminationFlag);
        variables.add(restVariable14);

        RestVariable restVariable15 = new RestVariable();
        restVariable15.setName("actualSettlement");
        restVariable15.setValue(params.get("actualSettlement"));
        variables.add(restVariable15);

        RestVariable restVariable16 = new RestVariable();
        restVariable16.setName("workflowType");
        restVariable16.setValue(workFlowType);
        variables.add(restVariable16);

        createRequest.setVariables(variables);
        createRequest.setTransientVariables(transientVariables);

        return createRequest;
    }

    @Override
    public void cancel(IRequest iRequest, Map params) {
        String businessKey = (String) params.get("businessKey");
        String processInstanceId = (String) params.get("processInstanceId");
        long id = Long.parseLong(businessKey);
        long prcId = Long.parseLong(processInstanceId);
        HlsCusConContractChangeReq conContractChangeReq = new HlsCusConContractChangeReq();
        conContractChangeReq.setChangeReqId(id);
        conContractChangeReq.setStatus(CANCEL_STATUS);
        conContractChangeService.updateByPrimaryKeySelective(iRequest,conContractChangeReq);
    }
}
