package hls.core.wfl.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hand.hap.activiti.dto.ReProcdef;
import com.hand.hap.activiti.service.IReProcdefService;
import com.hand.hap.core.IRequest;
import hls.core.cont.dto.HlsCusConContractChangeReq;
import hls.core.csh.dto.HlsCusConDebtExemptionReq;
import hls.core.csh.dto.HlsCusConDebtExemptionReqCf;
import hls.core.csh.service.ConDebtExemptionReqCfService;
import hls.core.csh.service.ConDebtExemptionReqService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.service.SysUserService;
import hls.core.wfl.service.IActivitiCommonService;
import org.activiti.rest.service.api.engine.variable.RestVariable;
import org.activiti.rest.service.api.runtime.process.ProcessInstanceCreateRequest;
import org.activiti.rest.service.api.runtime.process.ProcessInstanceResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.hand.hap.activiti.service.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created by haibin on 2017/7/25.
 */
@Service
@Transactional
public class ConDebtActivitiStartServiceImpl implements IActivitiCommonService {
    private static final String workFlowType = "CON_DEBT";
    @Autowired
    private IActivitiService activitiService;
    @Autowired
    private IReProcdefService reProcdefService;
    @Autowired
    private SysUserService sysUserService;
    @Autowired
    private ConDebtExemptionReqService conDebtExemptionReqService;

    @Override
    public String getWorkFlowType() {
        return workFlowType;
    }

    @Override
    public void process(IRequest iRequest, List list, Map params) {
        ProcessInstanceCreateRequest createRequest = getProcessInstanceCreateRequest((HlsCusConDebtExemptionReqCf) list.get(0), iRequest, params);
        ProcessInstanceResponse process = activitiService.startProcess(iRequest, createRequest);
    }

    public ProcessInstanceCreateRequest getProcessInstanceCreateRequest(HlsCusConDebtExemptionReqCf conDebtExemptionReqCf, IRequest iRequest, Map params) {
        ProcessInstanceCreateRequest createRequest = new ProcessInstanceCreateRequest();
        ReProcdef reProcdefs = reProcdefService.queryReProcdef("CON_DEBT_EXEMPTION_WORK_FLOW", "CON_CONTRACT");
        SysUser sysUser = sysUserService.selectUserById(iRequest.getUserId());
        String id = reProcdefs.getId_();
        String name = reProcdefs.getName_();
        createRequest.setProcessDefinitionId(id);
        createRequest.setBusinessKey(conDebtExemptionReqCf.getChangeReqId().toString());

        List<RestVariable> variables = new ArrayList<RestVariable>();
        List<RestVariable> transientVariables = new ArrayList<RestVariable>();
        RestVariable restVariable1 = new RestVariable();
        RestVariable restVariable2 = new RestVariable();
        RestVariable restVariable3 = new RestVariable();
        RestVariable restVariable4 = new RestVariable();
        RestVariable restVariable5 = new RestVariable();
        RestVariable restVariable13 = new RestVariable();

        restVariable13.setName("startUserDescription");
        restVariable13.setValue(sysUser.getDescription());
        variables.add(restVariable13);

        restVariable1.setName("processDefinitionId");
        restVariable1.setValue(id);
        variables.add(restVariable1);

        restVariable2.setName("conDebtExemptionReqCf");
        JSONObject jsonObject = JSON.parseObject(JSON.toJSONString(conDebtExemptionReqCf));
        restVariable2.setValue(jsonObject.toString());
        variables.add(restVariable2);

        restVariable3.setName("iRequest");
        restVariable3.setValue(iRequest);
        variables.add(restVariable3);

        restVariable4.setName("startUserName");
        restVariable4.setValue(iRequest.getEmployeeCode());
        variables.add(restVariable4);

        restVariable5.setName("contractId");
        restVariable5.setValue(conDebtExemptionReqCf.getContractId());
        variables.add(restVariable5);


        RestVariable restVariable8 = new RestVariable();
        restVariable8.setName("pName");
        restVariable8.setValue(name);
        variables.add(restVariable8);

        RestVariable restVariable14 = new RestVariable();
        restVariable14.setName("workflowType");
        restVariable14.setValue(workFlowType);
        variables.add(restVariable14);

        RestVariable restVariable15 = new RestVariable();
        restVariable15.setName("documentCategory");
        restVariable15.setValue("CON_CONTRACT_INCEPT");
        variables.add(restVariable15);

        createRequest.setVariables(variables);
        createRequest.setTransientVariables(transientVariables);

        return createRequest;
    }

    @Override
    public void cancel(IRequest iRequest, Map params) {
        String businessKey = (String) params.get("businessKey");
        String processInstanceId = (String) params.get("processInstanceId");
        long id = Long.parseLong(businessKey);
        long prcId = Long.parseLong(processInstanceId);
        HlsCusConDebtExemptionReq conDebtExemptionReq = new HlsCusConDebtExemptionReq();
        conDebtExemptionReq.setChangeReqId(id);
        conDebtExemptionReq.setReqStatus(CANCEL_STATUS);
        conDebtExemptionReqService.updateByPrimaryKeySelective(iRequest,conDebtExemptionReq);
    }
}
