package hls.core.wfl.service.impl;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.dto.ReProcdef;
import com.hand.hap.activiti.service.IReProcdefService;
import com.hand.hap.core.IRequest;
import hls.core.cont.dto.ConContractSign;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.dto.HlsCusConContractSign;
import hls.core.cont.service.ConContractService;
import hls.core.cont.service.ConContractSignService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.service.SysUserService;
import hls.core.wfl.service.IActivitiCommonService;
import com.alibaba.fastjson.JSONObject;
import org.activiti.rest.service.api.engine.variable.RestVariable;
import org.activiti.rest.service.api.runtime.process.ProcessInstanceCreateRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.hand.hap.activiti.service.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created by Administrator on 2017/4/18.
 */
@Service
@Transactional
public class ConSignActivitiStartServiceImpl implements IActivitiCommonService {

    private static final String workFlowType = "CONTRACT_SIGN";

    @Autowired
    private IActivitiService activitiService;
    @Autowired
    private IReProcdefService reProcdefService;
    @Autowired
    private ConContractService conContractService;
    @Autowired
    private ConContractSignService conContractSignService;
    @Autowired
    private SysUserService sysUserService;

    @Override
    public String getWorkFlowType() {
        return workFlowType;
    }

    @Override
    public void process(IRequest iRequest, List list, Map params) {
        ProcessInstanceCreateRequest processInstanceCreateRequest = getProcessInstanceCreateRequest((HlsCusConContractSign) list.get(0), iRequest);

        activitiService.startProcess(iRequest, processInstanceCreateRequest);
    }

    private ProcessInstanceCreateRequest getProcessInstanceCreateRequest(HlsCusConContractSign contractSign, IRequest iRequest) {
        ProcessInstanceCreateRequest createRequest = new ProcessInstanceCreateRequest();
        ReProcdef reProcdefs = reProcdefService.queryReProcdef("CONTRACT_SIGN_WORK_FLOW", "CON_CONTRACT");
        SysUser sysUser = sysUserService.selectUserById(iRequest.getUserId());
        String id = reProcdefs.getId_();
        String name = reProcdefs.getName_();
        createRequest.setProcessDefinitionId(id);
        createRequest.setBusinessKey(contractSign.getContractSignId().toString());

        List<RestVariable> variables = new ArrayList<RestVariable>();
        List<RestVariable> transientVariables = new ArrayList<RestVariable>();
        RestVariable restVariable1 = new RestVariable();
        RestVariable restVariable2 = new RestVariable();
        RestVariable restVariable3 = new RestVariable();
        RestVariable restVariable4 = new RestVariable();
        RestVariable restVariable13 = new RestVariable();

        restVariable13.setName("startUserDescription");
        restVariable13.setValue(sysUser.getDescription());
        variables.add(restVariable13);

        restVariable1.setName("processDefinitionId");
        restVariable1.setValue(id);
        variables.add(restVariable1);

        restVariable2.setName("contractSign");
        JSONObject jsonObject = JSON.parseObject(JSON.toJSONString(contractSign));

        restVariable2.setValue(jsonObject.toString());
        variables.add(restVariable2);

        restVariable3.setName("iRequest");
        restVariable3.setValue(iRequest);
        variables.add(restVariable3);

        restVariable4.setName("startUserName");
        restVariable4.setValue(iRequest.getEmployeeCode());
        variables.add(restVariable4);

        RestVariable restVariable5 = new RestVariable();
        RestVariable restVariable6 = new RestVariable();
        RestVariable restVariable7 = new RestVariable();

        restVariable5.setName("documentCategory");
        restVariable5.setValue("CON_CONTRACT_SIGN");
        variables.add(restVariable5);
        restVariable6.setName("documentType");
        restVariable6.setValue("");
        variables.add(restVariable6);
        restVariable7.setName("documentId");
        restVariable7.setValue(contractSign.getContractSignId());
        variables.add(restVariable7);

        RestVariable restVariable9 = new RestVariable();
        restVariable9.setName("contractId");
        restVariable9.setValue(contractSign.getContractId());
        variables.add(restVariable9);

        RestVariable restVariable8 = new RestVariable();
        restVariable8.setName("pName");
        restVariable8.setValue(name);
        variables.add(restVariable8);

        HlsCusConContract conContract = conContractService.squerConContractById(contractSign.getContractId());

        RestVariable restVariable10 = new RestVariable();
        restVariable10.setName("contractNumber");
        restVariable10.setValue(conContract.getContractNumber());
        variables.add(restVariable10);

        RestVariable restVariable11 = new RestVariable();
        restVariable11.setName("contractName");
        restVariable11.setValue(conContract.getContractName());
        variables.add(restVariable11);

        RestVariable restVariable12 = new RestVariable();
        restVariable12.setName("workflowType");
        restVariable12.setValue(workFlowType);
        variables.add(restVariable12);

        createRequest.setVariables(variables);
        createRequest.setTransientVariables(transientVariables);

        return createRequest;
    }

    @Override
    public void cancel(IRequest iRequest, Map params) {
        String businessKey = (String) params.get("businessKey");
        String processInstanceId = (String) params.get("processInstanceId");
        long id = Long.parseLong(businessKey);
        long prcId = Long.parseLong(processInstanceId);
        HlsCusConContractSign conContractSign = new HlsCusConContractSign();
        conContractSign.setContractSignId(id);
        conContractSign.setStatus(CANCEL_STATUS);
        conContractSignService.updateByPrimaryKeySelective(iRequest,conContractSign);
    }
}
