package hls.core.wfl.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hand.hap.activiti.dto.ReProcdef;
import com.hand.hap.activiti.service.IActivitiService;
import com.hand.hap.activiti.service.IReProcdefService;
import com.hand.hap.core.IRequest;
import hls.core.fct.dto.*;
import hls.core.fct.service.*;
import hls.core.hls.dto.HlsCusHlsDocumentVersionRel;
import hls.core.hls.dto.HlsDocumentVersionRel;
import hls.core.hls.service.IHlsDocumentVersionRelService;
import hls.core.lon.dto.HlsCusLonContract;
import hls.core.lon.service.ILonContractService;
import hls.core.prj.dto.HlsCusHlsCreditLine;
import hls.core.prj.dto.HlsCusHlsDocumentVersion;
import hls.core.prj.dto.HlsDocumentVersion;
import hls.core.prj.service.HlsCreditLineService;
import hls.core.prj.service.HlsDocumentVersionService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.service.SysUserService;
import hls.core.wfl.service.IActivitiCommonService;
import org.activiti.rest.service.api.engine.variable.RestVariable;
import org.activiti.rest.service.api.runtime.process.ProcessInstanceCreateRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * Created by wangyan on 2017/11/13.
 */
@Service
@Transactional
public class CreditLineHActivitiStartServiceImpl implements IActivitiCommonService {
    private static final String workFlowType = "CREDIT_LINE_CHANGE";
    @Autowired
    private IActivitiService activitiService;
    @Autowired
    private IReProcdefService reProcdefService;
    @Autowired
    private HlsCreditLineService hlsCreditLineService;
    @Autowired
    private SysUserService sysUserService;
    @Autowired
    private HlsCreditLineApprovalService hlsCreditLineApprovalService;
    @Autowired
    private HlsCreditLineChangeReqService  hlsCreditLineChangeReqService;
    @Autowired
    private HlsDocumentVersionService hlsDocumentVersionService;
    @Autowired
    private IHlsDocumentVersionRelService iHlsDocumentVersionRelService;
    @Autowired(required = false)
    private HlsCusFctWflCustomService fctWflCustomService;
    @Override
    public String getWorkFlowType() {
        return workFlowType;
    }

    @Override
    public void process(IRequest iRequest, List list, Map params) {
        ProcessInstanceCreateRequest processInstanceCreateRequest = getProcessInstanceCreateRequest((HlsCusHlsCreditLine)list.get(0),iRequest);
        if (fctWflCustomService != null && !fctWflCustomService.beforeChangeReqSubmit(iRequest, (HlsCusHlsCreditLine) list.get(0))) {
            return;
        }
        activitiService.startProcess(iRequest, processInstanceCreateRequest);
        if (fctWflCustomService != null) {
            fctWflCustomService.afterChangeReqSubmit(iRequest, (HlsCusHlsCreditLine) list.get(0));
        }
    }


    private ProcessInstanceCreateRequest getProcessInstanceCreateRequest(HlsCusHlsCreditLine hlsCreditLine, IRequest iRequest) {
        ProcessInstanceCreateRequest createRequest = new ProcessInstanceCreateRequest();
        ReProcdef reProcdefs = reProcdefService.queryReProcdef("FCT_CREDIT_LINE_CHANGE_WORK_FLOW","CREDIT_LINE_CHANGE");
        SysUser sysUser = sysUserService.selectUserById(iRequest.getUserId());
        String id = reProcdefs.getId_();
        String name = reProcdefs.getName_();
        createRequest.setProcessDefinitionId(id);
        createRequest.setBusinessKey(hlsCreditLine.getCreditLineId().toString());
        //设置参数
        List<RestVariable> variables = new ArrayList<RestVariable>();
        List<RestVariable> transientVariables = new ArrayList<RestVariable>();
        RestVariable restVariable1 = new RestVariable();
        restVariable1.setName("processDefinitionId");
        restVariable1.setValue(id);
        variables.add(restVariable1);
        RestVariable restVariable2 = new RestVariable();
        restVariable2.setName("startUserDescription");
        restVariable2.setValue(sysUser.getDescription());
        variables.add(restVariable2);
        RestVariable restVariable3 = new RestVariable();
        restVariable3.setName("iRequest");
        restVariable3.setValue(iRequest);
        variables.add(restVariable3);
        RestVariable restVariable4 = new RestVariable();
        restVariable4.setName("startUserName");
        restVariable4.setValue(iRequest.getEmployeeCode());
        variables.add(restVariable4);
        RestVariable restVariable5 = new RestVariable();
        restVariable5.setName("hlsCreditLine");
        JSONObject jsonObject= JSON.parseObject(JSON.toJSONString(hlsCreditLine));
        restVariable5.setValue(jsonObject.toString());
        variables.add(restVariable5);
        RestVariable restVariable6 = new RestVariable();
        restVariable6.setName("documentCategory");
        restVariable6.setValue("CREDIT_LINE_CHANGE");
        variables.add(restVariable6);
        RestVariable restVariable7 = new RestVariable();
        restVariable7.setName("documentType");
        restVariable7.setValue("");
        variables.add(restVariable7);
        RestVariable restVariable8 = new RestVariable();
        restVariable8.setName("documentId");
        restVariable8.setValue(hlsCreditLine.getCreditLineId());
        variables.add(restVariable8);
        RestVariable restVariable9 = new RestVariable();
        restVariable9.setName("pName");
        restVariable9.setValue(name);
        variables.add(restVariable9);
        RestVariable restVariable10 = new RestVariable();
        restVariable10.setName("creditLineName");
        restVariable10.setValue(hlsCreditLine.getCreditLineName());
        variables.add(restVariable10);

        RestVariable restVariable11 = new RestVariable();
        restVariable11.setName("workflowType");
        restVariable11.setValue(workFlowType);
        variables.add(restVariable11);

        //插入单据历史表
        Date day=new Date();
        HlsCusHlsDocumentVersion hlsDocumentVersion = new HlsCusHlsDocumentVersion();
        hlsDocumentVersion.setVersionDate(day);
        hlsDocumentVersion.setVersionType("CHANGE_REQ");
        hlsDocumentVersion.setSourceDocumentCategory(hlsCreditLine.getDocumentCategory());
        hlsDocumentVersion.setSourceDocumentId(hlsCreditLine.getCreditLineId());
        hlsDocumentVersion = hlsDocumentVersionService.insertSelective(iRequest,hlsDocumentVersion);

        //插入单据历史_主键关系表
        HlsCusHlsDocumentVersionRel hlsDocumentVersionRel = new HlsCusHlsDocumentVersionRel();
        hlsDocumentVersionRel.setVersionId(hlsDocumentVersion.getVersionId());
        hlsDocumentVersionRel.setFromTable("hls_credit_line");
        hlsDocumentVersionRel.setToTable("hls_credit_line_h");
        hlsDocumentVersionRel.setFromPk(hlsCreditLine.getCreditLineId());
        hlsDocumentVersionRel.setToPk(hlsCreditLine.getCreditLineHId());
        iHlsDocumentVersionRelService.insertSelective(iRequest,hlsDocumentVersionRel);

        //插入额度变更申请表
        HlsCusHlsCreditLineChangeReq hlsCusHlsCreditLineChangeReq = new HlsCusHlsCreditLineChangeReq();
        hlsCusHlsCreditLineChangeReq.setCreditLineId(hlsCreditLine.getCreditLineId());
        hlsCusHlsCreditLineChangeReq.setStatus("APPROVING");
        hlsCusHlsCreditLineChangeReq.setChangeReqDate(day);
        hlsCusHlsCreditLineChangeReq.setChangeReqUserId(iRequest.getUserId());
        hlsCusHlsCreditLineChangeReq.setDocumentType(hlsCreditLine.getDocumentType());
        hlsCusHlsCreditLineChangeReq.setDocumentCategory(hlsCreditLine.getDocumentCategory());
        hlsCusHlsCreditLineChangeReq.setBusinessType(hlsCreditLine.getBusinessType());
        hlsCusHlsCreditLineChangeReq.setDocumentVersionId(hlsDocumentVersion.getVersionId());
        hlsCreditLineChangeReqService.insertSelective(iRequest,hlsCusHlsCreditLineChangeReq);

        RestVariable restVariable12 = new RestVariable();
        restVariable12.setName("changeReqId");
        restVariable12.setValue(hlsCusHlsCreditLineChangeReq.getChangeReqId());
        variables.add(restVariable12);

        createRequest.setVariables(variables);
        createRequest.setTransientVariables(transientVariables);
        return createRequest;
    }

    @Override
    public void cancel(IRequest iRequest, Map params) {
        String businessKey = (String) params.get("businessKey");
        String processInstanceId = (String) params.get("processInstanceId");
        long id = Long.parseLong(businessKey);
        long prcId = Long.parseLong(processInstanceId);
        HlsCusHlsCreditLineApproval hlsCreditLineApproval = new HlsCusHlsCreditLineApproval();
        hlsCreditLineApproval.setCreditLineId(id);
        List<HlsCusHlsCreditLineApproval> hlsCreditLineApprovalList =  hlsCreditLineApprovalService.creditLineApprovalQuery(hlsCreditLineApproval);
        hlsCreditLineApproval.setApprovalId(hlsCreditLineApprovalList.get(0).getApprovalId());
        hlsCreditLineApproval.setStatus(CANCEL_STATUS);
        hlsCreditLineApprovalService.updateByPrimaryKeySelective(iRequest,hlsCreditLineApproval);
    }
}
