package hls.core.wfl.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hand.hap.activiti.dto.ReProcdef;
import com.hand.hap.activiti.service.IActivitiService;
import com.hand.hap.activiti.service.IReProcdefService;
import com.hand.hap.core.IRequest;
import hls.core.fct.dto.HlsCusFctProject;
import hls.core.fct.dto.HlsCusFctProjectAttachment;
import hls.core.fct.dto.HlsCusFctProjectConSignAprl;
import hls.core.fct.dto.HlsCusFctProjectConSignAtt;
import hls.core.fct.mapper.HlsCusFctProjectAttachmentMapper;
import hls.core.fct.mapper.HlsCusFctProjectConSignAprlMapper;
import hls.core.fct.service.*;
import hls.core.hls.bp.dto.HlsCusSysAttachment;
import hls.core.hls.bp.mapper.HlsCusSysAttachmentMapper;
import hls.core.hls.bp.service.HlsSysAttachmentService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.service.SysUserService;
import hls.core.wfl.service.IActivitiCommonService;
import org.activiti.rest.service.api.engine.variable.RestVariable;
import org.activiti.rest.service.api.runtime.process.ProcessInstanceCreateRequest;
import org.apache.commons.collections.map.HashedMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @Author: syj
 * @Description:
 * @Date: Created in 2017/11/16 10:35
 * @Modified By:
 */
@Service
@Transactional
public class FctContractSignActivitiStartServiceImpl implements IActivitiCommonService {
    private static final String workFlowType = "FCT_CONTRACT_SIGN";

    @Autowired
    private IReProcdefService reProcdefService;
    @Autowired
    private IActivitiService activitiService;
    @Autowired
    private SysUserService sysUserService;
    @Autowired
    private FctProjectService fctProjectService;

    @Autowired
    private FctProjectAttachmentService fctProjectAttachmentService;

    @Autowired
    private FctProjectConSignAprlService fctProjectConSignAprlService;
    @Autowired
    private FctProjectConSignAttService fctProjectConSignAttService;
    @Autowired
    private HlsCusFctProjectConSignAprlMapper fctProjectConSignAprlMapper;
    @Autowired
    private HlsCusSysAttachmentMapper sysAttachmentMapper;
    @Autowired
    private HlsSysAttachmentService sysAttachmentService;
    @Autowired
    private HlsCusFctProjectAttachmentMapper fctProjectAttachmentMapper;
    @Autowired(required = false)
    private HlsCusFctWflCustomService fctWflCustomService;

    @Override
    public String getWorkFlowType() {
        return workFlowType;
    }

    @Override
    public void process(IRequest iRequest, List list, Map params) {
        Long projectId = Long.parseLong(params.get("projectId").toString());
        ProcessInstanceCreateRequest processInstanceCreateRequest = getProcessInstanceCreateRequest((HlsCusFctProject) list.get(0), iRequest);
        if (fctWflCustomService != null && !fctWflCustomService.beforeSignSubmit(iRequest, list)) {
            return;
        }
        activitiService.startProcess(iRequest, processInstanceCreateRequest);
        if (fctWflCustomService != null) {
            fctWflCustomService.afterSignSubmit(iRequest,list);
        }
    }

    private ProcessInstanceCreateRequest getProcessInstanceCreateRequest(HlsCusFctProject fctProject, IRequest iRequest) {
        ProcessInstanceCreateRequest createRequest = new ProcessInstanceCreateRequest();
        Date signDate = fctProject.getSignDate();
        String signDescruption = fctProject.getSignDescription();

        //取出要签约的合同ID
        String[] paramPrjAttId = null;
        if (fctProject.getPrjAttId() != null) {
            paramPrjAttId = fctProject.getPrjAttId().split("、");
        }

        fctProject=fctProjectService.fctProjectDetailQuery(fctProject).get(0);
        fctProject.setSignDate(signDate);
        fctProject.setSignDescription(signDescruption);
        ReProcdef reProcdefs;

        reProcdefs = reProcdefService.queryReProcdef("FCT_CONTRACT_SIGN_WORK_FLOW", "FCT_CONTRACT_SIGN");
        SysUser sysUser = sysUserService.selectUserById(iRequest.getUserId());
        String id = reProcdefs.getId_();
        String name = reProcdefs.getName_();
        createRequest.setProcessDefinitionId(id);
        createRequest.setBusinessKey(fctProject.getProjectId().toString());

        List<RestVariable> variables = new ArrayList<RestVariable>();
        List<RestVariable> transientVariables = new ArrayList<RestVariable>();
        RestVariable restVariable1 = new RestVariable();
        RestVariable restVariable2 = new RestVariable();
        RestVariable restVariable3 = new RestVariable();
        RestVariable restVariable4 = new RestVariable();
        RestVariable restVariable5 = new RestVariable();
        RestVariable restVariable6 = new RestVariable();
        RestVariable restVariable7 = new RestVariable();
        RestVariable restVariable8 = new RestVariable();
        RestVariable restVariable9 = new RestVariable();
        RestVariable restVariable10 = new RestVariable();
        RestVariable restVariable11 = new RestVariable();
        RestVariable restVariable12 = new RestVariable();
        RestVariable restVariable13 = new RestVariable();
        RestVariable restVariable14 = new RestVariable();

        restVariable1.setName("processDefinitionId");
        restVariable1.setValue(id);
        variables.add(restVariable1);

        restVariable2.setName("fctProject");
        JSONObject jsonObject = JSON.parseObject(JSON.toJSONString(fctProject));
        restVariable2.setValue(jsonObject.toString());
        variables.add(restVariable2);

        restVariable3.setName("iRequest");
        restVariable3.setValue(iRequest);
        variables.add(restVariable3);

        restVariable4.setName("startUserName");
        restVariable4.setValue(sysUser.getDescription());
        variables.add(restVariable4);


        restVariable5.setName("documentCategory");
        restVariable5.setValue("FCT_CONTRACT_SIGN");
        variables.add(restVariable5);
        restVariable6.setName("documentType");
        restVariable6.setValue(fctProject.getDocumentType());
        variables.add(restVariable6);
        restVariable7.setName("documentId");
        restVariable7.setValue(fctProject.getProjectId());
        variables.add(restVariable7);

        restVariable8.setName("pName");
        restVariable8.setValue(name);
        variables.add(restVariable8);


        restVariable9.setName("projectName");
        restVariable9.setValue(fctProject.getProjectName());
        variables.add(restVariable9);


        restVariable10.setName("signDate");
        restVariable10.setValue(fctProject.getSignDate());
        variables.add(restVariable10);


        restVariable11.setName("signDescription");
        restVariable11.setValue(fctProject.getSignDescription());
        variables.add(restVariable11);

        //插入审批表
        HlsCusFctProjectConSignAprl fctProjectConSignAprl = new HlsCusFctProjectConSignAprl();
        fctProjectConSignAprl.setProjectId(fctProject.getProjectId());
        fctProjectConSignAprl.setStatus("APPROVING");
        fctProjectConSignAprl.setSignDate(fctProject.getSignDate());
        fctProjectConSignAprl.setSignDescription(fctProject.getSignDescription());
        // fctProjectConSignAprl.setProcessInstanceId(Long.parseLong(id));
        fctProjectConSignAprl = fctProjectConSignAprlService.insertSelective(iRequest, fctProjectConSignAprl);


        //插入审批文件明细表
        HlsCusFctProjectAttachment fctProjectAttachment = new HlsCusFctProjectAttachment();
        List<HlsCusFctProjectAttachment> fctProjectAttachmentList = new ArrayList<HlsCusFctProjectAttachment>();

        Map<String, Object> map = new HashedMap();

     //   fctProjectAttachment.setProjectId(fctProject.getProjectId());
        map.put("prjAttId",paramPrjAttId);
        map.put("projectId",fctProject.getProjectId());
        //得到要签约的合同
        fctProjectAttachmentList = fctProjectAttachmentMapper.fctProjectAttachmentForAttQuery(map);

           /* fctProjectAttachment.setSourceType("FCT_CONTRACT");
            fctProjectAttachmentList = fctProjectAttachmentService.fctProjectAttachmentQuery(fctProjectAttachment, 1, 9999);
            fctProjectAttachment.setSourceType("FCT_GUARANTEE");
            fctProjectAttachmentList.addAll(fctProjectAttachmentService.fctProjectAttachmentQuery(fctProjectAttachment, 1, 9999));
            fctProjectAttachment.setSourceType("FCT_REPURCHASE");
            fctProjectAttachmentList.addAll(fctProjectAttachmentService.fctProjectAttachmentQuery(fctProjectAttachment, 1, 9999));
            fctProjectAttachment.setSourceType("FCT_OTHERS");
            fctProjectAttachmentList.addAll(fctProjectAttachmentService.fctProjectAttachmentQuery(fctProjectAttachment, 1, 9999));*/
        for (int i = 0; i < fctProjectAttachmentList.size(); i++) {
            HlsCusFctProjectConSignAtt fctProjectConSignAtt = new HlsCusFctProjectConSignAtt();
            fctProjectConSignAtt.setSignApprovalId(fctProjectConSignAprl.getSignApprovalId());
            fctProjectConSignAtt.setProjectAttachmentId(fctProjectAttachmentList.get(i).getProjectAttachmentId());
            fctProjectConSignAtt.setStatus("SIGNING");
            fctProjectConSignAtt.setSignApprovalId(fctProjectConSignAprl.getSignApprovalId());

            fctProjectConSignAttService.insertSelective(iRequest, fctProjectConSignAtt);
        }
        //更新附件表合同状态
        for (int i = 0; i < fctProjectAttachmentList.size(); i++) {
            fctProjectAttachmentList.get(i).setStatus("SIGNING");
            fctProjectAttachmentList.get(i).set__status("update");
        }
        fctProjectAttachmentService.batchUpdate(iRequest, fctProjectAttachmentList);

          /*只要有合同状态为GENERATED 则PROCESS_IN_SIGN*/
        HlsCusFctProject cc = new HlsCusFctProject();
        cc.setProjectId(fctProject.getProjectId());
        cc = fctProjectService.selectByPrimaryKey(iRequest, cc);

        HlsCusFctProjectAttachment fctProjectAtt = new HlsCusFctProjectAttachment();
        Long projectId = fctProject.getProjectId();
        fctProjectAtt.setProjectId(projectId);
        fctProjectAtt.setStatus("GENERATED");
        List<HlsCusFctProjectAttachment> hlsCusFctProjectAttachmentLists = new ArrayList<>();
        hlsCusFctProjectAttachmentLists = fctProjectAttachmentMapper.fctProjectAttachmentForSignProcessQuery(fctProjectAtt);
        if(hlsCusFctProjectAttachmentLists.size()>0){
            cc.setContractStatus("PROCESS_IN_SIGN");
        }else{
            cc.setContractStatus("SIGN");
        }
        cc.setSignDate(signDate);
        fctProjectService.updateByPrimaryKeySelective(iRequest, cc);


        Long signApprovalId =  fctProjectConSignAprl.getSignApprovalId();
        restVariable12.setName("signApprovalId");
        restVariable12.setValue(signApprovalId);
        variables.add(restVariable12);

        restVariable13.setName("workflowType");
        restVariable13.setValue(workFlowType);
        variables.add(restVariable13);

        restVariable14.setName("projectId");
        restVariable14.setValue(fctProject.getProjectId());
        variables.add(restVariable14);

        createRequest.setVariables(variables);
        createRequest.setTransientVariables(transientVariables);


         /*附件sourceKey更新*/
         String key = "A";
         String sourceKey = projectId+key+signApprovalId;

        HlsCusSysAttachment sysAttachment = new HlsCusSysAttachment();
        sysAttachment.setSourceType("FCT_CONTRACT_SIGN");
        String attProjectId = String.valueOf(projectId);
        sysAttachment.setSourceKey(attProjectId);
        List<HlsCusSysAttachment> sysAttachmentList = new ArrayList<>();
        sysAttachmentList = sysAttachmentMapper.sysAttachmentQuery(sysAttachment);
        if(sysAttachmentList.size()>0) {
            sysAttachmentList.get(0).setSourceKey(sourceKey);
        /*sysAttachmentService.batchUpdate(iRequest,sysAttachmentList);*/
            sysAttachmentMapper.updateByPrimaryKey(sysAttachmentList.get(0));
        }
        return createRequest;
    }

    @Override
    public void cancel(IRequest iRequest, Map params) {
        String businessKey = (String) params.get("businessKey");
        long id = Long.parseLong(businessKey);
        String processInstanceId = (String) params.get("processInstanceId");
        long prcId = Long.parseLong(processInstanceId);
        HlsCusFctProject fctProject = new HlsCusFctProject();
        fctProject.setProjectId(id);
        fctProject.setContractStatus(CANCEL_STATUS);
        fctProjectService.updateByPrimaryKeySelective(iRequest,fctProject);
    }
}
