package hls.core.wfl.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hand.hap.activiti.dto.ReProcdef;
import com.hand.hap.activiti.service.IActivitiService;
import com.hand.hap.activiti.service.IReProcdefService;
import com.hand.hap.core.IRequest;
import hls.core.fct.dto.HlsCusFctProjectBasicTrx;
import hls.core.fct.dto.HlsCusFctProjectBasicTrxAprl;
import hls.core.fct.mapper.HlsCusFctProjectBasicTrxAprlMapper;
import hls.core.fct.mapper.HlsCusFctProjectBasicTrxMapper;
import hls.core.fct.service.FctProjectBasicTrxAprlService;
import hls.core.fct.service.FctProjectBasicTrxService;
import hls.core.fct.service.HlsCusFctWflCustomService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.service.SysUserService;
import hls.core.wfl.service.IActivitiCommonService;
import org.activiti.rest.service.api.engine.variable.RestVariable;
import org.activiti.rest.service.api.runtime.process.ProcessInstanceCreateRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * Created by wangyan on 2017/11/13.
 */
@Service
@Transactional
public class FctProjectBasicTrxActivitiStartServiceImpl implements IActivitiCommonService {
    private static final String workFlowType = "FCT_PROJECT_BASIC";
    @Autowired
    private IActivitiService activitiService;
    @Autowired
    private IReProcdefService reProcdefService;
    @Autowired
    private FctProjectBasicTrxService fctProjectBasicTrxService;
    @Autowired
    private SysUserService sysUserService;
    @Autowired
    private FctProjectBasicTrxAprlService fctProjectBasicTrxAprlService;
    @Autowired
    private HlsCusFctProjectBasicTrxMapper fctProjectBasicTrxMapper;
    @Autowired
    private HlsCusFctProjectBasicTrxAprlMapper mapper;
    @Autowired(required = false)
    private HlsCusFctWflCustomService fctWflCustomService;

    @Override
    public String getWorkFlowType() {
        return workFlowType;
    }

    @Override
    public void process(IRequest iRequest, List list, Map params) {
        ProcessInstanceCreateRequest processInstanceCreateRequest = getProcessInstanceCreateRequest((HlsCusFctProjectBasicTrx)list.get(0),iRequest);
        if (fctWflCustomService != null && !fctWflCustomService.beforeProjectSubmit(iRequest, (HlsCusFctProjectBasicTrx) list.get(0))) {
            return;
        }
        activitiService.startProcess(iRequest, processInstanceCreateRequest);
        if (fctWflCustomService != null) {
            fctWflCustomService.afterProjectSubmit(iRequest, (HlsCusFctProjectBasicTrx) list.get(0));
        }
    }


    private ProcessInstanceCreateRequest getProcessInstanceCreateRequest(HlsCusFctProjectBasicTrx fctProjectBasicTrx, IRequest iRequest) {
        ProcessInstanceCreateRequest createRequest = new ProcessInstanceCreateRequest();
        ReProcdef reProcdefs = reProcdefService.queryReProcdef("FCT_PROJECT_BASIC_TRX_WORK_FLOW","FCT_PROJECT_BASIC");
        SysUser sysUser = sysUserService.selectUserById(iRequest.getUserId());
        String id = reProcdefs.getId_();
        String name = reProcdefs.getName_();
        createRequest.setProcessDefinitionId(id);
        createRequest.setBusinessKey(fctProjectBasicTrx.getBasicTrxId().toString());
        //设置参数
        List<RestVariable> variables = new ArrayList<RestVariable>();
        List<RestVariable> transientVariables = new ArrayList<RestVariable>();
        RestVariable restVariable1 = new RestVariable();
        restVariable1.setName("processDefinitionId");
        restVariable1.setValue(id);
        variables.add(restVariable1);
        RestVariable restVariable2 = new RestVariable();
        restVariable2.setName("startUserDescription");
        restVariable2.setValue(sysUser.getDescription());
        variables.add(restVariable2);
        RestVariable restVariable3 = new RestVariable();
        restVariable3.setName("iRequest");
        restVariable3.setValue(iRequest);
        variables.add(restVariable3);
        RestVariable restVariable4 = new RestVariable();
        restVariable4.setName("startUserName");
        restVariable4.setValue(iRequest.getEmployeeCode());
        variables.add(restVariable4);
        RestVariable restVariable5 = new RestVariable();
        restVariable5.setName("fctProjectBasicTrx");
        JSONObject jsonObject= JSON.parseObject(JSON.toJSONString(fctProjectBasicTrx));
        restVariable5.setValue(jsonObject.toString());
        variables.add(restVariable5);
        RestVariable restVariable6 = new RestVariable();
        restVariable6.setName("documentCategory");
        restVariable6.setValue("FCT_PROJECT_BASIC");
        variables.add(restVariable6);
        RestVariable restVariable7 = new RestVariable();
        restVariable7.setName("documentType");
        restVariable7.setValue("");
        variables.add(restVariable7);
        RestVariable restVariable8 = new RestVariable();
        restVariable8.setName("documentId");
        restVariable8.setValue(fctProjectBasicTrx.getBasicTrxId());
        variables.add(restVariable8);
        RestVariable restVariable9 = new RestVariable();
        restVariable9.setName("pName");
        restVariable9.setValue(name);
        variables.add(restVariable9);
        RestVariable restVariable10 = new RestVariable();
        restVariable10.setName("basicDealsName");
        restVariable10.setValue(fctProjectBasicTrx.getBasicDealsName());
        variables.add(restVariable10);

        RestVariable restVariable11 = new RestVariable();
        restVariable11.setName("workflowType");
        restVariable11.setValue(workFlowType);
        variables.add(restVariable11);
        RestVariable restVariable12 = new RestVariable();
        restVariable12.setName("basicDealsNumber");
        restVariable12.setValue(fctProjectBasicTrx.getBasicDealsNumber());
        variables.add(restVariable12);

        RestVariable restVariable13 = new RestVariable();
        restVariable13.setName("projectId");
        restVariable13.setValue(fctProjectBasicTrx.getProjectId());
        variables.add(restVariable13);

        createRequest.setVariables(variables);
        createRequest.setTransientVariables(transientVariables);

        //插入审批表
        HlsCusFctProjectBasicTrxAprl fctProjectBasicTrxAprl = new HlsCusFctProjectBasicTrxAprl();
        fctProjectBasicTrxAprl.setBasicTrxId(fctProjectBasicTrx.getBasicTrxId());
        fctProjectBasicTrxAprl.setProjectId(fctProjectBasicTrx.getProjectId());
        fctProjectBasicTrxAprl.setStatus("APPROVING");
        fctProjectBasicTrxAprlService.insertSelective(iRequest,fctProjectBasicTrxAprl);
        return createRequest;
    }

    @Override
    public void cancel(IRequest iRequest, Map params) {
        String businessKey = (String) params.get("businessKey");//BasicTrxId
        String processInstanceId = (String) params.get("processInstanceId");
        long basicTrxId = Long.parseLong(businessKey);
        long prcId = Long.parseLong(processInstanceId);
        //更改审批状态
        HlsCusFctProjectBasicTrxAprl fctProjectBasicTrxAprl = new HlsCusFctProjectBasicTrxAprl();
        fctProjectBasicTrxAprl=mapper.queryBasicTrxAprlByBasicTrxId(basicTrxId);
        fctProjectBasicTrxAprl.setStatus(CANCEL_STATUS);
        fctProjectBasicTrxAprl.setProcessInstanceId(prcId);
        fctProjectBasicTrxAprlService.updateByPrimaryKeySelective(iRequest,fctProjectBasicTrxAprl);
        //更改授信状态为NEW
        fctProjectBasicTrxMapper.updateBasicDealsStatus(basicTrxId, "NEW", iRequest.getUserId(), new Date());
    }
    }
