package hls.core.wfl.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hand.hap.activiti.dto.ReProcdef;
import com.hand.hap.activiti.service.IActivitiService;
import com.hand.hap.activiti.service.IReProcdefService;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.lon.dto.HlsCusLonContract;
import hls.core.lon.dto.HlsCusLonContractWithdraw;
import hls.core.lon.service.ILonContractService;
import hls.core.lon.service.ILonContractWithdrawService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import hls.core.sys.service.SysUserService;
import hls.core.wfl.service.IActivitiCommonService;
import org.activiti.rest.service.api.engine.variable.RestVariable;
import org.activiti.rest.service.api.runtime.process.ProcessInstanceCreateRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 融资合同提款流程开始
 * <p>
 * Created by fjm on 2017/11/17.
 */
@Service
@Transactional
public class LonContractWithdrawActivitiStartServiceImpl implements IActivitiCommonService {
    private static final String workFlowType = "LON_CONTRACT_WITHDRAW";
    private static final String APPROVING = "APPROVING";
    public static final String LON_CONTRACT_WITHDRAW_WORK_FLOW = "LON_CONTRACT_WITHDRAW_WORK_FLOW";
    public static final String LON_CONTRACT = "LON_CONTRACT";
    public static final String CANCEL = "CANCEL";
    @Autowired
    private IActivitiService activitiService;
    @Autowired
    private IReProcdefService reProcdefService;
    @Autowired
    private ILonContractWithdrawService lonContractWithdrawService;
    @Autowired
    private SysUserService sysUserService;
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;

    @Override
    public String getWorkFlowType() {
        return workFlowType;
    }

    @Override
    public void process(IRequest iRequest, List list, Map params) {
        HlsCusLonContractWithdraw lonContractWithdraw = (HlsCusLonContractWithdraw) list.stream().findFirst().get();
        databaseLockProvider.lock(lonContractWithdraw);
        ProcessInstanceCreateRequest processInstance = new ProcessInstanceCreateRequest();
        ReProcdef reProcdefs = reProcdefService.queryReProcdef(LON_CONTRACT_WITHDRAW_WORK_FLOW, LON_CONTRACT);
        String id = reProcdefs.getId_();
        String name = reProcdefs.getName_();
        processInstance.setProcessDefinitionId(id);
        processInstance.setBusinessKey(lonContractWithdraw.getWithdrawId().toString());
        SysUser sysUser = sysUserService.selectUserById(iRequest.getUserId());
        List<RestVariable> variables = new ArrayList<RestVariable>();
        List<RestVariable> transientVariables = new ArrayList<RestVariable>();
        RestVariable restVariable1 = new RestVariable();
        RestVariable restVariable2 = new RestVariable();
        RestVariable restVariable3 = new RestVariable();
        RestVariable restVariable4 = new RestVariable();
        RestVariable restVariable5 = new RestVariable();
        RestVariable restVariable6 = new RestVariable();
        RestVariable restVariable7 = new RestVariable();
        RestVariable restVariable8 = new RestVariable();
        RestVariable restVariable9 = new RestVariable();
        RestVariable restVariable10 = new RestVariable();
        RestVariable restVariable11 = new RestVariable();
        RestVariable restVariable12 = new RestVariable();
        restVariable1.setName("iRequest");
        restVariable1.setValue(iRequest);
        restVariable2.setName("startUserDescription");
        restVariable2.setValue(sysUser.getDescription());
        restVariable3.setName("documentCategory");
        restVariable3.setValue("LON_CONTRACT");
        restVariable4.setName("documentType");
        restVariable4.setValue("");
        restVariable5.setName("documentId");
        restVariable5.setValue(lonContractWithdraw.getWithdrawId());
        restVariable6.setName("startUserName");
        restVariable6.setValue(iRequest.getEmployeeCode());
        restVariable7.setName("processDefinitionId");
        restVariable7.setValue(reProcdefs.getId_());
        restVariable8.setName("withdrawNumber");
        restVariable8.setValue(lonContractWithdraw.getWithdrawNumber());
        restVariable9.setName("contractId");
        restVariable9.setValue(lonContractWithdraw.getContractId());
        restVariable10.setName("pName");
        restVariable10.setValue(name);
        restVariable11.setName("processDefinitionId");
        restVariable11.setValue(id);
        restVariable12.setName("workflowType");
        restVariable12.setValue(workFlowType);

        variables.add(restVariable1);
        variables.add(restVariable2);
        variables.add(restVariable3);
        variables.add(restVariable4);
        variables.add(restVariable5);
        variables.add(restVariable6);
        variables.add(restVariable7);
        variables.add(restVariable8);
        variables.add(restVariable9);
        variables.add(restVariable10);
        variables.add(restVariable11);
        variables.add(restVariable12);
        processInstance.setVariables(variables);
        processInstance.setTransientVariables(transientVariables);
        activitiService.startProcess(iRequest, processInstance);
        lonContractWithdraw.setWithdrawStatus(APPROVING);
        lonContractWithdrawService.updateByPrimaryKeySelective(iRequest, lonContractWithdraw);

    }

    /**
     * 工作流撤回,根据业务主键ID修改业务单据状态为CANCEL
     *
     * @param iRequest
     * @param params
     */
    @Override
    public void cancel(IRequest iRequest, Map params) {
        String businessKey = (String) params.get("businessKey");
        String processInstanceId = (String) params.get("processInstanceId");
        long id = Long.parseLong(businessKey);
        long prcId = Long.parseLong(processInstanceId);
        HlsCusLonContractWithdraw lonContractWithdraw = new HlsCusLonContractWithdraw();
        lonContractWithdraw.setWithdrawId(id);
        lonContractWithdraw.setWithdrawStatus(CANCEL_STATUS);
        lonContractWithdrawService.updateByPrimaryKeySelective(iRequest,lonContractWithdraw);
    }
}
