package hls.core.wfl.service.impl;

import com.hand.hap.activiti.dto.ReProcdef;
import com.hand.hap.activiti.service.IReProcdefService;
import com.hand.hap.core.IRequest;
import hls.core.csh.dto.HlsCusConContractCashflow;
import hls.core.csh.dto.HlsCusCshPaymentReqHd;
import hls.core.csh.dto.HlsCusCshPaymentReqLn;
import hls.core.csh.mapper.HlsCusCshPaymentReqLnMapper;
import hls.core.csh.service.ICshPaymentReqHdService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.service.SysUserService;
import hls.core.wfl.service.IActivitiCommonService;
import org.activiti.rest.service.api.engine.variable.RestVariable;
import org.activiti.rest.service.api.runtime.process.ProcessInstanceCreateRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import com.hand.hap.activiti.service.*;
/**
 * Created by Administrator on 2017/4/17.
 */
@Service
@Transactional
public class PaymentActivitStartServiceImpl implements IActivitiCommonService {

    private static final String workFlowType = "PAY_PAYMENT";

    @Autowired
    private IReProcdefService reProcdefService;
    @Autowired
    private IActivitiService activitiService;
    @Autowired
    private SysUserService sysUserService;
    @Autowired
    HlsCusCshPaymentReqLnMapper hlsCusCshPaymentReqLnMapper;
    @Autowired
    ICshPaymentReqHdService cshPaymentReqHdService;

    @Override
    public String getWorkFlowType() {
        return workFlowType;
    }
    @Override
    public void process(IRequest iRequest, List list,Map params) {

        ProcessInstanceCreateRequest createRequest = getProcessInstanceCreateRequest(list,iRequest,params);
        activitiService.startProcess(iRequest, createRequest);
    }

    public ProcessInstanceCreateRequest getProcessInstanceCreateRequest(List<HlsCusConContractCashflow> list, IRequest iRequest, Map params) {
        ProcessInstanceCreateRequest createRequest = new ProcessInstanceCreateRequest();
        ReProcdef reProcdefs = reProcdefService.queryReProcdef("CSH_PAYMENT_APPLY_WORK_FLOW","CSH_PAYMENT");
        SysUser sysUser = sysUserService.selectUserById(iRequest.getUserId());
        String id = reProcdefs.getId_();
        String name = reProcdefs.getName_();
        createRequest.setProcessDefinitionId(id);
        createRequest.setBusinessKey(list.get(0).getContract_id().toString());

        List<RestVariable> variables = new ArrayList<RestVariable>();
        List<RestVariable> transientVariables = new ArrayList<RestVariable>();
        RestVariable restVariable1 = new RestVariable();
        RestVariable restVariable2 = new RestVariable();
        RestVariable restVariable3 = new RestVariable();
        RestVariable restVariable4 = new RestVariable();
        RestVariable restVariable5 = new RestVariable();
        RestVariable restVariable13 = new RestVariable();
        RestVariable restVariable20 = new RestVariable();
        RestVariable restVariable = new RestVariable();
        RestVariable restVariable14 = new RestVariable();


        HlsCusCshPaymentReqLn cshPaymentReqLn =  (HlsCusCshPaymentReqLn)params.get("cshPaymentReqLn");
        restVariable.setName("paymentRedId");
        restVariable.setValue(cshPaymentReqLn.getPayment_req_id());
        variables.add(restVariable);

        restVariable20.setName("contractId");
        restVariable20.setValue(cshPaymentReqLn.getSource_doc_id());
        variables.add(restVariable20);

        restVariable1.setName("processDefinitionId");
        restVariable1.setValue(id);
        variables.add(restVariable1);

        restVariable2.setName("contractCashflows");
        restVariable2.setValue(list);
        variables.add(restVariable2);

        restVariable3.setName("iRequest");
        restVariable3.setValue(iRequest);
        variables.add(restVariable3);

        double sumAmount = 0L;
        for(HlsCusConContractCashflow contractCashflow:list){
            sumAmount = add(sumAmount,contractCashflow.getAmount());
        }
        restVariable4.setName("sumAmount");
        restVariable4.setValue(sumAmount);
        variables.add(restVariable4);

        restVariable5.setName("startUserName");
        restVariable5.setValue(iRequest.getEmployeeCode());
        variables.add(restVariable5);

        RestVariable restVariable6 = new RestVariable();
        RestVariable restVariable7 = new RestVariable();
        RestVariable restVariable8 = new RestVariable();

        restVariable6.setName("documentCategory");
        restVariable6.setValue("CSH_PAYMENT_REQ");
        variables.add(restVariable6);
        restVariable7.setName("documentType");
        restVariable7.setValue("PAYMENT_REQ");
        variables.add(restVariable7);
        restVariable8.setName("documentId");
        restVariable8.setValue(cshPaymentReqLn.getPayment_req_id());
        variables.add(restVariable8);

        RestVariable restVariable9 = new RestVariable();
        restVariable9.setName("pName");
        restVariable9.setValue(name);
        variables.add(restVariable9);

        RestVariable restVariable10 = new RestVariable();
        restVariable10.setName("cshPaymentReqLn");
        restVariable10.setValue(cshPaymentReqLn);
        variables.add(restVariable10);


        RestVariable restVariable11 = new RestVariable();
        restVariable11.setName("ContractId");
        restVariable11.setValue(cshPaymentReqLn.getContract_id());
        variables.add(restVariable11);



        restVariable13.setName("startUserDescription");
        restVariable13.setValue(sysUser.getDescription());
        variables.add(restVariable13);

        restVariable14.setName("workflowType");
        restVariable14.setValue(workFlowType);
        variables.add(restVariable14);

        createRequest.setVariables(variables);
        createRequest.setTransientVariables(transientVariables);


        return createRequest;
    }
    private double add(Double a, Double b) {
        BigDecimal aa = new BigDecimal(a.toString());
        BigDecimal bb = new BigDecimal(b.toString());

        return aa.add(bb).setScale(2,BigDecimal.ROUND_HALF_UP).doubleValue();
    }

    @Override
    public void cancel(IRequest iRequest, Map params) {
        String businessKey = (String) params.get("businessKey");
        String processInstanceId = (String) params.get("processInstanceId");
        long contractId = Long.parseLong(businessKey);
        long prcId = Long.parseLong(processInstanceId);
        HlsCusCshPaymentReqLn cshPaymentReqLn = new HlsCusCshPaymentReqLn();
        cshPaymentReqLn = hlsCusCshPaymentReqLnMapper.queryCshPaymentLnByContractId(contractId);
        long reqId = cshPaymentReqLn.getPayment_req_id();
        HlsCusCshPaymentReqHd cshPaymentReqHd = new HlsCusCshPaymentReqHd();
        cshPaymentReqHd.setPayment_req_id(reqId);
        cshPaymentReqHd.setPayment_req_status(CANCEL_STATUS);
        cshPaymentReqHdService.updateByPrimaryKeySelective(iRequest,cshPaymentReqHd);
    }

}
