package hls.core.wfl.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hand.hap.activiti.dto.ReProcdef;
import com.hand.hap.activiti.service.IReProcdefService;
import com.hand.hap.core.IRequest;
import hls.core.prj.dto.HlsCusPrjProject;
import hls.core.prj.dto.HlsCusPrjProjectMeeting;
import hls.core.prj.mapper.HlsCusPrjProjectMeetingMapper;
import hls.core.prj.service.PrjProjectService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.service.SysUserService;
import hls.core.wfl.service.IActivitiCommonService;
import org.activiti.rest.service.api.engine.variable.RestVariable;
import org.activiti.rest.service.api.runtime.process.ProcessInstanceCreateRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.hand.hap.activiti.service.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created by Administrator on 2017/4/17.
 */
@Service
@Transactional
public class PrjActivitStartServiceImpl implements IActivitiCommonService {

    private static final String workFlowType = "PRJ_PROJECT";
    @Autowired
    private IActivitiService activitiService;
    @Autowired
    private IReProcdefService reProcdefService;
    @Autowired
    private PrjProjectService projectService;
    @Autowired
    private HlsCusPrjProjectMeetingMapper meetingMapper;
    @Autowired
    private SysUserService sysUserService;

    @Override
    public String getWorkFlowType() {
        return workFlowType;
    }

    @Override
    public void process(IRequest iRequest, List list, Map params) {
        Long projectMeetingId = Long.parseLong(params.get("projectMeetingId").toString());
        ProcessInstanceCreateRequest processInstanceCreateRequest = getProcessInstanceCreateRequest((HlsCusPrjProject) list.get(0), iRequest, projectMeetingId);
        activitiService.startProcess(iRequest, processInstanceCreateRequest);
    }

    private ProcessInstanceCreateRequest getProcessInstanceCreateRequest(HlsCusPrjProject prjProject, IRequest iRequest, Long projectMeetingId) {
        ProcessInstanceCreateRequest createRequest = new ProcessInstanceCreateRequest();
        HlsCusPrjProject project = projectService.selectByPrimaryKey(iRequest, prjProject);
        ReProcdef reProcdefs;
        SysUser sysUser = sysUserService.selectUserById(iRequest.getUserId());
        if ("CREDIT_LINE".equalsIgnoreCase(project.getDocumentType())) {
            reProcdefs = reProcdefService.queryReProcdef("PRJ_CREDIT_LINE_WORK_FLOW", "PRJ_PROJECT");
        } else {
            reProcdefs = reProcdefService.queryReProcdef("PROJECT_REPORT_WORK_FLOW", "PRJ_PROJECT");
        }
        String id = reProcdefs.getId_();
        String name = reProcdefs.getName_();
        createRequest.setProcessDefinitionId(id);
        createRequest.setBusinessKey(prjProject.getProjectId().toString());

        List<RestVariable> variables = new ArrayList<RestVariable>();
        List<RestVariable> transientVariables = new ArrayList<RestVariable>();
        RestVariable restVariable1 = new RestVariable();
        RestVariable restVariable2 = new RestVariable();
        RestVariable restVariable3 = new RestVariable();
        RestVariable restVariable4 = new RestVariable();
        RestVariable restVariable5 = new RestVariable();
        RestVariable restVariable6 = new RestVariable();
        RestVariable restVariable13 = new RestVariable();
        RestVariable restVariable14 = new RestVariable();

        restVariable1.setName("processDefinitionId");
        restVariable1.setValue(id);
        variables.add(restVariable1);

        restVariable2.setName("prjProject");
        JSONObject jsonObject = JSON.parseObject(JSON.toJSONString(prjProject));

        restVariable2.setValue(jsonObject.toString());
        variables.add(restVariable2);

        restVariable3.setName("iRequest");
        restVariable3.setValue(iRequest);
        variables.add(restVariable3);

        restVariable4.setName("projectNum");
        restVariable4.setValue(project.getProjectNumber());
        variables.add(restVariable4);

        restVariable5.setName("projectName");
        restVariable5.setValue(project.getProjectName());
        variables.add(restVariable5);

        restVariable6.setName("startUserName");
        restVariable6.setValue(iRequest.getEmployeeCode());
        variables.add(restVariable6);

        restVariable13.setName("startUserDescription");
        restVariable13.setValue(sysUser.getDescription());
        variables.add(restVariable13);

        RestVariable restVariable7 = new RestVariable();
        RestVariable restVariable8 = new RestVariable();
        RestVariable restVariable9 = new RestVariable();

        restVariable7.setName("documentCategory");
        restVariable7.setValue(project.getDocumentCategory());
        variables.add(restVariable7);
        restVariable8.setName("documentType");
        restVariable8.setValue(project.getDocumentType());
        variables.add(restVariable8);
        restVariable9.setName("documentId");
        restVariable9.setValue(project.getProjectId());
        variables.add(restVariable9);

        RestVariable restVariable10 = new RestVariable();
        restVariable10.setName("doubleFlag");
        HlsCusPrjProjectMeeting meeting = new HlsCusPrjProjectMeeting();
        meeting.setProjectId(prjProject.getProjectId());
        List<HlsCusPrjProjectMeeting> list = meetingMapper.select(meeting);
        if (list.size() > 1) {
            restVariable10.setValue("Y");
        } else {
            restVariable10.setValue("N");
        }
        variables.add(restVariable10);

        RestVariable restVariable11 = new RestVariable();
        restVariable11.setName("pName");
        restVariable11.setValue(name);
        variables.add(restVariable11);

        RestVariable restVariable12 = new RestVariable();
        restVariable12.setName("projectMeetingId");
        restVariable12.setValue(projectMeetingId);
        variables.add(restVariable12);

        restVariable14.setName("workflowType");
        restVariable14.setValue(workFlowType);
        variables.add(restVariable14);

        createRequest.setVariables(variables);
        createRequest.setTransientVariables(transientVariables);

        return createRequest;
    }

    @Override
    public void cancel(IRequest iRequest, Map params) {
        String businessKey = (String) params.get("businessKey");
        String processInstanceId = (String) params.get("processInstanceId");
        long id = Long.parseLong(businessKey);
        long prcId = Long.parseLong(processInstanceId);
        HlsCusPrjProject prjProject = new HlsCusPrjProject();
        prjProject.setProjectId(id);
        prjProject.setProjectStatus(CANCEL_STATUS);
        projectService.updateByPrimaryKeySelective(iRequest,prjProject);
    }
}
