package hls.core.wfl.service.impl;

import com.hand.hap.activiti.dto.ReProcdef;
import com.hand.hap.activiti.service.IActivitiService;
import com.hand.hap.activiti.service.IReProcdefService;
import com.hand.hap.core.IRequest;
import hls.core.csh.dto.HlsCusCshPaymentReqHd;
import hls.core.csh.service.ICshPaymentReqHdService;
import hls.core.hls.components.CalculateUtil;
import hls.core.lon.dto.HlsCusLonContractRepayment;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import hls.core.sys.service.SysUserService;
import hls.core.wfl.service.IActivitiCommonService;
import org.activiti.rest.service.api.engine.variable.RestVariable;
import org.activiti.rest.service.api.runtime.process.ProcessInstanceCreateRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created by wangyan on 2017/11/15.
 */
@Service
@Transactional
public class RepaymentActivitiServiceImpl implements IActivitiCommonService {
    private static final String workFlowType = "PAY_REPAYMENT";
    @Autowired
    private IReProcdefService reProcdefService;
    @Autowired
    private IActivitiService activitiService;
    @Autowired
    private SysUserService sysUserService;
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    ICshPaymentReqHdService cshPaymentReqHdService;

    @Override
    public String getWorkFlowType() {
        return workFlowType;
    }
    @Override
    public void process(IRequest iRequest, List list, Map params) {

        ProcessInstanceCreateRequest createRequest = getProcessInstanceCreateRequest(list,iRequest,params);
        activitiService.startProcess(iRequest, createRequest);
    }

    public ProcessInstanceCreateRequest getProcessInstanceCreateRequest(List<HlsCusLonContractRepayment> list, IRequest iRequest, Map params) {
        ProcessInstanceCreateRequest createRequest = new ProcessInstanceCreateRequest();
        ReProcdef reProcdefs = reProcdefService.queryReProcdef("CSH_REPAYMENT_WORK_FLOW","CSH_REPAYMENT");
        SysUser sysUser = sysUserService.selectUserById(iRequest.getUserId());
        String id = reProcdefs.getId_();
        String name = reProcdefs.getName_();
        createRequest.setProcessDefinitionId(id);
        createRequest.setBusinessKey(params.get("paymentReqHdId").toString());//主键设置为申请头id

        List<RestVariable> variables = new ArrayList<RestVariable>();
        List<RestVariable> transientVariables = new ArrayList<RestVariable>();
        RestVariable restVariable1 = new RestVariable();
        RestVariable restVariable2 = new RestVariable();
        RestVariable restVariable3 = new RestVariable();
        RestVariable restVariable4 = new RestVariable();
        RestVariable restVariable5 = new RestVariable();
        RestVariable restVariable6 = new RestVariable();
        RestVariable restVariable7 = new RestVariable();
        RestVariable restVariable8 = new RestVariable();
        RestVariable restVariable9 = new RestVariable();
        RestVariable restVariable10 = new RestVariable();
        RestVariable restVariable11 = new RestVariable();
        RestVariable restVariable12 = new RestVariable();
        RestVariable restVariable13 = new RestVariable();

        restVariable1.setName("processDefinitionId");
        restVariable1.setValue(id);
        variables.add(restVariable1);

        restVariable2.setName("iRequest");
        restVariable2.setValue(iRequest);
        variables.add(restVariable2);

        Double sumAmount = 0D;
        String amountList = "";
        for(HlsCusLonContractRepayment item:list){
            sumAmount = CalculateUtil.add(sumAmount,item.getApplyAmount());//申请金额
            amountList = amountList+item.getApplyAmount()+"-";//申请金额列表
        }
        restVariable3.setName("sumAmount");
        restVariable3.setValue(sumAmount);
        variables.add(restVariable3);

        restVariable4.setName("startUserName");
        restVariable4.setValue(iRequest.getEmployeeCode());
        variables.add(restVariable4);

        restVariable5.setName("documentCategory");
        restVariable5.setValue("CSH_PAYMENT_REQ");
        variables.add(restVariable5);

        restVariable6.setName("documentType");
        restVariable6.setValue("REPAYMENT_REQ");
        variables.add(restVariable6);

        restVariable7.setName("pName");
        restVariable7.setValue(name);
        variables.add(restVariable7);

        restVariable8.setName("startUserDescription");
        restVariable8.setValue(sysUser.getDescription());
        variables.add(restVariable8);

        restVariable9.setName("withdrawId");
        restVariable9.setValue(list.get(0).getWithdrawId());
        variables.add(restVariable9);

        restVariable10.setName("contractId");
        restVariable10.setValue(list.get(0).getContractId());
        variables.add(restVariable10);

        restVariable11.setName("repaymentIds");
        String repaymentIds="";
        for(int i =0;i<list.size();i++){
            repaymentIds = repaymentIds+list.get(i).getRepaymentId()+"-";
        }
        restVariable11.setValue(repaymentIds);
        variables.add(restVariable11);

        restVariable12.setName("amountList");
        restVariable12.setValue(amountList);
        variables.add(restVariable12);

        restVariable13.setName("workflowType");
        restVariable13.setValue(workFlowType);
        variables.add(restVariable13);

        createRequest.setVariables(variables);
        createRequest.setTransientVariables(transientVariables);

        sysEventService.createEvent(iRequest, list.get(0).getWithdrawId(), "LON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_LON_CONTRACT_REPAYMENT_CREATE);

        return createRequest;

    }

    @Override
    public void cancel(IRequest iRequest, Map params) {
        String businessKey = (String) params.get("businessKey");
        String processInstanceId = (String) params.get("processInstanceId");
        long id = Long.parseLong(businessKey);
        long prcId = Long.parseLong(processInstanceId);
        HlsCusCshPaymentReqHd cshPaymentReqHd = new HlsCusCshPaymentReqHd();
        cshPaymentReqHd.setPayment_req_id(id);
        cshPaymentReqHd.setPayment_req_status(CANCEL_STATUS);
        cshPaymentReqHdService.updateByPrimaryKeySelective(iRequest,cshPaymentReqHd);
    }

    }
